package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDirIterator extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum IteratorFlag implements com.trolltech.qt.QtEnumerator {
        NoIteratorFlags(0),
        FollowSymlinks(1),
        Subdirectories(2);

        IteratorFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static IteratorFlags createQFlags(IteratorFlag ... values) {
            return new IteratorFlags(values);
        }
        public static IteratorFlag resolve(int value) {
            return (IteratorFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoIteratorFlags;
            case 1: return FollowSymlinks;
            case 2: return Subdirectories;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class IteratorFlags extends com.trolltech.qt.QFlags<IteratorFlag> {
        private static final long serialVersionUID = 1L;
        public IteratorFlags(IteratorFlag ... args) { super(args); }
        public IteratorFlags(int value) { setValue(value); }
    }



    public QDirIterator(com.trolltech.qt.core.QDir dir) {
        this(dir, new com.trolltech.qt.core.QDirIterator.IteratorFlags(0));
    }
    public QDirIterator(com.trolltech.qt.core.QDir dir, com.trolltech.qt.core.QDirIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDirIterator_QDir_IteratorFlags(dir == null ? 0 : dir.nativeId(), flags.value());
    }
    private native void __qt_QDirIterator_QDir_IteratorFlags(long dir, int flags);



    public QDirIterator(java.lang.String path) {
        this(path, new com.trolltech.qt.core.QDirIterator.IteratorFlags(0));
    }
    public QDirIterator(java.lang.String path, com.trolltech.qt.core.QDirIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDirIterator_String_IteratorFlags(path, flags.value());
    }
    private native void __qt_QDirIterator_String_IteratorFlags(java.lang.String path, int flags);



    public QDirIterator(java.lang.String path, java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters) {
        this(path, nameFilters, filters, new com.trolltech.qt.core.QDirIterator.IteratorFlags(0));
    }

    public QDirIterator(java.lang.String path, java.util.List<java.lang.String> nameFilters) {
        this(path, nameFilters, new com.trolltech.qt.core.QDir.Filters(-1), new com.trolltech.qt.core.QDirIterator.IteratorFlags(0));
    }
    public QDirIterator(java.lang.String path, java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDirIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDirIterator_String_List_Filters_IteratorFlags(path, nameFilters, filters.value(), flags.value());
    }
    private native void __qt_QDirIterator_String_List_Filters_IteratorFlags(java.lang.String path, java.util.List<java.lang.String> nameFilters, int filters, int flags);



    public QDirIterator(java.lang.String path, com.trolltech.qt.core.QDir.Filters filter) {
        this(path, filter, new com.trolltech.qt.core.QDirIterator.IteratorFlags(0));
    }
    public QDirIterator(java.lang.String path, com.trolltech.qt.core.QDir.Filters filter, com.trolltech.qt.core.QDirIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDirIterator_String_Filters_IteratorFlags(path, filter.value(), flags.value());
    }
    private native void __qt_QDirIterator_String_Filters_IteratorFlags(java.lang.String path, int filter, int flags);


    @QtBlockedSlot public final com.trolltech.qt.core.QFileInfo fileInfo() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileInfo(nativeId());
    }
    private native static com.trolltech.qt.core.QFileInfo __qt_fileInfo(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String filePath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_filePath(nativeId());
    }
    private native static java.lang.String __qt_filePath(long __this__nativeId);

    @QtBlockedSlot public final boolean hasNext() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasNext(nativeId());
    }
    private native static boolean __qt_hasNext(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String next() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_next(nativeId());
    }
    private native static java.lang.String __qt_next(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String path() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_path(nativeId());
    }
    private native static java.lang.String __qt_path(long __this__nativeId);


    public static native QDirIterator fromNativePointer(QNativePointer nativePointer);

    protected QDirIterator(QPrivateConstructor p) { super(p); } 

}
