package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMutex extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum RecursionMode implements com.trolltech.qt.QtEnumerator {
        NonRecursive(0),
        Recursive(1);

        RecursionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static RecursionMode resolve(int value) {
            return (RecursionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NonRecursive;
            case 1: return Recursive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QMutex() {
        this(com.trolltech.qt.core.QMutex.RecursionMode.NonRecursive);
    }
    public QMutex(com.trolltech.qt.core.QMutex.RecursionMode mode) {
        super((QPrivateConstructor)null);
        __qt_QMutex_RecursionMode(mode.value());
    }
    private native void __qt_QMutex_RecursionMode(int mode);


    @QtBlockedSlot public final void lock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_lock(nativeId());
    }
    private native static void __qt_lock(long __this__nativeId);

    @QtBlockedSlot public final boolean tryLock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tryLock(nativeId());
    }
    private native static boolean __qt_tryLock(long __this__nativeId);

    @QtBlockedSlot public final boolean tryLock(int timeout) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tryLock_int(nativeId(), timeout);
    }
    private native static boolean __qt_tryLock_int(long __this__nativeId, int timeout);

    @QtBlockedSlot public final void unlock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unlock(nativeId());
    }
    private native static void __qt_unlock(long __this__nativeId);


    public static native QMutex fromNativePointer(QNativePointer nativePointer);

    protected QMutex(QPrivateConstructor p) { super(p); } 

}
