package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QPoint extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public QPoint() {
        super((QPrivateConstructor)null);
        __qt_QPoint();
    }
    private native void __qt_QPoint();


    public QPoint(int xpos, int ypos) {
        super((QPrivateConstructor)null);
        __qt_QPoint_int_int(xpos, ypos);
    }
    private native void __qt_QPoint_int_int(int xpos, int ypos);


    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final int manhattanLength() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_manhattanLength(nativeId());
    }
    private native static int __qt_manhattanLength(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_multiply_assign(double c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_multiply_assign_double(nativeId(), c);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_multiply_assign_double(long __this__nativeId, double c);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_add_assign(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_add_assign_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_add_assign_QPoint(long __this__nativeId, long p);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_subtract_assign(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_subtract_assign_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_subtract_assign_QPoint(long __this__nativeId, long p);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_divide_assign(double c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_divide_assign_double(nativeId(), c);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_divide_assign_double(long __this__nativeId, double c);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.core.QPoint p2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QPoint(nativeId(), p2 == null ? (p2 = new com.trolltech.qt.core.QPoint()).nativeId() : p2.nativeId());
    }
    private native static boolean __qt_operator_equal_QPoint(long __this__nativeId, long p2);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setX(int x) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setX_int(nativeId(), x);
    }
    private native static void __qt_setX_int(long __this__nativeId, int x);

    @QtBlockedSlot public final void setY(int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setY_int(nativeId(), y);
    }
    private native static void __qt_setY_int(long __this__nativeId, int y);

    @QtBlockedSlot public final int x() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x(nativeId());
    }
    private native static int __qt_x(long __this__nativeId);

    @QtBlockedSlot public final int y() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y(nativeId());
    }
    private native static int __qt_y(long __this__nativeId);


    public static native QPoint fromNativePointer(QNativePointer nativePointer);

    protected QPoint(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QPoint array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.core.QPoint)
            return operator_equal((com.trolltech.qt.core.QPoint) other);
        return false;
    }


	public final QPoint multiply(double d) { operator_multiply_assign(d); return this; }
	public final QPoint divide(double d) { operator_divide_assign(d); return this; }
	public final QPoint add(QPoint p) { operator_add_assign(p); return this; }
	public final QPoint subtract(QPoint p) { operator_subtract_assign(p); return this; }
    
}
