package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QProcess extends com.trolltech.qt.core.QIODevice
{
    @SuppressWarnings("unused") private Object __rcStandardOutputProcess = null;
    public enum ProcessError implements com.trolltech.qt.QtEnumerator {
        FailedToStart(0),
        Crashed(1),
        Timedout(2),
        ReadError(3),
        WriteError(4),
        UnknownError(5);

        ProcessError(int value) { this.value = value; }
        public int value() { return value; }

        public static ProcessError resolve(int value) {
            return (ProcessError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FailedToStart;
            case 1: return Crashed;
            case 2: return Timedout;
            case 3: return ReadError;
            case 4: return WriteError;
            case 5: return UnknownError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ProcessChannelMode implements com.trolltech.qt.QtEnumerator {
        SeparateChannels(0),
        MergedChannels(1),
        ForwardedChannels(2);

        ProcessChannelMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ProcessChannelMode resolve(int value) {
            return (ProcessChannelMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SeparateChannels;
            case 1: return MergedChannels;
            case 2: return ForwardedChannels;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ProcessChannel implements com.trolltech.qt.QtEnumerator {
        StandardOutput(0),
        StandardError(1);

        ProcessChannel(int value) { this.value = value; }
        public int value() { return value; }

        public static ProcessChannel resolve(int value) {
            return (ProcessChannel) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return StandardOutput;
            case 1: return StandardError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ProcessState implements com.trolltech.qt.QtEnumerator {
        NotRunning(0),
        Starting(1),
        Running(2);

        ProcessState(int value) { this.value = value; }
        public int value() { return value; }

        public static ProcessState resolve(int value) {
            return (ProcessState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotRunning;
            case 1: return Starting;
            case 2: return Running;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ExitStatus implements com.trolltech.qt.QtEnumerator {
        NormalExit(0),
        CrashExit(1);

        ExitStatus(int value) { this.value = value; }
        public int value() { return value; }

        public static ExitStatus resolve(int value) {
            return (ExitStatus) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NormalExit;
            case 1: return CrashExit;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.core.QProcess.ProcessError> error = new Signal1<com.trolltech.qt.core.QProcess.ProcessError>();

    @SuppressWarnings("unused")
    private final void error(com.trolltech.qt.core.QProcess.ProcessError error) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_error_ProcessError(nativeId(), error.value());
    }
    private native static void __qt_error_ProcessError(long __this__nativeId, int error);

    public final Signal1<java.lang.Integer> finished = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void finished(int exitCode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_finished_int(nativeId(), exitCode);
    }
    private native static void __qt_finished_int(long __this__nativeId, int exitCode);

    public final Signal2<java.lang.Integer, com.trolltech.qt.core.QProcess.ExitStatus> finishedWithStatusCode = new Signal2<java.lang.Integer, com.trolltech.qt.core.QProcess.ExitStatus>();

    @SuppressWarnings("unused")
    private final void finishedWithStatusCode(int exitCode, com.trolltech.qt.core.QProcess.ExitStatus exitStatus) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_finishedWithStatusCode_int_ExitStatus(nativeId(), exitCode, exitStatus.value());
    }
    private native static void __qt_finishedWithStatusCode_int_ExitStatus(long __this__nativeId, int exitCode, int exitStatus);

    public final Signal0 readyReadStandardError = new Signal0();

    @SuppressWarnings("unused")
    private final void readyReadStandardError() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readyReadStandardError(nativeId());
    }
    private native static void __qt_readyReadStandardError(long __this__nativeId);

    public final Signal0 readyReadStandardOutput = new Signal0();

    @SuppressWarnings("unused")
    private final void readyReadStandardOutput() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readyReadStandardOutput(nativeId());
    }
    private native static void __qt_readyReadStandardOutput(long __this__nativeId);

    public final Signal0 started = new Signal0();

    @SuppressWarnings("unused")
    private final void started() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_started(nativeId());
    }
    private native static void __qt_started(long __this__nativeId);

    public final Signal1<com.trolltech.qt.core.QProcess.ProcessState> stateChanged = new Signal1<com.trolltech.qt.core.QProcess.ProcessState>();

    @SuppressWarnings("unused")
    private final void stateChanged(com.trolltech.qt.core.QProcess.ProcessState state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_ProcessState(nativeId(), state.value());
    }
    private native static void __qt_stateChanged_ProcessState(long __this__nativeId, int state);


    public QProcess() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QProcess(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QProcess_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QProcess_QObject(long parent);


    @QtBlockedSlot public final void closeReadChannel(com.trolltech.qt.core.QProcess.ProcessChannel channel) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeReadChannel_ProcessChannel(nativeId(), channel.value());
    }
    private native static void __qt_closeReadChannel_ProcessChannel(long __this__nativeId, int channel);

    @QtBlockedSlot public final void closeWriteChannel() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeWriteChannel(nativeId());
    }
    private native static void __qt_closeWriteChannel(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.String> environment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_environment(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_environment(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QProcess.ProcessError error() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QProcess.ProcessError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final int exitCode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exitCode(nativeId());
    }
    private native static int __qt_exitCode(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QProcess.ExitStatus exitStatus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QProcess.ExitStatus.resolve(__qt_exitStatus(nativeId()));
    }
    private native static int __qt_exitStatus(long __this__nativeId);

    public final void kill() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_kill(nativeId());
    }
    private native static void __qt_kill(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QProcess.ProcessChannelMode processChannelMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QProcess.ProcessChannelMode.resolve(__qt_processChannelMode(nativeId()));
    }
    private native static int __qt_processChannelMode(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readAllStandardError() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAllStandardError(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readAllStandardError(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readAllStandardOutput() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAllStandardOutput(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readAllStandardOutput(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QProcess.ProcessChannel readChannel() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QProcess.ProcessChannel.resolve(__qt_readChannel(nativeId()));
    }
    private native static int __qt_readChannel(long __this__nativeId);

    @QtBlockedSlot public final void setEnvironment(java.util.List<java.lang.String> environment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEnvironment_List(nativeId(), environment);
    }
    private native static void __qt_setEnvironment_List(long __this__nativeId, java.util.List<java.lang.String> environment);

    @QtBlockedSlot public final void setProcessChannelMode(com.trolltech.qt.core.QProcess.ProcessChannelMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProcessChannelMode_ProcessChannelMode(nativeId(), mode.value());
    }
    private native static void __qt_setProcessChannelMode_ProcessChannelMode(long __this__nativeId, int mode);

    @QtBlockedSlot protected final void setProcessState(com.trolltech.qt.core.QProcess.ProcessState state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProcessState_ProcessState(nativeId(), state.value());
    }
    private native static void __qt_setProcessState_ProcessState(long __this__nativeId, int state);

    @QtBlockedSlot public final void setReadChannel(com.trolltech.qt.core.QProcess.ProcessChannel channel) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadChannel_ProcessChannel(nativeId(), channel.value());
    }
    private native static void __qt_setReadChannel_ProcessChannel(long __this__nativeId, int channel);


    @QtBlockedSlot public final void setStandardErrorFile(java.lang.String fileName, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.setStandardErrorFile(fileName, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @QtBlockedSlot public final void setStandardErrorFile(java.lang.String fileName) {
        setStandardErrorFile(fileName, new com.trolltech.qt.core.QIODevice.OpenMode(8));
    }
    @QtBlockedSlot public final void setStandardErrorFile(java.lang.String fileName, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStandardErrorFile_String_OpenMode(nativeId(), fileName, mode.value());
    }
    private native static void __qt_setStandardErrorFile_String_OpenMode(long __this__nativeId, java.lang.String fileName, int mode);

    @QtBlockedSlot public final void setStandardInputFile(java.lang.String fileName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStandardInputFile_String(nativeId(), fileName);
    }
    private native static void __qt_setStandardInputFile_String(long __this__nativeId, java.lang.String fileName);


    @QtBlockedSlot public final void setStandardOutputFile(java.lang.String fileName, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.setStandardOutputFile(fileName, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @QtBlockedSlot public final void setStandardOutputFile(java.lang.String fileName) {
        setStandardOutputFile(fileName, new com.trolltech.qt.core.QIODevice.OpenMode(8));
    }
    @QtBlockedSlot public final void setStandardOutputFile(java.lang.String fileName, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStandardOutputFile_String_OpenMode(nativeId(), fileName, mode.value());
    }
    private native static void __qt_setStandardOutputFile_String_OpenMode(long __this__nativeId, java.lang.String fileName, int mode);

    @QtBlockedSlot public final void setStandardOutputProcess(com.trolltech.qt.core.QProcess destination) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcStandardOutputProcess = destination;
        }
        __qt_setStandardOutputProcess_QProcess(nativeId(), destination == null ? 0 : destination.nativeId());
    }
    private native static void __qt_setStandardOutputProcess_QProcess(long __this__nativeId, long destination);

    @QtBlockedSlot public final void setWorkingDirectory(java.lang.String dir) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWorkingDirectory_String(nativeId(), dir);
    }
    private native static void __qt_setWorkingDirectory_String(long __this__nativeId, java.lang.String dir);


    @QtBlockedSlot public final void start(java.lang.String program, java.util.List<java.lang.String> arguments, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.start(program, arguments, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @QtBlockedSlot public final void start(java.lang.String program, java.util.List<java.lang.String> arguments) {
        start(program, arguments, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @QtBlockedSlot public final void start(java.lang.String program, java.util.List<java.lang.String> arguments, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start_String_List_OpenMode(nativeId(), program, arguments, mode.value());
    }
    private native static void __qt_start_String_List_OpenMode(long __this__nativeId, java.lang.String program, java.util.List<java.lang.String> arguments, int mode);


    @QtBlockedSlot public final void start(java.lang.String program, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.start(program, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @QtBlockedSlot public final void start(java.lang.String program) {
        start(program, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @QtBlockedSlot public final void start(java.lang.String program, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start_String_OpenMode(nativeId(), program, mode.value());
    }
    private native static void __qt_start_String_OpenMode(long __this__nativeId, java.lang.String program, int mode);

    @QtBlockedSlot public final com.trolltech.qt.core.QProcess.ProcessState state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QProcess.ProcessState.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);

    public final void terminate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_terminate(nativeId());
    }
    private native static void __qt_terminate(long __this__nativeId);


    @QtBlockedSlot public final boolean waitForFinished() {
        return waitForFinished((int)30000);
    }
    @QtBlockedSlot public final boolean waitForFinished(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForFinished_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForFinished_int(long __this__nativeId, int msecs);


    @QtBlockedSlot public final boolean waitForStarted() {
        return waitForStarted((int)30000);
    }
    @QtBlockedSlot public final boolean waitForStarted(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForStarted_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForStarted_int(long __this__nativeId, int msecs);

    @QtBlockedSlot public final java.lang.String workingDirectory() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_workingDirectory(nativeId());
    }
    private native static java.lang.String __qt_workingDirectory(long __this__nativeId);

    @QtBlockedSlot public boolean atEnd() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public long bytesAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesAvailable(nativeId());
    }
    private native static long __qt_bytesAvailable(long __this__nativeId);

    @QtBlockedSlot public long bytesToWrite() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesToWrite(nativeId());
    }
    private native static long __qt_bytesToWrite(long __this__nativeId);

    @QtBlockedSlot public boolean canReadLine() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canReadLine(nativeId());
    }
    private native static boolean __qt_canReadLine(long __this__nativeId);

    @QtBlockedSlot public void close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_close(nativeId());
    }
    private native static void __qt_close(long __this__nativeId);

    @QtBlockedSlot public boolean isSequential() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSequential(nativeId());
    }
    private native static boolean __qt_isSequential(long __this__nativeId);

    @QtBlockedSlot protected int readData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot protected void setupChildProcess() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setupChildProcess(nativeId());
    }
    private native static void __qt_setupChildProcess(long __this__nativeId);

    @QtBlockedSlot public boolean waitForBytesWritten(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForBytesWritten_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForBytesWritten_int(long __this__nativeId, int msecs);

    @QtBlockedSlot public boolean waitForReadyRead(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForReadyRead_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForReadyRead_int(long __this__nativeId, int msecs);

    @QtBlockedSlot protected int writeData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_writeData_nativepointer_long(long __this__nativeId, byte[] data);

    public native static int execute(java.lang.String program);

    public native static int execute(java.lang.String program, java.util.List<java.lang.String> arguments);

    @SuppressWarnings("unused")
    private native static boolean startDetached(java.lang.String program, java.util.List<java.lang.String> arguments, java.lang.String workingDirectory, com.trolltech.qt.QNativePointer pid);

    public native static boolean startDetached(java.lang.String program, java.util.List<java.lang.String> arguments);

    public native static boolean startDetached(java.lang.String program);

    public native static java.util.List<java.lang.String> systemEnvironment();


    public static native QProcess fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QProcess(QPrivateConstructor p) { super(p); } 


        public static class DetachedProcessInfo {
            public DetachedProcessInfo(boolean success, long pid) {
                this.success = success;
                this.pid = pid;
            }
            
            public boolean success;
            public long pid;
        }
        
        public static DetachedProcessInfo startDetached(String program, java.util.List<String> arguments, String workingDirectory) {
            QNativePointer pid = new QNativePointer(QNativePointer.Type.Long);
            boolean success = startDetached(program, arguments, workingDirectory, pid);
            return new DetachedProcessInfo(success, pid.longValue());
        }
    
}
