package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QRegExp extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum PatternSyntax implements com.trolltech.qt.QtEnumerator {
        RegExp(0),
        Wildcard(1),
        FixedString(2),
        RegExp2(3);

        PatternSyntax(int value) { this.value = value; }
        public int value() { return value; }

        public static PatternSyntax resolve(int value) {
            return (PatternSyntax) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return RegExp;
            case 1: return Wildcard;
            case 2: return FixedString;
            case 3: return RegExp2;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CaretMode implements com.trolltech.qt.QtEnumerator {
        CaretAtZero(0),
        CaretAtOffset(1),
        CaretWontMatch(2);

        CaretMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CaretMode resolve(int value) {
            return (CaretMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CaretAtZero;
            case 1: return CaretAtOffset;
            case 2: return CaretWontMatch;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QRegExp(java.lang.String pattern, com.trolltech.qt.core.Qt.CaseSensitivity cs) {
        this(pattern, cs, com.trolltech.qt.core.QRegExp.PatternSyntax.RegExp);
    }

    public QRegExp(java.lang.String pattern) {
        this(pattern, com.trolltech.qt.core.Qt.CaseSensitivity.CaseSensitive, com.trolltech.qt.core.QRegExp.PatternSyntax.RegExp);
    }
    public QRegExp(java.lang.String pattern, com.trolltech.qt.core.Qt.CaseSensitivity cs, com.trolltech.qt.core.QRegExp.PatternSyntax syntax) {
        super((QPrivateConstructor)null);
        __qt_QRegExp_String_CaseSensitivity_PatternSyntax(pattern, cs.value(), syntax.value());
    }
    private native void __qt_QRegExp_String_CaseSensitivity_PatternSyntax(java.lang.String pattern, int cs, int syntax);


    public QRegExp(com.trolltech.qt.core.QRegExp rx) {
        super((QPrivateConstructor)null);
        __qt_QRegExp_QRegExp(rx == null ? (rx = new com.trolltech.qt.core.QRegExp()).nativeId() : rx.nativeId());
    }
    private native void __qt_QRegExp_QRegExp(long rx);


    public QRegExp() {
        super((QPrivateConstructor)null);
        __qt_QRegExp();
    }
    private native void __qt_QRegExp();



    @QtBlockedSlot public final java.lang.String cap() {
        return cap((int)0);
    }
    @QtBlockedSlot public final java.lang.String cap(int nth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cap_int(nativeId(), nth);
    }
    private native static java.lang.String __qt_cap_int(long __this__nativeId, int nth);

    @QtBlockedSlot public final java.util.List<java.lang.String> capturedTexts() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_capturedTexts(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_capturedTexts(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.CaseSensitivity caseSensitivity() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.CaseSensitivity.resolve(__qt_caseSensitivity(nativeId()));
    }
    private native static int __qt_caseSensitivity(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final boolean exactMatch(java.lang.String str) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exactMatch_String(nativeId(), str);
    }
    private native static boolean __qt_exactMatch_String(long __this__nativeId, java.lang.String str);


    @QtBlockedSlot public final int indexIn(java.lang.String str, int offset) {
        return indexIn(str, offset, com.trolltech.qt.core.QRegExp.CaretMode.CaretAtZero);
    }

    @QtBlockedSlot public final int indexIn(java.lang.String str) {
        return indexIn(str, (int)0, com.trolltech.qt.core.QRegExp.CaretMode.CaretAtZero);
    }
    @QtBlockedSlot public final int indexIn(java.lang.String str, int offset, com.trolltech.qt.core.QRegExp.CaretMode caretMode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexIn_String_int_CaretMode(nativeId(), str, offset, caretMode.value());
    }
    private native static int __qt_indexIn_String_int_CaretMode(long __this__nativeId, java.lang.String str, int offset, int caretMode);

    @QtBlockedSlot public final boolean isEmpty() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @QtBlockedSlot public final boolean isMinimal() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isMinimal(nativeId());
    }
    private native static boolean __qt_isMinimal(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);


    @QtBlockedSlot public final int lastIndexIn(java.lang.String str, int offset) {
        return lastIndexIn(str, offset, com.trolltech.qt.core.QRegExp.CaretMode.CaretAtZero);
    }

    @QtBlockedSlot public final int lastIndexIn(java.lang.String str) {
        return lastIndexIn(str, (int)-1, com.trolltech.qt.core.QRegExp.CaretMode.CaretAtZero);
    }
    @QtBlockedSlot public final int lastIndexIn(java.lang.String str, int offset, com.trolltech.qt.core.QRegExp.CaretMode caretMode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastIndexIn_String_int_CaretMode(nativeId(), str, offset, caretMode.value());
    }
    private native static int __qt_lastIndexIn_String_int_CaretMode(long __this__nativeId, java.lang.String str, int offset, int caretMode);

    @QtBlockedSlot public final int matchedLength() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_matchedLength(nativeId());
    }
    private native static int __qt_matchedLength(long __this__nativeId);

    @QtBlockedSlot public final int numCaptures() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numCaptures(nativeId());
    }
    private native static int __qt_numCaptures(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long out);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.core.QRegExp rx) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QRegExp(nativeId(), rx == null ? (rx = new com.trolltech.qt.core.QRegExp()).nativeId() : rx.nativeId());
    }
    private native static boolean __qt_operator_equal_QRegExp(long __this__nativeId, long rx);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public final java.lang.String pattern() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pattern(nativeId());
    }
    private native static java.lang.String __qt_pattern(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRegExp.PatternSyntax patternSyntax() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QRegExp.PatternSyntax.resolve(__qt_patternSyntax(nativeId()));
    }
    private native static int __qt_patternSyntax(long __this__nativeId);


    @QtBlockedSlot public final int pos() {
        return pos((int)0);
    }
    @QtBlockedSlot public final int pos(int nth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos_int(nativeId(), nth);
    }
    private native static int __qt_pos_int(long __this__nativeId, int nth);

    @QtBlockedSlot public final void setCaseSensitivity(com.trolltech.qt.core.Qt.CaseSensitivity cs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCaseSensitivity_CaseSensitivity(nativeId(), cs.value());
    }
    private native static void __qt_setCaseSensitivity_CaseSensitivity(long __this__nativeId, int cs);

    @QtBlockedSlot public final void setMinimal(boolean minimal) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimal_boolean(nativeId(), minimal);
    }
    private native static void __qt_setMinimal_boolean(long __this__nativeId, boolean minimal);

    @QtBlockedSlot public final void setPattern(java.lang.String pattern) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPattern_String(nativeId(), pattern);
    }
    private native static void __qt_setPattern_String(long __this__nativeId, java.lang.String pattern);

    @QtBlockedSlot public final void setPatternSyntax(com.trolltech.qt.core.QRegExp.PatternSyntax syntax) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPatternSyntax_PatternSyntax(nativeId(), syntax.value());
    }
    private native static void __qt_setPatternSyntax_PatternSyntax(long __this__nativeId, int syntax);

    public native static java.lang.String escape(java.lang.String str);


    public static native QRegExp fromNativePointer(QNativePointer nativePointer);

    protected QRegExp(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QRegExp array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.core.QRegExp)
            return operator_equal((com.trolltech.qt.core.QRegExp) other);
        return false;
    }

}
