package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSystemLocale extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum QueryType implements com.trolltech.qt.QtEnumerator {
        LanguageId(0),
        CountryId(1),
        DecimalPoint(2),
        GroupSeparator(3),
        ZeroDigit(4),
        NegativeSign(5),
        DateFormatLong(6),
        DateFormatShort(7),
        TimeFormatLong(8),
        TimeFormatShort(9),
        DayNameLong(10),
        DayNameShort(11),
        MonthNameLong(12),
        MonthNameShort(13),
        DateToStringLong(14),
        DateToStringShort(15),
        TimeToStringLong(16),
        TimeToStringShort(17);

        QueryType(int value) { this.value = value; }
        public int value() { return value; }

        public static QueryType resolve(int value) {
            return (QueryType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LanguageId;
            case 1: return CountryId;
            case 2: return DecimalPoint;
            case 3: return GroupSeparator;
            case 4: return ZeroDigit;
            case 5: return NegativeSign;
            case 6: return DateFormatLong;
            case 7: return DateFormatShort;
            case 8: return TimeFormatLong;
            case 9: return TimeFormatShort;
            case 10: return DayNameLong;
            case 11: return DayNameShort;
            case 12: return MonthNameLong;
            case 13: return MonthNameShort;
            case 14: return DateToStringLong;
            case 15: return DateToStringShort;
            case 16: return TimeToStringLong;
            case 17: return TimeToStringShort;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QSystemLocale() {
        super((QPrivateConstructor)null);
        __qt_QSystemLocale();
    }
    private native void __qt_QSystemLocale();


    @QtBlockedSlot public com.trolltech.qt.core.QLocale fallbackLocale() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fallbackLocale(nativeId());
    }
    private native static com.trolltech.qt.core.QLocale __qt_fallbackLocale(long __this__nativeId);

    @QtBlockedSlot public java.lang.Object query(com.trolltech.qt.core.QSystemLocale.QueryType type, java.lang.Object in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_query_QueryType_Object(nativeId(), type.value(), in);
    }
    private native static java.lang.Object __qt_query_QueryType_Object(long __this__nativeId, int type, java.lang.Object in);


    public static native QSystemLocale fromNativePointer(QNativePointer nativePointer);

    protected QSystemLocale(QPrivateConstructor p) { super(p); } 

}
