package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTimer extends com.trolltech.qt.core.QObject
{
    public final Signal0 timeout = new Signal0();

    @SuppressWarnings("unused")
    private final void timeout() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timeout(nativeId());
    }
    private native static void __qt_timeout(long __this__nativeId);


    public QTimer() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QTimer(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QTimer_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTimer_QObject(long parent);


    @com.trolltech.qt.QtPropertyReader(name="interval")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int interval() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_interval(nativeId());
    }
    private native static int __qt_interval(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="active")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean isActive() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isActive(nativeId());
    }
    private native static boolean __qt_isActive(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="singleShot")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isSingleShot() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSingleShot(nativeId());
    }
    private native static boolean __qt_isSingleShot(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="interval")
    @QtBlockedSlot public final void setInterval(int msec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInterval_int(nativeId(), msec);
    }
    private native static void __qt_setInterval_int(long __this__nativeId, int msec);

    @com.trolltech.qt.QtPropertyWriter(name="singleShot")
    @QtBlockedSlot public final void setSingleShot(boolean singleShot) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSingleShot_boolean(nativeId(), singleShot);
    }
    private native static void __qt_setSingleShot_boolean(long __this__nativeId, boolean singleShot);

    public final void start(int msec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start_int(nativeId(), msec);
    }
    private native static void __qt_start_int(long __this__nativeId, int msec);

    public final void start() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start(nativeId());
    }
    private native static void __qt_start(long __this__nativeId);

    public final void stop() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stop(nativeId());
    }
    private native static void __qt_stop(long __this__nativeId);

    @QtBlockedSlot public final int timerId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_timerId(nativeId());
    }
    private native static int __qt_timerId(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long arg__1);


    public static native QTimer fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTimer(QPrivateConstructor p) { super(p); } 


        static private class QSingleShotTimer extends QObject
        {
            private int timerId = -1;
            public Signal0 timeout = new Signal0();
            
            public QSingleShotTimer(int msec, QObject obj, String method)
            {
                super(obj);
                timeout.connect(obj, method);
                timerId = startTimer(msec);
            }
            
            protected void disposed()
            {
                if (timerId > 0)
                    killTimer(timerId);
                super.disposed();
            }
            
            protected void timerEvent(QTimerEvent e)
            {
                if (timerId > 0)
                    killTimer(timerId);
                timerId = -1;
                timeout.emit();
                disposeLater();
            }
            
        }
    
        public static void singleShot(int msec, QObject obj, String method)
        {
            new QSingleShotTimer(msec, obj, method);
        }
    
}
