package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QUuid extends com.trolltech.qt.QtJambiObject
    implements java.lang.Comparable
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum Variant implements com.trolltech.qt.QtEnumerator {
        VarUnknown(-1),
        NCS(0),
        DCE(2),
        Microsoft(6),
        Reserved(7);

        Variant(int value) { this.value = value; }
        public int value() { return value; }

        public static Variant resolve(int value) {
            return (Variant) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return VarUnknown;
            case 0: return NCS;
            case 2: return DCE;
            case 6: return Microsoft;
            case 7: return Reserved;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Version implements com.trolltech.qt.QtEnumerator {
        VerUnknown(-1),
        Time(1),
        EmbeddedPOSIX(2),
        Name(3),
        Random(4);

        Version(int value) { this.value = value; }
        public int value() { return value; }

        public static Version resolve(int value) {
            return (Version) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return VerUnknown;
            case 1: return Time;
            case 2: return EmbeddedPOSIX;
            case 3: return Name;
            case 4: return Random;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QUuid(java.lang.String arg__1) {
        super((QPrivateConstructor)null);
        __qt_QUuid_String(arg__1);
    }
    private native void __qt_QUuid_String(java.lang.String arg__1);


    public QUuid() {
        super((QPrivateConstructor)null);
        __qt_QUuid();
    }
    private native void __qt_QUuid();


    public QUuid(int l, char w1, char w2, byte b1, byte b2, byte b3, byte b4, byte b5, byte b6, byte b7, byte b8) {
        super((QPrivateConstructor)null);
        __qt_QUuid_int_char_char_byte_byte_byte_byte_byte_byte_byte_byte(l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8);
    }
    private native void __qt_QUuid_int_char_char_byte_byte_byte_byte_byte_byte_byte_byte(int l, char w1, char w2, byte b1, byte b2, byte b3, byte b4, byte b5, byte b6, byte b7, byte b8);


    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_less(com.trolltech.qt.core.QUuid other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QUuid(nativeId(), other == null ? (other = new com.trolltech.qt.core.QUuid()).nativeId() : other.nativeId());
    }
    private native static boolean __qt_operator_less_QUuid(long __this__nativeId, long other);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.core.QUuid orig) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QUuid(nativeId(), orig == null ? (orig = new com.trolltech.qt.core.QUuid()).nativeId() : orig.nativeId());
    }
    private native static boolean __qt_operator_equal_QUuid(long __this__nativeId, long orig);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final java.lang.String toString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString(nativeId());
    }
    private native static java.lang.String __qt_toString(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QUuid.Variant variant() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QUuid.Variant.resolve(__qt_variant(nativeId()));
    }
    private native static int __qt_variant(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QUuid.Version version() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QUuid.Version.resolve(__qt_version(nativeId()));
    }
    private native static int __qt_version(long __this__nativeId);

    public native static com.trolltech.qt.core.QUuid createUuid();

    @QtBlockedSlot public final void setData1(int data1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData1_int(nativeId(), data1);
    }
    private native static void __qt_setData1_int(long __this__nativeId, int data1);

    @QtBlockedSlot public final int data1() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data1(nativeId());
    }
    private native static int __qt_data1(long __this__nativeId);

    @QtBlockedSlot public final void setData2(char data2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData2_char(nativeId(), data2);
    }
    private native static void __qt_setData2_char(long __this__nativeId, char data2);

    @QtBlockedSlot public final char data2() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data2(nativeId());
    }
    private native static char __qt_data2(long __this__nativeId);

    @QtBlockedSlot public final void setData3(char data3) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData3_char(nativeId(), data3);
    }
    private native static void __qt_setData3_char(long __this__nativeId, char data3);

    @QtBlockedSlot public final char data3() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data3(nativeId());
    }
    private native static char __qt_data3(long __this__nativeId);

    @QtBlockedSlot public final void setData4(byte[] data4) {
        if (data4.length != 8)
            throw new IllegalArgumentException("Wrong number of elements in array. Found: " + data4.length + ", expected: 8");

        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData4_byte_3(nativeId(), data4);
    }
    private native static void __qt_setData4_byte_3(long __this__nativeId, byte[] data4);

    @QtBlockedSlot public final byte[] data4() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data4(nativeId());
    }
    private native static byte[] __qt_data4(long __this__nativeId);


    public static native QUuid fromNativePointer(QNativePointer nativePointer);

    protected QUuid(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QUuid array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.core.QUuid)
            return operator_equal((com.trolltech.qt.core.QUuid) other);
        return false;
    }

    public int compareTo(Object other) {
        if (equals(other)) return 0;
        else if (other instanceof com.trolltech.qt.core.QUuid && operator_less((com.trolltech.qt.core.QUuid) other)) return -1;
        else return 1;
    }
}
