package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QAbstractPrintDialog extends com.trolltech.qt.gui.QDialog
{
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.gui.QAbstractPrintDialog {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot public int exec() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exec(nativeId());
        }
    }

    public enum PrintRange implements com.trolltech.qt.QtEnumerator {
        AllPages(0),
        Selection(1),
        PageRange(2);

        PrintRange(int value) { this.value = value; }
        public int value() { return value; }

        public static PrintRange resolve(int value) {
            return (PrintRange) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AllPages;
            case 1: return Selection;
            case 2: return PageRange;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PrintDialogOption implements com.trolltech.qt.QtEnumerator {
        None(0),
        PrintToFile(1),
        PrintSelection(2),
        PrintPageRange(4),
        PrintCollateCopies(16);

        PrintDialogOption(int value) { this.value = value; }
        public int value() { return value; }

        public static PrintDialogOptions createQFlags(PrintDialogOption ... values) {
            return new PrintDialogOptions(values);
        }
        public static PrintDialogOption resolve(int value) {
            return (PrintDialogOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return PrintToFile;
            case 2: return PrintSelection;
            case 4: return PrintPageRange;
            case 16: return PrintCollateCopies;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class PrintDialogOptions extends com.trolltech.qt.QFlags<PrintDialogOption> {
        private static final long serialVersionUID = 1L;
        public PrintDialogOptions(PrintDialogOption ... args) { super(args); }
        public PrintDialogOptions(int value) { setValue(value); }
    }



    public QAbstractPrintDialog(com.trolltech.qt.gui.QPrinter printer) {
        this(printer, (com.trolltech.qt.gui.QWidget)null);
    }
    public QAbstractPrintDialog(com.trolltech.qt.gui.QPrinter printer, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QAbstractPrintDialog_QPrinter_QWidget(printer == null ? 0 : printer.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QAbstractPrintDialog_QPrinter_QWidget(long printer, long parent);


    @QtBlockedSlot public final void addEnabledOption(com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOption option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addEnabledOption_PrintDialogOption(nativeId(), option.value());
    }
    private native static void __qt_addEnabledOption_PrintDialogOption(long __this__nativeId, int option);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOptions enabledOptions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOptions(__qt_enabledOptions(nativeId()));
    }
    private native static int __qt_enabledOptions(long __this__nativeId);

    @QtBlockedSlot public final int fromPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fromPage(nativeId());
    }
    private native static int __qt_fromPage(long __this__nativeId);

    @QtBlockedSlot public final boolean isOptionEnabled(com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOption option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isOptionEnabled_PrintDialogOption(nativeId(), option.value());
    }
    private native static boolean __qt_isOptionEnabled_PrintDialogOption(long __this__nativeId, int option);

    @QtBlockedSlot public final int maxPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maxPage(nativeId());
    }
    private native static int __qt_maxPage(long __this__nativeId);

    @QtBlockedSlot public final int minPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minPage(nativeId());
    }
    private native static int __qt_minPage(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractPrintDialog.PrintRange printRange() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QAbstractPrintDialog.PrintRange.resolve(__qt_printRange(nativeId()));
    }
    private native static int __qt_printRange(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter printer() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_printer(nativeId());
    }
    private native static com.trolltech.qt.gui.QPrinter __qt_printer(long __this__nativeId);


    @QtBlockedSlot public final void setEnabledOptions(com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOption ... options) {
        this.setEnabledOptions(new com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOptions(options));
    }
    @QtBlockedSlot public final void setEnabledOptions(com.trolltech.qt.gui.QAbstractPrintDialog.PrintDialogOptions options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEnabledOptions_PrintDialogOptions(nativeId(), options.value());
    }
    private native static void __qt_setEnabledOptions_PrintDialogOptions(long __this__nativeId, int options);

    @QtBlockedSlot public final void setFromTo(int fromPage, int toPage) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFromTo_int_int(nativeId(), fromPage, toPage);
    }
    private native static void __qt_setFromTo_int_int(long __this__nativeId, int fromPage, int toPage);

    @QtBlockedSlot public final void setMinMax(int min, int max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinMax_int_int(nativeId(), min, max);
    }
    private native static void __qt_setMinMax_int_int(long __this__nativeId, int min, int max);

    @QtBlockedSlot public final void setPrintRange(com.trolltech.qt.gui.QAbstractPrintDialog.PrintRange range) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrintRange_PrintRange(nativeId(), range.value());
    }
    private native static void __qt_setPrintRange_PrintRange(long __this__nativeId, int range);

    @QtBlockedSlot public final int toPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toPage(nativeId());
    }
    private native static int __qt_toPage(long __this__nativeId);

    @QtBlockedSlot public abstract int exec();
    private native static int __qt_exec(long __this__nativeId);


    public static native QAbstractPrintDialog fromNativePointer(QNativePointer nativePointer);

    protected QAbstractPrintDialog(QPrivateConstructor p) { super(p); } 

}
