package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QAbstractSpinBox extends com.trolltech.qt.gui.QWidget
{
    public enum StepEnabledFlag implements com.trolltech.qt.QtEnumerator {
        StepNone(0),
        StepUpEnabled(1),
        StepDownEnabled(2);

        StepEnabledFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static StepEnabled createQFlags(StepEnabledFlag ... values) {
            return new StepEnabled(values);
        }
        public static StepEnabledFlag resolve(int value) {
            return (StepEnabledFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return StepNone;
            case 1: return StepUpEnabled;
            case 2: return StepDownEnabled;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class StepEnabled extends com.trolltech.qt.QFlags<StepEnabledFlag> {
        private static final long serialVersionUID = 1L;
        public StepEnabled(StepEnabledFlag ... args) { super(args); }
        public StepEnabled(int value) { setValue(value); }
    }

    public enum CorrectionMode implements com.trolltech.qt.QtEnumerator {
        CorrectToPreviousValue(0),
        CorrectToNearestValue(1);

        CorrectionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CorrectionMode resolve(int value) {
            return (CorrectionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CorrectToPreviousValue;
            case 1: return CorrectToNearestValue;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ButtonSymbols implements com.trolltech.qt.QtEnumerator {
        UpDownArrows(0),
        PlusMinus(1),
        NoButtons(2);

        ButtonSymbols(int value) { this.value = value; }
        public int value() { return value; }

        public static ButtonSymbols resolve(int value) {
            return (ButtonSymbols) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UpDownArrows;
            case 1: return PlusMinus;
            case 2: return NoButtons;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 editingFinished = new Signal0();

    @SuppressWarnings("unused")
    private final void editingFinished() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_editingFinished(nativeId());
    }
    private native static void __qt_editingFinished(long __this__nativeId);


    public QAbstractSpinBox() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QAbstractSpinBox(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QAbstractSpinBox_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QAbstractSpinBox_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="alignment")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment alignment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_alignment(nativeId()));
    }
    private native static int __qt_alignment(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="buttonSymbols")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractSpinBox.ButtonSymbols buttonSymbols() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QAbstractSpinBox.ButtonSymbols.resolve(__qt_buttonSymbols(nativeId()));
    }
    private native static int __qt_buttonSymbols(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="correctionMode")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractSpinBox.CorrectionMode correctionMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QAbstractSpinBox.CorrectionMode.resolve(__qt_correctionMode(nativeId()));
    }
    private native static int __qt_correctionMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="acceptableInput")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final boolean hasAcceptableInput() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasAcceptableInput(nativeId());
    }
    private native static boolean __qt_hasAcceptableInput(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frame")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final boolean hasFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFrame(nativeId());
    }
    private native static boolean __qt_hasFrame(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot public final void interpretText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_interpretText(nativeId());
    }
    private native static void __qt_interpretText(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="accelerated")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final boolean isAccelerated() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAccelerated(nativeId());
    }
    private native static boolean __qt_isAccelerated(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="readOnly")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean isReadOnly() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadOnly(nativeId());
    }
    private native static boolean __qt_isReadOnly(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="keyboardTracking")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final boolean keyboardTracking() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_keyboardTracking(nativeId());
    }
    private native static boolean __qt_keyboardTracking(long __this__nativeId);

    @QtBlockedSlot protected final com.trolltech.qt.gui.QLineEdit lineEdit() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineEdit(nativeId());
    }
    private native static com.trolltech.qt.gui.QLineEdit __qt_lineEdit(long __this__nativeId);

    public final void selectAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectAll(nativeId());
    }
    private native static void __qt_selectAll(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="accelerated")
    @QtBlockedSlot public final void setAccelerated(boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAccelerated_boolean(nativeId(), on);
    }
    private native static void __qt_setAccelerated_boolean(long __this__nativeId, boolean on);


    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... flag) {
        this.setAlignment(new com.trolltech.qt.core.Qt.Alignment(flag));
    }
    @com.trolltech.qt.QtPropertyWriter(name="alignment")
    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.Alignment flag) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlignment_Alignment(nativeId(), flag.value());
    }
    private native static void __qt_setAlignment_Alignment(long __this__nativeId, int flag);

    @com.trolltech.qt.QtPropertyWriter(name="buttonSymbols")
    @QtBlockedSlot public final void setButtonSymbols(com.trolltech.qt.gui.QAbstractSpinBox.ButtonSymbols bs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setButtonSymbols_ButtonSymbols(nativeId(), bs.value());
    }
    private native static void __qt_setButtonSymbols_ButtonSymbols(long __this__nativeId, int bs);

    @com.trolltech.qt.QtPropertyWriter(name="correctionMode")
    @QtBlockedSlot public final void setCorrectionMode(com.trolltech.qt.gui.QAbstractSpinBox.CorrectionMode cm) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCorrectionMode_CorrectionMode(nativeId(), cm.value());
    }
    private native static void __qt_setCorrectionMode_CorrectionMode(long __this__nativeId, int cm);

    @com.trolltech.qt.QtPropertyWriter(name="frame")
    @QtBlockedSlot public final void setFrame(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrame_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setFrame_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="keyboardTracking")
    @QtBlockedSlot public final void setKeyboardTracking(boolean kt) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setKeyboardTracking_boolean(nativeId(), kt);
    }
    private native static void __qt_setKeyboardTracking_boolean(long __this__nativeId, boolean kt);

    @QtBlockedSlot protected final void setLineEdit(com.trolltech.qt.gui.QLineEdit edit) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (edit == null)
            throw new NullPointerException("Argument 'edit': null not expected.");
        __qt_setLineEdit_QLineEdit(nativeId(), edit == null ? 0 : edit.nativeId());
    }
    private native static void __qt_setLineEdit_QLineEdit(long __this__nativeId, long edit);

    @com.trolltech.qt.QtPropertyWriter(name="readOnly")
    @QtBlockedSlot public final void setReadOnly(boolean r) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadOnly_boolean(nativeId(), r);
    }
    private native static void __qt_setReadOnly_boolean(long __this__nativeId, boolean r);

    @com.trolltech.qt.QtPropertyWriter(name="specialValueText")
    @QtBlockedSlot public final void setSpecialValueText(java.lang.String txt) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSpecialValueText_String(nativeId(), txt);
    }
    private native static void __qt_setSpecialValueText_String(long __this__nativeId, java.lang.String txt);

    @com.trolltech.qt.QtPropertyWriter(name="wrapping")
    @QtBlockedSlot public final void setWrapping(boolean w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWrapping_boolean(nativeId(), w);
    }
    private native static void __qt_setWrapping_boolean(long __this__nativeId, boolean w);

    @com.trolltech.qt.QtPropertyReader(name="specialValueText")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final java.lang.String specialValueText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_specialValueText(nativeId());
    }
    private native static java.lang.String __qt_specialValueText(long __this__nativeId);

    public final void stepDown() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stepDown(nativeId());
    }
    private native static void __qt_stepDown(long __this__nativeId);

    public final void stepUp() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stepUp(nativeId());
    }
    private native static void __qt_stepUp(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="text")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final java.lang.String text() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="wrapping")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean wrapping() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_wrapping(nativeId());
    }
    private native static boolean __qt_wrapping(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long event);

    public void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public java.lang.String fixup(java.lang.String input) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fixup_nativepointer(nativeId(), input);
    }
    private native static java.lang.String __qt_fixup_nativepointer(long __this__nativeId, java.lang.String input);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void hideEvent(com.trolltech.qt.gui.QHideEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideEvent_QHideEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_hideEvent_QHideEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot public void stepBy(int steps) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stepBy_int(nativeId(), steps);
    }
    private native static void __qt_stepBy_int(long __this__nativeId, int steps);

    @QtBlockedSlot protected com.trolltech.qt.gui.QAbstractSpinBox.StepEnabled stepEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QAbstractSpinBox.StepEnabled(__qt_stepEnabled(nativeId()));
    }
    private native static int __qt_stepEnabled(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.gui.QValidator.State validate(com.trolltech.qt.gui.QValidator.QValidationData input) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QValidator.State.resolve(__qt_validate_nativepointer_nativepointer(nativeId(), input));
    }
    private native static int __qt_validate_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.gui.QValidator.QValidationData input);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long event);


    public static native QAbstractSpinBox fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QAbstractSpinBox(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected  void initStyleOption(QStyleOptionSpinBox option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
