package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QBoxLayout extends com.trolltech.qt.gui.QLayout
{
    public enum Direction implements com.trolltech.qt.QtEnumerator {
        LeftToRight(0),
        RightToLeft(1),
        TopToBottom(2),
        BottomToTop(3),
;

        Direction(int value) { this.value = value; }
        public int value() { return value; }

        public static Direction resolve(int value) {
            return (Direction) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LeftToRight;
            case 1: return RightToLeft;
            case 2: return TopToBottom;
            case 3: return BottomToTop;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QBoxLayout(com.trolltech.qt.gui.QBoxLayout.Direction arg__1) {
        this(arg__1, (com.trolltech.qt.gui.QWidget)null);
    }
    public QBoxLayout(com.trolltech.qt.gui.QBoxLayout.Direction arg__1, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QBoxLayout_Direction_QWidget(arg__1.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QBoxLayout_Direction_QWidget(int arg__1, long parent);



    @QtBlockedSlot public final void addLayout(com.trolltech.qt.gui.QLayout layout) {
        addLayout(layout, (int)0);
    }
    @QtBlockedSlot public final void addLayout(com.trolltech.qt.gui.QLayout layout, int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (layout != null) {
            layout.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addLayout_QLayout_int(nativeId(), layout == null ? 0 : layout.nativeId(), stretch);
    }
    private native static void __qt_addLayout_QLayout_int(long __this__nativeId, long layout, int stretch);

    @QtBlockedSlot public final void addSpacing(int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addSpacing_int(nativeId(), size);
    }
    private native static void __qt_addSpacing_int(long __this__nativeId, int size);


    @QtBlockedSlot public final void addStretch() {
        addStretch((int)0);
    }
    @QtBlockedSlot public final void addStretch(int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addStretch_int(nativeId(), stretch);
    }
    private native static void __qt_addStretch_int(long __this__nativeId, int stretch);

    @QtBlockedSlot public final void addStrut(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addStrut_int(nativeId(), arg__1);
    }
    private native static void __qt_addStrut_int(long __this__nativeId, int arg__1);


    @QtBlockedSlot public final void addWidget(com.trolltech.qt.gui.QWidget arg__1, int stretch, com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.addWidget(arg__1, stretch, new com.trolltech.qt.core.Qt.Alignment(alignment));
    }
    @QtBlockedSlot public final void addWidget(com.trolltech.qt.gui.QWidget arg__1, int stretch, com.trolltech.qt.core.Qt.Alignment alignment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (arg__1 == null)
            throw new NullPointerException("Argument 'arg__1': null not expected.");
        java.util.Collection<Object> __rcTmp = (java.util.Collection<Object>)com.trolltech.qt.QtJambiInternal.fetchField(this,
                                                                     QLayout.class,
                                                                     "__rcWidgets");
        if (arg__1 != null) {
            __rcTmp.add(arg__1);
        }
        __qt_addWidget_QWidget_int_Alignment(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), stretch, alignment.value());
    }
    private native static void __qt_addWidget_QWidget_int_Alignment(long __this__nativeId, long arg__1, int stretch, int alignment);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBoxLayout.Direction direction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QBoxLayout.Direction.resolve(__qt_direction(nativeId()));
    }
    private native static int __qt_direction(long __this__nativeId);

    @QtBlockedSlot protected final void insertItem(int index, com.trolltech.qt.gui.QLayoutItemInterface arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (arg__2 != null) {
            arg__2.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertItem_int_QLayoutItem(nativeId(), index, arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static void __qt_insertItem_int_QLayoutItem(long __this__nativeId, int index, long arg__2);


    @QtBlockedSlot public final void insertLayout(int index, com.trolltech.qt.gui.QLayout layout) {
        insertLayout(index, layout, (int)0);
    }
    @QtBlockedSlot public final void insertLayout(int index, com.trolltech.qt.gui.QLayout layout, int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (layout != null) {
            layout.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertLayout_int_QLayout_int(nativeId(), index, layout == null ? 0 : layout.nativeId(), stretch);
    }
    private native static void __qt_insertLayout_int_QLayout_int(long __this__nativeId, int index, long layout, int stretch);

    @QtBlockedSlot public final void insertSpacing(int index, int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertSpacing_int_int(nativeId(), index, size);
    }
    private native static void __qt_insertSpacing_int_int(long __this__nativeId, int index, int size);


    @QtBlockedSlot public final void insertStretch(int index) {
        insertStretch(index, (int)0);
    }
    @QtBlockedSlot public final void insertStretch(int index, int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertStretch_int_int(nativeId(), index, stretch);
    }
    private native static void __qt_insertStretch_int_int(long __this__nativeId, int index, int stretch);


    @QtBlockedSlot public final void insertWidget(int index, com.trolltech.qt.gui.QWidget widget, int stretch, com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.insertWidget(index, widget, stretch, new com.trolltech.qt.core.Qt.Alignment(alignment));
    }

    @QtBlockedSlot public final void insertWidget(int index, com.trolltech.qt.gui.QWidget widget, int stretch) {
        insertWidget(index, widget, stretch, new com.trolltech.qt.core.Qt.Alignment(0));
    }

    @QtBlockedSlot public final void insertWidget(int index, com.trolltech.qt.gui.QWidget widget) {
        insertWidget(index, widget, (int)0, new com.trolltech.qt.core.Qt.Alignment(0));
    }
    @QtBlockedSlot public final void insertWidget(int index, com.trolltech.qt.gui.QWidget widget, int stretch, com.trolltech.qt.core.Qt.Alignment alignment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        java.util.Collection<Object> __rcTmp = (java.util.Collection<Object>)com.trolltech.qt.QtJambiInternal.fetchField(this,
                                                                     QLayout.class,
                                                                     "__rcWidgets");
        if (widget != null) {
            __rcTmp.add(widget);
        }
        __qt_insertWidget_int_QWidget_int_Alignment(nativeId(), index, widget == null ? 0 : widget.nativeId(), stretch, alignment.value());
    }
    private native static void __qt_insertWidget_int_QWidget_int_Alignment(long __this__nativeId, int index, long widget, int stretch, int alignment);

    @QtBlockedSlot public final void setDirection(com.trolltech.qt.gui.QBoxLayout.Direction arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirection_Direction(nativeId(), arg__1.value());
    }
    private native static void __qt_setDirection_Direction(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setSpacing(int spacing) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSpacing_int(nativeId(), spacing);
    }
    private native static void __qt_setSpacing_int(long __this__nativeId, int spacing);

    @QtBlockedSlot public final boolean setStretchFactor(com.trolltech.qt.gui.QWidget w, int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setStretchFactor_QWidget_int(nativeId(), w == null ? 0 : w.nativeId(), stretch);
    }
    private native static boolean __qt_setStretchFactor_QWidget_int(long __this__nativeId, long w, int stretch);

    @QtBlockedSlot public final boolean setStretchFactor(com.trolltech.qt.gui.QLayout l, int stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setStretchFactor_QLayout_int(nativeId(), l == null ? 0 : l.nativeId(), stretch);
    }
    private native static boolean __qt_setStretchFactor_QLayout_int(long __this__nativeId, long l, int stretch);

    @QtBlockedSlot public final int spacing() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_spacing(nativeId());
    }
    private native static int __qt_spacing(long __this__nativeId);

    @QtBlockedSlot public void addItem(com.trolltech.qt.gui.QLayoutItemInterface arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (arg__1 != null) {
            arg__1.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addItem_QLayoutItem(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_addItem_QLayoutItem(long __this__nativeId, long arg__1);

    @QtBlockedSlot public int count() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.Qt.Orientations expandingDirections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Orientations(__qt_expandingDirections(nativeId()));
    }
    private native static int __qt_expandingDirections(long __this__nativeId);

    @QtBlockedSlot public boolean hasHeightForWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasHeightForWidth(nativeId());
    }
    private native static boolean __qt_hasHeightForWidth(long __this__nativeId);

    @QtBlockedSlot public int heightForWidth(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightForWidth_int(nativeId(), arg__1);
    }
    private native static int __qt_heightForWidth_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public void invalidate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_invalidate(nativeId());
    }
    private native static void __qt_invalidate(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.gui.QLayoutItemInterface itemAt(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemAt_int(nativeId(), arg__1);
    }
    private native static com.trolltech.qt.gui.QLayoutItemInterface __qt_itemAt_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize maximumSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_maximumSize(long __this__nativeId);

    @QtBlockedSlot public int minimumHeightForWidth(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumHeightForWidth_int(nativeId(), arg__1);
    }
    private native static int __qt_minimumHeightForWidth_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSize(long __this__nativeId);

    @QtBlockedSlot public void setGeometry(com.trolltech.qt.core.QRect arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGeometry_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setGeometry_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.gui.QLayoutItemInterface takeAt(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_takeAt_int(nativeId(), arg__1);
    }
    private native static com.trolltech.qt.gui.QLayoutItemInterface __qt_takeAt_int(long __this__nativeId, int arg__1);


    public static native QBoxLayout fromNativePointer(QNativePointer nativePointer);

    protected QBoxLayout(QPrivateConstructor p) { super(p); } 

}
