package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QComboBox extends com.trolltech.qt.gui.QWidget
{
    @SuppressWarnings("unused") private Object __rcModel = null;
    @SuppressWarnings("unused") private Object __rcCompleter = null;
    @SuppressWarnings("unused") private Object __rcValidator = null;
    public enum InsertPolicy implements com.trolltech.qt.QtEnumerator {
        NoInsert(0),
        InsertAtTop(1),
        InsertAtCurrent(2),
        InsertAtBottom(3),
        InsertAfterCurrent(4),
        InsertBeforeCurrent(5),
        InsertAlphabetically(6);

        InsertPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static InsertPolicy resolve(int value) {
            return (InsertPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoInsert;
            case 1: return InsertAtTop;
            case 2: return InsertAtCurrent;
            case 3: return InsertAtBottom;
            case 4: return InsertAfterCurrent;
            case 5: return InsertBeforeCurrent;
            case 6: return InsertAlphabetically;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SizeAdjustPolicy implements com.trolltech.qt.QtEnumerator {
        AdjustToContents(0),
        AdjustToContentsOnFirstShow(1),
        AdjustToMinimumContentsLength(2),
        AdjustToMinimumContentsLengthWithIcon(3);

        SizeAdjustPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static SizeAdjustPolicy resolve(int value) {
            return (SizeAdjustPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AdjustToContents;
            case 1: return AdjustToContentsOnFirstShow;
            case 2: return AdjustToMinimumContentsLength;
            case 3: return AdjustToMinimumContentsLengthWithIcon;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> activatedIndex = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void activatedIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activatedIndex_int(nativeId(), index);
    }
    private native static void __qt_activatedIndex_int(long __this__nativeId, int index);

    public final Signal1<java.lang.String> activated = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void activated(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activated_String(nativeId(), arg__1);
    }
    private native static void __qt_activated_String(long __this__nativeId, java.lang.String arg__1);

    public final Signal1<java.lang.Integer> currentIndexChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void currentIndexChanged(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentIndexChanged_int(nativeId(), index);
    }
    private native static void __qt_currentIndexChanged_int(long __this__nativeId, int index);

    public final Signal1<java.lang.String> currentStringChanged = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void currentStringChanged(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentStringChanged_String(nativeId(), arg__1);
    }
    private native static void __qt_currentStringChanged_String(long __this__nativeId, java.lang.String arg__1);

    public final Signal1<java.lang.String> editTextChanged = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void editTextChanged(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_editTextChanged_String(nativeId(), arg__1);
    }
    private native static void __qt_editTextChanged_String(long __this__nativeId, java.lang.String arg__1);

    public final Signal1<java.lang.Integer> highlightedIndex = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void highlightedIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_highlightedIndex_int(nativeId(), index);
    }
    private native static void __qt_highlightedIndex_int(long __this__nativeId, int index);

    public final Signal1<java.lang.String> highlighted = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void highlighted(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_highlighted_String(nativeId(), arg__1);
    }
    private native static void __qt_highlighted_String(long __this__nativeId, java.lang.String arg__1);


    public QComboBox() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QComboBox(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QComboBox_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QComboBox_QWidget(long parent);



    @QtBlockedSlot public final void addItem(java.lang.String text) {
        addItem(text, (java.lang.Object)null);
    }
    @QtBlockedSlot public final void addItem(java.lang.String text, java.lang.Object userData) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addItem_String_Object(nativeId(), text, userData);
    }
    private native static void __qt_addItem_String_Object(long __this__nativeId, java.lang.String text, java.lang.Object userData);


    @QtBlockedSlot public final void addItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        addItem(icon, text, (java.lang.Object)null);
    }
    @QtBlockedSlot public final void addItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text, java.lang.Object userData) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addItem_QIcon_String_Object(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text, userData);
    }
    private native static void __qt_addItem_QIcon_String_Object(long __this__nativeId, long icon, java.lang.String text, java.lang.Object userData);

    @QtBlockedSlot public final void addItems(java.util.List<java.lang.String> texts) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addItems_List(nativeId(), texts);
    }
    private native static void __qt_addItems_List(long __this__nativeId, java.util.List<java.lang.String> texts);

    public final void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    public final void clearEditText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearEditText(nativeId());
    }
    private native static void __qt_clearEditText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QCompleter completer() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completer(nativeId());
    }
    private native static com.trolltech.qt.gui.QCompleter __qt_completer(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="count")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int count() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentIndex")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int currentIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentIndex(nativeId());
    }
    private native static int __qt_currentIndex(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentText")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final java.lang.String currentText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentText(nativeId());
    }
    private native static java.lang.String __qt_currentText(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="duplicatesEnabled")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final boolean duplicatesEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_duplicatesEnabled(nativeId());
    }
    private native static boolean __qt_duplicatesEnabled(long __this__nativeId);


    @QtBlockedSlot public final int findData(java.lang.Object data, int role, com.trolltech.qt.core.Qt.MatchFlag ... flags) {
        return this.findData(data, role, new com.trolltech.qt.core.Qt.MatchFlags(flags));
    }

    @QtBlockedSlot public final int findData(java.lang.Object data, int role) {
        return findData(data, role, new com.trolltech.qt.core.Qt.MatchFlags(16));
    }

    @QtBlockedSlot public final int findData(java.lang.Object data) {
        return findData(data, (int)32, new com.trolltech.qt.core.Qt.MatchFlags(16));
    }
    @QtBlockedSlot public final int findData(java.lang.Object data, int role, com.trolltech.qt.core.Qt.MatchFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_findData_Object_int_MatchFlags(nativeId(), data, role, flags.value());
    }
    private native static int __qt_findData_Object_int_MatchFlags(long __this__nativeId, java.lang.Object data, int role, int flags);


    @QtBlockedSlot public final int findText(java.lang.String text, com.trolltech.qt.core.Qt.MatchFlag ... flags) {
        return this.findText(text, new com.trolltech.qt.core.Qt.MatchFlags(flags));
    }

    @QtBlockedSlot public final int findText(java.lang.String text) {
        return findText(text, new com.trolltech.qt.core.Qt.MatchFlags(16));
    }
    @QtBlockedSlot public final int findText(java.lang.String text, com.trolltech.qt.core.Qt.MatchFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_findText_String_MatchFlags(nativeId(), text, flags.value());
    }
    private native static int __qt_findText_String_MatchFlags(long __this__nativeId, java.lang.String text, int flags);

    @com.trolltech.qt.QtPropertyReader(name="frame")
    @com.trolltech.qt.QtPropertyOrder(13)
    @QtBlockedSlot public final boolean hasFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFrame(nativeId());
    }
    private native static boolean __qt_hasFrame(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="iconSize")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);


    @QtBlockedSlot public final void insertItem(int index, java.lang.String text) {
        insertItem(index, text, (java.lang.Object)null);
    }
    @QtBlockedSlot public final void insertItem(int index, java.lang.String text, java.lang.Object userData) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertItem_int_String_Object(nativeId(), index, text, userData);
    }
    private native static void __qt_insertItem_int_String_Object(long __this__nativeId, int index, java.lang.String text, java.lang.Object userData);


    @QtBlockedSlot public final void insertItem(int index, com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        insertItem(index, icon, text, (java.lang.Object)null);
    }
    @QtBlockedSlot public final void insertItem(int index, com.trolltech.qt.gui.QIcon icon, java.lang.String text, java.lang.Object userData) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertItem_int_QIcon_String_Object(nativeId(), index, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text, userData);
    }
    private native static void __qt_insertItem_int_QIcon_String_Object(long __this__nativeId, int index, long icon, java.lang.String text, java.lang.Object userData);

    @QtBlockedSlot public final void insertItems(int index, java.util.List<java.lang.String> texts) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertItems_int_List(nativeId(), index, texts);
    }
    private native static void __qt_insertItems_int_List(long __this__nativeId, int index, java.util.List<java.lang.String> texts);

    @com.trolltech.qt.QtPropertyReader(name="insertPolicy")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.gui.QComboBox.InsertPolicy insertPolicy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QComboBox.InsertPolicy.resolve(__qt_insertPolicy(nativeId()));
    }
    private native static int __qt_insertPolicy(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="editable")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isEditable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEditable(nativeId());
    }
    private native static boolean __qt_isEditable(long __this__nativeId);


    @QtBlockedSlot public final java.lang.Object itemData(int index) {
        return itemData(index, (int)32);
    }
    @QtBlockedSlot public final java.lang.Object itemData(int index, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemData_int_int(nativeId(), index, role);
    }
    private native static java.lang.Object __qt_itemData_int_int(long __this__nativeId, int index, int role);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractItemDelegate itemDelegate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemDelegate(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractItemDelegate __qt_itemDelegate(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon itemIcon(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemIcon_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QIcon __qt_itemIcon_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String itemText(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemText_int(nativeId(), index);
    }
    private native static java.lang.String __qt_itemText_int(long __this__nativeId, int index);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLineEdit lineEdit() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineEdit(nativeId());
    }
    private native static com.trolltech.qt.gui.QLineEdit __qt_lineEdit(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maxCount")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int maxCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maxCount(nativeId());
    }
    private native static int __qt_maxCount(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maxVisibleItems")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int maxVisibleItems() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maxVisibleItems(nativeId());
    }
    private native static int __qt_maxVisibleItems(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumContentsLength")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final int minimumContentsLength() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumContentsLength(nativeId());
    }
    private native static int __qt_minimumContentsLength(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractItemModel model() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_model(nativeId());
    }
    private native static com.trolltech.qt.core.QAbstractItemModel __qt_model(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="modelColumn")
    @com.trolltech.qt.QtPropertyOrder(14)
    @QtBlockedSlot public final int modelColumn() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_modelColumn(nativeId());
    }
    private native static int __qt_modelColumn(long __this__nativeId);

    @QtBlockedSlot public final void removeItem(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeItem_int(nativeId(), index);
    }
    private native static void __qt_removeItem_int(long __this__nativeId, int index);

    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex rootModelIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rootModelIndex(nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_rootModelIndex(long __this__nativeId);

    @QtBlockedSlot public final void setCompleter(com.trolltech.qt.gui.QCompleter c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcCompleter = c;
        }
        __qt_setCompleter_QCompleter(nativeId(), c == null ? 0 : c.nativeId());
    }
    private native static void __qt_setCompleter_QCompleter(long __this__nativeId, long c);

    @com.trolltech.qt.QtPropertyWriter(name="currentIndex")
    public final void setCurrentIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentIndex_int(nativeId(), index);
    }
    private native static void __qt_setCurrentIndex_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyWriter(name="duplicatesEnabled")
    @QtBlockedSlot public final void setDuplicatesEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDuplicatesEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setDuplicatesEnabled_boolean(long __this__nativeId, boolean enable);

    public final void setEditText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEditText_String(nativeId(), text);
    }
    private native static void __qt_setEditText_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="editable")
    @QtBlockedSlot public final void setEditable(boolean editable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEditable_boolean(nativeId(), editable);
    }
    private native static void __qt_setEditable_boolean(long __this__nativeId, boolean editable);

    @com.trolltech.qt.QtPropertyWriter(name="frame")
    @QtBlockedSlot public final void setFrame(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrame_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setFrame_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="iconSize")
    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long size);

    @com.trolltech.qt.QtPropertyWriter(name="insertPolicy")
    @QtBlockedSlot public final void setInsertPolicy(com.trolltech.qt.gui.QComboBox.InsertPolicy policy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInsertPolicy_InsertPolicy(nativeId(), policy.value());
    }
    private native static void __qt_setInsertPolicy_InsertPolicy(long __this__nativeId, int policy);


    @QtBlockedSlot public final void setItemData(int index, java.lang.Object value) {
        setItemData(index, value, (int)32);
    }
    @QtBlockedSlot public final void setItemData(int index, java.lang.Object value, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setItemData_int_Object_int(nativeId(), index, value, role);
    }
    private native static void __qt_setItemData_int_Object_int(long __this__nativeId, int index, java.lang.Object value, int role);

    @QtBlockedSlot public final void setItemDelegate(com.trolltech.qt.gui.QAbstractItemDelegate delegate) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (delegate != null) {
            delegate.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (delegate == null)
            throw new NullPointerException("Argument 'delegate': null not expected.");
        __qt_setItemDelegate_QAbstractItemDelegate(nativeId(), delegate == null ? 0 : delegate.nativeId());
    }
    private native static void __qt_setItemDelegate_QAbstractItemDelegate(long __this__nativeId, long delegate);

    @QtBlockedSlot public final void setItemIcon(int index, com.trolltech.qt.gui.QIcon icon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setItemIcon_int_QIcon(nativeId(), index, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setItemIcon_int_QIcon(long __this__nativeId, int index, long icon);

    @QtBlockedSlot public final void setItemText(int index, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setItemText_int_String(nativeId(), index, text);
    }
    private native static void __qt_setItemText_int_String(long __this__nativeId, int index, java.lang.String text);

    @QtBlockedSlot public final void setLineEdit(com.trolltech.qt.gui.QLineEdit edit) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (edit == null)
            throw new NullPointerException("Argument 'edit': null not expected.");
        __qt_setLineEdit_QLineEdit(nativeId(), edit == null ? 0 : edit.nativeId());
    }
    private native static void __qt_setLineEdit_QLineEdit(long __this__nativeId, long edit);

    @com.trolltech.qt.QtPropertyWriter(name="maxCount")
    @QtBlockedSlot public final void setMaxCount(int max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaxCount_int(nativeId(), max);
    }
    private native static void __qt_setMaxCount_int(long __this__nativeId, int max);

    @com.trolltech.qt.QtPropertyWriter(name="maxVisibleItems")
    @QtBlockedSlot public final void setMaxVisibleItems(int maxItems) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaxVisibleItems_int(nativeId(), maxItems);
    }
    private native static void __qt_setMaxVisibleItems_int(long __this__nativeId, int maxItems);

    @com.trolltech.qt.QtPropertyWriter(name="minimumContentsLength")
    @QtBlockedSlot public final void setMinimumContentsLength(int characters) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumContentsLength_int(nativeId(), characters);
    }
    private native static void __qt_setMinimumContentsLength_int(long __this__nativeId, int characters);

    @QtBlockedSlot public final void setModel(com.trolltech.qt.core.QAbstractItemModel model) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (model == null)
            throw new NullPointerException("Argument 'model': null not expected.");
        {
            __rcModel = model;
        }
        __qt_setModel_QAbstractItemModel(nativeId(), model == null ? 0 : model.nativeId());
    }
    private native static void __qt_setModel_QAbstractItemModel(long __this__nativeId, long model);

    @com.trolltech.qt.QtPropertyWriter(name="modelColumn")
    @QtBlockedSlot public final void setModelColumn(int visibleColumn) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModelColumn_int(nativeId(), visibleColumn);
    }
    private native static void __qt_setModelColumn_int(long __this__nativeId, int visibleColumn);

    @QtBlockedSlot public final void setRootModelIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRootModelIndex_QModelIndex(nativeId(), index);
    }
    private native static void __qt_setRootModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @com.trolltech.qt.QtPropertyWriter(name="sizeAdjustPolicy")
    @QtBlockedSlot public final void setSizeAdjustPolicy(com.trolltech.qt.gui.QComboBox.SizeAdjustPolicy policy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeAdjustPolicy_SizeAdjustPolicy(nativeId(), policy.value());
    }
    private native static void __qt_setSizeAdjustPolicy_SizeAdjustPolicy(long __this__nativeId, int policy);

    @QtBlockedSlot public final void setValidator(com.trolltech.qt.gui.QValidator v) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcValidator = v;
        }
        __qt_setValidator_QValidator(nativeId(), v == null ? 0 : v.nativeId());
    }
    private native static void __qt_setValidator_QValidator(long __this__nativeId, long v);

    @QtBlockedSlot public final void setView(com.trolltech.qt.gui.QAbstractItemView itemView) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (itemView == null)
            throw new NullPointerException("Argument 'itemView': null not expected.");
        __qt_setView_QAbstractItemView(nativeId(), itemView == null ? 0 : itemView.nativeId());
    }
    private native static void __qt_setView_QAbstractItemView(long __this__nativeId, long itemView);

    @com.trolltech.qt.QtPropertyReader(name="sizeAdjustPolicy")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.gui.QComboBox.SizeAdjustPolicy sizeAdjustPolicy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QComboBox.SizeAdjustPolicy.resolve(__qt_sizeAdjustPolicy(nativeId()));
    }
    private native static int __qt_sizeAdjustPolicy(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QValidator validator() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_validator(nativeId());
    }
    private native static com.trolltech.qt.gui.QValidator __qt_validator(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractItemView view() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_view(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractItemView __qt_view(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long e);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void hideEvent(com.trolltech.qt.gui.QHideEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideEvent_QHideEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_hideEvent_QHideEvent(long __this__nativeId, long e);

    @QtBlockedSlot public void hidePopup() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hidePopup(nativeId());
    }
    private native static void __qt_hidePopup(long __this__nativeId);

    @QtBlockedSlot protected void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_inputMethodEvent_QInputMethodEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_inputMethodEvent_QInputMethodEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputMethodQuery_InputMethodQuery(nativeId(), arg__1.value());
    }
    private native static java.lang.Object __qt_inputMethodQuery_InputMethodQuery(long __this__nativeId, int arg__1);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long e);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long e);

    @QtBlockedSlot public void showPopup() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showPopup(nativeId());
    }
    private native static void __qt_showPopup(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long e);


    public static native QComboBox fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QComboBox(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionComboBox option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
