package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QContextMenuEvent extends com.trolltech.qt.gui.QInputEvent
{
    public enum Reason implements com.trolltech.qt.QtEnumerator {
        Mouse(0),
        Keyboard(1),
        Other(2);

        Reason(int value) { this.value = value; }
        public int value() { return value; }

        public static Reason resolve(int value) {
            return (Reason) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Mouse;
            case 1: return Keyboard;
            case 2: return Other;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QContextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent.Reason reason, com.trolltech.qt.core.QPoint pos) {
        super((QPrivateConstructor)null);
        __qt_QContextMenuEvent_Reason_QPoint(reason.value(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native void __qt_QContextMenuEvent_Reason_QPoint(int reason, long pos);


    public QContextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent.Reason reason, com.trolltech.qt.core.QPoint pos, com.trolltech.qt.core.QPoint globalPos) {
        super((QPrivateConstructor)null);
        __qt_QContextMenuEvent_Reason_QPoint_QPoint(reason.value(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId(), globalPos == null ? (globalPos = new com.trolltech.qt.core.QPoint()).nativeId() : globalPos.nativeId());
    }
    private native void __qt_QContextMenuEvent_Reason_QPoint_QPoint(int reason, long pos, long globalPos);


    @QtBlockedSlot public final com.trolltech.qt.core.QPoint globalPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_globalPos(long __this__nativeId);

    @QtBlockedSlot public final int globalX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalX(nativeId());
    }
    private native static int __qt_globalX(long __this__nativeId);

    @QtBlockedSlot public final int globalY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalY(nativeId());
    }
    private native static int __qt_globalY(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_pos(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QContextMenuEvent.Reason reason() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QContextMenuEvent.Reason.resolve(__qt_reason(nativeId()));
    }
    private native static int __qt_reason(long __this__nativeId);

    @QtBlockedSlot public final int x() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x(nativeId());
    }
    private native static int __qt_x(long __this__nativeId);

    @QtBlockedSlot public final int y() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y(nativeId());
    }
    private native static int __qt_y(long __this__nativeId);

    @QtBlockedSlot protected final void setReas(int reas) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReas_int(nativeId(), reas);
    }
    private native static void __qt_setReas_int(long __this__nativeId, int reas);

    @QtBlockedSlot protected final int reas() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_reas(nativeId());
    }
    private native static int __qt_reas(long __this__nativeId);

    @QtBlockedSlot protected final void setGp(com.trolltech.qt.core.QPoint gp) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGp_QPoint(nativeId(), gp == null ? (gp = new com.trolltech.qt.core.QPoint()).nativeId() : gp.nativeId());
    }
    private native static void __qt_setGp_QPoint(long __this__nativeId, long gp);

    @QtBlockedSlot protected final com.trolltech.qt.core.QPoint gp() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_gp(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_gp(long __this__nativeId);

    @QtBlockedSlot protected final void setP(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setP_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static void __qt_setP_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot protected final com.trolltech.qt.core.QPoint p() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_p(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_p(long __this__nativeId);


    public static native QContextMenuEvent fromNativePointer(QNativePointer nativePointer);

    protected QContextMenuEvent(QPrivateConstructor p) { super(p); } 

}
