package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDateTimeEdit extends com.trolltech.qt.gui.QAbstractSpinBox
{
    public enum Section implements com.trolltech.qt.QtEnumerator {
        NoSection(0),
        AmPmSection(1),
        MSecSection(2),
        SecondSection(4),
        MinuteSection(8),
        HourSection(16),
        DaySection(256),
        MonthSection(512),
        YearSection(1024),
        TimeSections_Mask(31),
        DateSections_Mask(1792);

        Section(int value) { this.value = value; }
        public int value() { return value; }

        public static Sections createQFlags(Section ... values) {
            return new Sections(values);
        }
        public static Section resolve(int value) {
            return (Section) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoSection;
            case 1: return AmPmSection;
            case 2: return MSecSection;
            case 4: return SecondSection;
            case 8: return MinuteSection;
            case 16: return HourSection;
            case 256: return DaySection;
            case 512: return MonthSection;
            case 1024: return YearSection;
            case 31: return TimeSections_Mask;
            case 1792: return DateSections_Mask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Sections extends com.trolltech.qt.QFlags<Section> {
        private static final long serialVersionUID = 1L;
        public Sections(Section ... args) { super(args); }
        public Sections(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.core.QDate> dateChanged = new Signal1<com.trolltech.qt.core.QDate>();

    @SuppressWarnings("unused")
    private final void dateChanged(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dateChanged_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_dateChanged_QDate(long __this__nativeId, long date);

    public final Signal1<com.trolltech.qt.core.QDateTime> dateTimeChanged = new Signal1<com.trolltech.qt.core.QDateTime>();

    @SuppressWarnings("unused")
    private final void dateTimeChanged(com.trolltech.qt.core.QDateTime date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dateTimeChanged_QDateTime(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDateTime()).nativeId() : date.nativeId());
    }
    private native static void __qt_dateTimeChanged_QDateTime(long __this__nativeId, long date);

    public final Signal1<com.trolltech.qt.core.QTime> timeChanged = new Signal1<com.trolltech.qt.core.QTime>();

    @SuppressWarnings("unused")
    private final void timeChanged(com.trolltech.qt.core.QTime date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timeChanged_QTime(nativeId(), date == null ? (date = new com.trolltech.qt.core.QTime()).nativeId() : date.nativeId());
    }
    private native static void __qt_timeChanged_QTime(long __this__nativeId, long date);


    public QDateTimeEdit(com.trolltech.qt.core.QDateTime dt) {
        this(dt, (com.trolltech.qt.gui.QWidget)null);
    }
    public QDateTimeEdit(com.trolltech.qt.core.QDateTime dt, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDateTimeEdit_QDateTime_QWidget(dt == null ? (dt = new com.trolltech.qt.core.QDateTime()).nativeId() : dt.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDateTimeEdit_QDateTime_QWidget(long dt, long parent);



    public QDateTimeEdit(com.trolltech.qt.core.QTime t) {
        this(t, (com.trolltech.qt.gui.QWidget)null);
    }
    public QDateTimeEdit(com.trolltech.qt.core.QTime t, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDateTimeEdit_QTime_QWidget(t == null ? (t = new com.trolltech.qt.core.QTime()).nativeId() : t.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDateTimeEdit_QTime_QWidget(long t, long parent);



    public QDateTimeEdit(com.trolltech.qt.core.QDate d) {
        this(d, (com.trolltech.qt.gui.QWidget)null);
    }
    public QDateTimeEdit(com.trolltech.qt.core.QDate d, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDateTimeEdit_QDate_QWidget(d == null ? (d = new com.trolltech.qt.core.QDate()).nativeId() : d.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDateTimeEdit_QDate_QWidget(long d, long parent);



    public QDateTimeEdit() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QDateTimeEdit(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDateTimeEdit_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDateTimeEdit_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="calendarPopup")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final boolean calendarPopup() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_calendarPopup(nativeId());
    }
    private native static boolean __qt_calendarPopup(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="maximumDate")
    @QtBlockedSlot public final void clearMaximumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearMaximumDate(nativeId());
    }
    private native static void __qt_clearMaximumDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="maximumTime")
    @QtBlockedSlot public final void clearMaximumTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearMaximumTime(nativeId());
    }
    private native static void __qt_clearMaximumTime(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="minimumDate")
    @QtBlockedSlot public final void clearMinimumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearMinimumDate(nativeId());
    }
    private native static void __qt_clearMinimumDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="minimumTime")
    @QtBlockedSlot public final void clearMinimumTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearMinimumTime(nativeId());
    }
    private native static void __qt_clearMinimumTime(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentSection")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.gui.QDateTimeEdit.Section currentSection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QDateTimeEdit.Section.resolve(__qt_currentSection(nativeId()));
    }
    private native static int __qt_currentSection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentSectionIndex")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final int currentSectionIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentSectionIndex(nativeId());
    }
    private native static int __qt_currentSectionIndex(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="date")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate date() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_date(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_date(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="dateTime")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.core.QDateTime dateTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dateTime(nativeId());
    }
    private native static com.trolltech.qt.core.QDateTime __qt_dateTime(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="displayFormat")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final java.lang.String displayFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_displayFormat(nativeId());
    }
    private native static java.lang.String __qt_displayFormat(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="displayedSections")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final com.trolltech.qt.gui.QDateTimeEdit.Sections displayedSections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QDateTimeEdit.Sections(__qt_displayedSections(nativeId()));
    }
    private native static int __qt_displayedSections(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initDateTimeEditStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initDateTimeEditStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initDateTimeEditStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @com.trolltech.qt.QtPropertyReader(name="maximumDate")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate maximumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumDate(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_maximumDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximumTime")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.QTime maximumTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumTime(nativeId());
    }
    private native static com.trolltech.qt.core.QTime __qt_maximumTime(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumDate")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate minimumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumDate(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_minimumDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumTime")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.core.QTime minimumTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumTime(nativeId());
    }
    private native static com.trolltech.qt.core.QTime __qt_minimumTime(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QDateTimeEdit.Section sectionAt(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QDateTimeEdit.Section.resolve(__qt_sectionAt_int(nativeId(), index));
    }
    private native static int __qt_sectionAt_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyReader(name="sectionCount")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final int sectionCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionCount(nativeId());
    }
    private native static int __qt_sectionCount(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String sectionText(com.trolltech.qt.gui.QDateTimeEdit.Section section) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionText_Section(nativeId(), section.value());
    }
    private native static java.lang.String __qt_sectionText_Section(long __this__nativeId, int section);

    @com.trolltech.qt.QtPropertyWriter(name="calendarPopup")
    @QtBlockedSlot public final void setCalendarPopup(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCalendarPopup_boolean(nativeId(), enable);
    }
    private native static void __qt_setCalendarPopup_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="currentSection")
    @QtBlockedSlot public final void setCurrentSection(com.trolltech.qt.gui.QDateTimeEdit.Section section) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentSection_Section(nativeId(), section.value());
    }
    private native static void __qt_setCurrentSection_Section(long __this__nativeId, int section);

    @com.trolltech.qt.QtPropertyWriter(name="currentSectionIndex")
    @QtBlockedSlot public final void setCurrentSectionIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentSectionIndex_int(nativeId(), index);
    }
    private native static void __qt_setCurrentSectionIndex_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyWriter(name="date")
    public final void setDate(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDate_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_setDate_QDate(long __this__nativeId, long date);

    @QtBlockedSlot public final void setDateRange(com.trolltech.qt.core.QDate min, com.trolltech.qt.core.QDate max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateRange_QDate_QDate(nativeId(), min == null ? (min = new com.trolltech.qt.core.QDate()).nativeId() : min.nativeId(), max == null ? (max = new com.trolltech.qt.core.QDate()).nativeId() : max.nativeId());
    }
    private native static void __qt_setDateRange_QDate_QDate(long __this__nativeId, long min, long max);

    @com.trolltech.qt.QtPropertyWriter(name="dateTime")
    public final void setDateTime(com.trolltech.qt.core.QDateTime dateTime) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateTime_QDateTime(nativeId(), dateTime == null ? (dateTime = new com.trolltech.qt.core.QDateTime()).nativeId() : dateTime.nativeId());
    }
    private native static void __qt_setDateTime_QDateTime(long __this__nativeId, long dateTime);

    @com.trolltech.qt.QtPropertyWriter(name="displayFormat")
    @QtBlockedSlot public final void setDisplayFormat(java.lang.String format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDisplayFormat_String(nativeId(), format);
    }
    private native static void __qt_setDisplayFormat_String(long __this__nativeId, java.lang.String format);

    @com.trolltech.qt.QtPropertyWriter(name="maximumDate")
    @QtBlockedSlot public final void setMaximumDate(com.trolltech.qt.core.QDate max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumDate_QDate(nativeId(), max == null ? (max = new com.trolltech.qt.core.QDate()).nativeId() : max.nativeId());
    }
    private native static void __qt_setMaximumDate_QDate(long __this__nativeId, long max);

    @com.trolltech.qt.QtPropertyWriter(name="maximumTime")
    @QtBlockedSlot public final void setMaximumTime(com.trolltech.qt.core.QTime max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumTime_QTime(nativeId(), max == null ? (max = new com.trolltech.qt.core.QTime()).nativeId() : max.nativeId());
    }
    private native static void __qt_setMaximumTime_QTime(long __this__nativeId, long max);

    @com.trolltech.qt.QtPropertyWriter(name="minimumDate")
    @QtBlockedSlot public final void setMinimumDate(com.trolltech.qt.core.QDate min) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumDate_QDate(nativeId(), min == null ? (min = new com.trolltech.qt.core.QDate()).nativeId() : min.nativeId());
    }
    private native static void __qt_setMinimumDate_QDate(long __this__nativeId, long min);

    @com.trolltech.qt.QtPropertyWriter(name="minimumTime")
    @QtBlockedSlot public final void setMinimumTime(com.trolltech.qt.core.QTime min) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumTime_QTime(nativeId(), min == null ? (min = new com.trolltech.qt.core.QTime()).nativeId() : min.nativeId());
    }
    private native static void __qt_setMinimumTime_QTime(long __this__nativeId, long min);

    @QtBlockedSlot public final void setSelectedSection(com.trolltech.qt.gui.QDateTimeEdit.Section section) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectedSection_Section(nativeId(), section.value());
    }
    private native static void __qt_setSelectedSection_Section(long __this__nativeId, int section);

    @com.trolltech.qt.QtPropertyWriter(name="time")
    public final void setTime(com.trolltech.qt.core.QTime time) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTime_QTime(nativeId(), time == null ? (time = new com.trolltech.qt.core.QTime()).nativeId() : time.nativeId());
    }
    private native static void __qt_setTime_QTime(long __this__nativeId, long time);

    @QtBlockedSlot public final void setTimeRange(com.trolltech.qt.core.QTime min, com.trolltech.qt.core.QTime max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTimeRange_QTime_QTime(nativeId(), min == null ? (min = new com.trolltech.qt.core.QTime()).nativeId() : min.nativeId(), max == null ? (max = new com.trolltech.qt.core.QTime()).nativeId() : max.nativeId());
    }
    private native static void __qt_setTimeRange_QTime_QTime(long __this__nativeId, long min, long max);

    @com.trolltech.qt.QtPropertyReader(name="time")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.core.QTime time() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_time(nativeId());
    }
    private native static com.trolltech.qt.core.QTime __qt_time(long __this__nativeId);

    @QtBlockedSlot public void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot protected com.trolltech.qt.core.QDateTime dateTimeFromText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dateTimeFromText_String(nativeId(), text);
    }
    private native static com.trolltech.qt.core.QDateTime __qt_dateTimeFromText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public java.lang.String fixup(java.lang.String input) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fixup_nativepointer(nativeId(), input);
    }
    private native static java.lang.String __qt_fixup_nativepointer(long __this__nativeId, java.lang.String input);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected boolean focusNextPrevChild(boolean next) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusNextPrevChild_boolean(nativeId(), next);
    }
    private native static boolean __qt_focusNextPrevChild_boolean(long __this__nativeId, boolean next);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot public void stepBy(int steps) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stepBy_int(nativeId(), steps);
    }
    private native static void __qt_stepBy_int(long __this__nativeId, int steps);

    @QtBlockedSlot protected com.trolltech.qt.gui.QAbstractSpinBox.StepEnabled stepEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QAbstractSpinBox.StepEnabled(__qt_stepEnabled(nativeId()));
    }
    private native static int __qt_stepEnabled(long __this__nativeId);

    @QtBlockedSlot protected java.lang.String textFromDateTime(com.trolltech.qt.core.QDateTime dt) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textFromDateTime_QDateTime(nativeId(), dt == null ? (dt = new com.trolltech.qt.core.QDateTime()).nativeId() : dt.nativeId());
    }
    private native static java.lang.String __qt_textFromDateTime_QDateTime(long __this__nativeId, long dt);

    @QtBlockedSlot public com.trolltech.qt.gui.QValidator.State validate(com.trolltech.qt.gui.QValidator.QValidationData input) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QValidator.State.resolve(__qt_validate_nativepointer_nativepointer(nativeId(), input));
    }
    private native static int __qt_validate_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.gui.QValidator.QValidationData input);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long event);


    public static native QDateTimeEdit fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QDateTimeEdit(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initDateTimeEditStyleOption(QStyleOptionSpinBox option) {
            initDateTimeEditStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
