package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDirModel extends com.trolltech.qt.core.QAbstractItemModel
{
    @SuppressWarnings("unused") private Object __rcIconProvider = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Roles implements com.trolltech.qt.QtEnumerator {
        FileIconRole(0),
        FilePathRole(1),
        FileNameRole(2);

        Roles(int value) { this.value = value; }
        public int value() { return value; }

        public static Roles resolve(int value) {
            return (Roles) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FileIconRole;
            case 1: return FilePathRole;
            case 2: return FileNameRole;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QDirModel(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort) {
        this(nameFilters, filters, sort, (com.trolltech.qt.core.QObject)null);
    }
    public QDirModel(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QDirModel_List_Filters_SortFlags_QObject(nameFilters, filters.value(), sort.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDirModel_List_Filters_SortFlags_QObject(java.util.List<java.lang.String> nameFilters, int filters, int sort, long parent);



    public QDirModel() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QDirModel(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QDirModel_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDirModel_QObject(long parent);


    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon fileIcon(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileIcon_QModelIndex(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QIcon __qt_fileIcon_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final com.trolltech.qt.core.QFileInfo fileInfo(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileInfo_QModelIndex(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QFileInfo __qt_fileInfo_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final java.lang.String fileName(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName_QModelIndex(nativeId(), index);
    }
    private native static java.lang.String __qt_fileName_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final java.lang.String filePath(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_filePath_QModelIndex(nativeId(), index);
    }
    private native static java.lang.String __qt_filePath_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final com.trolltech.qt.core.QDir.Filters filter() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QDir.Filters(__qt_filter(nativeId()));
    }
    private native static int __qt_filter(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFileIconProvider iconProvider() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconProvider(nativeId());
    }
    private native static com.trolltech.qt.gui.QFileIconProvider __qt_iconProvider(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex index(java.lang.String path) {
        return index(path, (int)0);
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex index(java.lang.String path, int column) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_index_String_int(nativeId(), path, column);
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_index_String_int(long __this__nativeId, java.lang.String path, int column);

    @QtBlockedSlot public final boolean isDir(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDir_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_isDir_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @com.trolltech.qt.QtPropertyReader(name="readOnly")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final boolean isReadOnly() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadOnly(nativeId());
    }
    private native static boolean __qt_isReadOnly(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="lazyChildCount")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean lazyChildCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lazyChildCount(nativeId());
    }
    private native static boolean __qt_lazyChildCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex mkdir(com.trolltech.qt.core.QModelIndex parent, java.lang.String name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mkdir_QModelIndex_String(nativeId(), parent, name);
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_mkdir_QModelIndex_String(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, java.lang.String name);

    @QtBlockedSlot public final java.util.List<java.lang.String> nameFilters() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nameFilters(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_nameFilters(long __this__nativeId);


    public final void refresh() {
        refresh((com.trolltech.qt.core.QModelIndex)null);
    }
    public final void refresh(com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_refresh_QModelIndex(nativeId(), parent);
    }
    private native static void __qt_refresh_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public final boolean remove(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_remove_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_remove_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @com.trolltech.qt.QtPropertyReader(name="resolveSymlinks")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean resolveSymlinks() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolveSymlinks(nativeId());
    }
    private native static boolean __qt_resolveSymlinks(long __this__nativeId);

    @QtBlockedSlot public final boolean rmdir(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rmdir_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_rmdir_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);


    @QtBlockedSlot public final void setFilter(com.trolltech.qt.core.QDir.Filter ... filters) {
        this.setFilter(new com.trolltech.qt.core.QDir.Filters(filters));
    }
    @QtBlockedSlot public final void setFilter(com.trolltech.qt.core.QDir.Filters filters) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFilter_Filters(nativeId(), filters.value());
    }
    private native static void __qt_setFilter_Filters(long __this__nativeId, int filters);

    @QtBlockedSlot public final void setIconProvider(com.trolltech.qt.gui.QFileIconProvider provider) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcIconProvider = provider;
        }
        __qt_setIconProvider_QFileIconProvider(nativeId(), provider == null ? 0 : provider.nativeId());
    }
    private native static void __qt_setIconProvider_QFileIconProvider(long __this__nativeId, long provider);

    @com.trolltech.qt.QtPropertyWriter(name="lazyChildCount")
    @QtBlockedSlot public final void setLazyChildCount(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLazyChildCount_boolean(nativeId(), enable);
    }
    private native static void __qt_setLazyChildCount_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setNameFilters(java.util.List<java.lang.String> filters) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNameFilters_List(nativeId(), filters);
    }
    private native static void __qt_setNameFilters_List(long __this__nativeId, java.util.List<java.lang.String> filters);

    @com.trolltech.qt.QtPropertyWriter(name="readOnly")
    @QtBlockedSlot public final void setReadOnly(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadOnly_boolean(nativeId(), enable);
    }
    private native static void __qt_setReadOnly_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="resolveSymlinks")
    @QtBlockedSlot public final void setResolveSymlinks(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResolveSymlinks_boolean(nativeId(), enable);
    }
    private native static void __qt_setResolveSymlinks_boolean(long __this__nativeId, boolean enable);


    @QtBlockedSlot public final void setSorting(com.trolltech.qt.core.QDir.SortFlag ... sort) {
        this.setSorting(new com.trolltech.qt.core.QDir.SortFlags(sort));
    }
    @QtBlockedSlot public final void setSorting(com.trolltech.qt.core.QDir.SortFlags sort) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSorting_SortFlags(nativeId(), sort.value());
    }
    private native static void __qt_setSorting_SortFlags(long __this__nativeId, int sort);

    @QtBlockedSlot public final com.trolltech.qt.core.QDir.SortFlags sorting() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QDir.SortFlags(__qt_sorting(nativeId()));
    }
    private native static int __qt_sorting(long __this__nativeId);

    @QtBlockedSlot public int columnCount(com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnCount_QModelIndex(nativeId(), parent);
    }
    private native static int __qt_columnCount_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public java.lang.Object data(com.trolltech.qt.core.QModelIndex index, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data_QModelIndex_int(nativeId(), index, role);
    }
    private native static java.lang.Object __qt_data_QModelIndex_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, int role);

    @QtBlockedSlot public boolean dropMimeData(com.trolltech.qt.gui.QMimeData data, com.trolltech.qt.core.Qt.DropAction action, int row, int column, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dropMimeData_QMimeData_DropAction_int_int_QModelIndex(nativeId(), data == null ? 0 : data.nativeId(), action.value(), row, column, parent);
    }
    private native static boolean __qt_dropMimeData_QMimeData_DropAction_int_int_QModelIndex(long __this__nativeId, long data, int action, int row, int column, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public com.trolltech.qt.core.Qt.ItemFlags flags(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.ItemFlags(__qt_flags_QModelIndex(nativeId(), index));
    }
    private native static int __qt_flags_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public boolean hasChildren(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasChildren_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_hasChildren_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public java.lang.Object headerData(int section, com.trolltech.qt.core.Qt.Orientation orientation, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_headerData_int_Orientation_int(nativeId(), section, orientation.value(), role);
    }
    private native static java.lang.Object __qt_headerData_int_Orientation_int(long __this__nativeId, int section, int orientation, int role);

    @QtBlockedSlot public com.trolltech.qt.core.QModelIndex index(int row, int column, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_index_int_int_QModelIndex(nativeId(), row, column, parent);
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_index_int_int_QModelIndex(long __this__nativeId, int row, int column, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public com.trolltech.qt.gui.QMimeData mimeData(java.util.List<com.trolltech.qt.core.QModelIndex> indexes) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mimeData_List(nativeId(), indexes);
    }
    private native static com.trolltech.qt.gui.QMimeData __qt_mimeData_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QModelIndex> indexes);

    @QtBlockedSlot public java.util.List<java.lang.String> mimeTypes() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mimeTypes(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_mimeTypes(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QModelIndex parent(com.trolltech.qt.core.QModelIndex child) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parent_QModelIndex(nativeId(), child);
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_parent_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex child);

    @QtBlockedSlot public int rowCount(com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rowCount_QModelIndex(nativeId(), parent);
    }
    private native static int __qt_rowCount_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public boolean setData(com.trolltech.qt.core.QModelIndex index, java.lang.Object value, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setData_QModelIndex_Object_int(nativeId(), index, value, role);
    }
    private native static boolean __qt_setData_QModelIndex_Object_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, java.lang.Object value, int role);

    @QtBlockedSlot public void sort(int column, com.trolltech.qt.core.Qt.SortOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sort_int_SortOrder(nativeId(), column, order.value());
    }
    private native static void __qt_sort_int_SortOrder(long __this__nativeId, int column, int order);

    @QtBlockedSlot public com.trolltech.qt.core.Qt.DropActions supportedDropActions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.DropActions(__qt_supportedDropActions(nativeId()));
    }
    private native static int __qt_supportedDropActions(long __this__nativeId);


    public static native QDirModel fromNativePointer(QNativePointer nativePointer);

    protected QDirModel(QPrivateConstructor p) { super(p); } 

}
