package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDoubleValidator extends com.trolltech.qt.gui.QValidator
{
    public enum Notation implements com.trolltech.qt.QtEnumerator {
        StandardNotation(0),
        ScientificNotation(1);

        Notation(int value) { this.value = value; }
        public int value() { return value; }

        public static Notation resolve(int value) {
            return (Notation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return StandardNotation;
            case 1: return ScientificNotation;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QDoubleValidator(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QDoubleValidator_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDoubleValidator_QObject(long parent);


    public QDoubleValidator(double bottom, double top, int decimals, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QDoubleValidator_double_double_int_QObject(bottom, top, decimals, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDoubleValidator_double_double_int_QObject(double bottom, double top, int decimals, long parent);


    @com.trolltech.qt.QtPropertyReader(name="bottom")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final double bottom() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bottom(nativeId());
    }
    private native static double __qt_bottom(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="decimals")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int decimals() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_decimals(nativeId());
    }
    private native static int __qt_decimals(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="notation")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.gui.QDoubleValidator.Notation notation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QDoubleValidator.Notation.resolve(__qt_notation(nativeId()));
    }
    private native static int __qt_notation(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="bottom")
    @QtBlockedSlot public final void setBottom(double arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBottom_double(nativeId(), arg__1);
    }
    private native static void __qt_setBottom_double(long __this__nativeId, double arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="decimals")
    @QtBlockedSlot public final void setDecimals(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDecimals_int(nativeId(), arg__1);
    }
    private native static void __qt_setDecimals_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="notation")
    @QtBlockedSlot public final void setNotation(com.trolltech.qt.gui.QDoubleValidator.Notation arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNotation_Notation(nativeId(), arg__1.value());
    }
    private native static void __qt_setNotation_Notation(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="top")
    @QtBlockedSlot public final void setTop(double arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTop_double(nativeId(), arg__1);
    }
    private native static void __qt_setTop_double(long __this__nativeId, double arg__1);

    @com.trolltech.qt.QtPropertyReader(name="top")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final double top() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_top(nativeId());
    }
    private native static double __qt_top(long __this__nativeId);


    @QtBlockedSlot public final void setRange(double bottom, double top) {
        setRange(bottom, top, (int)0);
    }
    @QtBlockedSlot public void setRange(double bottom, double top, int decimals) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRange_double_double_int(nativeId(), bottom, top, decimals);
    }
    private native static void __qt_setRange_double_double_int(long __this__nativeId, double bottom, double top, int decimals);

    @QtBlockedSlot public com.trolltech.qt.gui.QValidator.State validate(com.trolltech.qt.gui.QValidator.QValidationData arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QValidator.State.resolve(__qt_validate_nativepointer_nativepointer(nativeId(), arg__1));
    }
    private native static int __qt_validate_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.gui.QValidator.QValidationData arg__1);


    public static native QDoubleValidator fromNativePointer(QNativePointer nativePointer);

    protected QDoubleValidator(QPrivateConstructor p) { super(p); } 

}
