package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFont extends com.trolltech.qt.QtJambiObject
    implements java.lang.Comparable
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum StyleStrategy implements com.trolltech.qt.QtEnumerator {
        PreferDefault(1),
        PreferBitmap(2),
        PreferDevice(4),
        PreferOutline(8),
        ForceOutline(16),
        PreferMatch(32),
        PreferQuality(64),
        PreferAntialias(128),
        NoAntialias(256),
        OpenGLCompatible(512),
        NoFontMerging(32768);

        StyleStrategy(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleStrategy resolve(int value) {
            return (StyleStrategy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return PreferDefault;
            case 2: return PreferBitmap;
            case 4: return PreferDevice;
            case 8: return PreferOutline;
            case 16: return ForceOutline;
            case 32: return PreferMatch;
            case 64: return PreferQuality;
            case 128: return PreferAntialias;
            case 256: return NoAntialias;
            case 512: return OpenGLCompatible;
            case 32768: return NoFontMerging;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleHint implements com.trolltech.qt.QtEnumerator {
        Helvetica(0),
        Times(1),
        Courier(2),
        OldEnglish(3),
        System(4),
        AnyStyle(5);

        StyleHint(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleHint resolve(int value) {
            return (StyleHint) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Helvetica;
            case 1: return Times;
            case 2: return Courier;
            case 3: return OldEnglish;
            case 4: return System;
            case 5: return AnyStyle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Weight implements com.trolltech.qt.QtEnumerator {
        Light(25),
        Normal(50),
        DemiBold(63),
        Bold(75),
        Black(87);

        Weight(int value) { this.value = value; }
        public int value() { return value; }

        public static Weight resolve(int value) {
            return (Weight) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 25: return Light;
            case 50: return Normal;
            case 63: return DemiBold;
            case 75: return Bold;
            case 87: return Black;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Stretch implements com.trolltech.qt.QtEnumerator {
        UltraCondensed(50),
        ExtraCondensed(62),
        Condensed(75),
        SemiCondensed(87),
        Unstretched(100),
        SemiExpanded(112),
        Expanded(125),
        ExtraExpanded(150),
        UltraExpanded(200);

        Stretch(int value) { this.value = value; }
        public int value() { return value; }

        public static Stretch resolve(int value) {
            return (Stretch) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 50: return UltraCondensed;
            case 62: return ExtraCondensed;
            case 75: return Condensed;
            case 87: return SemiCondensed;
            case 100: return Unstretched;
            case 112: return SemiExpanded;
            case 125: return Expanded;
            case 150: return ExtraExpanded;
            case 200: return UltraExpanded;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Style implements com.trolltech.qt.QtEnumerator {
        StyleNormal(0),
        StyleItalic(1),
        StyleOblique(2);

        Style(int value) { this.value = value; }
        public int value() { return value; }

        public static Style resolve(int value) {
            return (Style) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return StyleNormal;
            case 1: return StyleItalic;
            case 2: return StyleOblique;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QFont(com.trolltech.qt.gui.QFont arg__1) {
        super((QPrivateConstructor)null);
        __qt_QFont_QFont(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native void __qt_QFont_QFont(long arg__1);



    public QFont(java.lang.String family, int pointSize, int weight) {
        this(family, pointSize, weight, (boolean)false);
    }

    public QFont(java.lang.String family, int pointSize) {
        this(family, pointSize, (int)-1, (boolean)false);
    }

    public QFont(java.lang.String family) {
        this(family, (int)-1, (int)-1, (boolean)false);
    }
    public QFont(java.lang.String family, int pointSize, int weight, boolean italic) {
        super((QPrivateConstructor)null);
        __qt_QFont_String_int_int_boolean(family, pointSize, weight, italic);
    }
    private native void __qt_QFont_String_int_int_boolean(java.lang.String family, int pointSize, int weight, boolean italic);


    public QFont() {
        super((QPrivateConstructor)null);
        __qt_QFont();
    }
    private native void __qt_QFont();


    public QFont(com.trolltech.qt.gui.QFont arg__1, com.trolltech.qt.gui.QPaintDeviceInterface pd) {
        super((QPrivateConstructor)null);
        __qt_QFont_QFont_QPaintDevice(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId(), pd == null ? 0 : pd.nativeId());
    }
    private native void __qt_QFont_QFont_QPaintDevice(long arg__1, long pd);


    @QtBlockedSlot public final boolean bold() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bold(nativeId());
    }
    private native static boolean __qt_bold(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String defaultFamily() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultFamily(nativeId());
    }
    private native static java.lang.String __qt_defaultFamily(long __this__nativeId);

    @QtBlockedSlot public final boolean exactMatch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exactMatch(nativeId());
    }
    private native static boolean __qt_exactMatch(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String family() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_family(nativeId());
    }
    private native static java.lang.String __qt_family(long __this__nativeId);

    @QtBlockedSlot public final boolean fixedPitch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fixedPitch(nativeId());
    }
    private native static boolean __qt_fixedPitch(long __this__nativeId);

    @QtBlockedSlot public final boolean fromString(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fromString_String(nativeId(), arg__1);
    }
    private native static boolean __qt_fromString_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final long handle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static long __qt_handle(long __this__nativeId);

    @QtBlockedSlot public final boolean isCopyOf(com.trolltech.qt.gui.QFont arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCopyOf_QFont(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_isCopyOf_QFont(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final boolean italic() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_italic(nativeId());
    }
    private native static boolean __qt_italic(long __this__nativeId);

    @QtBlockedSlot public final boolean kerning() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_kerning(nativeId());
    }
    private native static boolean __qt_kerning(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String key() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_key(nativeId());
    }
    private native static java.lang.String __qt_key(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String lastResortFamily() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastResortFamily(nativeId());
    }
    private native static java.lang.String __qt_lastResortFamily(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String lastResortFont() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastResortFont(nativeId());
    }
    private native static java.lang.String __qt_lastResortFont(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_less(com.trolltech.qt.gui.QFont arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QFont(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_operator_less_QFont(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QFont arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QFont(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_operator_equal_QFont(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final boolean overline() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_overline(nativeId());
    }
    private native static boolean __qt_overline(long __this__nativeId);

    @QtBlockedSlot public final int pixelSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixelSize(nativeId());
    }
    private native static int __qt_pixelSize(long __this__nativeId);

    @QtBlockedSlot public final int pointSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pointSize(nativeId());
    }
    private native static int __qt_pointSize(long __this__nativeId);

    @QtBlockedSlot public final double pointSizeF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pointSizeF(nativeId());
    }
    private native static double __qt_pointSizeF(long __this__nativeId);

    @QtBlockedSlot public final boolean rawMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rawMode(nativeId());
    }
    private native static boolean __qt_rawMode(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String rawName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rawName(nativeId());
    }
    private native static java.lang.String __qt_rawName(long __this__nativeId);

    @QtBlockedSlot public final int resolve() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolve(nativeId());
    }
    private native static int __qt_resolve(long __this__nativeId);

    @QtBlockedSlot public final void resolve(int mask) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resolve_int(nativeId(), mask);
    }
    private native static void __qt_resolve_int(long __this__nativeId, int mask);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont resolve(com.trolltech.qt.gui.QFont arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolve_QFont(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_resolve_QFont(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setBold(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBold_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setBold_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setFamily(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFamily_String(nativeId(), arg__1);
    }
    private native static void __qt_setFamily_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setFixedPitch(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFixedPitch_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setFixedPitch_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setItalic(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setItalic_boolean(nativeId(), b);
    }
    private native static void __qt_setItalic_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public final void setKerning(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setKerning_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setKerning_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setOverline(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOverline_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setOverline_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setPixelSize(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPixelSize_int(nativeId(), arg__1);
    }
    private native static void __qt_setPixelSize_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setPointSize(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPointSize_int(nativeId(), arg__1);
    }
    private native static void __qt_setPointSize_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setPointSizeF(double arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPointSizeF_double(nativeId(), arg__1);
    }
    private native static void __qt_setPointSizeF_double(long __this__nativeId, double arg__1);

    @QtBlockedSlot public final void setRawMode(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRawMode_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setRawMode_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setRawName(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRawName_String(nativeId(), arg__1);
    }
    private native static void __qt_setRawName_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setStretch(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStretch_int(nativeId(), arg__1);
    }
    private native static void __qt_setStretch_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setStrikeOut(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStrikeOut_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setStrikeOut_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setStyle(com.trolltech.qt.gui.QFont.Style style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStyle_Style(nativeId(), style.value());
    }
    private native static void __qt_setStyle_Style(long __this__nativeId, int style);


    @QtBlockedSlot public final void setStyleHint(com.trolltech.qt.gui.QFont.StyleHint arg__1) {
        setStyleHint(arg__1, com.trolltech.qt.gui.QFont.StyleStrategy.PreferDefault);
    }
    @QtBlockedSlot public final void setStyleHint(com.trolltech.qt.gui.QFont.StyleHint arg__1, com.trolltech.qt.gui.QFont.StyleStrategy arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStyleHint_StyleHint_StyleStrategy(nativeId(), arg__1.value(), arg__2.value());
    }
    private native static void __qt_setStyleHint_StyleHint_StyleStrategy(long __this__nativeId, int arg__1, int arg__2);

    @QtBlockedSlot public final void setStyleStrategy(com.trolltech.qt.gui.QFont.StyleStrategy s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStyleStrategy_StyleStrategy(nativeId(), s.value());
    }
    private native static void __qt_setStyleStrategy_StyleStrategy(long __this__nativeId, int s);

    @QtBlockedSlot public final void setUnderline(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUnderline_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setUnderline_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setWeight(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWeight_int(nativeId(), arg__1);
    }
    private native static void __qt_setWeight_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final int stretch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stretch(nativeId());
    }
    private native static int __qt_stretch(long __this__nativeId);

    @QtBlockedSlot public final boolean strikeOut() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_strikeOut(nativeId());
    }
    private native static boolean __qt_strikeOut(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont.Style style() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFont.Style.resolve(__qt_style(nativeId()));
    }
    private native static int __qt_style(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont.StyleHint styleHint() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFont.StyleHint.resolve(__qt_styleHint(nativeId()));
    }
    private native static int __qt_styleHint(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont.StyleStrategy styleStrategy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFont.StyleStrategy.resolve(__qt_styleStrategy(nativeId()));
    }
    private native static int __qt_styleStrategy(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String toString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString(nativeId());
    }
    private native static java.lang.String __qt_toString(long __this__nativeId);

    @QtBlockedSlot public final boolean underline() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_underline(nativeId());
    }
    private native static boolean __qt_underline(long __this__nativeId);

    @QtBlockedSlot public final int weight() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_weight(nativeId());
    }
    private native static int __qt_weight(long __this__nativeId);

    public native static void cacheStatistics();

    public native static void cleanup();

    public native static void initialize();

    public native static void insertSubstitution(java.lang.String arg__1, java.lang.String arg__2);

    public native static void insertSubstitutions(java.lang.String arg__1, java.util.List<java.lang.String> arg__2);

    public native static void removeSubstitution(java.lang.String arg__1);

    public native static java.lang.String substitute(java.lang.String arg__1);

    public native static java.util.List<java.lang.String> substitutes(java.lang.String arg__1);

    public native static java.util.List<java.lang.String> substitutions();


    public static native QFont fromNativePointer(QNativePointer nativePointer);

    protected QFont(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QFont array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QFont)
            return operator_equal((com.trolltech.qt.gui.QFont) other);
        return false;
    }

    public int compareTo(Object other) {
        if (equals(other)) return 0;
        else if (other instanceof com.trolltech.qt.gui.QFont && operator_less((com.trolltech.qt.gui.QFont) other)) return -1;
        else return 1;
    }
}
