package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public interface QGraphicsItemInterface extends QtJambiInterface
{
    @QtBlockedSlot public boolean acceptDrops();

    @QtBlockedSlot public com.trolltech.qt.core.Qt.MouseButtons acceptedMouseButtons();

    @QtBlockedSlot public boolean acceptsHoverEvents();

    @QtBlockedSlot public void addToIndex();

    @QtBlockedSlot public java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> childItems();

    @QtBlockedSlot public com.trolltech.qt.core.QRectF childrenBoundingRect();

    @QtBlockedSlot public void clearFocus();

    @QtBlockedSlot public java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> collidingItems(com.trolltech.qt.core.Qt.ItemSelectionMode mode);

    @QtBlockedSlot public com.trolltech.qt.gui.QCursor cursor();

    @QtBlockedSlot public java.lang.Object data(int key);

    @QtBlockedSlot public com.trolltech.qt.gui.QTransform deviceTransform(com.trolltech.qt.gui.QTransform viewportTransform);

    @QtBlockedSlot public void ensureVisible(double x, double y, double w, double h, int xmargin, int ymargin);

    @QtBlockedSlot public void ensureVisible(com.trolltech.qt.core.QRectF rect, int xmargin, int ymargin);

    @QtBlockedSlot public com.trolltech.qt.gui.QGraphicsItem.GraphicsItemFlags flags();

    @QtBlockedSlot public com.trolltech.qt.gui.QGraphicsItemGroup group();

    @QtBlockedSlot public boolean handlesChildEvents();

    @QtBlockedSlot public boolean hasCursor();

    @QtBlockedSlot public boolean hasFocus();

    @QtBlockedSlot public void hide();

    @QtBlockedSlot public void installSceneEventFilter(com.trolltech.qt.gui.QGraphicsItemInterface filterItem);

    @QtBlockedSlot public boolean isAncestorOf(com.trolltech.qt.gui.QGraphicsItemInterface child);

    @QtBlockedSlot public boolean isEnabled();

    @QtBlockedSlot public boolean isObscured();

    @QtBlockedSlot public boolean isObscured(double x, double y, double w, double h);

    @QtBlockedSlot public boolean isObscured(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public boolean isSelected();

    @QtBlockedSlot public boolean isVisible();

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, double x, double y, double w, double h);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromItem(com.trolltech.qt.gui.QGraphicsItemInterface item, double x, double y);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromParent(double x, double y, double w, double h);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromParent(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapFromParent(com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromParent(com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromParent(double x, double y);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromParent(com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromScene(com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromScene(double x, double y, double w, double h);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapFromScene(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromScene(com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapFromScene(double x, double y);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapFromScene(com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, double x, double y);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, double x, double y, double w, double h);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToParent(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToParent(double x, double y);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToParent(com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapToParent(com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToParent(com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToParent(double x, double y, double w, double h);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToScene(double x, double y);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath mapToScene(com.trolltech.qt.gui.QPainterPath path);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToScene(com.trolltech.qt.gui.QPolygonF polygon);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToScene(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public com.trolltech.qt.core.QPointF mapToScene(com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public com.trolltech.qt.gui.QPolygonF mapToScene(double x, double y, double w, double h);

    @QtBlockedSlot public void moveBy(double dx, double dy);

    @QtBlockedSlot public com.trolltech.qt.gui.QGraphicsItemInterface parentItem();

    @QtBlockedSlot public com.trolltech.qt.core.QPointF pos();

    @QtBlockedSlot public void prepareGeometryChange();

    @QtBlockedSlot public void removeFromIndex();

    @QtBlockedSlot public void removeSceneEventFilter(com.trolltech.qt.gui.QGraphicsItemInterface filterItem);

    @QtBlockedSlot public void resetTransform();

    @QtBlockedSlot public void rotate(double angle);

    @QtBlockedSlot public void scale(double sx, double sy);

    @QtBlockedSlot public com.trolltech.qt.gui.QGraphicsScene scene();

    @QtBlockedSlot public com.trolltech.qt.core.QRectF sceneBoundingRect();

    @QtBlockedSlot public com.trolltech.qt.core.QPointF scenePos();

    @QtBlockedSlot public com.trolltech.qt.gui.QTransform sceneTransform();

    @QtBlockedSlot public void setAcceptDrops(boolean on);

    @QtBlockedSlot public void setAcceptedMouseButtons(com.trolltech.qt.core.Qt.MouseButtons buttons);

    @QtBlockedSlot public void setAcceptsHoverEvents(boolean enabled);

    @QtBlockedSlot public void setCursor(com.trolltech.qt.gui.QCursor cursor);

    @QtBlockedSlot public void setData(int key, java.lang.Object value);

    @QtBlockedSlot public void setEnabled(boolean enabled);

    @QtBlockedSlot public void setFlag(com.trolltech.qt.gui.QGraphicsItem.GraphicsItemFlag flag, boolean enabled);

    @QtBlockedSlot public void setFlags(com.trolltech.qt.gui.QGraphicsItem.GraphicsItemFlags flags);

    @QtBlockedSlot public void setFocus(com.trolltech.qt.core.Qt.FocusReason focusReason);

    @QtBlockedSlot public void setGroup(com.trolltech.qt.gui.QGraphicsItemGroup group);

    @QtBlockedSlot public void setHandlesChildEvents(boolean enabled);

    @QtBlockedSlot public void setParentItem(com.trolltech.qt.gui.QGraphicsItemInterface parent);

    @QtBlockedSlot public void setPos(com.trolltech.qt.core.QPointF pos);

    @QtBlockedSlot public void setPos(double x, double y);

    @QtBlockedSlot public void setSelected(boolean selected);

    @QtBlockedSlot public void setToolTip(java.lang.String toolTip);

    @QtBlockedSlot public void setTransform(com.trolltech.qt.gui.QTransform matrix, boolean combine);

    @QtBlockedSlot public void setVisible(boolean visible);

    @QtBlockedSlot public void setZValue(double z);

    @QtBlockedSlot public void shear(double sh, double sv);

    @QtBlockedSlot public void show();

    @QtBlockedSlot public java.lang.String toolTip();

    @QtBlockedSlot public com.trolltech.qt.gui.QGraphicsItemInterface topLevelItem();

    @QtBlockedSlot public com.trolltech.qt.gui.QTransform transform();

    @QtBlockedSlot public void translate(double dx, double dy);

    @QtBlockedSlot public void unsetCursor();

    @QtBlockedSlot public void update(com.trolltech.qt.core.QRectF rect);

    @QtBlockedSlot public void update(double x, double y, double width, double height);

    @QtBlockedSlot public double x();

    @QtBlockedSlot public double y();

    @QtBlockedSlot public double zValue();

    @QtBlockedSlot public void advance(int phase);

    @QtBlockedSlot public com.trolltech.qt.core.QRectF boundingRect();

    @QtBlockedSlot public boolean collidesWithItem(com.trolltech.qt.gui.QGraphicsItemInterface other, com.trolltech.qt.core.Qt.ItemSelectionMode mode);

    @QtBlockedSlot public boolean collidesWithPath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.core.Qt.ItemSelectionMode mode);

    @QtBlockedSlot public boolean contains(com.trolltech.qt.core.QPointF point);

    @QtBlockedSlot public void contextMenuEvent(com.trolltech.qt.gui.QGraphicsSceneContextMenuEvent event);

    @QtBlockedSlot public void dragEnterEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event);

    @QtBlockedSlot public void dragLeaveEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event);

    @QtBlockedSlot public void dragMoveEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event);

    @QtBlockedSlot public void dropEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event);

    @QtBlockedSlot public java.lang.Object extension(java.lang.Object variant);

    @QtBlockedSlot public void focusInEvent(com.trolltech.qt.gui.QFocusEvent event);

    @QtBlockedSlot public void focusOutEvent(com.trolltech.qt.gui.QFocusEvent event);

    @QtBlockedSlot public void hoverEnterEvent(com.trolltech.qt.gui.QGraphicsSceneHoverEvent event);

    @QtBlockedSlot public void hoverLeaveEvent(com.trolltech.qt.gui.QGraphicsSceneHoverEvent event);

    @QtBlockedSlot public void hoverMoveEvent(com.trolltech.qt.gui.QGraphicsSceneHoverEvent event);

    @QtBlockedSlot public void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent event);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery query);

    @QtBlockedSlot public boolean isObscuredBy(com.trolltech.qt.gui.QGraphicsItemInterface item);

    @QtBlockedSlot public java.lang.Object itemChange(com.trolltech.qt.gui.QGraphicsItem.GraphicsItemChange change, java.lang.Object value);

    @QtBlockedSlot public void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event);

    @QtBlockedSlot public void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent event);

    @QtBlockedSlot public void mouseDoubleClickEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event);

    @QtBlockedSlot public void mouseMoveEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event);

    @QtBlockedSlot public void mousePressEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event);

    @QtBlockedSlot public void mouseReleaseEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath opaqueArea();

    @QtBlockedSlot public void paint(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.gui.QStyleOptionGraphicsItem option, com.trolltech.qt.gui.QWidget widget);

    @QtBlockedSlot public boolean sceneEvent(com.trolltech.qt.core.QEvent event);

    @QtBlockedSlot public boolean sceneEventFilter(com.trolltech.qt.gui.QGraphicsItemInterface watched, com.trolltech.qt.core.QEvent event);

    @QtBlockedSlot public void setExtension(com.trolltech.qt.gui.QGraphicsItem.Extension extension, java.lang.Object variant);

    @QtBlockedSlot public com.trolltech.qt.gui.QPainterPath shape();

    @QtBlockedSlot public boolean supportsExtension(com.trolltech.qt.gui.QGraphicsItem.Extension extension);

    @QtBlockedSlot public int type();

    @QtBlockedSlot public void wheelEvent(com.trolltech.qt.gui.QGraphicsSceneWheelEvent event);


    public long __qt_cast_to_QGraphicsItem(long ptr);
}
