package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGraphicsScene extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private Object __rcFocusItem = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum SceneLayer implements com.trolltech.qt.QtEnumerator {
        ItemLayer(1),
        BackgroundLayer(2),
        ForegroundLayer(4),
        AllLayers(65535);

        SceneLayer(int value) { this.value = value; }
        public int value() { return value; }

        public static SceneLayers createQFlags(SceneLayer ... values) {
            return new SceneLayers(values);
        }
        public static SceneLayer resolve(int value) {
            return (SceneLayer) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return ItemLayer;
            case 2: return BackgroundLayer;
            case 4: return ForegroundLayer;
            case 65535: return AllLayers;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class SceneLayers extends com.trolltech.qt.QFlags<SceneLayer> {
        private static final long serialVersionUID = 1L;
        public SceneLayers(SceneLayer ... args) { super(args); }
        public SceneLayers(int value) { setValue(value); }
    }

    public enum ItemIndexMethod implements com.trolltech.qt.QtEnumerator {
        BspTreeIndex(0),
        NoIndex(-1);

        ItemIndexMethod(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemIndexMethod resolve(int value) {
            return (ItemIndexMethod) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return BspTreeIndex;
            case -1: return NoIndex;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.util.List<com.trolltech.qt.core.QRectF>> changed = new Signal1<java.util.List<com.trolltech.qt.core.QRectF>>();

    @SuppressWarnings("unused")
    private final void changed(java.util.List<com.trolltech.qt.core.QRectF> region) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changed_List(nativeId(), region);
    }
    private native static void __qt_changed_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QRectF> region);

    public final Signal1<com.trolltech.qt.core.QRectF> sceneRectChanged = new Signal1<com.trolltech.qt.core.QRectF>();

    @SuppressWarnings("unused")
    private final void sceneRectChanged(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sceneRectChanged_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_sceneRectChanged_QRectF(long __this__nativeId, long rect);

    public final Signal0 selectionChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void selectionChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged(nativeId());
    }
    private native static void __qt_selectionChanged(long __this__nativeId);


    public QGraphicsScene() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QGraphicsScene(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsScene_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QGraphicsScene_QObject(long parent);



    public QGraphicsScene(com.trolltech.qt.core.QRectF sceneRect) {
        this(sceneRect, (com.trolltech.qt.core.QObject)null);
    }
    public QGraphicsScene(com.trolltech.qt.core.QRectF sceneRect, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsScene_QRectF_QObject(sceneRect == null ? (sceneRect = new com.trolltech.qt.core.QRectF()).nativeId() : sceneRect.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QGraphicsScene_QRectF_QObject(long sceneRect, long parent);



    public QGraphicsScene(double x, double y, double width, double height) {
        this(x, y, width, height, (com.trolltech.qt.core.QObject)null);
    }
    public QGraphicsScene(double x, double y, double width, double height, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsScene_double_double_double_double_QObject(x, y, width, height, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QGraphicsScene_double_double_double_double_QObject(double x, double y, double width, double height, long parent);



    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(double x, double y, double w, double h, com.trolltech.qt.gui.QPen pen) {
        return addEllipse(x, y, w, h, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(double x, double y, double w, double h) {
        return addEllipse(x, y, w, h, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(double x, double y, double w, double h, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addEllipse_double_double_double_double_QPen_QBrush(nativeId(), x, y, w, h, pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsEllipseItem __qt_addEllipse_double_double_double_double_QPen_QBrush(long __this__nativeId, double x, double y, double w, double h, long pen, long brush);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPen pen) {
        return addEllipse(rect, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(com.trolltech.qt.core.QRectF rect) {
        return addEllipse(rect, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsEllipseItem addEllipse(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsEllipseItem __qt_return_value = __qt_addEllipse_QRectF_QPen_QBrush(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsEllipseItem __qt_addEllipse_QRectF_QPen_QBrush(long __this__nativeId, long rect, long pen, long brush);

    @QtBlockedSlot public final void addItem(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (item != null) {
            item.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addItem_QGraphicsItem(nativeId(), item == null ? 0 : item.nativeId());
    }
    private native static void __qt_addItem_QGraphicsItem(long __this__nativeId, long item);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsLineItem addLine(double x1, double y1, double x2, double y2) {
        return addLine(x1, y1, x2, y2, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsLineItem addLine(double x1, double y1, double x2, double y2, com.trolltech.qt.gui.QPen pen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addLine_double_double_double_double_QPen(nativeId(), x1, y1, x2, y2, pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsLineItem __qt_addLine_double_double_double_double_QPen(long __this__nativeId, double x1, double y1, double x2, double y2, long pen);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsLineItem addLine(com.trolltech.qt.gui.QLineF line) {
        return addLine(line, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsLineItem addLine(com.trolltech.qt.gui.QLineF line, com.trolltech.qt.gui.QPen pen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsLineItem __qt_return_value = __qt_addLine_QLineF_QPen(nativeId(), line == null ? (line = new com.trolltech.qt.gui.QLineF()).nativeId() : line.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsLineItem __qt_addLine_QLineF_QPen(long __this__nativeId, long line, long pen);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPathItem addPath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.gui.QPen pen) {
        return addPath(path, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPathItem addPath(com.trolltech.qt.gui.QPainterPath path) {
        return addPath(path, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPathItem addPath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsPathItem __qt_return_value = __qt_addPath_QPainterPath_QPen_QBrush(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsPathItem __qt_addPath_QPainterPath_QPen_QBrush(long __this__nativeId, long path, long pen, long brush);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPixmapItem addPixmap(com.trolltech.qt.gui.QPixmap pixmap) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsPixmapItem __qt_return_value = __qt_addPixmap_QPixmap(nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsPixmapItem __qt_addPixmap_QPixmap(long __this__nativeId, long pixmap);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPolygonItem addPolygon(com.trolltech.qt.gui.QPolygonF polygon, com.trolltech.qt.gui.QPen pen) {
        return addPolygon(polygon, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPolygonItem addPolygon(com.trolltech.qt.gui.QPolygonF polygon) {
        return addPolygon(polygon, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsPolygonItem addPolygon(com.trolltech.qt.gui.QPolygonF polygon, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsPolygonItem __qt_return_value = __qt_addPolygon_QPolygonF_QPen_QBrush(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsPolygonItem __qt_addPolygon_QPolygonF_QPen_QBrush(long __this__nativeId, long polygon, long pen, long brush);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(double x, double y, double w, double h, com.trolltech.qt.gui.QPen pen) {
        return addRect(x, y, w, h, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(double x, double y, double w, double h) {
        return addRect(x, y, w, h, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(double x, double y, double w, double h, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addRect_double_double_double_double_QPen_QBrush(nativeId(), x, y, w, h, pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsRectItem __qt_addRect_double_double_double_double_QPen_QBrush(long __this__nativeId, double x, double y, double w, double h, long pen, long brush);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPen pen) {
        return addRect(rect, pen, (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(com.trolltech.qt.core.QRectF rect) {
        return addRect(rect, (com.trolltech.qt.gui.QPen)new com.trolltech.qt.gui.QPen(), (com.trolltech.qt.gui.QBrush)new com.trolltech.qt.gui.QBrush());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsRectItem addRect(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPen pen, com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsRectItem __qt_return_value = __qt_addRect_QRectF_QPen_QBrush(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsRectItem __qt_addRect_QRectF_QPen_QBrush(long __this__nativeId, long rect, long pen, long brush);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsSimpleTextItem addSimpleText(java.lang.String text) {
        return addSimpleText(text, (com.trolltech.qt.gui.QFont)new com.trolltech.qt.gui.QFont());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsSimpleTextItem addSimpleText(java.lang.String text, com.trolltech.qt.gui.QFont font) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addSimpleText_String_QFont(nativeId(), text, font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsSimpleTextItem __qt_addSimpleText_String_QFont(long __this__nativeId, java.lang.String text, long font);


    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsTextItem addText(java.lang.String text) {
        return addText(text, (com.trolltech.qt.gui.QFont)new com.trolltech.qt.gui.QFont());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsTextItem addText(java.lang.String text, com.trolltech.qt.gui.QFont font) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QGraphicsTextItem __qt_return_value = __qt_addText_String_QFont(nativeId(), text, font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
        if (__qt_return_value != null) {
          __qt_return_value.disableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QGraphicsTextItem __qt_addText_String_QFont(long __this__nativeId, java.lang.String text, long font);

    public final void advance() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_advance(nativeId());
    }
    private native static void __qt_advance(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="backgroundBrush")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush backgroundBrush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_backgroundBrush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_backgroundBrush(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="bspTreeDepth")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int bspTreeDepth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bspTreeDepth(nativeId());
    }
    private native static int __qt_bspTreeDepth(long __this__nativeId);

    @QtBlockedSlot public final void clearFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearFocus(nativeId());
    }
    private native static void __qt_clearFocus(long __this__nativeId);

    @QtBlockedSlot public final void clearSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearSelection(nativeId());
    }
    private native static void __qt_clearSelection(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> collidingItems(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        return collidingItems(item, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> collidingItems(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_collidingItems_QGraphicsItem_ItemSelectionMode(nativeId(), item == null ? 0 : item.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_collidingItems_QGraphicsItem_ItemSelectionMode(long __this__nativeId, long item, int mode);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemGroup createItemGroup(java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createItemGroup_List(nativeId(), items);
    }
    private native static com.trolltech.qt.gui.QGraphicsItemGroup __qt_createItemGroup_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items);

    @QtBlockedSlot public final void destroyItemGroup(com.trolltech.qt.gui.QGraphicsItemGroup group) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_destroyItemGroup_QGraphicsItemGroup(nativeId(), group == null ? 0 : group.nativeId());
    }
    private native static void __qt_destroyItemGroup_QGraphicsItemGroup(long __this__nativeId, long group);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface focusItem() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusItem(nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_focusItem(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="foregroundBrush")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foregroundBrush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foregroundBrush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foregroundBrush(long __this__nativeId);

    @QtBlockedSlot public final boolean hasFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFocus(nativeId());
    }
    private native static boolean __qt_hasFocus(long __this__nativeId);

    @QtBlockedSlot public final double height() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static double __qt_height(long __this__nativeId);


    public final void invalidate(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QGraphicsScene.SceneLayer ... layers) {
        this.invalidate(rect, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(layers));
    }

    public final void invalidate(com.trolltech.qt.core.QRectF rect) {
        invalidate(rect, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(65535));
    }

    public final void invalidate() {
        invalidate((com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(65535));
    }
    public final void invalidate(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QGraphicsScene.SceneLayers layers) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_invalidate_QRectF_SceneLayers(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), layers.value());
    }
    private native static void __qt_invalidate_QRectF_SceneLayers(long __this__nativeId, long rect, int layers);


    @QtBlockedSlot public final void invalidate(double x, double y, double w, double h, com.trolltech.qt.gui.QGraphicsScene.SceneLayer ... layers) {
        this.invalidate(x, y, w, h, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(layers));
    }

    @QtBlockedSlot public final void invalidate(double x, double y, double w, double h) {
        invalidate(x, y, w, h, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(65535));
    }
    @QtBlockedSlot public final void invalidate(double x, double y, double w, double h, com.trolltech.qt.gui.QGraphicsScene.SceneLayers layers) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_invalidate_double_double_double_double_SceneLayers(nativeId(), x, y, w, h, layers.value());
    }
    private native static void __qt_invalidate_double_double_double_double_SceneLayers(long __this__nativeId, double x, double y, double w, double h, int layers);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface itemAt(double x, double y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemAt_double_double(nativeId(), x, y);
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_itemAt_double_double(long __this__nativeId, double x, double y);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface itemAt(com.trolltech.qt.core.QPointF pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemAt_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_itemAt_QPointF(long __this__nativeId, long pos);

    @com.trolltech.qt.QtPropertyReader(name="itemIndexMethod")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsScene.ItemIndexMethod itemIndexMethod() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsScene.ItemIndexMethod.resolve(__qt_itemIndexMethod(nativeId()));
    }
    private native static int __qt_itemIndexMethod(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QPointF pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPointF(long __this__nativeId, long pos);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QRectF rect) {
        return items(rect, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QRectF_ItemSelectionMode(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QRectF_ItemSelectionMode(long __this__nativeId, long rect, int mode);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(double x, double y, double w, double h) {
        return items(x, y, w, h, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(double x, double y, double w, double h, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_double_double_double_double_ItemSelectionMode(nativeId(), x, y, w, h, mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_double_double_double_double_ItemSelectionMode(long __this__nativeId, double x, double y, double w, double h, int mode);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPainterPath path) {
        return items(path, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPainterPath_ItemSelectionMode(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPainterPath_ItemSelectionMode(long __this__nativeId, long path, int mode);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPolygonF polygon) {
        return items(polygon, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPolygonF polygon, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPolygonF_ItemSelectionMode(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPolygonF_ItemSelectionMode(long __this__nativeId, long polygon, int mode);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF itemsBoundingRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemsBoundingRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_itemsBoundingRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface mouseGrabberItem() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mouseGrabberItem(nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_mouseGrabberItem(long __this__nativeId);

    @QtBlockedSlot public final void removeItem(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (item != null) {
            item.reenableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeItem_QGraphicsItem(nativeId(), item == null ? 0 : item.nativeId());
    }
    private native static void __qt_removeItem_QGraphicsItem(long __this__nativeId, long item);


    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target, com.trolltech.qt.core.QRectF source) {
        render(painter, target, source, com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target) {
        render(painter, target, (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter) {
        render(painter, (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }
    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target, com.trolltech.qt.core.QRectF source, com.trolltech.qt.core.Qt.AspectRatioMode aspectRatioMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_render_QPainter_QRectF_QRectF_AspectRatioMode(nativeId(), painter == null ? 0 : painter.nativeId(), target == null ? (target = new com.trolltech.qt.core.QRectF()).nativeId() : target.nativeId(), source == null ? (source = new com.trolltech.qt.core.QRectF()).nativeId() : source.nativeId(), aspectRatioMode.value());
    }
    private native static void __qt_render_QPainter_QRectF_QRectF_AspectRatioMode(long __this__nativeId, long painter, long target, long source, int aspectRatioMode);

    @com.trolltech.qt.QtPropertyReader(name="sceneRect")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.QRectF sceneRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sceneRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_sceneRect(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> selectedItems() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedItems(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_selectedItems(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath selectionArea() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectionArea(nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_selectionArea(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="backgroundBrush")
    @QtBlockedSlot public final void setBackgroundBrush(com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackgroundBrush_QBrush(long __this__nativeId, long brush);

    @com.trolltech.qt.QtPropertyWriter(name="bspTreeDepth")
    @QtBlockedSlot public final void setBspTreeDepth(int depth) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBspTreeDepth_int(nativeId(), depth);
    }
    private native static void __qt_setBspTreeDepth_int(long __this__nativeId, int depth);


    @QtBlockedSlot public final void setFocus() {
        setFocus(com.trolltech.qt.core.Qt.FocusReason.OtherFocusReason);
    }
    @QtBlockedSlot public final void setFocus(com.trolltech.qt.core.Qt.FocusReason focusReason) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFocus_FocusReason(nativeId(), focusReason.value());
    }
    private native static void __qt_setFocus_FocusReason(long __this__nativeId, int focusReason);


    @QtBlockedSlot public final void setFocusItem(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        setFocusItem(item, com.trolltech.qt.core.Qt.FocusReason.OtherFocusReason);
    }
    @QtBlockedSlot public final void setFocusItem(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.Qt.FocusReason focusReason) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcFocusItem = item;
        }
        __qt_setFocusItem_QGraphicsItem_FocusReason(nativeId(), item == null ? 0 : item.nativeId(), focusReason.value());
    }
    private native static void __qt_setFocusItem_QGraphicsItem_FocusReason(long __this__nativeId, long item, int focusReason);

    @com.trolltech.qt.QtPropertyWriter(name="foregroundBrush")
    @QtBlockedSlot public final void setForegroundBrush(com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForegroundBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForegroundBrush_QBrush(long __this__nativeId, long brush);

    @com.trolltech.qt.QtPropertyWriter(name="itemIndexMethod")
    @QtBlockedSlot public final void setItemIndexMethod(com.trolltech.qt.gui.QGraphicsScene.ItemIndexMethod method) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setItemIndexMethod_ItemIndexMethod(nativeId(), method.value());
    }
    private native static void __qt_setItemIndexMethod_ItemIndexMethod(long __this__nativeId, int method);

    @com.trolltech.qt.QtPropertyWriter(name="sceneRect")
    @QtBlockedSlot public final void setSceneRect(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSceneRect_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setSceneRect_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final void setSceneRect(double x, double y, double w, double h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSceneRect_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static void __qt_setSceneRect_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);

    @QtBlockedSlot public final void setSelectionArea(com.trolltech.qt.gui.QPainterPath path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectionArea_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static void __qt_setSelectionArea_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final void setSelectionArea(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.core.Qt.ItemSelectionMode arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectionArea_QPainterPath_ItemSelectionMode(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), arg__2.value());
    }
    private native static void __qt_setSelectionArea_QPainterPath_ItemSelectionMode(long __this__nativeId, long path, int arg__2);

    @QtBlockedSlot public final void update(double x, double y, double w, double h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static void __qt_update_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);


    public final void update() {
        update((com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF());
    }
    public final void update(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_update_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsView> views() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_views(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsView> __qt_views(long __this__nativeId);

    @QtBlockedSlot public final double width() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static double __qt_width(long __this__nativeId);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QGraphicsSceneContextMenuEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QGraphicsSceneContextMenuEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_contextMenuEvent_QGraphicsSceneContextMenuEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragEnterEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragEnterEvent_QGraphicsSceneDragDropEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragEnterEvent_QGraphicsSceneDragDropEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragLeaveEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragLeaveEvent_QGraphicsSceneDragDropEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragLeaveEvent_QGraphicsSceneDragDropEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragMoveEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragMoveEvent_QGraphicsSceneDragDropEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragMoveEvent_QGraphicsSceneDragDropEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void drawBackground(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawBackground_QPainter_QRectF(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawBackground_QPainter_QRectF(long __this__nativeId, long painter, long rect);

    @QtBlockedSlot protected void drawForeground(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawForeground_QPainter_QRectF(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawForeground_QPainter_QRectF(long __this__nativeId, long painter, long rect);


    @QtBlockedSlot protected final void drawItems(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.gui.QGraphicsItemInterface[] items, com.trolltech.qt.gui.QStyleOptionGraphicsItem[] options) {
        drawItems(painter, items, options, (com.trolltech.qt.gui.QWidget)null);
    }
    @QtBlockedSlot protected void drawItems(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.gui.QGraphicsItemInterface[] items, com.trolltech.qt.gui.QStyleOptionGraphicsItem[] options, com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawItems_QPainter_int_nativepointer_nativepointer_QWidget(nativeId(), painter == null ? 0 : painter.nativeId(), items, options, widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_drawItems_QPainter_int_nativepointer_nativepointer_QWidget(long __this__nativeId, long painter, com.trolltech.qt.gui.QGraphicsItemInterface[] items, com.trolltech.qt.gui.QStyleOptionGraphicsItem[] options, long widget);

    @QtBlockedSlot protected void dropEvent(com.trolltech.qt.gui.QGraphicsSceneDragDropEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dropEvent_QGraphicsSceneDragDropEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dropEvent_QGraphicsSceneDragDropEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void helpEvent(com.trolltech.qt.gui.QGraphicsSceneHelpEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_helpEvent_QGraphicsSceneHelpEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_helpEvent_QGraphicsSceneHelpEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_inputMethodEvent_QInputMethodEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_inputMethodEvent_QInputMethodEvent(long __this__nativeId, long event);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery query) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputMethodQuery_InputMethodQuery(nativeId(), query.value());
    }
    private native static java.lang.Object __qt_inputMethodQuery_InputMethodQuery(long __this__nativeId, int query);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QGraphicsSceneMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QGraphicsSceneMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QGraphicsSceneMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QGraphicsSceneMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QGraphicsSceneMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mousePressEvent_QGraphicsSceneMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QGraphicsSceneMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QGraphicsSceneMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QGraphicsSceneMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QGraphicsSceneWheelEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QGraphicsSceneWheelEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_wheelEvent_QGraphicsSceneWheelEvent(long __this__nativeId, long event);


    public static native QGraphicsScene fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QGraphicsScene(QPrivateConstructor p) { super(p); } 

}
