package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGraphicsView extends com.trolltech.qt.gui.QAbstractScrollArea
{
    @SuppressWarnings("unused") private Object __rcScene = null;
    public enum OptimizationFlag implements com.trolltech.qt.QtEnumerator {
        DontClipPainter(1),
        DontSavePainterState(2),
        DontAdjustForAntialiasing(4);

        OptimizationFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static OptimizationFlags createQFlags(OptimizationFlag ... values) {
            return new OptimizationFlags(values);
        }
        public static OptimizationFlag resolve(int value) {
            return (OptimizationFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DontClipPainter;
            case 2: return DontSavePainterState;
            case 4: return DontAdjustForAntialiasing;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class OptimizationFlags extends com.trolltech.qt.QFlags<OptimizationFlag> {
        private static final long serialVersionUID = 1L;
        public OptimizationFlags(OptimizationFlag ... args) { super(args); }
        public OptimizationFlags(int value) { setValue(value); }
    }

    public enum ViewportAnchor implements com.trolltech.qt.QtEnumerator {
        NoAnchor(0),
        AnchorViewCenter(1),
        AnchorUnderMouse(2);

        ViewportAnchor(int value) { this.value = value; }
        public int value() { return value; }

        public static ViewportAnchor resolve(int value) {
            return (ViewportAnchor) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoAnchor;
            case 1: return AnchorViewCenter;
            case 2: return AnchorUnderMouse;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ViewportUpdateMode implements com.trolltech.qt.QtEnumerator {
        FullViewportUpdate(0),
        MinimalViewportUpdate(1),
        SmartViewportUpdate(2),
        NoViewportUpdate(3);

        ViewportUpdateMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ViewportUpdateMode resolve(int value) {
            return (ViewportUpdateMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FullViewportUpdate;
            case 1: return MinimalViewportUpdate;
            case 2: return SmartViewportUpdate;
            case 3: return NoViewportUpdate;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CacheModeFlag implements com.trolltech.qt.QtEnumerator {
        CacheNone(0),
        CacheBackground(1);

        CacheModeFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static CacheMode createQFlags(CacheModeFlag ... values) {
            return new CacheMode(values);
        }
        public static CacheModeFlag resolve(int value) {
            return (CacheModeFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CacheNone;
            case 1: return CacheBackground;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class CacheMode extends com.trolltech.qt.QFlags<CacheModeFlag> {
        private static final long serialVersionUID = 1L;
        public CacheMode(CacheModeFlag ... args) { super(args); }
        public CacheMode(int value) { setValue(value); }
    }

    public enum DragMode implements com.trolltech.qt.QtEnumerator {
        NoDrag(0),
        ScrollHandDrag(1),
        RubberBandDrag(2);

        DragMode(int value) { this.value = value; }
        public int value() { return value; }

        public static DragMode resolve(int value) {
            return (DragMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoDrag;
            case 1: return ScrollHandDrag;
            case 2: return RubberBandDrag;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QGraphicsView() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QGraphicsView(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsView_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QGraphicsView_QWidget(long parent);



    public QGraphicsView(com.trolltech.qt.gui.QGraphicsScene scene) {
        this(scene, (com.trolltech.qt.gui.QWidget)null);
    }
    public QGraphicsView(com.trolltech.qt.gui.QGraphicsScene scene, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsView_QGraphicsScene_QWidget(scene == null ? 0 : scene.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QGraphicsView_QGraphicsScene_QWidget(long scene, long parent);


    @com.trolltech.qt.QtPropertyReader(name="alignment")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment alignment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_alignment(nativeId()));
    }
    private native static int __qt_alignment(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="backgroundBrush")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush backgroundBrush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_backgroundBrush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_backgroundBrush(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="cacheMode")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.CacheMode cacheMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QGraphicsView.CacheMode(__qt_cacheMode(nativeId()));
    }
    private native static int __qt_cacheMode(long __this__nativeId);

    @QtBlockedSlot public final void centerOn(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_centerOn_QGraphicsItem(nativeId(), item == null ? 0 : item.nativeId());
    }
    private native static void __qt_centerOn_QGraphicsItem(long __this__nativeId, long item);

    @QtBlockedSlot public final void centerOn(com.trolltech.qt.core.QPointF pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_centerOn_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static void __qt_centerOn_QPointF(long __this__nativeId, long pos);

    @QtBlockedSlot public final void centerOn(double x, double y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_centerOn_double_double(nativeId(), x, y);
    }
    private native static void __qt_centerOn_double_double(long __this__nativeId, double x, double y);

    @com.trolltech.qt.QtPropertyReader(name="dragMode")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.DragMode dragMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsView.DragMode.resolve(__qt_dragMode(nativeId()));
    }
    private native static int __qt_dragMode(long __this__nativeId);


    @QtBlockedSlot public final void ensureVisible(double x, double y, double w, double h, int xmargin) {
        ensureVisible(x, y, w, h, xmargin, (int)50);
    }

    @QtBlockedSlot public final void ensureVisible(double x, double y, double w, double h) {
        ensureVisible(x, y, w, h, (int)50, (int)50);
    }
    @QtBlockedSlot public final void ensureVisible(double x, double y, double w, double h, int xmargin, int ymargin) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ensureVisible_double_double_double_double_int_int(nativeId(), x, y, w, h, xmargin, ymargin);
    }
    private native static void __qt_ensureVisible_double_double_double_double_int_int(long __this__nativeId, double x, double y, double w, double h, int xmargin, int ymargin);


    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.gui.QGraphicsItemInterface item, int xmargin) {
        ensureVisible(item, xmargin, (int)50);
    }

    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        ensureVisible(item, (int)50, (int)50);
    }
    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.gui.QGraphicsItemInterface item, int xmargin, int ymargin) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ensureVisible_QGraphicsItem_int_int(nativeId(), item == null ? 0 : item.nativeId(), xmargin, ymargin);
    }
    private native static void __qt_ensureVisible_QGraphicsItem_int_int(long __this__nativeId, long item, int xmargin, int ymargin);


    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.core.QRectF rect, int xmargin) {
        ensureVisible(rect, xmargin, (int)50);
    }

    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.core.QRectF rect) {
        ensureVisible(rect, (int)50, (int)50);
    }
    @QtBlockedSlot public final void ensureVisible(com.trolltech.qt.core.QRectF rect, int xmargin, int ymargin) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ensureVisible_QRectF_int_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), xmargin, ymargin);
    }
    private native static void __qt_ensureVisible_QRectF_int_int(long __this__nativeId, long rect, int xmargin, int ymargin);


    @QtBlockedSlot public final void fitInView(double x, double y, double w, double h) {
        fitInView(x, y, w, h, com.trolltech.qt.core.Qt.AspectRatioMode.IgnoreAspectRatio);
    }
    @QtBlockedSlot public final void fitInView(double x, double y, double w, double h, com.trolltech.qt.core.Qt.AspectRatioMode aspectRadioMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fitInView_double_double_double_double_AspectRatioMode(nativeId(), x, y, w, h, aspectRadioMode.value());
    }
    private native static void __qt_fitInView_double_double_double_double_AspectRatioMode(long __this__nativeId, double x, double y, double w, double h, int aspectRadioMode);


    @QtBlockedSlot public final void fitInView(com.trolltech.qt.gui.QGraphicsItemInterface item) {
        fitInView(item, com.trolltech.qt.core.Qt.AspectRatioMode.IgnoreAspectRatio);
    }
    @QtBlockedSlot public final void fitInView(com.trolltech.qt.gui.QGraphicsItemInterface item, com.trolltech.qt.core.Qt.AspectRatioMode aspectRadioMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fitInView_QGraphicsItem_AspectRatioMode(nativeId(), item == null ? 0 : item.nativeId(), aspectRadioMode.value());
    }
    private native static void __qt_fitInView_QGraphicsItem_AspectRatioMode(long __this__nativeId, long item, int aspectRadioMode);


    @QtBlockedSlot public final void fitInView(com.trolltech.qt.core.QRectF rect) {
        fitInView(rect, com.trolltech.qt.core.Qt.AspectRatioMode.IgnoreAspectRatio);
    }
    @QtBlockedSlot public final void fitInView(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.core.Qt.AspectRatioMode aspectRadioMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fitInView_QRectF_AspectRatioMode(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), aspectRadioMode.value());
    }
    private native static void __qt_fitInView_QRectF_AspectRatioMode(long __this__nativeId, long rect, int aspectRadioMode);

    @com.trolltech.qt.QtPropertyReader(name="foregroundBrush")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foregroundBrush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foregroundBrush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foregroundBrush(long __this__nativeId);


    public final void invalidateScene(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QGraphicsScene.SceneLayer ... layers) {
        this.invalidateScene(rect, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(layers));
    }

    public final void invalidateScene(com.trolltech.qt.core.QRectF rect) {
        invalidateScene(rect, new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(65535));
    }

    public final void invalidateScene() {
        invalidateScene((com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), new com.trolltech.qt.gui.QGraphicsScene.SceneLayers(65535));
    }
    public final void invalidateScene(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QGraphicsScene.SceneLayers layers) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_invalidateScene_QRectF_SceneLayers(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), layers.value());
    }
    private native static void __qt_invalidateScene_QRectF_SceneLayers(long __this__nativeId, long rect, int layers);

    @com.trolltech.qt.QtPropertyReader(name="interactive")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean isInteractive() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isInteractive(nativeId());
    }
    private native static boolean __qt_isInteractive(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface itemAt(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemAt_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_itemAt_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsItemInterface itemAt(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemAt_int_int(nativeId(), x, y);
    }
    private native static com.trolltech.qt.gui.QGraphicsItemInterface __qt_itemAt_int_int(long __this__nativeId, int x, int y);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPolygon polygon) {
        return items(polygon, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPolygon polygon, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPolygon_ItemSelectionMode(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygon()).nativeId() : polygon.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPolygon_ItemSelectionMode(long __this__nativeId, long polygon, int mode);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPainterPath path) {
        return items(path, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPainterPath_ItemSelectionMode(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPainterPath_ItemSelectionMode(long __this__nativeId, long path, int mode);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QPoint(long __this__nativeId, long pos);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(int x, int y, int w, int h) {
        return items(x, y, w, h, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(int x, int y, int w, int h, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_int_int_int_int_ItemSelectionMode(nativeId(), x, y, w, h, mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_int_int_int_int_ItemSelectionMode(long __this__nativeId, int x, int y, int w, int h, int mode);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_int_int(nativeId(), x, y);
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_int_int(long __this__nativeId, int x, int y);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QRect rect) {
        return items(rect, com.trolltech.qt.core.Qt.ItemSelectionMode.IntersectsItemShape);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items(com.trolltech.qt.core.QRect rect, com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items_QRect_ItemSelectionMode(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), mode.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items_QRect_ItemSelectionMode(long __this__nativeId, long rect, int mode);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> items() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_items(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QGraphicsItemInterface> __qt_items(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapFromScene(double x, double y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_double_double(nativeId(), x, y);
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapFromScene_double_double(long __this__nativeId, double x, double y);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapFromScene(com.trolltech.qt.core.QPointF point) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_QPointF(nativeId(), point == null ? (point = new com.trolltech.qt.core.QPointF()).nativeId() : point.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapFromScene_QPointF(long __this__nativeId, long point);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygon mapFromScene(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygon __qt_mapFromScene_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygon mapFromScene(double x, double y, double w, double h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static com.trolltech.qt.gui.QPolygon __qt_mapFromScene_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath mapFromScene(com.trolltech.qt.gui.QPainterPath path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_mapFromScene_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygon mapFromScene(com.trolltech.qt.gui.QPolygonF polygon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromScene_QPolygonF(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygon __qt_mapFromScene_QPolygonF(long __this__nativeId, long polygon);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF mapToScene(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_int_int(nativeId(), x, y);
    }
    private native static com.trolltech.qt.core.QPointF __qt_mapToScene_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF mapToScene(com.trolltech.qt.gui.QPolygon polygon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_QPolygon(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygon()).nativeId() : polygon.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_mapToScene_QPolygon(long __this__nativeId, long polygon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF mapToScene(int x, int y, int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_mapToScene_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF mapToScene(com.trolltech.qt.core.QRect rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_mapToScene_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF mapToScene(com.trolltech.qt.core.QPoint point) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_QPoint(nativeId(), point == null ? (point = new com.trolltech.qt.core.QPoint()).nativeId() : point.nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_mapToScene_QPoint(long __this__nativeId, long point);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath mapToScene(com.trolltech.qt.gui.QPainterPath path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToScene_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_mapToScene_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMatrix matrix() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_matrix(nativeId());
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_matrix(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="optimizationFlags")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.OptimizationFlags optimizationFlags() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QGraphicsView.OptimizationFlags(__qt_optimizationFlags(nativeId()));
    }
    private native static int __qt_optimizationFlags(long __this__nativeId);


    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target, com.trolltech.qt.core.QRect source) {
        render(painter, target, source, com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target) {
        render(painter, target, (com.trolltech.qt.core.QRect)new com.trolltech.qt.core.QRect(), com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter) {
        render(painter, (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF(), (com.trolltech.qt.core.QRect)new com.trolltech.qt.core.QRect(), com.trolltech.qt.core.Qt.AspectRatioMode.KeepAspectRatio);
    }
    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF target, com.trolltech.qt.core.QRect source, com.trolltech.qt.core.Qt.AspectRatioMode aspectRatioMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_render_QPainter_QRectF_QRect_AspectRatioMode(nativeId(), painter == null ? 0 : painter.nativeId(), target == null ? (target = new com.trolltech.qt.core.QRectF()).nativeId() : target.nativeId(), source == null ? (source = new com.trolltech.qt.core.QRect()).nativeId() : source.nativeId(), aspectRatioMode.value());
    }
    private native static void __qt_render_QPainter_QRectF_QRect_AspectRatioMode(long __this__nativeId, long painter, long target, long source, int aspectRatioMode);

    @com.trolltech.qt.QtPropertyReader(name="renderHints")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.gui.QPainter.RenderHints renderHints() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QPainter.RenderHints(__qt_renderHints(nativeId()));
    }
    private native static int __qt_renderHints(long __this__nativeId);

    @QtBlockedSlot public final void resetCachedContent() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetCachedContent(nativeId());
    }
    private native static void __qt_resetCachedContent(long __this__nativeId);

    @QtBlockedSlot public final void resetMatrix() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetMatrix(nativeId());
    }
    private native static void __qt_resetMatrix(long __this__nativeId);

    @QtBlockedSlot public final void resetTransform() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetTransform(nativeId());
    }
    private native static void __qt_resetTransform(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="resizeAnchor")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.ViewportAnchor resizeAnchor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsView.ViewportAnchor.resolve(__qt_resizeAnchor(nativeId()));
    }
    private native static int __qt_resizeAnchor(long __this__nativeId);

    @QtBlockedSlot public final void rotate(double angle) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rotate_double(nativeId(), angle);
    }
    private native static void __qt_rotate_double(long __this__nativeId, double angle);

    @com.trolltech.qt.QtPropertyReader(name="rubberBandSelectionMode")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ItemSelectionMode rubberBandSelectionMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ItemSelectionMode.resolve(__qt_rubberBandSelectionMode(nativeId()));
    }
    private native static int __qt_rubberBandSelectionMode(long __this__nativeId);

    @QtBlockedSlot public final void scale(double sx, double sy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scale_double_double(nativeId(), sx, sy);
    }
    private native static void __qt_scale_double_double(long __this__nativeId, double sx, double sy);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsScene scene() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scene(nativeId());
    }
    private native static com.trolltech.qt.gui.QGraphicsScene __qt_scene(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sceneRect")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.QRectF sceneRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sceneRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_sceneRect(long __this__nativeId);


    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.setAlignment(new com.trolltech.qt.core.Qt.Alignment(alignment));
    }
    @com.trolltech.qt.QtPropertyWriter(name="alignment")
    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.Alignment alignment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlignment_Alignment(nativeId(), alignment.value());
    }
    private native static void __qt_setAlignment_Alignment(long __this__nativeId, int alignment);

    @com.trolltech.qt.QtPropertyWriter(name="backgroundBrush")
    @QtBlockedSlot public final void setBackgroundBrush(com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackgroundBrush_QBrush(long __this__nativeId, long brush);


    @QtBlockedSlot public final void setCacheMode(com.trolltech.qt.gui.QGraphicsView.CacheModeFlag ... mode) {
        this.setCacheMode(new com.trolltech.qt.gui.QGraphicsView.CacheMode(mode));
    }
    @com.trolltech.qt.QtPropertyWriter(name="cacheMode")
    @QtBlockedSlot public final void setCacheMode(com.trolltech.qt.gui.QGraphicsView.CacheMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCacheMode_CacheMode(nativeId(), mode.value());
    }
    private native static void __qt_setCacheMode_CacheMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="dragMode")
    @QtBlockedSlot public final void setDragMode(com.trolltech.qt.gui.QGraphicsView.DragMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDragMode_DragMode(nativeId(), mode.value());
    }
    private native static void __qt_setDragMode_DragMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="foregroundBrush")
    @QtBlockedSlot public final void setForegroundBrush(com.trolltech.qt.gui.QBrush brush) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForegroundBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForegroundBrush_QBrush(long __this__nativeId, long brush);

    @com.trolltech.qt.QtPropertyWriter(name="interactive")
    @QtBlockedSlot public final void setInteractive(boolean allowed) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInteractive_boolean(nativeId(), allowed);
    }
    private native static void __qt_setInteractive_boolean(long __this__nativeId, boolean allowed);


    @QtBlockedSlot public final void setMatrix(com.trolltech.qt.gui.QMatrix matrix) {
        setMatrix(matrix, (boolean)false);
    }
    @QtBlockedSlot public final void setMatrix(com.trolltech.qt.gui.QMatrix matrix, boolean combine) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMatrix_QMatrix_boolean(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId(), combine);
    }
    private native static void __qt_setMatrix_QMatrix_boolean(long __this__nativeId, long matrix, boolean combine);


    @QtBlockedSlot public final void setOptimizationFlag(com.trolltech.qt.gui.QGraphicsView.OptimizationFlag flag) {
        setOptimizationFlag(flag, (boolean)true);
    }
    @QtBlockedSlot public final void setOptimizationFlag(com.trolltech.qt.gui.QGraphicsView.OptimizationFlag flag, boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOptimizationFlag_OptimizationFlag_boolean(nativeId(), flag.value(), enabled);
    }
    private native static void __qt_setOptimizationFlag_OptimizationFlag_boolean(long __this__nativeId, int flag, boolean enabled);


    @QtBlockedSlot public final void setOptimizationFlags(com.trolltech.qt.gui.QGraphicsView.OptimizationFlag ... flags) {
        this.setOptimizationFlags(new com.trolltech.qt.gui.QGraphicsView.OptimizationFlags(flags));
    }
    @com.trolltech.qt.QtPropertyWriter(name="optimizationFlags")
    @QtBlockedSlot public final void setOptimizationFlags(com.trolltech.qt.gui.QGraphicsView.OptimizationFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOptimizationFlags_OptimizationFlags(nativeId(), flags.value());
    }
    private native static void __qt_setOptimizationFlags_OptimizationFlags(long __this__nativeId, int flags);


    @QtBlockedSlot public final void setRenderHint(com.trolltech.qt.gui.QPainter.RenderHint hint) {
        setRenderHint(hint, (boolean)true);
    }
    @QtBlockedSlot public final void setRenderHint(com.trolltech.qt.gui.QPainter.RenderHint hint, boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRenderHint_RenderHint_boolean(nativeId(), hint.value(), enabled);
    }
    private native static void __qt_setRenderHint_RenderHint_boolean(long __this__nativeId, int hint, boolean enabled);


    @QtBlockedSlot public final void setRenderHints(com.trolltech.qt.gui.QPainter.RenderHint ... hints) {
        this.setRenderHints(new com.trolltech.qt.gui.QPainter.RenderHints(hints));
    }
    @com.trolltech.qt.QtPropertyWriter(name="renderHints")
    @QtBlockedSlot public final void setRenderHints(com.trolltech.qt.gui.QPainter.RenderHints hints) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRenderHints_RenderHints(nativeId(), hints.value());
    }
    private native static void __qt_setRenderHints_RenderHints(long __this__nativeId, int hints);

    @com.trolltech.qt.QtPropertyWriter(name="resizeAnchor")
    @QtBlockedSlot public final void setResizeAnchor(com.trolltech.qt.gui.QGraphicsView.ViewportAnchor anchor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResizeAnchor_ViewportAnchor(nativeId(), anchor.value());
    }
    private native static void __qt_setResizeAnchor_ViewportAnchor(long __this__nativeId, int anchor);

    @com.trolltech.qt.QtPropertyWriter(name="rubberBandSelectionMode")
    @QtBlockedSlot public final void setRubberBandSelectionMode(com.trolltech.qt.core.Qt.ItemSelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRubberBandSelectionMode_ItemSelectionMode(nativeId(), mode.value());
    }
    private native static void __qt_setRubberBandSelectionMode_ItemSelectionMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setScene(com.trolltech.qt.gui.QGraphicsScene scene) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcScene = scene;
        }
        __qt_setScene_QGraphicsScene(nativeId(), scene == null ? 0 : scene.nativeId());
    }
    private native static void __qt_setScene_QGraphicsScene(long __this__nativeId, long scene);

    @com.trolltech.qt.QtPropertyWriter(name="sceneRect")
    @QtBlockedSlot public final void setSceneRect(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSceneRect_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setSceneRect_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final void setSceneRect(double x, double y, double w, double h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSceneRect_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static void __qt_setSceneRect_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);


    @QtBlockedSlot public final void setTransform(com.trolltech.qt.gui.QTransform matrix) {
        setTransform(matrix, (boolean)false);
    }
    @QtBlockedSlot public final void setTransform(com.trolltech.qt.gui.QTransform matrix, boolean combine) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTransform_QTransform_boolean(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId(), combine);
    }
    private native static void __qt_setTransform_QTransform_boolean(long __this__nativeId, long matrix, boolean combine);

    @com.trolltech.qt.QtPropertyWriter(name="transformationAnchor")
    @QtBlockedSlot public final void setTransformationAnchor(com.trolltech.qt.gui.QGraphicsView.ViewportAnchor anchor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTransformationAnchor_ViewportAnchor(nativeId(), anchor.value());
    }
    private native static void __qt_setTransformationAnchor_ViewportAnchor(long __this__nativeId, int anchor);

    @com.trolltech.qt.QtPropertyWriter(name="viewportUpdateMode")
    @QtBlockedSlot public final void setViewportUpdateMode(com.trolltech.qt.gui.QGraphicsView.ViewportUpdateMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewportUpdateMode_ViewportUpdateMode(nativeId(), mode.value());
    }
    private native static void __qt_setViewportUpdateMode_ViewportUpdateMode(long __this__nativeId, int mode);

    protected void setupViewport(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setupViewport_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setupViewport_QWidget(long __this__nativeId, long widget);

    @QtBlockedSlot public final void shear(double sh, double sv) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_shear_double_double(nativeId(), sh, sv);
    }
    private native static void __qt_shear_double_double(long __this__nativeId, double sh, double sv);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform transform() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_transform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_transform(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="transformationAnchor")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.ViewportAnchor transformationAnchor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsView.ViewportAnchor.resolve(__qt_transformationAnchor(nativeId()));
    }
    private native static int __qt_transformationAnchor(long __this__nativeId);

    @QtBlockedSlot public final void translate(double dx, double dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_double_double(nativeId(), dx, dy);
    }
    private native static void __qt_translate_double_double(long __this__nativeId, double dx, double dy);

    public final void updateScene(java.util.List<com.trolltech.qt.core.QRectF> rects) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateScene_List(nativeId(), rects);
    }
    private native static void __qt_updateScene_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QRectF> rects);

    public final void updateSceneRect(com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateSceneRect_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_updateSceneRect_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform viewportTransform() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewportTransform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_viewportTransform(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="viewportUpdateMode")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsView.ViewportUpdateMode viewportUpdateMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsView.ViewportUpdateMode.resolve(__qt_viewportUpdateMode(nativeId()));
    }
    private native static int __qt_viewportUpdateMode(long __this__nativeId);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragEnterEvent(com.trolltech.qt.gui.QDragEnterEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragEnterEvent_QDragEnterEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragEnterEvent_QDragEnterEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragLeaveEvent(com.trolltech.qt.gui.QDragLeaveEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragLeaveEvent_QDragLeaveEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragLeaveEvent_QDragLeaveEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void dragMoveEvent(com.trolltech.qt.gui.QDragMoveEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragMoveEvent_QDragMoveEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dragMoveEvent_QDragMoveEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void drawBackground(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawBackground_QPainter_QRectF(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawBackground_QPainter_QRectF(long __this__nativeId, long painter, long rect);

    @QtBlockedSlot protected void drawForeground(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawForeground_QPainter_QRectF(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawForeground_QPainter_QRectF(long __this__nativeId, long painter, long rect);

    @QtBlockedSlot protected void drawItems(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.gui.QGraphicsItemInterface[] items, com.trolltech.qt.gui.QStyleOptionGraphicsItem[] options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawItems_QPainter_int_nativepointer_nativepointer(nativeId(), painter == null ? 0 : painter.nativeId(), items, options);
    }
    private native static void __qt_drawItems_QPainter_int_nativepointer_nativepointer(long __this__nativeId, long painter, com.trolltech.qt.gui.QGraphicsItemInterface[] items, com.trolltech.qt.gui.QStyleOptionGraphicsItem[] options);

    @QtBlockedSlot protected void dropEvent(com.trolltech.qt.gui.QDropEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dropEvent_QDropEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_dropEvent_QDropEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_inputMethodEvent_QInputMethodEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_inputMethodEvent_QInputMethodEvent(long __this__nativeId, long event);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery query) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputMethodQuery_InputMethodQuery(nativeId(), query.value());
    }
    private native static java.lang.Object __qt_inputMethodQuery_InputMethodQuery(long __this__nativeId, int query);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void scrollContentsBy(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollContentsBy_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scrollContentsBy_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected boolean viewportEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewportEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_viewportEvent_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long event);


    public static native QGraphicsView fromNativePointer(QNativePointer nativePointer);

    protected QGraphicsView(QPrivateConstructor p) { super(p); } 

}
