package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QHeaderView extends com.trolltech.qt.gui.QAbstractItemView
{
    public enum ResizeMode implements com.trolltech.qt.QtEnumerator {
        Interactive(0),
        Stretch(1),
        Fixed(2),
        ResizeToContents(3),
;

        ResizeMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ResizeMode resolve(int value) {
            return (ResizeMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Interactive;
            case 1: return Stretch;
            case 2: return Fixed;
            case 3: return ResizeToContents;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 geometriesChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void geometriesChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_geometriesChanged(nativeId());
    }
    private native static void __qt_geometriesChanged(long __this__nativeId);

    public final Signal2<java.lang.Integer, com.trolltech.qt.gui.QHeaderView.ResizeMode> sectionAutoResize = new Signal2<java.lang.Integer, com.trolltech.qt.gui.QHeaderView.ResizeMode>();

    @SuppressWarnings("unused")
    private final void sectionAutoResize(int logicalIndex, com.trolltech.qt.gui.QHeaderView.ResizeMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionAutoResize_int_ResizeMode(nativeId(), logicalIndex, mode.value());
    }
    private native static void __qt_sectionAutoResize_int_ResizeMode(long __this__nativeId, int logicalIndex, int mode);

    public final Signal1<java.lang.Integer> sectionClicked = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionClicked(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionClicked_int(nativeId(), logicalIndex);
    }
    private native static void __qt_sectionClicked_int(long __this__nativeId, int logicalIndex);

    public final Signal2<java.lang.Integer, java.lang.Integer> sectionCountChanged = new Signal2<java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionCountChanged(int oldCount, int newCount) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionCountChanged_int_int(nativeId(), oldCount, newCount);
    }
    private native static void __qt_sectionCountChanged_int_int(long __this__nativeId, int oldCount, int newCount);

    public final Signal1<java.lang.Integer> sectionDoubleClicked = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionDoubleClicked(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionDoubleClicked_int(nativeId(), logicalIndex);
    }
    private native static void __qt_sectionDoubleClicked_int(long __this__nativeId, int logicalIndex);

    public final Signal1<java.lang.Integer> sectionEntered = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionEntered(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionEntered_int(nativeId(), logicalIndex);
    }
    private native static void __qt_sectionEntered_int(long __this__nativeId, int logicalIndex);

    public final Signal1<java.lang.Integer> sectionHandleDoubleClicked = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionHandleDoubleClicked(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionHandleDoubleClicked_int(nativeId(), logicalIndex);
    }
    private native static void __qt_sectionHandleDoubleClicked_int(long __this__nativeId, int logicalIndex);

    public final Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer> sectionMoved = new Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionMoved(int logicalIndex, int oldVisualIndex, int newVisualIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionMoved_int_int_int(nativeId(), logicalIndex, oldVisualIndex, newVisualIndex);
    }
    private native static void __qt_sectionMoved_int_int_int(long __this__nativeId, int logicalIndex, int oldVisualIndex, int newVisualIndex);

    public final Signal1<java.lang.Integer> sectionPressed = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionPressed(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionPressed_int(nativeId(), logicalIndex);
    }
    private native static void __qt_sectionPressed_int(long __this__nativeId, int logicalIndex);

    public final Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer> sectionResized = new Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sectionResized(int logicalIndex, int oldSize, int newSize) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionResized_int_int_int(nativeId(), logicalIndex, oldSize, newSize);
    }
    private native static void __qt_sectionResized_int_int_int(long __this__nativeId, int logicalIndex, int oldSize, int newSize);

    public final Signal2<java.lang.Integer, com.trolltech.qt.core.Qt.SortOrder> sortIndicatorChanged = new Signal2<java.lang.Integer, com.trolltech.qt.core.Qt.SortOrder>();

    @SuppressWarnings("unused")
    private final void sortIndicatorChanged(int logicalIndex, com.trolltech.qt.core.Qt.SortOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sortIndicatorChanged_int_SortOrder(nativeId(), logicalIndex, order.value());
    }
    private native static void __qt_sortIndicatorChanged_int_SortOrder(long __this__nativeId, int logicalIndex, int order);


    public QHeaderView(com.trolltech.qt.core.Qt.Orientation orientation) {
        this(orientation, (com.trolltech.qt.gui.QWidget)null);
    }
    public QHeaderView(com.trolltech.qt.core.Qt.Orientation orientation, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QHeaderView_Orientation_QWidget(orientation.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QHeaderView_Orientation_QWidget(int orientation, long parent);


    @com.trolltech.qt.QtPropertyReader(name="cascadingSectionResizes")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean cascadingSectionResizes() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cascadingSectionResizes(nativeId());
    }
    private native static boolean __qt_cascadingSectionResizes(long __this__nativeId);

    @QtBlockedSlot public final int count() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="defaultAlignment")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment defaultAlignment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_defaultAlignment(nativeId()));
    }
    private native static int __qt_defaultAlignment(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="defaultSectionSize")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int defaultSectionSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultSectionSize(nativeId());
    }
    private native static int __qt_defaultSectionSize(long __this__nativeId);

    public final void headerDataChanged(com.trolltech.qt.core.Qt.Orientation orientation, int logicalFirst, int logicalLast) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_headerDataChanged_Orientation_int_int(nativeId(), orientation.value(), logicalFirst, logicalLast);
    }
    private native static void __qt_headerDataChanged_Orientation_int_int(long __this__nativeId, int orientation, int logicalFirst, int logicalLast);

    @QtBlockedSlot public final int hiddenSectionCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hiddenSectionCount(nativeId());
    }
    private native static int __qt_hiddenSectionCount(long __this__nativeId);

    @QtBlockedSlot public final void hideSection(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideSection_int(nativeId(), logicalIndex);
    }
    private native static void __qt_hideSection_int(long __this__nativeId, int logicalIndex);

    @com.trolltech.qt.QtPropertyReader(name="highlightSections")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final boolean highlightSections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_highlightSections(nativeId());
    }
    private native static boolean __qt_highlightSections(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot protected final void initialize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initialize(nativeId());
    }
    private native static void __qt_initialize(long __this__nativeId);

    @QtBlockedSlot protected final void initializeSections(int start, int end) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initializeSections_int_int(nativeId(), start, end);
    }
    private native static void __qt_initializeSections_int_int(long __this__nativeId, int start, int end);

    @QtBlockedSlot protected final void initializeSections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initializeSections(nativeId());
    }
    private native static void __qt_initializeSections(long __this__nativeId);

    @QtBlockedSlot public final boolean isClickable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isClickable(nativeId());
    }
    private native static boolean __qt_isClickable(long __this__nativeId);

    @QtBlockedSlot public final boolean isMovable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isMovable(nativeId());
    }
    private native static boolean __qt_isMovable(long __this__nativeId);

    @QtBlockedSlot public final boolean isSectionHidden(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSectionHidden_int(nativeId(), logicalIndex);
    }
    private native static boolean __qt_isSectionHidden_int(long __this__nativeId, int logicalIndex);

    @com.trolltech.qt.QtPropertyReader(name="showSortIndicator")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isSortIndicatorShown() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSortIndicatorShown(nativeId());
    }
    private native static boolean __qt_isSortIndicatorShown(long __this__nativeId);

    @QtBlockedSlot public final int length() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_length(nativeId());
    }
    private native static int __qt_length(long __this__nativeId);

    @QtBlockedSlot public final int logicalIndex(int visualIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalIndex_int(nativeId(), visualIndex);
    }
    private native static int __qt_logicalIndex_int(long __this__nativeId, int visualIndex);

    @QtBlockedSlot public final int logicalIndexAt(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalIndexAt_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static int __qt_logicalIndexAt_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final int logicalIndexAt(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalIndexAt_int_int(nativeId(), x, y);
    }
    private native static int __qt_logicalIndexAt_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final int logicalIndexAt(int position) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalIndexAt_int(nativeId(), position);
    }
    private native static int __qt_logicalIndexAt_int(long __this__nativeId, int position);

    @com.trolltech.qt.QtPropertyReader(name="minimumSectionSize")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int minimumSectionSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSectionSize(nativeId());
    }
    private native static int __qt_minimumSectionSize(long __this__nativeId);

    @QtBlockedSlot public final void moveSection(int from, int to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveSection_int_int(nativeId(), from, to);
    }
    private native static void __qt_moveSection_int_int(long __this__nativeId, int from, int to);

    @QtBlockedSlot public final int offset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_offset(nativeId());
    }
    private native static int __qt_offset(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientation orientation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QHeaderView.ResizeMode resizeMode(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QHeaderView.ResizeMode.resolve(__qt_resizeMode_int(nativeId(), logicalIndex));
    }
    private native static int __qt_resizeMode_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final void resizeSection(int logicalIndex, int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeSection_int_int(nativeId(), logicalIndex, size);
    }
    private native static void __qt_resizeSection_int_int(long __this__nativeId, int logicalIndex, int size);

    protected final void resizeSections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeSections(nativeId());
    }
    private native static void __qt_resizeSections(long __this__nativeId);

    @QtBlockedSlot public final void resizeSections(com.trolltech.qt.gui.QHeaderView.ResizeMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeSections_ResizeMode(nativeId(), mode.value());
    }
    private native static void __qt_resizeSections_ResizeMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final boolean restoreState(com.trolltech.qt.core.QByteArray state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_restoreState_QByteArray(nativeId(), state == null ? (state = new com.trolltech.qt.core.QByteArray()).nativeId() : state.nativeId());
    }
    private native static boolean __qt_restoreState_QByteArray(long __this__nativeId, long state);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray saveState() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saveState(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_saveState(long __this__nativeId);

    @QtBlockedSlot public final int sectionPosition(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionPosition_int(nativeId(), logicalIndex);
    }
    private native static int __qt_sectionPosition_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final int sectionSize(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionSize_int(nativeId(), logicalIndex);
    }
    private native static int __qt_sectionSize_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final int sectionSizeHint(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionSizeHint_int(nativeId(), logicalIndex);
    }
    private native static int __qt_sectionSizeHint_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final int sectionViewportPosition(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionViewportPosition_int(nativeId(), logicalIndex);
    }
    private native static int __qt_sectionViewportPosition_int(long __this__nativeId, int logicalIndex);

    protected final void sectionsAboutToBeRemoved(com.trolltech.qt.core.QModelIndex parent, int logicalFirst, int logicalLast) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionsAboutToBeRemoved_QModelIndex_int_int(nativeId(), parent, logicalFirst, logicalLast);
    }
    private native static void __qt_sectionsAboutToBeRemoved_QModelIndex_int_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, int logicalFirst, int logicalLast);

    @QtBlockedSlot public final boolean sectionsHidden() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionsHidden(nativeId());
    }
    private native static boolean __qt_sectionsHidden(long __this__nativeId);

    protected final void sectionsInserted(com.trolltech.qt.core.QModelIndex parent, int logicalFirst, int logicalLast) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sectionsInserted_QModelIndex_int_int(nativeId(), parent, logicalFirst, logicalLast);
    }
    private native static void __qt_sectionsInserted_QModelIndex_int_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, int logicalFirst, int logicalLast);

    @QtBlockedSlot public final boolean sectionsMoved() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionsMoved(nativeId());
    }
    private native static boolean __qt_sectionsMoved(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="cascadingSectionResizes")
    @QtBlockedSlot public final void setCascadingSectionResizes(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCascadingSectionResizes_boolean(nativeId(), enable);
    }
    private native static void __qt_setCascadingSectionResizes_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setClickable(boolean clickable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClickable_boolean(nativeId(), clickable);
    }
    private native static void __qt_setClickable_boolean(long __this__nativeId, boolean clickable);


    @QtBlockedSlot public final void setDefaultAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.setDefaultAlignment(new com.trolltech.qt.core.Qt.Alignment(alignment));
    }
    @com.trolltech.qt.QtPropertyWriter(name="defaultAlignment")
    @QtBlockedSlot public final void setDefaultAlignment(com.trolltech.qt.core.Qt.Alignment alignment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultAlignment_Alignment(nativeId(), alignment.value());
    }
    private native static void __qt_setDefaultAlignment_Alignment(long __this__nativeId, int alignment);

    @com.trolltech.qt.QtPropertyWriter(name="defaultSectionSize")
    @QtBlockedSlot public final void setDefaultSectionSize(int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultSectionSize_int(nativeId(), size);
    }
    private native static void __qt_setDefaultSectionSize_int(long __this__nativeId, int size);

    @com.trolltech.qt.QtPropertyWriter(name="highlightSections")
    @QtBlockedSlot public final void setHighlightSections(boolean highlight) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHighlightSections_boolean(nativeId(), highlight);
    }
    private native static void __qt_setHighlightSections_boolean(long __this__nativeId, boolean highlight);

    @com.trolltech.qt.QtPropertyWriter(name="minimumSectionSize")
    @QtBlockedSlot public final void setMinimumSectionSize(int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumSectionSize_int(nativeId(), size);
    }
    private native static void __qt_setMinimumSectionSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setMovable(boolean movable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMovable_boolean(nativeId(), movable);
    }
    private native static void __qt_setMovable_boolean(long __this__nativeId, boolean movable);

    public final void setOffset(int offset) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOffset_int(nativeId(), offset);
    }
    private native static void __qt_setOffset_int(long __this__nativeId, int offset);

    public final void setOffsetToLastSection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOffsetToLastSection(nativeId());
    }
    private native static void __qt_setOffsetToLastSection(long __this__nativeId);

    public final void setOffsetToSectionPosition(int visualIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOffsetToSectionPosition_int(nativeId(), visualIndex);
    }
    private native static void __qt_setOffsetToSectionPosition_int(long __this__nativeId, int visualIndex);

    @QtBlockedSlot public final void setResizeMode(int logicalIndex, com.trolltech.qt.gui.QHeaderView.ResizeMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResizeMode_int_ResizeMode(nativeId(), logicalIndex, mode.value());
    }
    private native static void __qt_setResizeMode_int_ResizeMode(long __this__nativeId, int logicalIndex, int mode);

    @QtBlockedSlot public final void setResizeMode(com.trolltech.qt.gui.QHeaderView.ResizeMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResizeMode_ResizeMode(nativeId(), mode.value());
    }
    private native static void __qt_setResizeMode_ResizeMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setSectionHidden(int logicalIndex, boolean hide) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSectionHidden_int_boolean(nativeId(), logicalIndex, hide);
    }
    private native static void __qt_setSectionHidden_int_boolean(long __this__nativeId, int logicalIndex, boolean hide);

    @QtBlockedSlot public final void setSortIndicator(int logicalIndex, com.trolltech.qt.core.Qt.SortOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSortIndicator_int_SortOrder(nativeId(), logicalIndex, order.value());
    }
    private native static void __qt_setSortIndicator_int_SortOrder(long __this__nativeId, int logicalIndex, int order);

    @com.trolltech.qt.QtPropertyWriter(name="showSortIndicator")
    @QtBlockedSlot public final void setSortIndicatorShown(boolean show) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSortIndicatorShown_boolean(nativeId(), show);
    }
    private native static void __qt_setSortIndicatorShown_boolean(long __this__nativeId, boolean show);

    @com.trolltech.qt.QtPropertyWriter(name="stretchLastSection")
    @QtBlockedSlot public final void setStretchLastSection(boolean stretch) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStretchLastSection_boolean(nativeId(), stretch);
    }
    private native static void __qt_setStretchLastSection_boolean(long __this__nativeId, boolean stretch);

    @QtBlockedSlot public final void showSection(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showSection_int(nativeId(), logicalIndex);
    }
    private native static void __qt_showSection_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.SortOrder sortIndicatorOrder() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.SortOrder.resolve(__qt_sortIndicatorOrder(nativeId()));
    }
    private native static int __qt_sortIndicatorOrder(long __this__nativeId);

    @QtBlockedSlot public final int sortIndicatorSection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sortIndicatorSection(nativeId());
    }
    private native static int __qt_sortIndicatorSection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="stretchLastSection")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean stretchLastSection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stretchLastSection(nativeId());
    }
    private native static boolean __qt_stretchLastSection(long __this__nativeId);

    @QtBlockedSlot public final int stretchSectionCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stretchSectionCount(nativeId());
    }
    private native static int __qt_stretchSectionCount(long __this__nativeId);

    @QtBlockedSlot public final void swapSections(int first, int second) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_swapSections_int_int(nativeId(), first, second);
    }
    private native static void __qt_swapSections_int_int(long __this__nativeId, int first, int second);

    protected final void updateSection(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateSection_int(nativeId(), logicalIndex);
    }
    private native static void __qt_updateSection_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final int visualIndex(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualIndex_int(nativeId(), logicalIndex);
    }
    private native static int __qt_visualIndex_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public final int visualIndexAt(int position) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualIndexAt_int(nativeId(), position);
    }
    private native static int __qt_visualIndexAt_int(long __this__nativeId, int position);

    @QtBlockedSlot protected void currentChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex old) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_QModelIndex_QModelIndex(nativeId(), current, old);
    }
    private native static void __qt_currentChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex old);

    @QtBlockedSlot protected void dataChanged(com.trolltech.qt.core.QModelIndex topLeft, com.trolltech.qt.core.QModelIndex bottomRight) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataChanged_QModelIndex_QModelIndex(nativeId(), topLeft, bottomRight);
    }
    private native static void __qt_dataChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex topLeft, com.trolltech.qt.core.QModelIndex bottomRight);

    @QtBlockedSlot public void doItemsLayout() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_doItemsLayout(nativeId());
    }
    private native static void __qt_doItemsLayout(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected int horizontalOffset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_horizontalOffset(nativeId());
    }
    private native static int __qt_horizontalOffset(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QModelIndex indexAt(com.trolltech.qt.core.QPoint p) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexAt_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_indexAt_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot protected boolean isIndexHidden(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isIndexHidden_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_isIndexHidden_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected com.trolltech.qt.core.QModelIndex moveCursor(com.trolltech.qt.gui.QAbstractItemView.CursorAction arg__1, com.trolltech.qt.core.Qt.KeyboardModifiers arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_moveCursor_CursorAction_KeyboardModifiers(nativeId(), arg__1.value(), arg__2.value());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_moveCursor_CursorAction_KeyboardModifiers(long __this__nativeId, int arg__1, int arg__2);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintSection(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect, int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintSection_QPainter_QRect_int(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), logicalIndex);
    }
    private native static void __qt_paintSection_QPainter_QRect_int(long __this__nativeId, long painter, long rect, int logicalIndex);

    @QtBlockedSlot public void reset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);

    @QtBlockedSlot protected void rowsInserted(com.trolltech.qt.core.QModelIndex parent, int start, int end) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rowsInserted_QModelIndex_int_int(nativeId(), parent, start, end);
    }
    private native static void __qt_rowsInserted_QModelIndex_int_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, int start, int end);

    @QtBlockedSlot protected void scrollContentsBy(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollContentsBy_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scrollContentsBy_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot public void scrollTo(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QAbstractItemView.ScrollHint hint) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollTo_QModelIndex_ScrollHint(nativeId(), index, hint.value());
    }
    private native static void __qt_scrollTo_QModelIndex_ScrollHint(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, int hint);

    @QtBlockedSlot protected com.trolltech.qt.core.QSize sectionSizeFromContents(int logicalIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sectionSizeFromContents_int(nativeId(), logicalIndex);
    }
    private native static com.trolltech.qt.core.QSize __qt_sectionSizeFromContents_int(long __this__nativeId, int logicalIndex);

    @QtBlockedSlot public void setModel(com.trolltech.qt.core.QAbstractItemModel model) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            com.trolltech.qt.QtJambiInternal.setField(this, QAbstractItemView.class, "__rcModel", model);
        }
        __qt_setModel_QAbstractItemModel(nativeId(), model == null ? 0 : model.nativeId());
    // setModel() creates a new selection model for the object
        com.trolltech.qt.QtJambiInternal.setField(this, com.trolltech.qt.gui.QAbstractItemView.class, "__rcItemSelectionModel", null);

    }
    private native static void __qt_setModel_QAbstractItemModel(long __this__nativeId, long model);

    @QtBlockedSlot protected void setSelection(com.trolltech.qt.core.QRect arg__1, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelection_QRect_SelectionFlags(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), arg__2.value());
    }
    private native static void __qt_setSelection_QRect_SelectionFlags(long __this__nativeId, long arg__1, int arg__2);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void updateGeometries() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateGeometries(nativeId());
    }
    private native static void __qt_updateGeometries(long __this__nativeId);

    @QtBlockedSlot protected int verticalOffset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_verticalOffset(nativeId());
    }
    private native static int __qt_verticalOffset(long __this__nativeId);

    @QtBlockedSlot protected boolean viewportEvent(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewportEvent_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_viewportEvent_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public com.trolltech.qt.core.QRect visualRect(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualRect_QModelIndex(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QRect __qt_visualRect_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected com.trolltech.qt.gui.QRegion visualRegionForSelection(com.trolltech.qt.gui.QItemSelection selection) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualRegionForSelection_QItemSelection(nativeId(), selection == null ? (selection = new com.trolltech.qt.gui.QItemSelection()).nativeId() : selection.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_visualRegionForSelection_QItemSelection(long __this__nativeId, long selection);


    public static native QHeaderView fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QHeaderView(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionHeader option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
