package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QIcon extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Mode implements com.trolltech.qt.QtEnumerator {
        Normal(0),
        Disabled(1),
        Active(2),
        Selected(3);

        Mode(int value) { this.value = value; }
        public int value() { return value; }

        public static Mode resolve(int value) {
            return (Mode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Normal;
            case 1: return Disabled;
            case 2: return Active;
            case 3: return Selected;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum State implements com.trolltech.qt.QtEnumerator {
        On(0),
        Off(1);

        State(int value) { this.value = value; }
        public int value() { return value; }

        public static State resolve(int value) {
            return (State) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return On;
            case 1: return Off;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QIcon(com.trolltech.qt.gui.QPixmap pixmap) {
        super((QPrivateConstructor)null);
        __qt_QIcon_QPixmap(pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId());
    }
    private native void __qt_QIcon_QPixmap(long pixmap);


    public QIcon(java.lang.String fileName) {
        super((QPrivateConstructor)null);
        __qt_QIcon_String(fileName);
    }
    private native void __qt_QIcon_String(java.lang.String fileName);


    public QIcon(com.trolltech.qt.gui.QIconEngineV2 engine) {
        super((QPrivateConstructor)null);
        if (engine != null) {
            engine.disableGarbageCollection();
        }
        __qt_QIcon_QIconEngineV2(engine == null ? 0 : engine.nativeId());
    }
    private native void __qt_QIcon_QIconEngineV2(long engine);


    public QIcon(com.trolltech.qt.gui.QIcon other) {
        super((QPrivateConstructor)null);
        __qt_QIcon_QIcon(other == null ? (other = new com.trolltech.qt.gui.QIcon()).nativeId() : other.nativeId());
    }
    private native void __qt_QIcon_QIcon(long other);


    public QIcon() {
        super((QPrivateConstructor)null);
        __qt_QIcon();
    }
    private native void __qt_QIcon();


    public QIcon(com.trolltech.qt.gui.QIconEngine engine) {
        super((QPrivateConstructor)null);
        if (engine != null) {
            engine.disableGarbageCollection();
        }
        __qt_QIcon_QIconEngine(engine == null ? 0 : engine.nativeId());
    }
    private native void __qt_QIcon_QIconEngine(long engine);



    @QtBlockedSlot public final com.trolltech.qt.core.QSize actualSize(com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode) {
        return actualSize(size, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final com.trolltech.qt.core.QSize actualSize(com.trolltech.qt.core.QSize size) {
        return actualSize(size, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QSize actualSize(com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_actualSize_QSize_Mode_State(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), mode.value(), state.value());
    }
    private native static com.trolltech.qt.core.QSize __qt_actualSize_QSize_Mode_State(long __this__nativeId, long size, int mode, int state);


    @QtBlockedSlot public final void addFile(java.lang.String fileName, com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode) {
        addFile(fileName, size, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void addFile(java.lang.String fileName, com.trolltech.qt.core.QSize size) {
        addFile(fileName, size, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void addFile(java.lang.String fileName) {
        addFile(fileName, (com.trolltech.qt.core.QSize)new com.trolltech.qt.core.QSize(), com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final void addFile(java.lang.String fileName, com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addFile_String_QSize_Mode_State(nativeId(), fileName, size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), mode.value(), state.value());
    }
    private native static void __qt_addFile_String_QSize_Mode_State(long __this__nativeId, java.lang.String fileName, long size, int mode, int state);


    @QtBlockedSlot public final void addPixmap(com.trolltech.qt.gui.QPixmap pixmap, com.trolltech.qt.gui.QIcon.Mode mode) {
        addPixmap(pixmap, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void addPixmap(com.trolltech.qt.gui.QPixmap pixmap) {
        addPixmap(pixmap, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final void addPixmap(com.trolltech.qt.gui.QPixmap pixmap, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addPixmap_QPixmap_Mode_State(nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), mode.value(), state.value());
    }
    private native static void __qt_addPixmap_QPixmap_Mode_State(long __this__nativeId, long pixmap, int mode, int state);

    @QtBlockedSlot public final long cacheKey() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cacheKey(nativeId());
    }
    private native static long __qt_cacheKey(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);


    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect, com.trolltech.qt.core.Qt.Alignment alignment, com.trolltech.qt.gui.QIcon.Mode mode) {
        paint(painter, rect, alignment, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect, com.trolltech.qt.core.Qt.Alignment alignment) {
        paint(painter, rect, alignment, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect) {
        paint(painter, rect, new com.trolltech.qt.core.Qt.Alignment(132), com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect, com.trolltech.qt.core.Qt.Alignment alignment, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paint_QPainter_QRect_Alignment_Mode_State(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), alignment.value(), mode.value(), state.value());
    }
    private native static void __qt_paint_QPainter_QRect_Alignment_Mode_State(long __this__nativeId, long painter, long rect, int alignment, int mode, int state);


    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, int x, int y, int w, int h, com.trolltech.qt.core.Qt.Alignment alignment, com.trolltech.qt.gui.QIcon.Mode mode) {
        paint(painter, x, y, w, h, alignment, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, int x, int y, int w, int h, com.trolltech.qt.core.Qt.Alignment alignment) {
        paint(painter, x, y, w, h, alignment, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, int x, int y, int w, int h) {
        paint(painter, x, y, w, h, new com.trolltech.qt.core.Qt.Alignment(132), com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final void paint(com.trolltech.qt.gui.QPainter painter, int x, int y, int w, int h, com.trolltech.qt.core.Qt.Alignment alignment, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paint_QPainter_int_int_int_int_Alignment_Mode_State(nativeId(), painter == null ? 0 : painter.nativeId(), x, y, w, h, alignment.value(), mode.value(), state.value());
    }
    private native static void __qt_paint_QPainter_int_int_int_int_Alignment_Mode_State(long __this__nativeId, long painter, int x, int y, int w, int h, int alignment, int mode, int state);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int extent, com.trolltech.qt.gui.QIcon.Mode mode) {
        return pixmap(extent, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int extent) {
        return pixmap(extent, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int extent, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixmap_int_Mode_State(nativeId(), extent, mode.value(), state.value());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_pixmap_int_Mode_State(long __this__nativeId, int extent, int mode, int state);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int w, int h, com.trolltech.qt.gui.QIcon.Mode mode) {
        return pixmap(w, h, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int w, int h) {
        return pixmap(w, h, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(int w, int h, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixmap_int_int_Mode_State(nativeId(), w, h, mode.value(), state.value());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_pixmap_int_int_Mode_State(long __this__nativeId, int w, int h, int mode, int state);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode) {
        return pixmap(size, mode, com.trolltech.qt.gui.QIcon.State.Off);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(com.trolltech.qt.core.QSize size) {
        return pixmap(size, com.trolltech.qt.gui.QIcon.Mode.Normal, com.trolltech.qt.gui.QIcon.State.Off);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QIcon.Mode mode, com.trolltech.qt.gui.QIcon.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixmap_QSize_Mode_State(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), mode.value(), state.value());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_pixmap_QSize_Mode_State(long __this__nativeId, long size, int mode, int state);


    public static native QIcon fromNativePointer(QNativePointer nativePointer);

    protected QIcon(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QIcon array[]);
}
