package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QImageIOHandler extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.gui.QImageIOHandler {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot public boolean canRead() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canRead(nativeId());
        }
        @QtBlockedSlot public boolean read(com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_nativepointer(nativeId(), image);
        }
    }

    public enum ImageOption implements com.trolltech.qt.QtEnumerator {
        Size(0),
        ClipRect(1),
        Description(2),
        ScaledClipRect(3),
        ScaledSize(4),
        CompressionRatio(5),
        Gamma(6),
        Quality(7),
        Name(8),
        SubType(9),
        IncrementalReading(10),
        Endianness(11),
        Animation(12),
        BackgroundColor(13);

        ImageOption(int value) { this.value = value; }
        public int value() { return value; }

        public static ImageOption resolve(int value) {
            return (ImageOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Size;
            case 1: return ClipRect;
            case 2: return Description;
            case 3: return ScaledClipRect;
            case 4: return ScaledSize;
            case 5: return CompressionRatio;
            case 6: return Gamma;
            case 7: return Quality;
            case 8: return Name;
            case 9: return SubType;
            case 10: return IncrementalReading;
            case 11: return Endianness;
            case 12: return Animation;
            case 13: return BackgroundColor;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QImageIOHandler() {
        super((QPrivateConstructor)null);
        __qt_QImageIOHandler();
    }
    private native void __qt_QImageIOHandler();


    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_format(long __this__nativeId);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setFormat(com.trolltech.qt.core.QByteArray format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_QByteArray(nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native static void __qt_setFormat_QByteArray(long __this__nativeId, long format);

    @QtBlockedSlot public abstract boolean canRead();
    private native static boolean __qt_canRead(long __this__nativeId);

    @QtBlockedSlot public int currentImageNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentImageNumber(nativeId());
    }
    private native static int __qt_currentImageNumber(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QRect currentImageRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentImageRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_currentImageRect(long __this__nativeId);

    @QtBlockedSlot public int imageCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_imageCount(nativeId());
    }
    private native static int __qt_imageCount(long __this__nativeId);

    @QtBlockedSlot public boolean jumpToImage(int imageNumber) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToImage_int(nativeId(), imageNumber);
    }
    private native static boolean __qt_jumpToImage_int(long __this__nativeId, int imageNumber);

    @QtBlockedSlot public boolean jumpToNextImage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToNextImage(nativeId());
    }
    private native static boolean __qt_jumpToNextImage(long __this__nativeId);

    @QtBlockedSlot public int loopCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loopCount(nativeId());
    }
    private native static int __qt_loopCount(long __this__nativeId);

    @QtBlockedSlot public int nextImageDelay() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextImageDelay(nativeId());
    }
    private native static int __qt_nextImageDelay(long __this__nativeId);

    @QtBlockedSlot public java.lang.Object option(com.trolltech.qt.gui.QImageIOHandler.ImageOption option) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_option_ImageOption(nativeId(), option.value());
    }
    private native static java.lang.Object __qt_option_ImageOption(long __this__nativeId, int option);

    @QtBlockedSlot public abstract boolean read(com.trolltech.qt.gui.QImage image);
    private native static boolean __qt_read_nativepointer(long __this__nativeId, com.trolltech.qt.gui.QImage image);

    @QtBlockedSlot public void setOption(com.trolltech.qt.gui.QImageIOHandler.ImageOption option, java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOption_ImageOption_Object(nativeId(), option.value(), value);
    }
    private native static void __qt_setOption_ImageOption_Object(long __this__nativeId, int option, java.lang.Object value);

    @QtBlockedSlot public boolean supportsOption(com.trolltech.qt.gui.QImageIOHandler.ImageOption option) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsOption_ImageOption(nativeId(), option.value());
    }
    private native static boolean __qt_supportsOption_ImageOption(long __this__nativeId, int option);

    @QtBlockedSlot public boolean write(com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_write_QImage(nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static boolean __qt_write_QImage(long __this__nativeId, long image);


    public static native QImageIOHandler fromNativePointer(QNativePointer nativePointer);

    protected QImageIOHandler(QPrivateConstructor p) { super(p); } 

}
