package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QImageWriter extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ImageWriterError implements com.trolltech.qt.QtEnumerator {
        UnknownError(0),
        DeviceError(1),
        UnsupportedFormatError(2);

        ImageWriterError(int value) { this.value = value; }
        public int value() { return value; }

        public static ImageWriterError resolve(int value) {
            return (ImageWriterError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnknownError;
            case 1: return DeviceError;
            case 2: return UnsupportedFormatError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QImageWriter() {
        super((QPrivateConstructor)null);
        __qt_QImageWriter();
    }
    private native void __qt_QImageWriter();


    public QImageWriter(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.core.QByteArray format) {
        super((QPrivateConstructor)null);
        __qt_QImageWriter_QIODevice_QByteArray(device == null ? 0 : device.nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native void __qt_QImageWriter_QIODevice_QByteArray(long device, long format);



    public QImageWriter(java.lang.String fileName) {
        this(fileName, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }
    public QImageWriter(java.lang.String fileName, com.trolltech.qt.core.QByteArray format) {
        super((QPrivateConstructor)null);
        __qt_QImageWriter_String_QByteArray(fileName, format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native void __qt_QImageWriter_String_QByteArray(java.lang.String fileName, long format);


    @QtBlockedSlot public final boolean canWrite() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canWrite(nativeId());
    }
    private native static boolean __qt_canWrite(long __this__nativeId);

    @QtBlockedSlot public final int compression() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_compression(nativeId());
    }
    private native static int __qt_compression(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImageWriter.ImageWriterError error() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QImageWriter.ImageWriterError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_format(long __this__nativeId);

    @QtBlockedSlot public final float gamma() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_gamma(nativeId());
    }
    private native static float __qt_gamma(long __this__nativeId);

    @QtBlockedSlot public final int quality() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_quality(nativeId());
    }
    private native static int __qt_quality(long __this__nativeId);

    @QtBlockedSlot public final void setCompression(int compression) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompression_int(nativeId(), compression);
    }
    private native static void __qt_setCompression_int(long __this__nativeId, int compression);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setFileName(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileName_String(nativeId(), fileName);
    }
    private native static void __qt_setFileName_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final void setFormat(com.trolltech.qt.core.QByteArray format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_QByteArray(nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native static void __qt_setFormat_QByteArray(long __this__nativeId, long format);

    @QtBlockedSlot public final void setGamma(float gamma) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGamma_float(nativeId(), gamma);
    }
    private native static void __qt_setGamma_float(long __this__nativeId, float gamma);

    @QtBlockedSlot public final void setQuality(int quality) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setQuality_int(nativeId(), quality);
    }
    private native static void __qt_setQuality_int(long __this__nativeId, int quality);

    @QtBlockedSlot public final void setText(java.lang.String key, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String_String(nativeId(), key, text);
    }
    private native static void __qt_setText_String_String(long __this__nativeId, java.lang.String key, java.lang.String text);

    @QtBlockedSlot public final boolean supportsOption(com.trolltech.qt.gui.QImageIOHandler.ImageOption option) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsOption_ImageOption(nativeId(), option.value());
    }
    private native static boolean __qt_supportsOption_ImageOption(long __this__nativeId, int option);

    @QtBlockedSlot public final boolean write(com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_write_QImage(nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static boolean __qt_write_QImage(long __this__nativeId, long image);

    public native static java.util.List<com.trolltech.qt.core.QByteArray> supportedImageFormats();


    public static native QImageWriter fromNativePointer(QNativePointer nativePointer);

    protected QImageWriter(QPrivateConstructor p) { super(p); } 

}
