package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QInputMethodEvent extends com.trolltech.qt.core.QEvent
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum AttributeType implements com.trolltech.qt.QtEnumerator {
        TextFormat(0),
        Cursor(1),
        Language(2),
        Ruby(3);

        AttributeType(int value) { this.value = value; }
        public int value() { return value; }

        public static AttributeType resolve(int value) {
            return (AttributeType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TextFormat;
            case 1: return Cursor;
            case 2: return Language;
            case 3: return Ruby;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QInputMethodEvent(java.lang.String preeditText, java.util.List<com.trolltech.qt.gui.QInputMethodEvent_Attribute> attributes) {
        super((QPrivateConstructor)null);
        __qt_QInputMethodEvent_String_List(preeditText, attributes);
    }
    private native void __qt_QInputMethodEvent_String_List(java.lang.String preeditText, java.util.List<com.trolltech.qt.gui.QInputMethodEvent_Attribute> attributes);


    public QInputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent other) {
        super((QPrivateConstructor)null);
        __qt_QInputMethodEvent_QInputMethodEvent(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QInputMethodEvent_QInputMethodEvent(long other);


    public QInputMethodEvent() {
        super((QPrivateConstructor)null);
        __qt_QInputMethodEvent();
    }
    private native void __qt_QInputMethodEvent();


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QInputMethodEvent_Attribute> attributes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_attributes(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QInputMethodEvent_Attribute> __qt_attributes(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String commitString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_commitString(nativeId());
    }
    private native static java.lang.String __qt_commitString(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String preeditString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_preeditString(nativeId());
    }
    private native static java.lang.String __qt_preeditString(long __this__nativeId);

    @QtBlockedSlot public final int replacementLength() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_replacementLength(nativeId());
    }
    private native static int __qt_replacementLength(long __this__nativeId);

    @QtBlockedSlot public final int replacementStart() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_replacementStart(nativeId());
    }
    private native static int __qt_replacementStart(long __this__nativeId);


    @QtBlockedSlot public final void setCommitString(java.lang.String commitString, int replaceFrom) {
        setCommitString(commitString, replaceFrom, (int)0);
    }

    @QtBlockedSlot public final void setCommitString(java.lang.String commitString) {
        setCommitString(commitString, (int)0, (int)0);
    }
    @QtBlockedSlot public final void setCommitString(java.lang.String commitString, int replaceFrom, int replaceLength) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCommitString_String_int_int(nativeId(), commitString, replaceFrom, replaceLength);
    }
    private native static void __qt_setCommitString_String_int_int(long __this__nativeId, java.lang.String commitString, int replaceFrom, int replaceLength);


    public static native QInputMethodEvent fromNativePointer(QNativePointer nativePointer);

    protected QInputMethodEvent(QPrivateConstructor p) { super(p); } 

}
