package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QKeySequence extends com.trolltech.qt.QtJambiObject
    implements java.lang.Comparable
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum SequenceFormat implements com.trolltech.qt.QtEnumerator {
        NativeText(0),
        PortableText(1);

        SequenceFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static SequenceFormat resolve(int value) {
            return (SequenceFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NativeText;
            case 1: return PortableText;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StandardKey implements com.trolltech.qt.QtEnumerator {
        UnknownKey(0),
        HelpContents(1),
        WhatsThis(2),
        Open(3),
        Close(4),
        Save(5),
        New(6),
        Delete(7),
        Cut(8),
        Copy(9),
        Paste(10),
        Undo(11),
        Redo(12),
        Back(13),
        Forward(14),
        Refresh(15),
        ZoomIn(16),
        ZoomOut(17),
        Print(18),
        AddTab(19),
        NextChild(20),
        PreviousChild(21),
        Find(22),
        FindNext(23),
        FindPrevious(24),
        Replace(25),
        SelectAll(26),
        Bold(27),
        Italic(28),
        Underline(29),
        MoveToNextChar(30),
        MoveToPreviousChar(31),
        MoveToNextWord(32),
        MoveToPreviousWord(33),
        MoveToNextLine(34),
        MoveToPreviousLine(35),
        MoveToNextPage(36),
        MoveToPreviousPage(37),
        MoveToStartOfLine(38),
        MoveToEndOfLine(39),
        MoveToStartOfBlock(40),
        MoveToEndOfBlock(41),
        MoveToStartOfDocument(42),
        MoveToEndOfDocument(43),
        SelectNextChar(44),
        SelectPreviousChar(45),
        SelectNextWord(46),
        SelectPreviousWord(47),
        SelectNextLine(48),
        SelectPreviousLine(49),
        SelectNextPage(50),
        SelectPreviousPage(51),
        SelectStartOfLine(52),
        SelectEndOfLine(53),
        SelectStartOfBlock(54),
        SelectEndOfBlock(55),
        SelectStartOfDocument(56),
        SelectEndOfDocument(57),
        DeleteStartOfWord(58),
        DeleteEndOfWord(59),
        DeleteEndOfLine(60);

        StandardKey(int value) { this.value = value; }
        public int value() { return value; }

        public static StandardKey resolve(int value) {
            return (StandardKey) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnknownKey;
            case 1: return HelpContents;
            case 2: return WhatsThis;
            case 3: return Open;
            case 4: return Close;
            case 5: return Save;
            case 6: return New;
            case 7: return Delete;
            case 8: return Cut;
            case 9: return Copy;
            case 10: return Paste;
            case 11: return Undo;
            case 12: return Redo;
            case 13: return Back;
            case 14: return Forward;
            case 15: return Refresh;
            case 16: return ZoomIn;
            case 17: return ZoomOut;
            case 18: return Print;
            case 19: return AddTab;
            case 20: return NextChild;
            case 21: return PreviousChild;
            case 22: return Find;
            case 23: return FindNext;
            case 24: return FindPrevious;
            case 25: return Replace;
            case 26: return SelectAll;
            case 27: return Bold;
            case 28: return Italic;
            case 29: return Underline;
            case 30: return MoveToNextChar;
            case 31: return MoveToPreviousChar;
            case 32: return MoveToNextWord;
            case 33: return MoveToPreviousWord;
            case 34: return MoveToNextLine;
            case 35: return MoveToPreviousLine;
            case 36: return MoveToNextPage;
            case 37: return MoveToPreviousPage;
            case 38: return MoveToStartOfLine;
            case 39: return MoveToEndOfLine;
            case 40: return MoveToStartOfBlock;
            case 41: return MoveToEndOfBlock;
            case 42: return MoveToStartOfDocument;
            case 43: return MoveToEndOfDocument;
            case 44: return SelectNextChar;
            case 45: return SelectPreviousChar;
            case 46: return SelectNextWord;
            case 47: return SelectPreviousWord;
            case 48: return SelectNextLine;
            case 49: return SelectPreviousLine;
            case 50: return SelectNextPage;
            case 51: return SelectPreviousPage;
            case 52: return SelectStartOfLine;
            case 53: return SelectEndOfLine;
            case 54: return SelectStartOfBlock;
            case 55: return SelectEndOfBlock;
            case 56: return SelectStartOfDocument;
            case 57: return SelectEndOfDocument;
            case 58: return DeleteStartOfWord;
            case 59: return DeleteEndOfWord;
            case 60: return DeleteEndOfLine;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SequenceMatch implements com.trolltech.qt.QtEnumerator {
        NoMatch(0),
        PartialMatch(1),
        ExactMatch(2);

        SequenceMatch(int value) { this.value = value; }
        public int value() { return value; }

        public static SequenceMatch resolve(int value) {
            return (SequenceMatch) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoMatch;
            case 1: return PartialMatch;
            case 2: return ExactMatch;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QKeySequence(int k1, int k2, int k3) {
        this(k1, k2, k3, (int)0);
    }

    public QKeySequence(int k1, int k2) {
        this(k1, k2, (int)0, (int)0);
    }

    public QKeySequence(int k1) {
        this(k1, (int)0, (int)0, (int)0);
    }
    public QKeySequence(int k1, int k2, int k3, int k4) {
        super((QPrivateConstructor)null);
        __qt_QKeySequence_int_int_int_int(k1, k2, k3, k4);
    }
    private native void __qt_QKeySequence_int_int_int_int(int k1, int k2, int k3, int k4);


    public QKeySequence(com.trolltech.qt.gui.QKeySequence.StandardKey key) {
        super((QPrivateConstructor)null);
        __qt_QKeySequence_StandardKey(key.value());
    }
    private native void __qt_QKeySequence_StandardKey(int key);


    public QKeySequence(com.trolltech.qt.gui.QKeySequence ks) {
        super((QPrivateConstructor)null);
        __qt_QKeySequence_QKeySequence(ks == null ? (ks = new com.trolltech.qt.gui.QKeySequence()).nativeId() : ks.nativeId());
    }
    private native void __qt_QKeySequence_QKeySequence(long ks);


    public QKeySequence() {
        super((QPrivateConstructor)null);
        __qt_QKeySequence();
    }
    private native void __qt_QKeySequence();


    public QKeySequence(java.lang.String key) {
        super((QPrivateConstructor)null);
        __qt_QKeySequence_String(key);
    }
    private native void __qt_QKeySequence_String(java.lang.String key);


    @QtBlockedSlot public final int count() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @QtBlockedSlot public final boolean isEmpty() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QKeySequence.SequenceMatch matches(com.trolltech.qt.gui.QKeySequence seq) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QKeySequence.SequenceMatch.resolve(__qt_matches_QKeySequence(nativeId(), seq == null ? (seq = new com.trolltech.qt.gui.QKeySequence()).nativeId() : seq.nativeId()));
    }
    private native static int __qt_matches_QKeySequence(long __this__nativeId, long seq);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final int operator_cast_int() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_cast_int(nativeId());
    }
    private native static int __qt_operator_cast_int(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_less(com.trolltech.qt.gui.QKeySequence ks) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QKeySequence(nativeId(), ks == null ? (ks = new com.trolltech.qt.gui.QKeySequence()).nativeId() : ks.nativeId());
    }
    private native static boolean __qt_operator_less_QKeySequence(long __this__nativeId, long ks);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long in);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QKeySequence other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QKeySequence(nativeId(), other == null ? (other = new com.trolltech.qt.gui.QKeySequence()).nativeId() : other.nativeId());
    }
    private native static boolean __qt_operator_equal_QKeySequence(long __this__nativeId, long other);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long out);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final int operator_subscript(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_subscript_int(nativeId(), i);
    }
    private native static int __qt_operator_subscript_int(long __this__nativeId, int i);


    @QtBlockedSlot public final java.lang.String toString() {
        return toString(com.trolltech.qt.gui.QKeySequence.SequenceFormat.PortableText);
    }
    @QtBlockedSlot public final java.lang.String toString(com.trolltech.qt.gui.QKeySequence.SequenceFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString_SequenceFormat(nativeId(), format.value());
    }
    private native static java.lang.String __qt_toString_SequenceFormat(long __this__nativeId, int format);


    public static com.trolltech.qt.gui.QKeySequence fromString(java.lang.String str) {
        return fromString(str, com.trolltech.qt.gui.QKeySequence.SequenceFormat.PortableText);
    }
    public static com.trolltech.qt.gui.QKeySequence fromString(java.lang.String str, com.trolltech.qt.gui.QKeySequence.SequenceFormat format) {
        return __qt_fromString_String_SequenceFormat(str, format.value());
    }
    private native static com.trolltech.qt.gui.QKeySequence __qt_fromString_String_SequenceFormat(java.lang.String str, int format);

    public static java.util.List<com.trolltech.qt.gui.QKeySequence> keyBindings(com.trolltech.qt.gui.QKeySequence.StandardKey key) {
        return __qt_keyBindings_StandardKey(key.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QKeySequence> __qt_keyBindings_StandardKey(int key);

    public native static com.trolltech.qt.gui.QKeySequence mnemonic(java.lang.String text);


    public static native QKeySequence fromNativePointer(QNativePointer nativePointer);

    protected QKeySequence(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QKeySequence array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QKeySequence)
            return operator_equal((com.trolltech.qt.gui.QKeySequence) other);
        return false;
    }

    public int compareTo(Object other) {
        if (equals(other)) return 0;
        else if (other instanceof com.trolltech.qt.gui.QKeySequence && operator_less((com.trolltech.qt.gui.QKeySequence) other)) return -1;
        else return 1;
    }

    @QtBlockedSlot public final int toInt() { return operator_cast_int(); }
    @QtBlockedSlot public final int at(int i) { return operator_subscript(i); }
    
}
