package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QLCDNumber extends com.trolltech.qt.gui.QFrame
{
    public enum Mode implements com.trolltech.qt.QtEnumerator {
        Hex(0),
        Dec(1),
        Oct(2),
        Bin(3);

        Mode(int value) { this.value = value; }
        public int value() { return value; }

        public static Mode resolve(int value) {
            return (Mode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Hex;
            case 1: return Dec;
            case 2: return Oct;
            case 3: return Bin;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SegmentStyle implements com.trolltech.qt.QtEnumerator {
        Outline(0),
        Filled(1),
        Flat(2);

        SegmentStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static SegmentStyle resolve(int value) {
            return (SegmentStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Outline;
            case 1: return Filled;
            case 2: return Flat;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 overflow = new Signal0();

    @SuppressWarnings("unused")
    private final void overflow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_overflow(nativeId());
    }
    private native static void __qt_overflow(long __this__nativeId);


    public QLCDNumber() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QLCDNumber(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QLCDNumber_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QLCDNumber_QWidget(long parent);



    public QLCDNumber(int numDigits) {
        this(numDigits, (com.trolltech.qt.gui.QWidget)null);
    }
    public QLCDNumber(int numDigits, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QLCDNumber_int_QWidget(numDigits, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QLCDNumber_int_QWidget(int numDigits, long parent);


    @QtBlockedSlot public final boolean checkOverflow(double num) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_checkOverflow_double(nativeId(), num);
    }
    private native static boolean __qt_checkOverflow_double(long __this__nativeId, double num);

    @QtBlockedSlot public final boolean checkOverflow(int num) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_checkOverflow_int(nativeId(), num);
    }
    private native static boolean __qt_checkOverflow_int(long __this__nativeId, int num);

    public final void display(int num) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_display_int(nativeId(), num);
    }
    private native static void __qt_display_int(long __this__nativeId, int num);

    public final void display(java.lang.String str) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_display_String(nativeId(), str);
    }
    private native static void __qt_display_String(long __this__nativeId, java.lang.String str);

    @com.trolltech.qt.QtPropertyWriter(name="value")
    public final void display(double num) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_display_double(nativeId(), num);
    }
    private native static void __qt_display_double(long __this__nativeId, double num);

    @com.trolltech.qt.QtPropertyReader(name="intValue")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int intValue() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intValue(nativeId());
    }
    private native static int __qt_intValue(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="mode")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QLCDNumber.Mode mode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QLCDNumber.Mode.resolve(__qt_mode(nativeId()));
    }
    private native static int __qt_mode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="numDigits")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int numDigits() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numDigits(nativeId());
    }
    private native static int __qt_numDigits(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="segmentStyle")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.gui.QLCDNumber.SegmentStyle segmentStyle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QLCDNumber.SegmentStyle.resolve(__qt_segmentStyle(nativeId()));
    }
    private native static int __qt_segmentStyle(long __this__nativeId);

    public final void setBinMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBinMode(nativeId());
    }
    private native static void __qt_setBinMode(long __this__nativeId);

    public final void setDecMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDecMode(nativeId());
    }
    private native static void __qt_setDecMode(long __this__nativeId);

    public final void setHexMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHexMode(nativeId());
    }
    private native static void __qt_setHexMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="mode")
    @QtBlockedSlot public final void setMode(com.trolltech.qt.gui.QLCDNumber.Mode arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMode_Mode(nativeId(), arg__1.value());
    }
    private native static void __qt_setMode_Mode(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="numDigits")
    @QtBlockedSlot public final void setNumDigits(int nDigits) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumDigits_int(nativeId(), nDigits);
    }
    private native static void __qt_setNumDigits_int(long __this__nativeId, int nDigits);

    public final void setOctMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOctMode(nativeId());
    }
    private native static void __qt_setOctMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="segmentStyle")
    @QtBlockedSlot public final void setSegmentStyle(com.trolltech.qt.gui.QLCDNumber.SegmentStyle arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSegmentStyle_SegmentStyle(nativeId(), arg__1.value());
    }
    private native static void __qt_setSegmentStyle_SegmentStyle(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="smallDecimalPoint")
    public final void setSmallDecimalPoint(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSmallDecimalPoint_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setSmallDecimalPoint_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyReader(name="smallDecimalPoint")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean smallDecimalPoint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_smallDecimalPoint(nativeId());
    }
    private native static boolean __qt_smallDecimalPoint(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="value")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final double value() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value(nativeId());
    }
    private native static double __qt_value(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QLCDNumber fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QLCDNumber(QPrivateConstructor p) { super(p); } 

}
