package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QLineF extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum IntersectType implements com.trolltech.qt.QtEnumerator {
        NoIntersection(0),
        BoundedIntersection(1),
        UnboundedIntersection(2);

        IntersectType(int value) { this.value = value; }
        public int value() { return value; }

        public static IntersectType resolve(int value) {
            return (IntersectType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoIntersection;
            case 1: return BoundedIntersection;
            case 2: return UnboundedIntersection;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QLineF(double x1, double y1, double x2, double y2) {
        super((QPrivateConstructor)null);
        __qt_QLineF_double_double_double_double(x1, y1, x2, y2);
    }
    private native void __qt_QLineF_double_double_double_double(double x1, double y1, double x2, double y2);


    public QLineF(com.trolltech.qt.core.QPointF pt1, com.trolltech.qt.core.QPointF pt2) {
        super((QPrivateConstructor)null);
        __qt_QLineF_QPointF_QPointF(pt1 == null ? (pt1 = new com.trolltech.qt.core.QPointF()).nativeId() : pt1.nativeId(), pt2 == null ? (pt2 = new com.trolltech.qt.core.QPointF()).nativeId() : pt2.nativeId());
    }
    private native void __qt_QLineF_QPointF_QPointF(long pt1, long pt2);


    public QLineF(com.trolltech.qt.gui.QLine line) {
        super((QPrivateConstructor)null);
        __qt_QLineF_QLine(line == null ? (line = new com.trolltech.qt.gui.QLine()).nativeId() : line.nativeId());
    }
    private native void __qt_QLineF_QLine(long line);


    public QLineF() {
        super((QPrivateConstructor)null);
        __qt_QLineF();
    }
    private native void __qt_QLineF();


    @QtBlockedSlot public final double angle(com.trolltech.qt.gui.QLineF l) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_angle_QLineF(nativeId(), l == null ? (l = new com.trolltech.qt.gui.QLineF()).nativeId() : l.nativeId());
    }
    private native static double __qt_angle_QLineF(long __this__nativeId, long l);

    @QtBlockedSlot public final double dx() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dx(nativeId());
    }
    private native static double __qt_dx(long __this__nativeId);

    @QtBlockedSlot public final double dy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dy(nativeId());
    }
    private native static double __qt_dy(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.gui.QLineF.IntersectType intersect(com.trolltech.qt.gui.QLineF l, com.trolltech.qt.QNativePointer intersectionPoint) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QLineF.IntersectType.resolve(__qt_intersect_QLineF_nativepointer(nativeId(), l == null ? (l = new com.trolltech.qt.gui.QLineF()).nativeId() : l.nativeId(), intersectionPoint));
    }
    private native static int __qt_intersect_QLineF_nativepointer(long __this__nativeId, long l, com.trolltech.qt.QNativePointer intersectionPoint);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final double length() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_length(nativeId());
    }
    private native static double __qt_length(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLineF normalVector() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_normalVector(nativeId());
    }
    private native static com.trolltech.qt.gui.QLineF __qt_normalVector(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QLineF d) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QLineF(nativeId(), d == null ? (d = new com.trolltech.qt.gui.QLineF()).nativeId() : d.nativeId());
    }
    private native static boolean __qt_operator_equal_QLineF(long __this__nativeId, long d);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF p1() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_p1(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_p1(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF p2() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_p2(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_p2(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF pointAt(double t) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pointAt_double(nativeId(), t);
    }
    private native static com.trolltech.qt.core.QPointF __qt_pointAt_double(long __this__nativeId, double t);

    @QtBlockedSlot public final void setLength(double len) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLength_double(nativeId(), len);
    }
    private native static void __qt_setLength_double(long __this__nativeId, double len);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLine toLine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toLine(nativeId());
    }
    private native static com.trolltech.qt.gui.QLine __qt_toLine(long __this__nativeId);

    @QtBlockedSlot public final void translate(com.trolltech.qt.core.QPointF p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_QPointF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId());
    }
    private native static void __qt_translate_QPointF(long __this__nativeId, long p);

    @QtBlockedSlot public final void translate(double dx, double dy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_double_double(nativeId(), dx, dy);
    }
    private native static void __qt_translate_double_double(long __this__nativeId, double dx, double dy);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLineF unitVector() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_unitVector(nativeId());
    }
    private native static com.trolltech.qt.gui.QLineF __qt_unitVector(long __this__nativeId);

    @QtBlockedSlot public final double x1() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x1(nativeId());
    }
    private native static double __qt_x1(long __this__nativeId);

    @QtBlockedSlot public final double x2() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x2(nativeId());
    }
    private native static double __qt_x2(long __this__nativeId);

    @QtBlockedSlot public final double y1() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y1(nativeId());
    }
    private native static double __qt_y1(long __this__nativeId);

    @QtBlockedSlot public final double y2() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y2(nativeId());
    }
    private native static double __qt_y2(long __this__nativeId);


    public static native QLineF fromNativePointer(QNativePointer nativePointer);

    protected QLineF(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QLineF array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QLineF)
            return operator_equal((com.trolltech.qt.gui.QLineF) other);
        return false;
    }


        public final QLineF.IntersectType intersect(QLineF line, com.trolltech.qt.core.QPointF intersectionPoint) {
            return intersect(line, intersectionPoint != null ? intersectionPoint.nativePointer() : null);
        }
    
}
