package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QListView extends com.trolltech.qt.gui.QAbstractItemView
{
    public enum ResizeMode implements com.trolltech.qt.QtEnumerator {
        Fixed(0),
        Adjust(1);

        ResizeMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ResizeMode resolve(int value) {
            return (ResizeMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Fixed;
            case 1: return Adjust;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum LayoutMode implements com.trolltech.qt.QtEnumerator {
        SinglePass(0),
        Batched(1);

        LayoutMode(int value) { this.value = value; }
        public int value() { return value; }

        public static LayoutMode resolve(int value) {
            return (LayoutMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SinglePass;
            case 1: return Batched;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ViewMode implements com.trolltech.qt.QtEnumerator {
        ListMode(0),
        IconMode(1);

        ViewMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ViewMode resolve(int value) {
            return (ViewMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ListMode;
            case 1: return IconMode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Flow implements com.trolltech.qt.QtEnumerator {
        LeftToRight(0),
        TopToBottom(1);

        Flow(int value) { this.value = value; }
        public int value() { return value; }

        public static Flow resolve(int value) {
            return (Flow) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LeftToRight;
            case 1: return TopToBottom;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Movement implements com.trolltech.qt.QtEnumerator {
        Static(0),
        Free(1),
        Snap(2);

        Movement(int value) { this.value = value; }
        public int value() { return value; }

        public static Movement resolve(int value) {
            return (Movement) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Static;
            case 1: return Free;
            case 2: return Snap;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.util.List<com.trolltech.qt.core.QModelIndex>> indexesMoved = new Signal1<java.util.List<com.trolltech.qt.core.QModelIndex>>();

    @SuppressWarnings("unused")
    private final void indexesMoved(java.util.List<com.trolltech.qt.core.QModelIndex> indexes) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_indexesMoved_List(nativeId(), indexes);
    }
    private native static void __qt_indexesMoved_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QModelIndex> indexes);


    public QListView() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QListView(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QListView_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QListView_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="batchSize")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final int batchSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_batchSize(nativeId());
    }
    private native static int __qt_batchSize(long __this__nativeId);

    @QtBlockedSlot public final void clearPropertyFlags() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearPropertyFlags(nativeId());
    }
    private native static void __qt_clearPropertyFlags(long __this__nativeId);

    @QtBlockedSlot protected final com.trolltech.qt.core.QSize contentsSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contentsSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_contentsSize(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="flow")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QListView.Flow flow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QListView.Flow.resolve(__qt_flow(nativeId()));
    }
    private native static int __qt_flow(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="gridSize")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize gridSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_gridSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_gridSize(long __this__nativeId);


    @QtBlockedSlot protected final void internalDrag(com.trolltech.qt.core.Qt.DropAction ... supportedActions) {
        this.internalDrag(new com.trolltech.qt.core.Qt.DropActions(supportedActions));
    }
    @QtBlockedSlot protected final void internalDrag(com.trolltech.qt.core.Qt.DropActions supportedActions) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_internalDrag_DropActions(nativeId(), supportedActions.value());
    }
    private native static void __qt_internalDrag_DropActions(long __this__nativeId, int supportedActions);

    @QtBlockedSlot protected final void internalDrop(com.trolltech.qt.gui.QDropEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_internalDrop_QDropEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_internalDrop_QDropEvent(long __this__nativeId, long e);

    @QtBlockedSlot public final boolean isRowHidden(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRowHidden_int(nativeId(), row);
    }
    private native static boolean __qt_isRowHidden_int(long __this__nativeId, int row);

    @com.trolltech.qt.QtPropertyReader(name="selectionRectVisible")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final boolean isSelectionRectVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelectionRectVisible(nativeId());
    }
    private native static boolean __qt_isSelectionRectVisible(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="isWrapping")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean isWrapping() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWrapping(nativeId());
    }
    private native static boolean __qt_isWrapping(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="layoutMode")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.gui.QListView.LayoutMode layoutMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QListView.LayoutMode.resolve(__qt_layoutMode(nativeId()));
    }
    private native static int __qt_layoutMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="modelColumn")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final int modelColumn() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_modelColumn(nativeId());
    }
    private native static int __qt_modelColumn(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="movement")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QListView.Movement movement() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QListView.Movement.resolve(__qt_movement(nativeId()));
    }
    private native static int __qt_movement(long __this__nativeId);

    @QtBlockedSlot protected final com.trolltech.qt.core.QRect rectForIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rectForIndex_QModelIndex(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QRect __qt_rectForIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected final void resizeContents(int width, int height) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeContents_int_int(nativeId(), width, height);
    }
    private native static void __qt_resizeContents_int_int(long __this__nativeId, int width, int height);

    @com.trolltech.qt.QtPropertyReader(name="resizeMode")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.gui.QListView.ResizeMode resizeMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QListView.ResizeMode.resolve(__qt_resizeMode(nativeId()));
    }
    private native static int __qt_resizeMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="batchSize")
    @QtBlockedSlot public final void setBatchSize(int batchSize) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBatchSize_int(nativeId(), batchSize);
    }
    private native static void __qt_setBatchSize_int(long __this__nativeId, int batchSize);

    @com.trolltech.qt.QtPropertyWriter(name="flow")
    @QtBlockedSlot public final void setFlow(com.trolltech.qt.gui.QListView.Flow flow) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFlow_Flow(nativeId(), flow.value());
    }
    private native static void __qt_setFlow_Flow(long __this__nativeId, int flow);

    @com.trolltech.qt.QtPropertyWriter(name="gridSize")
    @QtBlockedSlot public final void setGridSize(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGridSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setGridSize_QSize(long __this__nativeId, long size);

    @com.trolltech.qt.QtPropertyWriter(name="layoutMode")
    @QtBlockedSlot public final void setLayoutMode(com.trolltech.qt.gui.QListView.LayoutMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLayoutMode_LayoutMode(nativeId(), mode.value());
    }
    private native static void __qt_setLayoutMode_LayoutMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="modelColumn")
    @QtBlockedSlot public final void setModelColumn(int column) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModelColumn_int(nativeId(), column);
    }
    private native static void __qt_setModelColumn_int(long __this__nativeId, int column);

    @com.trolltech.qt.QtPropertyWriter(name="movement")
    @QtBlockedSlot public final void setMovement(com.trolltech.qt.gui.QListView.Movement movement) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMovement_Movement(nativeId(), movement.value());
    }
    private native static void __qt_setMovement_Movement(long __this__nativeId, int movement);

    @QtBlockedSlot protected final void setPositionForIndex(com.trolltech.qt.core.QPoint position, com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPositionForIndex_QPoint_QModelIndex(nativeId(), position == null ? (position = new com.trolltech.qt.core.QPoint()).nativeId() : position.nativeId(), index);
    }
    private native static void __qt_setPositionForIndex_QPoint_QModelIndex(long __this__nativeId, long position, com.trolltech.qt.core.QModelIndex index);

    @com.trolltech.qt.QtPropertyWriter(name="resizeMode")
    @QtBlockedSlot public final void setResizeMode(com.trolltech.qt.gui.QListView.ResizeMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResizeMode_ResizeMode(nativeId(), mode.value());
    }
    private native static void __qt_setResizeMode_ResizeMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setRowHidden(int row, boolean hide) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRowHidden_int_boolean(nativeId(), row, hide);
    }
    private native static void __qt_setRowHidden_int_boolean(long __this__nativeId, int row, boolean hide);

    @com.trolltech.qt.QtPropertyWriter(name="selectionRectVisible")
    @QtBlockedSlot public final void setSelectionRectVisible(boolean show) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectionRectVisible_boolean(nativeId(), show);
    }
    private native static void __qt_setSelectionRectVisible_boolean(long __this__nativeId, boolean show);

    @com.trolltech.qt.QtPropertyWriter(name="spacing")
    @QtBlockedSlot public final void setSpacing(int space) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSpacing_int(nativeId(), space);
    }
    private native static void __qt_setSpacing_int(long __this__nativeId, int space);

    @com.trolltech.qt.QtPropertyWriter(name="uniformItemSizes")
    @QtBlockedSlot public final void setUniformItemSizes(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUniformItemSizes_boolean(nativeId(), enable);
    }
    private native static void __qt_setUniformItemSizes_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="viewMode")
    @QtBlockedSlot public final void setViewMode(com.trolltech.qt.gui.QListView.ViewMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewMode_ViewMode(nativeId(), mode.value());
    }
    private native static void __qt_setViewMode_ViewMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="wordWrap")
    @QtBlockedSlot public final void setWordWrap(boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWordWrap_boolean(nativeId(), on);
    }
    private native static void __qt_setWordWrap_boolean(long __this__nativeId, boolean on);

    @com.trolltech.qt.QtPropertyWriter(name="isWrapping")
    @QtBlockedSlot public final void setWrapping(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWrapping_boolean(nativeId(), enable);
    }
    private native static void __qt_setWrapping_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyReader(name="spacing")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int spacing() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_spacing(nativeId());
    }
    private native static int __qt_spacing(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="uniformItemSizes")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final boolean uniformItemSizes() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_uniformItemSizes(nativeId());
    }
    private native static boolean __qt_uniformItemSizes(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="viewMode")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.gui.QListView.ViewMode viewMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QListView.ViewMode.resolve(__qt_viewMode(nativeId()));
    }
    private native static int __qt_viewMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="wordWrap")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final boolean wordWrap() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_wordWrap(nativeId());
    }
    private native static boolean __qt_wordWrap(long __this__nativeId);

    @QtBlockedSlot protected void currentChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_QModelIndex_QModelIndex(nativeId(), current, previous);
    }
    private native static void __qt_currentChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous);

    @QtBlockedSlot protected void dataChanged(com.trolltech.qt.core.QModelIndex topLeft, com.trolltech.qt.core.QModelIndex bottomRight) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataChanged_QModelIndex_QModelIndex(nativeId(), topLeft, bottomRight);
    }
    private native static void __qt_dataChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex topLeft, com.trolltech.qt.core.QModelIndex bottomRight);

    @QtBlockedSlot public void doItemsLayout() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_doItemsLayout(nativeId());
    }
    private native static void __qt_doItemsLayout(long __this__nativeId);

    @QtBlockedSlot protected void dragLeaveEvent(com.trolltech.qt.gui.QDragLeaveEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragLeaveEvent_QDragLeaveEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dragLeaveEvent_QDragLeaveEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void dragMoveEvent(com.trolltech.qt.gui.QDragMoveEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragMoveEvent_QDragMoveEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dragMoveEvent_QDragMoveEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void dropEvent(com.trolltech.qt.gui.QDropEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dropEvent_QDropEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dropEvent_QDropEvent(long __this__nativeId, long e);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected int horizontalOffset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_horizontalOffset(nativeId());
    }
    private native static int __qt_horizontalOffset(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QModelIndex indexAt(com.trolltech.qt.core.QPoint p) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexAt_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_indexAt_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot protected boolean isIndexHidden(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isIndexHidden_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_isIndexHidden_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected com.trolltech.qt.core.QModelIndex moveCursor(com.trolltech.qt.gui.QAbstractItemView.CursorAction cursorAction, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_moveCursor_CursorAction_KeyboardModifiers(nativeId(), cursorAction.value(), modifiers.value());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_moveCursor_CursorAction_KeyboardModifiers(long __this__nativeId, int cursorAction, int modifiers);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long e);

    @QtBlockedSlot public void reset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void rowsAboutToBeRemoved(com.trolltech.qt.core.QModelIndex parent, int start, int end) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rowsAboutToBeRemoved_QModelIndex_int_int(nativeId(), parent, start, end);
    }
    private native static void __qt_rowsAboutToBeRemoved_QModelIndex_int_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, int start, int end);

    @QtBlockedSlot protected void rowsInserted(com.trolltech.qt.core.QModelIndex parent, int start, int end) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rowsInserted_QModelIndex_int_int(nativeId(), parent, start, end);
    }
    private native static void __qt_rowsInserted_QModelIndex_int_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent, int start, int end);

    @QtBlockedSlot protected void scrollContentsBy(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollContentsBy_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scrollContentsBy_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot public void scrollTo(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QAbstractItemView.ScrollHint hint) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollTo_QModelIndex_ScrollHint(nativeId(), index, hint.value());
    }
    private native static void __qt_scrollTo_QModelIndex_ScrollHint(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, int hint);

    @QtBlockedSlot protected java.util.List<com.trolltech.qt.core.QModelIndex> selectedIndexes() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedIndexes(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.core.QModelIndex> __qt_selectedIndexes(long __this__nativeId);

    @QtBlockedSlot protected void selectionChanged(com.trolltech.qt.gui.QItemSelection selected, com.trolltech.qt.gui.QItemSelection deselected) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged_QItemSelection_QItemSelection(nativeId(), selected == null ? (selected = new com.trolltech.qt.gui.QItemSelection()).nativeId() : selected.nativeId(), deselected == null ? (deselected = new com.trolltech.qt.gui.QItemSelection()).nativeId() : deselected.nativeId());
    }
    private native static void __qt_selectionChanged_QItemSelection_QItemSelection(long __this__nativeId, long selected, long deselected);

    @QtBlockedSlot public void setRootIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRootIndex_QModelIndex(nativeId(), index);
    }
    private native static void __qt_setRootIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected void setSelection(com.trolltech.qt.core.QRect rect, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags command) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelection_QRect_SelectionFlags(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), command.value());
    }
    private native static void __qt_setSelection_QRect_SelectionFlags(long __this__nativeId, long rect, int command);

    @QtBlockedSlot protected void startDrag(com.trolltech.qt.core.Qt.DropActions supportedActions) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_startDrag_DropActions(nativeId(), supportedActions.value());
    }
    private native static void __qt_startDrag_DropActions(long __this__nativeId, int supportedActions);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void updateGeometries() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateGeometries(nativeId());
    }
    private native static void __qt_updateGeometries(long __this__nativeId);

    @QtBlockedSlot protected int verticalOffset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_verticalOffset(nativeId());
    }
    private native static int __qt_verticalOffset(long __this__nativeId);

    @QtBlockedSlot protected com.trolltech.qt.gui.QStyleOptionViewItem viewOptions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewOptions(nativeId());
    }
    private native static com.trolltech.qt.gui.QStyleOptionViewItem __qt_viewOptions(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QRect visualRect(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualRect_QModelIndex(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QRect __qt_visualRect_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot protected com.trolltech.qt.gui.QRegion visualRegionForSelection(com.trolltech.qt.gui.QItemSelection selection) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visualRegionForSelection_QItemSelection(nativeId(), selection == null ? (selection = new com.trolltech.qt.gui.QItemSelection()).nativeId() : selection.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_visualRegionForSelection_QItemSelection(long __this__nativeId, long selection);


    public static native QListView fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QListView(QPrivateConstructor p) { super(p); } 

}
