package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QListWidgetItem extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ItemType implements com.trolltech.qt.QtEnumerator {
        Type(0),
        UserType(1000);

        ItemType(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemType resolve(int value) {
            return (ItemType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Type;
            case 1000: return UserType;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QListWidgetItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text, com.trolltech.qt.gui.QListWidget view) {
        this(icon, text, view, (int)0);
    }

    public QListWidgetItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        this(icon, text, (com.trolltech.qt.gui.QListWidget)null, (int)0);
    }
    public QListWidgetItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text, com.trolltech.qt.gui.QListWidget view, int type) {
        super((QPrivateConstructor)null);
        __qt_QListWidgetItem_QIcon_String_QListWidget_int(icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text, view == null ? 0 : view.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QListWidgetItem_QIcon_String_QListWidget_int(long icon, java.lang.String text, long view, int type);



    public QListWidgetItem(com.trolltech.qt.gui.QListWidget view) {
        this(view, (int)0);
    }

    public QListWidgetItem() {
        this((com.trolltech.qt.gui.QListWidget)null, (int)0);
    }
    public QListWidgetItem(com.trolltech.qt.gui.QListWidget view, int type) {
        super((QPrivateConstructor)null);
        __qt_QListWidgetItem_QListWidget_int(view == null ? 0 : view.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QListWidgetItem_QListWidget_int(long view, int type);


    public QListWidgetItem(com.trolltech.qt.gui.QListWidgetItem other) {
        super((QPrivateConstructor)null);
        __qt_QListWidgetItem_QListWidgetItem(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QListWidgetItem_QListWidgetItem(long other);



    public QListWidgetItem(java.lang.String text, com.trolltech.qt.gui.QListWidget view) {
        this(text, view, (int)0);
    }

    public QListWidgetItem(java.lang.String text) {
        this(text, (com.trolltech.qt.gui.QListWidget)null, (int)0);
    }
    public QListWidgetItem(java.lang.String text, com.trolltech.qt.gui.QListWidget view, int type) {
        super((QPrivateConstructor)null);
        __qt_QListWidgetItem_String_QListWidget_int(text, view == null ? 0 : view.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QListWidgetItem_String_QListWidget_int(java.lang.String text, long view, int type);


    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.CheckState checkState() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.CheckState.resolve(__qt_checkState(nativeId()));
    }
    private native static int __qt_checkState(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ItemFlags flags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.ItemFlags(__qt_flags(nativeId()));
    }
    private native static int __qt_flags(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foreground() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foreground(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foreground(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final boolean isHidden() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isHidden(nativeId());
    }
    private native static boolean __qt_isHidden(long __this__nativeId);

    @QtBlockedSlot public final boolean isSelected() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelected(nativeId());
    }
    private native static boolean __qt_isSelected(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QListWidget listWidget() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_listWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QListWidget __qt_listWidget(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long out);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setCheckState(com.trolltech.qt.core.Qt.CheckState state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCheckState_CheckState(nativeId(), state.value());
    }
    private native static void __qt_setCheckState_CheckState(long __this__nativeId, int state);


    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlag ... flags) {
        this.setFlags(new com.trolltech.qt.core.Qt.ItemFlags(flags));
    }
    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFlags_ItemFlags(nativeId(), flags.value());
    }
    private native static void __qt_setFlags_ItemFlags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final void setForeground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForeground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForeground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setHidden(boolean hide) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHidden_boolean(nativeId(), hide);
    }
    private native static void __qt_setHidden_boolean(long __this__nativeId, boolean hide);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final void setSelected(boolean select) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelected_boolean(nativeId(), select);
    }
    private native static void __qt_setSelected_boolean(long __this__nativeId, boolean select);

    @QtBlockedSlot public final void setSizeHint(com.trolltech.qt.core.QSize size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeHint_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setSizeHint_QSize(long __this__nativeId, long size);

    @QtBlockedSlot public final void setStatusTip(java.lang.String statusTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusTip_String(nativeId(), statusTip);
    }
    private native static void __qt_setStatusTip_String(long __this__nativeId, java.lang.String statusTip);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final void setTextAlignment(int alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_int(nativeId(), alignment);
    }
    private native static void __qt_setTextAlignment_int(long __this__nativeId, int alignment);

    @QtBlockedSlot public final void setToolTip(java.lang.String toolTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_String(nativeId(), toolTip);
    }
    private native static void __qt_setToolTip_String(long __this__nativeId, java.lang.String toolTip);

    @QtBlockedSlot public final void setWhatsThis(java.lang.String whatsThis) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWhatsThis_String(nativeId(), whatsThis);
    }
    private native static void __qt_setWhatsThis_String(long __this__nativeId, java.lang.String whatsThis);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize sizeHint() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String statusTip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusTip(nativeId());
    }
    private native static java.lang.String __qt_statusTip(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final int textAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textAlignment(nativeId());
    }
    private native static int __qt_textAlignment(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String toolTip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip(nativeId());
    }
    private native static java.lang.String __qt_toolTip(long __this__nativeId);

    @QtBlockedSlot public final int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String whatsThis() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_whatsThis(nativeId());
    }
    private native static java.lang.String __qt_whatsThis(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.gui.QListWidgetItem clone() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clone(nativeId());
    }
    private native static com.trolltech.qt.gui.QListWidgetItem __qt_clone(long __this__nativeId);

    @QtBlockedSlot public java.lang.Object data(int role) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data_int(nativeId(), role);
    }
    private native static java.lang.Object __qt_data_int(long __this__nativeId, int role);

    @SuppressWarnings("unused")
    @QtBlockedSlot private boolean operator_less(com.trolltech.qt.gui.QListWidgetItem other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QListWidgetItem(nativeId(), other == null ? 0 : other.nativeId());
    }
    private native static boolean __qt_operator_less_QListWidgetItem(long __this__nativeId, long other);

    @QtBlockedSlot public void read(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_read_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_read_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public void setData(int role, java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData_int_Object(nativeId(), role, value);
    }
    private native static void __qt_setData_int_Object(long __this__nativeId, int role, java.lang.Object value);

    @QtBlockedSlot public void write(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_write_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_write_QDataStream(long __this__nativeId, long out);


    public static native QListWidgetItem fromNativePointer(QNativePointer nativePointer);

    protected QListWidgetItem(QPrivateConstructor p) { super(p); } 

}
