package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMdiSubWindow extends com.trolltech.qt.gui.QWidget
{
    public enum SubWindowOption implements com.trolltech.qt.QtEnumerator {
        AllowOutsideAreaHorizontally(1),
        AllowOutsideAreaVertically(2),
        RubberBandResize(4),
        RubberBandMove(8);

        SubWindowOption(int value) { this.value = value; }
        public int value() { return value; }

        public static SubWindowOptions createQFlags(SubWindowOption ... values) {
            return new SubWindowOptions(values);
        }
        public static SubWindowOption resolve(int value) {
            return (SubWindowOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return AllowOutsideAreaHorizontally;
            case 2: return AllowOutsideAreaVertically;
            case 4: return RubberBandResize;
            case 8: return RubberBandMove;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class SubWindowOptions extends com.trolltech.qt.QFlags<SubWindowOption> {
        private static final long serialVersionUID = 1L;
        public SubWindowOptions(SubWindowOption ... args) { super(args); }
        public SubWindowOptions(int value) { setValue(value); }
    }


    public final Signal0 aboutToActivate = new Signal0();

    @SuppressWarnings("unused")
    private final void aboutToActivate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_aboutToActivate(nativeId());
    }
    private native static void __qt_aboutToActivate(long __this__nativeId);

    public final Signal2<com.trolltech.qt.core.Qt.WindowStates, com.trolltech.qt.core.Qt.WindowStates> windowStateChanged = new Signal2<com.trolltech.qt.core.Qt.WindowStates, com.trolltech.qt.core.Qt.WindowStates>();

    @SuppressWarnings("unused")
    private final void windowStateChanged(com.trolltech.qt.core.Qt.WindowStates oldState, com.trolltech.qt.core.Qt.WindowStates newState) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_windowStateChanged_WindowStates_WindowStates(nativeId(), oldState.value(), newState.value());
    }
    private native static void __qt_windowStateChanged_WindowStates_WindowStates(long __this__nativeId, int oldState, int newState);


    public QMdiSubWindow(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QMdiSubWindow() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QMdiSubWindow(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QMdiSubWindow_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), flags.value());
    }
    private native void __qt_QMdiSubWindow_QWidget_WindowFlags(long parent, int flags);


    @QtBlockedSlot public final boolean isShaded() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isShaded(nativeId());
    }
    private native static boolean __qt_isShaded(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="keyboardPageStep")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int keyboardPageStep() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_keyboardPageStep(nativeId());
    }
    private native static int __qt_keyboardPageStep(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="keyboardSingleStep")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final int keyboardSingleStep() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_keyboardSingleStep(nativeId());
    }
    private native static int __qt_keyboardSingleStep(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget maximizedButtonsWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximizedButtonsWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_maximizedButtonsWidget(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget maximizedSystemMenuIconWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximizedSystemMenuIconWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_maximizedSystemMenuIconWidget(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="keyboardPageStep")
    @QtBlockedSlot public final void setKeyboardPageStep(int step) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setKeyboardPageStep_int(nativeId(), step);
    }
    private native static void __qt_setKeyboardPageStep_int(long __this__nativeId, int step);

    @com.trolltech.qt.QtPropertyWriter(name="keyboardSingleStep")
    @QtBlockedSlot public final void setKeyboardSingleStep(int step) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setKeyboardSingleStep_int(nativeId(), step);
    }
    private native static void __qt_setKeyboardSingleStep_int(long __this__nativeId, int step);


    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QMdiSubWindow.SubWindowOption option) {
        setOption(option, (boolean)true);
    }
    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QMdiSubWindow.SubWindowOption option, boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOption_SubWindowOption_boolean(nativeId(), option.value(), on);
    }
    private native static void __qt_setOption_SubWindowOption_boolean(long __this__nativeId, int option, boolean on);

    @QtBlockedSlot public final void setSystemMenu(com.trolltech.qt.gui.QMenu systemMenu) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSystemMenu_QMenu(nativeId(), systemMenu == null ? 0 : systemMenu.nativeId());
    }
    private native static void __qt_setSystemMenu_QMenu(long __this__nativeId, long systemMenu);

    @QtBlockedSlot public final void setWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setWidget_QWidget(long __this__nativeId, long widget);

    public final void showShaded() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showShaded(nativeId());
    }
    private native static void __qt_showShaded(long __this__nativeId);

    public final void showSystemMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showSystemMenu(nativeId());
    }
    private native static void __qt_showSystemMenu(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMenu systemMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_systemMenu(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenu __qt_systemMenu(long __this__nativeId);

    @QtBlockedSlot public final boolean testOption(com.trolltech.qt.gui.QMdiSubWindow.SubWindowOption arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testOption_SubWindowOption(nativeId(), arg__1.value());
    }
    private native static boolean __qt_testOption_SubWindowOption(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget widget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_widget(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent changeEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), changeEvent == null ? 0 : changeEvent.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long changeEvent);

    @QtBlockedSlot protected void childEvent(com.trolltech.qt.core.QChildEvent childEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_childEvent_QChildEvent(nativeId(), childEvent == null ? 0 : childEvent.nativeId());
    }
    private native static void __qt_childEvent_QChildEvent(long __this__nativeId, long childEvent);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent closeEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), closeEvent == null ? 0 : closeEvent.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long closeEvent);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent contextMenuEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), contextMenuEvent == null ? 0 : contextMenuEvent.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long contextMenuEvent);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean eventFilter(com.trolltech.qt.core.QObject object, com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_eventFilter_QObject_QEvent(nativeId(), object == null ? 0 : object.nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_eventFilter_QObject_QEvent(long __this__nativeId, long object, long event);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent focusInEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), focusInEvent == null ? 0 : focusInEvent.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long focusInEvent);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent focusOutEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), focusOutEvent == null ? 0 : focusOutEvent.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long focusOutEvent);

    @QtBlockedSlot protected void hideEvent(com.trolltech.qt.gui.QHideEvent hideEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideEvent_QHideEvent(nativeId(), hideEvent == null ? 0 : hideEvent.nativeId());
    }
    private native static void __qt_hideEvent_QHideEvent(long __this__nativeId, long hideEvent);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent keyEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), keyEvent == null ? 0 : keyEvent.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long keyEvent);

    @QtBlockedSlot protected void leaveEvent(com.trolltech.qt.core.QEvent leaveEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_leaveEvent_QEvent(nativeId(), leaveEvent == null ? 0 : leaveEvent.nativeId());
    }
    private native static void __qt_leaveEvent_QEvent(long __this__nativeId, long leaveEvent);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QMouseEvent mouseEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QMouseEvent(nativeId(), mouseEvent == null ? 0 : mouseEvent.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QMouseEvent(long __this__nativeId, long mouseEvent);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent mouseEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), mouseEvent == null ? 0 : mouseEvent.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long mouseEvent);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent mouseEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), mouseEvent == null ? 0 : mouseEvent.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long mouseEvent);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent mouseEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), mouseEvent == null ? 0 : mouseEvent.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long mouseEvent);

    @QtBlockedSlot protected void moveEvent(com.trolltech.qt.gui.QMoveEvent moveEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveEvent_QMoveEvent(nativeId(), moveEvent == null ? 0 : moveEvent.nativeId());
    }
    private native static void __qt_moveEvent_QMoveEvent(long __this__nativeId, long moveEvent);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent paintEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), paintEvent == null ? 0 : paintEvent.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long paintEvent);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent resizeEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), resizeEvent == null ? 0 : resizeEvent.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long resizeEvent);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent showEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), showEvent == null ? 0 : showEvent.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long showEvent);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent timerEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), timerEvent == null ? 0 : timerEvent.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long timerEvent);


    public static native QMdiSubWindow fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QMdiSubWindow(QPrivateConstructor p) { super(p); } 

}
