package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QPaintDevice extends com.trolltech.qt.QtJambiObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.gui.QPaintDevice {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
        }
    }

    public enum PaintDeviceMetric implements com.trolltech.qt.QtEnumerator {
        PdmWidth(1),
        PdmHeight(2),
        PdmWidthMM(3),
        PdmHeightMM(4),
        PdmNumColors(5),
        PdmDepth(6),
        PdmDpiX(7),
        PdmDpiY(8),
        PdmPhysicalDpiX(9),
        PdmPhysicalDpiY(10);

        PaintDeviceMetric(int value) { this.value = value; }
        public int value() { return value; }

        public static PaintDeviceMetric resolve(int value) {
            return (PaintDeviceMetric) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return PdmWidth;
            case 2: return PdmHeight;
            case 3: return PdmWidthMM;
            case 4: return PdmHeightMM;
            case 5: return PdmNumColors;
            case 6: return PdmDepth;
            case 7: return PdmDpiX;
            case 8: return PdmDpiY;
            case 9: return PdmPhysicalDpiX;
            case 10: return PdmPhysicalDpiY;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QPaintDevice() {
        super((QPrivateConstructor)null);
        __qt_QPaintDevice();
    }
    private native void __qt_QPaintDevice();


    @QtBlockedSlot public final int depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final int height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);

    @QtBlockedSlot public final boolean paintingActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final int width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public int devType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric metric) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), metric.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int metric);

    @QtBlockedSlot public abstract com.trolltech.qt.gui.QPaintEngine paintEngine();
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    @QtBlockedSlot protected final void setPainters(char painters) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPainters_char(nativeId(), painters);
    }
    private native static void __qt_setPainters_char(long __this__nativeId, char painters);

    @QtBlockedSlot protected final char painters() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_painters(nativeId());
    }
    private native static char __qt_painters(long __this__nativeId);


    public static native QPaintDevice fromNativePointer(QNativePointer nativePointer);

    protected QPaintDevice(QPrivateConstructor p) { super(p); } 


    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);
}
