package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QPainterPath extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ElementType implements com.trolltech.qt.QtEnumerator {
        MoveToElement(0),
        LineToElement(1),
        CurveToElement(2),
        CurveToDataElement(3);

        ElementType(int value) { this.value = value; }
        public int value() { return value; }

        public static ElementType resolve(int value) {
            return (ElementType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MoveToElement;
            case 1: return LineToElement;
            case 2: return CurveToElement;
            case 3: return CurveToDataElement;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QPainterPath(com.trolltech.qt.gui.QPainterPath other) {
        super((QPrivateConstructor)null);
        __qt_QPainterPath_QPainterPath(other == null ? (other = new com.trolltech.qt.gui.QPainterPath()).nativeId() : other.nativeId());
    }
    private native void __qt_QPainterPath_QPainterPath(long other);


    public QPainterPath(com.trolltech.qt.core.QPointF startPoint) {
        super((QPrivateConstructor)null);
        __qt_QPainterPath_QPointF(startPoint == null ? (startPoint = new com.trolltech.qt.core.QPointF()).nativeId() : startPoint.nativeId());
    }
    private native void __qt_QPainterPath_QPointF(long startPoint);


    public QPainterPath() {
        super((QPrivateConstructor)null);
        __qt_QPainterPath();
    }
    private native void __qt_QPainterPath();


    @QtBlockedSlot public final void addEllipse(com.trolltech.qt.core.QRectF rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addEllipse_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_addEllipse_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final void addEllipse(double x, double y, double w, double h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addEllipse_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static void __qt_addEllipse_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);

    @QtBlockedSlot public final void addPath(com.trolltech.qt.gui.QPainterPath path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addPath_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static void __qt_addPath_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final void addPolygon(com.trolltech.qt.gui.QPolygonF polygon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addPolygon_QPolygonF(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId());
    }
    private native static void __qt_addPolygon_QPolygonF(long __this__nativeId, long polygon);

    @QtBlockedSlot public final void addRect(double x, double y, double w, double h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRect_double_double_double_double(nativeId(), x, y, w, h);
    }
    private native static void __qt_addRect_double_double_double_double(long __this__nativeId, double x, double y, double w, double h);

    @QtBlockedSlot public final void addRect(com.trolltech.qt.core.QRectF rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRect_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_addRect_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final void addRegion(com.trolltech.qt.gui.QRegion region) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRegion_QRegion(nativeId(), region == null ? (region = new com.trolltech.qt.gui.QRegion()).nativeId() : region.nativeId());
    }
    private native static void __qt_addRegion_QRegion(long __this__nativeId, long region);

    @QtBlockedSlot public final void addRoundRect(com.trolltech.qt.core.QRectF rect, int roundness) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRoundRect_QRectF_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), roundness);
    }
    private native static void __qt_addRoundRect_QRectF_int(long __this__nativeId, long rect, int roundness);

    @QtBlockedSlot public final void addRoundRect(com.trolltech.qt.core.QRectF rect, int xRnd, int yRnd) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRoundRect_QRectF_int_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), xRnd, yRnd);
    }
    private native static void __qt_addRoundRect_QRectF_int_int(long __this__nativeId, long rect, int xRnd, int yRnd);

    @QtBlockedSlot public final void addRoundRect(double x, double y, double w, double h, int roundness) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRoundRect_double_double_double_double_int(nativeId(), x, y, w, h, roundness);
    }
    private native static void __qt_addRoundRect_double_double_double_double_int(long __this__nativeId, double x, double y, double w, double h, int roundness);

    @QtBlockedSlot public final void addRoundRect(double x, double y, double w, double h, int xRnd, int yRnd) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addRoundRect_double_double_double_double_int_int(nativeId(), x, y, w, h, xRnd, yRnd);
    }
    private native static void __qt_addRoundRect_double_double_double_double_int_int(long __this__nativeId, double x, double y, double w, double h, int xRnd, int yRnd);

    @QtBlockedSlot public final void addText(com.trolltech.qt.core.QPointF point, com.trolltech.qt.gui.QFont f, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addText_QPointF_QFont_String(nativeId(), point == null ? (point = new com.trolltech.qt.core.QPointF()).nativeId() : point.nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId(), text);
    }
    private native static void __qt_addText_QPointF_QFont_String(long __this__nativeId, long point, long f, java.lang.String text);

    @QtBlockedSlot public final void addText(double x, double y, com.trolltech.qt.gui.QFont f, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addText_double_double_QFont_String(nativeId(), x, y, f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId(), text);
    }
    private native static void __qt_addText_double_double_QFont_String(long __this__nativeId, double x, double y, long f, java.lang.String text);

    @QtBlockedSlot public final double angleAtPercent(double t) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_angleAtPercent_double(nativeId(), t);
    }
    private native static double __qt_angleAtPercent_double(long __this__nativeId, double t);

    @QtBlockedSlot public final void arcMoveTo(double x, double y, double w, double h, double angle) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_arcMoveTo_double_double_double_double_double(nativeId(), x, y, w, h, angle);
    }
    private native static void __qt_arcMoveTo_double_double_double_double_double(long __this__nativeId, double x, double y, double w, double h, double angle);

    @QtBlockedSlot public final void arcMoveTo(com.trolltech.qt.core.QRectF rect, double angle) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_arcMoveTo_QRectF_double(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), angle);
    }
    private native static void __qt_arcMoveTo_QRectF_double(long __this__nativeId, long rect, double angle);

    @QtBlockedSlot public final void arcTo(com.trolltech.qt.core.QRectF rect, double startAngle, double arcLength) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_arcTo_QRectF_double_double(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), startAngle, arcLength);
    }
    private native static void __qt_arcTo_QRectF_double_double(long __this__nativeId, long rect, double startAngle, double arcLength);

    @QtBlockedSlot public final void arcTo(double x, double y, double w, double h, double startAngle, double arcLength) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_arcTo_double_double_double_double_double_double(nativeId(), x, y, w, h, startAngle, arcLength);
    }
    private native static void __qt_arcTo_double_double_double_double_double_double(long __this__nativeId, double x, double y, double w, double h, double startAngle, double arcLength);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF boundingRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_boundingRect(long __this__nativeId);

    @QtBlockedSlot public final void closeSubpath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeSubpath(nativeId());
    }
    private native static void __qt_closeSubpath(long __this__nativeId);

    @QtBlockedSlot public final void connectPath(com.trolltech.qt.gui.QPainterPath path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_connectPath_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static void __qt_connectPath_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final boolean contains(com.trolltech.qt.core.QRectF rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static boolean __qt_contains_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final boolean contains(com.trolltech.qt.gui.QPainterPath p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_QPainterPath(nativeId(), p == null ? (p = new com.trolltech.qt.gui.QPainterPath()).nativeId() : p.nativeId());
    }
    private native static boolean __qt_contains_QPainterPath(long __this__nativeId, long p);

    @QtBlockedSlot public final boolean contains(com.trolltech.qt.core.QPointF pt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_QPointF(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPointF()).nativeId() : pt.nativeId());
    }
    private native static boolean __qt_contains_QPointF(long __this__nativeId, long pt);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF controlPointRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_controlPointRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_controlPointRect(long __this__nativeId);

    @QtBlockedSlot public final void cubicTo(com.trolltech.qt.core.QPointF ctrlPt1, com.trolltech.qt.core.QPointF ctrlPt2, com.trolltech.qt.core.QPointF endPt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cubicTo_QPointF_QPointF_QPointF(nativeId(), ctrlPt1 == null ? (ctrlPt1 = new com.trolltech.qt.core.QPointF()).nativeId() : ctrlPt1.nativeId(), ctrlPt2 == null ? (ctrlPt2 = new com.trolltech.qt.core.QPointF()).nativeId() : ctrlPt2.nativeId(), endPt == null ? (endPt = new com.trolltech.qt.core.QPointF()).nativeId() : endPt.nativeId());
    }
    private native static void __qt_cubicTo_QPointF_QPointF_QPointF(long __this__nativeId, long ctrlPt1, long ctrlPt2, long endPt);

    @QtBlockedSlot public final void cubicTo(double ctrlPt1x, double ctrlPt1y, double ctrlPt2x, double ctrlPt2y, double endPtx, double endPty) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cubicTo_double_double_double_double_double_double(nativeId(), ctrlPt1x, ctrlPt1y, ctrlPt2x, ctrlPt2y, endPtx, endPty);
    }
    private native static void __qt_cubicTo_double_double_double_double_double_double(long __this__nativeId, double ctrlPt1x, double ctrlPt1y, double ctrlPt2x, double ctrlPt2y, double endPtx, double endPty);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF currentPosition() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentPosition(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_currentPosition(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath_Element elementAt(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_elementAt_int(nativeId(), i);
    }
    private native static com.trolltech.qt.gui.QPainterPath_Element __qt_elementAt_int(long __this__nativeId, int i);

    @QtBlockedSlot public final int elementCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_elementCount(nativeId());
    }
    private native static int __qt_elementCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.FillRule fillRule() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.FillRule.resolve(__qt_fillRule(nativeId()));
    }
    private native static int __qt_fillRule(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath intersected(com.trolltech.qt.gui.QPainterPath r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersected_QPainterPath(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QPainterPath()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_intersected_QPainterPath(long __this__nativeId, long r);

    @QtBlockedSlot public final boolean intersects(com.trolltech.qt.core.QRectF rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersects_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static boolean __qt_intersects_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final boolean intersects(com.trolltech.qt.gui.QPainterPath p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersects_QPainterPath(nativeId(), p == null ? (p = new com.trolltech.qt.gui.QPainterPath()).nativeId() : p.nativeId());
    }
    private native static boolean __qt_intersects_QPainterPath(long __this__nativeId, long p);

    @QtBlockedSlot public final boolean isEmpty() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @QtBlockedSlot public final double length() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_length(nativeId());
    }
    private native static double __qt_length(long __this__nativeId);

    @QtBlockedSlot public final void lineTo(com.trolltech.qt.core.QPointF p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_lineTo_QPointF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId());
    }
    private native static void __qt_lineTo_QPointF(long __this__nativeId, long p);

    @QtBlockedSlot public final void lineTo(double x, double y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_lineTo_double_double(nativeId(), x, y);
    }
    private native static void __qt_lineTo_double_double(long __this__nativeId, double x, double y);

    @QtBlockedSlot public final void moveTo(com.trolltech.qt.core.QPointF p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveTo_QPointF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId());
    }
    private native static void __qt_moveTo_QPointF(long __this__nativeId, long p);

    @QtBlockedSlot public final void moveTo(double x, double y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveTo_double_double(nativeId(), x, y);
    }
    private native static void __qt_moveTo_double_double(long __this__nativeId, double x, double y);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QPainterPath other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QPainterPath(nativeId(), other == null ? (other = new com.trolltech.qt.gui.QPainterPath()).nativeId() : other.nativeId());
    }
    private native static boolean __qt_operator_equal_QPainterPath(long __this__nativeId, long other);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final double percentAtLength(double t) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_percentAtLength_double(nativeId(), t);
    }
    private native static double __qt_percentAtLength_double(long __this__nativeId, double t);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF pointAtPercent(double t) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pointAtPercent_double(nativeId(), t);
    }
    private native static com.trolltech.qt.core.QPointF __qt_pointAtPercent_double(long __this__nativeId, double t);

    @QtBlockedSlot public final void quadTo(double ctrlPtx, double ctrlPty, double endPtx, double endPty) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_quadTo_double_double_double_double(nativeId(), ctrlPtx, ctrlPty, endPtx, endPty);
    }
    private native static void __qt_quadTo_double_double_double_double(long __this__nativeId, double ctrlPtx, double ctrlPty, double endPtx, double endPty);

    @QtBlockedSlot public final void quadTo(com.trolltech.qt.core.QPointF ctrlPt, com.trolltech.qt.core.QPointF endPt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_quadTo_QPointF_QPointF(nativeId(), ctrlPt == null ? (ctrlPt = new com.trolltech.qt.core.QPointF()).nativeId() : ctrlPt.nativeId(), endPt == null ? (endPt = new com.trolltech.qt.core.QPointF()).nativeId() : endPt.nativeId());
    }
    private native static void __qt_quadTo_QPointF_QPointF(long __this__nativeId, long ctrlPt, long endPt);

    @QtBlockedSlot public final void setElementPositionAt(int i, double x, double y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setElementPositionAt_int_double_double(nativeId(), i, x, y);
    }
    private native static void __qt_setElementPositionAt_int_double_double(long __this__nativeId, int i, double x, double y);

    @QtBlockedSlot public final void setFillRule(com.trolltech.qt.core.Qt.FillRule fillRule) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFillRule_FillRule(nativeId(), fillRule.value());
    }
    private native static void __qt_setFillRule_FillRule(long __this__nativeId, int fillRule);

    @QtBlockedSlot public final double slopeAtPercent(double t) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_slopeAtPercent_double(nativeId(), t);
    }
    private native static double __qt_slopeAtPercent_double(long __this__nativeId, double t);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath subtracted(com.trolltech.qt.gui.QPainterPath r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_subtracted_QPainterPath(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QPainterPath()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_subtracted_QPainterPath(long __this__nativeId, long r);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath subtractedInverted(com.trolltech.qt.gui.QPainterPath r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_subtractedInverted_QPainterPath(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QPainterPath()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_subtractedInverted_QPainterPath(long __this__nativeId, long r);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF toFillPolygon() {
        return toFillPolygon((com.trolltech.qt.gui.QMatrix)new com.trolltech.qt.gui.QMatrix());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF toFillPolygon(com.trolltech.qt.gui.QMatrix matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toFillPolygon_QMatrix(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_toFillPolygon_QMatrix(long __this__nativeId, long matrix);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF toFillPolygon(com.trolltech.qt.gui.QTransform matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toFillPolygon_QTransform(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_toFillPolygon_QTransform(long __this__nativeId, long matrix);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toFillPolygons() {
        return toFillPolygons((com.trolltech.qt.gui.QMatrix)new com.trolltech.qt.gui.QMatrix());
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toFillPolygons(com.trolltech.qt.gui.QMatrix matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toFillPolygons_QMatrix(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QPolygonF> __qt_toFillPolygons_QMatrix(long __this__nativeId, long matrix);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toFillPolygons(com.trolltech.qt.gui.QTransform matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toFillPolygons_QTransform(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QPolygonF> __qt_toFillPolygons_QTransform(long __this__nativeId, long matrix);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath toReversed() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toReversed(nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_toReversed(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toSubpathPolygons() {
        return toSubpathPolygons((com.trolltech.qt.gui.QMatrix)new com.trolltech.qt.gui.QMatrix());
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toSubpathPolygons(com.trolltech.qt.gui.QMatrix matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toSubpathPolygons_QMatrix(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QPolygonF> __qt_toSubpathPolygons_QMatrix(long __this__nativeId, long matrix);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QPolygonF> toSubpathPolygons(com.trolltech.qt.gui.QTransform matrix) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toSubpathPolygons_QTransform(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QPolygonF> __qt_toSubpathPolygons_QTransform(long __this__nativeId, long matrix);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath united(com.trolltech.qt.gui.QPainterPath r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_united_QPainterPath(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QPainterPath()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_united_QPainterPath(long __this__nativeId, long r);


    public static native QPainterPath fromNativePointer(QNativePointer nativePointer);

    protected QPainterPath(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QPainterPath array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QPainterPath)
            return operator_equal((com.trolltech.qt.gui.QPainterPath) other);
        return false;
    }

}
