package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QPalette extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ColorGroup implements com.trolltech.qt.QtEnumerator {
        Active(0),
        Disabled(1),
        Inactive(2),
        NColorGroups(3),
        Current(4),
        All(5),
;

        ColorGroup(int value) { this.value = value; }
        public int value() { return value; }

        public static ColorGroup resolve(int value) {
            return (ColorGroup) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Active;
            case 1: return Disabled;
            case 2: return Inactive;
            case 3: return NColorGroups;
            case 4: return Current;
            case 5: return All;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ColorRole implements com.trolltech.qt.QtEnumerator {
        WindowText(0),
        Button(1),
        Light(2),
        Midlight(3),
        Dark(4),
        Mid(5),
        Text(6),
        BrightText(7),
        ButtonText(8),
        Base(9),
        Window(10),
        Shadow(11),
        Highlight(12),
        HighlightedText(13),
        Link(14),
        LinkVisited(15),
        AlternateBase(16),
        NoRole(17),
;

        ColorRole(int value) { this.value = value; }
        public int value() { return value; }

        public static ColorRole resolve(int value) {
            return (ColorRole) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WindowText;
            case 1: return Button;
            case 2: return Light;
            case 3: return Midlight;
            case 4: return Dark;
            case 5: return Mid;
            case 6: return Text;
            case 7: return BrightText;
            case 8: return ButtonText;
            case 9: return Base;
            case 10: return Window;
            case 11: return Shadow;
            case 12: return Highlight;
            case 13: return HighlightedText;
            case 14: return Link;
            case 15: return LinkVisited;
            case 16: return AlternateBase;
            case 17: return NoRole;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QPalette(com.trolltech.qt.gui.QPalette palette) {
        super((QPrivateConstructor)null);
        __qt_QPalette_QPalette(palette == null ? (palette = new com.trolltech.qt.gui.QPalette()).nativeId() : palette.nativeId());
    }
    private native void __qt_QPalette_QPalette(long palette);


    public QPalette(com.trolltech.qt.gui.QColor button) {
        super((QPrivateConstructor)null);
        __qt_QPalette_QColor(button == null ? (button = new com.trolltech.qt.gui.QColor()).nativeId() : button.nativeId());
    }
    private native void __qt_QPalette_QColor(long button);


    public QPalette(com.trolltech.qt.gui.QBrush windowText, com.trolltech.qt.gui.QBrush button, com.trolltech.qt.gui.QBrush light, com.trolltech.qt.gui.QBrush dark, com.trolltech.qt.gui.QBrush mid, com.trolltech.qt.gui.QBrush text, com.trolltech.qt.gui.QBrush bright_text, com.trolltech.qt.gui.QBrush base, com.trolltech.qt.gui.QBrush window) {
        super((QPrivateConstructor)null);
        __qt_QPalette_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush(windowText == null ? (windowText = new com.trolltech.qt.gui.QBrush()).nativeId() : windowText.nativeId(), button == null ? (button = new com.trolltech.qt.gui.QBrush()).nativeId() : button.nativeId(), light == null ? (light = new com.trolltech.qt.gui.QBrush()).nativeId() : light.nativeId(), dark == null ? (dark = new com.trolltech.qt.gui.QBrush()).nativeId() : dark.nativeId(), mid == null ? (mid = new com.trolltech.qt.gui.QBrush()).nativeId() : mid.nativeId(), text == null ? (text = new com.trolltech.qt.gui.QBrush()).nativeId() : text.nativeId(), bright_text == null ? (bright_text = new com.trolltech.qt.gui.QBrush()).nativeId() : bright_text.nativeId(), base == null ? (base = new com.trolltech.qt.gui.QBrush()).nativeId() : base.nativeId(), window == null ? (window = new com.trolltech.qt.gui.QBrush()).nativeId() : window.nativeId());
    }
    private native void __qt_QPalette_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush(long windowText, long button, long light, long dark, long mid, long text, long bright_text, long base, long window);


    public QPalette(com.trolltech.qt.core.Qt.GlobalColor button) {
        super((QPrivateConstructor)null);
        __qt_QPalette_GlobalColor(button.value());
    }
    private native void __qt_QPalette_GlobalColor(int button);


    public QPalette() {
        super((QPrivateConstructor)null);
        __qt_QPalette();
    }
    private native void __qt_QPalette();


    public QPalette(com.trolltech.qt.gui.QColor button, com.trolltech.qt.gui.QColor window) {
        super((QPrivateConstructor)null);
        __qt_QPalette_QColor_QColor(button == null ? (button = new com.trolltech.qt.gui.QColor()).nativeId() : button.nativeId(), window == null ? (window = new com.trolltech.qt.gui.QColor()).nativeId() : window.nativeId());
    }
    private native void __qt_QPalette_QColor_QColor(long button, long window);


    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush alternateBase() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alternateBase(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_alternateBase(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush base() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_base(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_base(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush brightText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brightText(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_brightText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush brush(com.trolltech.qt.gui.QPalette.ColorRole cr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brush_ColorRole(nativeId(), cr.value());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_brush_ColorRole(long __this__nativeId, int cr);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush brush(com.trolltech.qt.gui.QPalette.ColorGroup cg, com.trolltech.qt.gui.QPalette.ColorRole cr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brush_ColorGroup_ColorRole(nativeId(), cg.value(), cr.value());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_brush_ColorGroup_ColorRole(long __this__nativeId, int cg, int cr);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush button() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_button(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_button(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush buttonText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_buttonText(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_buttonText(long __this__nativeId);

    @QtBlockedSlot public final long cacheKey() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cacheKey(nativeId());
    }
    private native static long __qt_cacheKey(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor color(com.trolltech.qt.gui.QPalette.ColorRole cr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_color_ColorRole(nativeId(), cr.value());
    }
    private native static com.trolltech.qt.gui.QColor __qt_color_ColorRole(long __this__nativeId, int cr);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor color(com.trolltech.qt.gui.QPalette.ColorGroup cg, com.trolltech.qt.gui.QPalette.ColorRole cr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_color_ColorGroup_ColorRole(nativeId(), cg.value(), cr.value());
    }
    private native static com.trolltech.qt.gui.QColor __qt_color_ColorGroup_ColorRole(long __this__nativeId, int cg, int cr);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette.ColorGroup currentColorGroup() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPalette.ColorGroup.resolve(__qt_currentColorGroup(nativeId()));
    }
    private native static int __qt_currentColorGroup(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush dark() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dark(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_dark(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush highlight() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_highlight(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_highlight(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush highlightedText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_highlightedText(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_highlightedText(long __this__nativeId);

    @QtBlockedSlot public final boolean isBrushSet(com.trolltech.qt.gui.QPalette.ColorGroup cg, com.trolltech.qt.gui.QPalette.ColorRole cr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isBrushSet_ColorGroup_ColorRole(nativeId(), cg.value(), cr.value());
    }
    private native static boolean __qt_isBrushSet_ColorGroup_ColorRole(long __this__nativeId, int cg, int cr);

    @QtBlockedSlot public final boolean isCopyOf(com.trolltech.qt.gui.QPalette p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCopyOf_QPalette(nativeId(), p == null ? (p = new com.trolltech.qt.gui.QPalette()).nativeId() : p.nativeId());
    }
    private native static boolean __qt_isCopyOf_QPalette(long __this__nativeId, long p);

    @QtBlockedSlot public final boolean isEqual(com.trolltech.qt.gui.QPalette.ColorGroup cr1, com.trolltech.qt.gui.QPalette.ColorGroup cr2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEqual_ColorGroup_ColorGroup(nativeId(), cr1.value(), cr2.value());
    }
    private native static boolean __qt_isEqual_ColorGroup_ColorGroup(long __this__nativeId, int cr1, int cr2);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush light() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_light(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_light(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush link() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_link(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_link(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush linkVisited() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_linkVisited(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_linkVisited(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush mid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mid(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_mid(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush midlight() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_midlight(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_midlight(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream ds) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), ds == null ? 0 : ds.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long ds);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QPalette p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QPalette(nativeId(), p == null ? (p = new com.trolltech.qt.gui.QPalette()).nativeId() : p.nativeId());
    }
    private native static boolean __qt_operator_equal_QPalette(long __this__nativeId, long p);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream ds) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), ds == null ? 0 : ds.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long ds);

    @QtBlockedSlot public final int resolve() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolve(nativeId());
    }
    private native static int __qt_resolve(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette resolve(com.trolltech.qt.gui.QPalette arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolve_QPalette(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QPalette()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.gui.QPalette __qt_resolve_QPalette(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void resolve(int mask) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resolve_int(nativeId(), mask);
    }
    private native static void __qt_resolve_int(long __this__nativeId, int mask);

    @QtBlockedSlot public final void setBrush(com.trolltech.qt.gui.QPalette.ColorGroup cg, com.trolltech.qt.gui.QPalette.ColorRole cr, com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrush_ColorGroup_ColorRole_QBrush(nativeId(), cg.value(), cr.value(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBrush_ColorGroup_ColorRole_QBrush(long __this__nativeId, int cg, int cr, long brush);

    @QtBlockedSlot public final void setBrush(com.trolltech.qt.gui.QPalette.ColorRole cr, com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrush_ColorRole_QBrush(nativeId(), cr.value(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBrush_ColorRole_QBrush(long __this__nativeId, int cr, long brush);

    @QtBlockedSlot public final void setColor(com.trolltech.qt.gui.QPalette.ColorGroup cg, com.trolltech.qt.gui.QPalette.ColorRole cr, com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColor_ColorGroup_ColorRole_QColor(nativeId(), cg.value(), cr.value(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setColor_ColorGroup_ColorRole_QColor(long __this__nativeId, int cg, int cr, long color);

    @QtBlockedSlot public final void setColor(com.trolltech.qt.gui.QPalette.ColorRole cr, com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColor_ColorRole_QColor(nativeId(), cr.value(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setColor_ColorRole_QColor(long __this__nativeId, int cr, long color);

    @QtBlockedSlot public final void setColorGroup(com.trolltech.qt.gui.QPalette.ColorGroup cr, com.trolltech.qt.gui.QBrush windowText, com.trolltech.qt.gui.QBrush button, com.trolltech.qt.gui.QBrush light, com.trolltech.qt.gui.QBrush dark, com.trolltech.qt.gui.QBrush mid, com.trolltech.qt.gui.QBrush text, com.trolltech.qt.gui.QBrush bright_text, com.trolltech.qt.gui.QBrush base, com.trolltech.qt.gui.QBrush window) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColorGroup_ColorGroup_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush(nativeId(), cr.value(), windowText == null ? (windowText = new com.trolltech.qt.gui.QBrush()).nativeId() : windowText.nativeId(), button == null ? (button = new com.trolltech.qt.gui.QBrush()).nativeId() : button.nativeId(), light == null ? (light = new com.trolltech.qt.gui.QBrush()).nativeId() : light.nativeId(), dark == null ? (dark = new com.trolltech.qt.gui.QBrush()).nativeId() : dark.nativeId(), mid == null ? (mid = new com.trolltech.qt.gui.QBrush()).nativeId() : mid.nativeId(), text == null ? (text = new com.trolltech.qt.gui.QBrush()).nativeId() : text.nativeId(), bright_text == null ? (bright_text = new com.trolltech.qt.gui.QBrush()).nativeId() : bright_text.nativeId(), base == null ? (base = new com.trolltech.qt.gui.QBrush()).nativeId() : base.nativeId(), window == null ? (window = new com.trolltech.qt.gui.QBrush()).nativeId() : window.nativeId());
    }
    private native static void __qt_setColorGroup_ColorGroup_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush_QBrush(long __this__nativeId, int cr, long windowText, long button, long light, long dark, long mid, long text, long bright_text, long base, long window);

    @QtBlockedSlot public final void setCurrentColorGroup(com.trolltech.qt.gui.QPalette.ColorGroup cg) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentColorGroup_ColorGroup(nativeId(), cg.value());
    }
    private native static void __qt_setCurrentColorGroup_ColorGroup(long __this__nativeId, int cg);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush shadow() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_shadow(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_shadow(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_text(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush window() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_window(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_window(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush windowText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowText(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_windowText(long __this__nativeId);


    public static native QPalette fromNativePointer(QNativePointer nativePointer);

    protected QPalette(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QPalette array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QPalette)
            return operator_equal((com.trolltech.qt.gui.QPalette) other);
        return false;
    }

}
