package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSizePolicy extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ControlType implements com.trolltech.qt.QtEnumerator {
        DefaultType(1),
        ButtonBox(2),
        CheckBox(4),
        ComboBox(8),
        Frame(16),
        GroupBox(32),
        Label(64),
        Line(128),
        LineEdit(256),
        PushButton(512),
        RadioButton(1024),
        Slider(2048),
        SpinBox(4096),
        TabWidget(8192),
        ToolButton(16384);

        ControlType(int value) { this.value = value; }
        public int value() { return value; }

        public static ControlTypes createQFlags(ControlType ... values) {
            return new ControlTypes(values);
        }
        public static ControlType resolve(int value) {
            return (ControlType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DefaultType;
            case 2: return ButtonBox;
            case 4: return CheckBox;
            case 8: return ComboBox;
            case 16: return Frame;
            case 32: return GroupBox;
            case 64: return Label;
            case 128: return Line;
            case 256: return LineEdit;
            case 512: return PushButton;
            case 1024: return RadioButton;
            case 2048: return Slider;
            case 4096: return SpinBox;
            case 8192: return TabWidget;
            case 16384: return ToolButton;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ControlTypes extends com.trolltech.qt.QFlags<ControlType> {
        private static final long serialVersionUID = 1L;
        public ControlTypes(ControlType ... args) { super(args); }
        public ControlTypes(int value) { setValue(value); }
    }

    public enum PolicyFlag implements com.trolltech.qt.QtEnumerator {
        GrowFlag(1),
        ExpandFlag(2),
        ShrinkFlag(4),
        IgnoreFlag(8);

        PolicyFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static PolicyFlag resolve(int value) {
            return (PolicyFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return GrowFlag;
            case 2: return ExpandFlag;
            case 4: return ShrinkFlag;
            case 8: return IgnoreFlag;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Policy implements com.trolltech.qt.QtEnumerator {
        Fixed(0),
        Minimum(1),
        Maximum(4),
        Preferred(5),
        MinimumExpanding(3),
        Expanding(7),
        Ignored(13);

        Policy(int value) { this.value = value; }
        public int value() { return value; }

        public static Policy resolve(int value) {
            return (Policy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Fixed;
            case 1: return Minimum;
            case 4: return Maximum;
            case 5: return Preferred;
            case 3: return MinimumExpanding;
            case 7: return Expanding;
            case 13: return Ignored;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QSizePolicy(com.trolltech.qt.gui.QSizePolicy.Policy horizontal, com.trolltech.qt.gui.QSizePolicy.Policy vertical, com.trolltech.qt.gui.QSizePolicy.ControlType type) {
        super((QPrivateConstructor)null);
        __qt_QSizePolicy_Policy_Policy_ControlType(horizontal.value(), vertical.value(), type.value());
    }
    private native void __qt_QSizePolicy_Policy_Policy_ControlType(int horizontal, int vertical, int type);


    public QSizePolicy() {
        super((QPrivateConstructor)null);
        __qt_QSizePolicy();
    }
    private native void __qt_QSizePolicy();


    public QSizePolicy(com.trolltech.qt.gui.QSizePolicy.Policy horizontal, com.trolltech.qt.gui.QSizePolicy.Policy vertical) {
        super((QPrivateConstructor)null);
        __qt_QSizePolicy_Policy_Policy(horizontal.value(), vertical.value());
    }
    private native void __qt_QSizePolicy_Policy_Policy(int horizontal, int vertical);


    @QtBlockedSlot public final com.trolltech.qt.gui.QSizePolicy.ControlType controlType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QSizePolicy.ControlType.resolve(__qt_controlType(nativeId()));
    }
    private native static int __qt_controlType(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientations expandingDirections() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Orientations(__qt_expandingDirections(nativeId()));
    }
    private native static int __qt_expandingDirections(long __this__nativeId);

    @QtBlockedSlot public final boolean hasHeightForWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasHeightForWidth(nativeId());
    }
    private native static boolean __qt_hasHeightForWidth(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QSizePolicy.Policy horizontalPolicy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QSizePolicy.Policy.resolve(__qt_horizontalPolicy(nativeId()));
    }
    private native static int __qt_horizontalPolicy(long __this__nativeId);

    @QtBlockedSlot public final int horizontalStretch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_horizontalStretch(nativeId());
    }
    private native static int __qt_horizontalStretch(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QSizePolicy s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QSizePolicy(nativeId(), s == null ? (s = new com.trolltech.qt.gui.QSizePolicy()).nativeId() : s.nativeId());
    }
    private native static boolean __qt_operator_equal_QSizePolicy(long __this__nativeId, long s);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setControlType(com.trolltech.qt.gui.QSizePolicy.ControlType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setControlType_ControlType(nativeId(), type.value());
    }
    private native static void __qt_setControlType_ControlType(long __this__nativeId, int type);

    @QtBlockedSlot public final void setHeightForWidth(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHeightForWidth_boolean(nativeId(), b);
    }
    private native static void __qt_setHeightForWidth_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public final void setHorizontalPolicy(com.trolltech.qt.gui.QSizePolicy.Policy d) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHorizontalPolicy_Policy(nativeId(), d.value());
    }
    private native static void __qt_setHorizontalPolicy_Policy(long __this__nativeId, int d);

    @QtBlockedSlot public final void setHorizontalStretch(byte stretchFactor) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHorizontalStretch_byte(nativeId(), stretchFactor);
    }
    private native static void __qt_setHorizontalStretch_byte(long __this__nativeId, byte stretchFactor);

    @QtBlockedSlot public final void setVerticalPolicy(com.trolltech.qt.gui.QSizePolicy.Policy d) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVerticalPolicy_Policy(nativeId(), d.value());
    }
    private native static void __qt_setVerticalPolicy_Policy(long __this__nativeId, int d);

    @QtBlockedSlot public final void setVerticalStretch(byte stretchFactor) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVerticalStretch_byte(nativeId(), stretchFactor);
    }
    private native static void __qt_setVerticalStretch_byte(long __this__nativeId, byte stretchFactor);

    @QtBlockedSlot public final void transpose() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_transpose(nativeId());
    }
    private native static void __qt_transpose(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QSizePolicy.Policy verticalPolicy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QSizePolicy.Policy.resolve(__qt_verticalPolicy(nativeId()));
    }
    private native static int __qt_verticalPolicy(long __this__nativeId);

    @QtBlockedSlot public final int verticalStretch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_verticalStretch(nativeId());
    }
    private native static int __qt_verticalStretch(long __this__nativeId);


    public static native QSizePolicy fromNativePointer(QNativePointer nativePointer);

    protected QSizePolicy(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QSizePolicy array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QSizePolicy)
            return operator_equal((com.trolltech.qt.gui.QSizePolicy) other);
        return false;
    }

}
