package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStandardItem extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ItemType implements com.trolltech.qt.QtEnumerator {
        Type(0),
        UserType(1000);

        ItemType(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemType resolve(int value) {
            return (ItemType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Type;
            case 1000: return UserType;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStandardItem(java.lang.String text) {
        super((QPrivateConstructor)null);
        __qt_QStandardItem_String(text);
    }
    private native void __qt_QStandardItem_String(java.lang.String text);



    public QStandardItem(int rows) {
        this(rows, (int)1);
    }
    public QStandardItem(int rows, int columns) {
        super((QPrivateConstructor)null);
        __qt_QStandardItem_int_int(rows, columns);
    }
    private native void __qt_QStandardItem_int_int(int rows, int columns);


    public QStandardItem(com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        super((QPrivateConstructor)null);
        __qt_QStandardItem_QIcon_String(icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text);
    }
    private native void __qt_QStandardItem_QIcon_String(long icon, java.lang.String text);


    public QStandardItem() {
        super((QPrivateConstructor)null);
        __qt_QStandardItem();
    }
    private native void __qt_QStandardItem();


    protected QStandardItem(com.trolltech.qt.gui.QStandardItem other) {
        super((QPrivateConstructor)null);
        __qt_QStandardItem_QStandardItem(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QStandardItem_QStandardItem(long other);


    @QtBlockedSlot public final java.lang.String accessibleDescription() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_accessibleDescription(nativeId());
    }
    private native static java.lang.String __qt_accessibleDescription(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String accessibleText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_accessibleText(nativeId());
    }
    private native static java.lang.String __qt_accessibleText(long __this__nativeId);

    @QtBlockedSlot public final void appendColumn(java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (items != null) {
            for (com.trolltech.qt.gui.QStandardItem i : items)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_appendColumn_List(nativeId(), items);
    }
    private native static void __qt_appendColumn_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final void appendRow(com.trolltech.qt.gui.QStandardItem item) {
        if (item != null) {
            item.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_appendRow_QStandardItem(nativeId(), item == null ? 0 : item.nativeId());
    }
    private native static void __qt_appendRow_QStandardItem(long __this__nativeId, long item);

    @QtBlockedSlot public final void appendRow(java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (items != null) {
            for (com.trolltech.qt.gui.QStandardItem i : items)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_appendRow_List(nativeId(), items);
    }
    private native static void __qt_appendRow_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final void appendRows(java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_appendRows_List(nativeId(), items);
    }
    private native static void __qt_appendRows_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.CheckState checkState() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.CheckState.resolve(__qt_checkState(nativeId()));
    }
    private native static int __qt_checkState(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItem child(int row) {
        return child(row, (int)0);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItem child(int row, int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_child_int_int(nativeId(), row, column);
    }
    private native static com.trolltech.qt.gui.QStandardItem __qt_child_int_int(long __this__nativeId, int row, int column);

    @QtBlockedSlot public final int column() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_column(nativeId());
    }
    private native static int __qt_column(long __this__nativeId);

    @QtBlockedSlot public final int columnCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnCount(nativeId());
    }
    private native static int __qt_columnCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ItemFlags flags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.ItemFlags(__qt_flags(nativeId()));
    }
    private native static int __qt_flags(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foreground() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foreground(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foreground(long __this__nativeId);

    @QtBlockedSlot public final boolean hasChildren() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasChildren(nativeId());
    }
    private native static boolean __qt_hasChildren(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex index() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_index(nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_index(long __this__nativeId);

    @QtBlockedSlot public final void insertColumn(int column, java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (items != null) {
            for (com.trolltech.qt.gui.QStandardItem i : items)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertColumn_int_List(nativeId(), column, items);
    }
    private native static void __qt_insertColumn_int_List(long __this__nativeId, int column, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final void insertColumns(int column, int count) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertColumns_int_int(nativeId(), column, count);
    }
    private native static void __qt_insertColumns_int_int(long __this__nativeId, int column, int count);

    @QtBlockedSlot public final void insertRow(int row, com.trolltech.qt.gui.QStandardItem item) {
        if (item != null) {
            item.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertRow_int_QStandardItem(nativeId(), row, item == null ? 0 : item.nativeId());
    }
    private native static void __qt_insertRow_int_QStandardItem(long __this__nativeId, int row, long item);

    @QtBlockedSlot public final void insertRow(int row, java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (items != null) {
            for (com.trolltech.qt.gui.QStandardItem i : items)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertRow_int_List(nativeId(), row, items);
    }
    private native static void __qt_insertRow_int_List(long __this__nativeId, int row, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final void insertRows(int row, java.util.List<com.trolltech.qt.gui.QStandardItem> items) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertRows_int_List(nativeId(), row, items);
    }
    private native static void __qt_insertRows_int_List(long __this__nativeId, int row, java.util.List<com.trolltech.qt.gui.QStandardItem> items);

    @QtBlockedSlot public final void insertRows(int row, int count) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertRows_int_int(nativeId(), row, count);
    }
    private native static void __qt_insertRows_int_int(long __this__nativeId, int row, int count);

    @QtBlockedSlot public final boolean isCheckable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCheckable(nativeId());
    }
    private native static boolean __qt_isCheckable(long __this__nativeId);

    @QtBlockedSlot public final boolean isDragEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDragEnabled(nativeId());
    }
    private native static boolean __qt_isDragEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isDropEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDropEnabled(nativeId());
    }
    private native static boolean __qt_isDropEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isEditable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEditable(nativeId());
    }
    private native static boolean __qt_isEditable(long __this__nativeId);

    @QtBlockedSlot public final boolean isEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEnabled(nativeId());
    }
    private native static boolean __qt_isEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isSelectable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelectable(nativeId());
    }
    private native static boolean __qt_isSelectable(long __this__nativeId);

    @QtBlockedSlot public final boolean isTristate() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTristate(nativeId());
    }
    private native static boolean __qt_isTristate(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItemModel model() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_model(nativeId());
    }
    private native static com.trolltech.qt.gui.QStandardItemModel __qt_model(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long out);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItem parent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parent(nativeId());
    }
    private native static com.trolltech.qt.gui.QStandardItem __qt_parent(long __this__nativeId);

    @QtBlockedSlot public final void removeColumn(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeColumn_int(nativeId(), column);
    }
    private native static void __qt_removeColumn_int(long __this__nativeId, int column);

    @QtBlockedSlot public final void removeColumns(int column, int count) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeColumns_int_int(nativeId(), column, count);
    }
    private native static void __qt_removeColumns_int_int(long __this__nativeId, int column, int count);

    @QtBlockedSlot public final void removeRow(int row) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeRow_int(nativeId(), row);
    }
    private native static void __qt_removeRow_int(long __this__nativeId, int row);

    @QtBlockedSlot public final void removeRows(int row, int count) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeRows_int_int(nativeId(), row, count);
    }
    private native static void __qt_removeRows_int_int(long __this__nativeId, int row, int count);

    @QtBlockedSlot public final int row() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_row(nativeId());
    }
    private native static int __qt_row(long __this__nativeId);

    @QtBlockedSlot public final int rowCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rowCount(nativeId());
    }
    private native static int __qt_rowCount(long __this__nativeId);

    @QtBlockedSlot public final void setAccessibleDescription(java.lang.String accessibleDescription) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAccessibleDescription_String(nativeId(), accessibleDescription);
    }
    private native static void __qt_setAccessibleDescription_String(long __this__nativeId, java.lang.String accessibleDescription);

    @QtBlockedSlot public final void setAccessibleText(java.lang.String accessibleText) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAccessibleText_String(nativeId(), accessibleText);
    }
    private native static void __qt_setAccessibleText_String(long __this__nativeId, java.lang.String accessibleText);

    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setCheckState(com.trolltech.qt.core.Qt.CheckState checkState) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCheckState_CheckState(nativeId(), checkState.value());
    }
    private native static void __qt_setCheckState_CheckState(long __this__nativeId, int checkState);

    @QtBlockedSlot public final void setCheckable(boolean checkable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCheckable_boolean(nativeId(), checkable);
    }
    private native static void __qt_setCheckable_boolean(long __this__nativeId, boolean checkable);

    @QtBlockedSlot public final void setChild(int row, int column, com.trolltech.qt.gui.QStandardItem item) {
        if (item != null) {
            item.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setChild_int_int_QStandardItem(nativeId(), row, column, item == null ? 0 : item.nativeId());
    }
    private native static void __qt_setChild_int_int_QStandardItem(long __this__nativeId, int row, int column, long item);

    @QtBlockedSlot public final void setChild(int row, com.trolltech.qt.gui.QStandardItem item) {
        if (item != null) {
            item.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setChild_int_QStandardItem(nativeId(), row, item == null ? 0 : item.nativeId());
    }
    private native static void __qt_setChild_int_QStandardItem(long __this__nativeId, int row, long item);

    @QtBlockedSlot public final void setColumnCount(int columns) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColumnCount_int(nativeId(), columns);
    }
    private native static void __qt_setColumnCount_int(long __this__nativeId, int columns);

    @QtBlockedSlot public final void setDragEnabled(boolean dragEnabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDragEnabled_boolean(nativeId(), dragEnabled);
    }
    private native static void __qt_setDragEnabled_boolean(long __this__nativeId, boolean dragEnabled);

    @QtBlockedSlot public final void setDropEnabled(boolean dropEnabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDropEnabled_boolean(nativeId(), dropEnabled);
    }
    private native static void __qt_setDropEnabled_boolean(long __this__nativeId, boolean dropEnabled);

    @QtBlockedSlot public final void setEditable(boolean editable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEditable_boolean(nativeId(), editable);
    }
    private native static void __qt_setEditable_boolean(long __this__nativeId, boolean editable);

    @QtBlockedSlot public final void setEnabled(boolean enabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEnabled_boolean(nativeId(), enabled);
    }
    private native static void __qt_setEnabled_boolean(long __this__nativeId, boolean enabled);


    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlag ... flags) {
        this.setFlags(new com.trolltech.qt.core.Qt.ItemFlags(flags));
    }
    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFlags_ItemFlags(nativeId(), flags.value());
    }
    private native static void __qt_setFlags_ItemFlags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final void setForeground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForeground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForeground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final void setRowCount(int rows) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRowCount_int(nativeId(), rows);
    }
    private native static void __qt_setRowCount_int(long __this__nativeId, int rows);

    @QtBlockedSlot public final void setSelectable(boolean selectable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectable_boolean(nativeId(), selectable);
    }
    private native static void __qt_setSelectable_boolean(long __this__nativeId, boolean selectable);

    @QtBlockedSlot public final void setSizeHint(com.trolltech.qt.core.QSize sizeHint) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeHint_QSize(nativeId(), sizeHint == null ? (sizeHint = new com.trolltech.qt.core.QSize()).nativeId() : sizeHint.nativeId());
    }
    private native static void __qt_setSizeHint_QSize(long __this__nativeId, long sizeHint);

    @QtBlockedSlot public final void setStatusTip(java.lang.String statusTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusTip_String(nativeId(), statusTip);
    }
    private native static void __qt_setStatusTip_String(long __this__nativeId, java.lang.String statusTip);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);


    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... textAlignment) {
        this.setTextAlignment(new com.trolltech.qt.core.Qt.Alignment(textAlignment));
    }
    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.Alignment textAlignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_Alignment(nativeId(), textAlignment.value());
    }
    private native static void __qt_setTextAlignment_Alignment(long __this__nativeId, int textAlignment);

    @QtBlockedSlot public final void setToolTip(java.lang.String toolTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_String(nativeId(), toolTip);
    }
    private native static void __qt_setToolTip_String(long __this__nativeId, java.lang.String toolTip);

    @QtBlockedSlot public final void setTristate(boolean tristate) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTristate_boolean(nativeId(), tristate);
    }
    private native static void __qt_setTristate_boolean(long __this__nativeId, boolean tristate);

    @QtBlockedSlot public final void setWhatsThis(java.lang.String whatsThis) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWhatsThis_String(nativeId(), whatsThis);
    }
    private native static void __qt_setWhatsThis_String(long __this__nativeId, java.lang.String whatsThis);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize sizeHint() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    @QtBlockedSlot public final void sortChildren(int column) {
        sortChildren(column, com.trolltech.qt.core.Qt.SortOrder.AscendingOrder);
    }
    @QtBlockedSlot public final void sortChildren(int column, com.trolltech.qt.core.Qt.SortOrder order) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sortChildren_int_SortOrder(nativeId(), column, order.value());
    }
    private native static void __qt_sortChildren_int_SortOrder(long __this__nativeId, int column, int order);

    @QtBlockedSlot public final java.lang.String statusTip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusTip(nativeId());
    }
    private native static java.lang.String __qt_statusTip(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItem takeChild(int row) {
        return takeChild(row, (int)0);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QStandardItem takeChild(int row, int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QStandardItem __qt_return_value = __qt_takeChild_int_int(nativeId(), row, column);
        if (__qt_return_value != null) {
          __qt_return_value.reenableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QStandardItem __qt_takeChild_int_int(long __this__nativeId, int row, int column);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QStandardItem> takeColumn(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        java.util.List<com.trolltech.qt.gui.QStandardItem> __qt_return_value = __qt_takeColumn_int(nativeId(), column);
        if (__qt_return_value != null) {
            for (com.trolltech.qt.gui.QStandardItem i : __qt_return_value)
                if (i != null) i.reenableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static java.util.List<com.trolltech.qt.gui.QStandardItem> __qt_takeColumn_int(long __this__nativeId, int column);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QStandardItem> takeRow(int row) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        java.util.List<com.trolltech.qt.gui.QStandardItem> __qt_return_value = __qt_takeRow_int(nativeId(), row);
        if (__qt_return_value != null) {
            for (com.trolltech.qt.gui.QStandardItem i : __qt_return_value)
                if (i != null) i.reenableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static java.util.List<com.trolltech.qt.gui.QStandardItem> __qt_takeRow_int(long __this__nativeId, int row);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment textAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_textAlignment(nativeId()));
    }
    private native static int __qt_textAlignment(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String toolTip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip(nativeId());
    }
    private native static java.lang.String __qt_toolTip(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String whatsThis() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_whatsThis(nativeId());
    }
    private native static java.lang.String __qt_whatsThis(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.gui.QStandardItem clone() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clone(nativeId());
    }
    private native static com.trolltech.qt.gui.QStandardItem __qt_clone(long __this__nativeId);


    @QtBlockedSlot public final java.lang.Object data() {
        return data((int)33);
    }
    @QtBlockedSlot public java.lang.Object data(int role) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data_int(nativeId(), role);
    }
    private native static java.lang.Object __qt_data_int(long __this__nativeId, int role);

    @SuppressWarnings("unused")
    @QtBlockedSlot private boolean operator_less(com.trolltech.qt.gui.QStandardItem other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QStandardItem(nativeId(), other == null ? 0 : other.nativeId());
    }
    private native static boolean __qt_operator_less_QStandardItem(long __this__nativeId, long other);

    @QtBlockedSlot public void read(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_read_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_read_QDataStream(long __this__nativeId, long in);


    @QtBlockedSlot public final void setData(java.lang.Object value) {
        setData(value, (int)33);
    }
    @QtBlockedSlot public void setData(java.lang.Object value, int role) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData_Object_int(nativeId(), value, role);
    }
    private native static void __qt_setData_Object_int(long __this__nativeId, java.lang.Object value, int role);

    @QtBlockedSlot public int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public void write(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_write_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_write_QDataStream(long __this__nativeId, long out);


    public static native QStandardItem fromNativePointer(QNativePointer nativePointer);

    protected QStandardItem(QPrivateConstructor p) { super(p); } 

}
