package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionGroupBox extends com.trolltech.qt.gui.QStyleOptionComplex
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(983047);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 983047: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionGroupBox(com.trolltech.qt.gui.QStyleOptionGroupBox other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionGroupBox_QStyleOptionGroupBox(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionGroupBox()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionGroupBox_QStyleOptionGroupBox(long other);


    public QStyleOptionGroupBox() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionGroupBox();
    }
    private native void __qt_QStyleOptionGroupBox();


    protected QStyleOptionGroupBox(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionGroupBox_int(version);
    }
    private native void __qt_QStyleOptionGroupBox_int(int version);

    @QtBlockedSlot public final void setLineWidth(int lineWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWidth_int(nativeId(), lineWidth);
    }
    private native static void __qt_setLineWidth_int(long __this__nativeId, int lineWidth);

    @QtBlockedSlot public final int lineWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineWidth(nativeId());
    }
    private native static int __qt_lineWidth(long __this__nativeId);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_FrameFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_FrameFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);


    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... textAlignment) {
        this.setTextAlignment(new com.trolltech.qt.core.Qt.Alignment(textAlignment));
    }
    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.Alignment textAlignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_Alignment(nativeId(), textAlignment.value());
    }
    private native static void __qt_setTextAlignment_Alignment(long __this__nativeId, int textAlignment);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment textAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_textAlignment(nativeId()));
    }
    private native static int __qt_textAlignment(long __this__nativeId);

    @QtBlockedSlot public final void setMidLineWidth(int midLineWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMidLineWidth_int(nativeId(), midLineWidth);
    }
    private native static void __qt_setMidLineWidth_int(long __this__nativeId, int midLineWidth);

    @QtBlockedSlot public final int midLineWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_midLineWidth(nativeId());
    }
    private native static int __qt_midLineWidth(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setTextColor(com.trolltech.qt.gui.QColor textColor) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextColor_QColor(nativeId(), textColor == null ? (textColor = new com.trolltech.qt.gui.QColor()).nativeId() : textColor.nativeId());
    }
    private native static void __qt_setTextColor_QColor(long __this__nativeId, long textColor);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor textColor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_textColor(long __this__nativeId);


    public static native QStyleOptionGroupBox fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionGroupBox(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionGroupBox array[]);
}
