package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionHeader extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SectionPosition implements com.trolltech.qt.QtEnumerator {
        Beginning(0),
        Middle(1),
        End(2),
        OnlyOneSection(3);

        SectionPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static SectionPosition resolve(int value) {
            return (SectionPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Beginning;
            case 1: return Middle;
            case 2: return End;
            case 3: return OnlyOneSection;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SelectedPosition implements com.trolltech.qt.QtEnumerator {
        NotAdjacent(0),
        NextIsSelected(1),
        PreviousIsSelected(2),
        NextAndPreviousAreSelected(3);

        SelectedPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectedPosition resolve(int value) {
            return (SelectedPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotAdjacent;
            case 1: return NextIsSelected;
            case 2: return PreviousIsSelected;
            case 3: return NextAndPreviousAreSelected;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(8);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 8: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SortIndicator implements com.trolltech.qt.QtEnumerator {
        None(0),
        SortUp(1),
        SortDown(2);

        SortIndicator(int value) { this.value = value; }
        public int value() { return value; }

        public static SortIndicator resolve(int value) {
            return (SortIndicator) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return SortUp;
            case 2: return SortDown;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionHeader(com.trolltech.qt.gui.QStyleOptionHeader other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionHeader_QStyleOptionHeader(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionHeader()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionHeader_QStyleOptionHeader(long other);


    public QStyleOptionHeader() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionHeader();
    }
    private native void __qt_QStyleOptionHeader();


    protected QStyleOptionHeader(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionHeader_int(version);
    }
    private native void __qt_QStyleOptionHeader_int(int version);

    @QtBlockedSlot public final void setSection(int section) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSection_int(nativeId(), section);
    }
    private native static void __qt_setSection_int(long __this__nativeId, int section);

    @QtBlockedSlot public final int section() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_section(nativeId());
    }
    private native static int __qt_section(long __this__nativeId);

    @QtBlockedSlot public final void setSortIndicator(com.trolltech.qt.gui.QStyleOptionHeader.SortIndicator sortIndicator) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSortIndicator_SortIndicator(nativeId(), sortIndicator.value());
    }
    private native static void __qt_setSortIndicator_SortIndicator(long __this__nativeId, int sortIndicator);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionHeader.SortIndicator sortIndicator() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionHeader.SortIndicator.resolve(__qt_sortIndicator(nativeId()));
    }
    private native static int __qt_sortIndicator(long __this__nativeId);

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.gui.QStyleOptionHeader.SectionPosition position) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_SectionPosition(nativeId(), position.value());
    }
    private native static void __qt_setPosition_SectionPosition(long __this__nativeId, int position);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionHeader.SectionPosition position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionHeader.SectionPosition.resolve(__qt_position(nativeId()));
    }
    private native static int __qt_position(long __this__nativeId);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);


    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... textAlignment) {
        this.setTextAlignment(new com.trolltech.qt.core.Qt.Alignment(textAlignment));
    }
    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.Alignment textAlignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_Alignment(nativeId(), textAlignment.value());
    }
    private native static void __qt_setTextAlignment_Alignment(long __this__nativeId, int textAlignment);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment textAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_textAlignment(nativeId()));
    }
    private native static int __qt_textAlignment(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setSelectedPosition(com.trolltech.qt.gui.QStyleOptionHeader.SelectedPosition selectedPosition) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectedPosition_SelectedPosition(nativeId(), selectedPosition.value());
    }
    private native static void __qt_setSelectedPosition_SelectedPosition(long __this__nativeId, int selectedPosition);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionHeader.SelectedPosition selectedPosition() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionHeader.SelectedPosition.resolve(__qt_selectedPosition(nativeId()));
    }
    private native static int __qt_selectedPosition(long __this__nativeId);


    @QtBlockedSlot public final void setIconAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... iconAlignment) {
        this.setIconAlignment(new com.trolltech.qt.core.Qt.Alignment(iconAlignment));
    }
    @QtBlockedSlot public final void setIconAlignment(com.trolltech.qt.core.Qt.Alignment iconAlignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconAlignment_Alignment(nativeId(), iconAlignment.value());
    }
    private native static void __qt_setIconAlignment_Alignment(long __this__nativeId, int iconAlignment);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment iconAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_iconAlignment(nativeId()));
    }
    private native static int __qt_iconAlignment(long __this__nativeId);

    @QtBlockedSlot public final void setOrientation(com.trolltech.qt.core.Qt.Orientation orientation) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOrientation_Orientation(nativeId(), orientation.value());
    }
    private native static void __qt_setOrientation_Orientation(long __this__nativeId, int orientation);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientation orientation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);


    public static native QStyleOptionHeader fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionHeader(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionHeader array[]);
}
