package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionToolButton extends com.trolltech.qt.gui.QStyleOptionComplex
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolButtonFeature implements com.trolltech.qt.QtEnumerator {
        None(0),
        Arrow(1),
        Menu(4),
        PopupDelay(8),
        HasMenu(16);

        ToolButtonFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolButtonFeatures createQFlags(ToolButtonFeature ... values) {
            return new ToolButtonFeatures(values);
        }
        public static ToolButtonFeature resolve(int value) {
            return (ToolButtonFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return Arrow;
            case 4: return Menu;
            case 8: return PopupDelay;
            case 16: return HasMenu;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ToolButtonFeatures extends com.trolltech.qt.QFlags<ToolButtonFeature> {
        private static final long serialVersionUID = 1L;
        public ToolButtonFeatures(ToolButtonFeature ... args) { super(args); }
        public ToolButtonFeatures(int value) { setValue(value); }
    }

    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(983043);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 983043: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionToolButton(com.trolltech.qt.gui.QStyleOptionToolButton other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolButton_QStyleOptionToolButton(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionToolButton()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionToolButton_QStyleOptionToolButton(long other);


    public QStyleOptionToolButton() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolButton();
    }
    private native void __qt_QStyleOptionToolButton();


    protected QStyleOptionToolButton(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolButton_int(version);
    }
    private native void __qt_QStyleOptionToolButton_int(int version);

    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize iconSize) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), iconSize == null ? (iconSize = new com.trolltech.qt.core.QSize()).nativeId() : iconSize.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long iconSize);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);

    @QtBlockedSlot public final void setToolButtonStyle(com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolButtonStyle_ToolButtonStyle(nativeId(), toolButtonStyle.value());
    }
    private native static void __qt_setToolButtonStyle_ToolButtonStyle(long __this__nativeId, int toolButtonStyle);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ToolButtonStyle.resolve(__qt_toolButtonStyle(nativeId()));
    }
    private native static int __qt_toolButtonStyle(long __this__nativeId);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionToolButton.ToolButtonFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionToolButton.ToolButtonFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionToolButton.ToolButtonFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_ToolButtonFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_ToolButtonFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolButton.ToolButtonFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionToolButton.ToolButtonFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);

    @QtBlockedSlot public final void setArrowType(com.trolltech.qt.core.Qt.ArrowType arrowType) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setArrowType_ArrowType(nativeId(), arrowType.value());
    }
    private native static void __qt_setArrowType_ArrowType(long __this__nativeId, int arrowType);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ArrowType arrowType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ArrowType.resolve(__qt_arrowType(nativeId()));
    }
    private native static int __qt_arrowType(long __this__nativeId);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final void setPos(com.trolltech.qt.core.QPoint pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPos_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static void __qt_setPos_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_pos(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);


    public static native QStyleOptionToolButton fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionToolButton(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionToolButton array[]);
}
