package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSystemTrayIcon extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private Object __rcContextMenu = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum MessageIcon implements com.trolltech.qt.QtEnumerator {
        NoIcon(0),
        Information(1),
        Warning(2),
        Critical(3);

        MessageIcon(int value) { this.value = value; }
        public int value() { return value; }

        public static MessageIcon resolve(int value) {
            return (MessageIcon) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoIcon;
            case 1: return Information;
            case 2: return Warning;
            case 3: return Critical;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ActivationReason implements com.trolltech.qt.QtEnumerator {
        Unknown(0),
        Context(1),
        DoubleClick(2),
        Trigger(3),
        MiddleClick(4);

        ActivationReason(int value) { this.value = value; }
        public int value() { return value; }

        public static ActivationReason resolve(int value) {
            return (ActivationReason) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Unknown;
            case 1: return Context;
            case 2: return DoubleClick;
            case 3: return Trigger;
            case 4: return MiddleClick;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QSystemTrayIcon.ActivationReason> activated = new Signal1<com.trolltech.qt.gui.QSystemTrayIcon.ActivationReason>();

    @SuppressWarnings("unused")
    private final void activated(com.trolltech.qt.gui.QSystemTrayIcon.ActivationReason reason) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activated_ActivationReason(nativeId(), reason.value());
    }
    private native static void __qt_activated_ActivationReason(long __this__nativeId, int reason);

    public final Signal0 messageClicked = new Signal0();

    @SuppressWarnings("unused")
    private final void messageClicked() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_messageClicked(nativeId());
    }
    private native static void __qt_messageClicked(long __this__nativeId);


    public QSystemTrayIcon() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QSystemTrayIcon(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSystemTrayIcon_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSystemTrayIcon_QObject(long parent);



    public QSystemTrayIcon(com.trolltech.qt.gui.QIcon icon) {
        this(icon, (com.trolltech.qt.core.QObject)null);
    }
    public QSystemTrayIcon(com.trolltech.qt.gui.QIcon icon, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSystemTrayIcon_QIcon_QObject(icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSystemTrayIcon_QIcon_QObject(long icon, long parent);


    @QtBlockedSlot public final com.trolltech.qt.gui.QMenu contextMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contextMenu(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenu __qt_contextMenu(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect geometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_geometry(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_geometry(long __this__nativeId);

    public final void hide() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hide(nativeId());
    }
    private native static void __qt_hide(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="icon")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="visible")
    @com.trolltech.qt.QtPropertyOrder(2)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final boolean isVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isVisible(nativeId());
    }
    private native static boolean __qt_isVisible(long __this__nativeId);

    @QtBlockedSlot public final void setContextMenu(com.trolltech.qt.gui.QMenu menu) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcContextMenu = menu;
        }
        __qt_setContextMenu_QMenu(nativeId(), menu == null ? 0 : menu.nativeId());
    }
    private native static void __qt_setContextMenu_QMenu(long __this__nativeId, long menu);

    @com.trolltech.qt.QtPropertyWriter(name="icon")
    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @com.trolltech.qt.QtPropertyWriter(name="toolTip")
    @QtBlockedSlot public final void setToolTip(java.lang.String tip) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_String(nativeId(), tip);
    }
    private native static void __qt_setToolTip_String(long __this__nativeId, java.lang.String tip);

    @com.trolltech.qt.QtPropertyWriter(name="visible")
    public final void setVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setVisible_boolean(long __this__nativeId, boolean visible);

    public final void show() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_show(nativeId());
    }
    private native static void __qt_show(long __this__nativeId);


    @QtBlockedSlot public final void showMessage(java.lang.String title, java.lang.String msg, com.trolltech.qt.gui.QSystemTrayIcon.MessageIcon icon) {
        showMessage(title, msg, icon, (int)10000);
    }

    @QtBlockedSlot public final void showMessage(java.lang.String title, java.lang.String msg) {
        showMessage(title, msg, com.trolltech.qt.gui.QSystemTrayIcon.MessageIcon.Information, (int)10000);
    }
    @QtBlockedSlot public final void showMessage(java.lang.String title, java.lang.String msg, com.trolltech.qt.gui.QSystemTrayIcon.MessageIcon icon, int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showMessage_String_String_MessageIcon_int(nativeId(), title, msg, icon.value(), msecs);
    }
    private native static void __qt_showMessage_String_String_MessageIcon_int(long __this__nativeId, java.lang.String title, java.lang.String msg, int icon, int msecs);

    @com.trolltech.qt.QtPropertyReader(name="toolTip")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final java.lang.String toolTip() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip(nativeId());
    }
    private native static java.lang.String __qt_toolTip(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    public native static boolean isSystemTrayAvailable();

    public native static boolean supportsMessages();


    public static native QSystemTrayIcon fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QSystemTrayIcon(QPrivateConstructor p) { super(p); } 

}
