package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTabBar extends com.trolltech.qt.gui.QWidget
{
    public enum Shape implements com.trolltech.qt.QtEnumerator {
        RoundedNorth(0),
        RoundedSouth(1),
        RoundedWest(2),
        RoundedEast(3),
        TriangularNorth(4),
        TriangularSouth(5),
        TriangularWest(6),
        TriangularEast(7);

        Shape(int value) { this.value = value; }
        public int value() { return value; }

        public static Shape resolve(int value) {
            return (Shape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return RoundedNorth;
            case 1: return RoundedSouth;
            case 2: return RoundedWest;
            case 3: return RoundedEast;
            case 4: return TriangularNorth;
            case 5: return TriangularSouth;
            case 6: return TriangularWest;
            case 7: return TriangularEast;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> currentChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void currentChanged(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_int(nativeId(), index);
    }
    private native static void __qt_currentChanged_int(long __this__nativeId, int index);


    public QTabBar() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QTabBar(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QTabBar_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTabBar_QWidget(long parent);


    @QtBlockedSlot public final int addTab(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addTab_String(nativeId(), text);
    }
    private native static int __qt_addTab_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final int addTab(com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addTab_QIcon_String(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text);
    }
    private native static int __qt_addTab_QIcon_String(long __this__nativeId, long icon, java.lang.String text);

    @com.trolltech.qt.QtPropertyReader(name="count")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int count() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentIndex")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int currentIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentIndex(nativeId());
    }
    private native static int __qt_currentIndex(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="drawBase")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean drawBase() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_drawBase(nativeId());
    }
    private native static boolean __qt_drawBase(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="elideMode")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextElideMode elideMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.TextElideMode.resolve(__qt_elideMode(nativeId()));
    }
    private native static int __qt_elideMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="iconSize")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option, int tabIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer_int(nativeId(), option, tabIndex);
    }
    private native static void __qt_initStyleOption_nativepointer_int(long __this__nativeId, com.trolltech.qt.QNativePointer option, int tabIndex);

    @QtBlockedSlot public final int insertTab(int index, com.trolltech.qt.gui.QIcon icon, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTab_int_QIcon_String(nativeId(), index, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), text);
    }
    private native static int __qt_insertTab_int_QIcon_String(long __this__nativeId, int index, long icon, java.lang.String text);

    @QtBlockedSlot public final int insertTab(int index, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTab_int_String(nativeId(), index, text);
    }
    private native static int __qt_insertTab_int_String(long __this__nativeId, int index, java.lang.String text);

    @QtBlockedSlot public final boolean isTabEnabled(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTabEnabled_int(nativeId(), index);
    }
    private native static boolean __qt_isTabEnabled_int(long __this__nativeId, int index);

    @QtBlockedSlot public final void removeTab(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeTab_int(nativeId(), index);
    }
    private native static void __qt_removeTab_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyWriter(name="currentIndex")
    public final void setCurrentIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentIndex_int(nativeId(), index);
    }
    private native static void __qt_setCurrentIndex_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyWriter(name="drawBase")
    @QtBlockedSlot public final void setDrawBase(boolean drawTheBase) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDrawBase_boolean(nativeId(), drawTheBase);
    }
    private native static void __qt_setDrawBase_boolean(long __this__nativeId, boolean drawTheBase);

    @com.trolltech.qt.QtPropertyWriter(name="elideMode")
    @QtBlockedSlot public final void setElideMode(com.trolltech.qt.core.Qt.TextElideMode arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setElideMode_TextElideMode(nativeId(), arg__1.value());
    }
    private native static void __qt_setElideMode_TextElideMode(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="iconSize")
    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long size);

    @com.trolltech.qt.QtPropertyWriter(name="shape")
    @QtBlockedSlot public final void setShape(com.trolltech.qt.gui.QTabBar.Shape shape) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setShape_Shape(nativeId(), shape.value());
    }
    private native static void __qt_setShape_Shape(long __this__nativeId, int shape);

    @QtBlockedSlot public final void setTabData(int index, java.lang.Object data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabData_int_Object(nativeId(), index, data);
    }
    private native static void __qt_setTabData_int_Object(long __this__nativeId, int index, java.lang.Object data);

    @QtBlockedSlot public final void setTabEnabled(int index, boolean arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabEnabled_int_boolean(nativeId(), index, arg__2);
    }
    private native static void __qt_setTabEnabled_int_boolean(long __this__nativeId, int index, boolean arg__2);

    @QtBlockedSlot public final void setTabIcon(int index, com.trolltech.qt.gui.QIcon icon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabIcon_int_QIcon(nativeId(), index, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setTabIcon_int_QIcon(long __this__nativeId, int index, long icon);

    @QtBlockedSlot public final void setTabText(int index, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabText_int_String(nativeId(), index, text);
    }
    private native static void __qt_setTabText_int_String(long __this__nativeId, int index, java.lang.String text);

    @QtBlockedSlot public final void setTabTextColor(int index, com.trolltech.qt.gui.QColor color) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabTextColor_int_QColor(nativeId(), index, color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setTabTextColor_int_QColor(long __this__nativeId, int index, long color);

    @QtBlockedSlot public final void setTabToolTip(int index, java.lang.String tip) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabToolTip_int_String(nativeId(), index, tip);
    }
    private native static void __qt_setTabToolTip_int_String(long __this__nativeId, int index, java.lang.String tip);

    @QtBlockedSlot public final void setTabWhatsThis(int index, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabWhatsThis_int_String(nativeId(), index, text);
    }
    private native static void __qt_setTabWhatsThis_int_String(long __this__nativeId, int index, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="usesScrollButtons")
    @QtBlockedSlot public final void setUsesScrollButtons(boolean useButtons) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUsesScrollButtons_boolean(nativeId(), useButtons);
    }
    private native static void __qt_setUsesScrollButtons_boolean(long __this__nativeId, boolean useButtons);

    @com.trolltech.qt.QtPropertyReader(name="shape")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QTabBar.Shape shape() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabBar.Shape.resolve(__qt_shape(nativeId()));
    }
    private native static int __qt_shape(long __this__nativeId);

    @QtBlockedSlot public final int tabAt(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabAt_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static int __qt_tabAt_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final java.lang.Object tabData(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabData_int(nativeId(), index);
    }
    private native static java.lang.Object __qt_tabData_int(long __this__nativeId, int index);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon tabIcon(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabIcon_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QIcon __qt_tabIcon_int(long __this__nativeId, int index);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect tabRect(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabRect_int(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QRect __qt_tabRect_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String tabText(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabText_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabText_int(long __this__nativeId, int index);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor tabTextColor(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabTextColor_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QColor __qt_tabTextColor_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String tabToolTip(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabToolTip_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabToolTip_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String tabWhatsThis(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabWhatsThis_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabWhatsThis_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyReader(name="usesScrollButtons")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final boolean usesScrollButtons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_usesScrollButtons(nativeId());
    }
    private native static boolean __qt_usesScrollButtons(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void tabInserted(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabInserted_int(nativeId(), index);
    }
    private native static void __qt_tabInserted_int(long __this__nativeId, int index);

    @QtBlockedSlot protected void tabLayoutChange() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabLayoutChange(nativeId());
    }
    private native static void __qt_tabLayoutChange(long __this__nativeId);

    @QtBlockedSlot protected void tabRemoved(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabRemoved_int(nativeId(), index);
    }
    private native static void __qt_tabRemoved_int(long __this__nativeId, int index);

    @QtBlockedSlot protected com.trolltech.qt.core.QSize tabSizeHint(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabSizeHint_int(nativeId(), index);
    }
    private native static com.trolltech.qt.core.QSize __qt_tabSizeHint_int(long __this__nativeId, int index);


    public static native QTabBar fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTabBar(QPrivateConstructor p) { super(p); } 


        public final void initStyleOption(QStyleOptionTab option, int tabIndex) {
            initStyleOption(option.nativePointer(), tabIndex);
        }
    
}
