package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextDocument extends com.trolltech.qt.core.QObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ResourceType implements com.trolltech.qt.QtEnumerator {
        HtmlResource(1),
        ImageResource(2),
        StyleSheetResource(3),
        UserResource(100);

        ResourceType(int value) { this.value = value; }
        public int value() { return value; }

        public static ResourceType resolve(int value) {
            return (ResourceType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return HtmlResource;
            case 2: return ImageResource;
            case 3: return StyleSheetResource;
            case 100: return UserResource;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FindFlag implements com.trolltech.qt.QtEnumerator {
        FindBackward(1),
        FindCaseSensitively(2),
        FindWholeWords(4);

        FindFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static FindFlags createQFlags(FindFlag ... values) {
            return new FindFlags(values);
        }
        public static FindFlag resolve(int value) {
            return (FindFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return FindBackward;
            case 2: return FindCaseSensitively;
            case 4: return FindWholeWords;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FindFlags extends com.trolltech.qt.QFlags<FindFlag> {
        private static final long serialVersionUID = 1L;
        public FindFlags(FindFlag ... args) { super(args); }
        public FindFlags(int value) { setValue(value); }
    }

    public enum MetaInformation implements com.trolltech.qt.QtEnumerator {
        DocumentTitle(0);

        MetaInformation(int value) { this.value = value; }
        public int value() { return value; }

        public static MetaInformation resolve(int value) {
            return (MetaInformation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return DocumentTitle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> blockCountChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void blockCountChanged(int newBlockCount) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_blockCountChanged_int(nativeId(), newBlockCount);
    }
    private native static void __qt_blockCountChanged_int(long __this__nativeId, int newBlockCount);

    public final Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer> contentsChange = new Signal3<java.lang.Integer, java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void contentsChange(int from, int charsRemoves, int charsAdded) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contentsChange_int_int_int(nativeId(), from, charsRemoves, charsAdded);
    }
    private native static void __qt_contentsChange_int_int_int(long __this__nativeId, int from, int charsRemoves, int charsAdded);

    public final Signal0 contentsChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void contentsChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contentsChanged(nativeId());
    }
    private native static void __qt_contentsChanged(long __this__nativeId);

    public final Signal1<com.trolltech.qt.gui.QTextCursor> cursorPositionChanged = new Signal1<com.trolltech.qt.gui.QTextCursor>();

    @SuppressWarnings("unused")
    private final void cursorPositionChanged(com.trolltech.qt.gui.QTextCursor cursor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cursorPositionChanged_QTextCursor(nativeId(), cursor == null ? (cursor = new com.trolltech.qt.gui.QTextCursor()).nativeId() : cursor.nativeId());
    }
    private native static void __qt_cursorPositionChanged_QTextCursor(long __this__nativeId, long cursor);

    public final Signal1<java.lang.Boolean> modificationChanged = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void modificationChanged(boolean m) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_modificationChanged_boolean(nativeId(), m);
    }
    private native static void __qt_modificationChanged_boolean(long __this__nativeId, boolean m);

    public final Signal1<java.lang.Boolean> redoAvailable = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void redoAvailable(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_redoAvailable_boolean(nativeId(), arg__1);
    }
    private native static void __qt_redoAvailable_boolean(long __this__nativeId, boolean arg__1);

    public final Signal1<java.lang.Boolean> undoAvailable = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void undoAvailable(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_undoAvailable_boolean(nativeId(), arg__1);
    }
    private native static void __qt_undoAvailable_boolean(long __this__nativeId, boolean arg__1);


    public QTextDocument() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QTextDocument(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QTextDocument_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTextDocument_QObject(long parent);



    public QTextDocument(java.lang.String text) {
        this(text, (com.trolltech.qt.core.QObject)null);
    }
    public QTextDocument(java.lang.String text, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QTextDocument_String_QObject(text, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTextDocument_String_QObject(java.lang.String text, long parent);


    @QtBlockedSlot public final void addResource(int type, com.trolltech.qt.core.QUrl name, java.lang.Object resource) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addResource_int_QUrl_Object(nativeId(), type, name == null ? (name = new com.trolltech.qt.core.QUrl()).nativeId() : name.nativeId(), resource);
    }
    private native static void __qt_addResource_int_QUrl_Object(long __this__nativeId, int type, long name, java.lang.Object resource);

    @QtBlockedSlot public final void adjustSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_adjustSize(nativeId());
    }
    private native static void __qt_adjustSize(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QTextFormat> allFormats() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_allFormats(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QTextFormat> __qt_allFormats(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlock begin() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_begin(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextBlock __qt_begin(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="blockCount")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final int blockCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blockCount(nativeId());
    }
    private native static int __qt_blockCount(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTextDocument clone() {
        return clone((com.trolltech.qt.core.QObject)null);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextDocument clone(com.trolltech.qt.core.QObject parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clone_QObject(nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextDocument __qt_clone_QObject(long __this__nativeId, long parent);

    @com.trolltech.qt.QtPropertyReader(name="defaultFont")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFont defaultFont() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultFont(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_defaultFont(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="defaultStyleSheet")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final java.lang.String defaultStyleSheet() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultStyleSheet(nativeId());
    }
    private native static java.lang.String __qt_defaultStyleSheet(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextOption defaultTextOption() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultTextOption(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextOption __qt_defaultTextOption(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractTextDocumentLayout documentLayout() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_documentLayout(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractTextDocumentLayout __qt_documentLayout(long __this__nativeId);


    @QtBlockedSlot public final void drawContents(com.trolltech.qt.gui.QPainter painter) {
        drawContents(painter, (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF());
    }
    @QtBlockedSlot public final void drawContents(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRectF rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawContents_QPainter_QRectF(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawContents_QPainter_QRectF(long __this__nativeId, long painter, long rect);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlock end() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_end(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextBlock __qt_end(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, int from, com.trolltech.qt.gui.QTextDocument.FindFlag ... options) {
        return this.find(expr, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(options));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, int from) {
        return find(expr, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr) {
        return find(expr, (int)0, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, int from, com.trolltech.qt.gui.QTextDocument.FindFlags options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_find_QRegExp_int_FindFlags(nativeId(), expr == null ? (expr = new com.trolltech.qt.core.QRegExp()).nativeId() : expr.nativeId(), from, options.value());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_find_QRegExp_int_FindFlags(long __this__nativeId, long expr, int from, int options);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, com.trolltech.qt.gui.QTextCursor from, com.trolltech.qt.gui.QTextDocument.FindFlag ... options) {
        return this.find(expr, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(options));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, com.trolltech.qt.gui.QTextCursor from) {
        return find(expr, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(com.trolltech.qt.core.QRegExp expr, com.trolltech.qt.gui.QTextCursor from, com.trolltech.qt.gui.QTextDocument.FindFlags options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_find_QRegExp_QTextCursor_FindFlags(nativeId(), expr == null ? (expr = new com.trolltech.qt.core.QRegExp()).nativeId() : expr.nativeId(), from == null ? (from = new com.trolltech.qt.gui.QTextCursor()).nativeId() : from.nativeId(), options.value());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_find_QRegExp_QTextCursor_FindFlags(long __this__nativeId, long expr, long from, int options);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, int from, com.trolltech.qt.gui.QTextDocument.FindFlag ... options) {
        return this.find(subString, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(options));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, int from) {
        return find(subString, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString) {
        return find(subString, (int)0, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, int from, com.trolltech.qt.gui.QTextDocument.FindFlags options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_find_String_int_FindFlags(nativeId(), subString, from, options.value());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_find_String_int_FindFlags(long __this__nativeId, java.lang.String subString, int from, int options);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, com.trolltech.qt.gui.QTextCursor from, com.trolltech.qt.gui.QTextDocument.FindFlag ... options) {
        return this.find(subString, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(options));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, com.trolltech.qt.gui.QTextCursor from) {
        return find(subString, from, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor find(java.lang.String subString, com.trolltech.qt.gui.QTextCursor from, com.trolltech.qt.gui.QTextDocument.FindFlags options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_find_String_QTextCursor_FindFlags(nativeId(), subString, from == null ? (from = new com.trolltech.qt.gui.QTextCursor()).nativeId() : from.nativeId(), options.value());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_find_String_QTextCursor_FindFlags(long __this__nativeId, java.lang.String subString, long from, int options);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlock findBlock(int pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_findBlock_int(nativeId(), pos);
    }
    private native static com.trolltech.qt.gui.QTextBlock __qt_findBlock_int(long __this__nativeId, int pos);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrame frameAt(int pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameAt_int(nativeId(), pos);
    }
    private native static com.trolltech.qt.gui.QTextFrame __qt_frameAt_int(long __this__nativeId, int pos);

    @QtBlockedSlot public final double idealWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_idealWidth(nativeId());
    }
    private native static double __qt_idealWidth(long __this__nativeId);

    @QtBlockedSlot public final boolean isEmpty() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="modified")
    @com.trolltech.qt.QtPropertyOrder(1)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final boolean isModified() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isModified(nativeId());
    }
    private native static boolean __qt_isModified(long __this__nativeId);

    @QtBlockedSlot public final boolean isRedoAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRedoAvailable(nativeId());
    }
    private native static boolean __qt_isRedoAvailable(long __this__nativeId);

    @QtBlockedSlot public final boolean isUndoAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isUndoAvailable(nativeId());
    }
    private native static boolean __qt_isUndoAvailable(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="undoRedoEnabled")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isUndoRedoEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isUndoRedoEnabled(nativeId());
    }
    private native static boolean __qt_isUndoRedoEnabled(long __this__nativeId);

    @QtBlockedSlot public final void markContentsDirty(int from, int length) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_markContentsDirty_int_int(nativeId(), from, length);
    }
    private native static void __qt_markContentsDirty_int_int(long __this__nativeId, int from, int length);

    @com.trolltech.qt.QtPropertyReader(name="maximumBlockCount")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final int maximumBlockCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumBlockCount(nativeId());
    }
    private native static int __qt_maximumBlockCount(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String metaInformation(com.trolltech.qt.gui.QTextDocument.MetaInformation info) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metaInformation_MetaInformation(nativeId(), info.value());
    }
    private native static java.lang.String __qt_metaInformation_MetaInformation(long __this__nativeId, int info);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextObject object(int objectIndex) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_object_int(nativeId(), objectIndex);
    }
    private native static com.trolltech.qt.gui.QTextObject __qt_object_int(long __this__nativeId, int objectIndex);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextObject objectForFormat(com.trolltech.qt.gui.QTextFormat arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_objectForFormat_QTextFormat(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QTextFormat()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextObject __qt_objectForFormat_QTextFormat(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final int pageCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pageCount(nativeId());
    }
    private native static int __qt_pageCount(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="pageSize")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.core.QSizeF pageSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pageSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSizeF __qt_pageSize(long __this__nativeId);

    @QtBlockedSlot public final void print(com.trolltech.qt.gui.QPrinter printer) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_print_QPrinter(nativeId(), printer == null ? 0 : printer.nativeId());
    }
    private native static void __qt_print_QPrinter(long __this__nativeId, long printer);

    public final void redo() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_redo(nativeId());
    }
    private native static void __qt_redo(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void redo(com.trolltech.qt.QNativePointer cursor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_redo_nativepointer(nativeId(), cursor);
    }
    private native static void __qt_redo_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer cursor);

    @QtBlockedSlot public final java.lang.Object resource(int type, com.trolltech.qt.core.QUrl name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resource_int_QUrl(nativeId(), type, name == null ? (name = new com.trolltech.qt.core.QUrl()).nativeId() : name.nativeId());
    }
    private native static java.lang.Object __qt_resource_int_QUrl(long __this__nativeId, int type, long name);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrame rootFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rootFrame(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextFrame __qt_rootFrame(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="defaultFont")
    @QtBlockedSlot public final void setDefaultFont(com.trolltech.qt.gui.QFont font) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setDefaultFont_QFont(long __this__nativeId, long font);

    @com.trolltech.qt.QtPropertyWriter(name="defaultStyleSheet")
    @QtBlockedSlot public final void setDefaultStyleSheet(java.lang.String sheet) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultStyleSheet_String(nativeId(), sheet);
    }
    private native static void __qt_setDefaultStyleSheet_String(long __this__nativeId, java.lang.String sheet);

    @QtBlockedSlot public final void setDefaultTextOption(com.trolltech.qt.gui.QTextOption option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultTextOption_QTextOption(nativeId(), option == null ? (option = new com.trolltech.qt.gui.QTextOption()).nativeId() : option.nativeId());
    }
    private native static void __qt_setDefaultTextOption_QTextOption(long __this__nativeId, long option);

    @QtBlockedSlot public final void setDocumentLayout(com.trolltech.qt.gui.QAbstractTextDocumentLayout layout) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (layout != null) {
            layout.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDocumentLayout_QAbstractTextDocumentLayout(nativeId(), layout == null ? 0 : layout.nativeId());
    }
    private native static void __qt_setDocumentLayout_QAbstractTextDocumentLayout(long __this__nativeId, long layout);

    @QtBlockedSlot public final void setHtml(java.lang.String html) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHtml_String(nativeId(), html);
    }
    private native static void __qt_setHtml_String(long __this__nativeId, java.lang.String html);

    @com.trolltech.qt.QtPropertyWriter(name="maximumBlockCount")
    @QtBlockedSlot public final void setMaximumBlockCount(int maximum) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumBlockCount_int(nativeId(), maximum);
    }
    private native static void __qt_setMaximumBlockCount_int(long __this__nativeId, int maximum);

    @QtBlockedSlot public final void setMetaInformation(com.trolltech.qt.gui.QTextDocument.MetaInformation info, java.lang.String arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMetaInformation_MetaInformation_String(nativeId(), info.value(), arg__2);
    }
    private native static void __qt_setMetaInformation_MetaInformation_String(long __this__nativeId, int info, java.lang.String arg__2);


    public final void setModified() {
        setModified((boolean)true);
    }
    @com.trolltech.qt.QtPropertyWriter(name="modified")
    public final void setModified(boolean m) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModified_boolean(nativeId(), m);
    }
    private native static void __qt_setModified_boolean(long __this__nativeId, boolean m);

    @com.trolltech.qt.QtPropertyWriter(name="pageSize")
    @QtBlockedSlot public final void setPageSize(com.trolltech.qt.core.QSizeF size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPageSize_QSizeF(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSizeF()).nativeId() : size.nativeId());
    }
    private native static void __qt_setPageSize_QSizeF(long __this__nativeId, long size);

    @QtBlockedSlot public final void setPlainText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPlainText_String(nativeId(), text);
    }
    private native static void __qt_setPlainText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final void setTextWidth(double width) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextWidth_double(nativeId(), width);
    }
    private native static void __qt_setTextWidth_double(long __this__nativeId, double width);

    @com.trolltech.qt.QtPropertyWriter(name="undoRedoEnabled")
    @QtBlockedSlot public final void setUndoRedoEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUndoRedoEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setUndoRedoEnabled_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="useDesignMetrics")
    @QtBlockedSlot public final void setUseDesignMetrics(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUseDesignMetrics_boolean(nativeId(), b);
    }
    private native static void __qt_setUseDesignMetrics_boolean(long __this__nativeId, boolean b);

    @com.trolltech.qt.QtPropertyReader(name="size")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.QSizeF size() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSizeF __qt_size(long __this__nativeId);

    @QtBlockedSlot public final double textWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textWidth(nativeId());
    }
    private native static double __qt_textWidth(long __this__nativeId);


    @QtBlockedSlot public final java.lang.String toHtml() {
        return toHtml((com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }
    @QtBlockedSlot public final java.lang.String toHtml(com.trolltech.qt.core.QByteArray encoding) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toHtml_QByteArray(nativeId(), encoding == null ? (encoding = new com.trolltech.qt.core.QByteArray()).nativeId() : encoding.nativeId());
    }
    private native static java.lang.String __qt_toHtml_QByteArray(long __this__nativeId, long encoding);

    @QtBlockedSlot public final java.lang.String toPlainText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toPlainText(nativeId());
    }
    private native static java.lang.String __qt_toPlainText(long __this__nativeId);

    public final void undo() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_undo(nativeId());
    }
    private native static void __qt_undo(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void undo(com.trolltech.qt.QNativePointer cursor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_undo_nativepointer(nativeId(), cursor);
    }
    private native static void __qt_undo_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer cursor);

    @com.trolltech.qt.QtPropertyReader(name="useDesignMetrics")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final boolean useDesignMetrics() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_useDesignMetrics(nativeId());
    }
    private native static boolean __qt_useDesignMetrics(long __this__nativeId);

    @QtBlockedSlot public void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot protected com.trolltech.qt.gui.QTextObject createObject(com.trolltech.qt.gui.QTextFormat f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createObject_QTextFormat(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QTextFormat()).nativeId() : f.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextObject __qt_createObject_QTextFormat(long __this__nativeId, long f);

    @QtBlockedSlot protected java.lang.Object loadResource(int type, com.trolltech.qt.core.QUrl name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loadResource_int_QUrl(nativeId(), type, name == null ? (name = new com.trolltech.qt.core.QUrl()).nativeId() : name.nativeId());
    }
    private native static java.lang.Object __qt_loadResource_int_QUrl(long __this__nativeId, int type, long name);


    public static native QTextDocument fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTextDocument(QPrivateConstructor p) { super(p); } 


        public final void redo(QTextCursor cursor) {
            redo(cursor.nativePointer());
        }
    

        public final void undo(QTextCursor cursor) {
            undo(cursor.nativePointer());
        } 
    
}
