package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextFormat extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Property implements com.trolltech.qt.QtEnumerator {
        ObjectIndex(0),
        CssFloat(2048),
        LayoutDirection(2049),
        OutlinePen(2064),
        BackgroundBrush(2080),
        ForegroundBrush(2081),
        BlockAlignment(4112),
        BlockTopMargin(4144),
        BlockBottomMargin(4145),
        BlockLeftMargin(4146),
        BlockRightMargin(4147),
        TextIndent(4148),
        BlockIndent(4160),
        BlockNonBreakableLines(4176),
        BlockTrailingHorizontalRulerWidth(4192),
        FontFamily(8192),
        FontPointSize(8193),
        FontSizeAdjustment(8194),
        FontWeight(8195),
        FontItalic(8196),
        FontUnderline(8197),
        FontOverline(8198),
        FontStrikeOut(8199),
        FontFixedPitch(8200),
        FontPixelSize(8201),
        TextUnderlineColor(8208),
        TextVerticalAlignment(8225),
        TextOutline(8226),
        TextUnderlineStyle(8227),
        TextToolTip(8228),
        IsAnchor(8240),
        AnchorHref(8241),
        AnchorName(8242),
        ObjectType(12032),
        ListStyle(12288),
        ListIndent(12289),
        FrameBorder(16384),
        FrameMargin(16385),
        FramePadding(16386),
        FrameWidth(16387),
        FrameHeight(16388),
        FrameTopMargin(16389),
        FrameBottomMargin(16390),
        FrameLeftMargin(16391),
        FrameRightMargin(16392),
        FrameBorderBrush(16393),
        FrameBorderStyle(16400),
        TableColumns(16640),
        TableColumnWidthConstraints(16641),
        TableCellSpacing(16642),
        TableCellPadding(16643),
        TableHeaderRowCount(16644),
        TableCellRowSpan(18448),
        TableCellColumnSpan(18449),
        ImageName(20480),
        ImageWidth(20496),
        ImageHeight(20497),
        FullWidthSelection(24576),
        PageBreakPolicy(28672),
        UserProperty(1048576);

        Property(int value) { this.value = value; }
        public int value() { return value; }

        public static Property resolve(int value) {
            return (Property) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ObjectIndex;
            case 2048: return CssFloat;
            case 2049: return LayoutDirection;
            case 2064: return OutlinePen;
            case 2080: return BackgroundBrush;
            case 2081: return ForegroundBrush;
            case 4112: return BlockAlignment;
            case 4144: return BlockTopMargin;
            case 4145: return BlockBottomMargin;
            case 4146: return BlockLeftMargin;
            case 4147: return BlockRightMargin;
            case 4148: return TextIndent;
            case 4160: return BlockIndent;
            case 4176: return BlockNonBreakableLines;
            case 4192: return BlockTrailingHorizontalRulerWidth;
            case 8192: return FontFamily;
            case 8193: return FontPointSize;
            case 8194: return FontSizeAdjustment;
            case 8195: return FontWeight;
            case 8196: return FontItalic;
            case 8197: return FontUnderline;
            case 8198: return FontOverline;
            case 8199: return FontStrikeOut;
            case 8200: return FontFixedPitch;
            case 8201: return FontPixelSize;
            case 8208: return TextUnderlineColor;
            case 8225: return TextVerticalAlignment;
            case 8226: return TextOutline;
            case 8227: return TextUnderlineStyle;
            case 8228: return TextToolTip;
            case 8240: return IsAnchor;
            case 8241: return AnchorHref;
            case 8242: return AnchorName;
            case 12032: return ObjectType;
            case 12288: return ListStyle;
            case 12289: return ListIndent;
            case 16384: return FrameBorder;
            case 16385: return FrameMargin;
            case 16386: return FramePadding;
            case 16387: return FrameWidth;
            case 16388: return FrameHeight;
            case 16389: return FrameTopMargin;
            case 16390: return FrameBottomMargin;
            case 16391: return FrameLeftMargin;
            case 16392: return FrameRightMargin;
            case 16393: return FrameBorderBrush;
            case 16400: return FrameBorderStyle;
            case 16640: return TableColumns;
            case 16641: return TableColumnWidthConstraints;
            case 16642: return TableCellSpacing;
            case 16643: return TableCellPadding;
            case 16644: return TableHeaderRowCount;
            case 18448: return TableCellRowSpan;
            case 18449: return TableCellColumnSpan;
            case 20480: return ImageName;
            case 20496: return ImageWidth;
            case 20497: return ImageHeight;
            case 24576: return FullWidthSelection;
            case 28672: return PageBreakPolicy;
            case 1048576: return UserProperty;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FormatType implements com.trolltech.qt.QtEnumerator {
        InvalidFormat(-1),
        BlockFormat(1),
        CharFormat(2),
        ListFormat(3),
        TableFormat(4),
        FrameFormat(5),
        UserFormat(100);

        FormatType(int value) { this.value = value; }
        public int value() { return value; }

        public static FormatType resolve(int value) {
            return (FormatType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return InvalidFormat;
            case 1: return BlockFormat;
            case 2: return CharFormat;
            case 3: return ListFormat;
            case 4: return TableFormat;
            case 5: return FrameFormat;
            case 100: return UserFormat;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ObjectTypes implements com.trolltech.qt.QtEnumerator {
        NoObject(0),
        ImageObject(1),
        TableObject(2),
        UserObject(4096);

        ObjectTypes(int value) { this.value = value; }
        public int value() { return value; }

        public static ObjectTypes resolve(int value) {
            return (ObjectTypes) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoObject;
            case 1: return ImageObject;
            case 2: return TableObject;
            case 4096: return UserObject;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PageBreakFlag implements com.trolltech.qt.QtEnumerator {
        PageBreak_Auto(0),
        PageBreak_AlwaysBefore(1),
        PageBreak_AlwaysAfter(16);

        PageBreakFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static PageBreakFlags createQFlags(PageBreakFlag ... values) {
            return new PageBreakFlags(values);
        }
        public static PageBreakFlag resolve(int value) {
            return (PageBreakFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return PageBreak_Auto;
            case 1: return PageBreak_AlwaysBefore;
            case 16: return PageBreak_AlwaysAfter;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class PageBreakFlags extends com.trolltech.qt.QFlags<PageBreakFlag> {
        private static final long serialVersionUID = 1L;
        public PageBreakFlags(PageBreakFlag ... args) { super(args); }
        public PageBreakFlags(int value) { setValue(value); }
    }


    public QTextFormat(com.trolltech.qt.gui.QTextFormat rhs) {
        super((QPrivateConstructor)null);
        __qt_QTextFormat_QTextFormat(rhs == null ? (rhs = new com.trolltech.qt.gui.QTextFormat()).nativeId() : rhs.nativeId());
    }
    private native void __qt_QTextFormat_QTextFormat(long rhs);


    public QTextFormat() {
        super((QPrivateConstructor)null);
        __qt_QTextFormat();
    }
    private native void __qt_QTextFormat();


    public QTextFormat(int type) {
        super((QPrivateConstructor)null);
        __qt_QTextFormat_int(type);
    }
    private native void __qt_QTextFormat_int(int type);


    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    @QtBlockedSlot public final boolean boolProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boolProperty_int(nativeId(), propertyId);
    }
    private native static boolean __qt_boolProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush brushProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brushProperty_int(nativeId(), propertyId);
    }
    private native static com.trolltech.qt.gui.QBrush __qt_brushProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final void clearBackground() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearBackground(nativeId());
    }
    private native static void __qt_clearBackground(long __this__nativeId);

    @QtBlockedSlot public final void clearForeground() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearForeground(nativeId());
    }
    private native static void __qt_clearForeground(long __this__nativeId);

    @QtBlockedSlot public final void clearProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearProperty_int(nativeId(), propertyId);
    }
    private native static void __qt_clearProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor colorProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_colorProperty_int(nativeId(), propertyId);
    }
    private native static com.trolltech.qt.gui.QColor __qt_colorProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final double doubleProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_doubleProperty_int(nativeId(), propertyId);
    }
    private native static double __qt_doubleProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foreground() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foreground(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foreground(long __this__nativeId);

    @QtBlockedSlot public final boolean hasProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasProperty_int(nativeId(), propertyId);
    }
    private native static boolean __qt_hasProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final int intProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intProperty_int(nativeId(), propertyId);
    }
    private native static int __qt_intProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final boolean isBlockFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isBlockFormat(nativeId());
    }
    private native static boolean __qt_isBlockFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean isCharFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCharFormat(nativeId());
    }
    private native static boolean __qt_isCharFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean isFrameFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFrameFormat(nativeId());
    }
    private native static boolean __qt_isFrameFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean isImageFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isImageFormat(nativeId());
    }
    private native static boolean __qt_isImageFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean isListFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isListFormat(nativeId());
    }
    private native static boolean __qt_isListFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean isTableFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTableFormat(nativeId());
    }
    private native static boolean __qt_isTableFormat(long __this__nativeId);

    @QtBlockedSlot public boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.LayoutDirection layoutDirection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_layoutDirection(nativeId()));
    }
    private native static int __qt_layoutDirection(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLength lengthProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lengthProperty_int(nativeId(), propertyId);
    }
    private native static com.trolltech.qt.gui.QTextLength __qt_lengthProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QTextLength> lengthVectorProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lengthVectorProperty_int(nativeId(), propertyId);
    }
    private native static java.util.List<com.trolltech.qt.gui.QTextLength> __qt_lengthVectorProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final void merge(com.trolltech.qt.gui.QTextFormat other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_merge_QTextFormat(nativeId(), other == null ? (other = new com.trolltech.qt.gui.QTextFormat()).nativeId() : other.nativeId());
    }
    private native static void __qt_merge_QTextFormat(long __this__nativeId, long other);

    @QtBlockedSlot public final int objectIndex() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_objectIndex(nativeId());
    }
    private native static int __qt_objectIndex(long __this__nativeId);

    @QtBlockedSlot public final int objectType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_objectType(nativeId());
    }
    private native static int __qt_objectType(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QTextFormat rhs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QTextFormat(nativeId(), rhs == null ? (rhs = new com.trolltech.qt.gui.QTextFormat()).nativeId() : rhs.nativeId());
    }
    private native static boolean __qt_operator_equal_QTextFormat(long __this__nativeId, long rhs);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPen penProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_penProperty_int(nativeId(), propertyId);
    }
    private native static com.trolltech.qt.gui.QPen __qt_penProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final java.util.SortedMap<java.lang.Integer, java.lang.Object> properties() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_properties(nativeId());
    }
    private native static java.util.SortedMap<java.lang.Integer, java.lang.Object> __qt_properties(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object property(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_property_int(nativeId(), propertyId);
    }
    private native static java.lang.Object __qt_property_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final int propertyCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_propertyCount(nativeId());
    }
    private native static int __qt_propertyCount(long __this__nativeId);

    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setForeground(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForeground_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForeground_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setLayoutDirection(com.trolltech.qt.core.Qt.LayoutDirection direction) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLayoutDirection_LayoutDirection(nativeId(), direction.value());
    }
    private native static void __qt_setLayoutDirection_LayoutDirection(long __this__nativeId, int direction);

    @QtBlockedSlot public final void setObjectIndex(int object) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setObjectIndex_int(nativeId(), object);
    }
    private native static void __qt_setObjectIndex_int(long __this__nativeId, int object);

    @QtBlockedSlot public final void setObjectType(int type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setObjectType_int(nativeId(), type);
    }
    private native static void __qt_setObjectType_int(long __this__nativeId, int type);

    @QtBlockedSlot public final void setProperty(int propertyId, java.util.List<com.trolltech.qt.gui.QTextLength> lengths) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProperty_int_List(nativeId(), propertyId, lengths);
    }
    private native static void __qt_setProperty_int_List(long __this__nativeId, int propertyId, java.util.List<com.trolltech.qt.gui.QTextLength> lengths);

    @QtBlockedSlot public final void setProperty(int propertyId, java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProperty_int_Object(nativeId(), propertyId, value);
    }
    private native static void __qt_setProperty_int_Object(long __this__nativeId, int propertyId, java.lang.Object value);

    @QtBlockedSlot public final java.lang.String stringProperty(int propertyId) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stringProperty_int(nativeId(), propertyId);
    }
    private native static java.lang.String __qt_stringProperty_int(long __this__nativeId, int propertyId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlockFormat toBlockFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toBlockFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextBlockFormat __qt_toBlockFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat toCharFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toCharFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_toCharFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrameFormat toFrameFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toFrameFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextFrameFormat __qt_toFrameFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextImageFormat toImageFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toImageFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextImageFormat __qt_toImageFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextListFormat toListFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toListFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextListFormat __qt_toListFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextTableFormat toTableFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toTableFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextTableFormat __qt_toTableFormat(long __this__nativeId);

    @QtBlockedSlot public final int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);


    public static native QTextFormat fromNativePointer(QNativePointer nativePointer);

    protected QTextFormat(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextFormat array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QTextFormat)
            return operator_equal((com.trolltech.qt.gui.QTextFormat) other);
        return false;
    }

}
