package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextItem extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum RenderFlag implements com.trolltech.qt.QtEnumerator {
        RightToLeft(1),
        Overline(16),
        Underline(32),
        StrikeOut(64),
        Dummy(-1);

        RenderFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static RenderFlags createQFlags(RenderFlag ... values) {
            return new RenderFlags(values);
        }
        public static RenderFlag resolve(int value) {
            return (RenderFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return RightToLeft;
            case 16: return Overline;
            case 32: return Underline;
            case 64: return StrikeOut;
            case -1: return Dummy;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class RenderFlags extends com.trolltech.qt.QFlags<RenderFlag> {
        private static final long serialVersionUID = 1L;
        public RenderFlags(RenderFlag ... args) { super(args); }
        public RenderFlags(int value) { setValue(value); }
    }


    public QTextItem() {
        super((QPrivateConstructor)null);
        __qt_QTextItem();
    }
    private native void __qt_QTextItem();


    @QtBlockedSlot public final double ascent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ascent(nativeId());
    }
    private native static double __qt_ascent(long __this__nativeId);

    @QtBlockedSlot public final double descent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_descent(nativeId());
    }
    private native static double __qt_descent(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextItem.RenderFlags renderFlags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QTextItem.RenderFlags(__qt_renderFlags(nativeId()));
    }
    private native static int __qt_renderFlags(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final double width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static double __qt_width(long __this__nativeId);


    public static native QTextItem fromNativePointer(QNativePointer nativePointer);

    protected QTextItem(QPrivateConstructor p) { super(p); } 

}
