package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextOption extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Flag implements com.trolltech.qt.QtEnumerator {
        IncludeTrailingSpaces(-2147483648);

        Flag(int value) { this.value = value; }
        public int value() { return value; }

        public static Flags createQFlags(Flag ... values) {
            return new Flags(values);
        }
        public static Flag resolve(int value) {
            return (Flag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -2147483648: return IncludeTrailingSpaces;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Flags extends com.trolltech.qt.QFlags<Flag> {
        private static final long serialVersionUID = 1L;
        public Flags(Flag ... args) { super(args); }
        public Flags(int value) { setValue(value); }
    }

    public enum WrapMode implements com.trolltech.qt.QtEnumerator {
        NoWrap(0),
        WordWrap(1),
        ManualWrap(2),
        WrapAnywhere(3),
        WrapAtWordBoundaryOrAnywhere(4);

        WrapMode(int value) { this.value = value; }
        public int value() { return value; }

        public static WrapMode resolve(int value) {
            return (WrapMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoWrap;
            case 1: return WordWrap;
            case 2: return ManualWrap;
            case 3: return WrapAnywhere;
            case 4: return WrapAtWordBoundaryOrAnywhere;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextOption(com.trolltech.qt.gui.QTextOption o) {
        super((QPrivateConstructor)null);
        __qt_QTextOption_QTextOption(o == null ? (o = new com.trolltech.qt.gui.QTextOption()).nativeId() : o.nativeId());
    }
    private native void __qt_QTextOption_QTextOption(long o);


    public QTextOption() {
        super((QPrivateConstructor)null);
        __qt_QTextOption();
    }
    private native void __qt_QTextOption();


    public QTextOption(com.trolltech.qt.core.Qt.Alignment alignment) {
        super((QPrivateConstructor)null);
        __qt_QTextOption_Alignment(alignment.value());
    }
    private native void __qt_QTextOption_Alignment(int alignment);


    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment alignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_alignment(nativeId()));
    }
    private native static int __qt_alignment(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextOption.Flags flags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QTextOption.Flags(__qt_flags(nativeId()));
    }
    private native static int __qt_flags(long __this__nativeId);


    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.setAlignment(new com.trolltech.qt.core.Qt.Alignment(alignment));
    }
    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.Alignment alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlignment_Alignment(nativeId(), alignment.value());
    }
    private native static void __qt_setAlignment_Alignment(long __this__nativeId, int alignment);


    @QtBlockedSlot public final void setFlags(com.trolltech.qt.gui.QTextOption.Flag ... flags) {
        this.setFlags(new com.trolltech.qt.gui.QTextOption.Flags(flags));
    }
    @QtBlockedSlot public final void setFlags(com.trolltech.qt.gui.QTextOption.Flags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFlags_Flags(nativeId(), flags.value());
    }
    private native static void __qt_setFlags_Flags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setTabArray(java.util.List<java.lang.Double> tabStops) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabArray_List(nativeId(), tabStops);
    }
    private native static void __qt_setTabArray_List(long __this__nativeId, java.util.List<java.lang.Double> tabStops);

    @QtBlockedSlot public final void setTabStop(double tabStop) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabStop_double(nativeId(), tabStop);
    }
    private native static void __qt_setTabStop_double(long __this__nativeId, double tabStop);

    @QtBlockedSlot public final void setTextDirection(com.trolltech.qt.core.Qt.LayoutDirection aDirection) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextDirection_LayoutDirection(nativeId(), aDirection.value());
    }
    private native static void __qt_setTextDirection_LayoutDirection(long __this__nativeId, int aDirection);

    @QtBlockedSlot public final void setUseDesignMetrics(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUseDesignMetrics_boolean(nativeId(), b);
    }
    private native static void __qt_setUseDesignMetrics_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public final void setWrapMode(com.trolltech.qt.gui.QTextOption.WrapMode wrap) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWrapMode_WrapMode(nativeId(), wrap.value());
    }
    private native static void __qt_setWrapMode_WrapMode(long __this__nativeId, int wrap);

    @QtBlockedSlot public final java.util.List<java.lang.Double> tabArray() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabArray(nativeId());
    }
    private native static java.util.List<java.lang.Double> __qt_tabArray(long __this__nativeId);

    @QtBlockedSlot public final double tabStop() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabStop(nativeId());
    }
    private native static double __qt_tabStop(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.LayoutDirection textDirection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_textDirection(nativeId()));
    }
    private native static int __qt_textDirection(long __this__nativeId);

    @QtBlockedSlot public final boolean useDesignMetrics() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_useDesignMetrics(nativeId());
    }
    private native static boolean __qt_useDesignMetrics(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextOption.WrapMode wrapMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextOption.WrapMode.resolve(__qt_wrapMode(nativeId()));
    }
    private native static int __qt_wrapMode(long __this__nativeId);


    public static native QTextOption fromNativePointer(QNativePointer nativePointer);

    protected QTextOption(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextOption array[]);
}
