package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTreeWidgetItem extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ItemType implements com.trolltech.qt.QtEnumerator {
        Type(0),
        UserType(1000);

        ItemType(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemType resolve(int value) {
            return (ItemType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Type;
            case 1000: return UserType;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ChildIndicatorPolicy implements com.trolltech.qt.QtEnumerator {
        ShowIndicator(0),
        DontShowIndicator(1),
        DontShowIndicatorWhenChildless(2);

        ChildIndicatorPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static ChildIndicatorPolicy resolve(int value) {
            return (ChildIndicatorPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ShowIndicator;
            case 1: return DontShowIndicator;
            case 2: return DontShowIndicatorWhenChildless;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QTreeWidgetItem(java.util.List<java.lang.String> strings) {
        this(strings, (int)0);
    }
    public QTreeWidgetItem(java.util.List<java.lang.String> strings, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_List_int(strings, type);
    }
    private native void __qt_QTreeWidgetItem_List_int(java.util.List<java.lang.String> strings, int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view, java.util.List<java.lang.String> strings) {
        this(view, strings, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view, java.util.List<java.lang.String> strings, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidget_List_int(view == null ? 0 : view.nativeId(), strings, type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidget_List_int(long view, java.util.List<java.lang.String> strings, int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent, java.util.List<java.lang.String> strings) {
        this(parent, strings, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent, java.util.List<java.lang.String> strings, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidgetItem_List_int(parent == null ? 0 : parent.nativeId(), strings, type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidgetItem_List_int(long parent, java.util.List<java.lang.String> strings, int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view, com.trolltech.qt.gui.QTreeWidgetItem after) {
        this(view, after, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view, com.trolltech.qt.gui.QTreeWidgetItem after, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidget_QTreeWidgetItem_int(view == null ? 0 : view.nativeId(), after == null ? 0 : after.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidget_QTreeWidgetItem_int(long view, long after, int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent, com.trolltech.qt.gui.QTreeWidgetItem after) {
        this(parent, after, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent, com.trolltech.qt.gui.QTreeWidgetItem after, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidgetItem_QTreeWidgetItem_int(parent == null ? 0 : parent.nativeId(), after == null ? 0 : after.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidgetItem_QTreeWidgetItem_int(long parent, long after, int type);



    public QTreeWidgetItem() {
        this((int)0);
    }
    public QTreeWidgetItem(int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_int(type);
    }
    private native void __qt_QTreeWidgetItem_int(int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent) {
        this(parent, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidgetItem parent, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidgetItem_int(parent == null ? 0 : parent.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidgetItem_int(long parent, int type);



    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view) {
        this(view, (int)0);
    }
    public QTreeWidgetItem(com.trolltech.qt.gui.QTreeWidget view, int type) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItem_QTreeWidget_int(view == null ? 0 : view.nativeId(), type);
        this.disableGarbageCollection();
    }
    private native void __qt_QTreeWidgetItem_QTreeWidget_int(long view, int type);


    @QtBlockedSlot public final void addChild(com.trolltech.qt.gui.QTreeWidgetItem child) {
        if (child != null) {
            child.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addChild_QTreeWidgetItem(nativeId(), child == null ? 0 : child.nativeId());
    }
    private native static void __qt_addChild_QTreeWidgetItem(long __this__nativeId, long child);

    @QtBlockedSlot public final void addChildren(java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> children) {
        if (children != null) {
            for (com.trolltech.qt.gui.QTreeWidgetItem i : children)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addChildren_List(nativeId(), children);
    }
    private native static void __qt_addChildren_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> children);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background_int(nativeId(), column);
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.CheckState checkState(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.CheckState.resolve(__qt_checkState_int(nativeId(), column));
    }
    private native static int __qt_checkState_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTreeWidgetItem child(int index) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_child_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QTreeWidgetItem __qt_child_int(long __this__nativeId, int index);

    @QtBlockedSlot public final int childCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childCount(nativeId());
    }
    private native static int __qt_childCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTreeWidgetItem.ChildIndicatorPolicy childIndicatorPolicy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTreeWidgetItem.ChildIndicatorPolicy.resolve(__qt_childIndicatorPolicy(nativeId()));
    }
    private native static int __qt_childIndicatorPolicy(long __this__nativeId);

    @QtBlockedSlot public final int columnCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnCount(nativeId());
    }
    private native static int __qt_columnCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ItemFlags flags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.ItemFlags(__qt_flags(nativeId()));
    }
    private native static int __qt_flags(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font_int(nativeId(), column);
    }
    private native static com.trolltech.qt.gui.QFont __qt_font_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush foreground(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_foreground_int(nativeId(), column);
    }
    private native static com.trolltech.qt.gui.QBrush __qt_foreground_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon_int(nativeId(), column);
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon_int(long __this__nativeId, int column);

    @QtBlockedSlot public final int indexOfChild(com.trolltech.qt.gui.QTreeWidgetItem child) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexOfChild_QTreeWidgetItem(nativeId(), child == null ? 0 : child.nativeId());
    }
    private native static int __qt_indexOfChild_QTreeWidgetItem(long __this__nativeId, long child);

    @QtBlockedSlot public final void insertChild(int index, com.trolltech.qt.gui.QTreeWidgetItem child) {
        if (child != null) {
            child.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertChild_int_QTreeWidgetItem(nativeId(), index, child == null ? 0 : child.nativeId());
    }
    private native static void __qt_insertChild_int_QTreeWidgetItem(long __this__nativeId, int index, long child);

    @QtBlockedSlot public final void insertChildren(int index, java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> children) {
        if (children != null) {
            for (com.trolltech.qt.gui.QTreeWidgetItem i : children)
                if (i != null) i.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertChildren_int_List(nativeId(), index, children);
    }
    private native static void __qt_insertChildren_int_List(long __this__nativeId, int index, java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> children);

    @QtBlockedSlot public final boolean isDisabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDisabled(nativeId());
    }
    private native static boolean __qt_isDisabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isExpanded() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isExpanded(nativeId());
    }
    private native static boolean __qt_isExpanded(long __this__nativeId);

    @QtBlockedSlot public final boolean isFirstColumnSpanned() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFirstColumnSpanned(nativeId());
    }
    private native static boolean __qt_isFirstColumnSpanned(long __this__nativeId);

    @QtBlockedSlot public final boolean isHidden() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isHidden(nativeId());
    }
    private native static boolean __qt_isHidden(long __this__nativeId);

    @QtBlockedSlot public final boolean isSelected() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelected(nativeId());
    }
    private native static boolean __qt_isSelected(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long out);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTreeWidgetItem parent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parent(nativeId());
    }
    private native static com.trolltech.qt.gui.QTreeWidgetItem __qt_parent(long __this__nativeId);

    @QtBlockedSlot public final void removeChild(com.trolltech.qt.gui.QTreeWidgetItem child) {
        if (child != null) {
            child.reenableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeChild_QTreeWidgetItem(nativeId(), child == null ? 0 : child.nativeId());
    }
    private native static void __qt_removeChild_QTreeWidgetItem(long __this__nativeId, long child);

    @QtBlockedSlot public final void setBackground(int column, com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_int_QBrush(nativeId(), column, brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBackground_int_QBrush(long __this__nativeId, int column, long brush);

    @QtBlockedSlot public final void setCheckState(int column, com.trolltech.qt.core.Qt.CheckState state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCheckState_int_CheckState(nativeId(), column, state.value());
    }
    private native static void __qt_setCheckState_int_CheckState(long __this__nativeId, int column, int state);

    @QtBlockedSlot public final void setChildIndicatorPolicy(com.trolltech.qt.gui.QTreeWidgetItem.ChildIndicatorPolicy policy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setChildIndicatorPolicy_ChildIndicatorPolicy(nativeId(), policy.value());
    }
    private native static void __qt_setChildIndicatorPolicy_ChildIndicatorPolicy(long __this__nativeId, int policy);

    @QtBlockedSlot public final void setDisabled(boolean disabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDisabled_boolean(nativeId(), disabled);
    }
    private native static void __qt_setDisabled_boolean(long __this__nativeId, boolean disabled);

    @QtBlockedSlot public final void setExpanded(boolean expand) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setExpanded_boolean(nativeId(), expand);
    }
    private native static void __qt_setExpanded_boolean(long __this__nativeId, boolean expand);

    @QtBlockedSlot public final void setFirstColumnSpanned(boolean span) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFirstColumnSpanned_boolean(nativeId(), span);
    }
    private native static void __qt_setFirstColumnSpanned_boolean(long __this__nativeId, boolean span);


    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlag ... flags) {
        this.setFlags(new com.trolltech.qt.core.Qt.ItemFlags(flags));
    }
    @QtBlockedSlot public final void setFlags(com.trolltech.qt.core.Qt.ItemFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFlags_ItemFlags(nativeId(), flags.value());
    }
    private native static void __qt_setFlags_ItemFlags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setFont(int column, com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_int_QFont(nativeId(), column, font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_int_QFont(long __this__nativeId, int column, long font);

    @QtBlockedSlot public final void setForeground(int column, com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForeground_int_QBrush(nativeId(), column, brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setForeground_int_QBrush(long __this__nativeId, int column, long brush);

    @QtBlockedSlot public final void setHidden(boolean hide) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHidden_boolean(nativeId(), hide);
    }
    private native static void __qt_setHidden_boolean(long __this__nativeId, boolean hide);

    @QtBlockedSlot public final void setIcon(int column, com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_int_QIcon(nativeId(), column, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_int_QIcon(long __this__nativeId, int column, long icon);

    @QtBlockedSlot public final void setSelected(boolean select) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelected_boolean(nativeId(), select);
    }
    private native static void __qt_setSelected_boolean(long __this__nativeId, boolean select);

    @QtBlockedSlot public final void setSizeHint(int column, com.trolltech.qt.core.QSize size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeHint_int_QSize(nativeId(), column, size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setSizeHint_int_QSize(long __this__nativeId, int column, long size);

    @QtBlockedSlot public final void setStatusTip(int column, java.lang.String statusTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusTip_int_String(nativeId(), column, statusTip);
    }
    private native static void __qt_setStatusTip_int_String(long __this__nativeId, int column, java.lang.String statusTip);

    @QtBlockedSlot public final void setText(int column, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_int_String(nativeId(), column, text);
    }
    private native static void __qt_setText_int_String(long __this__nativeId, int column, java.lang.String text);

    @QtBlockedSlot public final void setTextAlignment(int column, int alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_int_int(nativeId(), column, alignment);
    }
    private native static void __qt_setTextAlignment_int_int(long __this__nativeId, int column, int alignment);

    @QtBlockedSlot public final void setToolTip(int column, java.lang.String toolTip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_int_String(nativeId(), column, toolTip);
    }
    private native static void __qt_setToolTip_int_String(long __this__nativeId, int column, java.lang.String toolTip);

    @QtBlockedSlot public final void setWhatsThis(int column, java.lang.String whatsThis) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWhatsThis_int_String(nativeId(), column, whatsThis);
    }
    private native static void __qt_setWhatsThis_int_String(long __this__nativeId, int column, java.lang.String whatsThis);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize sizeHint(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint_int(nativeId(), column);
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint_int(long __this__nativeId, int column);

    @QtBlockedSlot public final void sortChildren(int column, com.trolltech.qt.core.Qt.SortOrder order) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sortChildren_int_SortOrder(nativeId(), column, order.value());
    }
    private native static void __qt_sortChildren_int_SortOrder(long __this__nativeId, int column, int order);

    @QtBlockedSlot public final java.lang.String statusTip(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusTip_int(nativeId(), column);
    }
    private native static java.lang.String __qt_statusTip_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTreeWidgetItem takeChild(int index) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        com.trolltech.qt.gui.QTreeWidgetItem __qt_return_value = __qt_takeChild_int(nativeId(), index);
        if (__qt_return_value != null) {
          __qt_return_value.reenableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static com.trolltech.qt.gui.QTreeWidgetItem __qt_takeChild_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> takeChildren() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> __qt_return_value = __qt_takeChildren(nativeId());
        if (__qt_return_value != null) {
            for (com.trolltech.qt.gui.QTreeWidgetItem i : __qt_return_value)
                if (i != null) i.reenableGarbageCollection();
        }
        return __qt_return_value;
    }
    private native static java.util.List<com.trolltech.qt.gui.QTreeWidgetItem> __qt_takeChildren(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String text(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text_int(nativeId(), column);
    }
    private native static java.lang.String __qt_text_int(long __this__nativeId, int column);

    @QtBlockedSlot public final int textAlignment(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textAlignment_int(nativeId(), column);
    }
    private native static int __qt_textAlignment_int(long __this__nativeId, int column);

    @QtBlockedSlot public final java.lang.String toolTip(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip_int(nativeId(), column);
    }
    private native static java.lang.String __qt_toolTip_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTreeWidget treeWidget() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_treeWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QTreeWidget __qt_treeWidget(long __this__nativeId);

    @QtBlockedSlot public final int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String whatsThis(int column) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_whatsThis_int(nativeId(), column);
    }
    private native static java.lang.String __qt_whatsThis_int(long __this__nativeId, int column);

    @QtBlockedSlot public com.trolltech.qt.gui.QTreeWidgetItem clone() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clone(nativeId());
    }
    private native static com.trolltech.qt.gui.QTreeWidgetItem __qt_clone(long __this__nativeId);

    @QtBlockedSlot public java.lang.Object data(int column, int role) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data_int_int(nativeId(), column, role);
    }
    private native static java.lang.Object __qt_data_int_int(long __this__nativeId, int column, int role);

    @SuppressWarnings("unused")
    @QtBlockedSlot private boolean operator_less(com.trolltech.qt.gui.QTreeWidgetItem other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QTreeWidgetItem(nativeId(), other == null ? 0 : other.nativeId());
    }
    private native static boolean __qt_operator_less_QTreeWidgetItem(long __this__nativeId, long other);

    @QtBlockedSlot public void read(com.trolltech.qt.core.QDataStream in) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_read_QDataStream(nativeId(), in == null ? 0 : in.nativeId());
    }
    private native static void __qt_read_QDataStream(long __this__nativeId, long in);

    @QtBlockedSlot public void setData(int column, int role, java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setData_int_int_Object(nativeId(), column, role, value);
    }
    private native static void __qt_setData_int_int_Object(long __this__nativeId, int column, int role, java.lang.Object value);

    @QtBlockedSlot public void write(com.trolltech.qt.core.QDataStream out) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_write_QDataStream(nativeId(), out == null ? 0 : out.nativeId());
    }
    private native static void __qt_write_QDataStream(long __this__nativeId, long out);


    public static native QTreeWidgetItem fromNativePointer(QNativePointer nativePointer);

    protected QTreeWidgetItem(QPrivateConstructor p) { super(p); } 

}
