package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QWizard extends com.trolltech.qt.gui.QDialog
{
    public enum WizardButton implements com.trolltech.qt.QtEnumerator {
        BackButton(0),
        NextButton(1),
        CommitButton(2),
        FinishButton(3),
        CancelButton(4),
        HelpButton(5),
        CustomButton1(6),
        CustomButton2(7),
        CustomButton3(8),
        Stretch(9),
        NoButton(-1),
;

        WizardButton(int value) { this.value = value; }
        public int value() { return value; }

        public static WizardButton resolve(int value) {
            return (WizardButton) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return BackButton;
            case 1: return NextButton;
            case 2: return CommitButton;
            case 3: return FinishButton;
            case 4: return CancelButton;
            case 5: return HelpButton;
            case 6: return CustomButton1;
            case 7: return CustomButton2;
            case 8: return CustomButton3;
            case 9: return Stretch;
            case -1: return NoButton;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum WizardStyle implements com.trolltech.qt.QtEnumerator {
        ClassicStyle(0),
        ModernStyle(1),
        MacStyle(2),
        AeroStyle(3),
        NStyles(4);

        WizardStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static WizardStyle resolve(int value) {
            return (WizardStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ClassicStyle;
            case 1: return ModernStyle;
            case 2: return MacStyle;
            case 3: return AeroStyle;
            case 4: return NStyles;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum WizardPixmap implements com.trolltech.qt.QtEnumerator {
        WatermarkPixmap(0),
        LogoPixmap(1),
        BannerPixmap(2),
        BackgroundPixmap(3),
        NPixmaps(4);

        WizardPixmap(int value) { this.value = value; }
        public int value() { return value; }

        public static WizardPixmap resolve(int value) {
            return (WizardPixmap) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WatermarkPixmap;
            case 1: return LogoPixmap;
            case 2: return BannerPixmap;
            case 3: return BackgroundPixmap;
            case 4: return NPixmaps;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum WizardOption implements com.trolltech.qt.QtEnumerator {
        IndependentPages(1),
        IgnoreSubTitles(2),
        ExtendedWatermarkPixmap(4),
        NoDefaultButton(8),
        NoBackButtonOnStartPage(16),
        NoBackButtonOnLastPage(32),
        DisabledBackButtonOnLastPage(64),
        HaveNextButtonOnLastPage(128),
        HaveFinishButtonOnEarlyPages(256),
        NoCancelButton(512),
        CancelButtonOnLeft(1024),
        HaveHelpButton(2048),
        HelpButtonOnRight(4096),
        HaveCustomButton1(8192),
        HaveCustomButton2(16384),
        HaveCustomButton3(32768);

        WizardOption(int value) { this.value = value; }
        public int value() { return value; }

        public static WizardOptions createQFlags(WizardOption ... values) {
            return new WizardOptions(values);
        }
        public static WizardOption resolve(int value) {
            return (WizardOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return IndependentPages;
            case 2: return IgnoreSubTitles;
            case 4: return ExtendedWatermarkPixmap;
            case 8: return NoDefaultButton;
            case 16: return NoBackButtonOnStartPage;
            case 32: return NoBackButtonOnLastPage;
            case 64: return DisabledBackButtonOnLastPage;
            case 128: return HaveNextButtonOnLastPage;
            case 256: return HaveFinishButtonOnEarlyPages;
            case 512: return NoCancelButton;
            case 1024: return CancelButtonOnLeft;
            case 2048: return HaveHelpButton;
            case 4096: return HelpButtonOnRight;
            case 8192: return HaveCustomButton1;
            case 16384: return HaveCustomButton2;
            case 32768: return HaveCustomButton3;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class WizardOptions extends com.trolltech.qt.QFlags<WizardOption> {
        private static final long serialVersionUID = 1L;
        public WizardOptions(WizardOption ... args) { super(args); }
        public WizardOptions(int value) { setValue(value); }
    }


    public final Signal1<java.lang.Integer> currentIdChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void currentIdChanged(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentIdChanged_int(nativeId(), id);
    }
    private native static void __qt_currentIdChanged_int(long __this__nativeId, int id);

    public final Signal1<java.lang.Integer> customButtonClicked = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void customButtonClicked(int which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_customButtonClicked_int(nativeId(), which);
    }
    private native static void __qt_customButtonClicked_int(long __this__nativeId, int which);

    public final Signal0 helpRequested = new Signal0();

    @SuppressWarnings("unused")
    private final void helpRequested() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_helpRequested(nativeId());
    }
    private native static void __qt_helpRequested(long __this__nativeId);


    public QWizard(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QWizard() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QWizard(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QWizard_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), flags.value());
    }
    private native void __qt_QWizard_QWidget_WindowFlags(long parent, int flags);


    @QtBlockedSlot public final int addPage(com.trolltech.qt.gui.QWizardPage page) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (page == null)
            throw new NullPointerException("Argument 'page': null not expected.");
        return __qt_addPage_QWizardPage(nativeId(), page == null ? 0 : page.nativeId());
    }
    private native static int __qt_addPage_QWizardPage(long __this__nativeId, long page);

    public final void back() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_back(nativeId());
    }
    private native static void __qt_back(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractButton button(com.trolltech.qt.gui.QWizard.WizardButton which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_button_WizardButton(nativeId(), which.value());
    }
    private native static com.trolltech.qt.gui.QAbstractButton __qt_button_WizardButton(long __this__nativeId, int which);

    @QtBlockedSlot public final java.lang.String buttonText(com.trolltech.qt.gui.QWizard.WizardButton which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_buttonText_WizardButton(nativeId(), which.value());
    }
    private native static java.lang.String __qt_buttonText_WizardButton(long __this__nativeId, int which);

    @com.trolltech.qt.QtPropertyReader(name="currentId")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int currentId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentId(nativeId());
    }
    private native static int __qt_currentId(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWizardPage currentPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentPage(nativeId());
    }
    private native static com.trolltech.qt.gui.QWizardPage __qt_currentPage(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object field(java.lang.String name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_field_String(nativeId(), name);
    }
    private native static java.lang.Object __qt_field_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final boolean hasVisitedPage(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasVisitedPage_int(nativeId(), id);
    }
    private native static boolean __qt_hasVisitedPage_int(long __this__nativeId, int id);

    public final void next() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_next(nativeId());
    }
    private native static void __qt_next(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="options")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QWizard.WizardOptions options() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QWizard.WizardOptions(__qt_options(nativeId()));
    }
    private native static int __qt_options(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWizardPage page(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_page_int(nativeId(), id);
    }
    private native static com.trolltech.qt.gui.QWizardPage __qt_page_int(long __this__nativeId, int id);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(com.trolltech.qt.gui.QWizard.WizardPixmap which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixmap_WizardPixmap(nativeId(), which.value());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_pixmap_WizardPixmap(long __this__nativeId, int which);

    public final void restart() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_restart(nativeId());
    }
    private native static void __qt_restart(long __this__nativeId);

    @QtBlockedSlot public final void setButton(com.trolltech.qt.gui.QWizard.WizardButton which, com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setButton_WizardButton_QAbstractButton(nativeId(), which.value(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_setButton_WizardButton_QAbstractButton(long __this__nativeId, int which, long button);

    @QtBlockedSlot public final void setButtonLayout(java.util.List<com.trolltech.qt.gui.QWizard.WizardButton> layout) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setButtonLayout_List(nativeId(), layout);
    }
    private native static void __qt_setButtonLayout_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QWizard.WizardButton> layout);

    @QtBlockedSlot public final void setButtonText(com.trolltech.qt.gui.QWizard.WizardButton which, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setButtonText_WizardButton_String(nativeId(), which.value(), text);
    }
    private native static void __qt_setButtonText_WizardButton_String(long __this__nativeId, int which, java.lang.String text);

    @QtBlockedSlot public final void setField(java.lang.String name, java.lang.Object value) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setField_String_Object(nativeId(), name, value);
    }
    private native static void __qt_setField_String_Object(long __this__nativeId, java.lang.String name, java.lang.Object value);


    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QWizard.WizardOption option) {
        setOption(option, (boolean)true);
    }
    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QWizard.WizardOption option, boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOption_WizardOption_boolean(nativeId(), option.value(), on);
    }
    private native static void __qt_setOption_WizardOption_boolean(long __this__nativeId, int option, boolean on);


    @QtBlockedSlot public final void setOptions(com.trolltech.qt.gui.QWizard.WizardOption ... options) {
        this.setOptions(new com.trolltech.qt.gui.QWizard.WizardOptions(options));
    }
    @com.trolltech.qt.QtPropertyWriter(name="options")
    @QtBlockedSlot public final void setOptions(com.trolltech.qt.gui.QWizard.WizardOptions options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOptions_WizardOptions(nativeId(), options.value());
    }
    private native static void __qt_setOptions_WizardOptions(long __this__nativeId, int options);

    @QtBlockedSlot public final void setPage(int id, com.trolltech.qt.gui.QWizardPage page) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (page == null)
            throw new NullPointerException("Argument 'page': null not expected.");
        __qt_setPage_int_QWizardPage(nativeId(), id, page == null ? 0 : page.nativeId());
    }
    private native static void __qt_setPage_int_QWizardPage(long __this__nativeId, int id, long page);

    @QtBlockedSlot public final void setPixmap(com.trolltech.qt.gui.QWizard.WizardPixmap which, com.trolltech.qt.gui.QPixmap pixmap) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPixmap_WizardPixmap_QPixmap(nativeId(), which.value(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId());
    }
    private native static void __qt_setPixmap_WizardPixmap_QPixmap(long __this__nativeId, int which, long pixmap);

    @com.trolltech.qt.QtPropertyWriter(name="startId")
    @QtBlockedSlot public final void setStartId(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStartId_int(nativeId(), id);
    }
    private native static void __qt_setStartId_int(long __this__nativeId, int id);

    @com.trolltech.qt.QtPropertyWriter(name="subTitleFormat")
    @QtBlockedSlot public final void setSubTitleFormat(com.trolltech.qt.core.Qt.TextFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSubTitleFormat_TextFormat(nativeId(), format.value());
    }
    private native static void __qt_setSubTitleFormat_TextFormat(long __this__nativeId, int format);

    @com.trolltech.qt.QtPropertyWriter(name="titleFormat")
    @QtBlockedSlot public final void setTitleFormat(com.trolltech.qt.core.Qt.TextFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTitleFormat_TextFormat(nativeId(), format.value());
    }
    private native static void __qt_setTitleFormat_TextFormat(long __this__nativeId, int format);

    @com.trolltech.qt.QtPropertyWriter(name="wizardStyle")
    @QtBlockedSlot public final void setWizardStyle(com.trolltech.qt.gui.QWizard.WizardStyle style) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWizardStyle_WizardStyle(nativeId(), style.value());
    }
    private native static void __qt_setWizardStyle_WizardStyle(long __this__nativeId, int style);

    @com.trolltech.qt.QtPropertyReader(name="startId")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int startId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_startId(nativeId());
    }
    private native static int __qt_startId(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="subTitleFormat")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextFormat subTitleFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.TextFormat.resolve(__qt_subTitleFormat(nativeId()));
    }
    private native static int __qt_subTitleFormat(long __this__nativeId);

    @QtBlockedSlot public final boolean testOption(com.trolltech.qt.gui.QWizard.WizardOption option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testOption_WizardOption(nativeId(), option.value());
    }
    private native static boolean __qt_testOption_WizardOption(long __this__nativeId, int option);

    @com.trolltech.qt.QtPropertyReader(name="titleFormat")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextFormat titleFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.TextFormat.resolve(__qt_titleFormat(nativeId()));
    }
    private native static int __qt_titleFormat(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.Integer> visitedPages() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visitedPages(nativeId());
    }
    private native static java.util.List<java.lang.Integer> __qt_visitedPages(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="wizardStyle")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QWizard.WizardStyle wizardStyle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QWizard.WizardStyle.resolve(__qt_wizardStyle(nativeId()));
    }
    private native static int __qt_wizardStyle(long __this__nativeId);

    @QtBlockedSlot protected void cleanupPage(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cleanupPage_int(nativeId(), id);
    }
    private native static void __qt_cleanupPage_int(long __this__nativeId, int id);

    @QtBlockedSlot public void done(int result) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_done_int(nativeId(), result);
    }
    private native static void __qt_done_int(long __this__nativeId, int result);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void initializePage(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initializePage_int(nativeId(), id);
    }
    private native static void __qt_initializePage_int(long __this__nativeId, int id);

    @QtBlockedSlot public int nextId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextId(nativeId());
    }
    private native static int __qt_nextId(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long event);

    @QtBlockedSlot public void setVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setVisible_boolean(long __this__nativeId, boolean visible);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot public boolean validateCurrentPage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_validateCurrentPage(nativeId());
    }
    private native static boolean __qt_validateCurrentPage(long __this__nativeId);


    public static native QWizard fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QWizard(QPrivateConstructor p) { super(p); } 

}
