package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFtp extends com.trolltech.qt.core.QObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum TransferType implements com.trolltech.qt.QtEnumerator {
        Binary(0),
        Ascii(1);

        TransferType(int value) { this.value = value; }
        public int value() { return value; }

        public static TransferType resolve(int value) {
            return (TransferType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Binary;
            case 1: return Ascii;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Error implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        UnknownError(1),
        HostNotFound(2),
        ConnectionRefused(3),
        NotConnected(4);

        Error(int value) { this.value = value; }
        public int value() { return value; }

        public static Error resolve(int value) {
            return (Error) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return UnknownError;
            case 2: return HostNotFound;
            case 3: return ConnectionRefused;
            case 4: return NotConnected;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Command implements com.trolltech.qt.QtEnumerator {
        None(0),
        SetTransferMode(1),
        SetProxy(2),
        ConnectToHost(3),
        Login(4),
        Close(5),
        List(6),
        Cd(7),
        Get(8),
        Put(9),
        Remove(10),
        Mkdir(11),
        Rmdir(12),
        Rename(13),
        RawCommand(14);

        Command(int value) { this.value = value; }
        public int value() { return value; }

        public static Command resolve(int value) {
            return (Command) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return SetTransferMode;
            case 2: return SetProxy;
            case 3: return ConnectToHost;
            case 4: return Login;
            case 5: return Close;
            case 6: return List;
            case 7: return Cd;
            case 8: return Get;
            case 9: return Put;
            case 10: return Remove;
            case 11: return Mkdir;
            case 12: return Rmdir;
            case 13: return Rename;
            case 14: return RawCommand;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TransferMode implements com.trolltech.qt.QtEnumerator {
        Active(0),
        Passive(1);

        TransferMode(int value) { this.value = value; }
        public int value() { return value; }

        public static TransferMode resolve(int value) {
            return (TransferMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Active;
            case 1: return Passive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum State implements com.trolltech.qt.QtEnumerator {
        Unconnected(0),
        HostLookup(1),
        Connecting(2),
        Connected(3),
        LoggedIn(4),
        Closing(5);

        State(int value) { this.value = value; }
        public int value() { return value; }

        public static State resolve(int value) {
            return (State) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Unconnected;
            case 1: return HostLookup;
            case 2: return Connecting;
            case 3: return Connected;
            case 4: return LoggedIn;
            case 5: return Closing;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal2<java.lang.Integer, java.lang.Boolean> commandFinished = new Signal2<java.lang.Integer, java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void commandFinished(int arg__1, boolean arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_commandFinished_int_boolean(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_commandFinished_int_boolean(long __this__nativeId, int arg__1, boolean arg__2);

    public final Signal1<java.lang.Integer> commandStarted = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void commandStarted(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_commandStarted_int(nativeId(), arg__1);
    }
    private native static void __qt_commandStarted_int(long __this__nativeId, int arg__1);

    public final Signal2<java.lang.Long, java.lang.Long> dataTransferProgress = new Signal2<java.lang.Long, java.lang.Long>();

    @SuppressWarnings("unused")
    private final void dataTransferProgress(long arg__1, long arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataTransferProgress_long_long(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_dataTransferProgress_long_long(long __this__nativeId, long arg__1, long arg__2);

    public final Signal1<java.lang.Boolean> done = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void done(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_done_boolean(nativeId(), arg__1);
    }
    private native static void __qt_done_boolean(long __this__nativeId, boolean arg__1);

    public final Signal1<com.trolltech.qt.network.QUrlInfo> listInfo = new Signal1<com.trolltech.qt.network.QUrlInfo>();

    @SuppressWarnings("unused")
    private final void listInfo(com.trolltech.qt.network.QUrlInfo arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_listInfo_QUrlInfo(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_listInfo_QUrlInfo(long __this__nativeId, long arg__1);

    public final Signal2<java.lang.Integer, java.lang.String> rawCommandReply = new Signal2<java.lang.Integer, java.lang.String>();

    @SuppressWarnings("unused")
    private final void rawCommandReply(int arg__1, java.lang.String arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rawCommandReply_int_String(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_rawCommandReply_int_String(long __this__nativeId, int arg__1, java.lang.String arg__2);

    public final Signal0 readyRead = new Signal0();

    @SuppressWarnings("unused")
    private final void readyRead() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readyRead(nativeId());
    }
    private native static void __qt_readyRead(long __this__nativeId);

    public final Signal1<java.lang.Integer> stateChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void stateChanged(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_int(nativeId(), arg__1);
    }
    private native static void __qt_stateChanged_int(long __this__nativeId, int arg__1);


    public QFtp() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QFtp(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QFtp_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QFtp_QObject(long parent);


    public final void abort() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_abort(nativeId());
    }
    private native static void __qt_abort(long __this__nativeId);

    @QtBlockedSlot public final long bytesAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesAvailable(nativeId());
    }
    private native static long __qt_bytesAvailable(long __this__nativeId);

    @QtBlockedSlot public final int cd(java.lang.String dir) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cd_String(nativeId(), dir);
    }
    private native static int __qt_cd_String(long __this__nativeId, java.lang.String dir);

    @QtBlockedSlot public final void clearPendingCommands() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearPendingCommands(nativeId());
    }
    private native static void __qt_clearPendingCommands(long __this__nativeId);

    @QtBlockedSlot public final int close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_close(nativeId());
    }
    private native static int __qt_close(long __this__nativeId);


    @QtBlockedSlot public final int connectToHost(java.lang.String host) {
        return connectToHost(host, (char)21);
    }
    @QtBlockedSlot public final int connectToHost(java.lang.String host, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_connectToHost_String_char(nativeId(), host, port);
    }
    private native static int __qt_connectToHost_String_char(long __this__nativeId, java.lang.String host, char port);

    @QtBlockedSlot public final com.trolltech.qt.network.QFtp.Command currentCommand() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QFtp.Command.resolve(__qt_currentCommand(nativeId()));
    }
    private native static int __qt_currentCommand(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice currentDevice() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentDevice(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_currentDevice(long __this__nativeId);

    @QtBlockedSlot public final int currentId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentId(nativeId());
    }
    private native static int __qt_currentId(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QFtp.Error error() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QFtp.Error.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);


    @QtBlockedSlot public final int get(java.lang.String file, com.trolltech.qt.core.QIODevice dev) {
        return get(file, dev, com.trolltech.qt.network.QFtp.TransferType.Binary);
    }

    @QtBlockedSlot public final int get(java.lang.String file) {
        return get(file, (com.trolltech.qt.core.QIODevice)null, com.trolltech.qt.network.QFtp.TransferType.Binary);
    }
    @QtBlockedSlot public final int get(java.lang.String file, com.trolltech.qt.core.QIODevice dev, com.trolltech.qt.network.QFtp.TransferType type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_get_String_QIODevice_TransferType(nativeId(), file, dev == null ? 0 : dev.nativeId(), type.value());
    }
    private native static int __qt_get_String_QIODevice_TransferType(long __this__nativeId, java.lang.String file, long dev, int type);

    @QtBlockedSlot public final boolean hasPendingCommands() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasPendingCommands(nativeId());
    }
    private native static boolean __qt_hasPendingCommands(long __this__nativeId);


    @QtBlockedSlot public final int list() {
        return list((java.lang.String)"");
    }
    @QtBlockedSlot public final int list(java.lang.String dir) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_list_String(nativeId(), dir);
    }
    private native static int __qt_list_String(long __this__nativeId, java.lang.String dir);


    @QtBlockedSlot public final int login(java.lang.String user) {
        return login(user, (java.lang.String)"");
    }

    @QtBlockedSlot public final int login() {
        return login((java.lang.String)"", (java.lang.String)"");
    }
    @QtBlockedSlot public final int login(java.lang.String user, java.lang.String password) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_login_String_String(nativeId(), user, password);
    }
    private native static int __qt_login_String_String(long __this__nativeId, java.lang.String user, java.lang.String password);

    @QtBlockedSlot public final int mkdir(java.lang.String dir) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mkdir_String(nativeId(), dir);
    }
    private native static int __qt_mkdir_String(long __this__nativeId, java.lang.String dir);


    @QtBlockedSlot public final int put(com.trolltech.qt.core.QByteArray data, java.lang.String file) {
        return put(data, file, com.trolltech.qt.network.QFtp.TransferType.Binary);
    }
    @QtBlockedSlot public final int put(com.trolltech.qt.core.QByteArray data, java.lang.String file, com.trolltech.qt.network.QFtp.TransferType type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_put_QByteArray_String_TransferType(nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), file, type.value());
    }
    private native static int __qt_put_QByteArray_String_TransferType(long __this__nativeId, long data, java.lang.String file, int type);


    @QtBlockedSlot public final int put(com.trolltech.qt.core.QIODevice dev, java.lang.String file) {
        return put(dev, file, com.trolltech.qt.network.QFtp.TransferType.Binary);
    }
    @QtBlockedSlot public final int put(com.trolltech.qt.core.QIODevice dev, java.lang.String file, com.trolltech.qt.network.QFtp.TransferType type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_put_QIODevice_String_TransferType(nativeId(), dev == null ? 0 : dev.nativeId(), file, type.value());
    }
    private native static int __qt_put_QIODevice_String_TransferType(long __this__nativeId, long dev, java.lang.String file, int type);

    @QtBlockedSlot public final int rawCommand(java.lang.String command) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rawCommand_String(nativeId(), command);
    }
    private native static int __qt_rawCommand_String(long __this__nativeId, java.lang.String command);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long read(com.trolltech.qt.QNativePointer data, long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_read_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAll(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readAll(long __this__nativeId);

    @QtBlockedSlot public final int remove(java.lang.String file) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_remove_String(nativeId(), file);
    }
    private native static int __qt_remove_String(long __this__nativeId, java.lang.String file);

    @QtBlockedSlot public final int rename(java.lang.String oldname, java.lang.String newname) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rename_String_String(nativeId(), oldname, newname);
    }
    private native static int __qt_rename_String_String(long __this__nativeId, java.lang.String oldname, java.lang.String newname);

    @QtBlockedSlot public final int rmdir(java.lang.String dir) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rmdir_String(nativeId(), dir);
    }
    private native static int __qt_rmdir_String(long __this__nativeId, java.lang.String dir);

    @QtBlockedSlot public final int setProxy(java.lang.String host, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setProxy_String_char(nativeId(), host, port);
    }
    private native static int __qt_setProxy_String_char(long __this__nativeId, java.lang.String host, char port);

    @QtBlockedSlot public final int setTransferMode(com.trolltech.qt.network.QFtp.TransferMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setTransferMode_TransferMode(nativeId(), mode.value());
    }
    private native static int __qt_setTransferMode_TransferMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final com.trolltech.qt.network.QFtp.State state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QFtp.State.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);


    public static native QFtp fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QFtp(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - network.read_char*_long_long - START
        public final int read(byte data[]) {
            if (data.length == 0) return 0;
            
            com.trolltech.qt.QNativePointer np = new com.trolltech.qt.QNativePointer(com.trolltech.qt.QNativePointer.Type.Byte, data.length);
            int len = (int) read(np, data.length);
            for (int i=0; i<len; ++i) data[i] = np.byteAt(i);
            
            return len;
        }      
  // TEMPLATE - network.read_char*_long_long - END
    
}
