package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QHostInfo extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum HostInfoError implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        HostNotFound(1),
        UnknownError(2);

        HostInfoError(int value) { this.value = value; }
        public int value() { return value; }

        public static HostInfoError resolve(int value) {
            return (HostInfoError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return HostNotFound;
            case 2: return UnknownError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QHostInfo() {
        this((int)-1);
    }
    public QHostInfo(int lookupId) {
        super((QPrivateConstructor)null);
        __qt_QHostInfo_int(lookupId);
    }
    private native void __qt_QHostInfo_int(int lookupId);


    public QHostInfo(com.trolltech.qt.network.QHostInfo d) {
        super((QPrivateConstructor)null);
        __qt_QHostInfo_QHostInfo(d == null ? 0 : d.nativeId());
    }
    private native void __qt_QHostInfo_QHostInfo(long d);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.network.QHostAddress> addresses() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addresses(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.network.QHostAddress> __qt_addresses(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHostInfo.HostInfoError error() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QHostInfo.HostInfoError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String hostName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hostName(nativeId());
    }
    private native static java.lang.String __qt_hostName(long __this__nativeId);

    @QtBlockedSlot public final int lookupId() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lookupId(nativeId());
    }
    private native static int __qt_lookupId(long __this__nativeId);

    @QtBlockedSlot public final void setAddresses(java.util.List<com.trolltech.qt.network.QHostAddress> addresses) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAddresses_List(nativeId(), addresses);
    }
    private native static void __qt_setAddresses_List(long __this__nativeId, java.util.List<com.trolltech.qt.network.QHostAddress> addresses);

    @QtBlockedSlot public final void setError(com.trolltech.qt.network.QHostInfo.HostInfoError error) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setError_HostInfoError(nativeId(), error.value());
    }
    private native static void __qt_setError_HostInfoError(long __this__nativeId, int error);

    @QtBlockedSlot public final void setErrorString(java.lang.String errorString) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setErrorString_String(nativeId(), errorString);
    }
    private native static void __qt_setErrorString_String(long __this__nativeId, java.lang.String errorString);

    @QtBlockedSlot public final void setHostName(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHostName_String(nativeId(), name);
    }
    private native static void __qt_setHostName_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final void setLookupId(int id) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLookupId_int(nativeId(), id);
    }
    private native static void __qt_setLookupId_int(long __this__nativeId, int id);

    public native static void abortHostLookup(int lookupId);

    public native static com.trolltech.qt.network.QHostInfo fromName(java.lang.String name);

    public native static java.lang.String localHostName();


    public static native QHostInfo fromNativePointer(QNativePointer nativePointer);

    protected QHostInfo(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QHostInfo array[]);
}
