package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QNetworkInterface extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum InterfaceFlag implements com.trolltech.qt.QtEnumerator {
        IsUp(1),
        IsRunning(2),
        CanBroadcast(4),
        IsLoopBack(8),
        IsPointToPoint(16),
        CanMulticast(32);

        InterfaceFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static InterfaceFlags createQFlags(InterfaceFlag ... values) {
            return new InterfaceFlags(values);
        }
        public static InterfaceFlag resolve(int value) {
            return (InterfaceFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return IsUp;
            case 2: return IsRunning;
            case 4: return CanBroadcast;
            case 8: return IsLoopBack;
            case 16: return IsPointToPoint;
            case 32: return CanMulticast;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class InterfaceFlags extends com.trolltech.qt.QFlags<InterfaceFlag> {
        private static final long serialVersionUID = 1L;
        public InterfaceFlags(InterfaceFlag ... args) { super(args); }
        public InterfaceFlags(int value) { setValue(value); }
    }


    public QNetworkInterface() {
        super((QPrivateConstructor)null);
        __qt_QNetworkInterface();
    }
    private native void __qt_QNetworkInterface();


    public QNetworkInterface(com.trolltech.qt.network.QNetworkInterface other) {
        super((QPrivateConstructor)null);
        __qt_QNetworkInterface_QNetworkInterface(other == null ? (other = new com.trolltech.qt.network.QNetworkInterface()).nativeId() : other.nativeId());
    }
    private native void __qt_QNetworkInterface_QNetworkInterface(long other);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.network.QNetworkAddressEntry> addressEntries() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addressEntries(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.network.QNetworkAddressEntry> __qt_addressEntries(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QNetworkInterface.InterfaceFlags flags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.network.QNetworkInterface.InterfaceFlags(__qt_flags(nativeId()));
    }
    private native static int __qt_flags(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String hardwareAddress() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hardwareAddress(nativeId());
    }
    private native static java.lang.String __qt_hardwareAddress(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String name() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_name(nativeId());
    }
    private native static java.lang.String __qt_name(long __this__nativeId);

    public native static java.util.List<com.trolltech.qt.network.QHostAddress> allAddresses();

    public native static java.util.List<com.trolltech.qt.network.QNetworkInterface> allInterfaces();

    public native static com.trolltech.qt.network.QNetworkInterface interfaceFromIndex(int index);

    public native static com.trolltech.qt.network.QNetworkInterface interfaceFromName(java.lang.String name);


    public static native QNetworkInterface fromNativePointer(QNativePointer nativePointer);

    protected QNetworkInterface(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QNetworkInterface array[]);
}
