package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QNetworkProxy extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum ProxyType implements com.trolltech.qt.QtEnumerator {
        DefaultProxy(0),
        Socks5Proxy(1),
        NoProxy(2),
        HttpProxy(3);

        ProxyType(int value) { this.value = value; }
        public int value() { return value; }

        public static ProxyType resolve(int value) {
            return (ProxyType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return DefaultProxy;
            case 1: return Socks5Proxy;
            case 2: return NoProxy;
            case 3: return HttpProxy;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QNetworkProxy() {
        super((QPrivateConstructor)null);
        __qt_QNetworkProxy();
    }
    private native void __qt_QNetworkProxy();


    public QNetworkProxy(com.trolltech.qt.network.QNetworkProxy other) {
        super((QPrivateConstructor)null);
        __qt_QNetworkProxy_QNetworkProxy(other == null ? (other = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : other.nativeId());
    }
    private native void __qt_QNetworkProxy_QNetworkProxy(long other);



    @SuppressWarnings("unused")
    private QNetworkProxy(com.trolltech.qt.network.QNetworkProxy.ProxyType type, java.lang.String hostName, char port, java.lang.String user) {
        this(type, hostName, port, user, (java.lang.String)"");
    }

    @SuppressWarnings("unused")
    private QNetworkProxy(com.trolltech.qt.network.QNetworkProxy.ProxyType type, java.lang.String hostName, char port) {
        this(type, hostName, port, (java.lang.String)"", (java.lang.String)"");
    }

    @SuppressWarnings("unused")
    private QNetworkProxy(com.trolltech.qt.network.QNetworkProxy.ProxyType type, java.lang.String hostName) {
        this(type, hostName, (char)0, (java.lang.String)"", (java.lang.String)"");
    }

    @SuppressWarnings("unused")
    private QNetworkProxy(com.trolltech.qt.network.QNetworkProxy.ProxyType type) {
        this(type, (java.lang.String)"", (char)0, (java.lang.String)"", (java.lang.String)"");
    }
    @SuppressWarnings("unused")
    private QNetworkProxy(com.trolltech.qt.network.QNetworkProxy.ProxyType type, java.lang.String hostName, char port, java.lang.String user, java.lang.String password) {
        super((QPrivateConstructor)null);
        __qt_QNetworkProxy_ProxyType_String_char_String_String(type.value(), hostName, port, user, password);
    }
    private native void __qt_QNetworkProxy_ProxyType_String_char_String_String(int type, java.lang.String hostName, char port, java.lang.String user, java.lang.String password);


    @QtBlockedSlot public final java.lang.String hostName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hostName(nativeId());
    }
    private native static java.lang.String __qt_hostName(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String password() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_password(nativeId());
    }
    private native static java.lang.String __qt_password(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final char port_private() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_port_private(nativeId());
    }
    private native static char __qt_port_private(long __this__nativeId);

    @QtBlockedSlot public final void setHostName(java.lang.String hostName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHostName_String(nativeId(), hostName);
    }
    private native static void __qt_setHostName_String(long __this__nativeId, java.lang.String hostName);

    @QtBlockedSlot public final void setPassword(java.lang.String password) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPassword_String(nativeId(), password);
    }
    private native static void __qt_setPassword_String(long __this__nativeId, java.lang.String password);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void setPort(char port) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPort_char(nativeId(), port);
    }
    private native static void __qt_setPort_char(long __this__nativeId, char port);

    @QtBlockedSlot public final void setType(com.trolltech.qt.network.QNetworkProxy.ProxyType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setType_ProxyType(nativeId(), type.value());
    }
    private native static void __qt_setType_ProxyType(long __this__nativeId, int type);

    @QtBlockedSlot public final void setUser(java.lang.String userName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUser_String(nativeId(), userName);
    }
    private native static void __qt_setUser_String(long __this__nativeId, java.lang.String userName);

    @QtBlockedSlot public final com.trolltech.qt.network.QNetworkProxy.ProxyType type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QNetworkProxy.ProxyType.resolve(__qt_type(nativeId()));
    }
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String user() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_user(nativeId());
    }
    private native static java.lang.String __qt_user(long __this__nativeId);

    public native static com.trolltech.qt.network.QNetworkProxy applicationProxy();

    public static void setApplicationProxy(com.trolltech.qt.network.QNetworkProxy proxy) {
        __qt_setApplicationProxy_QNetworkProxy(proxy == null ? (proxy = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : proxy.nativeId());
    }
    private native static void __qt_setApplicationProxy_QNetworkProxy(long proxy);


    public static native QNetworkProxy fromNativePointer(QNativePointer nativePointer);

    protected QNetworkProxy(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QNetworkProxy array[]);

    public QNetworkProxy(QNetworkProxy.ProxyType type, String host, int port) {
        this(type, host, (char) port);
    }
    public QNetworkProxy(QNetworkProxy.ProxyType type, String host, int port, String username) {
        this(type, host, (char) port, username);
    }
    public QNetworkProxy(QNetworkProxy.ProxyType type, String host, int port, String username, String password) {
        this(type, host, (char) port, username, password);
    }
    public final void setPort(int port) { setPort((char) port); }
    public final int port() { return port_private(); }
    
}
