package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public interface QSsl
{
    public enum KeyType implements com.trolltech.qt.QtEnumerator {
        PrivateKey(0),
        PublicKey(1);

        KeyType(int value) { this.value = value; }
        public int value() { return value; }

        public static KeyType resolve(int value) {
            return (KeyType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return PrivateKey;
            case 1: return PublicKey;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum KeyAlgorithm implements com.trolltech.qt.QtEnumerator {
        Rsa(0),
        Dsa(1);

        KeyAlgorithm(int value) { this.value = value; }
        public int value() { return value; }

        public static KeyAlgorithm resolve(int value) {
            return (KeyAlgorithm) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Rsa;
            case 1: return Dsa;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SslProtocol implements com.trolltech.qt.QtEnumerator {
        SslV3(0),
        SslV2(1),
        TlsV1(2),
        AnyProtocol(3),
        UnknownProtocol(-1);

        SslProtocol(int value) { this.value = value; }
        public int value() { return value; }

        public static SslProtocol resolve(int value) {
            return (SslProtocol) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SslV3;
            case 1: return SslV2;
            case 2: return TlsV1;
            case 3: return AnyProtocol;
            case -1: return UnknownProtocol;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AlternateNameEntryType implements com.trolltech.qt.QtEnumerator {
        EmailEntry(0),
        DnsEntry(1);

        AlternateNameEntryType(int value) { this.value = value; }
        public int value() { return value; }

        public static AlternateNameEntryType resolve(int value) {
            return (AlternateNameEntryType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return EmailEntry;
            case 1: return DnsEntry;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum EncodingFormat implements com.trolltech.qt.QtEnumerator {
        Pem(0),
        Der(1);

        EncodingFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static EncodingFormat resolve(int value) {
            return (EncodingFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Pem;
            case 1: return Der;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
}
