package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QUrlInfo extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum PermissionSpec implements com.trolltech.qt.QtEnumerator {
        ReadOwner(256),
        WriteOwner(128),
        ExeOwner(64),
        ReadGroup(32),
        WriteGroup(16),
        ExeGroup(8),
        ReadOther(4),
        WriteOther(2),
        ExeOther(1);

        PermissionSpec(int value) { this.value = value; }
        public int value() { return value; }

        public static PermissionSpec resolve(int value) {
            return (PermissionSpec) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 256: return ReadOwner;
            case 128: return WriteOwner;
            case 64: return ExeOwner;
            case 32: return ReadGroup;
            case 16: return WriteGroup;
            case 8: return ExeGroup;
            case 4: return ReadOther;
            case 2: return WriteOther;
            case 1: return ExeOther;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QUrlInfo(com.trolltech.qt.network.QUrlInfo ui) {
        super((QPrivateConstructor)null);
        __qt_QUrlInfo_QUrlInfo(ui == null ? (ui = new com.trolltech.qt.network.QUrlInfo()).nativeId() : ui.nativeId());
    }
    private native void __qt_QUrlInfo_QUrlInfo(long ui);


    public QUrlInfo(com.trolltech.qt.core.QUrl url, int permissions, java.lang.String owner, java.lang.String group, long size, com.trolltech.qt.core.QDateTime lastModified, com.trolltech.qt.core.QDateTime lastRead, boolean isDir, boolean isFile, boolean isSymLink, boolean isWritable, boolean isReadable, boolean isExecutable) {
        super((QPrivateConstructor)null);
        __qt_QUrlInfo_QUrl_int_String_String_long_QDateTime_QDateTime_boolean_boolean_boolean_boolean_boolean_boolean(url == null ? (url = new com.trolltech.qt.core.QUrl()).nativeId() : url.nativeId(), permissions, owner, group, size, lastModified == null ? (lastModified = new com.trolltech.qt.core.QDateTime()).nativeId() : lastModified.nativeId(), lastRead == null ? (lastRead = new com.trolltech.qt.core.QDateTime()).nativeId() : lastRead.nativeId(), isDir, isFile, isSymLink, isWritable, isReadable, isExecutable);
    }
    private native void __qt_QUrlInfo_QUrl_int_String_String_long_QDateTime_QDateTime_boolean_boolean_boolean_boolean_boolean_boolean(long url, int permissions, java.lang.String owner, java.lang.String group, long size, long lastModified, long lastRead, boolean isDir, boolean isFile, boolean isSymLink, boolean isWritable, boolean isReadable, boolean isExecutable);


    public QUrlInfo() {
        super((QPrivateConstructor)null);
        __qt_QUrlInfo();
    }
    private native void __qt_QUrlInfo();


    public QUrlInfo(java.lang.String name, int permissions, java.lang.String owner, java.lang.String group, long size, com.trolltech.qt.core.QDateTime lastModified, com.trolltech.qt.core.QDateTime lastRead, boolean isDir, boolean isFile, boolean isSymLink, boolean isWritable, boolean isReadable, boolean isExecutable) {
        super((QPrivateConstructor)null);
        __qt_QUrlInfo_String_int_String_String_long_QDateTime_QDateTime_boolean_boolean_boolean_boolean_boolean_boolean(name, permissions, owner, group, size, lastModified == null ? (lastModified = new com.trolltech.qt.core.QDateTime()).nativeId() : lastModified.nativeId(), lastRead == null ? (lastRead = new com.trolltech.qt.core.QDateTime()).nativeId() : lastRead.nativeId(), isDir, isFile, isSymLink, isWritable, isReadable, isExecutable);
    }
    private native void __qt_QUrlInfo_String_int_String_String_long_QDateTime_QDateTime_boolean_boolean_boolean_boolean_boolean_boolean(java.lang.String name, int permissions, java.lang.String owner, java.lang.String group, long size, long lastModified, long lastRead, boolean isDir, boolean isFile, boolean isSymLink, boolean isWritable, boolean isReadable, boolean isExecutable);


    @QtBlockedSlot public final java.lang.String group() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_group(nativeId());
    }
    private native static java.lang.String __qt_group(long __this__nativeId);

    @QtBlockedSlot public final boolean isDir() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDir(nativeId());
    }
    private native static boolean __qt_isDir(long __this__nativeId);

    @QtBlockedSlot public final boolean isExecutable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isExecutable(nativeId());
    }
    private native static boolean __qt_isExecutable(long __this__nativeId);

    @QtBlockedSlot public final boolean isFile() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFile(nativeId());
    }
    private native static boolean __qt_isFile(long __this__nativeId);

    @QtBlockedSlot public final boolean isReadable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadable(nativeId());
    }
    private native static boolean __qt_isReadable(long __this__nativeId);

    @QtBlockedSlot public final boolean isSymLink() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSymLink(nativeId());
    }
    private native static boolean __qt_isSymLink(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final boolean isWritable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWritable(nativeId());
    }
    private native static boolean __qt_isWritable(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QDateTime lastModified() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastModified(nativeId());
    }
    private native static com.trolltech.qt.core.QDateTime __qt_lastModified(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QDateTime lastRead() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastRead(nativeId());
    }
    private native static com.trolltech.qt.core.QDateTime __qt_lastRead(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String name() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_name(nativeId());
    }
    private native static java.lang.String __qt_name(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.network.QUrlInfo i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QUrlInfo(nativeId(), i == null ? (i = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i.nativeId());
    }
    private native static boolean __qt_operator_equal_QUrlInfo(long __this__nativeId, long i);

    @QtBlockedSlot public final java.lang.String owner() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_owner(nativeId());
    }
    private native static java.lang.String __qt_owner(long __this__nativeId);

    @QtBlockedSlot public final int permissions() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_permissions(nativeId());
    }
    private native static int __qt_permissions(long __this__nativeId);

    @QtBlockedSlot public final long size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static long __qt_size(long __this__nativeId);

    @QtBlockedSlot public void setDir(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDir_boolean(nativeId(), b);
    }
    private native static void __qt_setDir_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public void setFile(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFile_boolean(nativeId(), b);
    }
    private native static void __qt_setFile_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public void setGroup(java.lang.String s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGroup_String(nativeId(), s);
    }
    private native static void __qt_setGroup_String(long __this__nativeId, java.lang.String s);

    @QtBlockedSlot public void setLastModified(com.trolltech.qt.core.QDateTime dt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLastModified_QDateTime(nativeId(), dt == null ? (dt = new com.trolltech.qt.core.QDateTime()).nativeId() : dt.nativeId());
    }
    private native static void __qt_setLastModified_QDateTime(long __this__nativeId, long dt);

    @QtBlockedSlot public void setName(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setName_String(nativeId(), name);
    }
    private native static void __qt_setName_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public void setOwner(java.lang.String s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOwner_String(nativeId(), s);
    }
    private native static void __qt_setOwner_String(long __this__nativeId, java.lang.String s);

    @QtBlockedSlot public void setPermissions(int p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPermissions_int(nativeId(), p);
    }
    private native static void __qt_setPermissions_int(long __this__nativeId, int p);

    @QtBlockedSlot public void setReadable(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadable_boolean(nativeId(), b);
    }
    private native static void __qt_setReadable_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public void setSize(long size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSize_long(nativeId(), size);
    }
    private native static void __qt_setSize_long(long __this__nativeId, long size);

    @QtBlockedSlot public void setSymLink(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSymLink_boolean(nativeId(), b);
    }
    private native static void __qt_setSymLink_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public void setWritable(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWritable_boolean(nativeId(), b);
    }
    private native static void __qt_setWritable_boolean(long __this__nativeId, boolean b);

    public static boolean equal(com.trolltech.qt.network.QUrlInfo i1, com.trolltech.qt.network.QUrlInfo i2, int sortBy) {
        return __qt_equal_QUrlInfo_QUrlInfo_int(i1 == null ? (i1 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i1.nativeId(), i2 == null ? (i2 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i2.nativeId(), sortBy);
    }
    private native static boolean __qt_equal_QUrlInfo_QUrlInfo_int(long i1, long i2, int sortBy);

    public static boolean greaterThan(com.trolltech.qt.network.QUrlInfo i1, com.trolltech.qt.network.QUrlInfo i2, int sortBy) {
        return __qt_greaterThan_QUrlInfo_QUrlInfo_int(i1 == null ? (i1 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i1.nativeId(), i2 == null ? (i2 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i2.nativeId(), sortBy);
    }
    private native static boolean __qt_greaterThan_QUrlInfo_QUrlInfo_int(long i1, long i2, int sortBy);

    public static boolean lessThan(com.trolltech.qt.network.QUrlInfo i1, com.trolltech.qt.network.QUrlInfo i2, int sortBy) {
        return __qt_lessThan_QUrlInfo_QUrlInfo_int(i1 == null ? (i1 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i1.nativeId(), i2 == null ? (i2 = new com.trolltech.qt.network.QUrlInfo()).nativeId() : i2.nativeId(), sortBy);
    }
    private native static boolean __qt_lessThan_QUrlInfo_QUrlInfo_int(long i1, long i2, int sortBy);


    public static native QUrlInfo fromNativePointer(QNativePointer nativePointer);

    protected QUrlInfo(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QUrlInfo array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.network.QUrlInfo)
            return operator_equal((com.trolltech.qt.network.QUrlInfo) other);
        return false;
    }

}
