package com.trolltech.qt.opengl;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public interface QGL
{
    public enum FormatOption implements com.trolltech.qt.QtEnumerator {
        DoubleBuffer(1),
        DepthBuffer(2),
        Rgba(4),
        AlphaChannel(8),
        AccumBuffer(16),
        StencilBuffer(32),
        StereoBuffers(64),
        DirectRendering(128),
        HasOverlay(256),
        SampleBuffers(512),
        SingleBuffer(65536),
        NoDepthBuffer(131072),
        ColorIndex(262144),
        NoAlphaChannel(524288),
        NoAccumBuffer(1048576),
        NoStencilBuffer(2097152),
        NoStereoBuffers(4194304),
        IndirectRendering(8388608),
        NoOverlay(16777216),
        NoSampleBuffers(33554432);

        FormatOption(int value) { this.value = value; }
        public int value() { return value; }

        public static FormatOptions createQFlags(FormatOption ... values) {
            return new FormatOptions(values);
        }
        public static FormatOption resolve(int value) {
            return (FormatOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DoubleBuffer;
            case 2: return DepthBuffer;
            case 4: return Rgba;
            case 8: return AlphaChannel;
            case 16: return AccumBuffer;
            case 32: return StencilBuffer;
            case 64: return StereoBuffers;
            case 128: return DirectRendering;
            case 256: return HasOverlay;
            case 512: return SampleBuffers;
            case 65536: return SingleBuffer;
            case 131072: return NoDepthBuffer;
            case 262144: return ColorIndex;
            case 524288: return NoAlphaChannel;
            case 1048576: return NoAccumBuffer;
            case 2097152: return NoStencilBuffer;
            case 4194304: return NoStereoBuffers;
            case 8388608: return IndirectRendering;
            case 16777216: return NoOverlay;
            case 33554432: return NoSampleBuffers;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FormatOptions extends com.trolltech.qt.QFlags<FormatOption> {
        private static final long serialVersionUID = 1L;
        public FormatOptions(FormatOption ... args) { super(args); }
        public FormatOptions(int value) { setValue(value); }
    }

}
