package com.trolltech.qt.opengl;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGLContext extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.opengl.QtJambi_LibraryInitializer.init();
    }
    public QGLContext(com.trolltech.qt.opengl.QGLFormat format, com.trolltech.qt.gui.QPaintDeviceInterface device) {
        super((QPrivateConstructor)null);
        __qt_QGLContext_QGLFormat_QPaintDevice(format == null ? (format = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : format.nativeId(), device == null ? 0 : device.nativeId());
    }
    private native void __qt_QGLContext_QGLFormat_QPaintDevice(long format, long device);


    public QGLContext(com.trolltech.qt.opengl.QGLFormat format) {
        super((QPrivateConstructor)null);
        __qt_QGLContext_QGLFormat(format == null ? (format = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : format.nativeId());
    }
    private native void __qt_QGLContext_QGLFormat(long format);



    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QImage image, int target) {
        return bindTexture(image, target, (int)0x1908);
    }

    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QImage image) {
        return bindTexture(image, (int)0x0DE1, (int)0x1908);
    }
    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QImage image, int target, int format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_QImage_int_int(nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), target, format);
    }
    private native static int __qt_bindTexture_QImage_int_int(long __this__nativeId, long image, int target, int format);

    @QtBlockedSlot public final int bindTexture(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_String(nativeId(), fileName);
    }
    private native static int __qt_bindTexture_String(long __this__nativeId, java.lang.String fileName);


    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QPixmap pixmap, int target) {
        return bindTexture(pixmap, target, (int)0x1908);
    }

    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QPixmap pixmap) {
        return bindTexture(pixmap, (int)0x0DE1, (int)0x1908);
    }
    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QPixmap pixmap, int target, int format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_QPixmap_int_int(nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), target, format);
    }
    private native static int __qt_bindTexture_QPixmap_int_int(long __this__nativeId, long pixmap, int target, int format);

    @QtBlockedSlot protected final int colorIndex(com.trolltech.qt.gui.QColor c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_colorIndex_QColor(nativeId(), c == null ? (c = new com.trolltech.qt.gui.QColor()).nativeId() : c.nativeId());
    }
    private native static int __qt_colorIndex_QColor(long __this__nativeId, long c);

    @QtBlockedSlot public final void deleteTexture(int tx_id) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_deleteTexture_int(nativeId(), tx_id);
    }
    private native static void __qt_deleteTexture_int(long __this__nativeId, int tx_id);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPaintDeviceInterface device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintDeviceInterface __qt_device(long __this__nativeId);

    @QtBlockedSlot protected final boolean deviceIsPixmap() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_deviceIsPixmap(nativeId());
    }
    private native static boolean __qt_deviceIsPixmap(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.opengl.QGLFormat format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.opengl.QGLFormat __qt_format(long __this__nativeId);

    @QtBlockedSlot protected final boolean initialized() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_initialized(nativeId());
    }
    private native static boolean __qt_initialized(long __this__nativeId);

    @QtBlockedSlot public final boolean isSharing() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSharing(nativeId());
    }
    private native static boolean __qt_isSharing(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor overlayTransparentColor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_overlayTransparentColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_overlayTransparentColor(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.opengl.QGLFormat requestedFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_requestedFormat(nativeId());
    }
    private native static com.trolltech.qt.opengl.QGLFormat __qt_requestedFormat(long __this__nativeId);

    @QtBlockedSlot public final void reset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);

    @QtBlockedSlot public final void setFormat(com.trolltech.qt.opengl.QGLFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_QGLFormat(nativeId(), format == null ? (format = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setFormat_QGLFormat(long __this__nativeId, long format);

    @QtBlockedSlot protected final void setInitialized(boolean on) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInitialized_boolean(nativeId(), on);
    }
    private native static void __qt_setInitialized_boolean(long __this__nativeId, boolean on);

    @QtBlockedSlot protected final void setValid(boolean valid) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setValid_boolean(nativeId(), valid);
    }
    private native static void __qt_setValid_boolean(long __this__nativeId, boolean valid);

    @QtBlockedSlot protected final void setWindowCreated(boolean on) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowCreated_boolean(nativeId(), on);
    }
    private native static void __qt_setWindowCreated_boolean(long __this__nativeId, boolean on);

    @QtBlockedSlot protected final boolean windowCreated() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowCreated(nativeId());
    }
    private native static boolean __qt_windowCreated(long __this__nativeId);


    @QtBlockedSlot protected final boolean chooseContext() {
        return chooseContext((com.trolltech.qt.opengl.QGLContext)null);
    }
    @QtBlockedSlot protected boolean chooseContext(com.trolltech.qt.opengl.QGLContext shareContext) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_chooseContext_QGLContext(nativeId(), shareContext == null ? 0 : shareContext.nativeId());
    }
    private native static boolean __qt_chooseContext_QGLContext(long __this__nativeId, long shareContext);


    @QtBlockedSlot public final boolean create() {
        return create((com.trolltech.qt.opengl.QGLContext)null);
    }
    @QtBlockedSlot public boolean create(com.trolltech.qt.opengl.QGLContext shareContext) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_create_QGLContext(nativeId(), shareContext == null ? 0 : shareContext.nativeId());
    }
    private native static boolean __qt_create_QGLContext(long __this__nativeId, long shareContext);

    @QtBlockedSlot public void doneCurrent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_doneCurrent(nativeId());
    }
    private native static void __qt_doneCurrent(long __this__nativeId);

    @QtBlockedSlot public void makeCurrent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_makeCurrent(nativeId());
    }
    private native static void __qt_makeCurrent(long __this__nativeId);

    @QtBlockedSlot public void swapBuffers() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_swapBuffers(nativeId());
    }
    private native static void __qt_swapBuffers(long __this__nativeId);

    public native static com.trolltech.qt.opengl.QGLContext currentContext();

    public native static void setTextureCacheLimit(int size);

    public native static int textureCacheLimit();


    public static native QGLContext fromNativePointer(QNativePointer nativePointer);

    protected QGLContext(QPrivateConstructor p) { super(p); } 

}
