package com.trolltech.qt.opengl;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGLFramebufferObject extends com.trolltech.qt.QtJambiObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    static {
        com.trolltech.qt.opengl.QtJambi_LibraryInitializer.init();
    }
    public enum Attachment implements com.trolltech.qt.QtEnumerator {
        NoAttachment(0),
        CombinedDepthStencil(1),
        Depth(2);

        Attachment(int value) { this.value = value; }
        public int value() { return value; }

        public static Attachment resolve(int value) {
            return (Attachment) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoAttachment;
            case 1: return CombinedDepthStencil;
            case 2: return Depth;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QGLFramebufferObject(com.trolltech.qt.core.QSize size) {
        this(size, (int)0x0DE1);
    }
    public QGLFramebufferObject(com.trolltech.qt.core.QSize size, int target) {
        super((QPrivateConstructor)null);
        __qt_QGLFramebufferObject_QSize_int(size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), target);
    }
    private native void __qt_QGLFramebufferObject_QSize_int(long size, int target);



    public QGLFramebufferObject(com.trolltech.qt.core.QSize size, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment, int target) {
        this(size, attachment, target, (int)0x8058);
    }

    public QGLFramebufferObject(com.trolltech.qt.core.QSize size, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment) {
        this(size, attachment, (int)0x0DE1, (int)0x8058);
    }
    public QGLFramebufferObject(com.trolltech.qt.core.QSize size, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment, int target, int internal_format) {
        super((QPrivateConstructor)null);
        __qt_QGLFramebufferObject_QSize_Attachment_int_int(size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), attachment.value(), target, internal_format);
    }
    private native void __qt_QGLFramebufferObject_QSize_Attachment_int_int(long size, int attachment, int target, int internal_format);



    public QGLFramebufferObject(int width, int height, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment, int target) {
        this(width, height, attachment, target, (int)0x8058);
    }

    public QGLFramebufferObject(int width, int height, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment) {
        this(width, height, attachment, (int)0x0DE1, (int)0x8058);
    }
    public QGLFramebufferObject(int width, int height, com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment, int target, int internal_format) {
        super((QPrivateConstructor)null);
        __qt_QGLFramebufferObject_int_int_Attachment_int_int(width, height, attachment.value(), target, internal_format);
    }
    private native void __qt_QGLFramebufferObject_int_int_Attachment_int_int(int width, int height, int attachment, int target, int internal_format);



    public QGLFramebufferObject(int width, int height) {
        this(width, height, (int)0x0DE1);
    }
    public QGLFramebufferObject(int width, int height, int target) {
        super((QPrivateConstructor)null);
        __qt_QGLFramebufferObject_int_int_int(width, height, target);
    }
    private native void __qt_QGLFramebufferObject_int_int_int(int width, int height, int target);


    @QtBlockedSlot public final com.trolltech.qt.opengl.QGLFramebufferObject.Attachment attachment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.opengl.QGLFramebufferObject.Attachment.resolve(__qt_attachment(nativeId()));
    }
    private native static int __qt_attachment(long __this__nativeId);

    @QtBlockedSlot public final boolean bind() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bind(nativeId());
    }
    private native static boolean __qt_bind(long __this__nativeId);

    @QtBlockedSlot public final int depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final int handle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static int __qt_handle(long __this__nativeId);

    @QtBlockedSlot public final int height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);

    @QtBlockedSlot public final boolean paintingActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final boolean release() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_release(nativeId());
    }
    private native static boolean __qt_release(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_size(long __this__nativeId);

    @QtBlockedSlot public final int texture() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_texture(nativeId());
    }
    private native static int __qt_texture(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage toImage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toImage(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_toImage(long __this__nativeId);

    @QtBlockedSlot public final int width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public int devType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric metric) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), metric.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int metric);

    @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    public native static boolean hasOpenGLFramebufferObjects();


    public static native QGLFramebufferObject fromNativePointer(QNativePointer nativePointer);

    protected QGLFramebufferObject(QPrivateConstructor p) { super(p); } 


    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);
}
