package com.trolltech.qt.opengl;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGLPixelBuffer extends com.trolltech.qt.QtJambiObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    static {
        com.trolltech.qt.opengl.QtJambi_LibraryInitializer.init();
    }

    public QGLPixelBuffer(com.trolltech.qt.core.QSize size, com.trolltech.qt.opengl.QGLFormat format) {
        this(size, format, (com.trolltech.qt.opengl.QGLWidget)null);
    }

    public QGLPixelBuffer(com.trolltech.qt.core.QSize size) {
        this(size, (com.trolltech.qt.opengl.QGLFormat)com.trolltech.qt.opengl.QGLFormat.defaultFormat(), (com.trolltech.qt.opengl.QGLWidget)null);
    }
    public QGLPixelBuffer(com.trolltech.qt.core.QSize size, com.trolltech.qt.opengl.QGLFormat format, com.trolltech.qt.opengl.QGLWidget shareWidget) {
        super((QPrivateConstructor)null);
        __qt_QGLPixelBuffer_QSize_QGLFormat_QGLWidget(size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), format == null ? (format = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : format.nativeId(), shareWidget == null ? 0 : shareWidget.nativeId());
    }
    private native void __qt_QGLPixelBuffer_QSize_QGLFormat_QGLWidget(long size, long format, long shareWidget);



    public QGLPixelBuffer(int width, int height, com.trolltech.qt.opengl.QGLFormat format) {
        this(width, height, format, (com.trolltech.qt.opengl.QGLWidget)null);
    }

    public QGLPixelBuffer(int width, int height) {
        this(width, height, (com.trolltech.qt.opengl.QGLFormat)com.trolltech.qt.opengl.QGLFormat.defaultFormat(), (com.trolltech.qt.opengl.QGLWidget)null);
    }
    public QGLPixelBuffer(int width, int height, com.trolltech.qt.opengl.QGLFormat format, com.trolltech.qt.opengl.QGLWidget shareWidget) {
        super((QPrivateConstructor)null);
        __qt_QGLPixelBuffer_int_int_QGLFormat_QGLWidget(width, height, format == null ? (format = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : format.nativeId(), shareWidget == null ? 0 : shareWidget.nativeId());
    }
    private native void __qt_QGLPixelBuffer_int_int_QGLFormat_QGLWidget(int width, int height, long format, long shareWidget);


    @QtBlockedSlot public final int bindTexture(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_String(nativeId(), fileName);
    }
    private native static int __qt_bindTexture_String(long __this__nativeId, java.lang.String fileName);


    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QImage image) {
        return bindTexture(image, (int)0x0DE1);
    }
    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QImage image, int target) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_QImage_int(nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), target);
    }
    private native static int __qt_bindTexture_QImage_int(long __this__nativeId, long image, int target);


    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QPixmap pixmap) {
        return bindTexture(pixmap, (int)0x0DE1);
    }
    @QtBlockedSlot public final int bindTexture(com.trolltech.qt.gui.QPixmap pixmap, int target) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindTexture_QPixmap_int(nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), target);
    }
    private native static int __qt_bindTexture_QPixmap_int(long __this__nativeId, long pixmap, int target);

    @QtBlockedSlot public final boolean bindToDynamicTexture(int texture) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bindToDynamicTexture_int(nativeId(), texture);
    }
    private native static boolean __qt_bindToDynamicTexture_int(long __this__nativeId, int texture);

    @QtBlockedSlot public final void deleteTexture(int texture_id) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_deleteTexture_int(nativeId(), texture_id);
    }
    private native static void __qt_deleteTexture_int(long __this__nativeId, int texture_id);

    @QtBlockedSlot public final int depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final boolean doneCurrent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_doneCurrent(nativeId());
    }
    private native static boolean __qt_doneCurrent(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.opengl.QGLFormat format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.opengl.QGLFormat __qt_format(long __this__nativeId);

    @QtBlockedSlot public final int generateDynamicTexture() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_generateDynamicTexture(nativeId());
    }
    private native static int __qt_generateDynamicTexture(long __this__nativeId);

    @QtBlockedSlot public final long handle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static long __qt_handle(long __this__nativeId);

    @QtBlockedSlot public final int height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final boolean makeCurrent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_makeCurrent(nativeId());
    }
    private native static boolean __qt_makeCurrent(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);

    @QtBlockedSlot public final boolean paintingActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final void releaseFromDynamicTexture() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_releaseFromDynamicTexture(nativeId());
    }
    private native static void __qt_releaseFromDynamicTexture(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_size(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage toImage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toImage(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_toImage(long __this__nativeId);

    @QtBlockedSlot public final void updateDynamicTexture(int texture_id) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateDynamicTexture_int(nativeId(), texture_id);
    }
    private native static void __qt_updateDynamicTexture_int(long __this__nativeId, int texture_id);

    @QtBlockedSlot public final int width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public int devType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric metric) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), metric.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int metric);

    @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    public native static boolean hasOpenGLPbuffers();


    public static native QGLPixelBuffer fromNativePointer(QNativePointer nativePointer);

    protected QGLPixelBuffer(QPrivateConstructor p) { super(p); } 


    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);
}
