package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public interface QSql
{
    public enum NumericalPrecisionPolicy implements com.trolltech.qt.QtEnumerator {
        LowPrecisionInt32(1),
        LowPrecisionInt64(2),
        LowPrecisionDouble(4),
        HighPrecision(0);

        NumericalPrecisionPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static NumericalPrecisionPolicy resolve(int value) {
            return (NumericalPrecisionPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return LowPrecisionInt32;
            case 2: return LowPrecisionInt64;
            case 4: return LowPrecisionDouble;
            case 0: return HighPrecision;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Location implements com.trolltech.qt.QtEnumerator {
        BeforeFirstRow(-1),
        AfterLastRow(-2);

        Location(int value) { this.value = value; }
        public int value() { return value; }

        public static Location resolve(int value) {
            return (Location) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return BeforeFirstRow;
            case -2: return AfterLastRow;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ParamTypeFlag implements com.trolltech.qt.QtEnumerator {
        In(1),
        Out(2),
        InOut(3),
        Binary(4);

        ParamTypeFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static ParamType createQFlags(ParamTypeFlag ... values) {
            return new ParamType(values);
        }
        public static ParamTypeFlag resolve(int value) {
            return (ParamTypeFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return In;
            case 2: return Out;
            case 3: return InOut;
            case 4: return Binary;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ParamType extends com.trolltech.qt.QFlags<ParamTypeFlag> {
        private static final long serialVersionUID = 1L;
        public ParamType(ParamTypeFlag ... args) { super(args); }
        public ParamType(int value) { setValue(value); }
    }

    public enum TableType implements com.trolltech.qt.QtEnumerator {
        Tables(1),
        SystemTables(2),
        Views(4),
        AllTables(255);

        TableType(int value) { this.value = value; }
        public int value() { return value; }

        public static TableType resolve(int value) {
            return (TableType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Tables;
            case 2: return SystemTables;
            case 4: return Views;
            case 255: return AllTables;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
}
