package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSqlError extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.sql.QtJambi_LibraryInitializer.init();
    }
    public enum ErrorType implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        ConnectionError(1),
        StatementError(2),
        TransactionError(3),
        UnknownError(4);

        ErrorType(int value) { this.value = value; }
        public int value() { return value; }

        public static ErrorType resolve(int value) {
            return (ErrorType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return ConnectionError;
            case 2: return StatementError;
            case 3: return TransactionError;
            case 4: return UnknownError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSqlError(java.lang.String driverText, java.lang.String databaseText, com.trolltech.qt.sql.QSqlError.ErrorType type) {
        this(driverText, databaseText, type, (int)-1);
    }

    public QSqlError(java.lang.String driverText, java.lang.String databaseText) {
        this(driverText, databaseText, com.trolltech.qt.sql.QSqlError.ErrorType.NoError, (int)-1);
    }

    public QSqlError(java.lang.String driverText) {
        this(driverText, (java.lang.String)"", com.trolltech.qt.sql.QSqlError.ErrorType.NoError, (int)-1);
    }

    public QSqlError() {
        this((java.lang.String)"", (java.lang.String)"", com.trolltech.qt.sql.QSqlError.ErrorType.NoError, (int)-1);
    }
    public QSqlError(java.lang.String driverText, java.lang.String databaseText, com.trolltech.qt.sql.QSqlError.ErrorType type, int number) {
        super((QPrivateConstructor)null);
        __qt_QSqlError_String_String_ErrorType_int(driverText, databaseText, type.value(), number);
    }
    private native void __qt_QSqlError_String_String_ErrorType_int(java.lang.String driverText, java.lang.String databaseText, int type, int number);


    public QSqlError(com.trolltech.qt.sql.QSqlError other) {
        super((QPrivateConstructor)null);
        __qt_QSqlError_QSqlError(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QSqlError_QSqlError(long other);


    @QtBlockedSlot public final java.lang.String databaseText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_databaseText(nativeId());
    }
    private native static java.lang.String __qt_databaseText(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String driverText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_driverText(nativeId());
    }
    private native static java.lang.String __qt_driverText(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final int number() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_number(nativeId());
    }
    private native static int __qt_number(long __this__nativeId);

    @QtBlockedSlot public final void setDatabaseText(java.lang.String databaseText) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDatabaseText_String(nativeId(), databaseText);
    }
    private native static void __qt_setDatabaseText_String(long __this__nativeId, java.lang.String databaseText);

    @QtBlockedSlot public final void setDriverText(java.lang.String driverText) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDriverText_String(nativeId(), driverText);
    }
    private native static void __qt_setDriverText_String(long __this__nativeId, java.lang.String driverText);

    @QtBlockedSlot public final void setNumber(int number) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumber_int(nativeId(), number);
    }
    private native static void __qt_setNumber_int(long __this__nativeId, int number);

    @QtBlockedSlot public final void setType(com.trolltech.qt.sql.QSqlError.ErrorType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setType_ErrorType(nativeId(), type.value());
    }
    private native static void __qt_setType_ErrorType(long __this__nativeId, int type);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlError.ErrorType type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.sql.QSqlError.ErrorType.resolve(__qt_type(nativeId()));
    }
    private native static int __qt_type(long __this__nativeId);


    public static native QSqlError fromNativePointer(QNativePointer nativePointer);

    protected QSqlError(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QSqlError array[]);
}
