package com.trolltech.qt.xml;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDomNode extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.xml.QtJambi_LibraryInitializer.init();
    }
    public enum NodeType implements com.trolltech.qt.QtEnumerator {
        ElementNode(1),
        AttributeNode(2),
        TextNode(3),
        CDATASectionNode(4),
        EntityReferenceNode(5),
        EntityNode(6),
        ProcessingInstructionNode(7),
        CommentNode(8),
        DocumentNode(9),
        DocumentTypeNode(10),
        DocumentFragmentNode(11),
        NotationNode(12),
        BaseNode(21),
        CharacterDataNode(22);

        NodeType(int value) { this.value = value; }
        public int value() { return value; }

        public static NodeType resolve(int value) {
            return (NodeType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return ElementNode;
            case 2: return AttributeNode;
            case 3: return TextNode;
            case 4: return CDATASectionNode;
            case 5: return EntityReferenceNode;
            case 6: return EntityNode;
            case 7: return ProcessingInstructionNode;
            case 8: return CommentNode;
            case 9: return DocumentNode;
            case 10: return DocumentTypeNode;
            case 11: return DocumentFragmentNode;
            case 12: return NotationNode;
            case 21: return BaseNode;
            case 22: return CharacterDataNode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum EncodingPolicy implements com.trolltech.qt.QtEnumerator {
        EncodingFromDocument(1),
        EncodingFromTextStream(2);

        EncodingPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static EncodingPolicy resolve(int value) {
            return (EncodingPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return EncodingFromDocument;
            case 2: return EncodingFromTextStream;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QDomNode() {
        super((QPrivateConstructor)null);
        __qt_QDomNode();
    }
    private native void __qt_QDomNode();


    public QDomNode(com.trolltech.qt.xml.QDomNode arg__1) {
        super((QPrivateConstructor)null);
        __qt_QDomNode_QDomNode(arg__1 == null ? (arg__1 = new com.trolltech.qt.xml.QDomNode()).nativeId() : arg__1.nativeId());
    }
    private native void __qt_QDomNode_QDomNode(long arg__1);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode appendChild(com.trolltech.qt.xml.QDomNode newChild) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_appendChild_QDomNode(nativeId(), newChild == null ? (newChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : newChild.nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_appendChild_QDomNode(long __this__nativeId, long newChild);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNodeList childNodes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childNodes(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNodeList __qt_childNodes(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode cloneNode() {
        return cloneNode((boolean)true);
    }
    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode cloneNode(boolean deep) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cloneNode_boolean(nativeId(), deep);
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_cloneNode_boolean(long __this__nativeId, boolean deep);

    @QtBlockedSlot public final int columnNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnNumber(nativeId());
    }
    private native static int __qt_columnNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode firstChild() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_firstChild(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_firstChild(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement firstChildElement() {
        return firstChildElement((java.lang.String)"");
    }
    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement firstChildElement(java.lang.String tagName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_firstChildElement_String(nativeId(), tagName);
    }
    private native static com.trolltech.qt.xml.QDomElement __qt_firstChildElement_String(long __this__nativeId, java.lang.String tagName);

    @QtBlockedSlot public final boolean hasAttributes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasAttributes(nativeId());
    }
    private native static boolean __qt_hasAttributes(long __this__nativeId);

    @QtBlockedSlot public final boolean hasChildNodes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasChildNodes(nativeId());
    }
    private native static boolean __qt_hasChildNodes(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode insertAfter(com.trolltech.qt.xml.QDomNode newChild, com.trolltech.qt.xml.QDomNode refChild) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertAfter_QDomNode_QDomNode(nativeId(), newChild == null ? (newChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : newChild.nativeId(), refChild == null ? (refChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : refChild.nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_insertAfter_QDomNode_QDomNode(long __this__nativeId, long newChild, long refChild);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode insertBefore(com.trolltech.qt.xml.QDomNode newChild, com.trolltech.qt.xml.QDomNode refChild) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertBefore_QDomNode_QDomNode(nativeId(), newChild == null ? (newChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : newChild.nativeId(), refChild == null ? (refChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : refChild.nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_insertBefore_QDomNode_QDomNode(long __this__nativeId, long newChild, long refChild);

    @QtBlockedSlot public final boolean isAttr() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAttr(nativeId());
    }
    private native static boolean __qt_isAttr(long __this__nativeId);

    @QtBlockedSlot public final boolean isCDATASection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCDATASection(nativeId());
    }
    private native static boolean __qt_isCDATASection(long __this__nativeId);

    @QtBlockedSlot public final boolean isCharacterData() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCharacterData(nativeId());
    }
    private native static boolean __qt_isCharacterData(long __this__nativeId);

    @QtBlockedSlot public final boolean isComment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isComment(nativeId());
    }
    private native static boolean __qt_isComment(long __this__nativeId);

    @QtBlockedSlot public final boolean isDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDocument(nativeId());
    }
    private native static boolean __qt_isDocument(long __this__nativeId);

    @QtBlockedSlot public final boolean isDocumentFragment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDocumentFragment(nativeId());
    }
    private native static boolean __qt_isDocumentFragment(long __this__nativeId);

    @QtBlockedSlot public final boolean isDocumentType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDocumentType(nativeId());
    }
    private native static boolean __qt_isDocumentType(long __this__nativeId);

    @QtBlockedSlot public final boolean isElement() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isElement(nativeId());
    }
    private native static boolean __qt_isElement(long __this__nativeId);

    @QtBlockedSlot public final boolean isEntity() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEntity(nativeId());
    }
    private native static boolean __qt_isEntity(long __this__nativeId);

    @QtBlockedSlot public final boolean isEntityReference() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEntityReference(nativeId());
    }
    private native static boolean __qt_isEntityReference(long __this__nativeId);

    @QtBlockedSlot public final boolean isNotation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNotation(nativeId());
    }
    private native static boolean __qt_isNotation(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final boolean isProcessingInstruction() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isProcessingInstruction(nativeId());
    }
    private native static boolean __qt_isProcessingInstruction(long __this__nativeId);

    @QtBlockedSlot public final boolean isSupported(java.lang.String feature, java.lang.String version) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSupported_String_String(nativeId(), feature, version);
    }
    private native static boolean __qt_isSupported_String_String(long __this__nativeId, java.lang.String feature, java.lang.String version);

    @QtBlockedSlot public final boolean isText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isText(nativeId());
    }
    private native static boolean __qt_isText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode lastChild() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastChild(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_lastChild(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement lastChildElement() {
        return lastChildElement((java.lang.String)"");
    }
    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement lastChildElement(java.lang.String tagName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastChildElement_String(nativeId(), tagName);
    }
    private native static com.trolltech.qt.xml.QDomElement __qt_lastChildElement_String(long __this__nativeId, java.lang.String tagName);

    @QtBlockedSlot public final int lineNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineNumber(nativeId());
    }
    private native static int __qt_lineNumber(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String localName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_localName(nativeId());
    }
    private native static java.lang.String __qt_localName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode namedItem(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_namedItem_String(nativeId(), name);
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_namedItem_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final java.lang.String namespaceURI() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_namespaceURI(nativeId());
    }
    private native static java.lang.String __qt_namespaceURI(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode nextSibling() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextSibling(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_nextSibling(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement nextSiblingElement() {
        return nextSiblingElement((java.lang.String)"");
    }
    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement nextSiblingElement(java.lang.String taName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextSiblingElement_String(nativeId(), taName);
    }
    private native static com.trolltech.qt.xml.QDomElement __qt_nextSiblingElement_String(long __this__nativeId, java.lang.String taName);

    @QtBlockedSlot public final java.lang.String nodeName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nodeName(nativeId());
    }
    private native static java.lang.String __qt_nodeName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode.NodeType nodeType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.xml.QDomNode.NodeType.resolve(__qt_nodeType(nativeId()));
    }
    private native static int __qt_nodeType(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String nodeValue() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nodeValue(nativeId());
    }
    private native static java.lang.String __qt_nodeValue(long __this__nativeId);

    @QtBlockedSlot public final void normalize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_normalize(nativeId());
    }
    private native static void __qt_normalize(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QTextStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QTextStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QTextStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.xml.QDomNode arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QDomNode(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.xml.QDomNode()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_operator_equal_QDomNode(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomDocument ownerDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ownerDocument(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomDocument __qt_ownerDocument(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode parentNode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parentNode(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_parentNode(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String prefix() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_prefix(nativeId());
    }
    private native static java.lang.String __qt_prefix(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode previousSibling() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_previousSibling(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_previousSibling(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement previousSiblingElement() {
        return previousSiblingElement((java.lang.String)"");
    }
    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement previousSiblingElement(java.lang.String tagName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_previousSiblingElement_String(nativeId(), tagName);
    }
    private native static com.trolltech.qt.xml.QDomElement __qt_previousSiblingElement_String(long __this__nativeId, java.lang.String tagName);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode removeChild(com.trolltech.qt.xml.QDomNode oldChild) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_removeChild_QDomNode(nativeId(), oldChild == null ? (oldChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : oldChild.nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_removeChild_QDomNode(long __this__nativeId, long oldChild);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNode replaceChild(com.trolltech.qt.xml.QDomNode newChild, com.trolltech.qt.xml.QDomNode oldChild) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_replaceChild_QDomNode_QDomNode(nativeId(), newChild == null ? (newChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : newChild.nativeId(), oldChild == null ? (oldChild = new com.trolltech.qt.xml.QDomNode()).nativeId() : oldChild.nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNode __qt_replaceChild_QDomNode_QDomNode(long __this__nativeId, long newChild, long oldChild);

    @QtBlockedSlot public final void save(com.trolltech.qt.core.QTextStream arg__1, int arg__2, com.trolltech.qt.xml.QDomNode.EncodingPolicy arg__3) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_save_QTextStream_int_EncodingPolicy(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2, arg__3.value());
    }
    private native static void __qt_save_QTextStream_int_EncodingPolicy(long __this__nativeId, long arg__1, int arg__2, int arg__3);

    @QtBlockedSlot public final void save(com.trolltech.qt.core.QTextStream arg__1, int arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_save_QTextStream_int(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2);
    }
    private native static void __qt_save_QTextStream_int(long __this__nativeId, long arg__1, int arg__2);

    @QtBlockedSlot public final void setNodeValue(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNodeValue_String(nativeId(), arg__1);
    }
    private native static void __qt_setNodeValue_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setPrefix(java.lang.String pre) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrefix_String(nativeId(), pre);
    }
    private native static void __qt_setPrefix_String(long __this__nativeId, java.lang.String pre);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomAttr toAttr() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toAttr(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomAttr __qt_toAttr(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomCDATASection toCDATASection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toCDATASection(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomCDATASection __qt_toCDATASection(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomCharacterData toCharacterData() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toCharacterData(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomCharacterData __qt_toCharacterData(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomComment toComment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toComment(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomComment __qt_toComment(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomDocument toDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toDocument(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomDocument __qt_toDocument(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomDocumentFragment toDocumentFragment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toDocumentFragment(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomDocumentFragment __qt_toDocumentFragment(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomDocumentType toDocumentType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toDocumentType(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomDocumentType __qt_toDocumentType(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomElement toElement() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toElement(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomElement __qt_toElement(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomEntity toEntity() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toEntity(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomEntity __qt_toEntity(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomEntityReference toEntityReference() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toEntityReference(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomEntityReference __qt_toEntityReference(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomNotation toNotation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toNotation(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomNotation __qt_toNotation(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomProcessingInstruction toProcessingInstruction() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toProcessingInstruction(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomProcessingInstruction __qt_toProcessingInstruction(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QDomText toText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toText(nativeId());
    }
    private native static com.trolltech.qt.xml.QDomText __qt_toText(long __this__nativeId);


    public static native QDomNode fromNativePointer(QNativePointer nativePointer);

    protected QDomNode(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QDomNode array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.xml.QDomNode)
            return operator_equal((com.trolltech.qt.xml.QDomNode) other);
        return false;
    }

}
