package com.trolltech.qt.xml;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QXmlStreamReader extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.xml.QtJambi_LibraryInitializer.init();
    }
    public enum Error implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        UnexpectedElementError(1),
        CustomError(2),
        NotWellFormedError(3),
        PrematureEndOfDocumentError(4);

        Error(int value) { this.value = value; }
        public int value() { return value; }

        public static Error resolve(int value) {
            return (Error) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return UnexpectedElementError;
            case 2: return CustomError;
            case 3: return NotWellFormedError;
            case 4: return PrematureEndOfDocumentError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TokenType implements com.trolltech.qt.QtEnumerator {
        NoToken(0),
        Invalid(1),
        StartDocument(2),
        EndDocument(3),
        StartElement(4),
        EndElement(5),
        Characters(6),
        Comment(7),
        DTD(8),
        EntityReference(9),
        ProcessingInstruction(10);

        TokenType(int value) { this.value = value; }
        public int value() { return value; }

        public static TokenType resolve(int value) {
            return (TokenType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoToken;
            case 1: return Invalid;
            case 2: return StartDocument;
            case 3: return EndDocument;
            case 4: return StartElement;
            case 5: return EndElement;
            case 6: return Characters;
            case 7: return Comment;
            case 8: return DTD;
            case 9: return EntityReference;
            case 10: return ProcessingInstruction;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QXmlStreamReader(com.trolltech.qt.core.QByteArray data) {
        super((QPrivateConstructor)null);
        __qt_QXmlStreamReader_QByteArray(data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId());
    }
    private native void __qt_QXmlStreamReader_QByteArray(long data);


    public QXmlStreamReader(java.lang.String data) {
        super((QPrivateConstructor)null);
        __qt_QXmlStreamReader_String(data);
    }
    private native void __qt_QXmlStreamReader_String(java.lang.String data);


    public QXmlStreamReader() {
        super((QPrivateConstructor)null);
        __qt_QXmlStreamReader();
    }
    private native void __qt_QXmlStreamReader();


    public QXmlStreamReader(com.trolltech.qt.core.QIODevice device) {
        super((QPrivateConstructor)null);
        __qt_QXmlStreamReader_QIODevice(device == null ? 0 : device.nativeId());
    }
    private native void __qt_QXmlStreamReader_QIODevice(long device);


    @QtBlockedSlot public final void addData(com.trolltech.qt.core.QByteArray data) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addData_QByteArray(nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId());
    }
    private native static void __qt_addData_QByteArray(long __this__nativeId, long data);

    @QtBlockedSlot public final void addData(java.lang.String data) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addData_String(nativeId(), data);
    }
    private native static void __qt_addData_String(long __this__nativeId, java.lang.String data);

    @QtBlockedSlot public final boolean atEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QXmlStreamAttributes attributes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_attributes(nativeId());
    }
    private native static com.trolltech.qt.xml.QXmlStreamAttributes __qt_attributes(long __this__nativeId);

    @QtBlockedSlot public final long characterOffset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_characterOffset(nativeId());
    }
    private native static long __qt_characterOffset(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    __rcDevice = null; // clear() call removes device from stream

    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final long columnNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnNumber(nativeId());
    }
    private native static long __qt_columnNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.xml.QXmlStreamEntityDeclaration> entityDeclarations() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entityDeclarations(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.xml.QXmlStreamEntityDeclaration> __qt_entityDeclarations(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QXmlStreamReader.Error error() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.xml.QXmlStreamReader.Error.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final boolean hasError() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasError(nativeId());
    }
    private native static boolean __qt_hasError(long __this__nativeId);

    @QtBlockedSlot public final boolean isCDATA() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCDATA(nativeId());
    }
    private native static boolean __qt_isCDATA(long __this__nativeId);

    @QtBlockedSlot public final boolean isCharacters() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCharacters(nativeId());
    }
    private native static boolean __qt_isCharacters(long __this__nativeId);

    @QtBlockedSlot public final boolean isComment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isComment(nativeId());
    }
    private native static boolean __qt_isComment(long __this__nativeId);

    @QtBlockedSlot public final boolean isDTD() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDTD(nativeId());
    }
    private native static boolean __qt_isDTD(long __this__nativeId);

    @QtBlockedSlot public final boolean isEndDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEndDocument(nativeId());
    }
    private native static boolean __qt_isEndDocument(long __this__nativeId);

    @QtBlockedSlot public final boolean isEndElement() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEndElement(nativeId());
    }
    private native static boolean __qt_isEndElement(long __this__nativeId);

    @QtBlockedSlot public final boolean isEntityReference() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEntityReference(nativeId());
    }
    private native static boolean __qt_isEntityReference(long __this__nativeId);

    @QtBlockedSlot public final boolean isProcessingInstruction() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isProcessingInstruction(nativeId());
    }
    private native static boolean __qt_isProcessingInstruction(long __this__nativeId);

    @QtBlockedSlot public final boolean isStandaloneDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isStandaloneDocument(nativeId());
    }
    private native static boolean __qt_isStandaloneDocument(long __this__nativeId);

    @QtBlockedSlot public final boolean isStartDocument() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isStartDocument(nativeId());
    }
    private native static boolean __qt_isStartDocument(long __this__nativeId);

    @QtBlockedSlot public final boolean isStartElement() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isStartElement(nativeId());
    }
    private native static boolean __qt_isStartElement(long __this__nativeId);

    @QtBlockedSlot public final boolean isWhitespace() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWhitespace(nativeId());
    }
    private native static boolean __qt_isWhitespace(long __this__nativeId);

    @QtBlockedSlot public final long lineNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineNumber(nativeId());
    }
    private native static long __qt_lineNumber(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String name() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_name(nativeId());
    }
    private native static java.lang.String __qt_name(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.xml.QXmlStreamNamespaceDeclaration> namespaceDeclarations() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_namespaceDeclarations(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.xml.QXmlStreamNamespaceDeclaration> __qt_namespaceDeclarations(long __this__nativeId);

    @QtBlockedSlot public final boolean namespaceProcessing() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_namespaceProcessing(nativeId());
    }
    private native static boolean __qt_namespaceProcessing(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String namespaceUri() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_namespaceUri(nativeId());
    }
    private native static java.lang.String __qt_namespaceUri(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.xml.QXmlStreamNotationDeclaration> notationDeclarations() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_notationDeclarations(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.xml.QXmlStreamNotationDeclaration> __qt_notationDeclarations(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String processingInstructionData() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_processingInstructionData(nativeId());
    }
    private native static java.lang.String __qt_processingInstructionData(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String processingInstructionTarget() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_processingInstructionTarget(nativeId());
    }
    private native static java.lang.String __qt_processingInstructionTarget(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String qualifiedName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_qualifiedName(nativeId());
    }
    private native static java.lang.String __qt_qualifiedName(long __this__nativeId);


    @QtBlockedSlot public final void raiseError() {
        raiseError((java.lang.String)"");
    }
    @QtBlockedSlot public final void raiseError(java.lang.String message) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_raiseError_String(nativeId(), message);
    }
    private native static void __qt_raiseError_String(long __this__nativeId, java.lang.String message);

    @QtBlockedSlot public final java.lang.String readElementText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readElementText(nativeId());
    }
    private native static java.lang.String __qt_readElementText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QXmlStreamReader.TokenType readNext() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.xml.QXmlStreamReader.TokenType.resolve(__qt_readNext(nativeId()));
    }
    private native static int __qt_readNext(long __this__nativeId);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setNamespaceProcessing(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNamespaceProcessing_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setNamespaceProcessing_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String tokenString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tokenString(nativeId());
    }
    private native static java.lang.String __qt_tokenString(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.xml.QXmlStreamReader.TokenType tokenType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.xml.QXmlStreamReader.TokenType.resolve(__qt_tokenType(nativeId()));
    }
    private native static int __qt_tokenType(long __this__nativeId);


    public static native QXmlStreamReader fromNativePointer(QNativePointer nativePointer);

    protected QXmlStreamReader(QPrivateConstructor p) { super(p); } 

}
