package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QAbstractFileEngine extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum FileName implements com.trolltech.qt.QtEnumerator {
        DefaultName(0),
        BaseName(1),
        PathName(2),
        AbsoluteName(3),
        AbsolutePathName(4),
        LinkName(5),
        CanonicalName(6),
        CanonicalPathName(7),
        BundleName(8);

        FileName(int value) { this.value = value; }
        public int value() { return value; }

        public static FileName resolve(int value) {
            return (FileName) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return DefaultName;
            case 1: return BaseName;
            case 2: return PathName;
            case 3: return AbsoluteName;
            case 4: return AbsolutePathName;
            case 5: return LinkName;
            case 6: return CanonicalName;
            case 7: return CanonicalPathName;
            case 8: return BundleName;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FileTime implements com.trolltech.qt.QtEnumerator {
        CreationTime(0),
        ModificationTime(1),
        AccessTime(2);

        FileTime(int value) { this.value = value; }
        public int value() { return value; }

        public static FileTime resolve(int value) {
            return (FileTime) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CreationTime;
            case 1: return ModificationTime;
            case 2: return AccessTime;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FileOwner implements com.trolltech.qt.QtEnumerator {
        OwnerUser(0),
        OwnerGroup(1);

        FileOwner(int value) { this.value = value; }
        public int value() { return value; }

        public static FileOwner resolve(int value) {
            return (FileOwner) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OwnerUser;
            case 1: return OwnerGroup;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Extension implements com.trolltech.qt.QtEnumerator {
        AtEndExtension(0),
        FastReadLineExtension(1),
        CustomEnum(0);

        Extension(int value) { this.value = value; }
        public int value() { return value; }

        public static Extension resolve(int value) {
            return (Extension) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AtEndExtension;
            case 1: return FastReadLineExtension;
            }
            if (enumCache == null)
                enumCache = new java.util.HashMap<Integer, Extension>();
            Extension e = enumCache.get(value);
            if (e == null) {
                e = (Extension) com.trolltech.qt.QtJambiInternal.createExtendedEnum(value, CustomEnum.ordinal(), Extension.class, CustomEnum.name());
                enumCache.put(value, e);
            }
            return e;
        }
        private final int value;

        private static java.util.HashMap<Integer, Extension> enumCache;    }
    public enum FileFlag implements com.trolltech.qt.QtEnumerator {
        ReadOwnerPerm(16384),
        WriteOwnerPerm(8192),
        ExeOwnerPerm(4096),
        ReadUserPerm(1024),
        WriteUserPerm(512),
        ExeUserPerm(256),
        ReadGroupPerm(64),
        WriteGroupPerm(32),
        ExeGroupPerm(16),
        ReadOtherPerm(4),
        WriteOtherPerm(2),
        ExeOtherPerm(1),
        LinkType(65536),
        FileType(131072),
        DirectoryType(262144),
        BundleType(524288),
        HiddenFlag(1048576),
        LocalDiskFlag(2097152),
        ExistsFlag(4194304),
        RootFlag(8388608),
        Refresh(16777216),
        PermsMask(65535),
        TypesMask(983040),
        FlagsMask(267386880),
        FileInfoAll(268435455);

        FileFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static FileFlags createQFlags(FileFlag ... values) {
            return new FileFlags(values);
        }
        public static FileFlag resolve(int value) {
            return (FileFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 16384: return ReadOwnerPerm;
            case 8192: return WriteOwnerPerm;
            case 4096: return ExeOwnerPerm;
            case 1024: return ReadUserPerm;
            case 512: return WriteUserPerm;
            case 256: return ExeUserPerm;
            case 64: return ReadGroupPerm;
            case 32: return WriteGroupPerm;
            case 16: return ExeGroupPerm;
            case 4: return ReadOtherPerm;
            case 2: return WriteOtherPerm;
            case 1: return ExeOtherPerm;
            case 65536: return LinkType;
            case 131072: return FileType;
            case 262144: return DirectoryType;
            case 524288: return BundleType;
            case 1048576: return HiddenFlag;
            case 2097152: return LocalDiskFlag;
            case 4194304: return ExistsFlag;
            case 8388608: return RootFlag;
            case 16777216: return Refresh;
            case 65535: return PermsMask;
            case 983040: return TypesMask;
            case 267386880: return FlagsMask;
            case 268435455: return FileInfoAll;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FileFlags extends com.trolltech.qt.QFlags<FileFlag> {
        private static final long serialVersionUID = 1L;
        public FileFlags(FileFlag ... args) { super(args); }
        public FileFlags(int value) { setValue(value); }
    }


    protected QAbstractFileEngine() {
        super((QPrivateConstructor)null);
        __qt_QAbstractFileEngine();
    }
    private native void __qt_QAbstractFileEngine();


    @QtBlockedSlot public final boolean atEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QFile.FileError error() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QFile.FileError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot protected final void setError(com.trolltech.qt.core.QFile.FileError error, java.lang.String str) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setError_FileError_String(nativeId(), error.value(), str);
    }
    private native static void __qt_setError_FileError_String(long __this__nativeId, int error, java.lang.String str);

    @QtBlockedSlot public boolean caseSensitive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_caseSensitive(nativeId());
    }
    private native static boolean __qt_caseSensitive(long __this__nativeId);

    @QtBlockedSlot public boolean close() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_close(nativeId());
    }
    private native static boolean __qt_close(long __this__nativeId);

    @QtBlockedSlot public boolean copy(java.lang.String newName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_copy_String(nativeId(), newName);
    }
    private native static boolean __qt_copy_String(long __this__nativeId, java.lang.String newName);

    @QtBlockedSlot public java.util.List<java.lang.String> entryList(com.trolltech.qt.core.QDir.Filters filters, java.util.List<java.lang.String> filterNames) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entryList_Filters_List(nativeId(), filters.value(), filterNames);
    }
    private native static java.util.List<java.lang.String> __qt_entryList_Filters_List(long __this__nativeId, int filters, java.util.List<java.lang.String> filterNames);


    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractFileEngine.FileFlags fileFlags(com.trolltech.qt.core.QAbstractFileEngine.FileFlag ... type) {
        return this.fileFlags(new com.trolltech.qt.core.QAbstractFileEngine.FileFlags(type));
    }

    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractFileEngine.FileFlags fileFlags() {
        return fileFlags(new com.trolltech.qt.core.QAbstractFileEngine.FileFlags(268435455));
    }
    @QtBlockedSlot public com.trolltech.qt.core.QAbstractFileEngine.FileFlags fileFlags(com.trolltech.qt.core.QAbstractFileEngine.FileFlags type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QAbstractFileEngine.FileFlags(__qt_fileFlags_FileFlags(nativeId(), type.value()));
    }
    private native static int __qt_fileFlags_FileFlags(long __this__nativeId, int type);


    @QtBlockedSlot public final java.lang.String fileName() {
        return fileName(com.trolltech.qt.core.QAbstractFileEngine.FileName.DefaultName);
    }
    @QtBlockedSlot public java.lang.String fileName(com.trolltech.qt.core.QAbstractFileEngine.FileName file) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName_FileName(nativeId(), file.value());
    }
    private native static java.lang.String __qt_fileName_FileName(long __this__nativeId, int file);

    @QtBlockedSlot public com.trolltech.qt.core.QDateTime fileTime(com.trolltech.qt.core.QAbstractFileEngine.FileTime time) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileTime_FileTime(nativeId(), time.value());
    }
    private native static com.trolltech.qt.core.QDateTime __qt_fileTime_FileTime(long __this__nativeId, int time);

    @QtBlockedSlot public boolean flush() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_flush(nativeId());
    }
    private native static boolean __qt_flush(long __this__nativeId);

    @QtBlockedSlot public int handle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static int __qt_handle(long __this__nativeId);

    @QtBlockedSlot public boolean isRelativePath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRelativePath(nativeId());
    }
    private native static boolean __qt_isRelativePath(long __this__nativeId);

    @QtBlockedSlot public boolean isSequential() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSequential(nativeId());
    }
    private native static boolean __qt_isSequential(long __this__nativeId);

    @QtBlockedSlot public boolean link(java.lang.String newName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_link_String(nativeId(), newName);
    }
    private native static boolean __qt_link_String(long __this__nativeId, java.lang.String newName);

    @QtBlockedSlot public boolean mkdir(java.lang.String dirName, boolean createParentDirectories) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mkdir_String_boolean(nativeId(), dirName, createParentDirectories);
    }
    private native static boolean __qt_mkdir_String_boolean(long __this__nativeId, java.lang.String dirName, boolean createParentDirectories);


    @QtBlockedSlot public final boolean open(com.trolltech.qt.core.QIODevice.OpenModeFlag ... openMode) {
        return this.open(new com.trolltech.qt.core.QIODevice.OpenMode(openMode));
    }
    @QtBlockedSlot public boolean open(com.trolltech.qt.core.QIODevice.OpenMode openMode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_open_OpenMode(nativeId(), openMode.value());
    }
    private native static boolean __qt_open_OpenMode(long __this__nativeId, int openMode);

    @QtBlockedSlot public java.lang.String owner(com.trolltech.qt.core.QAbstractFileEngine.FileOwner arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_owner_FileOwner(nativeId(), arg__1.value());
    }
    private native static java.lang.String __qt_owner_FileOwner(long __this__nativeId, int arg__1);

    @QtBlockedSlot public int ownerId(com.trolltech.qt.core.QAbstractFileEngine.FileOwner arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ownerId_FileOwner(nativeId(), arg__1.value());
    }
    private native static int __qt_ownerId_FileOwner(long __this__nativeId, int arg__1);

    @QtBlockedSlot public long pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static long __qt_pos(long __this__nativeId);

    @QtBlockedSlot public long read(com.trolltech.qt.QNativePointer data, long maxlen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_read_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public long readLine(com.trolltech.qt.QNativePointer data, long maxlen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLine_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_readLine_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public boolean remove() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_remove(nativeId());
    }
    private native static boolean __qt_remove(long __this__nativeId);

    @QtBlockedSlot public boolean rename(java.lang.String newName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rename_String(nativeId(), newName);
    }
    private native static boolean __qt_rename_String(long __this__nativeId, java.lang.String newName);

    @QtBlockedSlot public boolean rmdir(java.lang.String dirName, boolean recurseParentDirectories) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rmdir_String_boolean(nativeId(), dirName, recurseParentDirectories);
    }
    private native static boolean __qt_rmdir_String_boolean(long __this__nativeId, java.lang.String dirName, boolean recurseParentDirectories);

    @QtBlockedSlot public boolean seek(long pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_seek_long(nativeId(), pos);
    }
    private native static boolean __qt_seek_long(long __this__nativeId, long pos);

    @QtBlockedSlot public void setFileName(java.lang.String file) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileName_String(nativeId(), file);
    }
    private native static void __qt_setFileName_String(long __this__nativeId, java.lang.String file);

    @QtBlockedSlot public boolean setPermissions(int perms) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setPermissions_int(nativeId(), perms);
    }
    private native static boolean __qt_setPermissions_int(long __this__nativeId, int perms);

    @QtBlockedSlot public boolean setSize(long size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setSize_long(nativeId(), size);
    }
    private native static boolean __qt_setSize_long(long __this__nativeId, long size);

    @QtBlockedSlot public long size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static long __qt_size(long __this__nativeId);

    @QtBlockedSlot public boolean supportsExtension(com.trolltech.qt.core.QAbstractFileEngine.Extension extension) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsExtension_Extension(nativeId(), extension.value());
    }
    private native static boolean __qt_supportsExtension_Extension(long __this__nativeId, int extension);

    @QtBlockedSlot public long write(com.trolltech.qt.QNativePointer data, long len) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_write_nativepointer_long(nativeId(), data, len);
    }
    private native static long __qt_write_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long len);

    public native static com.trolltech.qt.core.QAbstractFileEngine create(java.lang.String fileName);


    public static native QAbstractFileEngine fromNativePointer(QNativePointer nativePointer);

    protected QAbstractFileEngine(QPrivateConstructor p) { super(p); } 

}
