package com.trolltech.qt.core;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QCoreApplication extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private static java.util.Collection<Object> __rcTranslators = new java.util.ArrayList<Object>();
    public enum Encoding implements com.trolltech.qt.QtEnumerator {
        CodecForTr(0),
        UnicodeUTF8(1),
;

        Encoding(int value) { this.value = value; }
        public int value() { return value; }

        public static Encoding resolve(int value) {
            return (Encoding) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CodecForTr;
            case 1: return UnicodeUTF8;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 aboutToQuit = new Signal0();

    @SuppressWarnings("unused")
    private final void aboutToQuit() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_aboutToQuit(nativeId());
    }
    private native static void __qt_aboutToQuit(long __this__nativeId);

    public final Signal1<java.lang.Integer> unixSignal = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void unixSignal(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unixSignal_int(nativeId(), arg__1);
    }
    private native static void __qt_unixSignal_int(long __this__nativeId, int arg__1);

    @SuppressWarnings("unused")
    private QCoreApplication(com.trolltech.qt.QNativePointer argc, com.trolltech.qt.QNativePointer argv) {
        super((QPrivateConstructor)null);
        __qt_QCoreApplication_nativepointer_nativepointer(argc, argv);
    }
    private native void __qt_QCoreApplication_nativepointer_nativepointer(com.trolltech.qt.QNativePointer argc, com.trolltech.qt.QNativePointer argv);


    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean notify(com.trolltech.qt.core.QObject arg__1, com.trolltech.qt.core.QEvent arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_notify_QObject_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static boolean __qt_notify_QObject_QEvent(long __this__nativeId, long arg__1, long arg__2);

    public native static void addLibraryPath(java.lang.String arg__1);

    public native static java.lang.String applicationDirPath();

    public native static java.lang.String applicationFilePath();

    @com.trolltech.qt.QtPropertyReader(name="applicationName")
    @com.trolltech.qt.QtPropertyOrder(0)
    public native static java.lang.String applicationName();

    public native static java.util.List<java.lang.String> arguments();

    public native static boolean closingDown();

    public native static int exec();


    public static void exit() {
        exit((int)0);
    }
    public native static void exit(int retcode);

    public native static void flush();

    public native static boolean hasPendingEvents();

    public static void installTranslator(com.trolltech.qt.core.QTranslator messageFile) {
        if (messageFile != null) {
            __rcTranslators.add(messageFile);
        }
        __qt_installTranslator_QTranslator(messageFile == null ? 0 : messageFile.nativeId());
    }
    private native static void __qt_installTranslator_QTranslator(long messageFile);

    public native static com.trolltech.qt.core.QCoreApplication instance();

    public native static java.util.List<java.lang.String> libraryPaths();

    @com.trolltech.qt.QtPropertyReader(name="organizationDomain")
    @com.trolltech.qt.QtPropertyOrder(2)
    public native static java.lang.String organizationDomain();

    @com.trolltech.qt.QtPropertyReader(name="organizationName")
    @com.trolltech.qt.QtPropertyOrder(1)
    public native static java.lang.String organizationName();

    public static void postEvent(com.trolltech.qt.core.QObject receiver, com.trolltech.qt.core.QEvent event, int priority) {
        __qt_postEvent_QObject_QEvent_int(receiver == null ? 0 : receiver.nativeId(), event == null ? 0 : event.nativeId(), priority);
    }
    private native static void __qt_postEvent_QObject_QEvent_int(long receiver, long event, int priority);

    public static void postEvent(com.trolltech.qt.core.QObject receiver, com.trolltech.qt.core.QEvent event) {
        if (event != null) {
            event.disableGarbageCollection();
        }
        __qt_postEvent_QObject_QEvent(receiver == null ? 0 : receiver.nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_postEvent_QObject_QEvent(long receiver, long event);

    public static void processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlags flags, int maxtime) {
        __qt_processEvents_ProcessEventsFlags_int(flags.value(), maxtime);
    }
    private native static void __qt_processEvents_ProcessEventsFlags_int(int flags, int maxtime);


    public static void processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlag ... flags) {
        com.trolltech.qt.core.QCoreApplication.processEvents(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(flags));
    }

    public static void processEvents() {
        processEvents(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(0));
    }
    public static void processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlags flags) {
        __qt_processEvents_ProcessEventsFlags(flags.value());
    }
    private native static void __qt_processEvents_ProcessEventsFlags(int flags);

    public native static void quit();

    public native static void removeLibraryPath(java.lang.String arg__1);

    public static void removePostedEvents(com.trolltech.qt.core.QObject receiver) {
        __qt_removePostedEvents_QObject(receiver == null ? 0 : receiver.nativeId());
    }
    private native static void __qt_removePostedEvents_QObject(long receiver);

    public static void removePostedEvents(com.trolltech.qt.core.QObject receiver, int eventType) {
        __qt_removePostedEvents_QObject_int(receiver == null ? 0 : receiver.nativeId(), eventType);
    }
    private native static void __qt_removePostedEvents_QObject_int(long receiver, int eventType);

    public static void removeTranslator(com.trolltech.qt.core.QTranslator messageFile) {
        if (messageFile != null) {
            while (__rcTranslators.remove(messageFile)) ;
        }
        __qt_removeTranslator_QTranslator(messageFile == null ? 0 : messageFile.nativeId());
    }
    private native static void __qt_removeTranslator_QTranslator(long messageFile);

    public static boolean sendEvent(com.trolltech.qt.core.QObject receiver, com.trolltech.qt.core.QEvent event) {
        return __qt_sendEvent_QObject_QEvent(receiver == null ? 0 : receiver.nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_sendEvent_QObject_QEvent(long receiver, long event);

    public static void sendPostedEvents(com.trolltech.qt.core.QObject receiver, int event_type) {
        __qt_sendPostedEvents_QObject_int(receiver == null ? 0 : receiver.nativeId(), event_type);
    }
    private native static void __qt_sendPostedEvents_QObject_int(long receiver, int event_type);

    public native static void sendPostedEvents();

    @com.trolltech.qt.QtPropertyWriter(name="applicationName")
    public native static void setApplicationName(java.lang.String application);


    public static void setAttribute(com.trolltech.qt.core.Qt.ApplicationAttribute attribute) {
        setAttribute(attribute, (boolean)true);
    }
    public static void setAttribute(com.trolltech.qt.core.Qt.ApplicationAttribute attribute, boolean on) {
        __qt_setAttribute_ApplicationAttribute_boolean(attribute.value(), on);
    }
    private native static void __qt_setAttribute_ApplicationAttribute_boolean(int attribute, boolean on);

    public native static void setLibraryPaths(java.util.List<java.lang.String> arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="organizationDomain")
    public native static void setOrganizationDomain(java.lang.String orgDomain);

    @com.trolltech.qt.QtPropertyWriter(name="organizationName")
    public native static void setOrganizationName(java.lang.String orgName);

    public native static boolean startingUp();

    public static boolean testAttribute(com.trolltech.qt.core.Qt.ApplicationAttribute attribute) {
        return __qt_testAttribute_ApplicationAttribute(attribute.value());
    }
    private native static boolean __qt_testAttribute_ApplicationAttribute(int attribute);

    @SuppressWarnings("unused")
    private static java.lang.String translate(com.trolltech.qt.QNativePointer context, com.trolltech.qt.QNativePointer key, com.trolltech.qt.QNativePointer comment, com.trolltech.qt.core.QCoreApplication.Encoding encoding, int n) {
        return __qt_translate_nativepointer_nativepointer_nativepointer_Encoding_int(context, key, comment, encoding.value(), n);
    }
    private native static java.lang.String __qt_translate_nativepointer_nativepointer_nativepointer_Encoding_int(com.trolltech.qt.QNativePointer context, com.trolltech.qt.QNativePointer key, com.trolltech.qt.QNativePointer comment, int encoding, int n);

    @SuppressWarnings("unused")
    private static java.lang.String translate(com.trolltech.qt.QNativePointer context, com.trolltech.qt.QNativePointer key, com.trolltech.qt.QNativePointer comment, com.trolltech.qt.core.QCoreApplication.Encoding encoding) {
        return __qt_translate_nativepointer_nativepointer_nativepointer_Encoding(context, key, comment, encoding.value());
    }
    private native static java.lang.String __qt_translate_nativepointer_nativepointer_nativepointer_Encoding(com.trolltech.qt.QNativePointer context, com.trolltech.qt.QNativePointer key, com.trolltech.qt.QNativePointer comment, int encoding);


    public static native QCoreApplication fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QCoreApplication(QPrivateConstructor p) { super(p); } 


        public static String translate(String context, String sourceText, String comment) {
            QTextCodec codec = QTextCodec.codecForName("UTF-8");
            return translate(context != null ? codec.fromUnicode(context).data() : null,
                             sourceText != null ? codec.fromUnicode(sourceText).data() : null,
                             comment != null ? codec.fromUnicode(comment).data() : null,
                             Encoding.CodecForTr);
        }

        public static String translate(String context, String sourceText) {
            return translate(context, sourceText, null);
        }
    

        public static String translate(String context, String sourceText, String comment, int n) {
            QTextCodec codec = QTextCodec.codecForName("UTF-8");
            return translate(context != null ? codec.fromUnicode(context).data() : null,
                             sourceText != null ? codec.fromUnicode(sourceText).data() : null,
                             comment != null ? codec.fromUnicode(comment).data() : null,
                             Encoding.CodecForTr, n);
        }
    

    protected static QCoreApplication m_instance = null;
    public static void initialize(String args[])
    {
        if (m_instance != null)
            throw new RuntimeException("QApplication can only be initialized once");
            
        m_instance = new QCoreApplication(args);
        m_instance.aboutToQuit.connect(m_instance, "disposeOfMyself()");
        String path = Utilities.unpackPlugins();
        if (path != null)
            addLibraryPath(path);
    }
        
    @SuppressWarnings("unused")
    private void disposeOfMyself() {
        m_instance = null;
        System.gc();
        this.dispose();        
    }
    
    protected final static com.trolltech.qt.QNativePointer argv(String args[])
    {
        String newArgs[] = new String[args.length + 1];
        System.arraycopy(args, 0, newArgs, 1, args.length);
        newArgs[0] = "Qt Jambi application";
        argv = com.trolltech.qt.QNativePointer.createCharPointerPointer(newArgs);
        return argv;
    }

    protected final static com.trolltech.qt.QNativePointer argc(String args[])
    {
        if (argc != null) {
             throw new RuntimeException("There can only exist one QCoreApplication instance");
        }
        argc = new com.trolltech.qt.QNativePointer(com.trolltech.qt.QNativePointer.Type.Int);
        argc.setIntValue(args.length + 1);
        return argc;
    }

    public QCoreApplication(String args[])         
    {
        this(argc(args), argv(args)); 
    }
    
    @Override
    protected void disposed() {
        argc = null; argv = null; m_instance = null;
        super.disposed();
    }
        
    public static void invokeLater(java.lang.Runnable runnable) {
        postEvent(new QInvokable(runnable), new QEvent(QInvokable.INVOKABLE_EVENT));
    }


    private static com.trolltech.qt.QNativePointer argc, argv;
    
}
