package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QCryptographicHash extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum Algorithm implements com.trolltech.qt.QtEnumerator {
        Md4(0),
        Md5(1),
        Sha1(2);

        Algorithm(int value) { this.value = value; }
        public int value() { return value; }

        public static Algorithm resolve(int value) {
            return (Algorithm) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Md4;
            case 1: return Md5;
            case 2: return Sha1;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QCryptographicHash(com.trolltech.qt.core.QCryptographicHash.Algorithm method) {
        super((QPrivateConstructor)null);
        __qt_QCryptographicHash_Algorithm(method.value());
    }
    private native void __qt_QCryptographicHash_Algorithm(int method);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final void addData(com.trolltech.qt.QNativePointer data, int length) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addData_nativepointer_int(nativeId(), data, length);
    }
    private native static void __qt_addData_nativepointer_int(long __this__nativeId, com.trolltech.qt.QNativePointer data, int length);

    @QtBlockedSlot public final void addData(com.trolltech.qt.core.QByteArray data) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addData_QByteArray(nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId());
    }
    private native static void __qt_addData_QByteArray(long __this__nativeId, long data);

    @QtBlockedSlot public final void reset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray result() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_result(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_result(long __this__nativeId);

    public static com.trolltech.qt.core.QByteArray hash(com.trolltech.qt.core.QByteArray data, com.trolltech.qt.core.QCryptographicHash.Algorithm method) {
        return __qt_hash_QByteArray_Algorithm(data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), method.value());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_hash_QByteArray_Algorithm(long data, int method);


    public static native QCryptographicHash fromNativePointer(QNativePointer nativePointer);

    protected QCryptographicHash(QPrivateConstructor p) { super(p); } 


        public final void addData(byte data[]) {
            QNativePointer np = com.trolltech.qt.QtJambiInternal.byteArrayToNativePointer(data);
            addData(np, data.length);
        }
    
}
