package com.trolltech.qt.core;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QDataStream extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum Version implements com.trolltech.qt.QtEnumerator {
        Qt_1_0(1),
        Qt_2_0(2),
        Qt_2_1(3),
        Qt_3_0(4),
        Qt_3_1(5),
        Qt_3_3(6),
        Qt_4_0(7),
        Qt_4_2(8),
        Qt_4_3(9);

        Version(int value) { this.value = value; }
        public int value() { return value; }

        public static Version resolve(int value) {
            return (Version) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Qt_1_0;
            case 2: return Qt_2_0;
            case 3: return Qt_2_1;
            case 4: return Qt_3_0;
            case 5: return Qt_3_1;
            case 6: return Qt_3_3;
            case 7: return Qt_4_0;
            case 8: return Qt_4_2;
            case 9: return Qt_4_3;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Status implements com.trolltech.qt.QtEnumerator {
        Ok(0),
        ReadPastEnd(1),
        ReadCorruptData(2);

        Status(int value) { this.value = value; }
        public int value() { return value; }

        public static Status resolve(int value) {
            return (Status) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Ok;
            case 1: return ReadPastEnd;
            case 2: return ReadCorruptData;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QDataStream(com.trolltech.qt.core.QIODevice arg__1) {
        super((QPrivateConstructor)null);
        __qt_QDataStream_QIODevice(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native void __qt_QDataStream_QIODevice(long arg__1);


    public QDataStream(com.trolltech.qt.core.QByteArray arg__1) {
        super((QPrivateConstructor)null);
        __qt_QDataStream_QByteArray(arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QByteArray()).nativeId() : arg__1.nativeId());
    }
    private native void __qt_QDataStream_QByteArray(long arg__1);


    @SuppressWarnings("unused")
    private QDataStream(com.trolltech.qt.QNativePointer arg__1, com.trolltech.qt.core.QIODevice.OpenMode flags) {
        super((QPrivateConstructor)null);
        __qt_QDataStream_nativepointer_OpenMode(arg__1, flags.value());
    }
    private native void __qt_QDataStream_nativepointer_OpenMode(com.trolltech.qt.QNativePointer arg__1, int flags);


    public QDataStream() {
        super((QPrivateConstructor)null);
        __qt_QDataStream();
    }
    private native void __qt_QDataStream();


    @QtBlockedSlot public final boolean atEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeFloat(float f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeFloat_float(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeFloat_float(long __this__nativeId, float f);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeInt(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeInt_int(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeInt_int(long __this__nativeId, int i);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeBoolean(boolean i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeBoolean_boolean(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeBoolean_boolean(long __this__nativeId, boolean i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream writeShort_char(char i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeShort_char_char(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeShort_char_char(long __this__nativeId, char i);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeLong(long i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeLong_long(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeLong_long(long __this__nativeId, long i);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeByte(byte i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeByte_byte(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeByte_byte(long __this__nativeId, byte i);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream writeDouble(double f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeDouble_double(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_writeDouble_double(long __this__nativeId, double f);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_char(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_char_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_char_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_double(com.trolltech.qt.QNativePointer f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_double_nativepointer(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_double_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer f);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_long(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_long_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_long_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_byte(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_byte_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_byte_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_boolean(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_boolean_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_boolean_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_short(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_short_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_short_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_int(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_int_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_int_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QDataStream operator_shift_right_float(com.trolltech.qt.QNativePointer f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_float_nativepointer(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QDataStream __qt_operator_shift_right_float_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer f);

    @QtBlockedSlot public final void resetStatus() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetStatus(nativeId());
    }
    private native static void __qt_resetStatus(long __this__nativeId);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = arg__1;
        }
        __qt_setDevice_QIODevice(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setStatus(com.trolltech.qt.core.QDataStream.Status status) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatus_Status(nativeId(), status.value());
    }
    private native static void __qt_setStatus_Status(long __this__nativeId, int status);

    @QtBlockedSlot public final void setVersion(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVersion_int(nativeId(), arg__1);
    }
    private native static void __qt_setVersion_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final int skipRawData(int len) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_skipRawData_int(nativeId(), len);
    }
    private native static int __qt_skipRawData_int(long __this__nativeId, int len);

    @QtBlockedSlot public final com.trolltech.qt.core.QDataStream.Status status() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QDataStream.Status.resolve(__qt_status(nativeId()));
    }
    private native static int __qt_status(long __this__nativeId);

    @QtBlockedSlot public final void unsetDevice() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unsetDevice(nativeId());
    __rcDevice = null;

    }
    private native static void __qt_unsetDevice(long __this__nativeId);

    @QtBlockedSlot public final int version() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_version(nativeId());
    }
    private native static int __qt_version(long __this__nativeId);


    public static native QDataStream fromNativePointer(QNativePointer nativePointer);

    protected QDataStream(QPrivateConstructor p) { super(p); } 


        private QNativePointer srb = new QNativePointer(QNativePointer.Type.Byte, 32) {
            {
                setVerificationEnabled(false);
            }
        };
        public final boolean readBoolean() { operator_shift_right_boolean(srb); return srb.booleanValue(); }
        public final byte    readByte()    { operator_shift_right_byte(srb);    return srb.byteValue(); }
        public final short   readShort()   { operator_shift_right_short(srb);   return srb.shortValue(); }
        public final int     readInt()     { operator_shift_right_int(srb);     return srb.intValue(); }
        public final long    readLong()    { operator_shift_right_long(srb);    return srb.longValue(); }
        public final float   readFloat()   { operator_shift_right_float(srb);   return srb.floatValue(); }
        public final double  readDouble()  { operator_shift_right_double(srb);  return srb.doubleValue(); }
        public final QDataStream writeShort(short s) { writeShort_char((char) s); return this; }
    

        private native String readString_private(long nativeId);
        private native void writeString_private(long nativeId, String string);
        
        public final String readString() {
            if (nativeId() == 0)
                throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
            return readString_private(nativeId());
        }
        
        public final void writeString(String string) {
            if (nativeId() == 0)
                throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
            writeString_private(nativeId(), string);
        }
    

        // TEMPLATE - core.stream_constructor_bytearray - START
        // Hold reference to byte array which goes away when the stream dies 
        @SuppressWarnings("unused")
        private QByteArray byteArray = null;                
        public QDataStream(QByteArray a, QIODevice.OpenMode mode) {            
            this(a.nativePointer(), mode);
            byteArray = a;
        }
        
        public QDataStream(QByteArray a, QIODevice.OpenModeFlag ... mode) {
            this(a, new QIODevice.OpenMode(mode));
        }    
    // TEMPLATE - core.stream_constructor_bytearray - END
    

    private native int writeBytes(long id, byte buffer[], int length);
    private native int readBytes(long id, byte buffer[], int length);

    public final int writeBytes(byte buffer[]) { return writeBytes(buffer, buffer.length); }
    public final int writeBytes(byte buffer[], int length) {
        return writeBytes(nativeId(), buffer, length);
    }

    public final int readBytes(byte buffer[]) { return readBytes(buffer, buffer.length); }
    public final int readBytes(byte buffer[], int length) {
        return readBytes(nativeId(), buffer, length);
    }
    
}
