package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDir extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum Filter implements com.trolltech.qt.QtEnumerator {
        Dirs(1),
        Files(2),
        Drives(4),
        NoSymLinks(8),
        AllEntries(7),
        TypeMask(15),
        Readable(16),
        Writable(32),
        Executable(64),
        PermissionMask(112),
        Modified(128),
        Hidden(256),
        System(512),
        AccessMask(1008),
        AllDirs(1024),
        CaseSensitive(2048),
        NoDotAndDotDot(4096),
        NoFilter(-1);

        Filter(int value) { this.value = value; }
        public int value() { return value; }

        public static Filters createQFlags(Filter ... values) {
            return new Filters(values);
        }
        public static Filter resolve(int value) {
            return (Filter) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Dirs;
            case 2: return Files;
            case 4: return Drives;
            case 8: return NoSymLinks;
            case 7: return AllEntries;
            case 15: return TypeMask;
            case 16: return Readable;
            case 32: return Writable;
            case 64: return Executable;
            case 112: return PermissionMask;
            case 128: return Modified;
            case 256: return Hidden;
            case 512: return System;
            case 1008: return AccessMask;
            case 1024: return AllDirs;
            case 2048: return CaseSensitive;
            case 4096: return NoDotAndDotDot;
            case -1: return NoFilter;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Filters extends com.trolltech.qt.QFlags<Filter> {
        private static final long serialVersionUID = 1L;
        public Filters(Filter ... args) { super(args); }
        public Filters(int value) { setValue(value); }
    }

    public enum SortFlag implements com.trolltech.qt.QtEnumerator {
        Name(0),
        Time(1),
        Size(2),
        SortByMask(3),
        DirsFirst(4),
        Reversed(8),
        IgnoreCase(16),
        DirsLast(32),
        LocaleAware(64),
        Type(128),
        NoSort(-1);

        SortFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static SortFlags createQFlags(SortFlag ... values) {
            return new SortFlags(values);
        }
        public static SortFlag resolve(int value) {
            return (SortFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Name;
            case 1: return Time;
            case 2: return Size;
            case 3: return SortByMask;
            case 4: return DirsFirst;
            case 8: return Reversed;
            case 16: return IgnoreCase;
            case 32: return DirsLast;
            case 64: return LocaleAware;
            case 128: return Type;
            case -1: return NoSort;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class SortFlags extends com.trolltech.qt.QFlags<SortFlag> {
        private static final long serialVersionUID = 1L;
        public SortFlags(SortFlag ... args) { super(args); }
        public SortFlags(int value) { setValue(value); }
    }



    public QDir() {
        this((java.lang.String)"");
    }
    public QDir(java.lang.String path) {
        super((QPrivateConstructor)null);
        __qt_QDir_String(path);
    }
    private native void __qt_QDir_String(java.lang.String path);



    public QDir(java.lang.String path, java.lang.String nameFilter, com.trolltech.qt.core.QDir.SortFlags sort) {
        this(path, nameFilter, sort, new com.trolltech.qt.core.QDir.Filters(7));
    }

    public QDir(java.lang.String path, java.lang.String nameFilter) {
        this(path, nameFilter, new com.trolltech.qt.core.QDir.SortFlags(SortFlag.Name, SortFlag.IgnoreCase), new com.trolltech.qt.core.QDir.Filters(7));
    }
    public QDir(java.lang.String path, java.lang.String nameFilter, com.trolltech.qt.core.QDir.SortFlags sort, com.trolltech.qt.core.QDir.Filters filter) {
        super((QPrivateConstructor)null);
        __qt_QDir_String_String_SortFlags_Filters(path, nameFilter, sort.value(), filter.value());
    }
    private native void __qt_QDir_String_String_SortFlags_Filters(java.lang.String path, java.lang.String nameFilter, int sort, int filter);


    public QDir(com.trolltech.qt.core.QDir arg__1) {
        super((QPrivateConstructor)null);
        __qt_QDir_QDir(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native void __qt_QDir_QDir(long arg__1);


    @QtBlockedSlot public final java.lang.String absoluteFilePath(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_absoluteFilePath_String(nativeId(), fileName);
    }
    private native static java.lang.String __qt_absoluteFilePath_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final java.lang.String absolutePath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_absolutePath(nativeId());
    }
    private native static java.lang.String __qt_absolutePath(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String canonicalPath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canonicalPath(nativeId());
    }
    private native static java.lang.String __qt_canonicalPath(long __this__nativeId);

    @QtBlockedSlot public final boolean cd(java.lang.String dirName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cd_String(nativeId(), dirName);
    }
    private native static boolean __qt_cd_String(long __this__nativeId, java.lang.String dirName);

    @QtBlockedSlot public final boolean cdUp() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cdUp(nativeId());
    }
    private native static boolean __qt_cdUp(long __this__nativeId);

    @QtBlockedSlot public final int count() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String dirName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dirName(nativeId());
    }
    private native static java.lang.String __qt_dirName(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlag ... sort) {
        return this.entryInfoList(nameFilters, filters, new com.trolltech.qt.core.QDir.SortFlags(sort));
    }

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters) {
        return entryInfoList(nameFilters, filters, new com.trolltech.qt.core.QDir.SortFlags(-1));
    }

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(java.util.List<java.lang.String> nameFilters) {
        return entryInfoList(nameFilters, new com.trolltech.qt.core.QDir.Filters(-1), new com.trolltech.qt.core.QDir.SortFlags(-1));
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entryInfoList_List_Filters_SortFlags(nativeId(), nameFilters, filters.value(), sort.value());
    }
    private native static java.util.List<com.trolltech.qt.core.QFileInfo> __qt_entryInfoList_List_Filters_SortFlags(long __this__nativeId, java.util.List<java.lang.String> nameFilters, int filters, int sort);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlag ... sort) {
        return this.entryInfoList(filters, new com.trolltech.qt.core.QDir.SortFlags(sort));
    }

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(com.trolltech.qt.core.QDir.Filters filters) {
        return entryInfoList(filters, new com.trolltech.qt.core.QDir.SortFlags(-1));
    }

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList() {
        return entryInfoList(new com.trolltech.qt.core.QDir.Filters(-1), new com.trolltech.qt.core.QDir.SortFlags(-1));
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QFileInfo> entryInfoList(com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entryInfoList_Filters_SortFlags(nativeId(), filters.value(), sort.value());
    }
    private native static java.util.List<com.trolltech.qt.core.QFileInfo> __qt_entryInfoList_Filters_SortFlags(long __this__nativeId, int filters, int sort);


    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlag ... sort) {
        return this.entryList(nameFilters, filters, new com.trolltech.qt.core.QDir.SortFlags(sort));
    }

    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters) {
        return entryList(nameFilters, filters, new com.trolltech.qt.core.QDir.SortFlags(-1));
    }

    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(java.util.List<java.lang.String> nameFilters) {
        return entryList(nameFilters, new com.trolltech.qt.core.QDir.Filters(-1), new com.trolltech.qt.core.QDir.SortFlags(-1));
    }
    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(java.util.List<java.lang.String> nameFilters, com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entryList_List_Filters_SortFlags(nativeId(), nameFilters, filters.value(), sort.value());
    }
    private native static java.util.List<java.lang.String> __qt_entryList_List_Filters_SortFlags(long __this__nativeId, java.util.List<java.lang.String> nameFilters, int filters, int sort);


    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlag ... sort) {
        return this.entryList(filters, new com.trolltech.qt.core.QDir.SortFlags(sort));
    }

    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(com.trolltech.qt.core.QDir.Filters filters) {
        return entryList(filters, new com.trolltech.qt.core.QDir.SortFlags(-1));
    }

    @QtBlockedSlot public final java.util.List<java.lang.String> entryList() {
        return entryList(new com.trolltech.qt.core.QDir.Filters(-1), new com.trolltech.qt.core.QDir.SortFlags(-1));
    }
    @QtBlockedSlot public final java.util.List<java.lang.String> entryList(com.trolltech.qt.core.QDir.Filters filters, com.trolltech.qt.core.QDir.SortFlags sort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_entryList_Filters_SortFlags(nativeId(), filters.value(), sort.value());
    }
    private native static java.util.List<java.lang.String> __qt_entryList_Filters_SortFlags(long __this__nativeId, int filters, int sort);

    @QtBlockedSlot public final boolean exists(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exists_String(nativeId(), name);
    }
    private native static boolean __qt_exists_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final boolean exists() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exists(nativeId());
    }
    private native static boolean __qt_exists(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String filePath(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_filePath_String(nativeId(), fileName);
    }
    private native static java.lang.String __qt_filePath_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final com.trolltech.qt.core.QDir.Filters filter() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QDir.Filters(__qt_filter(nativeId()));
    }
    private native static int __qt_filter(long __this__nativeId);

    @QtBlockedSlot public final boolean isAbsolute() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAbsolute(nativeId());
    }
    private native static boolean __qt_isAbsolute(long __this__nativeId);

    @QtBlockedSlot public final boolean isReadable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadable(nativeId());
    }
    private native static boolean __qt_isReadable(long __this__nativeId);

    @QtBlockedSlot public final boolean isRelative() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRelative(nativeId());
    }
    private native static boolean __qt_isRelative(long __this__nativeId);

    @QtBlockedSlot public final boolean isRoot() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRoot(nativeId());
    }
    private native static boolean __qt_isRoot(long __this__nativeId);

    @QtBlockedSlot public final boolean makeAbsolute() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_makeAbsolute(nativeId());
    }
    private native static boolean __qt_makeAbsolute(long __this__nativeId);

    @QtBlockedSlot public final boolean mkdir(java.lang.String dirName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mkdir_String(nativeId(), dirName);
    }
    private native static boolean __qt_mkdir_String(long __this__nativeId, java.lang.String dirName);

    @QtBlockedSlot public final boolean mkpath(java.lang.String dirPath) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mkpath_String(nativeId(), dirPath);
    }
    private native static boolean __qt_mkpath_String(long __this__nativeId, java.lang.String dirPath);

    @QtBlockedSlot public final java.util.List<java.lang.String> nameFilters() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nameFilters(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_nameFilters(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.core.QDir dir) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QDir(nativeId(), dir == null ? 0 : dir.nativeId());
    }
    private native static boolean __qt_operator_equal_QDir(long __this__nativeId, long dir);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final java.lang.String operator_subscript(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_subscript_int(nativeId(), arg__1);
    }
    private native static java.lang.String __qt_operator_subscript_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final java.lang.String path() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_path(nativeId());
    }
    private native static java.lang.String __qt_path(long __this__nativeId);

    @QtBlockedSlot public final void refresh() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_refresh(nativeId());
    }
    private native static void __qt_refresh(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String relativeFilePath(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_relativeFilePath_String(nativeId(), fileName);
    }
    private native static java.lang.String __qt_relativeFilePath_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final boolean remove(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_remove_String(nativeId(), fileName);
    }
    private native static boolean __qt_remove_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final boolean rename(java.lang.String oldName, java.lang.String newName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rename_String_String(nativeId(), oldName, newName);
    }
    private native static boolean __qt_rename_String_String(long __this__nativeId, java.lang.String oldName, java.lang.String newName);

    @QtBlockedSlot public final boolean rmdir(java.lang.String dirName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rmdir_String(nativeId(), dirName);
    }
    private native static boolean __qt_rmdir_String(long __this__nativeId, java.lang.String dirName);

    @QtBlockedSlot public final boolean rmpath(java.lang.String dirPath) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rmpath_String(nativeId(), dirPath);
    }
    private native static boolean __qt_rmpath_String(long __this__nativeId, java.lang.String dirPath);


    @QtBlockedSlot public final void setFilter(com.trolltech.qt.core.QDir.Filter ... filter) {
        this.setFilter(new com.trolltech.qt.core.QDir.Filters(filter));
    }
    @QtBlockedSlot public final void setFilter(com.trolltech.qt.core.QDir.Filters filter) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFilter_Filters(nativeId(), filter.value());
    }
    private native static void __qt_setFilter_Filters(long __this__nativeId, int filter);

    @QtBlockedSlot public final void setNameFilters(java.util.List<java.lang.String> nameFilters) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNameFilters_List(nativeId(), nameFilters);
    }
    private native static void __qt_setNameFilters_List(long __this__nativeId, java.util.List<java.lang.String> nameFilters);

    @QtBlockedSlot public final void setPath(java.lang.String path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPath_String(nativeId(), path);
    }
    private native static void __qt_setPath_String(long __this__nativeId, java.lang.String path);


    @QtBlockedSlot public final void setSorting(com.trolltech.qt.core.QDir.SortFlag ... sort) {
        this.setSorting(new com.trolltech.qt.core.QDir.SortFlags(sort));
    }
    @QtBlockedSlot public final void setSorting(com.trolltech.qt.core.QDir.SortFlags sort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSorting_SortFlags(nativeId(), sort.value());
    }
    private native static void __qt_setSorting_SortFlags(long __this__nativeId, int sort);

    @QtBlockedSlot public final com.trolltech.qt.core.QDir.SortFlags sorting() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QDir.SortFlags(__qt_sorting(nativeId()));
    }
    private native static int __qt_sorting(long __this__nativeId);

    public native static void addSearchPath(java.lang.String prefix, java.lang.String path);

    public native static java.lang.String cleanPath(java.lang.String path);

    public native static com.trolltech.qt.core.QDir current();

    public native static java.lang.String currentPath();

    public native static java.util.List<com.trolltech.qt.core.QFileInfo> drives();

    public native static java.lang.String fromNativeSeparators(java.lang.String pathName);

    public native static com.trolltech.qt.core.QDir home();

    public native static java.lang.String homePath();

    public native static boolean isAbsolutePath(java.lang.String path);

    public native static boolean isRelativePath(java.lang.String path);

    public native static boolean match(java.util.List<java.lang.String> filters, java.lang.String fileName);

    public native static boolean match(java.lang.String filter, java.lang.String fileName);

    public native static java.util.List<java.lang.String> nameFiltersFromString(java.lang.String nameFilter);

    public native static com.trolltech.qt.core.QDir root();

    public native static java.lang.String rootPath();

    public native static java.util.List<java.lang.String> searchPaths(java.lang.String prefix);

    public native static char separator();

    public native static boolean setCurrent(java.lang.String path);

    public native static void setSearchPaths(java.lang.String prefix, java.util.List<java.lang.String> searchPaths);

    public native static com.trolltech.qt.core.QDir temp();

    public native static java.lang.String tempPath();

    public native static java.lang.String toNativeSeparators(java.lang.String pathName);


    public static native QDir fromNativePointer(QNativePointer nativePointer);

    protected QDir(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QDir array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.core.QDir)
            return operator_equal((com.trolltech.qt.core.QDir) other);
        return false;
    }


    @com.trolltech.qt.QtBlockedSlot public String at(int i) { return operator_subscript(i); }
    
}
