package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QEventLoop extends com.trolltech.qt.core.QObject
{
    public enum ProcessEventsFlag implements com.trolltech.qt.QtEnumerator {
        AllEvents(0),
        ExcludeUserInputEvents(1),
        ExcludeSocketNotifiers(2),
        WaitForMoreEvents(4),
        X11ExcludeTimers(8),
        DeferredDeletion(16);

        ProcessEventsFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static ProcessEventsFlags createQFlags(ProcessEventsFlag ... values) {
            return new ProcessEventsFlags(values);
        }
        public static ProcessEventsFlag resolve(int value) {
            return (ProcessEventsFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AllEvents;
            case 1: return ExcludeUserInputEvents;
            case 2: return ExcludeSocketNotifiers;
            case 4: return WaitForMoreEvents;
            case 8: return X11ExcludeTimers;
            case 16: return DeferredDeletion;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ProcessEventsFlags extends com.trolltech.qt.QFlags<ProcessEventsFlag> {
        private static final long serialVersionUID = 1L;
        public ProcessEventsFlags(ProcessEventsFlag ... args) { super(args); }
        public ProcessEventsFlags(int value) { setValue(value); }
    }



    public QEventLoop() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QEventLoop(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QEventLoop_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QEventLoop_QObject(long parent);



    @QtBlockedSlot public final int exec(com.trolltech.qt.core.QEventLoop.ProcessEventsFlag ... flags) {
        return this.exec(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(flags));
    }

    @QtBlockedSlot public final int exec() {
        return exec(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(0));
    }
    @QtBlockedSlot public final int exec(com.trolltech.qt.core.QEventLoop.ProcessEventsFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exec_ProcessEventsFlags(nativeId(), flags.value());
    }
    private native static int __qt_exec_ProcessEventsFlags(long __this__nativeId, int flags);


    @QtBlockedSlot public final void exit() {
        exit((int)0);
    }
    @QtBlockedSlot public final void exit(int returnCode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_exit_int(nativeId(), returnCode);
    }
    private native static void __qt_exit_int(long __this__nativeId, int returnCode);

    @QtBlockedSlot public final boolean isRunning() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRunning(nativeId());
    }
    private native static boolean __qt_isRunning(long __this__nativeId);

    @QtBlockedSlot public final void processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlags flags, int maximumTime) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_processEvents_ProcessEventsFlags_int(nativeId(), flags.value(), maximumTime);
    }
    private native static void __qt_processEvents_ProcessEventsFlags_int(long __this__nativeId, int flags, int maximumTime);


    @QtBlockedSlot public final boolean processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlag ... flags) {
        return this.processEvents(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(flags));
    }

    @QtBlockedSlot public final boolean processEvents() {
        return processEvents(new com.trolltech.qt.core.QEventLoop.ProcessEventsFlags(0));
    }
    @QtBlockedSlot public final boolean processEvents(com.trolltech.qt.core.QEventLoop.ProcessEventsFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_processEvents_ProcessEventsFlags(nativeId(), flags.value());
    }
    private native static boolean __qt_processEvents_ProcessEventsFlags(long __this__nativeId, int flags);

    public final void quit() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_quit(nativeId());
    }
    private native static void __qt_quit(long __this__nativeId);

    @QtBlockedSlot public final void wakeUp() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wakeUp(nativeId());
    }
    private native static void __qt_wakeUp(long __this__nativeId);


    public static native QEventLoop fromNativePointer(QNativePointer nativePointer);

    protected QEventLoop(QPrivateConstructor p) { super(p); } 

}
