package com.trolltech.qt.core;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public abstract class QIODevice extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.core.QIODevice {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot protected int readData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readData_nativepointer_long(nativeId(), data);
        }
        @QtBlockedSlot protected int writeData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeData_nativepointer_long(nativeId(), data);
        }
    }

    public enum OpenModeFlag implements com.trolltech.qt.QtEnumerator {
        NotOpen(0),
        ReadOnly(1),
        WriteOnly(2),
        ReadWrite(3),
        Append(4),
        Truncate(8),
        Text(16),
        Unbuffered(32);

        OpenModeFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static OpenMode createQFlags(OpenModeFlag ... values) {
            return new OpenMode(values);
        }
        public static OpenModeFlag resolve(int value) {
            return (OpenModeFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotOpen;
            case 1: return ReadOnly;
            case 2: return WriteOnly;
            case 3: return ReadWrite;
            case 4: return Append;
            case 8: return Truncate;
            case 16: return Text;
            case 32: return Unbuffered;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class OpenMode extends com.trolltech.qt.QFlags<OpenModeFlag> {
        private static final long serialVersionUID = 1L;
        public OpenMode(OpenModeFlag ... args) { super(args); }
        public OpenMode(int value) { setValue(value); }
    }


    public final Signal0 aboutToClose = new Signal0();

    @SuppressWarnings("unused")
    private final void aboutToClose() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_aboutToClose(nativeId());
    }
    private native static void __qt_aboutToClose(long __this__nativeId);

    public final Signal1<java.lang.Long> bytesWritten = new Signal1<java.lang.Long>();

    @SuppressWarnings("unused")
    private final void bytesWritten(long bytes) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_bytesWritten_long(nativeId(), bytes);
    }
    private native static void __qt_bytesWritten_long(long __this__nativeId, long bytes);

    public final Signal0 readyRead = new Signal0();

    @SuppressWarnings("unused")
    private final void readyRead() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readyRead(nativeId());
    }
    private native static void __qt_readyRead(long __this__nativeId);

    public QIODevice() {
        super((QPrivateConstructor)null);
        __qt_QIODevice();
    }
    private native void __qt_QIODevice();


    public QIODevice(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QIODevice_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QIODevice_QObject(long parent);


    @QtBlockedSlot public final java.lang.String errorString() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean getByte(com.trolltech.qt.QNativePointer c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_getByte_nativepointer(nativeId(), c);
    }
    private native static boolean __qt_getByte_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer c);

    @QtBlockedSlot public final boolean isOpen() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isOpen(nativeId());
    }
    private native static boolean __qt_isOpen(long __this__nativeId);

    @QtBlockedSlot public final boolean isReadable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadable(nativeId());
    }
    private native static boolean __qt_isReadable(long __this__nativeId);

    @QtBlockedSlot public final boolean isTextModeEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTextModeEnabled(nativeId());
    }
    private native static boolean __qt_isTextModeEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isWritable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWritable(nativeId());
    }
    private native static boolean __qt_isWritable(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice.OpenMode openMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QIODevice.OpenMode(__qt_openMode(nativeId()));
    }
    private native static int __qt_openMode(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long peek(com.trolltech.qt.QNativePointer data, long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_peek_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_peek_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray peek(long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_peek_long(nativeId(), maxlen);
    }
    private native static com.trolltech.qt.core.QByteArray __qt_peek_long(long __this__nativeId, long maxlen);

    @QtBlockedSlot public final boolean putByte(byte c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_putByte_byte(nativeId(), c);
    }
    private native static boolean __qt_putByte_byte(long __this__nativeId, byte c);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long read(com.trolltech.qt.QNativePointer data, long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_read_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray read(long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_long(nativeId(), maxlen);
    }
    private native static com.trolltech.qt.core.QByteArray __qt_read_long(long __this__nativeId, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAll(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readAll(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readLine() {
        return readLine((long)0);
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readLine(long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLine_long(nativeId(), maxlen);
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readLine_long(long __this__nativeId, long maxlen);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long readLine(com.trolltech.qt.QNativePointer data, long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLine_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_readLine_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot protected final void setErrorString(java.lang.String errorString) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setErrorString_String(nativeId(), errorString);
    }
    private native static void __qt_setErrorString_String(long __this__nativeId, java.lang.String errorString);


    @QtBlockedSlot protected final void setOpenMode(com.trolltech.qt.core.QIODevice.OpenModeFlag ... openMode) {
        this.setOpenMode(new com.trolltech.qt.core.QIODevice.OpenMode(openMode));
    }
    @QtBlockedSlot protected final void setOpenMode(com.trolltech.qt.core.QIODevice.OpenMode openMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOpenMode_OpenMode(nativeId(), openMode.value());
    }
    private native static void __qt_setOpenMode_OpenMode(long __this__nativeId, int openMode);

    @QtBlockedSlot public final void setTextModeEnabled(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextModeEnabled_boolean(nativeId(), enabled);
    }
    private native static void __qt_setTextModeEnabled_boolean(long __this__nativeId, boolean enabled);

    @QtBlockedSlot public final void ungetByte(byte c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ungetByte_byte(nativeId(), c);
    }
    private native static void __qt_ungetByte_byte(long __this__nativeId, byte c);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long write(com.trolltech.qt.QNativePointer data, long len) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_write_nativepointer_long(nativeId(), data, len);
    }
    private native static long __qt_write_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long len);

    @QtBlockedSlot public final long write(com.trolltech.qt.core.QByteArray data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_write_QByteArray(nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId());
    }
    private native static long __qt_write_QByteArray(long __this__nativeId, long data);

    @QtBlockedSlot public boolean atEnd() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public long bytesAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesAvailable(nativeId());
    }
    private native static long __qt_bytesAvailable(long __this__nativeId);

    @QtBlockedSlot public long bytesToWrite() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesToWrite(nativeId());
    }
    private native static long __qt_bytesToWrite(long __this__nativeId);

    @QtBlockedSlot public boolean canReadLine() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canReadLine(nativeId());
    }
    private native static boolean __qt_canReadLine(long __this__nativeId);

    @QtBlockedSlot public void close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_close(nativeId());
    }
    private native static void __qt_close(long __this__nativeId);

    @QtBlockedSlot public boolean isSequential() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSequential(nativeId());
    }
    private native static boolean __qt_isSequential(long __this__nativeId);


    @QtBlockedSlot public final boolean open(com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        return this.open(new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }
    @QtBlockedSlot public boolean open(com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_open_OpenMode(nativeId(), mode.value());
    }
    private native static boolean __qt_open_OpenMode(long __this__nativeId, int mode);

    @QtBlockedSlot public long pos() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static long __qt_pos(long __this__nativeId);

    @QtBlockedSlot protected abstract int readData(byte[] data);
    private native static int __qt_readData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot protected int readLineData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLineData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readLineData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot public boolean reset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_reset(nativeId());
    }
    private native static boolean __qt_reset(long __this__nativeId);

    @QtBlockedSlot public boolean seek(long pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_seek_long(nativeId(), pos);
    }
    private native static boolean __qt_seek_long(long __this__nativeId, long pos);

    @QtBlockedSlot public long size() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static long __qt_size(long __this__nativeId);

    @QtBlockedSlot public boolean waitForBytesWritten(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForBytesWritten_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForBytesWritten_int(long __this__nativeId, int msecs);

    @QtBlockedSlot public boolean waitForReadyRead(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForReadyRead_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForReadyRead_int(long __this__nativeId, int msecs);

    @QtBlockedSlot protected abstract int writeData(byte[] data);
    private native static int __qt_writeData_nativepointer_long(long __this__nativeId, byte[] data);


    public static native QIODevice fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QIODevice(QPrivateConstructor p) { super(p); } 


        /** 
         * Gets a byte from the device. 
         *
         * @return -1 on failure, or the value of the byte on success
         */
        public final int getByte() {
            QNativePointer np = new QNativePointer(QNativePointer.Type.Byte);
            boolean success = getByte(np);
            return success ? np.byteValue() : -1;
        }
    

        // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - START
    // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - START
    public final int peek(byte data[]) {
        QNativePointer np = new QNativePointer(QNativePointer.Type.Byte, data.length);
        
        int returned = (int) peek(np, data.length);
        for (int i=0; i<returned; ++i) data[i] = np.byteAt(i);
        return returned;
    }
  // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - END
  // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - END
    

        // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - START
    // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - START
    public final int read(byte data[]) {
        QNativePointer np = new QNativePointer(QNativePointer.Type.Byte, data.length);
        
        int returned = (int) read(np, data.length);
        for (int i=0; i<returned; ++i) data[i] = np.byteAt(i);
        return returned;
    }
  // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - END
  // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - END            
     

        // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - START
    // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - START
    public final int readLine(byte data[]) {
        QNativePointer np = new QNativePointer(QNativePointer.Type.Byte, data.length);
        
        int returned = (int) readLine(np, data.length);
        for (int i=0; i<returned; ++i) data[i] = np.byteAt(i);
        return returned;
    }
  // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - END
  // TEMPLATE - core.read_with_byte[]_instead_of_char*_and_int - END                
    

        // TEMPLATE - core.write_with_byte[]_instead_of_char*_and_int - START
    // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - START
    public final int write(byte data[]) {
        QNativePointer np = new QNativePointer(QNativePointer.Type.Byte, data.length);
        for (int i=0; i<data.length; ++i) np.setByteAt(i, data[i]);
        int returned = (int) write(np, data.length);
        
        return returned;
    }
  // TEMPLATE - core.call_through_with_byte[]_instead_of_char*_and_int - END
  // TEMPLATE - core.write_with_byte[]_instead_of_char*_and_int - END
    
}
