package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSettings extends com.trolltech.qt.core.QObject
{
    public enum Format implements com.trolltech.qt.QtEnumerator {
        NativeFormat(0),
        IniFormat(1),
        InvalidFormat(16),
        CustomFormat1(17),
        CustomFormat2(18),
        CustomFormat3(19),
        CustomFormat4(20),
        CustomFormat5(21),
        CustomFormat6(22),
        CustomFormat7(23),
        CustomFormat8(24),
        CustomFormat9(25),
        CustomFormat10(26),
        CustomFormat11(27),
        CustomFormat12(28),
        CustomFormat13(29),
        CustomFormat14(30),
        CustomFormat15(31),
        CustomFormat16(32);

        Format(int value) { this.value = value; }
        public int value() { return value; }

        public static Format resolve(int value) {
            return (Format) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NativeFormat;
            case 1: return IniFormat;
            case 16: return InvalidFormat;
            case 17: return CustomFormat1;
            case 18: return CustomFormat2;
            case 19: return CustomFormat3;
            case 20: return CustomFormat4;
            case 21: return CustomFormat5;
            case 22: return CustomFormat6;
            case 23: return CustomFormat7;
            case 24: return CustomFormat8;
            case 25: return CustomFormat9;
            case 26: return CustomFormat10;
            case 27: return CustomFormat11;
            case 28: return CustomFormat12;
            case 29: return CustomFormat13;
            case 30: return CustomFormat14;
            case 31: return CustomFormat15;
            case 32: return CustomFormat16;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Status implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        AccessError(1),
        FormatError(2);

        Status(int value) { this.value = value; }
        public int value() { return value; }

        public static Status resolve(int value) {
            return (Status) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return AccessError;
            case 2: return FormatError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Scope implements com.trolltech.qt.QtEnumerator {
        UserScope(0),
        SystemScope(1);

        Scope(int value) { this.value = value; }
        public int value() { return value; }

        public static Scope resolve(int value) {
            return (Scope) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UserScope;
            case 1: return SystemScope;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSettings(java.lang.String organization, java.lang.String application) {
        this(organization, application, (com.trolltech.qt.core.QObject)null);
    }

    public QSettings(java.lang.String organization) {
        this(organization, (java.lang.String)"", (com.trolltech.qt.core.QObject)null);
    }
    public QSettings(java.lang.String organization, java.lang.String application, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSettings_String_String_QObject(organization, application, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSettings_String_String_QObject(java.lang.String organization, java.lang.String application, long parent);



    public QSettings(com.trolltech.qt.core.QSettings.Format format, com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization, java.lang.String application) {
        this(format, scope, organization, application, (com.trolltech.qt.core.QObject)null);
    }

    public QSettings(com.trolltech.qt.core.QSettings.Format format, com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization) {
        this(format, scope, organization, (java.lang.String)"", (com.trolltech.qt.core.QObject)null);
    }
    public QSettings(com.trolltech.qt.core.QSettings.Format format, com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization, java.lang.String application, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSettings_Format_Scope_String_String_QObject(format.value(), scope.value(), organization, application, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSettings_Format_Scope_String_String_QObject(int format, int scope, java.lang.String organization, java.lang.String application, long parent);



    public QSettings() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QSettings(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSettings_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSettings_QObject(long parent);



    public QSettings(java.lang.String fileName, com.trolltech.qt.core.QSettings.Format format) {
        this(fileName, format, (com.trolltech.qt.core.QObject)null);
    }
    public QSettings(java.lang.String fileName, com.trolltech.qt.core.QSettings.Format format, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSettings_String_Format_QObject(fileName, format.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSettings_String_Format_QObject(java.lang.String fileName, int format, long parent);



    public QSettings(com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization, java.lang.String application) {
        this(scope, organization, application, (com.trolltech.qt.core.QObject)null);
    }

    public QSettings(com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization) {
        this(scope, organization, (java.lang.String)"", (com.trolltech.qt.core.QObject)null);
    }
    public QSettings(com.trolltech.qt.core.QSettings.Scope scope, java.lang.String organization, java.lang.String application, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSettings_Scope_String_String_QObject(scope.value(), organization, application, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSettings_Scope_String_String_QObject(int scope, java.lang.String organization, java.lang.String application, long parent);


    @QtBlockedSlot public final java.util.List<java.lang.String> allKeys() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_allKeys(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_allKeys(long __this__nativeId);

    @QtBlockedSlot public final void beginGroup(java.lang.String prefix) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beginGroup_String(nativeId(), prefix);
    }
    private native static void __qt_beginGroup_String(long __this__nativeId, java.lang.String prefix);

    @QtBlockedSlot public final int beginReadArray(java.lang.String prefix) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_beginReadArray_String(nativeId(), prefix);
    }
    private native static int __qt_beginReadArray_String(long __this__nativeId, java.lang.String prefix);


    @QtBlockedSlot public final void beginWriteArray(java.lang.String prefix) {
        beginWriteArray(prefix, (int)-1);
    }
    @QtBlockedSlot public final void beginWriteArray(java.lang.String prefix, int size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beginWriteArray_String_int(nativeId(), prefix, size);
    }
    private native static void __qt_beginWriteArray_String_int(long __this__nativeId, java.lang.String prefix, int size);

    @QtBlockedSlot public final java.util.List<java.lang.String> childGroups() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childGroups(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_childGroups(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.String> childKeys() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childKeys(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_childKeys(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final boolean contains(java.lang.String key) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_String(nativeId(), key);
    }
    private native static boolean __qt_contains_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final void endArray() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_endArray(nativeId());
    }
    private native static void __qt_endArray(long __this__nativeId);

    @QtBlockedSlot public final void endGroup() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_endGroup(nativeId());
    }
    private native static void __qt_endGroup(long __this__nativeId);

    @QtBlockedSlot public final boolean fallbacksEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fallbacksEnabled(nativeId());
    }
    private native static boolean __qt_fallbacksEnabled(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String group() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_group(nativeId());
    }
    private native static java.lang.String __qt_group(long __this__nativeId);

    @QtBlockedSlot public final boolean isWritable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWritable(nativeId());
    }
    private native static boolean __qt_isWritable(long __this__nativeId);

    @QtBlockedSlot public final void remove(java.lang.String key) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_remove_String(nativeId(), key);
    }
    private native static void __qt_remove_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final void setArrayIndex(int i) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setArrayIndex_int(nativeId(), i);
    }
    private native static void __qt_setArrayIndex_int(long __this__nativeId, int i);

    @QtBlockedSlot public final void setFallbacksEnabled(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFallbacksEnabled_boolean(nativeId(), b);
    }
    private native static void __qt_setFallbacksEnabled_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public final void setValue(java.lang.String key, java.lang.Object value) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setValue_String_Object(nativeId(), key, value);
    }
    private native static void __qt_setValue_String_Object(long __this__nativeId, java.lang.String key, java.lang.Object value);

    @QtBlockedSlot public final com.trolltech.qt.core.QSettings.Status status() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QSettings.Status.resolve(__qt_status(nativeId()));
    }
    private native static int __qt_status(long __this__nativeId);

    @QtBlockedSlot public final void sync() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sync(nativeId());
    }
    private native static void __qt_sync(long __this__nativeId);


    @QtBlockedSlot public final java.lang.Object value(java.lang.String key) {
        return value(key, (java.lang.Object)null);
    }
    @QtBlockedSlot public final java.lang.Object value(java.lang.String key, java.lang.Object defaultValue) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value_String_Object(nativeId(), key, defaultValue);
    }
    private native static java.lang.Object __qt_value_String_Object(long __this__nativeId, java.lang.String key, java.lang.Object defaultValue);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    public static void setPath(com.trolltech.qt.core.QSettings.Format format, com.trolltech.qt.core.QSettings.Scope scope, java.lang.String path) {
        __qt_setPath_Format_Scope_String(format.value(), scope.value(), path);
    }
    private native static void __qt_setPath_Format_Scope_String(int format, int scope, java.lang.String path);


    public static native QSettings fromNativePointer(QNativePointer nativePointer);

    protected QSettings(QPrivateConstructor p) { super(p); } 

}
