package com.trolltech.qt.core;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QTextStream extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    @SuppressWarnings("unused") private Object __rcCodec = null;
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum RealNumberNotation implements com.trolltech.qt.QtEnumerator {
        SmartNotation(0),
        FixedNotation(1),
        ScientificNotation(2);

        RealNumberNotation(int value) { this.value = value; }
        public int value() { return value; }

        public static RealNumberNotation resolve(int value) {
            return (RealNumberNotation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SmartNotation;
            case 1: return FixedNotation;
            case 2: return ScientificNotation;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum NumberFlag implements com.trolltech.qt.QtEnumerator {
        ShowBase(1),
        ForcePoint(2),
        ForceSign(4),
        UppercaseBase(8),
        UppercaseDigits(16);

        NumberFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static NumberFlags createQFlags(NumberFlag ... values) {
            return new NumberFlags(values);
        }
        public static NumberFlag resolve(int value) {
            return (NumberFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return ShowBase;
            case 2: return ForcePoint;
            case 4: return ForceSign;
            case 8: return UppercaseBase;
            case 16: return UppercaseDigits;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class NumberFlags extends com.trolltech.qt.QFlags<NumberFlag> {
        private static final long serialVersionUID = 1L;
        public NumberFlags(NumberFlag ... args) { super(args); }
        public NumberFlags(int value) { setValue(value); }
    }

    public enum FieldAlignment implements com.trolltech.qt.QtEnumerator {
        AlignLeft(0),
        AlignRight(1),
        AlignCenter(2),
        AlignAccountingStyle(3);

        FieldAlignment(int value) { this.value = value; }
        public int value() { return value; }

        public static FieldAlignment resolve(int value) {
            return (FieldAlignment) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AlignLeft;
            case 1: return AlignRight;
            case 2: return AlignCenter;
            case 3: return AlignAccountingStyle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Status implements com.trolltech.qt.QtEnumerator {
        Ok(0),
        ReadPastEnd(1),
        ReadCorruptData(2);

        Status(int value) { this.value = value; }
        public int value() { return value; }

        public static Status resolve(int value) {
            return (Status) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Ok;
            case 1: return ReadPastEnd;
            case 2: return ReadCorruptData;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextStream(com.trolltech.qt.core.QIODevice device) {
        super((QPrivateConstructor)null);
        {
            __rcDevice = device;
        }
        __qt_QTextStream_QIODevice(device == null ? 0 : device.nativeId());
    }
    private native void __qt_QTextStream_QIODevice(long device);


    public QTextStream() {
        super((QPrivateConstructor)null);
        __qt_QTextStream();
    }
    private native void __qt_QTextStream();



    public QTextStream(com.trolltech.qt.core.QByteArray array) {
        this(array, new com.trolltech.qt.core.QIODevice.OpenMode(1));
    }
    public QTextStream(com.trolltech.qt.core.QByteArray array, com.trolltech.qt.core.QIODevice.OpenMode openMode) {
        super((QPrivateConstructor)null);
        __qt_QTextStream_QByteArray_OpenMode(array == null ? (array = new com.trolltech.qt.core.QByteArray()).nativeId() : array.nativeId(), openMode.value());
    }
    private native void __qt_QTextStream_QByteArray_OpenMode(long array, int openMode);


    @QtBlockedSlot public final boolean atEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public final boolean autoDetectUnicode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_autoDetectUnicode(nativeId());
    }
    private native static boolean __qt_autoDetectUnicode(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextCodec codec() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_codec(nativeId());
    }
    private native static com.trolltech.qt.core.QTextCodec __qt_codec(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream.FieldAlignment fieldAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTextStream.FieldAlignment.resolve(__qt_fieldAlignment(nativeId()));
    }
    private native static int __qt_fieldAlignment(long __this__nativeId);

    @QtBlockedSlot public final int fieldWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fieldWidth(nativeId());
    }
    private native static int __qt_fieldWidth(long __this__nativeId);

    @QtBlockedSlot public final void flush() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_flush(nativeId());
    }
    private native static void __qt_flush(long __this__nativeId);

    @QtBlockedSlot public final boolean generateByteOrderMark() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_generateByteOrderMark(nativeId());
    }
    private native static boolean __qt_generateByteOrderMark(long __this__nativeId);

    @QtBlockedSlot public final int integerBase() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_integerBase(nativeId());
    }
    private native static int __qt_integerBase(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream.NumberFlags numberFlags() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QTextStream.NumberFlags(__qt_numberFlags(nativeId()));
    }
    private native static int __qt_numberFlags(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeByte(byte ch) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeByte_byte(nativeId(), ch);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeByte_byte(long __this__nativeId, byte ch);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeLong(long i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeLong_long(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeLong_long(long __this__nativeId, long i);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeInt(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeInt_int(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeInt_int(long __this__nativeId, int i);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeDouble(double f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeDouble_double(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeDouble_double(long __this__nativeId, double f);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeBoolean(boolean b) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeBoolean_boolean(nativeId(), b);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeBoolean_boolean(long __this__nativeId, boolean b);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream writeFloat(float f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeFloat_float(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeFloat_float(long __this__nativeId, float f);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream writeShort_char(char i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeShort_char_char(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_writeShort_char_char(long __this__nativeId, char i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_byte(com.trolltech.qt.QNativePointer ch) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_byte_nativepointer(nativeId(), ch);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_byte_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer ch);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_float(com.trolltech.qt.QNativePointer f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_float_nativepointer(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_float_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer f);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_short(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_short_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_short_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_int(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_int_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_int_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_double(com.trolltech.qt.QNativePointer f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_double_nativepointer(nativeId(), f);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_double_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer f);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.core.QTextStream operator_shift_right_long(com.trolltech.qt.QNativePointer i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_operator_shift_right_long_nativepointer(nativeId(), i);
        return this;
    }
    private native static com.trolltech.qt.core.QTextStream __qt_operator_shift_right_long_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer i);

    @QtBlockedSlot public final char padChar() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_padChar(nativeId());
    }
    private native static char __qt_padChar(long __this__nativeId);

    @QtBlockedSlot public final long pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static long __qt_pos(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String read(long maxlen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_long(nativeId(), maxlen);
    }
    private native static java.lang.String __qt_read_long(long __this__nativeId, long maxlen);

    @QtBlockedSlot public final java.lang.String readAll() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAll(nativeId());
    }
    private native static java.lang.String __qt_readAll(long __this__nativeId);


    @QtBlockedSlot public final java.lang.String readLine() {
        return readLine((long)0);
    }
    @QtBlockedSlot public final java.lang.String readLine(long maxlen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLine_long(nativeId(), maxlen);
    }
    private native static java.lang.String __qt_readLine_long(long __this__nativeId, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream.RealNumberNotation realNumberNotation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTextStream.RealNumberNotation.resolve(__qt_realNumberNotation(nativeId()));
    }
    private native static int __qt_realNumberNotation(long __this__nativeId);

    @QtBlockedSlot public final int realNumberPrecision() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_realNumberPrecision(nativeId());
    }
    private native static int __qt_realNumberPrecision(long __this__nativeId);

    @QtBlockedSlot public final void reset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);

    @QtBlockedSlot public final void resetStatus() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetStatus(nativeId());
    }
    private native static void __qt_resetStatus(long __this__nativeId);

    @QtBlockedSlot public final boolean seek(long pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_seek_long(nativeId(), pos);
    }
    private native static boolean __qt_seek_long(long __this__nativeId, long pos);

    @QtBlockedSlot public final void setAutoDetectUnicode(boolean enabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutoDetectUnicode_boolean(nativeId(), enabled);
    }
    private native static void __qt_setAutoDetectUnicode_boolean(long __this__nativeId, boolean enabled);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void setCodec(com.trolltech.qt.QNativePointer codecName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCodec_nativepointer(nativeId(), codecName);
    }
    private native static void __qt_setCodec_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer codecName);

    @QtBlockedSlot public final void setCodec(com.trolltech.qt.core.QTextCodec codec) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcCodec = codec;
        }
        __qt_setCodec_QTextCodec(nativeId(), codec == null ? 0 : codec.nativeId());
    }
    private native static void __qt_setCodec_QTextCodec(long __this__nativeId, long codec);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setFieldAlignment(com.trolltech.qt.core.QTextStream.FieldAlignment alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFieldAlignment_FieldAlignment(nativeId(), alignment.value());
    }
    private native static void __qt_setFieldAlignment_FieldAlignment(long __this__nativeId, int alignment);

    @QtBlockedSlot public final void setFieldWidth(int width) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFieldWidth_int(nativeId(), width);
    }
    private native static void __qt_setFieldWidth_int(long __this__nativeId, int width);

    @QtBlockedSlot public final void setGenerateByteOrderMark(boolean generate) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGenerateByteOrderMark_boolean(nativeId(), generate);
    }
    private native static void __qt_setGenerateByteOrderMark_boolean(long __this__nativeId, boolean generate);

    @QtBlockedSlot public final void setIntegerBase(int base) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIntegerBase_int(nativeId(), base);
    }
    private native static void __qt_setIntegerBase_int(long __this__nativeId, int base);


    @QtBlockedSlot public final void setNumberFlags(com.trolltech.qt.core.QTextStream.NumberFlag ... flags) {
        this.setNumberFlags(new com.trolltech.qt.core.QTextStream.NumberFlags(flags));
    }
    @QtBlockedSlot public final void setNumberFlags(com.trolltech.qt.core.QTextStream.NumberFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumberFlags_NumberFlags(nativeId(), flags.value());
    }
    private native static void __qt_setNumberFlags_NumberFlags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setPadChar(char ch) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPadChar_char(nativeId(), ch);
    }
    private native static void __qt_setPadChar_char(long __this__nativeId, char ch);

    @QtBlockedSlot public final void setRealNumberNotation(com.trolltech.qt.core.QTextStream.RealNumberNotation notation) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRealNumberNotation_RealNumberNotation(nativeId(), notation.value());
    }
    private native static void __qt_setRealNumberNotation_RealNumberNotation(long __this__nativeId, int notation);

    @QtBlockedSlot public final void setRealNumberPrecision(int precision) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRealNumberPrecision_int(nativeId(), precision);
    }
    private native static void __qt_setRealNumberPrecision_int(long __this__nativeId, int precision);

    @QtBlockedSlot public final void setStatus(com.trolltech.qt.core.QTextStream.Status status) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatus_Status(nativeId(), status.value());
    }
    private native static void __qt_setStatus_Status(long __this__nativeId, int status);

    @QtBlockedSlot public final void skipWhiteSpace() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_skipWhiteSpace(nativeId());
    }
    private native static void __qt_skipWhiteSpace(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTextStream.Status status() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTextStream.Status.resolve(__qt_status(nativeId()));
    }
    private native static int __qt_status(long __this__nativeId);


    public static native QTextStream fromNativePointer(QNativePointer nativePointer);

    protected QTextStream(QPrivateConstructor p) { super(p); } 


        public final void setCodec(String codecName) {
            setCodec(QNativePointer.createCharPointer(codecName));
            if (codec() != __rcCodec)
                __rcCodec = null;
        }
    

        private QNativePointer srb = new QNativePointer(QNativePointer.Type.Byte, 32) {
            {
                setVerificationEnabled(false);
            }
        };
        public final byte    readByte()    { operator_shift_right_byte(srb);    return srb.byteValue(); }
        public final short   readShort()   { operator_shift_right_short(srb);   return srb.shortValue(); }
        public final int     readInt()     { operator_shift_right_int(srb);     return srb.intValue(); }
        public final long    readLong()    { operator_shift_right_long(srb);    return srb.longValue(); }
        public final float   readFloat()   { operator_shift_right_float(srb);   return srb.floatValue(); }
        public final double  readDouble()  { operator_shift_right_double(srb);  return srb.doubleValue(); }
        public final QTextStream writeShort(short s) { writeShort_char((char) s); return this; }
        public final String readString() { return readString_native(nativeId()); }
        public final void writeString(String string) { writeString_native(nativeId(), string); }
        private final native String readString_native(long id);
        private final native void writeString_native(long id, String string);
    
}
