package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTimeLine extends com.trolltech.qt.core.QObject
{
    public enum Direction implements com.trolltech.qt.QtEnumerator {
        Forward(0),
        Backward(1);

        Direction(int value) { this.value = value; }
        public int value() { return value; }

        public static Direction resolve(int value) {
            return (Direction) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Forward;
            case 1: return Backward;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CurveShape implements com.trolltech.qt.QtEnumerator {
        EaseInCurve(0),
        EaseOutCurve(1),
        EaseInOutCurve(2),
        LinearCurve(3),
        SineCurve(4);

        CurveShape(int value) { this.value = value; }
        public int value() { return value; }

        public static CurveShape resolve(int value) {
            return (CurveShape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return EaseInCurve;
            case 1: return EaseOutCurve;
            case 2: return EaseInOutCurve;
            case 3: return LinearCurve;
            case 4: return SineCurve;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum State implements com.trolltech.qt.QtEnumerator {
        NotRunning(0),
        Paused(1),
        Running(2);

        State(int value) { this.value = value; }
        public int value() { return value; }

        public static State resolve(int value) {
            return (State) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotRunning;
            case 1: return Paused;
            case 2: return Running;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 finished = new Signal0();

    @SuppressWarnings("unused")
    private final void finished() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_finished(nativeId());
    }
    private native static void __qt_finished(long __this__nativeId);

    public final Signal1<java.lang.Integer> frameChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void frameChanged(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_frameChanged_int(nativeId(), arg__1);
    }
    private native static void __qt_frameChanged_int(long __this__nativeId, int arg__1);

    public final Signal1<com.trolltech.qt.core.QTimeLine.State> stateChanged = new Signal1<com.trolltech.qt.core.QTimeLine.State>();

    @SuppressWarnings("unused")
    private final void stateChanged(com.trolltech.qt.core.QTimeLine.State newState) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_State(nativeId(), newState.value());
    }
    private native static void __qt_stateChanged_State(long __this__nativeId, int newState);

    public final Signal1<java.lang.Double> valueChanged = new Signal1<java.lang.Double>();

    @SuppressWarnings("unused")
    private final void valueChanged(double x) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_valueChanged_double(nativeId(), x);
    }
    private native static void __qt_valueChanged_double(long __this__nativeId, double x);


    public QTimeLine(int duration) {
        this(duration, (com.trolltech.qt.core.QObject)null);
    }

    public QTimeLine() {
        this((int)1000, (com.trolltech.qt.core.QObject)null);
    }
    public QTimeLine(int duration, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QTimeLine_int_QObject(duration, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTimeLine_int_QObject(int duration, long parent);


    @QtBlockedSlot public final int currentFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentFrame(nativeId());
    }
    private native static int __qt_currentFrame(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentTime")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int currentTime() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentTime(nativeId());
    }
    private native static int __qt_currentTime(long __this__nativeId);

    @QtBlockedSlot public final double currentValue() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentValue(nativeId());
    }
    private native static double __qt_currentValue(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="curveShape")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.QTimeLine.CurveShape curveShape() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTimeLine.CurveShape.resolve(__qt_curveShape(nativeId()));
    }
    private native static int __qt_curveShape(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="direction")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.QTimeLine.Direction direction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTimeLine.Direction.resolve(__qt_direction(nativeId()));
    }
    private native static int __qt_direction(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="duration")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final int duration() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_duration(nativeId());
    }
    private native static int __qt_duration(long __this__nativeId);

    @QtBlockedSlot public final int endFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_endFrame(nativeId());
    }
    private native static int __qt_endFrame(long __this__nativeId);

    @QtBlockedSlot public final int frameForTime(int msec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameForTime_int(nativeId(), msec);
    }
    private native static int __qt_frameForTime_int(long __this__nativeId, int msec);

    @com.trolltech.qt.QtPropertyReader(name="loopCount")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int loopCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loopCount(nativeId());
    }
    private native static int __qt_loopCount(long __this__nativeId);

    public final void resume() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resume(nativeId());
    }
    private native static void __qt_resume(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="currentTime")
    public final void setCurrentTime(int msec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentTime_int(nativeId(), msec);
    }
    private native static void __qt_setCurrentTime_int(long __this__nativeId, int msec);

    @com.trolltech.qt.QtPropertyWriter(name="curveShape")
    @QtBlockedSlot public final void setCurveShape(com.trolltech.qt.core.QTimeLine.CurveShape shape) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurveShape_CurveShape(nativeId(), shape.value());
    }
    private native static void __qt_setCurveShape_CurveShape(long __this__nativeId, int shape);

    @com.trolltech.qt.QtPropertyWriter(name="direction")
    @QtBlockedSlot public final void setDirection(com.trolltech.qt.core.QTimeLine.Direction direction) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirection_Direction(nativeId(), direction.value());
    }
    private native static void __qt_setDirection_Direction(long __this__nativeId, int direction);

    @com.trolltech.qt.QtPropertyWriter(name="duration")
    @QtBlockedSlot public final void setDuration(int duration) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDuration_int(nativeId(), duration);
    }
    private native static void __qt_setDuration_int(long __this__nativeId, int duration);

    @QtBlockedSlot public final void setEndFrame(int frame) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEndFrame_int(nativeId(), frame);
    }
    private native static void __qt_setEndFrame_int(long __this__nativeId, int frame);

    @QtBlockedSlot public final void setFrameRange(int startFrame, int endFrame) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrameRange_int_int(nativeId(), startFrame, endFrame);
    }
    private native static void __qt_setFrameRange_int_int(long __this__nativeId, int startFrame, int endFrame);

    @com.trolltech.qt.QtPropertyWriter(name="loopCount")
    @QtBlockedSlot public final void setLoopCount(int count) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLoopCount_int(nativeId(), count);
    }
    private native static void __qt_setLoopCount_int(long __this__nativeId, int count);

    public final void setPaused(boolean paused) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPaused_boolean(nativeId(), paused);
    }
    private native static void __qt_setPaused_boolean(long __this__nativeId, boolean paused);

    @QtBlockedSlot public final void setStartFrame(int frame) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStartFrame_int(nativeId(), frame);
    }
    private native static void __qt_setStartFrame_int(long __this__nativeId, int frame);

    @com.trolltech.qt.QtPropertyWriter(name="updateInterval")
    @QtBlockedSlot public final void setUpdateInterval(int interval) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUpdateInterval_int(nativeId(), interval);
    }
    private native static void __qt_setUpdateInterval_int(long __this__nativeId, int interval);

    public final void start() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start(nativeId());
    }
    private native static void __qt_start(long __this__nativeId);

    @QtBlockedSlot public final int startFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_startFrame(nativeId());
    }
    private native static int __qt_startFrame(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QTimeLine.State state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QTimeLine.State.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);

    public final void stop() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stop(nativeId());
    }
    private native static void __qt_stop(long __this__nativeId);

    public final void toggleDirection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_toggleDirection(nativeId());
    }
    private native static void __qt_toggleDirection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="updateInterval")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int updateInterval() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_updateInterval(nativeId());
    }
    private native static int __qt_updateInterval(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long event);

    @QtBlockedSlot public double valueForTime(int msec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_valueForTime_int(nativeId(), msec);
    }
    private native static double __qt_valueForTime_int(long __this__nativeId, int msec);


    public static native QTimeLine fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTimeLine(QPrivateConstructor p) { super(p); } 

}
