package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QUrl extends com.trolltech.qt.QtJambiObject
    implements java.lang.Comparable
{
    static {
        com.trolltech.qt.core.QtJambi_LibraryInitializer.init();
    }
    public enum ParsingMode implements com.trolltech.qt.QtEnumerator {
        TolerantMode(0),
        StrictMode(1);

        ParsingMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ParsingMode resolve(int value) {
            return (ParsingMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TolerantMode;
            case 1: return StrictMode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FormattingOption implements com.trolltech.qt.QtEnumerator {
        None(0),
        RemoveScheme(1),
        RemovePassword(2),
        RemoveUserInfo(6),
        RemovePort(8),
        RemoveAuthority(30),
        RemovePath(32),
        RemoveQuery(64),
        RemoveFragment(128),
        StripTrailingSlash(65536);

        FormattingOption(int value) { this.value = value; }
        public int value() { return value; }

        public static FormattingOptions createQFlags(FormattingOption ... values) {
            return new FormattingOptions(values);
        }
        public static FormattingOption resolve(int value) {
            return (FormattingOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return RemoveScheme;
            case 2: return RemovePassword;
            case 6: return RemoveUserInfo;
            case 8: return RemovePort;
            case 30: return RemoveAuthority;
            case 32: return RemovePath;
            case 64: return RemoveQuery;
            case 128: return RemoveFragment;
            case 65536: return StripTrailingSlash;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FormattingOptions extends com.trolltech.qt.QFlags<FormattingOption> {
        private static final long serialVersionUID = 1L;
        public FormattingOptions(FormattingOption ... args) { super(args); }
        public FormattingOptions(int value) { setValue(value); }
    }


    public QUrl(com.trolltech.qt.core.QUrl copy) {
        super((QPrivateConstructor)null);
        __qt_QUrl_QUrl(copy == null ? (copy = new com.trolltech.qt.core.QUrl()).nativeId() : copy.nativeId());
    }
    private native void __qt_QUrl_QUrl(long copy);


    public QUrl(java.lang.String url) {
        super((QPrivateConstructor)null);
        __qt_QUrl_String(url);
    }
    private native void __qt_QUrl_String(java.lang.String url);


    public QUrl(java.lang.String url, com.trolltech.qt.core.QUrl.ParsingMode mode) {
        super((QPrivateConstructor)null);
        __qt_QUrl_String_ParsingMode(url, mode.value());
    }
    private native void __qt_QUrl_String_ParsingMode(java.lang.String url, int mode);


    public QUrl() {
        super((QPrivateConstructor)null);
        __qt_QUrl();
    }
    private native void __qt_QUrl();


    @QtBlockedSlot public final void addQueryItem(java.lang.String key, java.lang.String value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addQueryItem_String_String(nativeId(), key, value);
    }
    private native static void __qt_addQueryItem_String_String(long __this__nativeId, java.lang.String key, java.lang.String value);

    @QtBlockedSlot public final java.util.List<java.lang.String> allQueryItemValues(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_allQueryItemValues_String(nativeId(), key);
    }
    private native static java.util.List<java.lang.String> __qt_allQueryItemValues_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final java.lang.String authority() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_authority(nativeId());
    }
    private native static java.lang.String __qt_authority(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray encodedQuery() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_encodedQuery(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_encodedQuery(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fragment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fragment(nativeId());
    }
    private native static java.lang.String __qt_fragment(long __this__nativeId);

    @QtBlockedSlot public final boolean hasFragment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFragment(nativeId());
    }
    private native static boolean __qt_hasFragment(long __this__nativeId);

    @QtBlockedSlot public final boolean hasQuery() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasQuery(nativeId());
    }
    private native static boolean __qt_hasQuery(long __this__nativeId);

    @QtBlockedSlot public final boolean hasQueryItem(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasQueryItem_String(nativeId(), key);
    }
    private native static boolean __qt_hasQueryItem_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final java.lang.String host() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_host(nativeId());
    }
    private native static java.lang.String __qt_host(long __this__nativeId);

    @QtBlockedSlot public final boolean isEmpty() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @QtBlockedSlot public final boolean isParentOf(com.trolltech.qt.core.QUrl url) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isParentOf_QUrl(nativeId(), url == null ? (url = new com.trolltech.qt.core.QUrl()).nativeId() : url.nativeId());
    }
    private native static boolean __qt_isParentOf_QUrl(long __this__nativeId, long url);

    @QtBlockedSlot public final boolean isRelative() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRelative(nativeId());
    }
    private native static boolean __qt_isRelative(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_less(com.trolltech.qt.core.QUrl url) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QUrl(nativeId(), url == null ? (url = new com.trolltech.qt.core.QUrl()).nativeId() : url.nativeId());
    }
    private native static boolean __qt_operator_less_QUrl(long __this__nativeId, long url);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.core.QUrl url) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QUrl(nativeId(), url == null ? (url = new com.trolltech.qt.core.QUrl()).nativeId() : url.nativeId());
    }
    private native static boolean __qt_operator_equal_QUrl(long __this__nativeId, long url);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final java.lang.String password() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_password(nativeId());
    }
    private native static java.lang.String __qt_password(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String path() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_path(nativeId());
    }
    private native static java.lang.String __qt_path(long __this__nativeId);

    @QtBlockedSlot public final int port() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_port(nativeId());
    }
    private native static int __qt_port(long __this__nativeId);

    @QtBlockedSlot public final int port(int defaultPort) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_port_int(nativeId(), defaultPort);
    }
    private native static int __qt_port_int(long __this__nativeId, int defaultPort);

    @QtBlockedSlot public final java.lang.String queryItemValue(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_queryItemValue_String(nativeId(), key);
    }
    private native static java.lang.String __qt_queryItemValue_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.QPair<java.lang.String, java.lang.String>> queryItems() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_queryItems(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.QPair<java.lang.String, java.lang.String>> __qt_queryItems(long __this__nativeId);

    @QtBlockedSlot public final byte queryPairDelimiter() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_queryPairDelimiter(nativeId());
    }
    private native static byte __qt_queryPairDelimiter(long __this__nativeId);

    @QtBlockedSlot public final byte queryValueDelimiter() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_queryValueDelimiter(nativeId());
    }
    private native static byte __qt_queryValueDelimiter(long __this__nativeId);

    @QtBlockedSlot public final void removeAllQueryItems(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeAllQueryItems_String(nativeId(), key);
    }
    private native static void __qt_removeAllQueryItems_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final void removeQueryItem(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeQueryItem_String(nativeId(), key);
    }
    private native static void __qt_removeQueryItem_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final com.trolltech.qt.core.QUrl resolved(com.trolltech.qt.core.QUrl relative) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolved_QUrl(nativeId(), relative == null ? (relative = new com.trolltech.qt.core.QUrl()).nativeId() : relative.nativeId());
    }
    private native static com.trolltech.qt.core.QUrl __qt_resolved_QUrl(long __this__nativeId, long relative);

    @QtBlockedSlot public final java.lang.String scheme() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scheme(nativeId());
    }
    private native static java.lang.String __qt_scheme(long __this__nativeId);

    @QtBlockedSlot public final void setAuthority(java.lang.String authority) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAuthority_String(nativeId(), authority);
    }
    private native static void __qt_setAuthority_String(long __this__nativeId, java.lang.String authority);

    @QtBlockedSlot public final void setEncodedQuery(com.trolltech.qt.core.QByteArray query) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEncodedQuery_QByteArray(nativeId(), query == null ? (query = new com.trolltech.qt.core.QByteArray()).nativeId() : query.nativeId());
    }
    private native static void __qt_setEncodedQuery_QByteArray(long __this__nativeId, long query);

    @QtBlockedSlot public final void setEncodedUrl(com.trolltech.qt.core.QByteArray url, com.trolltech.qt.core.QUrl.ParsingMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEncodedUrl_QByteArray_ParsingMode(nativeId(), url == null ? (url = new com.trolltech.qt.core.QByteArray()).nativeId() : url.nativeId(), mode.value());
    }
    private native static void __qt_setEncodedUrl_QByteArray_ParsingMode(long __this__nativeId, long url, int mode);

    @QtBlockedSlot public final void setEncodedUrl(com.trolltech.qt.core.QByteArray url) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEncodedUrl_QByteArray(nativeId(), url == null ? (url = new com.trolltech.qt.core.QByteArray()).nativeId() : url.nativeId());
    }
    private native static void __qt_setEncodedUrl_QByteArray(long __this__nativeId, long url);

    @QtBlockedSlot public final void setFragment(java.lang.String fragment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFragment_String(nativeId(), fragment);
    }
    private native static void __qt_setFragment_String(long __this__nativeId, java.lang.String fragment);

    @QtBlockedSlot public final void setHost(java.lang.String host) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHost_String(nativeId(), host);
    }
    private native static void __qt_setHost_String(long __this__nativeId, java.lang.String host);

    @QtBlockedSlot public final void setPassword(java.lang.String password) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPassword_String(nativeId(), password);
    }
    private native static void __qt_setPassword_String(long __this__nativeId, java.lang.String password);

    @QtBlockedSlot public final void setPath(java.lang.String path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPath_String(nativeId(), path);
    }
    private native static void __qt_setPath_String(long __this__nativeId, java.lang.String path);

    @QtBlockedSlot public final void setPort(int port) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPort_int(nativeId(), port);
    }
    private native static void __qt_setPort_int(long __this__nativeId, int port);

    @QtBlockedSlot public final void setQueryDelimiters(byte valueDelimiter, byte pairDelimiter) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setQueryDelimiters_byte_byte(nativeId(), valueDelimiter, pairDelimiter);
    }
    private native static void __qt_setQueryDelimiters_byte_byte(long __this__nativeId, byte valueDelimiter, byte pairDelimiter);

    @QtBlockedSlot public final void setQueryItems(java.util.List<com.trolltech.qt.QPair<java.lang.String, java.lang.String>> query) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setQueryItems_List(nativeId(), query);
    }
    private native static void __qt_setQueryItems_List(long __this__nativeId, java.util.List<com.trolltech.qt.QPair<java.lang.String, java.lang.String>> query);

    @QtBlockedSlot public final void setScheme(java.lang.String scheme) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScheme_String(nativeId(), scheme);
    }
    private native static void __qt_setScheme_String(long __this__nativeId, java.lang.String scheme);

    @QtBlockedSlot public final void setUrl(java.lang.String url) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUrl_String(nativeId(), url);
    }
    private native static void __qt_setUrl_String(long __this__nativeId, java.lang.String url);

    @QtBlockedSlot public final void setUrl(java.lang.String url, com.trolltech.qt.core.QUrl.ParsingMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUrl_String_ParsingMode(nativeId(), url, mode.value());
    }
    private native static void __qt_setUrl_String_ParsingMode(long __this__nativeId, java.lang.String url, int mode);

    @QtBlockedSlot public final void setUserInfo(java.lang.String userInfo) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUserInfo_String(nativeId(), userInfo);
    }
    private native static void __qt_setUserInfo_String(long __this__nativeId, java.lang.String userInfo);

    @QtBlockedSlot public final void setUserName(java.lang.String userName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUserName_String(nativeId(), userName);
    }
    private native static void __qt_setUserName_String(long __this__nativeId, java.lang.String userName);


    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray toEncoded(com.trolltech.qt.core.QUrl.FormattingOption ... options) {
        return this.toEncoded(new com.trolltech.qt.core.QUrl.FormattingOptions(options));
    }

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray toEncoded() {
        return toEncoded(new com.trolltech.qt.core.QUrl.FormattingOptions(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray toEncoded(com.trolltech.qt.core.QUrl.FormattingOptions options) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toEncoded_FormattingOptions(nativeId(), options.value());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_toEncoded_FormattingOptions(long __this__nativeId, int options);

    @QtBlockedSlot public final java.lang.String toLocalFile() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toLocalFile(nativeId());
    }
    private native static java.lang.String __qt_toLocalFile(long __this__nativeId);


    @QtBlockedSlot public final java.lang.String toString(com.trolltech.qt.core.QUrl.FormattingOption ... options) {
        return this.toString(new com.trolltech.qt.core.QUrl.FormattingOptions(options));
    }

    @QtBlockedSlot public final java.lang.String toString() {
        return toString(new com.trolltech.qt.core.QUrl.FormattingOptions(0));
    }
    @QtBlockedSlot public final java.lang.String toString(com.trolltech.qt.core.QUrl.FormattingOptions options) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString_FormattingOptions(nativeId(), options.value());
    }
    private native static java.lang.String __qt_toString_FormattingOptions(long __this__nativeId, int options);

    @QtBlockedSlot public final java.lang.String userInfo() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_userInfo(nativeId());
    }
    private native static java.lang.String __qt_userInfo(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String userName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_userName(nativeId());
    }
    private native static java.lang.String __qt_userName(long __this__nativeId);

    public static java.lang.String fromAce(com.trolltech.qt.core.QByteArray arg__1) {
        return __qt_fromAce_QByteArray(arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QByteArray()).nativeId() : arg__1.nativeId());
    }
    private native static java.lang.String __qt_fromAce_QByteArray(long arg__1);

    public static com.trolltech.qt.core.QUrl fromEncoded(com.trolltech.qt.core.QByteArray url) {
        return __qt_fromEncoded_QByteArray(url == null ? (url = new com.trolltech.qt.core.QByteArray()).nativeId() : url.nativeId());
    }
    private native static com.trolltech.qt.core.QUrl __qt_fromEncoded_QByteArray(long url);

    public static com.trolltech.qt.core.QUrl fromEncoded(com.trolltech.qt.core.QByteArray url, com.trolltech.qt.core.QUrl.ParsingMode mode) {
        return __qt_fromEncoded_QByteArray_ParsingMode(url == null ? (url = new com.trolltech.qt.core.QByteArray()).nativeId() : url.nativeId(), mode.value());
    }
    private native static com.trolltech.qt.core.QUrl __qt_fromEncoded_QByteArray_ParsingMode(long url, int mode);

    public native static com.trolltech.qt.core.QUrl fromLocalFile(java.lang.String localfile);

    public static java.lang.String fromPercentEncoding(com.trolltech.qt.core.QByteArray arg__1) {
        return __qt_fromPercentEncoding_QByteArray(arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QByteArray()).nativeId() : arg__1.nativeId());
    }
    private native static java.lang.String __qt_fromPercentEncoding_QByteArray(long arg__1);

    public native static java.util.List<java.lang.String> idnWhitelist();

    public native static void setIdnWhitelist(java.util.List<java.lang.String> arg__1);

    public native static com.trolltech.qt.core.QByteArray toAce(java.lang.String arg__1);


    public static com.trolltech.qt.core.QByteArray toPercentEncoding(java.lang.String arg__1, com.trolltech.qt.core.QByteArray exclude) {
        return toPercentEncoding(arg__1, exclude, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }

    public static com.trolltech.qt.core.QByteArray toPercentEncoding(java.lang.String arg__1) {
        return toPercentEncoding(arg__1, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray(), (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }
    public static com.trolltech.qt.core.QByteArray toPercentEncoding(java.lang.String arg__1, com.trolltech.qt.core.QByteArray exclude, com.trolltech.qt.core.QByteArray include) {
        return __qt_toPercentEncoding_String_QByteArray_QByteArray(arg__1, exclude == null ? (exclude = new com.trolltech.qt.core.QByteArray()).nativeId() : exclude.nativeId(), include == null ? (include = new com.trolltech.qt.core.QByteArray()).nativeId() : include.nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_toPercentEncoding_String_QByteArray_QByteArray(java.lang.String arg__1, long exclude, long include);


    public static native QUrl fromNativePointer(QNativePointer nativePointer);

    protected QUrl(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QUrl array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.core.QUrl)
            return operator_equal((com.trolltech.qt.core.QUrl) other);
        return false;
    }

    public int compareTo(Object other) {
        if (equals(other)) return 0;
        else if (other instanceof com.trolltech.qt.core.QUrl && operator_less((com.trolltech.qt.core.QUrl) other)) return -1;
        else return 1;
    }
}
