package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public interface Qt
{
    public enum CursorShape implements com.trolltech.qt.QtEnumerator {
        ArrowCursor(0),
        UpArrowCursor(1),
        CrossCursor(2),
        WaitCursor(3),
        IBeamCursor(4),
        SizeVerCursor(5),
        SizeHorCursor(6),
        SizeBDiagCursor(7),
        SizeFDiagCursor(8),
        SizeAllCursor(9),
        BlankCursor(10),
        SplitVCursor(11),
        SplitHCursor(12),
        PointingHandCursor(13),
        ForbiddenCursor(14),
        WhatsThisCursor(15),
        BusyCursor(16),
        OpenHandCursor(17),
        ClosedHandCursor(18),
        BitmapCursor(24),
        CustomCursor(25);

        CursorShape(int value) { this.value = value; }
        public int value() { return value; }

        public static CursorShape resolve(int value) {
            return (CursorShape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ArrowCursor;
            case 1: return UpArrowCursor;
            case 2: return CrossCursor;
            case 3: return WaitCursor;
            case 4: return IBeamCursor;
            case 5: return SizeVerCursor;
            case 6: return SizeHorCursor;
            case 7: return SizeBDiagCursor;
            case 8: return SizeFDiagCursor;
            case 9: return SizeAllCursor;
            case 10: return BlankCursor;
            case 11: return SplitVCursor;
            case 12: return SplitHCursor;
            case 13: return PointingHandCursor;
            case 14: return ForbiddenCursor;
            case 15: return WhatsThisCursor;
            case 16: return BusyCursor;
            case 17: return OpenHandCursor;
            case 18: return ClosedHandCursor;
            case 24: return BitmapCursor;
            case 25: return CustomCursor;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Corner implements com.trolltech.qt.QtEnumerator {
        TopLeftCorner(0),
        TopRightCorner(1),
        BottomLeftCorner(2),
        BottomRightCorner(3);

        Corner(int value) { this.value = value; }
        public int value() { return value; }

        public static Corner resolve(int value) {
            return (Corner) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TopLeftCorner;
            case 1: return TopRightCorner;
            case 2: return BottomLeftCorner;
            case 3: return BottomRightCorner;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Axis implements com.trolltech.qt.QtEnumerator {
        XAxis(0),
        YAxis(1),
        ZAxis(2);

        Axis(int value) { this.value = value; }
        public int value() { return value; }

        public static Axis resolve(int value) {
            return (Axis) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return XAxis;
            case 1: return YAxis;
            case 2: return ZAxis;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Orientation implements com.trolltech.qt.QtEnumerator {
        Horizontal(1),
        Vertical(2);

        Orientation(int value) { this.value = value; }
        public int value() { return value; }

        public static Orientations createQFlags(Orientation ... values) {
            return new Orientations(values);
        }
        public static Orientation resolve(int value) {
            return (Orientation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Horizontal;
            case 2: return Vertical;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Orientations extends com.trolltech.qt.QFlags<Orientation> {
        private static final long serialVersionUID = 1L;
        public Orientations(Orientation ... args) { super(args); }
        public Orientations(int value) { setValue(value); }
    }

    public enum LayoutDirection implements com.trolltech.qt.QtEnumerator {
        LeftToRight(0),
        RightToLeft(1);

        LayoutDirection(int value) { this.value = value; }
        public int value() { return value; }

        public static LayoutDirection resolve(int value) {
            return (LayoutDirection) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LeftToRight;
            case 1: return RightToLeft;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum BGMode implements com.trolltech.qt.QtEnumerator {
        TransparentMode(0),
        OpaqueMode(1);

        BGMode(int value) { this.value = value; }
        public int value() { return value; }

        public static BGMode resolve(int value) {
            return (BGMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TransparentMode;
            case 1: return OpaqueMode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AspectRatioMode implements com.trolltech.qt.QtEnumerator {
        IgnoreAspectRatio(0),
        KeepAspectRatio(1),
        KeepAspectRatioByExpanding(2);

        AspectRatioMode(int value) { this.value = value; }
        public int value() { return value; }

        public static AspectRatioMode resolve(int value) {
            return (AspectRatioMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return IgnoreAspectRatio;
            case 1: return KeepAspectRatio;
            case 2: return KeepAspectRatioByExpanding;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TextElideMode implements com.trolltech.qt.QtEnumerator {
        ElideLeft(0),
        ElideRight(1),
        ElideMiddle(2),
        ElideNone(3);

        TextElideMode(int value) { this.value = value; }
        public int value() { return value; }

        public static TextElideMode resolve(int value) {
            return (TextElideMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ElideLeft;
            case 1: return ElideRight;
            case 2: return ElideMiddle;
            case 3: return ElideNone;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum WindowType implements com.trolltech.qt.QtEnumerator {
        Widget(0),
        Window(1),
        Dialog(3),
        Sheet(5),
        Drawer(7),
        Popup(9),
        Tool(11),
        ToolTip(13),
        SplashScreen(15),
        Desktop(17),
        SubWindow(18),
        WindowType_Mask(255),
        MSWindowsFixedSizeDialogHint(256),
        MSWindowsOwnDC(512),
        X11BypassWindowManagerHint(1024),
        FramelessWindowHint(2048),
        WindowTitleHint(4096),
        WindowSystemMenuHint(8192),
        WindowMinimizeButtonHint(16384),
        WindowMaximizeButtonHint(32768),
        WindowMinMaxButtonsHint(49152),
        WindowContextHelpButtonHint(65536),
        WindowShadeButtonHint(131072),
        WindowStaysOnTopHint(262144),
        CustomizeWindowHint(33554432);

        WindowType(int value) { this.value = value; }
        public int value() { return value; }

        public static WindowFlags createQFlags(WindowType ... values) {
            return new WindowFlags(values);
        }
        public static WindowType resolve(int value) {
            return (WindowType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Widget;
            case 1: return Window;
            case 3: return Dialog;
            case 5: return Sheet;
            case 7: return Drawer;
            case 9: return Popup;
            case 11: return Tool;
            case 13: return ToolTip;
            case 15: return SplashScreen;
            case 17: return Desktop;
            case 18: return SubWindow;
            case 255: return WindowType_Mask;
            case 256: return MSWindowsFixedSizeDialogHint;
            case 512: return MSWindowsOwnDC;
            case 1024: return X11BypassWindowManagerHint;
            case 2048: return FramelessWindowHint;
            case 4096: return WindowTitleHint;
            case 8192: return WindowSystemMenuHint;
            case 16384: return WindowMinimizeButtonHint;
            case 32768: return WindowMaximizeButtonHint;
            case 49152: return WindowMinMaxButtonsHint;
            case 65536: return WindowContextHelpButtonHint;
            case 131072: return WindowShadeButtonHint;
            case 262144: return WindowStaysOnTopHint;
            case 33554432: return CustomizeWindowHint;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class WindowFlags extends com.trolltech.qt.QFlags<WindowType> {
        private static final long serialVersionUID = 1L;
        public WindowFlags(WindowType ... args) { super(args); }
        public WindowFlags(int value) { setValue(value); }
    }

    public static class ItemDataRole{
        public static final int DisplayRole = 0;
        public static final int DecorationRole = 1;
        public static final int EditRole = 2;
        public static final int ToolTipRole = 3;
        public static final int StatusTipRole = 4;
        public static final int WhatsThisRole = 5;
        public static final int FontRole = 6;
        public static final int TextAlignmentRole = 7;
        public static final int BackgroundRole = 8;
        public static final int ForegroundRole = 9;
        public static final int CheckStateRole = 10;
        public static final int AccessibleTextRole = 11;
        public static final int AccessibleDescriptionRole = 12;
        public static final int SizeHintRole = 13;
        public static final int UserRole = 32;
    } // end of enum ItemDataRole

    public enum SortOrder implements com.trolltech.qt.QtEnumerator {
        AscendingOrder(0),
        DescendingOrder(1);

        SortOrder(int value) { this.value = value; }
        public int value() { return value; }

        public static SortOrder resolve(int value) {
            return (SortOrder) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AscendingOrder;
            case 1: return DescendingOrder;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MatchFlag implements com.trolltech.qt.QtEnumerator {
        MatchExactly(0),
        MatchContains(1),
        MatchStartsWith(2),
        MatchEndsWith(3),
        MatchRegExp(4),
        MatchWildcard(5),
        MatchFixedString(8),
        MatchCaseSensitive(16),
        MatchWrap(32),
        MatchRecursive(64);

        MatchFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static MatchFlags createQFlags(MatchFlag ... values) {
            return new MatchFlags(values);
        }
        public static MatchFlag resolve(int value) {
            return (MatchFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MatchExactly;
            case 1: return MatchContains;
            case 2: return MatchStartsWith;
            case 3: return MatchEndsWith;
            case 4: return MatchRegExp;
            case 5: return MatchWildcard;
            case 8: return MatchFixedString;
            case 16: return MatchCaseSensitive;
            case 32: return MatchWrap;
            case 64: return MatchRecursive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class MatchFlags extends com.trolltech.qt.QFlags<MatchFlag> {
        private static final long serialVersionUID = 1L;
        public MatchFlags(MatchFlag ... args) { super(args); }
        public MatchFlags(int value) { setValue(value); }
    }

    public enum PenJoinStyle implements com.trolltech.qt.QtEnumerator {
        MiterJoin(0),
        BevelJoin(64),
        RoundJoin(128),
        SvgMiterJoin(256),
        MPenJoinStyle(448);

        PenJoinStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static PenJoinStyle resolve(int value) {
            return (PenJoinStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MiterJoin;
            case 64: return BevelJoin;
            case 128: return RoundJoin;
            case 256: return SvgMiterJoin;
            case 448: return MPenJoinStyle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CaseSensitivity implements com.trolltech.qt.QtEnumerator {
        CaseInsensitive(0),
        CaseSensitive(1);

        CaseSensitivity(int value) { this.value = value; }
        public int value() { return value; }

        public static CaseSensitivity resolve(int value) {
            return (CaseSensitivity) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CaseInsensitive;
            case 1: return CaseSensitive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum BrushStyle implements com.trolltech.qt.QtEnumerator {
        NoBrush(0),
        SolidPattern(1),
        Dense1Pattern(2),
        Dense2Pattern(3),
        Dense3Pattern(4),
        Dense4Pattern(5),
        Dense5Pattern(6),
        Dense6Pattern(7),
        Dense7Pattern(8),
        HorPattern(9),
        VerPattern(10),
        CrossPattern(11),
        BDiagPattern(12),
        FDiagPattern(13),
        DiagCrossPattern(14),
        LinearGradientPattern(15),
        RadialGradientPattern(16),
        ConicalGradientPattern(17),
        TexturePattern(24);

        BrushStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static BrushStyle resolve(int value) {
            return (BrushStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoBrush;
            case 1: return SolidPattern;
            case 2: return Dense1Pattern;
            case 3: return Dense2Pattern;
            case 4: return Dense3Pattern;
            case 5: return Dense4Pattern;
            case 6: return Dense5Pattern;
            case 7: return Dense6Pattern;
            case 8: return Dense7Pattern;
            case 9: return HorPattern;
            case 10: return VerPattern;
            case 11: return CrossPattern;
            case 12: return BDiagPattern;
            case 13: return FDiagPattern;
            case 14: return DiagCrossPattern;
            case 15: return LinearGradientPattern;
            case 16: return RadialGradientPattern;
            case 17: return ConicalGradientPattern;
            case 24: return TexturePattern;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ClipOperation implements com.trolltech.qt.QtEnumerator {
        NoClip(0),
        ReplaceClip(1),
        IntersectClip(2),
        UniteClip(3);

        ClipOperation(int value) { this.value = value; }
        public int value() { return value; }

        public static ClipOperation resolve(int value) {
            return (ClipOperation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoClip;
            case 1: return ReplaceClip;
            case 2: return IntersectClip;
            case 3: return UniteClip;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FocusReason implements com.trolltech.qt.QtEnumerator {
        MouseFocusReason(0),
        TabFocusReason(1),
        BacktabFocusReason(2),
        ActiveWindowFocusReason(3),
        PopupFocusReason(4),
        ShortcutFocusReason(5),
        MenuBarFocusReason(6),
        OtherFocusReason(7),
        NoFocusReason(8);

        FocusReason(int value) { this.value = value; }
        public int value() { return value; }

        public static FocusReason resolve(int value) {
            return (FocusReason) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MouseFocusReason;
            case 1: return TabFocusReason;
            case 2: return BacktabFocusReason;
            case 3: return ActiveWindowFocusReason;
            case 4: return PopupFocusReason;
            case 5: return ShortcutFocusReason;
            case 6: return MenuBarFocusReason;
            case 7: return OtherFocusReason;
            case 8: return NoFocusReason;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolBarArea implements com.trolltech.qt.QtEnumerator {
        LeftToolBarArea(1),
        RightToolBarArea(2),
        TopToolBarArea(4),
        BottomToolBarArea(8),
        ToolBarArea_Mask(15),
        NoToolBarArea(0);

        ToolBarArea(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolBarAreas createQFlags(ToolBarArea ... values) {
            return new ToolBarAreas(values);
        }
        public static ToolBarArea resolve(int value) {
            return (ToolBarArea) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return LeftToolBarArea;
            case 2: return RightToolBarArea;
            case 4: return TopToolBarArea;
            case 8: return BottomToolBarArea;
            case 15: return ToolBarArea_Mask;
            case 0: return NoToolBarArea;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ToolBarAreas extends com.trolltech.qt.QFlags<ToolBarArea> {
        private static final long serialVersionUID = 1L;
        public ToolBarAreas(ToolBarArea ... args) { super(args); }
        public ToolBarAreas(int value) { setValue(value); }
    }

    public enum KeyboardModifier implements com.trolltech.qt.QtEnumerator {
        NoModifier(0),
        ShiftModifier(33554432),
        ControlModifier(67108864),
        AltModifier(134217728),
        MetaModifier(268435456),
        KeypadModifier(536870912),
        GroupSwitchModifier(1073741824),
        KeyboardModifierMask(-33554432);

        KeyboardModifier(int value) { this.value = value; }
        public int value() { return value; }

        public static KeyboardModifiers createQFlags(KeyboardModifier ... values) {
            return new KeyboardModifiers(values);
        }
        public static KeyboardModifier resolve(int value) {
            return (KeyboardModifier) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoModifier;
            case 33554432: return ShiftModifier;
            case 67108864: return ControlModifier;
            case 134217728: return AltModifier;
            case 268435456: return MetaModifier;
            case 536870912: return KeypadModifier;
            case 1073741824: return GroupSwitchModifier;
            case -33554432: return KeyboardModifierMask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class KeyboardModifiers extends com.trolltech.qt.QFlags<KeyboardModifier> {
        private static final long serialVersionUID = 1L;
        public KeyboardModifiers(KeyboardModifier ... args) { super(args); }
        public KeyboardModifiers(int value) { setValue(value); }
    }

    public enum WhiteSpaceMode implements com.trolltech.qt.QtEnumerator {
        WhiteSpaceNormal(0),
        WhiteSpacePre(1),
        WhiteSpaceNoWrap(2),
        WhiteSpaceModeUndefined(-1);

        WhiteSpaceMode(int value) { this.value = value; }
        public int value() { return value; }

        public static WhiteSpaceMode resolve(int value) {
            return (WhiteSpaceMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WhiteSpaceNormal;
            case 1: return WhiteSpacePre;
            case 2: return WhiteSpaceNoWrap;
            case -1: return WhiteSpaceModeUndefined;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DayOfWeek implements com.trolltech.qt.QtEnumerator {
        Monday(1),
        Tuesday(2),
        Wednesday(3),
        Thursday(4),
        Friday(5),
        Saturday(6),
        Sunday(7);

        DayOfWeek(int value) { this.value = value; }
        public int value() { return value; }

        public static DayOfWeek resolve(int value) {
            return (DayOfWeek) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Monday;
            case 2: return Tuesday;
            case 3: return Wednesday;
            case 4: return Thursday;
            case 5: return Friday;
            case 6: return Saturday;
            case 7: return Sunday;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum EventPriority implements com.trolltech.qt.QtEnumerator {
        HighEventPriority(1),
        NormalEventPriority(0),
        LowEventPriority(-1);

        EventPriority(int value) { this.value = value; }
        public int value() { return value; }

        public static EventPriority resolve(int value) {
            return (EventPriority) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return HighEventPriority;
            case 0: return NormalEventPriority;
            case -1: return LowEventPriority;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DateFormat implements com.trolltech.qt.QtEnumerator {
        TextDate(0),
        ISODate(1),
        SystemLocaleDate(2),
        LocaleDate(3);

        DateFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static DateFormat resolve(int value) {
            return (DateFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TextDate;
            case 1: return ISODate;
            case 2: return SystemLocaleDate;
            case 3: return LocaleDate;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MaskMode implements com.trolltech.qt.QtEnumerator {
        MaskInColor(0),
        MaskOutColor(1);

        MaskMode(int value) { this.value = value; }
        public int value() { return value; }

        public static MaskMode resolve(int value) {
            return (MaskMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MaskInColor;
            case 1: return MaskOutColor;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum UIEffect implements com.trolltech.qt.QtEnumerator {
        UI_General(0),
        UI_AnimateMenu(1),
        UI_FadeMenu(2),
        UI_AnimateCombo(3),
        UI_AnimateTooltip(4),
        UI_FadeTooltip(5),
        UI_AnimateToolBox(6);

        UIEffect(int value) { this.value = value; }
        public int value() { return value; }

        public static UIEffect resolve(int value) {
            return (UIEffect) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UI_General;
            case 1: return UI_AnimateMenu;
            case 2: return UI_FadeMenu;
            case 3: return UI_AnimateCombo;
            case 4: return UI_AnimateTooltip;
            case 5: return UI_FadeTooltip;
            case 6: return UI_AnimateToolBox;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ContextMenuPolicy implements com.trolltech.qt.QtEnumerator {
        NoContextMenu(0),
        DefaultContextMenu(1),
        ActionsContextMenu(2),
        CustomContextMenu(3),
        PreventContextMenu(4);

        ContextMenuPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static ContextMenuPolicy resolve(int value) {
            return (ContextMenuPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoContextMenu;
            case 1: return DefaultContextMenu;
            case 2: return ActionsContextMenu;
            case 3: return CustomContextMenu;
            case 4: return PreventContextMenu;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AnchorAttribute implements com.trolltech.qt.QtEnumerator {
        AnchorName(0),
        AnchorHref(1);

        AnchorAttribute(int value) { this.value = value; }
        public int value() { return value; }

        public static AnchorAttribute resolve(int value) {
            return (AnchorAttribute) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AnchorName;
            case 1: return AnchorHref;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ScrollBarPolicy implements com.trolltech.qt.QtEnumerator {
        ScrollBarAsNeeded(0),
        ScrollBarAlwaysOff(1),
        ScrollBarAlwaysOn(2);

        ScrollBarPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static ScrollBarPolicy resolve(int value) {
            return (ScrollBarPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ScrollBarAsNeeded;
            case 1: return ScrollBarAlwaysOff;
            case 2: return ScrollBarAlwaysOn;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolButtonStyle implements com.trolltech.qt.QtEnumerator {
        ToolButtonIconOnly(0),
        ToolButtonTextOnly(1),
        ToolButtonTextBesideIcon(2),
        ToolButtonTextUnderIcon(3);

        ToolButtonStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolButtonStyle resolve(int value) {
            return (ToolButtonStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ToolButtonIconOnly;
            case 1: return ToolButtonTextOnly;
            case 2: return ToolButtonTextBesideIcon;
            case 3: return ToolButtonTextUnderIcon;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TextFlag implements com.trolltech.qt.QtEnumerator {
        TextSingleLine(256),
        TextDontClip(512),
        TextExpandTabs(1024),
        TextShowMnemonic(2048),
        TextWordWrap(4096),
        TextWrapAnywhere(8192),
        TextDontPrint(16384),
        TextIncludeTrailingSpaces(134217728),
        TextHideMnemonic(32768),
        TextJustificationForced(65536);

        TextFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static TextFlag resolve(int value) {
            return (TextFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 256: return TextSingleLine;
            case 512: return TextDontClip;
            case 1024: return TextExpandTabs;
            case 2048: return TextShowMnemonic;
            case 4096: return TextWordWrap;
            case 8192: return TextWrapAnywhere;
            case 16384: return TextDontPrint;
            case 134217728: return TextIncludeTrailingSpaces;
            case 32768: return TextHideMnemonic;
            case 65536: return TextJustificationForced;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ItemSelectionMode implements com.trolltech.qt.QtEnumerator {
        ContainsItemShape(0),
        IntersectsItemShape(1),
        ContainsItemBoundingRect(2),
        IntersectsItemBoundingRect(3);

        ItemSelectionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemSelectionMode resolve(int value) {
            return (ItemSelectionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ContainsItemShape;
            case 1: return IntersectsItemShape;
            case 2: return ContainsItemBoundingRect;
            case 3: return IntersectsItemBoundingRect;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Key implements com.trolltech.qt.QtEnumerator {
        Key_Escape(16777216),
        Key_Tab(16777217),
        Key_Backtab(16777218),
        Key_Backspace(16777219),
        Key_Return(16777220),
        Key_Enter(16777221),
        Key_Insert(16777222),
        Key_Delete(16777223),
        Key_Pause(16777224),
        Key_Print(16777225),
        Key_SysReq(16777226),
        Key_Clear(16777227),
        Key_Home(16777232),
        Key_End(16777233),
        Key_Left(16777234),
        Key_Up(16777235),
        Key_Right(16777236),
        Key_Down(16777237),
        Key_PageUp(16777238),
        Key_PageDown(16777239),
        Key_Shift(16777248),
        Key_Control(16777249),
        Key_Meta(16777250),
        Key_Alt(16777251),
        Key_CapsLock(16777252),
        Key_NumLock(16777253),
        Key_ScrollLock(16777254),
        Key_F1(16777264),
        Key_F2(16777265),
        Key_F3(16777266),
        Key_F4(16777267),
        Key_F5(16777268),
        Key_F6(16777269),
        Key_F7(16777270),
        Key_F8(16777271),
        Key_F9(16777272),
        Key_F10(16777273),
        Key_F11(16777274),
        Key_F12(16777275),
        Key_F13(16777276),
        Key_F14(16777277),
        Key_F15(16777278),
        Key_F16(16777279),
        Key_F17(16777280),
        Key_F18(16777281),
        Key_F19(16777282),
        Key_F20(16777283),
        Key_F21(16777284),
        Key_F22(16777285),
        Key_F23(16777286),
        Key_F24(16777287),
        Key_F25(16777288),
        Key_F26(16777289),
        Key_F27(16777290),
        Key_F28(16777291),
        Key_F29(16777292),
        Key_F30(16777293),
        Key_F31(16777294),
        Key_F32(16777295),
        Key_F33(16777296),
        Key_F34(16777297),
        Key_F35(16777298),
        Key_Super_L(16777299),
        Key_Super_R(16777300),
        Key_Menu(16777301),
        Key_Hyper_L(16777302),
        Key_Hyper_R(16777303),
        Key_Help(16777304),
        Key_Direction_L(16777305),
        Key_Direction_R(16777312),
        Key_Space(32),
        Key_Exclam(33),
        Key_QuoteDbl(34),
        Key_NumberSign(35),
        Key_Dollar(36),
        Key_Percent(37),
        Key_Ampersand(38),
        Key_Apostrophe(39),
        Key_ParenLeft(40),
        Key_ParenRight(41),
        Key_Asterisk(42),
        Key_Plus(43),
        Key_Comma(44),
        Key_Minus(45),
        Key_Period(46),
        Key_Slash(47),
        Key_0(48),
        Key_1(49),
        Key_2(50),
        Key_3(51),
        Key_4(52),
        Key_5(53),
        Key_6(54),
        Key_7(55),
        Key_8(56),
        Key_9(57),
        Key_Colon(58),
        Key_Semicolon(59),
        Key_Less(60),
        Key_Equal(61),
        Key_Greater(62),
        Key_Question(63),
        Key_At(64),
        Key_A(65),
        Key_B(66),
        Key_C(67),
        Key_D(68),
        Key_E(69),
        Key_F(70),
        Key_G(71),
        Key_H(72),
        Key_I(73),
        Key_J(74),
        Key_K(75),
        Key_L(76),
        Key_M(77),
        Key_N(78),
        Key_O(79),
        Key_P(80),
        Key_Q(81),
        Key_R(82),
        Key_S(83),
        Key_T(84),
        Key_U(85),
        Key_V(86),
        Key_W(87),
        Key_X(88),
        Key_Y(89),
        Key_Z(90),
        Key_BracketLeft(91),
        Key_Backslash(92),
        Key_BracketRight(93),
        Key_AsciiCircum(94),
        Key_Underscore(95),
        Key_QuoteLeft(96),
        Key_BraceLeft(123),
        Key_Bar(124),
        Key_BraceRight(125),
        Key_AsciiTilde(126),
        Key_nobreakspace(160),
        Key_exclamdown(161),
        Key_cent(162),
        Key_sterling(163),
        Key_currency(164),
        Key_yen(165),
        Key_brokenbar(166),
        Key_section(167),
        Key_diaeresis(168),
        Key_copyright(169),
        Key_ordfeminine(170),
        Key_guillemotleft(171),
        Key_notsign(172),
        Key_hyphen(173),
        Key_registered(174),
        Key_macron(175),
        Key_degree(176),
        Key_plusminus(177),
        Key_twosuperior(178),
        Key_threesuperior(179),
        Key_acute(180),
        Key_mu(181),
        Key_paragraph(182),
        Key_periodcentered(183),
        Key_cedilla(184),
        Key_onesuperior(185),
        Key_masculine(186),
        Key_guillemotright(187),
        Key_onequarter(188),
        Key_onehalf(189),
        Key_threequarters(190),
        Key_questiondown(191),
        Key_Agrave(192),
        Key_Aacute(193),
        Key_Acircumflex(194),
        Key_Atilde(195),
        Key_Adiaeresis(196),
        Key_Aring(197),
        Key_AE(198),
        Key_Ccedilla(199),
        Key_Egrave(200),
        Key_Eacute(201),
        Key_Ecircumflex(202),
        Key_Ediaeresis(203),
        Key_Igrave(204),
        Key_Iacute(205),
        Key_Icircumflex(206),
        Key_Idiaeresis(207),
        Key_ETH(208),
        Key_Ntilde(209),
        Key_Ograve(210),
        Key_Oacute(211),
        Key_Ocircumflex(212),
        Key_Otilde(213),
        Key_Odiaeresis(214),
        Key_multiply(215),
        Key_Ooblique(216),
        Key_Ugrave(217),
        Key_Uacute(218),
        Key_Ucircumflex(219),
        Key_Udiaeresis(220),
        Key_Yacute(221),
        Key_THORN(222),
        Key_ssharp(223),
        Key_division(247),
        Key_ydiaeresis(255),
        Key_AltGr(16781571),
        Key_Multi_key(16781600),
        Key_Codeinput(16781623),
        Key_SingleCandidate(16781628),
        Key_MultipleCandidate(16781629),
        Key_PreviousCandidate(16781630),
        Key_Mode_switch(16781694),
        Key_Kanji(16781601),
        Key_Muhenkan(16781602),
        Key_Henkan(16781603),
        Key_Romaji(16781604),
        Key_Hiragana(16781605),
        Key_Katakana(16781606),
        Key_Hiragana_Katakana(16781607),
        Key_Zenkaku(16781608),
        Key_Hankaku(16781609),
        Key_Zenkaku_Hankaku(16781610),
        Key_Touroku(16781611),
        Key_Massyo(16781612),
        Key_Kana_Lock(16781613),
        Key_Kana_Shift(16781614),
        Key_Eisu_Shift(16781615),
        Key_Eisu_toggle(16781616),
        Key_Hangul(16781617),
        Key_Hangul_Start(16781618),
        Key_Hangul_End(16781619),
        Key_Hangul_Hanja(16781620),
        Key_Hangul_Jamo(16781621),
        Key_Hangul_Romaja(16781622),
        Key_Hangul_Jeonja(16781624),
        Key_Hangul_Banja(16781625),
        Key_Hangul_PreHanja(16781626),
        Key_Hangul_PostHanja(16781627),
        Key_Hangul_Special(16781631),
        Key_Dead_Grave(16781904),
        Key_Dead_Acute(16781905),
        Key_Dead_Circumflex(16781906),
        Key_Dead_Tilde(16781907),
        Key_Dead_Macron(16781908),
        Key_Dead_Breve(16781909),
        Key_Dead_Abovedot(16781910),
        Key_Dead_Diaeresis(16781911),
        Key_Dead_Abovering(16781912),
        Key_Dead_Doubleacute(16781913),
        Key_Dead_Caron(16781914),
        Key_Dead_Cedilla(16781915),
        Key_Dead_Ogonek(16781916),
        Key_Dead_Iota(16781917),
        Key_Dead_Voiced_Sound(16781918),
        Key_Dead_Semivoiced_Sound(16781919),
        Key_Dead_Belowdot(16781920),
        Key_Dead_Hook(16781921),
        Key_Dead_Horn(16781922),
        Key_Back(16777313),
        Key_Forward(16777314),
        Key_Stop(16777315),
        Key_Refresh(16777316),
        Key_VolumeDown(16777328),
        Key_VolumeMute(16777329),
        Key_VolumeUp(16777330),
        Key_BassBoost(16777331),
        Key_BassUp(16777332),
        Key_BassDown(16777333),
        Key_TrebleUp(16777334),
        Key_TrebleDown(16777335),
        Key_MediaPlay(16777344),
        Key_MediaStop(16777345),
        Key_MediaPrevious(16777346),
        Key_MediaNext(16777347),
        Key_MediaRecord(16777348),
        Key_HomePage(16777360),
        Key_Favorites(16777361),
        Key_Search(16777362),
        Key_Standby(16777363),
        Key_OpenUrl(16777364),
        Key_LaunchMail(16777376),
        Key_LaunchMedia(16777377),
        Key_Launch0(16777378),
        Key_Launch1(16777379),
        Key_Launch2(16777380),
        Key_Launch3(16777381),
        Key_Launch4(16777382),
        Key_Launch5(16777383),
        Key_Launch6(16777384),
        Key_Launch7(16777385),
        Key_Launch8(16777386),
        Key_Launch9(16777387),
        Key_LaunchA(16777388),
        Key_LaunchB(16777389),
        Key_LaunchC(16777390),
        Key_LaunchD(16777391),
        Key_LaunchE(16777392),
        Key_LaunchF(16777393),
        Key_MediaLast(16842751),
        Key_Select(16842752),
        Key_Yes(16842753),
        Key_No(16842754),
        Key_Cancel(16908289),
        Key_Printer(16908290),
        Key_Execute(16908291),
        Key_Sleep(16908292),
        Key_Play(16908293),
        Key_Zoom(16908294),
        Key_Context1(17825792),
        Key_Context2(17825793),
        Key_Context3(17825794),
        Key_Context4(17825795),
        Key_Call(17825796),
        Key_Hangup(17825797),
        Key_Flip(17825798),
        Key_unknown(33554431);

        Key(int value) { this.value = value; }
        public int value() { return value; }

        public static Key resolve(int value) {
            return (Key) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 16777216: return Key_Escape;
            case 16777217: return Key_Tab;
            case 16777218: return Key_Backtab;
            case 16777219: return Key_Backspace;
            case 16777220: return Key_Return;
            case 16777221: return Key_Enter;
            case 16777222: return Key_Insert;
            case 16777223: return Key_Delete;
            case 16777224: return Key_Pause;
            case 16777225: return Key_Print;
            case 16777226: return Key_SysReq;
            case 16777227: return Key_Clear;
            case 16777232: return Key_Home;
            case 16777233: return Key_End;
            case 16777234: return Key_Left;
            case 16777235: return Key_Up;
            case 16777236: return Key_Right;
            case 16777237: return Key_Down;
            case 16777238: return Key_PageUp;
            case 16777239: return Key_PageDown;
            case 16777248: return Key_Shift;
            case 16777249: return Key_Control;
            case 16777250: return Key_Meta;
            case 16777251: return Key_Alt;
            case 16777252: return Key_CapsLock;
            case 16777253: return Key_NumLock;
            case 16777254: return Key_ScrollLock;
            case 16777264: return Key_F1;
            case 16777265: return Key_F2;
            case 16777266: return Key_F3;
            case 16777267: return Key_F4;
            case 16777268: return Key_F5;
            case 16777269: return Key_F6;
            case 16777270: return Key_F7;
            case 16777271: return Key_F8;
            case 16777272: return Key_F9;
            case 16777273: return Key_F10;
            case 16777274: return Key_F11;
            case 16777275: return Key_F12;
            case 16777276: return Key_F13;
            case 16777277: return Key_F14;
            case 16777278: return Key_F15;
            case 16777279: return Key_F16;
            case 16777280: return Key_F17;
            case 16777281: return Key_F18;
            case 16777282: return Key_F19;
            case 16777283: return Key_F20;
            case 16777284: return Key_F21;
            case 16777285: return Key_F22;
            case 16777286: return Key_F23;
            case 16777287: return Key_F24;
            case 16777288: return Key_F25;
            case 16777289: return Key_F26;
            case 16777290: return Key_F27;
            case 16777291: return Key_F28;
            case 16777292: return Key_F29;
            case 16777293: return Key_F30;
            case 16777294: return Key_F31;
            case 16777295: return Key_F32;
            case 16777296: return Key_F33;
            case 16777297: return Key_F34;
            case 16777298: return Key_F35;
            case 16777299: return Key_Super_L;
            case 16777300: return Key_Super_R;
            case 16777301: return Key_Menu;
            case 16777302: return Key_Hyper_L;
            case 16777303: return Key_Hyper_R;
            case 16777304: return Key_Help;
            case 16777305: return Key_Direction_L;
            case 16777312: return Key_Direction_R;
            case 32: return Key_Space;
            case 33: return Key_Exclam;
            case 34: return Key_QuoteDbl;
            case 35: return Key_NumberSign;
            case 36: return Key_Dollar;
            case 37: return Key_Percent;
            case 38: return Key_Ampersand;
            case 39: return Key_Apostrophe;
            case 40: return Key_ParenLeft;
            case 41: return Key_ParenRight;
            case 42: return Key_Asterisk;
            case 43: return Key_Plus;
            case 44: return Key_Comma;
            case 45: return Key_Minus;
            case 46: return Key_Period;
            case 47: return Key_Slash;
            case 48: return Key_0;
            case 49: return Key_1;
            case 50: return Key_2;
            case 51: return Key_3;
            case 52: return Key_4;
            case 53: return Key_5;
            case 54: return Key_6;
            case 55: return Key_7;
            case 56: return Key_8;
            case 57: return Key_9;
            case 58: return Key_Colon;
            case 59: return Key_Semicolon;
            case 60: return Key_Less;
            case 61: return Key_Equal;
            case 62: return Key_Greater;
            case 63: return Key_Question;
            case 64: return Key_At;
            case 65: return Key_A;
            case 66: return Key_B;
            case 67: return Key_C;
            case 68: return Key_D;
            case 69: return Key_E;
            case 70: return Key_F;
            case 71: return Key_G;
            case 72: return Key_H;
            case 73: return Key_I;
            case 74: return Key_J;
            case 75: return Key_K;
            case 76: return Key_L;
            case 77: return Key_M;
            case 78: return Key_N;
            case 79: return Key_O;
            case 80: return Key_P;
            case 81: return Key_Q;
            case 82: return Key_R;
            case 83: return Key_S;
            case 84: return Key_T;
            case 85: return Key_U;
            case 86: return Key_V;
            case 87: return Key_W;
            case 88: return Key_X;
            case 89: return Key_Y;
            case 90: return Key_Z;
            case 91: return Key_BracketLeft;
            case 92: return Key_Backslash;
            case 93: return Key_BracketRight;
            case 94: return Key_AsciiCircum;
            case 95: return Key_Underscore;
            case 96: return Key_QuoteLeft;
            case 123: return Key_BraceLeft;
            case 124: return Key_Bar;
            case 125: return Key_BraceRight;
            case 126: return Key_AsciiTilde;
            case 160: return Key_nobreakspace;
            case 161: return Key_exclamdown;
            case 162: return Key_cent;
            case 163: return Key_sterling;
            case 164: return Key_currency;
            case 165: return Key_yen;
            case 166: return Key_brokenbar;
            case 167: return Key_section;
            case 168: return Key_diaeresis;
            case 169: return Key_copyright;
            case 170: return Key_ordfeminine;
            case 171: return Key_guillemotleft;
            case 172: return Key_notsign;
            case 173: return Key_hyphen;
            case 174: return Key_registered;
            case 175: return Key_macron;
            case 176: return Key_degree;
            case 177: return Key_plusminus;
            case 178: return Key_twosuperior;
            case 179: return Key_threesuperior;
            case 180: return Key_acute;
            case 181: return Key_mu;
            case 182: return Key_paragraph;
            case 183: return Key_periodcentered;
            case 184: return Key_cedilla;
            case 185: return Key_onesuperior;
            case 186: return Key_masculine;
            case 187: return Key_guillemotright;
            case 188: return Key_onequarter;
            case 189: return Key_onehalf;
            case 190: return Key_threequarters;
            case 191: return Key_questiondown;
            case 192: return Key_Agrave;
            case 193: return Key_Aacute;
            case 194: return Key_Acircumflex;
            case 195: return Key_Atilde;
            case 196: return Key_Adiaeresis;
            case 197: return Key_Aring;
            case 198: return Key_AE;
            case 199: return Key_Ccedilla;
            case 200: return Key_Egrave;
            case 201: return Key_Eacute;
            case 202: return Key_Ecircumflex;
            case 203: return Key_Ediaeresis;
            case 204: return Key_Igrave;
            case 205: return Key_Iacute;
            case 206: return Key_Icircumflex;
            case 207: return Key_Idiaeresis;
            case 208: return Key_ETH;
            case 209: return Key_Ntilde;
            case 210: return Key_Ograve;
            case 211: return Key_Oacute;
            case 212: return Key_Ocircumflex;
            case 213: return Key_Otilde;
            case 214: return Key_Odiaeresis;
            case 215: return Key_multiply;
            case 216: return Key_Ooblique;
            case 217: return Key_Ugrave;
            case 218: return Key_Uacute;
            case 219: return Key_Ucircumflex;
            case 220: return Key_Udiaeresis;
            case 221: return Key_Yacute;
            case 222: return Key_THORN;
            case 223: return Key_ssharp;
            case 247: return Key_division;
            case 255: return Key_ydiaeresis;
            case 16781571: return Key_AltGr;
            case 16781600: return Key_Multi_key;
            case 16781623: return Key_Codeinput;
            case 16781628: return Key_SingleCandidate;
            case 16781629: return Key_MultipleCandidate;
            case 16781630: return Key_PreviousCandidate;
            case 16781694: return Key_Mode_switch;
            case 16781601: return Key_Kanji;
            case 16781602: return Key_Muhenkan;
            case 16781603: return Key_Henkan;
            case 16781604: return Key_Romaji;
            case 16781605: return Key_Hiragana;
            case 16781606: return Key_Katakana;
            case 16781607: return Key_Hiragana_Katakana;
            case 16781608: return Key_Zenkaku;
            case 16781609: return Key_Hankaku;
            case 16781610: return Key_Zenkaku_Hankaku;
            case 16781611: return Key_Touroku;
            case 16781612: return Key_Massyo;
            case 16781613: return Key_Kana_Lock;
            case 16781614: return Key_Kana_Shift;
            case 16781615: return Key_Eisu_Shift;
            case 16781616: return Key_Eisu_toggle;
            case 16781617: return Key_Hangul;
            case 16781618: return Key_Hangul_Start;
            case 16781619: return Key_Hangul_End;
            case 16781620: return Key_Hangul_Hanja;
            case 16781621: return Key_Hangul_Jamo;
            case 16781622: return Key_Hangul_Romaja;
            case 16781624: return Key_Hangul_Jeonja;
            case 16781625: return Key_Hangul_Banja;
            case 16781626: return Key_Hangul_PreHanja;
            case 16781627: return Key_Hangul_PostHanja;
            case 16781631: return Key_Hangul_Special;
            case 16781904: return Key_Dead_Grave;
            case 16781905: return Key_Dead_Acute;
            case 16781906: return Key_Dead_Circumflex;
            case 16781907: return Key_Dead_Tilde;
            case 16781908: return Key_Dead_Macron;
            case 16781909: return Key_Dead_Breve;
            case 16781910: return Key_Dead_Abovedot;
            case 16781911: return Key_Dead_Diaeresis;
            case 16781912: return Key_Dead_Abovering;
            case 16781913: return Key_Dead_Doubleacute;
            case 16781914: return Key_Dead_Caron;
            case 16781915: return Key_Dead_Cedilla;
            case 16781916: return Key_Dead_Ogonek;
            case 16781917: return Key_Dead_Iota;
            case 16781918: return Key_Dead_Voiced_Sound;
            case 16781919: return Key_Dead_Semivoiced_Sound;
            case 16781920: return Key_Dead_Belowdot;
            case 16781921: return Key_Dead_Hook;
            case 16781922: return Key_Dead_Horn;
            case 16777313: return Key_Back;
            case 16777314: return Key_Forward;
            case 16777315: return Key_Stop;
            case 16777316: return Key_Refresh;
            case 16777328: return Key_VolumeDown;
            case 16777329: return Key_VolumeMute;
            case 16777330: return Key_VolumeUp;
            case 16777331: return Key_BassBoost;
            case 16777332: return Key_BassUp;
            case 16777333: return Key_BassDown;
            case 16777334: return Key_TrebleUp;
            case 16777335: return Key_TrebleDown;
            case 16777344: return Key_MediaPlay;
            case 16777345: return Key_MediaStop;
            case 16777346: return Key_MediaPrevious;
            case 16777347: return Key_MediaNext;
            case 16777348: return Key_MediaRecord;
            case 16777360: return Key_HomePage;
            case 16777361: return Key_Favorites;
            case 16777362: return Key_Search;
            case 16777363: return Key_Standby;
            case 16777364: return Key_OpenUrl;
            case 16777376: return Key_LaunchMail;
            case 16777377: return Key_LaunchMedia;
            case 16777378: return Key_Launch0;
            case 16777379: return Key_Launch1;
            case 16777380: return Key_Launch2;
            case 16777381: return Key_Launch3;
            case 16777382: return Key_Launch4;
            case 16777383: return Key_Launch5;
            case 16777384: return Key_Launch6;
            case 16777385: return Key_Launch7;
            case 16777386: return Key_Launch8;
            case 16777387: return Key_Launch9;
            case 16777388: return Key_LaunchA;
            case 16777389: return Key_LaunchB;
            case 16777390: return Key_LaunchC;
            case 16777391: return Key_LaunchD;
            case 16777392: return Key_LaunchE;
            case 16777393: return Key_LaunchF;
            case 16842751: return Key_MediaLast;
            case 16842752: return Key_Select;
            case 16842753: return Key_Yes;
            case 16842754: return Key_No;
            case 16908289: return Key_Cancel;
            case 16908290: return Key_Printer;
            case 16908291: return Key_Execute;
            case 16908292: return Key_Sleep;
            case 16908293: return Key_Play;
            case 16908294: return Key_Zoom;
            case 17825792: return Key_Context1;
            case 17825793: return Key_Context2;
            case 17825794: return Key_Context3;
            case 17825795: return Key_Context4;
            case 17825796: return Key_Call;
            case 17825797: return Key_Hangup;
            case 17825798: return Key_Flip;
            case 33554431: return Key_unknown;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolBarAreaSizes implements com.trolltech.qt.QtEnumerator {
        NToolBarAreas(4);

        ToolBarAreaSizes(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolBarAreaSizes resolve(int value) {
            return (ToolBarAreaSizes) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 4: return NToolBarAreas;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ArrowType implements com.trolltech.qt.QtEnumerator {
        NoArrow(0),
        UpArrow(1),
        DownArrow(2),
        LeftArrow(3),
        RightArrow(4);

        ArrowType(int value) { this.value = value; }
        public int value() { return value; }

        public static ArrowType resolve(int value) {
            return (ArrowType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoArrow;
            case 1: return UpArrow;
            case 2: return DownArrow;
            case 3: return LeftArrow;
            case 4: return RightArrow;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FocusPolicy implements com.trolltech.qt.QtEnumerator {
        NoFocus(0),
        TabFocus(1),
        ClickFocus(2),
        StrongFocus(11),
        WheelFocus(15);

        FocusPolicy(int value) { this.value = value; }
        public int value() { return value; }

        public static FocusPolicy resolve(int value) {
            return (FocusPolicy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoFocus;
            case 1: return TabFocus;
            case 2: return ClickFocus;
            case 11: return StrongFocus;
            case 15: return WheelFocus;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum InputMethodQuery implements com.trolltech.qt.QtEnumerator {
        ImMicroFocus(0),
        ImFont(1),
        ImCursorPosition(2),
        ImSurroundingText(3),
        ImCurrentSelection(4);

        InputMethodQuery(int value) { this.value = value; }
        public int value() { return value; }

        public static InputMethodQuery resolve(int value) {
            return (InputMethodQuery) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ImMicroFocus;
            case 1: return ImFont;
            case 2: return ImCursorPosition;
            case 3: return ImSurroundingText;
            case 4: return ImCurrentSelection;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DropAction implements com.trolltech.qt.QtEnumerator {
        CopyAction(1),
        MoveAction(2),
        LinkAction(4),
        ActionMask(255),
        TargetMoveAction(32770),
        IgnoreAction(0);

        DropAction(int value) { this.value = value; }
        public int value() { return value; }

        public static DropActions createQFlags(DropAction ... values) {
            return new DropActions(values);
        }
        public static DropAction resolve(int value) {
            return (DropAction) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return CopyAction;
            case 2: return MoveAction;
            case 4: return LinkAction;
            case 255: return ActionMask;
            case 32770: return TargetMoveAction;
            case 0: return IgnoreAction;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class DropActions extends com.trolltech.qt.QFlags<DropAction> {
        private static final long serialVersionUID = 1L;
        public DropActions(DropAction ... args) { super(args); }
        public DropActions(int value) { setValue(value); }
    }

    public enum FillRule implements com.trolltech.qt.QtEnumerator {
        OddEvenFill(0),
        WindingFill(1);

        FillRule(int value) { this.value = value; }
        public int value() { return value; }

        public static FillRule resolve(int value) {
            return (FillRule) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OddEvenFill;
            case 1: return WindingFill;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum GlobalColor implements com.trolltech.qt.QtEnumerator {
        color0(0),
        color1(1),
        black(2),
        white(3),
        darkGray(4),
        gray(5),
        lightGray(6),
        red(7),
        green(8),
        blue(9),
        cyan(10),
        magenta(11),
        yellow(12),
        darkRed(13),
        darkGreen(14),
        darkBlue(15),
        darkCyan(16),
        darkMagenta(17),
        darkYellow(18),
        transparent(19);

        GlobalColor(int value) { this.value = value; }
        public int value() { return value; }

        public static GlobalColor resolve(int value) {
            return (GlobalColor) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return color0;
            case 1: return color1;
            case 2: return black;
            case 3: return white;
            case 4: return darkGray;
            case 5: return gray;
            case 6: return lightGray;
            case 7: return red;
            case 8: return green;
            case 9: return blue;
            case 10: return cyan;
            case 11: return magenta;
            case 12: return yellow;
            case 13: return darkRed;
            case 14: return darkGreen;
            case 15: return darkBlue;
            case 16: return darkCyan;
            case 17: return darkMagenta;
            case 18: return darkYellow;
            case 19: return transparent;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ConnectionType implements com.trolltech.qt.QtEnumerator {
        AutoConnection(0),
        DirectConnection(1),
        QueuedConnection(2),
        AutoCompatConnection(3),
        BlockingQueuedConnection(4);

        ConnectionType(int value) { this.value = value; }
        public int value() { return value; }

        public static ConnectionType resolve(int value) {
            return (ConnectionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AutoConnection;
            case 1: return DirectConnection;
            case 2: return QueuedConnection;
            case 3: return AutoCompatConnection;
            case 4: return BlockingQueuedConnection;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PenCapStyle implements com.trolltech.qt.QtEnumerator {
        FlatCap(0),
        SquareCap(16),
        RoundCap(32),
        MPenCapStyle(48);

        PenCapStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static PenCapStyle resolve(int value) {
            return (PenCapStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FlatCap;
            case 16: return SquareCap;
            case 32: return RoundCap;
            case 48: return MPenCapStyle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TransformationMode implements com.trolltech.qt.QtEnumerator {
        FastTransformation(0),
        SmoothTransformation(1);

        TransformationMode(int value) { this.value = value; }
        public int value() { return value; }

        public static TransformationMode resolve(int value) {
            return (TransformationMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FastTransformation;
            case 1: return SmoothTransformation;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DockWidgetAreaSizes implements com.trolltech.qt.QtEnumerator {
        NDockWidgetAreas(4);

        DockWidgetAreaSizes(int value) { this.value = value; }
        public int value() { return value; }

        public static DockWidgetAreaSizes resolve(int value) {
            return (DockWidgetAreaSizes) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 4: return NDockWidgetAreas;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ApplicationAttribute implements com.trolltech.qt.QtEnumerator {
        AA_ImmediateWidgetCreation(0),
        AA_MSWindowsUseDirect3DByDefault(1),
        AA_AttributeCount(2);

        ApplicationAttribute(int value) { this.value = value; }
        public int value() { return value; }

        public static ApplicationAttribute resolve(int value) {
            return (ApplicationAttribute) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AA_ImmediateWidgetCreation;
            case 1: return AA_MSWindowsUseDirect3DByDefault;
            case 2: return AA_AttributeCount;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ShortcutContext implements com.trolltech.qt.QtEnumerator {
        WidgetShortcut(0),
        WindowShortcut(1),
        ApplicationShortcut(2);

        ShortcutContext(int value) { this.value = value; }
        public int value() { return value; }

        public static ShortcutContext resolve(int value) {
            return (ShortcutContext) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WidgetShortcut;
            case 1: return WindowShortcut;
            case 2: return ApplicationShortcut;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TextInteractionFlag implements com.trolltech.qt.QtEnumerator {
        NoTextInteraction(0),
        TextSelectableByMouse(1),
        TextSelectableByKeyboard(2),
        LinksAccessibleByMouse(4),
        LinksAccessibleByKeyboard(8),
        TextEditable(16),
        TextEditorInteraction(19),
        TextBrowserInteraction(13);

        TextInteractionFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static TextInteractionFlags createQFlags(TextInteractionFlag ... values) {
            return new TextInteractionFlags(values);
        }
        public static TextInteractionFlag resolve(int value) {
            return (TextInteractionFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoTextInteraction;
            case 1: return TextSelectableByMouse;
            case 2: return TextSelectableByKeyboard;
            case 4: return LinksAccessibleByMouse;
            case 8: return LinksAccessibleByKeyboard;
            case 16: return TextEditable;
            case 19: return TextEditorInteraction;
            case 13: return TextBrowserInteraction;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class TextInteractionFlags extends com.trolltech.qt.QFlags<TextInteractionFlag> {
        private static final long serialVersionUID = 1L;
        public TextInteractionFlags(TextInteractionFlag ... args) { super(args); }
        public TextInteractionFlags(int value) { setValue(value); }
    }

    public enum CheckState implements com.trolltech.qt.QtEnumerator {
        Unchecked(0),
        PartiallyChecked(1),
        Checked(2);

        CheckState(int value) { this.value = value; }
        public int value() { return value; }

        public static CheckState resolve(int value) {
            return (CheckState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Unchecked;
            case 1: return PartiallyChecked;
            case 2: return Checked;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DockWidgetArea implements com.trolltech.qt.QtEnumerator {
        LeftDockWidgetArea(1),
        RightDockWidgetArea(2),
        TopDockWidgetArea(4),
        BottomDockWidgetArea(8),
        DockWidgetArea_Mask(15),
        NoDockWidgetArea(0);

        DockWidgetArea(int value) { this.value = value; }
        public int value() { return value; }

        public static DockWidgetAreas createQFlags(DockWidgetArea ... values) {
            return new DockWidgetAreas(values);
        }
        public static DockWidgetArea resolve(int value) {
            return (DockWidgetArea) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return LeftDockWidgetArea;
            case 2: return RightDockWidgetArea;
            case 4: return TopDockWidgetArea;
            case 8: return BottomDockWidgetArea;
            case 15: return DockWidgetArea_Mask;
            case 0: return NoDockWidgetArea;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class DockWidgetAreas extends com.trolltech.qt.QFlags<DockWidgetArea> {
        private static final long serialVersionUID = 1L;
        public DockWidgetAreas(DockWidgetArea ... args) { super(args); }
        public DockWidgetAreas(int value) { setValue(value); }
    }

    public enum TimeSpec implements com.trolltech.qt.QtEnumerator {
        LocalTime(0),
        UTC(1);

        TimeSpec(int value) { this.value = value; }
        public int value() { return value; }

        public static TimeSpec resolve(int value) {
            return (TimeSpec) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LocalTime;
            case 1: return UTC;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ImageConversionFlag implements com.trolltech.qt.QtEnumerator {
        ColorMode_Mask(3),
        AutoColor(0),
        MonoOnly(2),
        AlphaDither_Mask(12),
        OrderedAlphaDither(4),
        DiffuseAlphaDither(8),
        Dither_Mask(48),
        OrderedDither(16),
        ThresholdDither(32),
        DitherMode_Mask(192),
        PreferDither(64),
        AvoidDither(128);

        ImageConversionFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static ImageConversionFlags createQFlags(ImageConversionFlag ... values) {
            return new ImageConversionFlags(values);
        }
        public static ImageConversionFlag resolve(int value) {
            return (ImageConversionFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 3: return ColorMode_Mask;
            case 0: return AutoColor;
            case 2: return MonoOnly;
            case 12: return AlphaDither_Mask;
            case 4: return OrderedAlphaDither;
            case 8: return DiffuseAlphaDither;
            case 48: return Dither_Mask;
            case 16: return OrderedDither;
            case 32: return ThresholdDither;
            case 192: return DitherMode_Mask;
            case 64: return PreferDither;
            case 128: return AvoidDither;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ImageConversionFlags extends com.trolltech.qt.QFlags<ImageConversionFlag> {
        private static final long serialVersionUID = 1L;
        public ImageConversionFlags(ImageConversionFlag ... args) { super(args); }
        public ImageConversionFlags(int value) { setValue(value); }
    }

    public enum WindowModality implements com.trolltech.qt.QtEnumerator {
        NonModal(0),
        WindowModal(1),
        ApplicationModal(2);

        WindowModality(int value) { this.value = value; }
        public int value() { return value; }

        public static WindowModality resolve(int value) {
            return (WindowModality) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NonModal;
            case 1: return WindowModal;
            case 2: return ApplicationModal;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Modifier implements com.trolltech.qt.QtEnumerator {
        META(268435456),
        SHIFT(33554432),
        CTRL(67108864),
        ALT(134217728),
        MODIFIER_MASK(-33554432),
        UNICODE_ACCEL(0);

        Modifier(int value) { this.value = value; }
        public int value() { return value; }

        public static Modifier resolve(int value) {
            return (Modifier) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 268435456: return META;
            case 33554432: return SHIFT;
            case 67108864: return CTRL;
            case 134217728: return ALT;
            case -33554432: return MODIFIER_MASK;
            case 0: return UNICODE_ACCEL;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AlignmentFlag implements com.trolltech.qt.QtEnumerator {
        AlignLeft(1),
        AlignRight(2),
        AlignHCenter(4),
        AlignJustify(8),
        AlignAbsolute(16),
        AlignHorizontal_Mask(31),
        AlignTop(32),
        AlignBottom(64),
        AlignVCenter(128),
        AlignVertical_Mask(224),
        AlignCenter(132);

        AlignmentFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static Alignment createQFlags(AlignmentFlag ... values) {
            return new Alignment(values);
        }
        public static AlignmentFlag resolve(int value) {
            return (AlignmentFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return AlignLeft;
            case 2: return AlignRight;
            case 4: return AlignHCenter;
            case 8: return AlignJustify;
            case 16: return AlignAbsolute;
            case 31: return AlignHorizontal_Mask;
            case 32: return AlignTop;
            case 64: return AlignBottom;
            case 128: return AlignVCenter;
            case 224: return AlignVertical_Mask;
            case 132: return AlignCenter;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Alignment extends com.trolltech.qt.QFlags<AlignmentFlag> {
        private static final long serialVersionUID = 1L;
        public Alignment(AlignmentFlag ... args) { super(args); }
        public Alignment(int value) { setValue(value); }
    }

    public enum WidgetAttribute implements com.trolltech.qt.QtEnumerator {
        WA_Disabled(0),
        WA_UnderMouse(1),
        WA_MouseTracking(2),
        WA_ContentsPropagated(3),
        WA_OpaquePaintEvent(4),
        WA_StaticContents(5),
        WA_LaidOut(7),
        WA_PaintOnScreen(8),
        WA_NoSystemBackground(9),
        WA_UpdatesDisabled(10),
        WA_Mapped(11),
        WA_MacNoClickThrough(12),
        WA_PaintOutsidePaintEvent(13),
        WA_InputMethodEnabled(14),
        WA_WState_Visible(15),
        WA_WState_Hidden(16),
        WA_ForceDisabled(32),
        WA_KeyCompression(33),
        WA_PendingMoveEvent(34),
        WA_PendingResizeEvent(35),
        WA_SetPalette(36),
        WA_SetFont(37),
        WA_SetCursor(38),
        WA_NoChildEventsFromChildren(39),
        WA_WindowModified(41),
        WA_Resized(42),
        WA_Moved(43),
        WA_PendingUpdate(44),
        WA_InvalidSize(45),
        WA_MacBrushedMetal(46),
        WA_CustomWhatsThis(47),
        WA_LayoutOnEntireRect(48),
        WA_OutsideWSRange(49),
        WA_GrabbedShortcut(50),
        WA_TransparentForMouseEvents(51),
        WA_PaintUnclipped(52),
        WA_SetWindowIcon(53),
        WA_NoMouseReplay(54),
        WA_DeleteOnClose(55),
        WA_RightToLeft(56),
        WA_SetLayoutDirection(57),
        WA_NoChildEventsForParent(58),
        WA_ForceUpdatesDisabled(59),
        WA_WState_Created(60),
        WA_WState_CompressKeys(61),
        WA_WState_InPaintEvent(62),
        WA_WState_Reparented(63),
        WA_WState_ConfigPending(64),
        WA_WState_Polished(66),
        WA_WState_DND(67),
        WA_WState_OwnSizePolicy(68),
        WA_WState_ExplicitShowHide(69),
        WA_ShowModal(70),
        WA_MouseNoMask(71),
        WA_GroupLeader(72),
        WA_NoMousePropagation(73),
        WA_Hover(74),
        WA_InputMethodTransparent(75),
        WA_QuitOnClose(76),
        WA_KeyboardFocusChange(77),
        WA_AcceptDrops(78),
        WA_DropSiteRegistered(79),
        WA_WindowPropagation(80),
        WA_NoX11EventCompression(81),
        WA_TintedBackground(82),
        WA_X11OpenGLOverlay(83),
        WA_AlwaysShowToolTips(84),
        WA_MacOpaqueSizeGrip(85),
        WA_SetStyle(86),
        WA_SetLocale(87),
        WA_MacShowFocusRect(88),
        WA_MacNormalSize(89),
        WA_MacSmallSize(90),
        WA_MacMiniSize(91),
        WA_LayoutUsesWidgetRect(92),
        WA_StyledBackground(93),
        WA_MSWindowsUseDirect3D(94),
        WA_CanHostQMdiSubWindowTitleBar(95),
        WA_MacAlwaysShowToolWindow(96),
        WA_StyleSheet(97),
        WA_AttributeCount(98);

        WidgetAttribute(int value) { this.value = value; }
        public int value() { return value; }

        public static WidgetAttribute resolve(int value) {
            return (WidgetAttribute) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WA_Disabled;
            case 1: return WA_UnderMouse;
            case 2: return WA_MouseTracking;
            case 3: return WA_ContentsPropagated;
            case 4: return WA_OpaquePaintEvent;
            case 5: return WA_StaticContents;
            case 7: return WA_LaidOut;
            case 8: return WA_PaintOnScreen;
            case 9: return WA_NoSystemBackground;
            case 10: return WA_UpdatesDisabled;
            case 11: return WA_Mapped;
            case 12: return WA_MacNoClickThrough;
            case 13: return WA_PaintOutsidePaintEvent;
            case 14: return WA_InputMethodEnabled;
            case 15: return WA_WState_Visible;
            case 16: return WA_WState_Hidden;
            case 32: return WA_ForceDisabled;
            case 33: return WA_KeyCompression;
            case 34: return WA_PendingMoveEvent;
            case 35: return WA_PendingResizeEvent;
            case 36: return WA_SetPalette;
            case 37: return WA_SetFont;
            case 38: return WA_SetCursor;
            case 39: return WA_NoChildEventsFromChildren;
            case 41: return WA_WindowModified;
            case 42: return WA_Resized;
            case 43: return WA_Moved;
            case 44: return WA_PendingUpdate;
            case 45: return WA_InvalidSize;
            case 46: return WA_MacBrushedMetal;
            case 47: return WA_CustomWhatsThis;
            case 48: return WA_LayoutOnEntireRect;
            case 49: return WA_OutsideWSRange;
            case 50: return WA_GrabbedShortcut;
            case 51: return WA_TransparentForMouseEvents;
            case 52: return WA_PaintUnclipped;
            case 53: return WA_SetWindowIcon;
            case 54: return WA_NoMouseReplay;
            case 55: return WA_DeleteOnClose;
            case 56: return WA_RightToLeft;
            case 57: return WA_SetLayoutDirection;
            case 58: return WA_NoChildEventsForParent;
            case 59: return WA_ForceUpdatesDisabled;
            case 60: return WA_WState_Created;
            case 61: return WA_WState_CompressKeys;
            case 62: return WA_WState_InPaintEvent;
            case 63: return WA_WState_Reparented;
            case 64: return WA_WState_ConfigPending;
            case 66: return WA_WState_Polished;
            case 67: return WA_WState_DND;
            case 68: return WA_WState_OwnSizePolicy;
            case 69: return WA_WState_ExplicitShowHide;
            case 70: return WA_ShowModal;
            case 71: return WA_MouseNoMask;
            case 72: return WA_GroupLeader;
            case 73: return WA_NoMousePropagation;
            case 74: return WA_Hover;
            case 75: return WA_InputMethodTransparent;
            case 76: return WA_QuitOnClose;
            case 77: return WA_KeyboardFocusChange;
            case 78: return WA_AcceptDrops;
            case 79: return WA_DropSiteRegistered;
            case 80: return WA_WindowPropagation;
            case 81: return WA_NoX11EventCompression;
            case 82: return WA_TintedBackground;
            case 83: return WA_X11OpenGLOverlay;
            case 84: return WA_AlwaysShowToolTips;
            case 85: return WA_MacOpaqueSizeGrip;
            case 86: return WA_SetStyle;
            case 87: return WA_SetLocale;
            case 88: return WA_MacShowFocusRect;
            case 89: return WA_MacNormalSize;
            case 90: return WA_MacSmallSize;
            case 91: return WA_MacMiniSize;
            case 92: return WA_LayoutUsesWidgetRect;
            case 93: return WA_StyledBackground;
            case 94: return WA_MSWindowsUseDirect3D;
            case 95: return WA_CanHostQMdiSubWindowTitleBar;
            case 96: return WA_MacAlwaysShowToolWindow;
            case 97: return WA_StyleSheet;
            case 98: return WA_AttributeCount;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TextFormat implements com.trolltech.qt.QtEnumerator {
        PlainText(0),
        RichText(1),
        AutoText(2),
        LogText(3);

        TextFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static TextFormat resolve(int value) {
            return (TextFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return PlainText;
            case 1: return RichText;
            case 2: return AutoText;
            case 3: return LogText;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MouseButton implements com.trolltech.qt.QtEnumerator {
        NoButton(0),
        LeftButton(1),
        RightButton(2),
        MidButton(4),
        XButton1(8),
        XButton2(16),
        MouseButtonMask(255);

        MouseButton(int value) { this.value = value; }
        public int value() { return value; }

        public static MouseButtons createQFlags(MouseButton ... values) {
            return new MouseButtons(values);
        }
        public static MouseButton resolve(int value) {
            return (MouseButton) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoButton;
            case 1: return LeftButton;
            case 2: return RightButton;
            case 4: return MidButton;
            case 8: return XButton1;
            case 16: return XButton2;
            case 255: return MouseButtonMask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class MouseButtons extends com.trolltech.qt.QFlags<MouseButton> {
        private static final long serialVersionUID = 1L;
        public MouseButtons(MouseButton ... args) { super(args); }
        public MouseButtons(int value) { setValue(value); }
    }

    public enum WindowState implements com.trolltech.qt.QtEnumerator {
        WindowNoState(0),
        WindowMinimized(1),
        WindowMaximized(2),
        WindowFullScreen(4),
        WindowActive(8);

        WindowState(int value) { this.value = value; }
        public int value() { return value; }

        public static WindowStates createQFlags(WindowState ... values) {
            return new WindowStates(values);
        }
        public static WindowState resolve(int value) {
            return (WindowState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WindowNoState;
            case 1: return WindowMinimized;
            case 2: return WindowMaximized;
            case 4: return WindowFullScreen;
            case 8: return WindowActive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class WindowStates extends com.trolltech.qt.QFlags<WindowState> {
        private static final long serialVersionUID = 1L;
        public WindowStates(WindowState ... args) { super(args); }
        public WindowStates(int value) { setValue(value); }
    }

    public enum PenStyle implements com.trolltech.qt.QtEnumerator {
        NoPen(0),
        SolidLine(1),
        DashLine(2),
        DotLine(3),
        DashDotLine(4),
        DashDotDotLine(5),
        CustomDashLine(6),
        MPenStyle(15);

        PenStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static PenStyle resolve(int value) {
            return (PenStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoPen;
            case 1: return SolidLine;
            case 2: return DashLine;
            case 3: return DotLine;
            case 4: return DashDotLine;
            case 5: return DashDotDotLine;
            case 6: return CustomDashLine;
            case 15: return MPenStyle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ItemFlag implements com.trolltech.qt.QtEnumerator {
        ItemIsSelectable(1),
        ItemIsEditable(2),
        ItemIsDragEnabled(4),
        ItemIsDropEnabled(8),
        ItemIsUserCheckable(16),
        ItemIsEnabled(32),
        ItemIsTristate(64);

        ItemFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static ItemFlags createQFlags(ItemFlag ... values) {
            return new ItemFlags(values);
        }
        public static ItemFlag resolve(int value) {
            return (ItemFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return ItemIsSelectable;
            case 2: return ItemIsEditable;
            case 4: return ItemIsDragEnabled;
            case 8: return ItemIsDropEnabled;
            case 16: return ItemIsUserCheckable;
            case 32: return ItemIsEnabled;
            case 64: return ItemIsTristate;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ItemFlags extends com.trolltech.qt.QFlags<ItemFlag> {
        private static final long serialVersionUID = 1L;
        public ItemFlags(ItemFlag ... args) { super(args); }
        public ItemFlags(int value) { setValue(value); }
    }

    public enum HitTestAccuracy implements com.trolltech.qt.QtEnumerator {
        ExactHit(0),
        FuzzyHit(1);

        HitTestAccuracy(int value) { this.value = value; }
        public int value() { return value; }

        public static HitTestAccuracy resolve(int value) {
            return (HitTestAccuracy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ExactHit;
            case 1: return FuzzyHit;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
}
