package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QAbstractSlider extends com.trolltech.qt.gui.QWidget
{
    public enum SliderAction implements com.trolltech.qt.QtEnumerator {
        SliderNoAction(0),
        SliderSingleStepAdd(1),
        SliderSingleStepSub(2),
        SliderPageStepAdd(3),
        SliderPageStepSub(4),
        SliderToMinimum(5),
        SliderToMaximum(6),
        SliderMove(7);

        SliderAction(int value) { this.value = value; }
        public int value() { return value; }

        public static SliderAction resolve(int value) {
            return (SliderAction) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SliderNoAction;
            case 1: return SliderSingleStepAdd;
            case 2: return SliderSingleStepSub;
            case 3: return SliderPageStepAdd;
            case 4: return SliderPageStepSub;
            case 5: return SliderToMinimum;
            case 6: return SliderToMaximum;
            case 7: return SliderMove;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SliderChange implements com.trolltech.qt.QtEnumerator {
        SliderRangeChange(0),
        SliderOrientationChange(1),
        SliderStepsChange(2),
        SliderValueChange(3);

        SliderChange(int value) { this.value = value; }
        public int value() { return value; }

        public static SliderChange resolve(int value) {
            return (SliderChange) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SliderRangeChange;
            case 1: return SliderOrientationChange;
            case 2: return SliderStepsChange;
            case 3: return SliderValueChange;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> actionTriggered = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void actionTriggered(int action) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_actionTriggered_int(nativeId(), action);
    }
    private native static void __qt_actionTriggered_int(long __this__nativeId, int action);

    public final Signal2<java.lang.Integer, java.lang.Integer> rangeChanged = new Signal2<java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void rangeChanged(int min, int max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rangeChanged_int_int(nativeId(), min, max);
    }
    private native static void __qt_rangeChanged_int_int(long __this__nativeId, int min, int max);

    public final Signal1<java.lang.Integer> sliderMoved = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void sliderMoved(int position) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sliderMoved_int(nativeId(), position);
    }
    private native static void __qt_sliderMoved_int(long __this__nativeId, int position);

    public final Signal0 sliderPressed = new Signal0();

    @SuppressWarnings("unused")
    private final void sliderPressed() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sliderPressed(nativeId());
    }
    private native static void __qt_sliderPressed(long __this__nativeId);

    public final Signal0 sliderReleased = new Signal0();

    @SuppressWarnings("unused")
    private final void sliderReleased() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sliderReleased(nativeId());
    }
    private native static void __qt_sliderReleased(long __this__nativeId);

    public final Signal1<java.lang.Integer> valueChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void valueChanged(int value) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_valueChanged_int(nativeId(), value);
    }
    private native static void __qt_valueChanged_int(long __this__nativeId, int value);


    public QAbstractSlider() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QAbstractSlider(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QAbstractSlider_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QAbstractSlider_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="tracking")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final boolean hasTracking() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasTracking(nativeId());
    }
    private native static boolean __qt_hasTracking(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="invertedAppearance")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final boolean invertedAppearance() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_invertedAppearance(nativeId());
    }
    private native static boolean __qt_invertedAppearance(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="invertedControls")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final boolean invertedControls() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_invertedControls(nativeId());
    }
    private native static boolean __qt_invertedControls(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sliderDown")
    @com.trolltech.qt.QtPropertyOrder(10)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final boolean isSliderDown() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSliderDown(nativeId());
    }
    private native static boolean __qt_isSliderDown(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximum")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int maximum() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximum(nativeId());
    }
    private native static int __qt_maximum(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimum")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final int minimum() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimum(nativeId());
    }
    private native static int __qt_minimum(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="orientation")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientation orientation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="pageStep")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int pageStep() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pageStep(nativeId());
    }
    private native static int __qt_pageStep(long __this__nativeId);

    @QtBlockedSlot protected final com.trolltech.qt.gui.QAbstractSlider.SliderAction repeatAction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QAbstractSlider.SliderAction.resolve(__qt_repeatAction(nativeId()));
    }
    private native static int __qt_repeatAction(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="invertedAppearance")
    @QtBlockedSlot public final void setInvertedAppearance(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInvertedAppearance_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setInvertedAppearance_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="invertedControls")
    @QtBlockedSlot public final void setInvertedControls(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInvertedControls_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setInvertedControls_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="maximum")
    @QtBlockedSlot public final void setMaximum(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximum_int(nativeId(), arg__1);
    }
    private native static void __qt_setMaximum_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="minimum")
    @QtBlockedSlot public final void setMinimum(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimum_int(nativeId(), arg__1);
    }
    private native static void __qt_setMinimum_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="orientation")
    public final void setOrientation(com.trolltech.qt.core.Qt.Orientation arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOrientation_Orientation(nativeId(), arg__1.value());
    }
    private native static void __qt_setOrientation_Orientation(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="pageStep")
    @QtBlockedSlot public final void setPageStep(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPageStep_int(nativeId(), arg__1);
    }
    private native static void __qt_setPageStep_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setRange(int min, int max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRange_int_int(nativeId(), min, max);
    }
    private native static void __qt_setRange_int_int(long __this__nativeId, int min, int max);


    @QtBlockedSlot protected final void setRepeatAction(com.trolltech.qt.gui.QAbstractSlider.SliderAction action, int thresholdTime) {
        setRepeatAction(action, thresholdTime, (int)50);
    }

    @QtBlockedSlot protected final void setRepeatAction(com.trolltech.qt.gui.QAbstractSlider.SliderAction action) {
        setRepeatAction(action, (int)500, (int)50);
    }
    @QtBlockedSlot protected final void setRepeatAction(com.trolltech.qt.gui.QAbstractSlider.SliderAction action, int thresholdTime, int repeatTime) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRepeatAction_SliderAction_int_int(nativeId(), action.value(), thresholdTime, repeatTime);
    }
    private native static void __qt_setRepeatAction_SliderAction_int_int(long __this__nativeId, int action, int thresholdTime, int repeatTime);

    @com.trolltech.qt.QtPropertyWriter(name="singleStep")
    @QtBlockedSlot public final void setSingleStep(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSingleStep_int(nativeId(), arg__1);
    }
    private native static void __qt_setSingleStep_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="sliderDown")
    @QtBlockedSlot public final void setSliderDown(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSliderDown_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setSliderDown_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="sliderPosition")
    @QtBlockedSlot public final void setSliderPosition(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSliderPosition_int(nativeId(), arg__1);
    }
    private native static void __qt_setSliderPosition_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="tracking")
    @QtBlockedSlot public final void setTracking(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTracking_boolean(nativeId(), enable);
    }
    private native static void __qt_setTracking_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="value")
    public final void setValue(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setValue_int(nativeId(), arg__1);
    }
    private native static void __qt_setValue_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyReader(name="singleStep")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int singleStep() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_singleStep(nativeId());
    }
    private native static int __qt_singleStep(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sliderPosition")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int sliderPosition() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sliderPosition(nativeId());
    }
    private native static int __qt_sliderPosition(long __this__nativeId);

    @QtBlockedSlot public final void triggerAction(com.trolltech.qt.gui.QAbstractSlider.SliderAction action) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_triggerAction_SliderAction(nativeId(), action.value());
    }
    private native static void __qt_triggerAction_SliderAction(long __this__nativeId, int action);

    @com.trolltech.qt.QtPropertyReader(name="value")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int value() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value(nativeId());
    }
    private native static int __qt_value(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent ev) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), ev == null ? 0 : ev.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long ev);

    @QtBlockedSlot protected void sliderChange(com.trolltech.qt.gui.QAbstractSlider.SliderChange change) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sliderChange_SliderChange(nativeId(), change.value());
    }
    private native static void __qt_sliderChange_SliderChange(long __this__nativeId, int change);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long e);


    public static native QAbstractSlider fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QAbstractSlider(QPrivateConstructor p) { super(p); } 

}
