package com.trolltech.qt.gui;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QApplication extends com.trolltech.qt.core.QCoreApplication
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Type implements com.trolltech.qt.QtEnumerator {
        Tty(0),
        GuiClient(1),
        GuiServer(2);

        Type(int value) { this.value = value; }
        public int value() { return value; }

        public static Type resolve(int value) {
            return (Type) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Tty;
            case 1: return GuiClient;
            case 2: return GuiServer;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ColorSpec implements com.trolltech.qt.QtEnumerator {
        NormalColor(0),
        CustomColor(1),
        ManyColor(2);

        ColorSpec(int value) { this.value = value; }
        public int value() { return value; }

        public static ColorSpec resolve(int value) {
            return (ColorSpec) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NormalColor;
            case 1: return CustomColor;
            case 2: return ManyColor;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QSessionManager> commitDataRequest = new Signal1<com.trolltech.qt.gui.QSessionManager>();

    @SuppressWarnings("unused")
    private final void commitDataRequest(com.trolltech.qt.gui.QSessionManager sessionManager) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_commitDataRequest_QSessionManager(nativeId(), sessionManager == null ? 0 : sessionManager.nativeId());
    }
    private native static void __qt_commitDataRequest_QSessionManager(long __this__nativeId, long sessionManager);

    public final Signal2<com.trolltech.qt.gui.QWidget, com.trolltech.qt.gui.QWidget> focusChanged = new Signal2<com.trolltech.qt.gui.QWidget, com.trolltech.qt.gui.QWidget>();

    @SuppressWarnings("unused")
    private final void focusChanged(com.trolltech.qt.gui.QWidget old, com.trolltech.qt.gui.QWidget now) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusChanged_QWidget_QWidget(nativeId(), old == null ? 0 : old.nativeId(), now == null ? 0 : now.nativeId());
    }
    private native static void __qt_focusChanged_QWidget_QWidget(long __this__nativeId, long old, long now);

    public final Signal0 lastWindowClosed = new Signal0();

    @SuppressWarnings("unused")
    private final void lastWindowClosed() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_lastWindowClosed(nativeId());
    }
    private native static void __qt_lastWindowClosed(long __this__nativeId);

    public final Signal1<com.trolltech.qt.gui.QSessionManager> saveStateRequest = new Signal1<com.trolltech.qt.gui.QSessionManager>();

    @SuppressWarnings("unused")
    private final void saveStateRequest(com.trolltech.qt.gui.QSessionManager sessionManager) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_saveStateRequest_QSessionManager(nativeId(), sessionManager == null ? 0 : sessionManager.nativeId());
    }
    private native static void __qt_saveStateRequest_QSessionManager(long __this__nativeId, long sessionManager);


    @SuppressWarnings("unused")
    private QApplication(com.trolltech.qt.QNativePointer argc, com.trolltech.qt.QNativePointer argv) {
        this(argc, argv, (int)0x040302);
    }
    @SuppressWarnings("unused")
    private QApplication(com.trolltech.qt.QNativePointer argc, com.trolltech.qt.QNativePointer argv, int arg__3) {
        super((QPrivateConstructor)null);
        __qt_QApplication_nativepointer_nativepointer_int(argc, argv, arg__3);
    }
    private native void __qt_QApplication_nativepointer_nativepointer_int(com.trolltech.qt.QNativePointer argc, com.trolltech.qt.QNativePointer argv, int arg__3);


    @QtBlockedSlot public final com.trolltech.qt.gui.QInputContext inputContext() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputContext(nativeId());
    }
    private native static com.trolltech.qt.gui.QInputContext __qt_inputContext(long __this__nativeId);

    @QtBlockedSlot public final boolean isSessionRestored() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSessionRestored(nativeId());
    }
    private native static boolean __qt_isSessionRestored(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String sessionId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sessionId(nativeId());
    }
    private native static java.lang.String __qt_sessionId(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String sessionKey() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sessionKey(nativeId());
    }
    private native static java.lang.String __qt_sessionKey(long __this__nativeId);

    @QtBlockedSlot public final void setInputContext(com.trolltech.qt.gui.QInputContext arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (arg__1 != null) {
            arg__1.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInputContext_QInputContext(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setInputContext_QInputContext(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="styleSheet")
    public final void setStyleSheet(java.lang.String sheet) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStyleSheet_String(nativeId(), sheet);
    }
    private native static void __qt_setStyleSheet_String(long __this__nativeId, java.lang.String sheet);

    @com.trolltech.qt.QtPropertyReader(name="styleSheet")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final java.lang.String styleSheet() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_styleSheet(nativeId());
    }
    private native static java.lang.String __qt_styleSheet(long __this__nativeId);

    @QtBlockedSlot public void commitData(com.trolltech.qt.gui.QSessionManager sm) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_commitData_QSessionManager(nativeId(), sm == null ? 0 : sm.nativeId());
    }
    private native static void __qt_commitData_QSessionManager(long __this__nativeId, long sm);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean notify(com.trolltech.qt.core.QObject arg__1, com.trolltech.qt.core.QEvent arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_notify_QObject_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static boolean __qt_notify_QObject_QEvent(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot public void saveState(com.trolltech.qt.gui.QSessionManager sm) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_saveState_QSessionManager(nativeId(), sm == null ? 0 : sm.nativeId());
    }
    private native static void __qt_saveState_QSessionManager(long __this__nativeId, long sm);

    public native static void aboutQt();

    public native static com.trolltech.qt.gui.QWidget activeModalWidget();

    public native static com.trolltech.qt.gui.QWidget activePopupWidget();

    public native static com.trolltech.qt.gui.QWidget activeWindow();


    public static void alert(com.trolltech.qt.gui.QWidget widget) {
        alert(widget, (int)0);
    }
    public static void alert(com.trolltech.qt.gui.QWidget widget, int duration) {
        __qt_alert_QWidget_int(widget == null ? 0 : widget.nativeId(), duration);
    }
    private native static void __qt_alert_QWidget_int(long widget, int duration);

    public native static java.util.List<com.trolltech.qt.gui.QWidget> allWidgets();

    public native static void beep();

    public static void changeOverrideCursor(com.trolltech.qt.gui.QCursor arg__1) {
        __qt_changeOverrideCursor_QCursor(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QCursor()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_changeOverrideCursor_QCursor(long arg__1);

    public native static com.trolltech.qt.gui.QClipboard clipboard();

    public native static void closeAllWindows();

    public native static int colorSpec();

    @com.trolltech.qt.QtPropertyReader(name="cursorFlashTime")
    @com.trolltech.qt.QtPropertyOrder(2)
    public native static int cursorFlashTime();

    public native static com.trolltech.qt.gui.QDesktopWidget desktop();

    public native static boolean desktopSettingsAware();

    @com.trolltech.qt.QtPropertyReader(name="doubleClickInterval")
    @com.trolltech.qt.QtPropertyOrder(3)
    public native static int doubleClickInterval();

    public native static int exec();

    public native static com.trolltech.qt.gui.QWidget focusWidget();

    public static com.trolltech.qt.gui.QFont font(com.trolltech.qt.gui.QWidget arg__1) {
        return __qt_font_QWidget(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font_QWidget(long arg__1);

    public native static com.trolltech.qt.gui.QFont font();

    public native static com.trolltech.qt.gui.QFontMetrics fontMetrics();

    @com.trolltech.qt.QtPropertyReader(name="globalStrut")
    @com.trolltech.qt.QtPropertyOrder(6)
    public native static com.trolltech.qt.core.QSize globalStrut();

    public static boolean isEffectEnabled(com.trolltech.qt.core.Qt.UIEffect arg__1) {
        return __qt_isEffectEnabled_UIEffect(arg__1.value());
    }
    private native static boolean __qt_isEffectEnabled_UIEffect(int arg__1);

    public native static boolean isLeftToRight();

    public native static boolean isRightToLeft();

    public static com.trolltech.qt.core.Qt.LayoutDirection keyboardInputDirection() {
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_keyboardInputDirection());
    }
    private native static int __qt_keyboardInputDirection();

    @com.trolltech.qt.QtPropertyReader(name="keyboardInputInterval")
    @com.trolltech.qt.QtPropertyOrder(4)
    public native static int keyboardInputInterval();

    public native static com.trolltech.qt.core.QLocale keyboardInputLocale();

    public static com.trolltech.qt.core.Qt.KeyboardModifiers keyboardModifiers() {
        return new com.trolltech.qt.core.Qt.KeyboardModifiers(__qt_keyboardModifiers());
    }
    private native static int __qt_keyboardModifiers();

    @com.trolltech.qt.QtPropertyReader(name="layoutDirection")
    @com.trolltech.qt.QtPropertyOrder(0)
    public static com.trolltech.qt.core.Qt.LayoutDirection layoutDirection() {
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_layoutDirection());
    }
    private native static int __qt_layoutDirection();

    public static com.trolltech.qt.core.Qt.MouseButtons mouseButtons() {
        return new com.trolltech.qt.core.Qt.MouseButtons(__qt_mouseButtons());
    }
    private native static int __qt_mouseButtons();

    @SuppressWarnings("unused")
    private native static com.trolltech.qt.QNativePointer overrideCursor_private();

    public native static com.trolltech.qt.gui.QPalette palette();

    public static com.trolltech.qt.gui.QPalette palette(com.trolltech.qt.gui.QWidget arg__1) {
        return __qt_palette_QWidget(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static com.trolltech.qt.gui.QPalette __qt_palette_QWidget(long arg__1);

    @com.trolltech.qt.QtPropertyReader(name="quitOnLastWindowClosed")
    @com.trolltech.qt.QtPropertyOrder(9)
    public native static boolean quitOnLastWindowClosed();

    public native static void restoreOverrideCursor();

    public static void setActiveWindow(com.trolltech.qt.gui.QWidget act) {
        __qt_setActiveWindow_QWidget(act == null ? 0 : act.nativeId());
    }
    private native static void __qt_setActiveWindow_QWidget(long act);

    public native static void setColorSpec(int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="cursorFlashTime")
    public native static void setCursorFlashTime(int arg__1);

    public native static void setDesktopSettingsAware(boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="doubleClickInterval")
    public native static void setDoubleClickInterval(int arg__1);


    public static void setEffectEnabled(com.trolltech.qt.core.Qt.UIEffect arg__1) {
        setEffectEnabled(arg__1, (boolean)true);
    }
    public static void setEffectEnabled(com.trolltech.qt.core.Qt.UIEffect arg__1, boolean enable) {
        __qt_setEffectEnabled_UIEffect_boolean(arg__1.value(), enable);
    }
    private native static void __qt_setEffectEnabled_UIEffect_boolean(int arg__1, boolean enable);

    @SuppressWarnings("unused")
    private static void setFont(com.trolltech.qt.gui.QFont arg__1, com.trolltech.qt.QNativePointer className) {
        __qt_setFont_QFont_nativepointer(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId(), className);
    }
    private native static void __qt_setFont_QFont_nativepointer(long arg__1, com.trolltech.qt.QNativePointer className);

    @com.trolltech.qt.QtPropertyWriter(name="globalStrut")
    public static void setGlobalStrut(com.trolltech.qt.core.QSize arg__1) {
        __qt_setGlobalStrut_QSize(arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setGlobalStrut_QSize(long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="keyboardInputInterval")
    public native static void setKeyboardInputInterval(int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="layoutDirection")
    public static void setLayoutDirection(com.trolltech.qt.core.Qt.LayoutDirection direction) {
        __qt_setLayoutDirection_LayoutDirection(direction.value());
    }
    private native static void __qt_setLayoutDirection_LayoutDirection(int direction);

    public static void setOverrideCursor(com.trolltech.qt.gui.QCursor arg__1) {
        __qt_setOverrideCursor_QCursor(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QCursor()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setOverrideCursor_QCursor(long arg__1);

    @SuppressWarnings("unused")
    private static void setPalette(com.trolltech.qt.gui.QPalette arg__1, com.trolltech.qt.QNativePointer className) {
        __qt_setPalette_QPalette_nativepointer(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QPalette()).nativeId() : arg__1.nativeId(), className);
    }
    private native static void __qt_setPalette_QPalette_nativepointer(long arg__1, com.trolltech.qt.QNativePointer className);

    @com.trolltech.qt.QtPropertyWriter(name="quitOnLastWindowClosed")
    public native static void setQuitOnLastWindowClosed(boolean quit);

    @com.trolltech.qt.QtPropertyWriter(name="startDragDistance")
    public native static void setStartDragDistance(int l);

    @com.trolltech.qt.QtPropertyWriter(name="startDragTime")
    public native static void setStartDragTime(int ms);

    public native static com.trolltech.qt.gui.QStyle setStyle(java.lang.String arg__1);

    public static void setStyle(com.trolltech.qt.gui.QStyle arg__1) {
        __qt_setStyle_QStyle(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setStyle_QStyle(long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="wheelScrollLines")
    public native static void setWheelScrollLines(int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="windowIcon")
    public static void setWindowIcon(com.trolltech.qt.gui.QIcon icon) {
        __qt_setWindowIcon_QIcon(icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setWindowIcon_QIcon(long icon);

    @com.trolltech.qt.QtPropertyReader(name="startDragDistance")
    @com.trolltech.qt.QtPropertyOrder(8)
    public native static int startDragDistance();

    @com.trolltech.qt.QtPropertyReader(name="startDragTime")
    @com.trolltech.qt.QtPropertyOrder(7)
    public native static int startDragTime();

    public native static com.trolltech.qt.gui.QStyle style();

    public native static void syncX();

    public native static com.trolltech.qt.gui.QWidget topLevelAt(int x, int y);

    public static com.trolltech.qt.gui.QWidget topLevelAt(com.trolltech.qt.core.QPoint p) {
        return __qt_topLevelAt_QPoint(p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_topLevelAt_QPoint(long p);

    public native static java.util.List<com.trolltech.qt.gui.QWidget> topLevelWidgets();

    public static com.trolltech.qt.gui.QApplication.Type type() {
        return com.trolltech.qt.gui.QApplication.Type.resolve(__qt_type());
    }
    private native static int __qt_type();

    @com.trolltech.qt.QtPropertyReader(name="wheelScrollLines")
    @com.trolltech.qt.QtPropertyOrder(5)
    public native static int wheelScrollLines();

    public static com.trolltech.qt.gui.QWidget widgetAt(com.trolltech.qt.core.QPoint p) {
        return __qt_widgetAt_QPoint(p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_widgetAt_QPoint(long p);

    public native static com.trolltech.qt.gui.QWidget widgetAt(int x, int y);

    @com.trolltech.qt.QtPropertyReader(name="windowIcon")
    @com.trolltech.qt.QtPropertyOrder(1)
    public native static com.trolltech.qt.gui.QIcon windowIcon();


    public static native QApplication fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QApplication(QPrivateConstructor p) { super(p); } 


    public static void initialize(String args[])
    {
        if (m_instance != null)
            throw new RuntimeException("QApplication can only be initialized once");
            
        m_instance = new QApplication(args);
        m_instance.aboutToQuit.connect(m_instance, "disposeOfMyself()");
        String path = Utilities.unpackPlugins();
        if (path != null)
            addLibraryPath(path);
    }
    
    public static void aboutQtJambi() {
        com.trolltech.qt.QtJambiGuiInternal.aboutQtJambi();
    }

    public static QApplication instance() {
        if (type() != Type.Tty)
            return (QApplication) com.trolltech.qt.core.QCoreApplication.instance();
        return null;
    }
    

    public QApplication(String args[])         
    {
        this(argc(args), argv(args));        
    }
    

        public static void setFont(QFont font) {
            setFont(font, null);
        }
    

        public static void setPalette(QPalette palette) {
            setPalette(palette, null);
        }
    

        public static QCursor overrideCursor() {
            QNativePointer np = overrideCursor_private();
            return np == null ? null : QCursor.fromNativePointer(np);
        }
    
}
