package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QCalendarWidget extends com.trolltech.qt.gui.QWidget
{
    public enum HorizontalHeaderFormat implements com.trolltech.qt.QtEnumerator {
        NoHorizontalHeader(0),
        SingleLetterDayNames(1),
        ShortDayNames(2),
        LongDayNames(3);

        HorizontalHeaderFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static HorizontalHeaderFormat resolve(int value) {
            return (HorizontalHeaderFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoHorizontalHeader;
            case 1: return SingleLetterDayNames;
            case 2: return ShortDayNames;
            case 3: return LongDayNames;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum VerticalHeaderFormat implements com.trolltech.qt.QtEnumerator {
        NoVerticalHeader(0),
        ISOWeekNumbers(1);

        VerticalHeaderFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static VerticalHeaderFormat resolve(int value) {
            return (VerticalHeaderFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoVerticalHeader;
            case 1: return ISOWeekNumbers;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SelectionMode implements com.trolltech.qt.QtEnumerator {
        NoSelection(0),
        SingleSelection(1);

        SelectionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectionMode resolve(int value) {
            return (SelectionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoSelection;
            case 1: return SingleSelection;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.core.QDate> activated = new Signal1<com.trolltech.qt.core.QDate>();

    @SuppressWarnings("unused")
    private final void activated(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activated_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_activated_QDate(long __this__nativeId, long date);

    public final Signal1<com.trolltech.qt.core.QDate> clicked = new Signal1<com.trolltech.qt.core.QDate>();

    @SuppressWarnings("unused")
    private final void clicked(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clicked_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_clicked_QDate(long __this__nativeId, long date);

    public final Signal2<java.lang.Integer, java.lang.Integer> currentPageChanged = new Signal2<java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void currentPageChanged(int year, int month) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentPageChanged_int_int(nativeId(), year, month);
    }
    private native static void __qt_currentPageChanged_int_int(long __this__nativeId, int year, int month);

    public final Signal0 selectionChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void selectionChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged(nativeId());
    }
    private native static void __qt_selectionChanged(long __this__nativeId);


    public QCalendarWidget() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QCalendarWidget(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QCalendarWidget_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QCalendarWidget_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="dateEditAcceptDelay")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final int dateEditAcceptDelay() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dateEditAcceptDelay(nativeId());
    }
    private native static int __qt_dateEditAcceptDelay(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat dateTextFormat(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dateTextFormat_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_dateTextFormat_QDate(long __this__nativeId, long date);

    @QtBlockedSlot public final java.util.SortedMap<com.trolltech.qt.core.QDate, com.trolltech.qt.gui.QTextCharFormat> dateTextFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dateTextFormat(nativeId());
    }
    private native static java.util.SortedMap<com.trolltech.qt.core.QDate, com.trolltech.qt.gui.QTextCharFormat> __qt_dateTextFormat(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="firstDayOfWeek")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.DayOfWeek firstDayOfWeek() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.DayOfWeek.resolve(__qt_firstDayOfWeek(nativeId()));
    }
    private native static int __qt_firstDayOfWeek(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat headerTextFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_headerTextFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_headerTextFormat(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="horizontalHeaderFormat")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCalendarWidget.HorizontalHeaderFormat horizontalHeaderFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QCalendarWidget.HorizontalHeaderFormat.resolve(__qt_horizontalHeaderFormat(nativeId()));
    }
    private native static int __qt_horizontalHeaderFormat(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="dateEditEnabled")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final boolean isDateEditEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDateEditEnabled(nativeId());
    }
    private native static boolean __qt_isDateEditEnabled(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="gridVisible")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final boolean isGridVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isGridVisible(nativeId());
    }
    private native static boolean __qt_isGridVisible(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="navigationBarVisible")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final boolean isNavigationBarVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNavigationBarVisible(nativeId());
    }
    private native static boolean __qt_isNavigationBarVisible(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximumDate")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate maximumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumDate(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_maximumDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumDate")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate minimumDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumDate(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_minimumDate(long __this__nativeId);

    @QtBlockedSlot public final int monthShown() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_monthShown(nativeId());
    }
    private native static int __qt_monthShown(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="selectedDate")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.core.QDate selectedDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedDate(nativeId());
    }
    private native static com.trolltech.qt.core.QDate __qt_selectedDate(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="selectionMode")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCalendarWidget.SelectionMode selectionMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QCalendarWidget.SelectionMode.resolve(__qt_selectionMode(nativeId()));
    }
    private native static int __qt_selectionMode(long __this__nativeId);

    public final void setCurrentPage(int year, int month) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentPage_int_int(nativeId(), year, month);
    }
    private native static void __qt_setCurrentPage_int_int(long __this__nativeId, int year, int month);

    @com.trolltech.qt.QtPropertyWriter(name="dateEditAcceptDelay")
    @QtBlockedSlot public final void setDateEditAcceptDelay(int delay) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateEditAcceptDelay_int(nativeId(), delay);
    }
    private native static void __qt_setDateEditAcceptDelay_int(long __this__nativeId, int delay);

    @com.trolltech.qt.QtPropertyWriter(name="dateEditEnabled")
    @QtBlockedSlot public final void setDateEditEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateEditEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setDateEditEnabled_boolean(long __this__nativeId, boolean enable);

    public final void setDateRange(com.trolltech.qt.core.QDate min, com.trolltech.qt.core.QDate max) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateRange_QDate_QDate(nativeId(), min == null ? (min = new com.trolltech.qt.core.QDate()).nativeId() : min.nativeId(), max == null ? (max = new com.trolltech.qt.core.QDate()).nativeId() : max.nativeId());
    }
    private native static void __qt_setDateRange_QDate_QDate(long __this__nativeId, long min, long max);

    @QtBlockedSlot public final void setDateTextFormat(com.trolltech.qt.core.QDate date, com.trolltech.qt.gui.QTextCharFormat color) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDateTextFormat_QDate_QTextCharFormat(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId(), color == null ? (color = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : color.nativeId());
    }
    private native static void __qt_setDateTextFormat_QDate_QTextCharFormat(long __this__nativeId, long date, long color);

    @com.trolltech.qt.QtPropertyWriter(name="firstDayOfWeek")
    @QtBlockedSlot public final void setFirstDayOfWeek(com.trolltech.qt.core.Qt.DayOfWeek dayOfWeek) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFirstDayOfWeek_DayOfWeek(nativeId(), dayOfWeek.value());
    }
    private native static void __qt_setFirstDayOfWeek_DayOfWeek(long __this__nativeId, int dayOfWeek);

    @com.trolltech.qt.QtPropertyWriter(name="gridVisible")
    public final void setGridVisible(boolean show) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGridVisible_boolean(nativeId(), show);
    }
    private native static void __qt_setGridVisible_boolean(long __this__nativeId, boolean show);

    @QtBlockedSlot public final void setHeaderTextFormat(com.trolltech.qt.gui.QTextCharFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHeaderTextFormat_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setHeaderTextFormat_QTextCharFormat(long __this__nativeId, long format);

    @com.trolltech.qt.QtPropertyWriter(name="horizontalHeaderFormat")
    @QtBlockedSlot public final void setHorizontalHeaderFormat(com.trolltech.qt.gui.QCalendarWidget.HorizontalHeaderFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHorizontalHeaderFormat_HorizontalHeaderFormat(nativeId(), format.value());
    }
    private native static void __qt_setHorizontalHeaderFormat_HorizontalHeaderFormat(long __this__nativeId, int format);

    @com.trolltech.qt.QtPropertyWriter(name="maximumDate")
    @QtBlockedSlot public final void setMaximumDate(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumDate_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_setMaximumDate_QDate(long __this__nativeId, long date);

    @com.trolltech.qt.QtPropertyWriter(name="minimumDate")
    @QtBlockedSlot public final void setMinimumDate(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumDate_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_setMinimumDate_QDate(long __this__nativeId, long date);

    @com.trolltech.qt.QtPropertyWriter(name="navigationBarVisible")
    public final void setNavigationBarVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNavigationBarVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setNavigationBarVisible_boolean(long __this__nativeId, boolean visible);

    @com.trolltech.qt.QtPropertyWriter(name="selectedDate")
    public final void setSelectedDate(com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectedDate_QDate(nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_setSelectedDate_QDate(long __this__nativeId, long date);

    @com.trolltech.qt.QtPropertyWriter(name="selectionMode")
    @QtBlockedSlot public final void setSelectionMode(com.trolltech.qt.gui.QCalendarWidget.SelectionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectionMode_SelectionMode(nativeId(), mode.value());
    }
    private native static void __qt_setSelectionMode_SelectionMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="verticalHeaderFormat")
    @QtBlockedSlot public final void setVerticalHeaderFormat(com.trolltech.qt.gui.QCalendarWidget.VerticalHeaderFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVerticalHeaderFormat_VerticalHeaderFormat(nativeId(), format.value());
    }
    private native static void __qt_setVerticalHeaderFormat_VerticalHeaderFormat(long __this__nativeId, int format);

    @QtBlockedSlot public final void setWeekdayTextFormat(com.trolltech.qt.core.Qt.DayOfWeek dayOfWeek, com.trolltech.qt.gui.QTextCharFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWeekdayTextFormat_DayOfWeek_QTextCharFormat(nativeId(), dayOfWeek.value(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setWeekdayTextFormat_DayOfWeek_QTextCharFormat(long __this__nativeId, int dayOfWeek, long format);

    public final void showNextMonth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showNextMonth(nativeId());
    }
    private native static void __qt_showNextMonth(long __this__nativeId);

    public final void showNextYear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showNextYear(nativeId());
    }
    private native static void __qt_showNextYear(long __this__nativeId);

    public final void showPreviousMonth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showPreviousMonth(nativeId());
    }
    private native static void __qt_showPreviousMonth(long __this__nativeId);

    public final void showPreviousYear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showPreviousYear(nativeId());
    }
    private native static void __qt_showPreviousYear(long __this__nativeId);

    public final void showSelectedDate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showSelectedDate(nativeId());
    }
    private native static void __qt_showSelectedDate(long __this__nativeId);

    public final void showToday() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showToday(nativeId());
    }
    private native static void __qt_showToday(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="verticalHeaderFormat")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCalendarWidget.VerticalHeaderFormat verticalHeaderFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QCalendarWidget.VerticalHeaderFormat.resolve(__qt_verticalHeaderFormat(nativeId()));
    }
    private native static int __qt_verticalHeaderFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat weekdayTextFormat(com.trolltech.qt.core.Qt.DayOfWeek dayOfWeek) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_weekdayTextFormat_DayOfWeek(nativeId(), dayOfWeek.value());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_weekdayTextFormat_DayOfWeek(long __this__nativeId, int dayOfWeek);

    @QtBlockedSlot public final int yearShown() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_yearShown(nativeId());
    }
    private native static int __qt_yearShown(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void paintCell(com.trolltech.qt.gui.QPainter painter, com.trolltech.qt.core.QRect rect, com.trolltech.qt.core.QDate date) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintCell_QPainter_QRect_QDate(nativeId(), painter == null ? 0 : painter.nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), date == null ? (date = new com.trolltech.qt.core.QDate()).nativeId() : date.nativeId());
    }
    private native static void __qt_paintCell_QPainter_QRect_QDate(long __this__nativeId, long painter, long rect, long date);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QCalendarWidget fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QCalendarWidget(QPrivateConstructor p) { super(p); } 

}
