package com.trolltech.qt.gui;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public final class QClipboard extends com.trolltech.qt.core.QObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Mode implements com.trolltech.qt.QtEnumerator {
        Clipboard(0),
        Selection(1),
        FindBuffer(2),
;

        Mode(int value) { this.value = value; }
        public int value() { return value; }

        public static Mode resolve(int value) {
            return (Mode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Clipboard;
            case 1: return Selection;
            case 2: return FindBuffer;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QClipboard.Mode> changed = new Signal1<com.trolltech.qt.gui.QClipboard.Mode>();

    @SuppressWarnings("unused")
    private final void changed(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changed_Mode(nativeId(), mode.value());
    }
    private native static void __qt_changed_Mode(long __this__nativeId, int mode);

    public final Signal0 dataChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void dataChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataChanged(nativeId());
    }
    private native static void __qt_dataChanged(long __this__nativeId);

    public final Signal0 findBufferChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void findBufferChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_findBufferChanged(nativeId());
    }
    private native static void __qt_findBufferChanged(long __this__nativeId);

    public final Signal0 selectionChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void selectionChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged(nativeId());
    }
    private native static void __qt_selectionChanged(long __this__nativeId);


    @QtBlockedSlot public final void clear() {
        clear(com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final void clear(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear_Mode(nativeId(), mode.value());
    }
    private native static void __qt_clear_Mode(long __this__nativeId, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage image() {
        return image(com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage image(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_image_Mode(nativeId(), mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_image_Mode(long __this__nativeId, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QMimeData mimeData() {
        return mimeData(com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QMimeData mimeData(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mimeData_Mode(nativeId(), mode.value());
    }
    private native static com.trolltech.qt.gui.QMimeData __qt_mimeData_Mode(long __this__nativeId, int mode);

    @QtBlockedSlot public final boolean ownsClipboard() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ownsClipboard(nativeId());
    }
    private native static boolean __qt_ownsClipboard(long __this__nativeId);

    @QtBlockedSlot public final boolean ownsFindBuffer() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ownsFindBuffer(nativeId());
    }
    private native static boolean __qt_ownsFindBuffer(long __this__nativeId);

    @QtBlockedSlot public final boolean ownsSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ownsSelection(nativeId());
    }
    private native static boolean __qt_ownsSelection(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap() {
        return pixmap(com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap pixmap(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixmap_Mode(nativeId(), mode.value());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_pixmap_Mode(long __this__nativeId, int mode);


    @QtBlockedSlot public final void setImage(com.trolltech.qt.gui.QImage arg__1) {
        setImage(arg__1, com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final void setImage(com.trolltech.qt.gui.QImage arg__1, com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setImage_QImage_Mode(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QImage()).nativeId() : arg__1.nativeId(), mode.value());
    }
    private native static void __qt_setImage_QImage_Mode(long __this__nativeId, long arg__1, int mode);


    @QtBlockedSlot public final void setMimeData(com.trolltech.qt.gui.QMimeData data) {
        setMimeData(data, com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final void setMimeData(com.trolltech.qt.gui.QMimeData data, com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (data != null) {
            data.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMimeData_QMimeData_Mode(nativeId(), data == null ? 0 : data.nativeId(), mode.value());
    }
    private native static void __qt_setMimeData_QMimeData_Mode(long __this__nativeId, long data, int mode);


    @QtBlockedSlot public final void setPixmap(com.trolltech.qt.gui.QPixmap arg__1) {
        setPixmap(arg__1, com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final void setPixmap(com.trolltech.qt.gui.QPixmap arg__1, com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPixmap_QPixmap_Mode(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QPixmap()).nativeId() : arg__1.nativeId(), mode.value());
    }
    private native static void __qt_setPixmap_QPixmap_Mode(long __this__nativeId, long arg__1, int mode);


    @QtBlockedSlot public final void setText(java.lang.String arg__1) {
        setText(arg__1, com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final void setText(java.lang.String arg__1, com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String_Mode(nativeId(), arg__1, mode.value());
    }
    private native static void __qt_setText_String_Mode(long __this__nativeId, java.lang.String arg__1, int mode);

    @QtBlockedSlot public final boolean supportsFindBuffer() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsFindBuffer(nativeId());
    }
    private native static boolean __qt_supportsFindBuffer(long __this__nativeId);

    @QtBlockedSlot public final boolean supportsSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsSelection(nativeId());
    }
    private native static boolean __qt_supportsSelection(long __this__nativeId);


    @QtBlockedSlot public final java.lang.String text() {
        return text(com.trolltech.qt.gui.QClipboard.Mode.Clipboard);
    }
    @QtBlockedSlot public final java.lang.String text(com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text_Mode(nativeId(), mode.value());
    }
    private native static java.lang.String __qt_text_Mode(long __this__nativeId, int mode);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final java.lang.String text(com.trolltech.qt.QNativePointer subtype, com.trolltech.qt.gui.QClipboard.Mode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text_nativepointer_Mode(nativeId(), subtype, mode.value());
    }
    private native static java.lang.String __qt_text_nativepointer_Mode(long __this__nativeId, com.trolltech.qt.QNativePointer subtype, int mode);


    public static native QClipboard fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QClipboard(QPrivateConstructor p) { super(p); } 


        public static class Text {            
            public String text;
            public String subtype;
        }
        public final Text text(String subtype, Mode mode) {
            QNativePointer np = new QNativePointer(QNativePointer.Type.String);
            np.setStringValue(subtype != null ? subtype : "");            
            
            Text returned = new Text();
            returned.text = text(np, mode);                        
            returned.subtype = np.stringValue();
            return returned;            
        }
        
        public final Text text(String subtype) {
            return text(subtype, Mode.Clipboard);
        }
    
}
