package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QColor extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Spec implements com.trolltech.qt.QtEnumerator {
        Invalid(0),
        Rgb(1),
        Hsv(2),
        Cmyk(3);

        Spec(int value) { this.value = value; }
        public int value() { return value; }

        public static Spec resolve(int value) {
            return (Spec) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Invalid;
            case 1: return Rgb;
            case 2: return Hsv;
            case 3: return Cmyk;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QColor(int rgb) {
        super((QPrivateConstructor)null);
        __qt_QColor_int(rgb);
    }
    private native void __qt_QColor_int(int rgb);


    public QColor(com.trolltech.qt.core.Qt.GlobalColor color) {
        super((QPrivateConstructor)null);
        __qt_QColor_GlobalColor(color.value());
    }
    private native void __qt_QColor_GlobalColor(int color);



    public QColor(int r, int g, int b) {
        this(r, g, b, (int)255);
    }
    public QColor(int r, int g, int b, int a) {
        super((QPrivateConstructor)null);
        __qt_QColor_int_int_int_int(r, g, b, a);
    }
    private native void __qt_QColor_int_int_int_int(int r, int g, int b, int a);


    public QColor(com.trolltech.qt.gui.QColor color) {
        super((QPrivateConstructor)null);
        __qt_QColor_QColor(color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native void __qt_QColor_QColor(long color);


    public QColor() {
        super((QPrivateConstructor)null);
        __qt_QColor();
    }
    private native void __qt_QColor();


    public QColor(java.lang.String name) {
        super((QPrivateConstructor)null);
        __qt_QColor_String(name);
    }
    private native void __qt_QColor_String(java.lang.String name);


    @QtBlockedSlot public final int alpha() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alpha(nativeId());
    }
    private native static int __qt_alpha(long __this__nativeId);

    @QtBlockedSlot public final double alphaF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alphaF(nativeId());
    }
    private native static double __qt_alphaF(long __this__nativeId);

    @QtBlockedSlot public final int black() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_black(nativeId());
    }
    private native static int __qt_black(long __this__nativeId);

    @QtBlockedSlot public final double blackF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blackF(nativeId());
    }
    private native static double __qt_blackF(long __this__nativeId);

    @QtBlockedSlot public final int blue() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blue(nativeId());
    }
    private native static int __qt_blue(long __this__nativeId);

    @QtBlockedSlot public final double blueF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blueF(nativeId());
    }
    private native static double __qt_blueF(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor convertTo(com.trolltech.qt.gui.QColor.Spec colorSpec) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_convertTo_Spec(nativeId(), colorSpec.value());
    }
    private native static com.trolltech.qt.gui.QColor __qt_convertTo_Spec(long __this__nativeId, int colorSpec);

    @QtBlockedSlot public final int cyan() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cyan(nativeId());
    }
    private native static int __qt_cyan(long __this__nativeId);

    @QtBlockedSlot public final double cyanF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cyanF(nativeId());
    }
    private native static double __qt_cyanF(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QColor darker() {
        return darker((int)200);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QColor darker(int f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_darker_int(nativeId(), f);
    }
    private native static com.trolltech.qt.gui.QColor __qt_darker_int(long __this__nativeId, int f);

    @QtBlockedSlot public final int green() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_green(nativeId());
    }
    private native static int __qt_green(long __this__nativeId);

    @QtBlockedSlot public final double greenF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_greenF(nativeId());
    }
    private native static double __qt_greenF(long __this__nativeId);

    @QtBlockedSlot public final int hue() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hue(nativeId());
    }
    private native static int __qt_hue(long __this__nativeId);

    @QtBlockedSlot public final double hueF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hueF(nativeId());
    }
    private native static double __qt_hueF(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QColor lighter() {
        return lighter((int)150);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QColor lighter(int f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lighter_int(nativeId(), f);
    }
    private native static com.trolltech.qt.gui.QColor __qt_lighter_int(long __this__nativeId, int f);

    @QtBlockedSlot public final int magenta() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_magenta(nativeId());
    }
    private native static int __qt_magenta(long __this__nativeId);

    @QtBlockedSlot public final double magentaF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_magentaF(nativeId());
    }
    private native static double __qt_magentaF(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String name() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_name(nativeId());
    }
    private native static java.lang.String __qt_name(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QColor c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QColor(nativeId(), c == null ? (c = new com.trolltech.qt.gui.QColor()).nativeId() : c.nativeId());
    }
    private native static boolean __qt_operator_equal_QColor(long __this__nativeId, long c);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final int red() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_red(nativeId());
    }
    private native static int __qt_red(long __this__nativeId);

    @QtBlockedSlot public final double redF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_redF(nativeId());
    }
    private native static double __qt_redF(long __this__nativeId);

    @QtBlockedSlot public final int rgb() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rgb(nativeId());
    }
    private native static int __qt_rgb(long __this__nativeId);

    @QtBlockedSlot public final int rgba() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rgba(nativeId());
    }
    private native static int __qt_rgba(long __this__nativeId);

    @QtBlockedSlot public final int saturation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saturation(nativeId());
    }
    private native static int __qt_saturation(long __this__nativeId);

    @QtBlockedSlot public final double saturationF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saturationF(nativeId());
    }
    private native static double __qt_saturationF(long __this__nativeId);

    @QtBlockedSlot public final void setAlpha(int alpha) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlpha_int(nativeId(), alpha);
    }
    private native static void __qt_setAlpha_int(long __this__nativeId, int alpha);

    @QtBlockedSlot public final void setAlphaF(double alpha) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlphaF_double(nativeId(), alpha);
    }
    private native static void __qt_setAlphaF_double(long __this__nativeId, double alpha);

    @QtBlockedSlot public final void setBlue(int blue) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBlue_int(nativeId(), blue);
    }
    private native static void __qt_setBlue_int(long __this__nativeId, int blue);

    @QtBlockedSlot public final void setBlueF(double blue) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBlueF_double(nativeId(), blue);
    }
    private native static void __qt_setBlueF_double(long __this__nativeId, double blue);


    @QtBlockedSlot public final void setCmyk(int c, int m, int y, int k) {
        setCmyk(c, m, y, k, (int)255);
    }
    @QtBlockedSlot public final void setCmyk(int c, int m, int y, int k, int a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCmyk_int_int_int_int_int(nativeId(), c, m, y, k, a);
    }
    private native static void __qt_setCmyk_int_int_int_int_int(long __this__nativeId, int c, int m, int y, int k, int a);


    @QtBlockedSlot public final void setCmykF(double c, double m, double y, double k) {
        setCmykF(c, m, y, k, (double)1.0);
    }
    @QtBlockedSlot public final void setCmykF(double c, double m, double y, double k, double a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCmykF_double_double_double_double_double(nativeId(), c, m, y, k, a);
    }
    private native static void __qt_setCmykF_double_double_double_double_double(long __this__nativeId, double c, double m, double y, double k, double a);

    @QtBlockedSlot public final void setGreen(int green) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGreen_int(nativeId(), green);
    }
    private native static void __qt_setGreen_int(long __this__nativeId, int green);

    @QtBlockedSlot public final void setGreenF(double green) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGreenF_double(nativeId(), green);
    }
    private native static void __qt_setGreenF_double(long __this__nativeId, double green);


    @QtBlockedSlot public final void setHsv(int h, int s, int v) {
        setHsv(h, s, v, (int)255);
    }
    @QtBlockedSlot public final void setHsv(int h, int s, int v, int a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHsv_int_int_int_int(nativeId(), h, s, v, a);
    }
    private native static void __qt_setHsv_int_int_int_int(long __this__nativeId, int h, int s, int v, int a);


    @QtBlockedSlot public final void setHsvF(double h, double s, double v) {
        setHsvF(h, s, v, (double)1.0);
    }
    @QtBlockedSlot public final void setHsvF(double h, double s, double v, double a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHsvF_double_double_double_double(nativeId(), h, s, v, a);
    }
    private native static void __qt_setHsvF_double_double_double_double(long __this__nativeId, double h, double s, double v, double a);

    @QtBlockedSlot public final void setNamedColor(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNamedColor_String(nativeId(), name);
    }
    private native static void __qt_setNamedColor_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final void setRed(int red) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRed_int(nativeId(), red);
    }
    private native static void __qt_setRed_int(long __this__nativeId, int red);

    @QtBlockedSlot public final void setRedF(double red) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRedF_double(nativeId(), red);
    }
    private native static void __qt_setRedF_double(long __this__nativeId, double red);


    @QtBlockedSlot public final void setRgb(int r, int g, int b) {
        setRgb(r, g, b, (int)255);
    }
    @QtBlockedSlot public final void setRgb(int r, int g, int b, int a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRgb_int_int_int_int(nativeId(), r, g, b, a);
    }
    private native static void __qt_setRgb_int_int_int_int(long __this__nativeId, int r, int g, int b, int a);

    @QtBlockedSlot public final void setRgb(int rgb) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRgb_int(nativeId(), rgb);
    }
    private native static void __qt_setRgb_int(long __this__nativeId, int rgb);


    @QtBlockedSlot public final void setRgbF(double r, double g, double b) {
        setRgbF(r, g, b, (double)1.0);
    }
    @QtBlockedSlot public final void setRgbF(double r, double g, double b, double a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRgbF_double_double_double_double(nativeId(), r, g, b, a);
    }
    private native static void __qt_setRgbF_double_double_double_double(long __this__nativeId, double r, double g, double b, double a);

    @QtBlockedSlot public final void setRgba(int rgba) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRgba_int(nativeId(), rgba);
    }
    private native static void __qt_setRgba_int(long __this__nativeId, int rgba);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor.Spec spec() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QColor.Spec.resolve(__qt_spec(nativeId()));
    }
    private native static int __qt_spec(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor toCmyk() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toCmyk(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_toCmyk(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor toHsv() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toHsv(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_toHsv(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor toRgb() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toRgb(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_toRgb(long __this__nativeId);

    @QtBlockedSlot public final int value() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value(nativeId());
    }
    private native static int __qt_value(long __this__nativeId);

    @QtBlockedSlot public final double valueF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_valueF(nativeId());
    }
    private native static double __qt_valueF(long __this__nativeId);

    @QtBlockedSlot public final int yellow() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_yellow(nativeId());
    }
    private native static int __qt_yellow(long __this__nativeId);

    @QtBlockedSlot public final double yellowF() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_yellowF(nativeId());
    }
    private native static double __qt_yellowF(long __this__nativeId);

    public native static java.util.List<java.lang.String> colorNames();


    public static com.trolltech.qt.gui.QColor fromCmyk(int c, int m, int y, int k) {
        return fromCmyk(c, m, y, k, (int)255);
    }
    public native static com.trolltech.qt.gui.QColor fromCmyk(int c, int m, int y, int k, int a);


    public static com.trolltech.qt.gui.QColor fromCmykF(double c, double m, double y, double k) {
        return fromCmykF(c, m, y, k, (double)1.0);
    }
    public native static com.trolltech.qt.gui.QColor fromCmykF(double c, double m, double y, double k, double a);


    public static com.trolltech.qt.gui.QColor fromHsv(int h, int s, int v) {
        return fromHsv(h, s, v, (int)255);
    }
    public native static com.trolltech.qt.gui.QColor fromHsv(int h, int s, int v, int a);


    public static com.trolltech.qt.gui.QColor fromHsvF(double h, double s, double v) {
        return fromHsvF(h, s, v, (double)1.0);
    }
    public native static com.trolltech.qt.gui.QColor fromHsvF(double h, double s, double v, double a);

    public native static com.trolltech.qt.gui.QColor fromRgb(int rgb);


    public static com.trolltech.qt.gui.QColor fromRgb(int r, int g, int b) {
        return fromRgb(r, g, b, (int)255);
    }
    public native static com.trolltech.qt.gui.QColor fromRgb(int r, int g, int b, int a);


    public static com.trolltech.qt.gui.QColor fromRgbF(double r, double g, double b) {
        return fromRgbF(r, g, b, (double)1.0);
    }
    public native static com.trolltech.qt.gui.QColor fromRgbF(double r, double g, double b, double a);

    public native static com.trolltech.qt.gui.QColor fromRgba(int rgba);


    public static native QColor fromNativePointer(QNativePointer nativePointer);

    protected QColor(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QColor array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QColor)
            return operator_equal((com.trolltech.qt.gui.QColor) other);
        return false;
    }


    public String toString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString(nativeId());
    }
    private static native String __qt_toString(long __this_nativeId);


    public static final QColor white = new QColor(com.trolltech.qt.core.Qt.GlobalColor.white);
    public static final QColor black = new QColor(com.trolltech.qt.core.Qt.GlobalColor.black);
    public static final QColor red = new QColor(com.trolltech.qt.core.Qt.GlobalColor.red);
    public static final QColor darkRed = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkRed);
    public static final QColor green = new QColor(com.trolltech.qt.core.Qt.GlobalColor.green);
    public static final QColor darkGreen = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkGreen);
    public static final QColor blue = new QColor(com.trolltech.qt.core.Qt.GlobalColor.blue);
    public static final QColor darkBlue = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkBlue);
    public static final QColor cyan = new QColor(com.trolltech.qt.core.Qt.GlobalColor.cyan);
    public static final QColor darkCyan = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkCyan);
    public static final QColor magenta = new QColor(com.trolltech.qt.core.Qt.GlobalColor.magenta);
    public static final QColor darkMagenta = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkMagenta);
    public static final QColor yellow = new QColor(com.trolltech.qt.core.Qt.GlobalColor.yellow);
    public static final QColor darkYellow = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkYellow);
    public static final QColor gray = new QColor(com.trolltech.qt.core.Qt.GlobalColor.gray);
    public static final QColor darkGray = new QColor(com.trolltech.qt.core.Qt.GlobalColor.darkGray);
    public static final QColor lightGray = new QColor(com.trolltech.qt.core.Qt.GlobalColor.lightGray);
    public static final QColor transparent = new QColor(com.trolltech.qt.core.Qt.GlobalColor.transparent);
    public static final QColor color0 = new QColor(com.trolltech.qt.core.Qt.GlobalColor.color0);
    public static final QColor color1 = new QColor(com.trolltech.qt.core.Qt.GlobalColor.color1);
    
}
