package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QCompleter extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private Object __rcModel = null;
    @SuppressWarnings("unused") private Object __rcWidget = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ModelSorting implements com.trolltech.qt.QtEnumerator {
        UnsortedModel(0),
        CaseSensitivelySortedModel(1),
        CaseInsensitivelySortedModel(2);

        ModelSorting(int value) { this.value = value; }
        public int value() { return value; }

        public static ModelSorting resolve(int value) {
            return (ModelSorting) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnsortedModel;
            case 1: return CaseSensitivelySortedModel;
            case 2: return CaseInsensitivelySortedModel;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CompletionMode implements com.trolltech.qt.QtEnumerator {
        PopupCompletion(0),
        UnfilteredPopupCompletion(1),
        InlineCompletion(2);

        CompletionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CompletionMode resolve(int value) {
            return (CompletionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return PopupCompletion;
            case 1: return UnfilteredPopupCompletion;
            case 2: return InlineCompletion;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.core.QModelIndex> activatedIndex = new Signal1<com.trolltech.qt.core.QModelIndex>();

    @SuppressWarnings("unused")
    private final void activatedIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activatedIndex_QModelIndex(nativeId(), index);
    }
    private native static void __qt_activatedIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    public final Signal1<java.lang.String> activated = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void activated(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activated_String(nativeId(), text);
    }
    private native static void __qt_activated_String(long __this__nativeId, java.lang.String text);

    public final Signal1<com.trolltech.qt.core.QModelIndex> highlightedIndex = new Signal1<com.trolltech.qt.core.QModelIndex>();

    @SuppressWarnings("unused")
    private final void highlightedIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_highlightedIndex_QModelIndex(nativeId(), index);
    }
    private native static void __qt_highlightedIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    public final Signal1<java.lang.String> highlighted = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void highlighted(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_highlighted_String(nativeId(), text);
    }
    private native static void __qt_highlighted_String(long __this__nativeId, java.lang.String text);


    public QCompleter(java.util.List<java.lang.String> completions) {
        this(completions, (com.trolltech.qt.core.QObject)null);
    }
    public QCompleter(java.util.List<java.lang.String> completions, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QCompleter_List_QObject(completions, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QCompleter_List_QObject(java.util.List<java.lang.String> completions, long parent);



    public QCompleter() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QCompleter(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QCompleter_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QCompleter_QObject(long parent);



    public QCompleter(com.trolltech.qt.core.QAbstractItemModel model) {
        this(model, (com.trolltech.qt.core.QObject)null);
    }
    public QCompleter(com.trolltech.qt.core.QAbstractItemModel model, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QCompleter_QAbstractItemModel_QObject(model == null ? 0 : model.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QCompleter_QAbstractItemModel_QObject(long model, long parent);


    @com.trolltech.qt.QtPropertyReader(name="caseSensitivity")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.CaseSensitivity caseSensitivity() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.CaseSensitivity.resolve(__qt_caseSensitivity(nativeId()));
    }
    private native static int __qt_caseSensitivity(long __this__nativeId);


    public final void complete() {
        complete((com.trolltech.qt.core.QRect)new com.trolltech.qt.core.QRect());
    }
    public final void complete(com.trolltech.qt.core.QRect rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_complete_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_complete_QRect(long __this__nativeId, long rect);

    @com.trolltech.qt.QtPropertyReader(name="completionColumn")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int completionColumn() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completionColumn(nativeId());
    }
    private native static int __qt_completionColumn(long __this__nativeId);

    @QtBlockedSlot public final int completionCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completionCount(nativeId());
    }
    private native static int __qt_completionCount(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="completionMode")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCompleter.CompletionMode completionMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QCompleter.CompletionMode.resolve(__qt_completionMode(nativeId()));
    }
    private native static int __qt_completionMode(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractItemModel completionModel() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completionModel(nativeId());
    }
    private native static com.trolltech.qt.core.QAbstractItemModel __qt_completionModel(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="completionPrefix")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final java.lang.String completionPrefix() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completionPrefix(nativeId());
    }
    private native static java.lang.String __qt_completionPrefix(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="completionRole")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int completionRole() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_completionRole(nativeId());
    }
    private native static int __qt_completionRole(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String currentCompletion() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentCompletion(nativeId());
    }
    private native static java.lang.String __qt_currentCompletion(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex currentIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentIndex(nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_currentIndex(long __this__nativeId);

    @QtBlockedSlot public final int currentRow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentRow(nativeId());
    }
    private native static int __qt_currentRow(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractItemModel model() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_model(nativeId());
    }
    private native static com.trolltech.qt.core.QAbstractItemModel __qt_model(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="modelSorting")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCompleter.ModelSorting modelSorting() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QCompleter.ModelSorting.resolve(__qt_modelSorting(nativeId()));
    }
    private native static int __qt_modelSorting(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractItemView popup() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_popup(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractItemView __qt_popup(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="caseSensitivity")
    @QtBlockedSlot public final void setCaseSensitivity(com.trolltech.qt.core.Qt.CaseSensitivity caseSensitivity) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCaseSensitivity_CaseSensitivity(nativeId(), caseSensitivity.value());
    }
    private native static void __qt_setCaseSensitivity_CaseSensitivity(long __this__nativeId, int caseSensitivity);

    @com.trolltech.qt.QtPropertyWriter(name="completionColumn")
    @QtBlockedSlot public final void setCompletionColumn(int column) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompletionColumn_int(nativeId(), column);
    }
    private native static void __qt_setCompletionColumn_int(long __this__nativeId, int column);

    @com.trolltech.qt.QtPropertyWriter(name="completionMode")
    @QtBlockedSlot public final void setCompletionMode(com.trolltech.qt.gui.QCompleter.CompletionMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompletionMode_CompletionMode(nativeId(), mode.value());
    }
    private native static void __qt_setCompletionMode_CompletionMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="completionPrefix")
    public final void setCompletionPrefix(java.lang.String prefix) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompletionPrefix_String(nativeId(), prefix);
    }
    private native static void __qt_setCompletionPrefix_String(long __this__nativeId, java.lang.String prefix);

    @com.trolltech.qt.QtPropertyWriter(name="completionRole")
    @QtBlockedSlot public final void setCompletionRole(int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompletionRole_int(nativeId(), role);
    }
    private native static void __qt_setCompletionRole_int(long __this__nativeId, int role);

    @QtBlockedSlot public final boolean setCurrentRow(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setCurrentRow_int(nativeId(), row);
    }
    private native static boolean __qt_setCurrentRow_int(long __this__nativeId, int row);

    @QtBlockedSlot public final void setModel(com.trolltech.qt.core.QAbstractItemModel c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcModel = c;
        }
        __qt_setModel_QAbstractItemModel(nativeId(), c == null ? 0 : c.nativeId());
    }
    private native static void __qt_setModel_QAbstractItemModel(long __this__nativeId, long c);

    @com.trolltech.qt.QtPropertyWriter(name="modelSorting")
    @QtBlockedSlot public final void setModelSorting(com.trolltech.qt.gui.QCompleter.ModelSorting sorting) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModelSorting_ModelSorting(nativeId(), sorting.value());
    }
    private native static void __qt_setModelSorting_ModelSorting(long __this__nativeId, int sorting);

    @QtBlockedSlot public final void setPopup(com.trolltech.qt.gui.QAbstractItemView popup) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (popup != null) {
            popup.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (popup == null)
            throw new NullPointerException("Argument 'popup': null not expected.");
        __qt_setPopup_QAbstractItemView(nativeId(), popup == null ? 0 : popup.nativeId());
    }
    private native static void __qt_setPopup_QAbstractItemView(long __this__nativeId, long popup);

    @QtBlockedSlot public final void setWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcWidget = widget;
        }
        __qt_setWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setWidget_QWidget(long __this__nativeId, long widget);

    @com.trolltech.qt.QtPropertyWriter(name="wrapAround")
    public final void setWrapAround(boolean wrap) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWrapAround_boolean(nativeId(), wrap);
    }
    private native static void __qt_setWrapAround_boolean(long __this__nativeId, boolean wrap);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget widget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_widget(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="wrapAround")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final boolean wrapAround() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_wrapAround(nativeId());
    }
    private native static boolean __qt_wrapAround(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean eventFilter(com.trolltech.qt.core.QObject o, com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_eventFilter_QObject_QEvent(nativeId(), o == null ? 0 : o.nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_eventFilter_QObject_QEvent(long __this__nativeId, long o, long e);

    @QtBlockedSlot public java.lang.String pathFromIndex(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pathFromIndex_QModelIndex(nativeId(), index);
    }
    private native static java.lang.String __qt_pathFromIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public java.util.List<java.lang.String> splitPath(java.lang.String path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_splitPath_String(nativeId(), path);
    }
    private native static java.util.List<java.lang.String> __qt_splitPath_String(long __this__nativeId, java.lang.String path);


    public static native QCompleter fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QCompleter(QPrivateConstructor p) { super(p); } 

}
