package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDialog extends com.trolltech.qt.gui.QWidget
{
    public enum DialogCode implements com.trolltech.qt.QtEnumerator {
        Rejected(0),
        Accepted(1);

        DialogCode(int value) { this.value = value; }
        public int value() { return value; }

        public static DialogCode resolve(int value) {
            return (DialogCode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Rejected;
            case 1: return Accepted;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 accepted = new Signal0();

    @SuppressWarnings("unused")
    private final void accepted() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_accepted(nativeId());
    }
    private native static void __qt_accepted(long __this__nativeId);

    public final Signal1<java.lang.Integer> finished = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void finished(int result) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_finished_int(nativeId(), result);
    }
    private native static void __qt_finished_int(long __this__nativeId, int result);

    public final Signal0 rejected = new Signal0();

    @SuppressWarnings("unused")
    private final void rejected() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rejected(nativeId());
    }
    private native static void __qt_rejected(long __this__nativeId);


    public QDialog(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QDialog() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QDialog(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        super((QPrivateConstructor)null);
        __qt_QDialog_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native void __qt_QDialog_QWidget_WindowFlags(long parent, int f);


    @QtBlockedSlot protected final void adjustPosition(com.trolltech.qt.gui.QWidget arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_adjustPosition_QWidget(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_adjustPosition_QWidget(long __this__nativeId, long arg__1);

    public int exec() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exec(nativeId());
    }
    private native static int __qt_exec(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sizeGripEnabled")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isSizeGripEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSizeGripEnabled(nativeId());
    }
    private native static boolean __qt_isSizeGripEnabled(long __this__nativeId);

    @QtBlockedSlot public final int result() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_result(nativeId());
    }
    private native static int __qt_result(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="modal")
    @QtBlockedSlot public final void setModal(boolean modal) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModal_boolean(nativeId(), modal);
    }
    private native static void __qt_setModal_boolean(long __this__nativeId, boolean modal);

    @QtBlockedSlot public final void setResult(int r) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResult_int(nativeId(), r);
    }
    private native static void __qt_setResult_int(long __this__nativeId, int r);

    @com.trolltech.qt.QtPropertyWriter(name="sizeGripEnabled")
    @QtBlockedSlot public final void setSizeGripEnabled(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeGripEnabled_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setSizeGripEnabled_boolean(long __this__nativeId, boolean arg__1);

    public void accept() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_accept(nativeId());
    }
    private native static void __qt_accept(long __this__nativeId);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long arg__1);

    public void done(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_done_int(nativeId(), arg__1);
    }
    private native static void __qt_done_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public boolean eventFilter(com.trolltech.qt.core.QObject arg__1, com.trolltech.qt.core.QEvent arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_eventFilter_QObject_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static boolean __qt_eventFilter_QObject_QEvent(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    public void reject() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reject(nativeId());
    }
    private native static void __qt_reject(long __this__nativeId);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public void setVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setVisible_boolean(long __this__nativeId, boolean visible);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QDialog fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QDialog(QPrivateConstructor p) { super(p); } 

}
