package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDialogButtonBox extends com.trolltech.qt.gui.QWidget
{
    public enum ButtonLayout implements com.trolltech.qt.QtEnumerator {
        WinLayout(0),
        MacLayout(1),
        KdeLayout(2),
        GnomeLayout(3);

        ButtonLayout(int value) { this.value = value; }
        public int value() { return value; }

        public static ButtonLayout resolve(int value) {
            return (ButtonLayout) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WinLayout;
            case 1: return MacLayout;
            case 2: return KdeLayout;
            case 3: return GnomeLayout;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ButtonRole implements com.trolltech.qt.QtEnumerator {
        InvalidRole(-1),
        AcceptRole(0),
        RejectRole(1),
        DestructiveRole(2),
        ActionRole(3),
        HelpRole(4),
        YesRole(5),
        NoRole(6),
        ResetRole(7),
        ApplyRole(8),
        NRoles(9);

        ButtonRole(int value) { this.value = value; }
        public int value() { return value; }

        public static ButtonRole resolve(int value) {
            return (ButtonRole) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return InvalidRole;
            case 0: return AcceptRole;
            case 1: return RejectRole;
            case 2: return DestructiveRole;
            case 3: return ActionRole;
            case 4: return HelpRole;
            case 5: return YesRole;
            case 6: return NoRole;
            case 7: return ResetRole;
            case 8: return ApplyRole;
            case 9: return NRoles;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StandardButton implements com.trolltech.qt.QtEnumerator {
        NoButton(0),
        Ok(1024),
        Save(2048),
        SaveAll(4096),
        Open(8192),
        Yes(16384),
        YesToAll(32768),
        No(65536),
        NoToAll(131072),
        Abort(262144),
        Retry(524288),
        Ignore(1048576),
        Close(2097152),
        Cancel(4194304),
        Discard(8388608),
        Help(16777216),
        Apply(33554432),
        Reset(67108864),
        RestoreDefaults(134217728),
;

        StandardButton(int value) { this.value = value; }
        public int value() { return value; }

        public static StandardButtons createQFlags(StandardButton ... values) {
            return new StandardButtons(values);
        }
        public static StandardButton resolve(int value) {
            return (StandardButton) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoButton;
            case 1024: return Ok;
            case 2048: return Save;
            case 4096: return SaveAll;
            case 8192: return Open;
            case 16384: return Yes;
            case 32768: return YesToAll;
            case 65536: return No;
            case 131072: return NoToAll;
            case 262144: return Abort;
            case 524288: return Retry;
            case 1048576: return Ignore;
            case 2097152: return Close;
            case 4194304: return Cancel;
            case 8388608: return Discard;
            case 16777216: return Help;
            case 33554432: return Apply;
            case 67108864: return Reset;
            case 134217728: return RestoreDefaults;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class StandardButtons extends com.trolltech.qt.QFlags<StandardButton> {
        private static final long serialVersionUID = 1L;
        public StandardButtons(StandardButton ... args) { super(args); }
        public StandardButtons(int value) { setValue(value); }
    }


    public final Signal0 accepted = new Signal0();

    @SuppressWarnings("unused")
    private final void accepted() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_accepted(nativeId());
    }
    private native static void __qt_accepted(long __this__nativeId);

    public final Signal1<com.trolltech.qt.gui.QAbstractButton> clicked = new Signal1<com.trolltech.qt.gui.QAbstractButton>();

    @SuppressWarnings("unused")
    private final void clicked(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clicked_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_clicked_QAbstractButton(long __this__nativeId, long button);

    public final Signal0 helpRequested = new Signal0();

    @SuppressWarnings("unused")
    private final void helpRequested() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_helpRequested(nativeId());
    }
    private native static void __qt_helpRequested(long __this__nativeId);

    public final Signal0 rejected = new Signal0();

    @SuppressWarnings("unused")
    private final void rejected() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rejected(nativeId());
    }
    private native static void __qt_rejected(long __this__nativeId);


    public QDialogButtonBox(com.trolltech.qt.core.Qt.Orientation orientation) {
        this(orientation, (com.trolltech.qt.gui.QWidget)null);
    }
    public QDialogButtonBox(com.trolltech.qt.core.Qt.Orientation orientation, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDialogButtonBox_Orientation_QWidget(orientation.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDialogButtonBox_Orientation_QWidget(int orientation, long parent);



    public QDialogButtonBox(com.trolltech.qt.gui.QDialogButtonBox.StandardButtons buttons, com.trolltech.qt.core.Qt.Orientation orientation) {
        this(buttons, orientation, (com.trolltech.qt.gui.QWidget)null);
    }

    public QDialogButtonBox(com.trolltech.qt.gui.QDialogButtonBox.StandardButtons buttons) {
        this(buttons, com.trolltech.qt.core.Qt.Orientation.Horizontal, (com.trolltech.qt.gui.QWidget)null);
    }
    public QDialogButtonBox(com.trolltech.qt.gui.QDialogButtonBox.StandardButtons buttons, com.trolltech.qt.core.Qt.Orientation orientation, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDialogButtonBox_StandardButtons_Orientation_QWidget(buttons.value(), orientation.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDialogButtonBox_StandardButtons_Orientation_QWidget(int buttons, int orientation, long parent);



    public QDialogButtonBox() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QDialogButtonBox(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QDialogButtonBox_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QDialogButtonBox_QWidget(long parent);


    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton addButton(java.lang.String text, com.trolltech.qt.gui.QDialogButtonBox.ButtonRole role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addButton_String_ButtonRole(nativeId(), text, role.value());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_addButton_String_ButtonRole(long __this__nativeId, java.lang.String text, int role);

    @QtBlockedSlot public final void addButton(com.trolltech.qt.gui.QAbstractButton button, com.trolltech.qt.gui.QDialogButtonBox.ButtonRole role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addButton_QAbstractButton_ButtonRole(nativeId(), button == null ? 0 : button.nativeId(), role.value());
    }
    private native static void __qt_addButton_QAbstractButton_ButtonRole(long __this__nativeId, long button, int role);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton addButton(com.trolltech.qt.gui.QDialogButtonBox.StandardButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addButton_StandardButton(nativeId(), button.value());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_addButton_StandardButton(long __this__nativeId, int button);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton button(com.trolltech.qt.gui.QDialogButtonBox.StandardButton which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_button_StandardButton(nativeId(), which.value());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_button_StandardButton(long __this__nativeId, int which);

    @QtBlockedSlot public final com.trolltech.qt.gui.QDialogButtonBox.ButtonRole buttonRole(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QDialogButtonBox.ButtonRole.resolve(__qt_buttonRole_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId()));
    }
    private native static int __qt_buttonRole_QAbstractButton(long __this__nativeId, long button);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QAbstractButton> buttons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_buttons(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QAbstractButton> __qt_buttons(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="centerButtons")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean centerButtons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_centerButtons(nativeId());
    }
    private native static boolean __qt_centerButtons(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="orientation")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientation orientation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);

    @QtBlockedSlot public final void removeButton(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeButton_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_removeButton_QAbstractButton(long __this__nativeId, long button);

    @com.trolltech.qt.QtPropertyWriter(name="centerButtons")
    @QtBlockedSlot public final void setCenterButtons(boolean center) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCenterButtons_boolean(nativeId(), center);
    }
    private native static void __qt_setCenterButtons_boolean(long __this__nativeId, boolean center);

    @com.trolltech.qt.QtPropertyWriter(name="orientation")
    @QtBlockedSlot public final void setOrientation(com.trolltech.qt.core.Qt.Orientation orientation) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOrientation_Orientation(nativeId(), orientation.value());
    }
    private native static void __qt_setOrientation_Orientation(long __this__nativeId, int orientation);


    @QtBlockedSlot public final void setStandardButtons(com.trolltech.qt.gui.QDialogButtonBox.StandardButton ... buttons) {
        this.setStandardButtons(new com.trolltech.qt.gui.QDialogButtonBox.StandardButtons(buttons));
    }
    @com.trolltech.qt.QtPropertyWriter(name="standardButtons")
    @QtBlockedSlot public final void setStandardButtons(com.trolltech.qt.gui.QDialogButtonBox.StandardButtons buttons) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStandardButtons_StandardButtons(nativeId(), buttons.value());
    }
    private native static void __qt_setStandardButtons_StandardButtons(long __this__nativeId, int buttons);

    @QtBlockedSlot public final com.trolltech.qt.gui.QDialogButtonBox.StandardButton standardButton(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QDialogButtonBox.StandardButton.resolve(__qt_standardButton_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId()));
    }
    private native static int __qt_standardButton_QAbstractButton(long __this__nativeId, long button);

    @com.trolltech.qt.QtPropertyReader(name="standardButtons")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QDialogButtonBox.StandardButtons standardButtons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QDialogButtonBox.StandardButtons(__qt_standardButtons(nativeId()));
    }
    private native static int __qt_standardButtons(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);


    public static native QDialogButtonBox fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QDialogButtonBox(QPrivateConstructor p) { super(p); } 

}
