package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QDockWidget extends com.trolltech.qt.gui.QWidget
{
    public enum DockWidgetFeature implements com.trolltech.qt.QtEnumerator {
        DockWidgetClosable(1),
        DockWidgetMovable(2),
        DockWidgetFloatable(4),
        DockWidgetVerticalTitleBar(8),
        DockWidgetFeatureMask(15),
        AllDockWidgetFeatures(7),
        NoDockWidgetFeatures(0),
        Reserved(255);

        DockWidgetFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static DockWidgetFeatures createQFlags(DockWidgetFeature ... values) {
            return new DockWidgetFeatures(values);
        }
        public static DockWidgetFeature resolve(int value) {
            return (DockWidgetFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DockWidgetClosable;
            case 2: return DockWidgetMovable;
            case 4: return DockWidgetFloatable;
            case 8: return DockWidgetVerticalTitleBar;
            case 15: return DockWidgetFeatureMask;
            case 7: return AllDockWidgetFeatures;
            case 0: return NoDockWidgetFeatures;
            case 255: return Reserved;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class DockWidgetFeatures extends com.trolltech.qt.QFlags<DockWidgetFeature> {
        private static final long serialVersionUID = 1L;
        public DockWidgetFeatures(DockWidgetFeature ... args) { super(args); }
        public DockWidgetFeatures(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.core.Qt.DockWidgetAreas> allowedAreasChanged = new Signal1<com.trolltech.qt.core.Qt.DockWidgetAreas>();

    @SuppressWarnings("unused")
    private final void allowedAreasChanged(com.trolltech.qt.core.Qt.DockWidgetAreas allowedAreas) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_allowedAreasChanged_DockWidgetAreas(nativeId(), allowedAreas.value());
    }
    private native static void __qt_allowedAreasChanged_DockWidgetAreas(long __this__nativeId, int allowedAreas);

    public final Signal1<com.trolltech.qt.core.Qt.DockWidgetArea> dockLocationChanged = new Signal1<com.trolltech.qt.core.Qt.DockWidgetArea>();

    @SuppressWarnings("unused")
    private final void dockLocationChanged(com.trolltech.qt.core.Qt.DockWidgetArea area) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dockLocationChanged_DockWidgetArea(nativeId(), area.value());
    }
    private native static void __qt_dockLocationChanged_DockWidgetArea(long __this__nativeId, int area);

    public final Signal1<com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures> featuresChanged = new Signal1<com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures>();

    @SuppressWarnings("unused")
    private final void featuresChanged(com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures features) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_featuresChanged_DockWidgetFeatures(nativeId(), features.value());
    }
    private native static void __qt_featuresChanged_DockWidgetFeatures(long __this__nativeId, int features);

    public final Signal1<java.lang.Boolean> topLevelChanged = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void topLevelChanged(boolean topLevel) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_topLevelChanged_boolean(nativeId(), topLevel);
    }
    private native static void __qt_topLevelChanged_boolean(long __this__nativeId, boolean topLevel);

    public final Signal1<java.lang.Boolean> visibilityChanged = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void visibilityChanged(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_visibilityChanged_boolean(nativeId(), visible);
    }
    private native static void __qt_visibilityChanged_boolean(long __this__nativeId, boolean visible);


    public QDockWidget(java.lang.String title, com.trolltech.qt.gui.QWidget parent) {
        this(title, parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QDockWidget(java.lang.String title) {
        this(title, (com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QDockWidget(java.lang.String title, com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDockWidget_String_QWidget_WindowFlags(title, parent == null ? 0 : parent.nativeId(), flags.value());
    }
    private native void __qt_QDockWidget_String_QWidget_WindowFlags(java.lang.String title, long parent, int flags);



    public QDockWidget(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QDockWidget() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QDockWidget(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QDockWidget_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), flags.value());
    }
    private native void __qt_QDockWidget_QWidget_WindowFlags(long parent, int flags);


    @QtBlockedSlot public final com.trolltech.qt.core.Qt.DockWidgetAreas allowedAreas() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.DockWidgetAreas(__qt_allowedAreas(nativeId()));
    }
    private native static int __qt_allowedAreas(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="features")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures features() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot public final boolean isAreaAllowed(com.trolltech.qt.core.Qt.DockWidgetArea area) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAreaAllowed_DockWidgetArea(nativeId(), area.value());
    }
    private native static boolean __qt_isAreaAllowed_DockWidgetArea(long __this__nativeId, int area);

    @com.trolltech.qt.QtPropertyReader(name="floating")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isFloating() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFloating(nativeId());
    }
    private native static boolean __qt_isFloating(long __this__nativeId);


    @QtBlockedSlot public final void setAllowedAreas(com.trolltech.qt.core.Qt.DockWidgetArea ... areas) {
        this.setAllowedAreas(new com.trolltech.qt.core.Qt.DockWidgetAreas(areas));
    }
    @QtBlockedSlot public final void setAllowedAreas(com.trolltech.qt.core.Qt.DockWidgetAreas areas) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAllowedAreas_DockWidgetAreas(nativeId(), areas.value());
    }
    private native static void __qt_setAllowedAreas_DockWidgetAreas(long __this__nativeId, int areas);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QDockWidget.DockWidgetFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures(features));
    }
    @com.trolltech.qt.QtPropertyWriter(name="features")
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QDockWidget.DockWidgetFeatures features) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_DockWidgetFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_DockWidgetFeatures(long __this__nativeId, int features);

    @com.trolltech.qt.QtPropertyWriter(name="floating")
    @QtBlockedSlot public final void setFloating(boolean floating) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFloating_boolean(nativeId(), floating);
    }
    private native static void __qt_setFloating_boolean(long __this__nativeId, boolean floating);

    @QtBlockedSlot public final void setTitleBarWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTitleBarWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setTitleBarWidget_QWidget(long __this__nativeId, long widget);

    @QtBlockedSlot public final void setWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setWidget_QWidget(long __this__nativeId, long widget);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget titleBarWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_titleBarWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_titleBarWidget(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAction toggleViewAction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toggleViewAction(nativeId());
    }
    private native static com.trolltech.qt.gui.QAction __qt_toggleViewAction(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget widget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_widget(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long event);


    public static native QDockWidget fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QDockWidget(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionDockWidget option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
