package com.trolltech.qt.gui;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QFileDialog extends com.trolltech.qt.gui.QDialog
{
    @SuppressWarnings("unused") private Object __rcItemDelegate = null;
    @SuppressWarnings("unused") private Object __rcIconProvider = null;
    public enum FileMode implements com.trolltech.qt.QtEnumerator {
        AnyFile(0),
        ExistingFile(1),
        Directory(2),
        ExistingFiles(3),
        DirectoryOnly(4);

        FileMode(int value) { this.value = value; }
        public int value() { return value; }

        public static FileMode resolve(int value) {
            return (FileMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AnyFile;
            case 1: return ExistingFile;
            case 2: return Directory;
            case 3: return ExistingFiles;
            case 4: return DirectoryOnly;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Option implements com.trolltech.qt.QtEnumerator {
        ShowDirsOnly(1),
        DontResolveSymlinks(2),
        DontConfirmOverwrite(4),
        DontUseSheet(8),
        DontUseNativeDialog(16);

        Option(int value) { this.value = value; }
        public int value() { return value; }

        public static Options createQFlags(Option ... values) {
            return new Options(values);
        }
        public static Option resolve(int value) {
            return (Option) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return ShowDirsOnly;
            case 2: return DontResolveSymlinks;
            case 4: return DontConfirmOverwrite;
            case 8: return DontUseSheet;
            case 16: return DontUseNativeDialog;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Options extends com.trolltech.qt.QFlags<Option> {
        private static final long serialVersionUID = 1L;
        public Options(Option ... args) { super(args); }
        public Options(int value) { setValue(value); }
    }

    public enum DialogLabel implements com.trolltech.qt.QtEnumerator {
        LookIn(0),
        FileName(1),
        FileType(2),
        Accept(3),
        Reject(4);

        DialogLabel(int value) { this.value = value; }
        public int value() { return value; }

        public static DialogLabel resolve(int value) {
            return (DialogLabel) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LookIn;
            case 1: return FileName;
            case 2: return FileType;
            case 3: return Accept;
            case 4: return Reject;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ViewMode implements com.trolltech.qt.QtEnumerator {
        Detail(0),
        List(1);

        ViewMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ViewMode resolve(int value) {
            return (ViewMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Detail;
            case 1: return List;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AcceptMode implements com.trolltech.qt.QtEnumerator {
        AcceptOpen(0),
        AcceptSave(1);

        AcceptMode(int value) { this.value = value; }
        public int value() { return value; }

        public static AcceptMode resolve(int value) {
            return (AcceptMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AcceptOpen;
            case 1: return AcceptSave;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.String> currentChanged = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void currentChanged(java.lang.String path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_String(nativeId(), path);
    }
    private native static void __qt_currentChanged_String(long __this__nativeId, java.lang.String path);

    public final Signal1<java.lang.String> directoryEntered = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void directoryEntered(java.lang.String directory) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_directoryEntered_String(nativeId(), directory);
    }
    private native static void __qt_directoryEntered_String(long __this__nativeId, java.lang.String directory);

    public final Signal1<java.util.List<java.lang.String>> filesSelected = new Signal1<java.util.List<java.lang.String>>();

    @SuppressWarnings("unused")
    private final void filesSelected(java.util.List<java.lang.String> files) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_filesSelected_List(nativeId(), files);
    }
    private native static void __qt_filesSelected_List(long __this__nativeId, java.util.List<java.lang.String> files);

    public final Signal1<java.lang.String> filterSelected = new Signal1<java.lang.String>();

    @SuppressWarnings("unused")
    private final void filterSelected(java.lang.String filter) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_filterSelected_String(nativeId(), filter);
    }
    private native static void __qt_filterSelected_String(long __this__nativeId, java.lang.String filter);

    public QFileDialog(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        super((QPrivateConstructor)null);
        __qt_QFileDialog_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native void __qt_QFileDialog_QWidget_WindowFlags(long parent, int f);



    public QFileDialog(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String directory) {
        this(parent, caption, directory, (java.lang.String)"");
    }

    public QFileDialog(com.trolltech.qt.gui.QWidget parent, java.lang.String caption) {
        this(parent, caption, (java.lang.String)"", (java.lang.String)"");
    }

    public QFileDialog(com.trolltech.qt.gui.QWidget parent) {
        this(parent, (java.lang.String)"", (java.lang.String)"", (java.lang.String)"");
    }

    public QFileDialog() {
        this((com.trolltech.qt.gui.QWidget)null, (java.lang.String)"", (java.lang.String)"", (java.lang.String)"");
    }
    public QFileDialog(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String directory, java.lang.String filter) {
        super((QPrivateConstructor)null);
        __qt_QFileDialog_QWidget_String_String_String(parent == null ? 0 : parent.nativeId(), caption, directory, filter);
    }
    private native void __qt_QFileDialog_QWidget_String_String_String(long parent, java.lang.String caption, java.lang.String directory, java.lang.String filter);


    @com.trolltech.qt.QtPropertyReader(name="acceptMode")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFileDialog.AcceptMode acceptMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFileDialog.AcceptMode.resolve(__qt_acceptMode(nativeId()));
    }
    private native static int __qt_acceptMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="confirmOverwrite")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final boolean confirmOverwrite() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_confirmOverwrite(nativeId());
    }
    private native static boolean __qt_confirmOverwrite(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="defaultSuffix")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final java.lang.String defaultSuffix() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultSuffix(nativeId());
    }
    private native static java.lang.String __qt_defaultSuffix(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QDir directory() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_directory(nativeId());
    }
    private native static com.trolltech.qt.core.QDir __qt_directory(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="fileMode")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFileDialog.FileMode fileMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFileDialog.FileMode.resolve(__qt_fileMode(nativeId()));
    }
    private native static int __qt_fileMode(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.String> filters() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_filters(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_filters(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.String> history() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_history(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_history(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFileIconProvider iconProvider() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconProvider(nativeId());
    }
    private native static com.trolltech.qt.gui.QFileIconProvider __qt_iconProvider(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="readOnly")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean isReadOnly() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadOnly(nativeId());
    }
    private native static boolean __qt_isReadOnly(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractItemDelegate itemDelegate() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_itemDelegate(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractItemDelegate __qt_itemDelegate(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String labelText(com.trolltech.qt.gui.QFileDialog.DialogLabel label) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_labelText_DialogLabel(nativeId(), label.value());
    }
    private native static java.lang.String __qt_labelText_DialogLabel(long __this__nativeId, int label);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractProxyModel proxyModel() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_proxyModel(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractProxyModel __qt_proxyModel(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="resolveSymlinks")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final boolean resolveSymlinks() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolveSymlinks(nativeId());
    }
    private native static boolean __qt_resolveSymlinks(long __this__nativeId);

    @QtBlockedSlot public final boolean restoreState(com.trolltech.qt.core.QByteArray state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_restoreState_QByteArray(nativeId(), state == null ? (state = new com.trolltech.qt.core.QByteArray()).nativeId() : state.nativeId());
    }
    private native static boolean __qt_restoreState_QByteArray(long __this__nativeId, long state);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray saveState() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saveState(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_saveState(long __this__nativeId);

    @QtBlockedSlot public final void selectFile(java.lang.String filename) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectFile_String(nativeId(), filename);
    }
    private native static void __qt_selectFile_String(long __this__nativeId, java.lang.String filename);

    @QtBlockedSlot public final void selectFilter(java.lang.String filter) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectFilter_String(nativeId(), filter);
    }
    private native static void __qt_selectFilter_String(long __this__nativeId, java.lang.String filter);

    @QtBlockedSlot public final java.util.List<java.lang.String> selectedFiles() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedFiles(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_selectedFiles(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String selectedFilter() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedFilter(nativeId());
    }
    private native static java.lang.String __qt_selectedFilter(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="acceptMode")
    @QtBlockedSlot public final void setAcceptMode(com.trolltech.qt.gui.QFileDialog.AcceptMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAcceptMode_AcceptMode(nativeId(), mode.value());
    }
    private native static void __qt_setAcceptMode_AcceptMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="confirmOverwrite")
    @QtBlockedSlot public final void setConfirmOverwrite(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setConfirmOverwrite_boolean(nativeId(), enabled);
    }
    private native static void __qt_setConfirmOverwrite_boolean(long __this__nativeId, boolean enabled);

    @com.trolltech.qt.QtPropertyWriter(name="defaultSuffix")
    @QtBlockedSlot public final void setDefaultSuffix(java.lang.String suffix) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultSuffix_String(nativeId(), suffix);
    }
    private native static void __qt_setDefaultSuffix_String(long __this__nativeId, java.lang.String suffix);

    @QtBlockedSlot public final void setDirectory(java.lang.String directory) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirectory_String(nativeId(), directory);
    }
    private native static void __qt_setDirectory_String(long __this__nativeId, java.lang.String directory);

    @QtBlockedSlot public final void setDirectory(com.trolltech.qt.core.QDir directory) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirectory_QDir(nativeId(), directory == null ? 0 : directory.nativeId());
    }
    private native static void __qt_setDirectory_QDir(long __this__nativeId, long directory);

    @com.trolltech.qt.QtPropertyWriter(name="fileMode")
    @QtBlockedSlot public final void setFileMode(com.trolltech.qt.gui.QFileDialog.FileMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileMode_FileMode(nativeId(), mode.value());
    }
    private native static void __qt_setFileMode_FileMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setFilter(java.lang.String filter) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFilter_String(nativeId(), filter);
    }
    private native static void __qt_setFilter_String(long __this__nativeId, java.lang.String filter);

    @QtBlockedSlot public final void setFilters(java.util.List<java.lang.String> filters) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFilters_List(nativeId(), filters);
    }
    private native static void __qt_setFilters_List(long __this__nativeId, java.util.List<java.lang.String> filters);

    @QtBlockedSlot public final void setHistory(java.util.List<java.lang.String> paths) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHistory_List(nativeId(), paths);
    }
    private native static void __qt_setHistory_List(long __this__nativeId, java.util.List<java.lang.String> paths);

    @QtBlockedSlot public final void setIconProvider(com.trolltech.qt.gui.QFileIconProvider provider) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcIconProvider = provider;
        }
        __qt_setIconProvider_QFileIconProvider(nativeId(), provider == null ? 0 : provider.nativeId());
    }
    private native static void __qt_setIconProvider_QFileIconProvider(long __this__nativeId, long provider);

    @QtBlockedSlot public final void setItemDelegate(com.trolltech.qt.gui.QAbstractItemDelegate delegate) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcItemDelegate = delegate;
        }
        __qt_setItemDelegate_QAbstractItemDelegate(nativeId(), delegate == null ? 0 : delegate.nativeId());
    }
    private native static void __qt_setItemDelegate_QAbstractItemDelegate(long __this__nativeId, long delegate);

    @QtBlockedSlot public final void setLabelText(com.trolltech.qt.gui.QFileDialog.DialogLabel label, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLabelText_DialogLabel_String(nativeId(), label.value(), text);
    }
    private native static void __qt_setLabelText_DialogLabel_String(long __this__nativeId, int label, java.lang.String text);

    @QtBlockedSlot public final void setProxyModel(com.trolltech.qt.gui.QAbstractProxyModel model) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProxyModel_QAbstractProxyModel(nativeId(), model == null ? 0 : model.nativeId());
    }
    private native static void __qt_setProxyModel_QAbstractProxyModel(long __this__nativeId, long model);

    @com.trolltech.qt.QtPropertyWriter(name="readOnly")
    @QtBlockedSlot public final void setReadOnly(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadOnly_boolean(nativeId(), enabled);
    }
    private native static void __qt_setReadOnly_boolean(long __this__nativeId, boolean enabled);

    @com.trolltech.qt.QtPropertyWriter(name="resolveSymlinks")
    @QtBlockedSlot public final void setResolveSymlinks(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResolveSymlinks_boolean(nativeId(), enabled);
    }
    private native static void __qt_setResolveSymlinks_boolean(long __this__nativeId, boolean enabled);

    @QtBlockedSlot public final void setSidebarUrls(java.util.List<com.trolltech.qt.core.QUrl> urls) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSidebarUrls_List(nativeId(), urls);
    }
    private native static void __qt_setSidebarUrls_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QUrl> urls);

    @com.trolltech.qt.QtPropertyWriter(name="viewMode")
    @QtBlockedSlot public final void setViewMode(com.trolltech.qt.gui.QFileDialog.ViewMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewMode_ViewMode(nativeId(), mode.value());
    }
    private native static void __qt_setViewMode_ViewMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QUrl> sidebarUrls() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sidebarUrls(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.core.QUrl> __qt_sidebarUrls(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="viewMode")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFileDialog.ViewMode viewMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFileDialog.ViewMode.resolve(__qt_viewMode(nativeId()));
    }
    private native static int __qt_viewMode(long __this__nativeId);

    @QtBlockedSlot public void accept() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_accept(nativeId());
    }
    private native static void __qt_accept(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public void done(int result) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_done_int(nativeId(), result);
    }
    private native static void __qt_done_int(long __this__nativeId, int result);


    public static java.lang.String getExistingDirectory(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, com.trolltech.qt.gui.QFileDialog.Option ... options) {
        return com.trolltech.qt.gui.QFileDialog.getExistingDirectory(parent, caption, dir, new com.trolltech.qt.gui.QFileDialog.Options(options));
    }

    public static java.lang.String getExistingDirectory(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir) {
        return getExistingDirectory(parent, caption, dir, new com.trolltech.qt.gui.QFileDialog.Options(1));
    }

    public static java.lang.String getExistingDirectory(com.trolltech.qt.gui.QWidget parent, java.lang.String caption) {
        return getExistingDirectory(parent, caption, (java.lang.String)"", new com.trolltech.qt.gui.QFileDialog.Options(1));
    }

    public static java.lang.String getExistingDirectory(com.trolltech.qt.gui.QWidget parent) {
        return getExistingDirectory(parent, (java.lang.String)"", (java.lang.String)"", new com.trolltech.qt.gui.QFileDialog.Options(1));
    }

    public static java.lang.String getExistingDirectory() {
        return getExistingDirectory((com.trolltech.qt.gui.QWidget)null, (java.lang.String)"", (java.lang.String)"", new com.trolltech.qt.gui.QFileDialog.Options(1));
    }
    public static java.lang.String getExistingDirectory(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, com.trolltech.qt.gui.QFileDialog.Options options) {
        return __qt_getExistingDirectory_QWidget_String_String_Options(parent == null ? 0 : parent.nativeId(), caption, dir, options.value());
    }
    private native static java.lang.String __qt_getExistingDirectory_QWidget_String_String_Options(long parent, java.lang.String caption, java.lang.String dir, int options);


    @SuppressWarnings("unused")
    private static java.lang.String getOpenFileName(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Option ... options) {
        return com.trolltech.qt.gui.QFileDialog.getOpenFileName(parent, caption, dir, filter, selectedFilter, new com.trolltech.qt.gui.QFileDialog.Options(options));
    }
    @SuppressWarnings("unused")
    private static java.lang.String getOpenFileName(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Options options) {
        return __qt_getOpenFileName_QWidget_String_String_String_nativepointer_Options(parent == null ? 0 : parent.nativeId(), caption, dir, filter, selectedFilter, options.value());
    }
    private native static java.lang.String __qt_getOpenFileName_QWidget_String_String_String_nativepointer_Options(long parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, int options);


    @SuppressWarnings("unused")
    private static java.util.List<java.lang.String> getOpenFileNames(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Option ... options) {
        return com.trolltech.qt.gui.QFileDialog.getOpenFileNames(parent, caption, dir, filter, selectedFilter, new com.trolltech.qt.gui.QFileDialog.Options(options));
    }
    @SuppressWarnings("unused")
    private static java.util.List<java.lang.String> getOpenFileNames(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Options options) {
        return __qt_getOpenFileNames_QWidget_String_String_String_nativepointer_Options(parent == null ? 0 : parent.nativeId(), caption, dir, filter, selectedFilter, options.value());
    }
    private native static java.util.List<java.lang.String> __qt_getOpenFileNames_QWidget_String_String_String_nativepointer_Options(long parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, int options);


    @SuppressWarnings("unused")
    private static java.lang.String getSaveFileName(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Option ... options) {
        return com.trolltech.qt.gui.QFileDialog.getSaveFileName(parent, caption, dir, filter, selectedFilter, new com.trolltech.qt.gui.QFileDialog.Options(options));
    }
    @SuppressWarnings("unused")
    private static java.lang.String getSaveFileName(com.trolltech.qt.gui.QWidget parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, com.trolltech.qt.gui.QFileDialog.Options options) {
        return __qt_getSaveFileName_QWidget_String_String_String_nativepointer_Options(parent == null ? 0 : parent.nativeId(), caption, dir, filter, selectedFilter, options.value());
    }
    private native static java.lang.String __qt_getSaveFileName_QWidget_String_String_String_nativepointer_Options(long parent, java.lang.String caption, java.lang.String dir, java.lang.String filter, com.trolltech.qt.QNativePointer selectedFilter, int options);


    public static native QFileDialog fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QFileDialog(QPrivateConstructor p) { super(p); } 


        public static class Filter {
            public Filter(String filter) {
                this.filter = filter;
            }
            public String filter;
            public String selectedFilter = "";
        };    
    

        // TEMPLATE - gui.filedialog_get_xxx_filename - START
        public static String getOpenFileName(QWidget parent, String caption, String dir, Filter filter, Options options) {
            QNativePointer np = filter != null ? new QNativePointer(QNativePointer.Type.String) : null;
            String returned = getOpenFileName(parent, caption, dir, filter != null ? filter.filter : "", np, options);
            if (filter != null) 
                filter.selectedFilter = np.stringValue();
            return returned;
        }
        
        public static String getOpenFileName(QWidget parent, String caption, String dir, Filter filter, Option ... options) {
            return getOpenFileName(parent, caption, dir, filter, new Options(options));
        }
        
        public static String getOpenFileName(QWidget parent, String caption, String dir, Filter filter) {
            return getOpenFileName(parent, caption, dir, filter, new Options(0));
        }

        public static String getOpenFileName(QWidget parent, String caption, String dir) {
            return getOpenFileName(parent, caption, dir, null);
        }
        
        public static String getOpenFileName(QWidget parent, String caption) {
            return getOpenFileName(parent, caption, "");
        }

        public static String getOpenFileName(QWidget parent) {
            return getOpenFileName(parent, "");
        }

        public static String getOpenFileName() {
            return getOpenFileName(null);
        }
                
    // TEMPLATE - gui.filedialog_get_xxx_filename - END
    

        // TEMPLATE - gui.filedialog_get_xxx_filename - START
        public static java.util.List<String> getOpenFileNames(QWidget parent, String caption, String dir, Filter filter, Options options) {
            QNativePointer np = filter != null ? new QNativePointer(QNativePointer.Type.String) : null;
            java.util.List<String> returned = getOpenFileNames(parent, caption, dir, filter != null ? filter.filter : "", np, options);
            if (filter != null) 
                filter.selectedFilter = np.stringValue();
            return returned;
        }
        
        public static java.util.List<String> getOpenFileNames(QWidget parent, String caption, String dir, Filter filter, Option ... options) {
            return getOpenFileNames(parent, caption, dir, filter, new Options(options));
        }
        
        public static java.util.List<String> getOpenFileNames(QWidget parent, String caption, String dir, Filter filter) {
            return getOpenFileNames(parent, caption, dir, filter, new Options(0));
        }

        public static java.util.List<String> getOpenFileNames(QWidget parent, String caption, String dir) {
            return getOpenFileNames(parent, caption, dir, null);
        }
        
        public static java.util.List<String> getOpenFileNames(QWidget parent, String caption) {
            return getOpenFileNames(parent, caption, "");
        }

        public static java.util.List<String> getOpenFileNames(QWidget parent) {
            return getOpenFileNames(parent, "");
        }

        public static java.util.List<String> getOpenFileNames() {
            return getOpenFileNames(null);
        }
                
    // TEMPLATE - gui.filedialog_get_xxx_filename - END
    

        // TEMPLATE - gui.filedialog_get_xxx_filename - START
        public static String getSaveFileName(QWidget parent, String caption, String dir, Filter filter, Options options) {
            QNativePointer np = filter != null ? new QNativePointer(QNativePointer.Type.String) : null;
            String returned = getSaveFileName(parent, caption, dir, filter != null ? filter.filter : "", np, options);
            if (filter != null) 
                filter.selectedFilter = np.stringValue();
            return returned;
        }
        
        public static String getSaveFileName(QWidget parent, String caption, String dir, Filter filter, Option ... options) {
            return getSaveFileName(parent, caption, dir, filter, new Options(options));
        }
        
        public static String getSaveFileName(QWidget parent, String caption, String dir, Filter filter) {
            return getSaveFileName(parent, caption, dir, filter, new Options(0));
        }

        public static String getSaveFileName(QWidget parent, String caption, String dir) {
            return getSaveFileName(parent, caption, dir, null);
        }
        
        public static String getSaveFileName(QWidget parent, String caption) {
            return getSaveFileName(parent, caption, "");
        }

        public static String getSaveFileName(QWidget parent) {
            return getSaveFileName(parent, "");
        }

        public static String getSaveFileName() {
            return getSaveFileName(null);
        }
                
    // TEMPLATE - gui.filedialog_get_xxx_filename - END
    
}
