package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFontComboBox extends com.trolltech.qt.gui.QComboBox
{
    public enum FontFilter implements com.trolltech.qt.QtEnumerator {
        AllFonts(0),
        ScalableFonts(1),
        NonScalableFonts(2),
        MonospacedFonts(4),
        ProportionalFonts(8);

        FontFilter(int value) { this.value = value; }
        public int value() { return value; }

        public static FontFilters createQFlags(FontFilter ... values) {
            return new FontFilters(values);
        }
        public static FontFilter resolve(int value) {
            return (FontFilter) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AllFonts;
            case 1: return ScalableFonts;
            case 2: return NonScalableFonts;
            case 4: return MonospacedFonts;
            case 8: return ProportionalFonts;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FontFilters extends com.trolltech.qt.QFlags<FontFilter> {
        private static final long serialVersionUID = 1L;
        public FontFilters(FontFilter ... args) { super(args); }
        public FontFilters(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.gui.QFont> currentFontChanged = new Signal1<com.trolltech.qt.gui.QFont>();

    @SuppressWarnings("unused")
    private final void currentFontChanged(com.trolltech.qt.gui.QFont f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentFontChanged_QFont(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId());
    }
    private native static void __qt_currentFontChanged_QFont(long __this__nativeId, long f);


    public QFontComboBox() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QFontComboBox(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QFontComboBox_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QFontComboBox_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="currentFont")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFont currentFont() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentFont(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_currentFont(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="fontFilters")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFontComboBox.FontFilters fontFilters() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QFontComboBox.FontFilters(__qt_fontFilters(nativeId()));
    }
    private native static int __qt_fontFilters(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="currentFont")
    public final void setCurrentFont(com.trolltech.qt.gui.QFont f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentFont_QFont(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId());
    }
    private native static void __qt_setCurrentFont_QFont(long __this__nativeId, long f);


    @QtBlockedSlot public final void setFontFilters(com.trolltech.qt.gui.QFontComboBox.FontFilter ... filters) {
        this.setFontFilters(new com.trolltech.qt.gui.QFontComboBox.FontFilters(filters));
    }
    @com.trolltech.qt.QtPropertyWriter(name="fontFilters")
    @QtBlockedSlot public final void setFontFilters(com.trolltech.qt.gui.QFontComboBox.FontFilters filters) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontFilters_FontFilters(nativeId(), filters.value());
    }
    private native static void __qt_setFontFilters_FontFilters(long __this__nativeId, int filters);

    @com.trolltech.qt.QtPropertyWriter(name="writingSystem")
    @QtBlockedSlot public final void setWritingSystem(com.trolltech.qt.gui.QFontDatabase.WritingSystem arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWritingSystem_WritingSystem(nativeId(), arg__1.value());
    }
    private native static void __qt_setWritingSystem_WritingSystem(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyReader(name="writingSystem")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFontDatabase.WritingSystem writingSystem() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFontDatabase.WritingSystem.resolve(__qt_writingSystem(nativeId()));
    }
    private native static int __qt_writingSystem(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QFontComboBox fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QFontComboBox(QPrivateConstructor p) { super(p); } 

}
