package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFontDatabase extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum WritingSystem implements com.trolltech.qt.QtEnumerator {
        Any(0),
        Latin(1),
        Greek(2),
        Cyrillic(3),
        Armenian(4),
        Hebrew(5),
        Arabic(6),
        Syriac(7),
        Thaana(8),
        Devanagari(9),
        Bengali(10),
        Gurmukhi(11),
        Gujarati(12),
        Oriya(13),
        Tamil(14),
        Telugu(15),
        Kannada(16),
        Malayalam(17),
        Sinhala(18),
        Thai(19),
        Lao(20),
        Tibetan(21),
        Myanmar(22),
        Georgian(23),
        Khmer(24),
        SimplifiedChinese(25),
        TraditionalChinese(26),
        Japanese(27),
        Korean(28),
        Vietnamese(29),
        Symbol(30),
        Ogham(31),
        Runic(32),
        WritingSystemsCount(33);

        WritingSystem(int value) { this.value = value; }
        public int value() { return value; }

        public static WritingSystem resolve(int value) {
            return (WritingSystem) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Any;
            case 1: return Latin;
            case 2: return Greek;
            case 3: return Cyrillic;
            case 4: return Armenian;
            case 5: return Hebrew;
            case 6: return Arabic;
            case 7: return Syriac;
            case 8: return Thaana;
            case 9: return Devanagari;
            case 10: return Bengali;
            case 11: return Gurmukhi;
            case 12: return Gujarati;
            case 13: return Oriya;
            case 14: return Tamil;
            case 15: return Telugu;
            case 16: return Kannada;
            case 17: return Malayalam;
            case 18: return Sinhala;
            case 19: return Thai;
            case 20: return Lao;
            case 21: return Tibetan;
            case 22: return Myanmar;
            case 23: return Georgian;
            case 24: return Khmer;
            case 25: return SimplifiedChinese;
            case 26: return TraditionalChinese;
            case 27: return Japanese;
            case 28: return Korean;
            case 29: return Vietnamese;
            case 30: return Symbol;
            case 31: return Ogham;
            case 32: return Runic;
            case 33: return WritingSystemsCount;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QFontDatabase() {
        super((QPrivateConstructor)null);
        __qt_QFontDatabase();
    }
    private native void __qt_QFontDatabase();


    @QtBlockedSlot public final boolean bold(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bold_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_bold_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);


    @QtBlockedSlot public final java.util.List<java.lang.String> families() {
        return families(com.trolltech.qt.gui.QFontDatabase.WritingSystem.Any);
    }
    @QtBlockedSlot public final java.util.List<java.lang.String> families(com.trolltech.qt.gui.QFontDatabase.WritingSystem writingSystem) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_families_WritingSystem(nativeId(), writingSystem.value());
    }
    private native static java.util.List<java.lang.String> __qt_families_WritingSystem(long __this__nativeId, int writingSystem);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font(java.lang.String family, java.lang.String style, int pointSize) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font_String_String_int(nativeId(), family, style, pointSize);
    }
    private native static com.trolltech.qt.gui.QFont __qt_font_String_String_int(long __this__nativeId, java.lang.String family, java.lang.String style, int pointSize);


    @QtBlockedSlot public final boolean isBitmapScalable(java.lang.String family) {
        return isBitmapScalable(family, (java.lang.String)"");
    }
    @QtBlockedSlot public final boolean isBitmapScalable(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isBitmapScalable_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_isBitmapScalable_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);


    @QtBlockedSlot public final boolean isFixedPitch(java.lang.String family) {
        return isFixedPitch(family, (java.lang.String)"");
    }
    @QtBlockedSlot public final boolean isFixedPitch(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFixedPitch_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_isFixedPitch_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);


    @QtBlockedSlot public final boolean isScalable(java.lang.String family) {
        return isScalable(family, (java.lang.String)"");
    }
    @QtBlockedSlot public final boolean isScalable(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isScalable_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_isScalable_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);


    @QtBlockedSlot public final boolean isSmoothlyScalable(java.lang.String family) {
        return isSmoothlyScalable(family, (java.lang.String)"");
    }
    @QtBlockedSlot public final boolean isSmoothlyScalable(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSmoothlyScalable_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_isSmoothlyScalable_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);

    @QtBlockedSlot public final boolean italic(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_italic_String_String(nativeId(), family, style);
    }
    private native static boolean __qt_italic_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);


    @QtBlockedSlot public final java.util.List<java.lang.Integer> pointSizes(java.lang.String family) {
        return pointSizes(family, (java.lang.String)"");
    }
    @QtBlockedSlot public final java.util.List<java.lang.Integer> pointSizes(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pointSizes_String_String(nativeId(), family, style);
    }
    private native static java.util.List<java.lang.Integer> __qt_pointSizes_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);

    @QtBlockedSlot public final java.util.List<java.lang.Integer> smoothSizes(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_smoothSizes_String_String(nativeId(), family, style);
    }
    private native static java.util.List<java.lang.Integer> __qt_smoothSizes_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);

    @QtBlockedSlot public final java.lang.String styleString(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_styleString_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static java.lang.String __qt_styleString_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final java.lang.String styleString(com.trolltech.qt.gui.QFontInfo fontInfo) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_styleString_QFontInfo(nativeId(), fontInfo == null ? 0 : fontInfo.nativeId());
    }
    private native static java.lang.String __qt_styleString_QFontInfo(long __this__nativeId, long fontInfo);

    @QtBlockedSlot public final java.util.List<java.lang.String> styles(java.lang.String family) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_styles_String(nativeId(), family);
    }
    private native static java.util.List<java.lang.String> __qt_styles_String(long __this__nativeId, java.lang.String family);

    @QtBlockedSlot public final int weight(java.lang.String family, java.lang.String style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_weight_String_String(nativeId(), family, style);
    }
    private native static int __qt_weight_String_String(long __this__nativeId, java.lang.String family, java.lang.String style);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QFontDatabase.WritingSystem> writingSystems(java.lang.String family) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writingSystems_String(nativeId(), family);
    }
    private native static java.util.List<com.trolltech.qt.gui.QFontDatabase.WritingSystem> __qt_writingSystems_String(long __this__nativeId, java.lang.String family);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QFontDatabase.WritingSystem> writingSystems() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writingSystems(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QFontDatabase.WritingSystem> __qt_writingSystems(long __this__nativeId);

    public native static int addApplicationFont(java.lang.String fileName);

    public static int addApplicationFontFromData(com.trolltech.qt.core.QByteArray fontData) {
        return __qt_addApplicationFontFromData_QByteArray(fontData == null ? (fontData = new com.trolltech.qt.core.QByteArray()).nativeId() : fontData.nativeId());
    }
    private native static int __qt_addApplicationFontFromData_QByteArray(long fontData);

    public native static java.util.List<java.lang.String> applicationFontFamilies(int id);

    public native static boolean removeAllApplicationFonts();

    public native static boolean removeApplicationFont(int id);

    public native static java.util.List<java.lang.Integer> standardSizes();

    public static java.lang.String writingSystemName(com.trolltech.qt.gui.QFontDatabase.WritingSystem writingSystem) {
        return __qt_writingSystemName_WritingSystem(writingSystem.value());
    }
    private native static java.lang.String __qt_writingSystemName_WritingSystem(int writingSystem);

    public static java.lang.String writingSystemSample(com.trolltech.qt.gui.QFontDatabase.WritingSystem writingSystem) {
        return __qt_writingSystemSample_WritingSystem(writingSystem.value());
    }
    private native static java.lang.String __qt_writingSystemSample_WritingSystem(int writingSystem);


    public static native QFontDatabase fromNativePointer(QNativePointer nativePointer);

    protected QFontDatabase(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QFontDatabase array[]);
}
