package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFrame extends com.trolltech.qt.gui.QWidget
{
    public enum StyleMask implements com.trolltech.qt.QtEnumerator {
        Shadow_Mask(240),
        Shape_Mask(15);

        StyleMask(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleMask resolve(int value) {
            return (StyleMask) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 240: return Shadow_Mask;
            case 15: return Shape_Mask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Shape implements com.trolltech.qt.QtEnumerator {
        NoFrame(0),
        Box(1),
        Panel(2),
        WinPanel(3),
        HLine(4),
        VLine(5),
        StyledPanel(6);

        Shape(int value) { this.value = value; }
        public int value() { return value; }

        public static Shape resolve(int value) {
            return (Shape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoFrame;
            case 1: return Box;
            case 2: return Panel;
            case 3: return WinPanel;
            case 4: return HLine;
            case 5: return VLine;
            case 6: return StyledPanel;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Shadow implements com.trolltech.qt.QtEnumerator {
        Plain(16),
        Raised(32),
        Sunken(48),
        CustomEnum(0);

        Shadow(int value) { this.value = value; }
        public int value() { return value; }

        public static Shadow resolve(int value) {
            return (Shadow) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 16: return Plain;
            case 32: return Raised;
            case 48: return Sunken;
            }
            if (enumCache == null)
                enumCache = new java.util.HashMap<Integer, Shadow>();
            Shadow e = enumCache.get(value);
            if (e == null) {
                e = (Shadow) com.trolltech.qt.QtJambiInternal.createExtendedEnum(value, CustomEnum.ordinal(), Shadow.class, CustomEnum.name());
                enumCache.put(value, e);
            }
            return e;
        }
        private final int value;

        private static java.util.HashMap<Integer, Shadow> enumCache;    }


    public QFrame(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QFrame() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QFrame(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        super((QPrivateConstructor)null);
        __qt_QFrame_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native void __qt_QFrame_QWidget_WindowFlags(long parent, int f);


    @QtBlockedSlot protected final void drawFrame(com.trolltech.qt.gui.QPainter arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawFrame_QPainter(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_drawFrame_QPainter(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyReader(name="frameRect")
    @com.trolltech.qt.QtPropertyOrder(5)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final com.trolltech.qt.core.QRect frameRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_frameRect(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frameShadow")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFrame.Shadow frameShadow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFrame.Shadow.resolve(__qt_frameShadow(nativeId()));
    }
    private native static int __qt_frameShadow(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frameShape")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFrame.Shape frameShape() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QFrame.Shape.resolve(__qt_frameShape(nativeId()));
    }
    private native static int __qt_frameShape(long __this__nativeId);

    @QtBlockedSlot public final int frameStyle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameStyle(nativeId());
    }
    private native static int __qt_frameStyle(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frameWidth")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final int frameWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameWidth(nativeId());
    }
    private native static int __qt_frameWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="lineWidth")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int lineWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineWidth(nativeId());
    }
    private native static int __qt_lineWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="midLineWidth")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int midLineWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_midLineWidth(nativeId());
    }
    private native static int __qt_midLineWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="frameRect")
    @QtBlockedSlot public final void setFrameRect(com.trolltech.qt.core.QRect arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrameRect_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setFrameRect_QRect(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="frameShadow")
    @QtBlockedSlot public final void setFrameShadow(com.trolltech.qt.gui.QFrame.Shadow arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrameShadow_Shadow(nativeId(), arg__1.value());
    }
    private native static void __qt_setFrameShadow_Shadow(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="frameShape")
    @QtBlockedSlot public final void setFrameShape(com.trolltech.qt.gui.QFrame.Shape arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrameShape_Shape(nativeId(), arg__1.value());
    }
    private native static void __qt_setFrameShape_Shape(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setFrameStyle(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFrameStyle_int(nativeId(), arg__1);
    }
    private native static void __qt_setFrameStyle_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="lineWidth")
    @QtBlockedSlot public final void setLineWidth(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWidth_int(nativeId(), arg__1);
    }
    private native static void __qt_setLineWidth_int(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="midLineWidth")
    @QtBlockedSlot public final void setMidLineWidth(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMidLineWidth_int(nativeId(), arg__1);
    }
    private native static void __qt_setMidLineWidth_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QFrame fromNativePointer(QNativePointer nativePointer);

    protected QFrame(QPrivateConstructor p) { super(p); } 

}
