package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QGradient extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum CoordinateMode implements com.trolltech.qt.QtEnumerator {
        LogicalMode(0),
        StretchToDeviceMode(1),
        ObjectBoundingMode(2);

        CoordinateMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CoordinateMode resolve(int value) {
            return (CoordinateMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LogicalMode;
            case 1: return StretchToDeviceMode;
            case 2: return ObjectBoundingMode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Spread implements com.trolltech.qt.QtEnumerator {
        PadSpread(0),
        ReflectSpread(1),
        RepeatSpread(2);

        Spread(int value) { this.value = value; }
        public int value() { return value; }

        public static Spread resolve(int value) {
            return (Spread) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return PadSpread;
            case 1: return ReflectSpread;
            case 2: return RepeatSpread;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Type implements com.trolltech.qt.QtEnumerator {
        LinearGradient(0),
        RadialGradient(1),
        ConicalGradient(2),
        NoGradient(3);

        Type(int value) { this.value = value; }
        public int value() { return value; }

        public static Type resolve(int value) {
            return (Type) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return LinearGradient;
            case 1: return RadialGradient;
            case 2: return ConicalGradient;
            case 3: return NoGradient;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QGradient() {
        super((QPrivateConstructor)null);
        __qt_QGradient();
    }
    private native void __qt_QGradient();


    @QtBlockedSlot public final com.trolltech.qt.gui.QGradient.CoordinateMode coordinateMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGradient.CoordinateMode.resolve(__qt_coordinateMode(nativeId()));
    }
    private native static int __qt_coordinateMode(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QGradient gradient) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QGradient(nativeId(), gradient.nativeId());
    }
    private native static boolean __qt_operator_equal_QGradient(long __this__nativeId, long gradient);

    @QtBlockedSlot public final void setColorAt(double pos, com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColorAt_double_QColor(nativeId(), pos, color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setColorAt_double_QColor(long __this__nativeId, double pos, long color);

    @QtBlockedSlot public final void setCoordinateMode(com.trolltech.qt.gui.QGradient.CoordinateMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCoordinateMode_CoordinateMode(nativeId(), mode.value());
    }
    private native static void __qt_setCoordinateMode_CoordinateMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setSpread(com.trolltech.qt.gui.QGradient.Spread spread) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSpread_Spread(nativeId(), spread.value());
    }
    private native static void __qt_setSpread_Spread(long __this__nativeId, int spread);

    @QtBlockedSlot public final void setStops(java.util.List<com.trolltech.qt.QPair<java.lang.Double, com.trolltech.qt.gui.QColor>> stops) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStops_List(nativeId(), stops);
    }
    private native static void __qt_setStops_List(long __this__nativeId, java.util.List<com.trolltech.qt.QPair<java.lang.Double, com.trolltech.qt.gui.QColor>> stops);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGradient.Spread spread() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGradient.Spread.resolve(__qt_spread(nativeId()));
    }
    private native static int __qt_spread(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.QPair<java.lang.Double, com.trolltech.qt.gui.QColor>> stops() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stops(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.QPair<java.lang.Double, com.trolltech.qt.gui.QColor>> __qt_stops(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGradient.Type type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGradient.Type.resolve(__qt_type(nativeId()));
    }
    private native static int __qt_type(long __this__nativeId);


    public static native QGradient fromNativePointer(QNativePointer nativePointer);

    protected QGradient(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QGradient array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QGradient)
            return operator_equal((com.trolltech.qt.gui.QGradient) other);
        return false;
    }

}
