package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGraphicsSceneContextMenuEvent extends com.trolltech.qt.gui.QGraphicsSceneEvent
{
    public enum Reason implements com.trolltech.qt.QtEnumerator {
        Mouse(0),
        Keyboard(1),
        Other(2);

        Reason(int value) { this.value = value; }
        public int value() { return value; }

        public static Reason resolve(int value) {
            return (Reason) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Mouse;
            case 1: return Keyboard;
            case 2: return Other;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QGraphicsSceneContextMenuEvent() {
        this(com.trolltech.qt.core.QEvent.Type.None);
    }
    public QGraphicsSceneContextMenuEvent(com.trolltech.qt.core.QEvent.Type type) {
        super((QPrivateConstructor)null);
        __qt_QGraphicsSceneContextMenuEvent_Type(type.value());
    }
    private native void __qt_QGraphicsSceneContextMenuEvent_Type(int type);


    @QtBlockedSlot public final com.trolltech.qt.core.Qt.KeyboardModifiers modifiers() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.KeyboardModifiers(__qt_modifiers(nativeId()));
    }
    private native static int __qt_modifiers(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_pos(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QGraphicsSceneContextMenuEvent.Reason reason() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QGraphicsSceneContextMenuEvent.Reason.resolve(__qt_reason(nativeId()));
    }
    private native static int __qt_reason(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF scenePos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scenePos(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_scenePos(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint screenPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_screenPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_screenPos(long __this__nativeId);


    @QtBlockedSlot public final void setModifiers(com.trolltech.qt.core.Qt.KeyboardModifier ... modifiers) {
        this.setModifiers(new com.trolltech.qt.core.Qt.KeyboardModifiers(modifiers));
    }
    @QtBlockedSlot public final void setModifiers(com.trolltech.qt.core.Qt.KeyboardModifiers modifiers) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setModifiers_KeyboardModifiers(nativeId(), modifiers.value());
    }
    private native static void __qt_setModifiers_KeyboardModifiers(long __this__nativeId, int modifiers);

    @QtBlockedSlot public final void setPos(com.trolltech.qt.core.QPointF pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPos_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static void __qt_setPos_QPointF(long __this__nativeId, long pos);

    @QtBlockedSlot public final void setReason(com.trolltech.qt.gui.QGraphicsSceneContextMenuEvent.Reason reason) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReason_Reason(nativeId(), reason.value());
    }
    private native static void __qt_setReason_Reason(long __this__nativeId, int reason);

    @QtBlockedSlot public final void setScenePos(com.trolltech.qt.core.QPointF pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScenePos_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static void __qt_setScenePos_QPointF(long __this__nativeId, long pos);

    @QtBlockedSlot public final void setScreenPos(com.trolltech.qt.core.QPoint pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScreenPos_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static void __qt_setScreenPos_QPoint(long __this__nativeId, long pos);


    public static native QGraphicsSceneContextMenuEvent fromNativePointer(QNativePointer nativePointer);

    protected QGraphicsSceneContextMenuEvent(QPrivateConstructor p) { super(p); } 

}
