package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QImage extends com.trolltech.qt.QtJambiObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum InvertMode implements com.trolltech.qt.QtEnumerator {
        InvertRgb(0),
        InvertRgba(1);

        InvertMode(int value) { this.value = value; }
        public int value() { return value; }

        public static InvertMode resolve(int value) {
            return (InvertMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return InvertRgb;
            case 1: return InvertRgba;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Format implements com.trolltech.qt.QtEnumerator {
        Format_Invalid(0),
        Format_Mono(1),
        Format_MonoLSB(2),
        Format_Indexed8(3),
        Format_RGB32(4),
        Format_ARGB32(5),
        Format_ARGB32_Premultiplied(6),
        Format_RGB16(7),
        NImageFormats(8);

        Format(int value) { this.value = value; }
        public int value() { return value; }

        public static Format resolve(int value) {
            return (Format) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Format_Invalid;
            case 1: return Format_Mono;
            case 2: return Format_MonoLSB;
            case 3: return Format_Indexed8;
            case 4: return Format_RGB32;
            case 5: return Format_ARGB32;
            case 6: return Format_ARGB32_Premultiplied;
            case 7: return Format_RGB16;
            case 8: return NImageFormats;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QImage(com.trolltech.qt.QNativePointer data, int width, int height, int bytesPerLine, com.trolltech.qt.gui.QImage.Format format) {
        super((QPrivateConstructor)null);
        __qt_QImage_nativepointer_int_int_int_Format(data, width, height, bytesPerLine, format.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_nativepointer_int_int_int_Format(com.trolltech.qt.QNativePointer data, int width, int height, int bytesPerLine, int format);


    public QImage(int width, int height, com.trolltech.qt.gui.QImage.Format format) {
        super((QPrivateConstructor)null);
        __qt_QImage_int_int_Format(width, height, format.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_int_int_Format(int width, int height, int format);


    @SuppressWarnings("unused")
    private QImage(java.lang.String fileName, com.trolltech.qt.QNativePointer format) {
        super((QPrivateConstructor)null);
        __qt_QImage_String_nativepointer(fileName, format);

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_String_nativepointer(java.lang.String fileName, com.trolltech.qt.QNativePointer format);


    @SuppressWarnings("unused")
    private QImage(com.trolltech.qt.QNativePointer xpm) {
        super((QPrivateConstructor)null);
        __qt_QImage_nativepointer(xpm);

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_nativepointer(com.trolltech.qt.QNativePointer xpm);


    @SuppressWarnings("unused")
    private QImage(com.trolltech.qt.QNativePointer data, int width, int height, com.trolltech.qt.gui.QImage.Format format) {
        super((QPrivateConstructor)null);
        __qt_QImage_nativepointer_int_int_Format(data, width, height, format.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_nativepointer_int_int_Format(com.trolltech.qt.QNativePointer data, int width, int height, int format);


    public QImage(com.trolltech.qt.gui.QImage arg__1) {
        super((QPrivateConstructor)null);
        __qt_QImage_QImage(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QImage()).nativeId() : arg__1.nativeId());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_QImage(long arg__1);


    public QImage() {
        super((QPrivateConstructor)null);
        __qt_QImage();

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage();


    public QImage(com.trolltech.qt.core.QSize size, com.trolltech.qt.gui.QImage.Format format) {
        super((QPrivateConstructor)null);
        __qt_QImage_QSize_Format(size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId(), format.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QImage.class, height()*bytesPerLine(), 67108864);
    }
    private native void __qt_QImage_QSize_Format(long size, int format);


    @QtBlockedSlot public final boolean allGray() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_allGray(nativeId());
    }
    private native static boolean __qt_allGray(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage alphaChannel() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alphaChannel(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_alphaChannel(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.QNativePointer bits() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bits(nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_bits(long __this__nativeId);

    @QtBlockedSlot public final int bytesPerLine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesPerLine(nativeId());
    }
    private native static int __qt_bytesPerLine(long __this__nativeId);

    @QtBlockedSlot public final long cacheKey() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cacheKey(nativeId());
    }
    private native static long __qt_cacheKey(long __this__nativeId);

    @QtBlockedSlot public final int color(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_color_int(nativeId(), i);
    }
    private native static int __qt_color_int(long __this__nativeId, int i);

    @QtBlockedSlot public final java.util.List<java.lang.Integer> colorTable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_colorTable(nativeId());
    }
    private native static java.util.List<java.lang.Integer> __qt_colorTable(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f, java.util.List<java.lang.Integer> colorTable, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        return this.convertToFormat(f, colorTable, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f, java.util.List<java.lang.Integer> colorTable) {
        return convertToFormat(f, colorTable, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f, java.util.List<java.lang.Integer> colorTable, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_convertToFormat_Format_List_ImageConversionFlags(nativeId(), f.value(), colorTable, flags.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_convertToFormat_Format_List_ImageConversionFlags(long __this__nativeId, int f, java.util.List<java.lang.Integer> colorTable, int flags);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        return this.convertToFormat(f, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f) {
        return convertToFormat(f, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage convertToFormat(com.trolltech.qt.gui.QImage.Format f, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_convertToFormat_Format_ImageConversionFlags(nativeId(), f.value(), flags.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_convertToFormat_Format_ImageConversionFlags(long __this__nativeId, int f, int flags);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage copy() {
        return copy((com.trolltech.qt.core.QRect)new com.trolltech.qt.core.QRect());
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage copy(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_copy_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_copy_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage copy(int x, int y, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_copy_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static com.trolltech.qt.gui.QImage __qt_copy_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createAlphaMask(com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        return this.createAlphaMask(new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createAlphaMask() {
        return createAlphaMask(new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createAlphaMask(com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createAlphaMask_ImageConversionFlags(nativeId(), flags.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_createAlphaMask_ImageConversionFlags(long __this__nativeId, int flags);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createHeuristicMask() {
        return createHeuristicMask((boolean)true);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createHeuristicMask(boolean clipTight) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createHeuristicMask_boolean(nativeId(), clipTight);
    }
    private native static com.trolltech.qt.gui.QImage __qt_createHeuristicMask_boolean(long __this__nativeId, boolean clipTight);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createMaskFromColor(int color) {
        return createMaskFromColor(color, com.trolltech.qt.core.Qt.MaskMode.MaskInColor);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage createMaskFromColor(int color, com.trolltech.qt.core.Qt.MaskMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createMaskFromColor_int_MaskMode(nativeId(), color, mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_createMaskFromColor_int_MaskMode(long __this__nativeId, int color, int mode);

    @QtBlockedSlot public final int depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final int dotsPerMeterX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dotsPerMeterX(nativeId());
    }
    private native static int __qt_dotsPerMeterX(long __this__nativeId);

    @QtBlockedSlot public final int dotsPerMeterY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dotsPerMeterY(nativeId());
    }
    private native static int __qt_dotsPerMeterY(long __this__nativeId);

    @QtBlockedSlot public final void fill(int pixel) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fill_int(nativeId(), pixel);
    }
    private native static void __qt_fill_int(long __this__nativeId, int pixel);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage.Format format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QImage.Format.resolve(__qt_format(nativeId()));
    }
    private native static int __qt_format(long __this__nativeId);

    @QtBlockedSlot public final boolean hasAlphaChannel() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasAlphaChannel(nativeId());
    }
    private native static boolean __qt_hasAlphaChannel(long __this__nativeId);

    @QtBlockedSlot public final int height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);


    @QtBlockedSlot public final void invertPixels() {
        invertPixels(com.trolltech.qt.gui.QImage.InvertMode.InvertRgb);
    }
    @QtBlockedSlot public final void invertPixels(com.trolltech.qt.gui.QImage.InvertMode arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_invertPixels_InvertMode(nativeId(), arg__1.value());
    }
    private native static void __qt_invertPixels_InvertMode(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final boolean isGrayscale() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isGrayscale(nativeId());
    }
    private native static boolean __qt_isGrayscale(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean load(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.QNativePointer format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_load_QIODevice_nativepointer(nativeId(), device == null ? 0 : device.nativeId(), format);
    }
    private native static boolean __qt_load_QIODevice_nativepointer(long __this__nativeId, long device, com.trolltech.qt.QNativePointer format);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean load(java.lang.String fileName, com.trolltech.qt.QNativePointer format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_load_String_nativepointer(nativeId(), fileName, format);
    }
    private native static boolean __qt_load_String_nativepointer(long __this__nativeId, java.lang.String fileName, com.trolltech.qt.QNativePointer format);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean loadFromData(com.trolltech.qt.core.QByteArray data, com.trolltech.qt.QNativePointer aformat) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loadFromData_QByteArray_nativepointer(nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), aformat);
    }
    private native static boolean __qt_loadFromData_QByteArray_nativepointer(long __this__nativeId, long data, com.trolltech.qt.QNativePointer aformat);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean loadFromData(com.trolltech.qt.QNativePointer buf, int len) {
        return loadFromData(buf, len, (com.trolltech.qt.QNativePointer)null);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean loadFromData(com.trolltech.qt.QNativePointer buf, int len, com.trolltech.qt.QNativePointer format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loadFromData_nativepointer_int_nativepointer(nativeId(), buf, len, format);
    }
    private native static boolean __qt_loadFromData_nativepointer_int_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer buf, int len, com.trolltech.qt.QNativePointer format);

    @QtBlockedSlot public final int logicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage mirrored(boolean horizontally) {
        return mirrored(horizontally, (boolean)true);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage mirrored() {
        return mirrored((boolean)false, (boolean)true);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage mirrored(boolean horizontally, boolean vertically) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mirrored_boolean_boolean(nativeId(), horizontally, vertically);
    }
    private native static com.trolltech.qt.gui.QImage __qt_mirrored_boolean_boolean(long __this__nativeId, boolean horizontally, boolean vertically);

    @QtBlockedSlot public final int numBytes() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numBytes(nativeId());
    }
    private native static int __qt_numBytes(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint offset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_offset(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_offset(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QImage arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QImage(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QImage()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_operator_equal_QImage(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final boolean paintingActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final int pixel(com.trolltech.qt.core.QPoint pt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixel_QPoint(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPoint()).nativeId() : pt.nativeId());
    }
    private native static int __qt_pixel_QPoint(long __this__nativeId, long pt);

    @QtBlockedSlot public final int pixel(int x, int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixel_int_int(nativeId(), x, y);
    }
    private native static int __qt_pixel_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final int pixelIndex(int x, int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixelIndex_int_int(nativeId(), x, y);
    }
    private native static int __qt_pixelIndex_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final int pixelIndex(com.trolltech.qt.core.QPoint pt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pixelIndex_QPoint(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPoint()).nativeId() : pt.nativeId());
    }
    private native static int __qt_pixelIndex_QPoint(long __this__nativeId, long pt);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect rect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_rect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage rgbSwapped() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rgbSwapped(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_rgbSwapped(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean private_save(java.lang.String fileName, com.trolltech.qt.QNativePointer format, int quality) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_private_save_String_nativepointer_int(nativeId(), fileName, format, quality);
    }
    private native static boolean __qt_private_save_String_nativepointer_int(long __this__nativeId, java.lang.String fileName, com.trolltech.qt.QNativePointer format, int quality);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean private_save(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.QNativePointer format, int quality) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_private_save_QIODevice_nativepointer_int(nativeId(), device == null ? 0 : device.nativeId(), format, quality);
    }
    private native static boolean __qt_private_save_QIODevice_nativepointer_int(long __this__nativeId, long device, com.trolltech.qt.QNativePointer format, int quality);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(int w, int h, com.trolltech.qt.core.Qt.AspectRatioMode aspectMode) {
        return scaled(w, h, aspectMode, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(int w, int h) {
        return scaled(w, h, com.trolltech.qt.core.Qt.AspectRatioMode.IgnoreAspectRatio, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(int w, int h, com.trolltech.qt.core.Qt.AspectRatioMode aspectMode, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaled_int_int_AspectRatioMode_TransformationMode(nativeId(), w, h, aspectMode.value(), mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_scaled_int_int_AspectRatioMode_TransformationMode(long __this__nativeId, int w, int h, int aspectMode, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(com.trolltech.qt.core.QSize s, com.trolltech.qt.core.Qt.AspectRatioMode aspectMode) {
        return scaled(s, aspectMode, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(com.trolltech.qt.core.QSize s) {
        return scaled(s, com.trolltech.qt.core.Qt.AspectRatioMode.IgnoreAspectRatio, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaled(com.trolltech.qt.core.QSize s, com.trolltech.qt.core.Qt.AspectRatioMode aspectMode, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaled_QSize_AspectRatioMode_TransformationMode(nativeId(), s == null ? (s = new com.trolltech.qt.core.QSize()).nativeId() : s.nativeId(), aspectMode.value(), mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_scaled_QSize_AspectRatioMode_TransformationMode(long __this__nativeId, long s, int aspectMode, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaledToHeight(int h) {
        return scaledToHeight(h, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaledToHeight(int h, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaledToHeight_int_TransformationMode(nativeId(), h, mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_scaledToHeight_int_TransformationMode(long __this__nativeId, int h, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaledToWidth(int w) {
        return scaledToWidth(w, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage scaledToWidth(int w, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaledToWidth_int_TransformationMode(nativeId(), w, mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_scaledToWidth_int_TransformationMode(long __this__nativeId, int w, int mode);

    @QtBlockedSlot public final com.trolltech.qt.QNativePointer scanLine(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scanLine_int(nativeId(), arg__1);
    }
    private native static com.trolltech.qt.QNativePointer __qt_scanLine_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setAlphaChannel(com.trolltech.qt.gui.QImage alphaChannel) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlphaChannel_QImage(nativeId(), alphaChannel == null ? (alphaChannel = new com.trolltech.qt.gui.QImage()).nativeId() : alphaChannel.nativeId());
    }
    private native static void __qt_setAlphaChannel_QImage(long __this__nativeId, long alphaChannel);

    @QtBlockedSlot public final void setColor(int i, int c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColor_int_int(nativeId(), i, c);
    }
    private native static void __qt_setColor_int_int(long __this__nativeId, int i, int c);

    @QtBlockedSlot public final void setColorTable(java.util.List<java.lang.Integer> colors) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColorTable_List(nativeId(), colors);
    }
    private native static void __qt_setColorTable_List(long __this__nativeId, java.util.List<java.lang.Integer> colors);

    @QtBlockedSlot public final void setDotsPerMeterX(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDotsPerMeterX_int(nativeId(), arg__1);
    }
    private native static void __qt_setDotsPerMeterX_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setDotsPerMeterY(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDotsPerMeterY_int(nativeId(), arg__1);
    }
    private native static void __qt_setDotsPerMeterY_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setNumColors(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumColors_int(nativeId(), arg__1);
    }
    private native static void __qt_setNumColors_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setOffset(com.trolltech.qt.core.QPoint arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOffset_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setOffset_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setPixel(com.trolltech.qt.core.QPoint pt, int index_or_rgb) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPixel_QPoint_int(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPoint()).nativeId() : pt.nativeId(), index_or_rgb);
    }
    private native static void __qt_setPixel_QPoint_int(long __this__nativeId, long pt, int index_or_rgb);

    @QtBlockedSlot public final void setPixel(int x, int y, int index_or_rgb) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPixel_int_int_int(nativeId(), x, y, index_or_rgb);
    }
    private native static void __qt_setPixel_int_int_int(long __this__nativeId, int x, int y, int index_or_rgb);

    @QtBlockedSlot public final void setText(java.lang.String key, java.lang.String value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String_String(nativeId(), key, value);
    }
    private native static void __qt_setText_String_String(long __this__nativeId, java.lang.String key, java.lang.String value);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_size(long __this__nativeId);


    @QtBlockedSlot public final java.lang.String text() {
        return text((java.lang.String)"");
    }
    @QtBlockedSlot public final java.lang.String text(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text_String(nativeId(), key);
    }
    private native static java.lang.String __qt_text_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final java.util.List<java.lang.String> textKeys() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textKeys(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_textKeys(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage transformed(com.trolltech.qt.gui.QMatrix matrix) {
        return transformed(matrix, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage transformed(com.trolltech.qt.gui.QMatrix matrix, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_transformed_QMatrix_TransformationMode(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId(), mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_transformed_QMatrix_TransformationMode(long __this__nativeId, long matrix, int mode);


    @QtBlockedSlot public final com.trolltech.qt.gui.QImage transformed(com.trolltech.qt.gui.QTransform matrix) {
        return transformed(matrix, com.trolltech.qt.core.Qt.TransformationMode.FastTransformation);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QImage transformed(com.trolltech.qt.gui.QTransform matrix, com.trolltech.qt.core.Qt.TransformationMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_transformed_QTransform_TransformationMode(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId(), mode.value());
    }
    private native static com.trolltech.qt.gui.QImage __qt_transformed_QTransform_TransformationMode(long __this__nativeId, long matrix, int mode);

    @QtBlockedSlot public final boolean valid(com.trolltech.qt.core.QPoint pt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_valid_QPoint(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPoint()).nativeId() : pt.nativeId());
    }
    private native static boolean __qt_valid_QPoint(long __this__nativeId, long pt);

    @QtBlockedSlot public final boolean valid(int x, int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_valid_int_int(nativeId(), x, y);
    }
    private native static boolean __qt_valid_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final int width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public int devType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric metric) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), metric.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int metric);

    @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    @SuppressWarnings("unused")
    private static com.trolltech.qt.gui.QImage fromData(com.trolltech.qt.core.QByteArray data, com.trolltech.qt.QNativePointer format) {
        return __qt_fromData_QByteArray_nativepointer(data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), format);
    }
    private native static com.trolltech.qt.gui.QImage __qt_fromData_QByteArray_nativepointer(long data, com.trolltech.qt.QNativePointer format);

    public static com.trolltech.qt.gui.QMatrix trueMatrix(com.trolltech.qt.gui.QMatrix arg__1, int w, int h) {
        return __qt_trueMatrix_QMatrix_int_int(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QMatrix()).nativeId() : arg__1.nativeId(), w, h);
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_trueMatrix_QMatrix_int_int(long arg__1, int w, int h);

    public static com.trolltech.qt.gui.QTransform trueMatrix(com.trolltech.qt.gui.QTransform arg__1, int w, int h) {
        return __qt_trueMatrix_QTransform_int_int(arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QTransform()).nativeId() : arg__1.nativeId(), w, h);
    }
    private native static com.trolltech.qt.gui.QTransform __qt_trueMatrix_QTransform_int_int(long arg__1, int w, int h);


    public static native QImage fromNativePointer(QNativePointer nativePointer);

    protected QImage(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QImage array[]);

    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QImage)
            return operator_equal((com.trolltech.qt.gui.QImage) other);
        return false;
    }


        public QImage(String xpm[]) 
        {
            this(com.trolltech.qt.QNativePointer.createCharPointerPointer(xpm));
        }
    

        // TEMPLATE - gui.pixmap_save - START
        public final boolean save(String fileName, String format, int quality) {
            return private_save(fileName, com.trolltech.qt.QNativePointer.createCharPointer(format), quality);
        }
        public final boolean save(String fileName, String format) {
            return save(fileName, format, -1);
        }    
        public final boolean save(String fileName) {
            return save(fileName, null);
        }        
    // TEMPLATE - gui.pixmap_save - END
    

        public final byte[] copyOfBytes() {
            QNativePointer bits = bits();
            byte bytes[] = new byte[numBytes()];
            for (int i=0;i<bytes.length;++i) bytes[i] = bits.byteAt(i);            
            return bytes;
        }
    

        // TEMPLATE - gui.pixmap_save - START
        public final boolean save(com.trolltech.qt.core.QIODevice dev, String format, int quality) {
            return private_save(dev, com.trolltech.qt.QNativePointer.createCharPointer(format), quality);
        }
        public final boolean save(com.trolltech.qt.core.QIODevice dev, String format) {
            return save(dev, format, -1);
        }    
        public final boolean save(com.trolltech.qt.core.QIODevice dev) {
            return save(dev, null);
        }        
    // TEMPLATE - gui.pixmap_save - END
    

        public QImage(byte data[], int width, int height, Format format) {
            this(com.trolltech.qt.QtJambiInternal.byteArrayToNativePointer(data), width, height, format);
        }
    

        public QImage(String fileName, String format) {
            this(fileName, format == null ? null : QNativePointer.createCharPointer(format));
        }
        
        public QImage(String fileName) {
            this(fileName, (String) null);
        }
    

        // TEMPLATE - gui.image_load - START
        public final boolean load(String fileName, String format) {
            return load(fileName, format != null ? QNativePointer.createCharPointer(format) : null);
        }
        
        public final boolean load(String fileName) {
            return load(fileName, (String) null);
        }
    // TEMPLATE - gui.image_load - END
    

        // TEMPLATE - gui.image_load - START
        public final boolean load(com.trolltech.qt.core.QIODevice device, String format) {
            return load(device, format != null ? QNativePointer.createCharPointer(format) : null);
        }
        
        public final boolean load(com.trolltech.qt.core.QIODevice device) {
            return load(device, (String) null);
        }
    // TEMPLATE - gui.image_load - END
    

        // TEMPLATE - gui.image_load - START
        public final boolean loadFromData(byte[] data, String format) {
            return loadFromData(com.trolltech.qt.QtJambiInternal.byteArrayToNativePointer(data), data.length, format != null ? QNativePointer.createCharPointer(format) : null);
        }
        
        public final boolean loadFromData(byte[] data) {
            return loadFromData(data, (String) null);
        }
    // TEMPLATE - gui.image_load - END    
    

        // TEMPLATE - gui.image_load - START
        public final boolean loadFromData(com.trolltech.qt.core.QByteArray data, String format) {
            return loadFromData(data, format != null ? QNativePointer.createCharPointer(format) : null);
        }
        
        public final boolean loadFromData(com.trolltech.qt.core.QByteArray data) {
            return loadFromData(data, (String) null);
        }
    // TEMPLATE - gui.image_load - END
    

        // TEMPLATE - gui.image_load - START
        public static QImage fromData(com.trolltech.qt.core.QByteArray data, String format) {
            return fromData(data, format != null ? QNativePointer.createCharPointer(format) : null);
        }
        
        public static QImage fromData(com.trolltech.qt.core.QByteArray data) {
            return fromData(data, (String) null);
        }
    // TEMPLATE - gui.image_load - END        
    
}
