package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QImageReader extends com.trolltech.qt.QtJambiObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum ImageReaderError implements com.trolltech.qt.QtEnumerator {
        UnknownError(0),
        FileNotFoundError(1),
        DeviceError(2),
        UnsupportedFormatError(3),
        InvalidDataError(4);

        ImageReaderError(int value) { this.value = value; }
        public int value() { return value; }

        public static ImageReaderError resolve(int value) {
            return (ImageReaderError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnknownError;
            case 1: return FileNotFoundError;
            case 2: return DeviceError;
            case 3: return UnsupportedFormatError;
            case 4: return InvalidDataError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QImageReader(java.lang.String fileName) {
        this(fileName, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }
    public QImageReader(java.lang.String fileName, com.trolltech.qt.core.QByteArray format) {
        super((QPrivateConstructor)null);
        __qt_QImageReader_String_QByteArray(fileName, format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native void __qt_QImageReader_String_QByteArray(java.lang.String fileName, long format);


    public QImageReader() {
        super((QPrivateConstructor)null);
        __qt_QImageReader();
    }
    private native void __qt_QImageReader();



    public QImageReader(com.trolltech.qt.core.QIODevice device) {
        this(device, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray());
    }
    public QImageReader(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.core.QByteArray format) {
        super((QPrivateConstructor)null);
        __qt_QImageReader_QIODevice_QByteArray(device == null ? 0 : device.nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native void __qt_QImageReader_QIODevice_QByteArray(long device, long format);


    @QtBlockedSlot public final com.trolltech.qt.gui.QColor backgroundColor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_backgroundColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_backgroundColor(long __this__nativeId);

    @QtBlockedSlot public final boolean canRead() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canRead(nativeId());
    }
    private native static boolean __qt_canRead(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect clipRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clipRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_clipRect(long __this__nativeId);

    @QtBlockedSlot public final int currentImageNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentImageNumber(nativeId());
    }
    private native static int __qt_currentImageNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect currentImageRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentImageRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_currentImageRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImageReader.ImageReaderError error() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QImageReader.ImageReaderError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray format() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_format(long __this__nativeId);

    @QtBlockedSlot public final int imageCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_imageCount(nativeId());
    }
    private native static int __qt_imageCount(long __this__nativeId);

    @QtBlockedSlot public final boolean jumpToImage(int imageNumber) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToImage_int(nativeId(), imageNumber);
    }
    private native static boolean __qt_jumpToImage_int(long __this__nativeId, int imageNumber);

    @QtBlockedSlot public final boolean jumpToNextImage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToNextImage(nativeId());
    }
    private native static boolean __qt_jumpToNextImage(long __this__nativeId);

    @QtBlockedSlot public final int loopCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loopCount(nativeId());
    }
    private native static int __qt_loopCount(long __this__nativeId);

    @QtBlockedSlot public final int nextImageDelay() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextImageDelay(nativeId());
    }
    private native static int __qt_nextImageDelay(long __this__nativeId);

    @QtBlockedSlot public final int quality() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_quality(nativeId());
    }
    private native static int __qt_quality(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage read() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_read(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect scaledClipRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaledClipRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_scaledClipRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize scaledSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaledSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_scaledSize(long __this__nativeId);

    @QtBlockedSlot public final void setBackgroundColor(com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundColor_QColor(nativeId(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setBackgroundColor_QColor(long __this__nativeId, long color);

    @QtBlockedSlot public final void setClipRect(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipRect_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setClipRect_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setFileName(java.lang.String fileName) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileName_String(nativeId(), fileName);
    }
    private native static void __qt_setFileName_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final void setFormat(com.trolltech.qt.core.QByteArray format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_QByteArray(nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native static void __qt_setFormat_QByteArray(long __this__nativeId, long format);

    @QtBlockedSlot public final void setQuality(int quality) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setQuality_int(nativeId(), quality);
    }
    private native static void __qt_setQuality_int(long __this__nativeId, int quality);

    @QtBlockedSlot public final void setScaledClipRect(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScaledClipRect_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setScaledClipRect_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final void setScaledSize(com.trolltech.qt.core.QSize size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScaledSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setScaledSize_QSize(long __this__nativeId, long size);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_size(long __this__nativeId);

    @QtBlockedSlot public final boolean supportsAnimation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsAnimation(nativeId());
    }
    private native static boolean __qt_supportsAnimation(long __this__nativeId);

    @QtBlockedSlot public final boolean supportsOption(com.trolltech.qt.gui.QImageIOHandler.ImageOption option) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportsOption_ImageOption(nativeId(), option.value());
    }
    private native static boolean __qt_supportsOption_ImageOption(long __this__nativeId, int option);

    @QtBlockedSlot public final java.lang.String text(java.lang.String key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text_String(nativeId(), key);
    }
    private native static java.lang.String __qt_text_String(long __this__nativeId, java.lang.String key);

    @QtBlockedSlot public final java.util.List<java.lang.String> textKeys() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textKeys(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_textKeys(long __this__nativeId);

    public native static com.trolltech.qt.core.QByteArray imageFormat(java.lang.String fileName);

    public static com.trolltech.qt.core.QByteArray imageFormat(com.trolltech.qt.core.QIODevice device) {
        return __qt_imageFormat_QIODevice(device == null ? 0 : device.nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_imageFormat_QIODevice(long device);

    public native static java.util.List<com.trolltech.qt.core.QByteArray> supportedImageFormats();


    public static native QImageReader fromNativePointer(QNativePointer nativePointer);

    protected QImageReader(QPrivateConstructor p) { super(p); } 

}
