package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QItemSelectionModel extends com.trolltech.qt.core.QObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum SelectionFlag implements com.trolltech.qt.QtEnumerator {
        NoUpdate(0),
        Clear(1),
        Select(2),
        Deselect(4),
        Toggle(8),
        Current(16),
        Rows(32),
        Columns(64),
        SelectCurrent(18),
        ToggleCurrent(24),
        ClearAndSelect(3);

        SelectionFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectionFlags createQFlags(SelectionFlag ... values) {
            return new SelectionFlags(values);
        }
        public static SelectionFlag resolve(int value) {
            return (SelectionFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoUpdate;
            case 1: return Clear;
            case 2: return Select;
            case 4: return Deselect;
            case 8: return Toggle;
            case 16: return Current;
            case 32: return Rows;
            case 64: return Columns;
            case 18: return SelectCurrent;
            case 24: return ToggleCurrent;
            case 3: return ClearAndSelect;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class SelectionFlags extends com.trolltech.qt.QFlags<SelectionFlag> {
        private static final long serialVersionUID = 1L;
        public SelectionFlags(SelectionFlag ... args) { super(args); }
        public SelectionFlags(int value) { setValue(value); }
    }


    public final Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex> currentChanged = new Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex>();

    @SuppressWarnings("unused")
    private final void currentChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_QModelIndex_QModelIndex(nativeId(), current, previous);
    }
    private native static void __qt_currentChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous);

    public final Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex> currentColumnChanged = new Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex>();

    @SuppressWarnings("unused")
    private final void currentColumnChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentColumnChanged_QModelIndex_QModelIndex(nativeId(), current, previous);
    }
    private native static void __qt_currentColumnChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous);

    public final Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex> currentRowChanged = new Signal2<com.trolltech.qt.core.QModelIndex, com.trolltech.qt.core.QModelIndex>();

    @SuppressWarnings("unused")
    private final void currentRowChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentRowChanged_QModelIndex_QModelIndex(nativeId(), current, previous);
    }
    private native static void __qt_currentRowChanged_QModelIndex_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous);

    public final Signal2<com.trolltech.qt.gui.QItemSelection, com.trolltech.qt.gui.QItemSelection> selectionChanged = new Signal2<com.trolltech.qt.gui.QItemSelection, com.trolltech.qt.gui.QItemSelection>();

    @SuppressWarnings("unused")
    private final void selectionChanged(com.trolltech.qt.gui.QItemSelection selected, com.trolltech.qt.gui.QItemSelection deselected) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged_QItemSelection_QItemSelection(nativeId(), selected == null ? (selected = new com.trolltech.qt.gui.QItemSelection()).nativeId() : selected.nativeId(), deselected == null ? (deselected = new com.trolltech.qt.gui.QItemSelection()).nativeId() : deselected.nativeId());
    }
    private native static void __qt_selectionChanged_QItemSelection_QItemSelection(long __this__nativeId, long selected, long deselected);

    public QItemSelectionModel(com.trolltech.qt.core.QAbstractItemModel model) {
        super((QPrivateConstructor)null);
        __qt_QItemSelectionModel_QAbstractItemModel(model == null ? 0 : model.nativeId());
    }
    private native void __qt_QItemSelectionModel_QAbstractItemModel(long model);


    public QItemSelectionModel(com.trolltech.qt.core.QAbstractItemModel model, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QItemSelectionModel_QAbstractItemModel_QObject(model == null ? 0 : model.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QItemSelectionModel_QAbstractItemModel_QObject(long model, long parent);


    public final void clearSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearSelection(nativeId());
    }
    private native static void __qt_clearSelection(long __this__nativeId);

    @QtBlockedSlot public final boolean columnIntersectsSelection(int column, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnIntersectsSelection_int_QModelIndex(nativeId(), column, parent);
    }
    private native static boolean __qt_columnIntersectsSelection_int_QModelIndex(long __this__nativeId, int column, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public final com.trolltech.qt.core.QModelIndex currentIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentIndex(nativeId());
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_currentIndex(long __this__nativeId);

    @QtBlockedSlot protected final void emitSelectionChanged(com.trolltech.qt.gui.QItemSelection newSelection, com.trolltech.qt.gui.QItemSelection oldSelection) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_emitSelectionChanged_QItemSelection_QItemSelection(nativeId(), newSelection == null ? (newSelection = new com.trolltech.qt.gui.QItemSelection()).nativeId() : newSelection.nativeId(), oldSelection == null ? (oldSelection = new com.trolltech.qt.gui.QItemSelection()).nativeId() : oldSelection.nativeId());
    }
    private native static void __qt_emitSelectionChanged_QItemSelection_QItemSelection(long __this__nativeId, long newSelection, long oldSelection);

    @QtBlockedSlot public final boolean hasSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasSelection(nativeId());
    }
    private native static boolean __qt_hasSelection(long __this__nativeId);

    @QtBlockedSlot public final boolean isColumnSelected(int column, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isColumnSelected_int_QModelIndex(nativeId(), column, parent);
    }
    private native static boolean __qt_isColumnSelected_int_QModelIndex(long __this__nativeId, int column, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public final boolean isRowSelected(int row, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRowSelected_int_QModelIndex(nativeId(), row, parent);
    }
    private native static boolean __qt_isRowSelected_int_QModelIndex(long __this__nativeId, int row, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public final boolean isSelected(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelected_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_isSelected_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final com.trolltech.qt.core.QAbstractItemModel model() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_model(nativeId());
    }
    private native static com.trolltech.qt.core.QAbstractItemModel __qt_model(long __this__nativeId);

    @QtBlockedSlot public final boolean rowIntersectsSelection(int row, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rowIntersectsSelection_int_QModelIndex(nativeId(), row, parent);
    }
    private native static boolean __qt_rowIntersectsSelection_int_QModelIndex(long __this__nativeId, int row, com.trolltech.qt.core.QModelIndex parent);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QModelIndex> selectedColumns() {
        return selectedColumns((int)0);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QModelIndex> selectedColumns(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedColumns_int(nativeId(), row);
    }
    private native static java.util.List<com.trolltech.qt.core.QModelIndex> __qt_selectedColumns_int(long __this__nativeId, int row);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QModelIndex> selectedIndexes() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedIndexes(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.core.QModelIndex> __qt_selectedIndexes(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QModelIndex> selectedRows() {
        return selectedRows((int)0);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QModelIndex> selectedRows(int column) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedRows_int(nativeId(), column);
    }
    private native static java.util.List<com.trolltech.qt.core.QModelIndex> __qt_selectedRows_int(long __this__nativeId, int column);

    @QtBlockedSlot public final com.trolltech.qt.gui.QItemSelection selection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selection(nativeId());
    }
    private native static com.trolltech.qt.gui.QItemSelection __qt_selection(long __this__nativeId);


    public final void setCurrentIndex(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlag ... command) {
        this.setCurrentIndex(index, new com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags(command));
    }
    public final void setCurrentIndex(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags command) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentIndex_QModelIndex_SelectionFlags(nativeId(), index, command.value());
    }
    private native static void __qt_setCurrentIndex_QModelIndex_SelectionFlags(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, int command);

    public void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    public void reset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);


    public final void select(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlag ... command) {
        this.select(index, new com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags(command));
    }
    public void select(com.trolltech.qt.core.QModelIndex index, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags command) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_select_QModelIndex_SelectionFlags(nativeId(), index, command.value());
    }
    private native static void __qt_select_QModelIndex_SelectionFlags(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, int command);


    public final void select(com.trolltech.qt.gui.QItemSelection selection, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlag ... command) {
        this.select(selection, new com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags(command));
    }
    public void select(com.trolltech.qt.gui.QItemSelection selection, com.trolltech.qt.gui.QItemSelectionModel.SelectionFlags command) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_select_QItemSelection_SelectionFlags(nativeId(), selection == null ? (selection = new com.trolltech.qt.gui.QItemSelection()).nativeId() : selection.nativeId(), command.value());
    }
    private native static void __qt_select_QItemSelection_SelectionFlags(long __this__nativeId, long selection, int command);


    public static native QItemSelectionModel fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QItemSelectionModel(QPrivateConstructor p) { super(p); } 

}
