package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QKeyEvent extends com.trolltech.qt.gui.QInputEvent
{

    public QKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, java.lang.String text, boolean autorep) {
        this(type, key, modifiers, text, autorep, (char)1);
    }

    public QKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, java.lang.String text) {
        this(type, key, modifiers, text, (boolean)false, (char)1);
    }

    public QKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers) {
        this(type, key, modifiers, (java.lang.String)"", (boolean)false, (char)1);
    }
    public QKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, java.lang.String text, boolean autorep, char count) {
        super((QPrivateConstructor)null);
        __qt_QKeyEvent_Type_int_KeyboardModifiers_String_boolean_char(type.value(), key, modifiers.value(), text, autorep, count);
    }
    private native void __qt_QKeyEvent_Type_int_KeyboardModifiers_String_boolean_char(int type, int key, int modifiers, java.lang.String text, boolean autorep, char count);


    @QtBlockedSlot public final int count() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @QtBlockedSlot public final boolean hasExtendedInfo() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasExtendedInfo(nativeId());
    }
    private native static boolean __qt_hasExtendedInfo(long __this__nativeId);

    @QtBlockedSlot public final boolean isAutoRepeat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAutoRepeat(nativeId());
    }
    private native static boolean __qt_isAutoRepeat(long __this__nativeId);

    @QtBlockedSlot public final int key() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_key(nativeId());
    }
    private native static int __qt_key(long __this__nativeId);

    @QtBlockedSlot public final boolean matches(com.trolltech.qt.gui.QKeySequence.StandardKey key) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_matches_StandardKey(nativeId(), key.value());
    }
    private native static boolean __qt_matches_StandardKey(long __this__nativeId, int key);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.KeyboardModifiers modifiers() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.KeyboardModifiers(__qt_modifiers(nativeId()));
    }
    private native static int __qt_modifiers(long __this__nativeId);

    @QtBlockedSlot public final int nativeModifiers() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nativeModifiers(nativeId());
    }
    private native static int __qt_nativeModifiers(long __this__nativeId);

    @QtBlockedSlot public final int nativeScanCode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nativeScanCode(nativeId());
    }
    private native static int __qt_nativeScanCode(long __this__nativeId);

    @QtBlockedSlot public final int nativeVirtualKey() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nativeVirtualKey(nativeId());
    }
    private native static int __qt_nativeVirtualKey(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);


    public static com.trolltech.qt.gui.QKeyEvent createExtendedKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, int nativeScanCode, int nativeVirtualKey, int nativeModifiers, java.lang.String text, boolean autorep) {
        return createExtendedKeyEvent(type, key, modifiers, nativeScanCode, nativeVirtualKey, nativeModifiers, text, autorep, (char)1);
    }

    public static com.trolltech.qt.gui.QKeyEvent createExtendedKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, int nativeScanCode, int nativeVirtualKey, int nativeModifiers, java.lang.String text) {
        return createExtendedKeyEvent(type, key, modifiers, nativeScanCode, nativeVirtualKey, nativeModifiers, text, (boolean)false, (char)1);
    }

    public static com.trolltech.qt.gui.QKeyEvent createExtendedKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, int nativeScanCode, int nativeVirtualKey, int nativeModifiers) {
        return createExtendedKeyEvent(type, key, modifiers, nativeScanCode, nativeVirtualKey, nativeModifiers, (java.lang.String)"", (boolean)false, (char)1);
    }
    public static com.trolltech.qt.gui.QKeyEvent createExtendedKeyEvent(com.trolltech.qt.core.QEvent.Type type, int key, com.trolltech.qt.core.Qt.KeyboardModifiers modifiers, int nativeScanCode, int nativeVirtualKey, int nativeModifiers, java.lang.String text, boolean autorep, char count) {
        return __qt_createExtendedKeyEvent_Type_int_KeyboardModifiers_int_int_int_String_boolean_char(type.value(), key, modifiers.value(), nativeScanCode, nativeVirtualKey, nativeModifiers, text, autorep, count);
    }
    private native static com.trolltech.qt.gui.QKeyEvent __qt_createExtendedKeyEvent_Type_int_KeyboardModifiers_int_int_int_String_boolean_char(int type, int key, int modifiers, int nativeScanCode, int nativeVirtualKey, int nativeModifiers, java.lang.String text, boolean autorep, char count);

    @QtBlockedSlot protected final void setK(int k) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setK_int(nativeId(), k);
    }
    private native static void __qt_setK_int(long __this__nativeId, int k);

    @QtBlockedSlot protected final int k() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_k(nativeId());
    }
    private native static int __qt_k(long __this__nativeId);

    @QtBlockedSlot protected final void setTxt(java.lang.String txt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTxt_String(nativeId(), txt);
    }
    private native static void __qt_setTxt_String(long __this__nativeId, java.lang.String txt);

    @QtBlockedSlot protected final java.lang.String txt() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_txt(nativeId());
    }
    private native static java.lang.String __qt_txt(long __this__nativeId);

    @QtBlockedSlot protected final void setC(char c) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setC_char(nativeId(), c);
    }
    private native static void __qt_setC_char(long __this__nativeId, char c);

    @QtBlockedSlot protected final char c() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_c(nativeId());
    }
    private native static char __qt_c(long __this__nativeId);

    @QtBlockedSlot protected final void setAutor(int autor) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutor_int(nativeId(), autor);
    }
    private native static void __qt_setAutor_int(long __this__nativeId, int autor);

    @QtBlockedSlot protected final int autor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_autor(nativeId());
    }
    private native static int __qt_autor(long __this__nativeId);


    public static native QKeyEvent fromNativePointer(QNativePointer nativePointer);

    protected QKeyEvent(QPrivateConstructor p) { super(p); } 

}
