package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMainWindow extends com.trolltech.qt.gui.QWidget
{
    public enum DockOption implements com.trolltech.qt.QtEnumerator {
        AnimatedDocks(1),
        AllowNestedDocks(2),
        AllowTabbedDocks(4),
        ForceTabbedDocks(8),
        VerticalTabs(16);

        DockOption(int value) { this.value = value; }
        public int value() { return value; }

        public static DockOptions createQFlags(DockOption ... values) {
            return new DockOptions(values);
        }
        public static DockOption resolve(int value) {
            return (DockOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return AnimatedDocks;
            case 2: return AllowNestedDocks;
            case 4: return AllowTabbedDocks;
            case 8: return ForceTabbedDocks;
            case 16: return VerticalTabs;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class DockOptions extends com.trolltech.qt.QFlags<DockOption> {
        private static final long serialVersionUID = 1L;
        public DockOptions(DockOption ... args) { super(args); }
        public DockOptions(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.core.QSize> iconSizeChanged = new Signal1<com.trolltech.qt.core.QSize>();

    @SuppressWarnings("unused")
    private final void iconSizeChanged(com.trolltech.qt.core.QSize iconSize) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_iconSizeChanged_QSize(nativeId(), iconSize == null ? (iconSize = new com.trolltech.qt.core.QSize()).nativeId() : iconSize.nativeId());
    }
    private native static void __qt_iconSizeChanged_QSize(long __this__nativeId, long iconSize);

    public final Signal1<com.trolltech.qt.core.Qt.ToolButtonStyle> toolButtonStyleChanged = new Signal1<com.trolltech.qt.core.Qt.ToolButtonStyle>();

    @SuppressWarnings("unused")
    private final void toolButtonStyleChanged(com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_toolButtonStyleChanged_ToolButtonStyle(nativeId(), toolButtonStyle.value());
    }
    private native static void __qt_toolButtonStyleChanged_ToolButtonStyle(long __this__nativeId, int toolButtonStyle);


    public QMainWindow(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QMainWindow() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QMainWindow(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QMainWindow_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), flags.value());
    }
    private native void __qt_QMainWindow_QWidget_WindowFlags(long parent, int flags);


    @QtBlockedSlot public final void addDockWidget(com.trolltech.qt.core.Qt.DockWidgetArea area, com.trolltech.qt.gui.QDockWidget dockwidget, com.trolltech.qt.core.Qt.Orientation orientation) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addDockWidget_DockWidgetArea_QDockWidget_Orientation(nativeId(), area.value(), dockwidget == null ? 0 : dockwidget.nativeId(), orientation.value());
    }
    private native static void __qt_addDockWidget_DockWidgetArea_QDockWidget_Orientation(long __this__nativeId, int area, long dockwidget, int orientation);

    @QtBlockedSlot public final void addDockWidget(com.trolltech.qt.core.Qt.DockWidgetArea area, com.trolltech.qt.gui.QDockWidget dockwidget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addDockWidget_DockWidgetArea_QDockWidget(nativeId(), area.value(), dockwidget == null ? 0 : dockwidget.nativeId());
    }
    private native static void __qt_addDockWidget_DockWidgetArea_QDockWidget(long __this__nativeId, int area, long dockwidget);

    @QtBlockedSlot public final void addToolBar(com.trolltech.qt.core.Qt.ToolBarArea area, com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addToolBar_ToolBarArea_QToolBar(nativeId(), area.value(), toolbar == null ? 0 : toolbar.nativeId());
    }
    private native static void __qt_addToolBar_ToolBarArea_QToolBar(long __this__nativeId, int area, long toolbar);

    @QtBlockedSlot public final com.trolltech.qt.gui.QToolBar addToolBar(java.lang.String title) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addToolBar_String(nativeId(), title);
    }
    private native static com.trolltech.qt.gui.QToolBar __qt_addToolBar_String(long __this__nativeId, java.lang.String title);

    @QtBlockedSlot public final void addToolBar(com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addToolBar_QToolBar(nativeId(), toolbar == null ? 0 : toolbar.nativeId());
    }
    private native static void __qt_addToolBar_QToolBar(long __this__nativeId, long toolbar);


    @QtBlockedSlot public final void addToolBarBreak() {
        addToolBarBreak(com.trolltech.qt.core.Qt.ToolBarArea.TopToolBarArea);
    }
    @QtBlockedSlot public final void addToolBarBreak(com.trolltech.qt.core.Qt.ToolBarArea area) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addToolBarBreak_ToolBarArea(nativeId(), area.value());
    }
    private native static void __qt_addToolBarBreak_ToolBarArea(long __this__nativeId, int area);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget centralWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_centralWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_centralWidget(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.DockWidgetArea corner(com.trolltech.qt.core.Qt.Corner corner) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.DockWidgetArea.resolve(__qt_corner_Corner(nativeId(), corner.value()));
    }
    private native static int __qt_corner_Corner(long __this__nativeId, int corner);

    @com.trolltech.qt.QtPropertyReader(name="dockOptions")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.gui.QMainWindow.DockOptions dockOptions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QMainWindow.DockOptions(__qt_dockOptions(nativeId()));
    }
    private native static int __qt_dockOptions(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.DockWidgetArea dockWidgetArea(com.trolltech.qt.gui.QDockWidget dockwidget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.DockWidgetArea.resolve(__qt_dockWidgetArea_QDockWidget(nativeId(), dockwidget == null ? 0 : dockwidget.nativeId()));
    }
    private native static int __qt_dockWidgetArea_QDockWidget(long __this__nativeId, long dockwidget);

    @com.trolltech.qt.QtPropertyReader(name="iconSize")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);

    @QtBlockedSlot public final void insertToolBar(com.trolltech.qt.gui.QToolBar before, com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertToolBar_QToolBar_QToolBar(nativeId(), before == null ? 0 : before.nativeId(), toolbar == null ? 0 : toolbar.nativeId());
    }
    private native static void __qt_insertToolBar_QToolBar_QToolBar(long __this__nativeId, long before, long toolbar);

    @QtBlockedSlot public final void insertToolBarBreak(com.trolltech.qt.gui.QToolBar before) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertToolBarBreak_QToolBar(nativeId(), before == null ? 0 : before.nativeId());
    }
    private native static void __qt_insertToolBarBreak_QToolBar(long __this__nativeId, long before);

    @com.trolltech.qt.QtPropertyReader(name="animated")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean isAnimated() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAnimated(nativeId());
    }
    private native static boolean __qt_isAnimated(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="dockNestingEnabled")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean isDockNestingEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDockNestingEnabled(nativeId());
    }
    private native static boolean __qt_isDockNestingEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isSeparator(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSeparator_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static boolean __qt_isSeparator_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMenuBar menuBar() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_menuBar(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenuBar __qt_menuBar(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget menuWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_menuWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_menuWidget(long __this__nativeId);

    @QtBlockedSlot public final void removeDockWidget(com.trolltech.qt.gui.QDockWidget dockwidget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeDockWidget_QDockWidget(nativeId(), dockwidget == null ? 0 : dockwidget.nativeId());
    }
    private native static void __qt_removeDockWidget_QDockWidget(long __this__nativeId, long dockwidget);

    @QtBlockedSlot public final void removeToolBar(com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeToolBar_QToolBar(nativeId(), toolbar == null ? 0 : toolbar.nativeId());
    }
    private native static void __qt_removeToolBar_QToolBar(long __this__nativeId, long toolbar);

    @QtBlockedSlot public final void removeToolBarBreak(com.trolltech.qt.gui.QToolBar before) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeToolBarBreak_QToolBar(nativeId(), before == null ? 0 : before.nativeId());
    }
    private native static void __qt_removeToolBarBreak_QToolBar(long __this__nativeId, long before);


    @QtBlockedSlot public final boolean restoreState(com.trolltech.qt.core.QByteArray state) {
        return restoreState(state, (int)0);
    }
    @QtBlockedSlot public final boolean restoreState(com.trolltech.qt.core.QByteArray state, int version) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_restoreState_QByteArray_int(nativeId(), state == null ? (state = new com.trolltech.qt.core.QByteArray()).nativeId() : state.nativeId(), version);
    }
    private native static boolean __qt_restoreState_QByteArray_int(long __this__nativeId, long state, int version);


    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray saveState() {
        return saveState((int)0);
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray saveState(int version) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saveState_int(nativeId(), version);
    }
    private native static com.trolltech.qt.core.QByteArray __qt_saveState_int(long __this__nativeId, int version);

    @com.trolltech.qt.QtPropertyWriter(name="animated")
    public final void setAnimated(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAnimated_boolean(nativeId(), enabled);
    }
    private native static void __qt_setAnimated_boolean(long __this__nativeId, boolean enabled);

    @QtBlockedSlot public final void setCentralWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCentralWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setCentralWidget_QWidget(long __this__nativeId, long widget);

    @QtBlockedSlot public final void setCorner(com.trolltech.qt.core.Qt.Corner corner, com.trolltech.qt.core.Qt.DockWidgetArea area) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCorner_Corner_DockWidgetArea(nativeId(), corner.value(), area.value());
    }
    private native static void __qt_setCorner_Corner_DockWidgetArea(long __this__nativeId, int corner, int area);

    @com.trolltech.qt.QtPropertyWriter(name="dockNestingEnabled")
    public final void setDockNestingEnabled(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDockNestingEnabled_boolean(nativeId(), enabled);
    }
    private native static void __qt_setDockNestingEnabled_boolean(long __this__nativeId, boolean enabled);


    @QtBlockedSlot public final void setDockOptions(com.trolltech.qt.gui.QMainWindow.DockOption ... options) {
        this.setDockOptions(new com.trolltech.qt.gui.QMainWindow.DockOptions(options));
    }
    @com.trolltech.qt.QtPropertyWriter(name="dockOptions")
    @QtBlockedSlot public final void setDockOptions(com.trolltech.qt.gui.QMainWindow.DockOptions options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDockOptions_DockOptions(nativeId(), options.value());
    }
    private native static void __qt_setDockOptions_DockOptions(long __this__nativeId, int options);

    @com.trolltech.qt.QtPropertyWriter(name="iconSize")
    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize iconSize) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), iconSize == null ? (iconSize = new com.trolltech.qt.core.QSize()).nativeId() : iconSize.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long iconSize);

    @QtBlockedSlot public final void setMenuBar(com.trolltech.qt.gui.QMenuBar menubar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMenuBar_QMenuBar(nativeId(), menubar == null ? 0 : menubar.nativeId());
    }
    private native static void __qt_setMenuBar_QMenuBar(long __this__nativeId, long menubar);

    @QtBlockedSlot public final void setMenuWidget(com.trolltech.qt.gui.QWidget menubar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMenuWidget_QWidget(nativeId(), menubar == null ? 0 : menubar.nativeId());
    }
    private native static void __qt_setMenuWidget_QWidget(long __this__nativeId, long menubar);

    @QtBlockedSlot public final void setStatusBar(com.trolltech.qt.gui.QStatusBar statusbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusBar_QStatusBar(nativeId(), statusbar == null ? 0 : statusbar.nativeId());
    }
    private native static void __qt_setStatusBar_QStatusBar(long __this__nativeId, long statusbar);

    @com.trolltech.qt.QtPropertyWriter(name="toolButtonStyle")
    @QtBlockedSlot public final void setToolButtonStyle(com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolButtonStyle_ToolButtonStyle(nativeId(), toolButtonStyle.value());
    }
    private native static void __qt_setToolButtonStyle_ToolButtonStyle(long __this__nativeId, int toolButtonStyle);

    @com.trolltech.qt.QtPropertyWriter(name="unifiedTitleAndToolBarOnMac")
    @QtBlockedSlot public final void setUnifiedTitleAndToolBarOnMac(boolean set) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUnifiedTitleAndToolBarOnMac_boolean(nativeId(), set);
    }
    private native static void __qt_setUnifiedTitleAndToolBarOnMac_boolean(long __this__nativeId, boolean set);

    @QtBlockedSlot public final void splitDockWidget(com.trolltech.qt.gui.QDockWidget after, com.trolltech.qt.gui.QDockWidget dockwidget, com.trolltech.qt.core.Qt.Orientation orientation) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_splitDockWidget_QDockWidget_QDockWidget_Orientation(nativeId(), after == null ? 0 : after.nativeId(), dockwidget == null ? 0 : dockwidget.nativeId(), orientation.value());
    }
    private native static void __qt_splitDockWidget_QDockWidget_QDockWidget_Orientation(long __this__nativeId, long after, long dockwidget, int orientation);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStatusBar statusBar() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusBar(nativeId());
    }
    private native static com.trolltech.qt.gui.QStatusBar __qt_statusBar(long __this__nativeId);

    @QtBlockedSlot public final void tabifyDockWidget(com.trolltech.qt.gui.QDockWidget first, com.trolltech.qt.gui.QDockWidget second) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabifyDockWidget_QDockWidget_QDockWidget(nativeId(), first == null ? 0 : first.nativeId(), second == null ? 0 : second.nativeId());
    }
    private native static void __qt_tabifyDockWidget_QDockWidget_QDockWidget(long __this__nativeId, long first, long second);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ToolBarArea toolBarArea(com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ToolBarArea.resolve(__qt_toolBarArea_QToolBar(nativeId(), toolbar == null ? 0 : toolbar.nativeId()));
    }
    private native static int __qt_toolBarArea_QToolBar(long __this__nativeId, long toolbar);

    @QtBlockedSlot public final boolean toolBarBreak(com.trolltech.qt.gui.QToolBar toolbar) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolBarBreak_QToolBar(nativeId(), toolbar == null ? 0 : toolbar.nativeId());
    }
    private native static boolean __qt_toolBarBreak_QToolBar(long __this__nativeId, long toolbar);

    @com.trolltech.qt.QtPropertyReader(name="toolButtonStyle")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ToolButtonStyle.resolve(__qt_toolButtonStyle(nativeId()));
    }
    private native static int __qt_toolButtonStyle(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="unifiedTitleAndToolBarOnMac")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final boolean unifiedTitleAndToolBarOnMac() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_unifiedTitleAndToolBarOnMac(nativeId());
    }
    private native static boolean __qt_unifiedTitleAndToolBarOnMac(long __this__nativeId);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.gui.QMenu createPopupMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createPopupMenu(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenu __qt_createPopupMenu(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);


    public static native QMainWindow fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QMainWindow(QPrivateConstructor p) { super(p); } 

}
