package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMdiArea extends com.trolltech.qt.gui.QAbstractScrollArea
{
    public enum WindowOrder implements com.trolltech.qt.QtEnumerator {
        CreationOrder(0),
        StackingOrder(1);

        WindowOrder(int value) { this.value = value; }
        public int value() { return value; }

        public static WindowOrder resolve(int value) {
            return (WindowOrder) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CreationOrder;
            case 1: return StackingOrder;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum AreaOption implements com.trolltech.qt.QtEnumerator {
        DontMaximizeSubWindowOnActivation(1);

        AreaOption(int value) { this.value = value; }
        public int value() { return value; }

        public static AreaOptions createQFlags(AreaOption ... values) {
            return new AreaOptions(values);
        }
        public static AreaOption resolve(int value) {
            return (AreaOption) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DontMaximizeSubWindowOnActivation;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class AreaOptions extends com.trolltech.qt.QFlags<AreaOption> {
        private static final long serialVersionUID = 1L;
        public AreaOptions(AreaOption ... args) { super(args); }
        public AreaOptions(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.gui.QMdiSubWindow> subWindowActivated = new Signal1<com.trolltech.qt.gui.QMdiSubWindow>();

    @SuppressWarnings("unused")
    private final void subWindowActivated(com.trolltech.qt.gui.QMdiSubWindow arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_subWindowActivated_QMdiSubWindow(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_subWindowActivated_QMdiSubWindow(long __this__nativeId, long arg__1);


    public QMdiArea() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QMdiArea(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QMdiArea_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QMdiArea_QWidget(long parent);


    public final void activateNextSubWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activateNextSubWindow(nativeId());
    }
    private native static void __qt_activateNextSubWindow(long __this__nativeId);

    public final void activatePreviousSubWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activatePreviousSubWindow(nativeId());
    }
    private native static void __qt_activatePreviousSubWindow(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMdiSubWindow activeSubWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_activeSubWindow(nativeId());
    }
    private native static com.trolltech.qt.gui.QMdiSubWindow __qt_activeSubWindow(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QMdiSubWindow addSubWindow(com.trolltech.qt.gui.QWidget widget, com.trolltech.qt.core.Qt.WindowType ... flags) {
        return this.addSubWindow(widget, new com.trolltech.qt.core.Qt.WindowFlags(flags));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QMdiSubWindow addSubWindow(com.trolltech.qt.gui.QWidget widget) {
        return addSubWindow(widget, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QMdiSubWindow addSubWindow(com.trolltech.qt.gui.QWidget widget, com.trolltech.qt.core.Qt.WindowFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addSubWindow_QWidget_WindowFlags(nativeId(), widget == null ? 0 : widget.nativeId(), flags.value());
    }
    private native static com.trolltech.qt.gui.QMdiSubWindow __qt_addSubWindow_QWidget_WindowFlags(long __this__nativeId, long widget, int flags);

    @com.trolltech.qt.QtPropertyReader(name="background")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    public final void cascadeSubWindows() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cascadeSubWindows(nativeId());
    }
    private native static void __qt_cascadeSubWindows(long __this__nativeId);

    public final void closeActiveSubWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeActiveSubWindow(nativeId());
    }
    private native static void __qt_closeActiveSubWindow(long __this__nativeId);

    public final void closeAllSubWindows() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeAllSubWindows(nativeId());
    }
    private native static void __qt_closeAllSubWindows(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMdiSubWindow currentSubWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentSubWindow(nativeId());
    }
    private native static com.trolltech.qt.gui.QMdiSubWindow __qt_currentSubWindow(long __this__nativeId);

    @QtBlockedSlot public final void removeSubWindow(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeSubWindow_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_removeSubWindow_QWidget(long __this__nativeId, long widget);

    public final void setActiveSubWindow(com.trolltech.qt.gui.QMdiSubWindow window) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setActiveSubWindow_QMdiSubWindow(nativeId(), window == null ? 0 : window.nativeId());
    }
    private native static void __qt_setActiveSubWindow_QMdiSubWindow(long __this__nativeId, long window);

    @com.trolltech.qt.QtPropertyWriter(name="background")
    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush background) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), background == null ? (background = new com.trolltech.qt.gui.QBrush()).nativeId() : background.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long background);


    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QMdiArea.AreaOption option) {
        setOption(option, (boolean)true);
    }
    @QtBlockedSlot public final void setOption(com.trolltech.qt.gui.QMdiArea.AreaOption option, boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOption_AreaOption_boolean(nativeId(), option.value(), on);
    }
    private native static void __qt_setOption_AreaOption_boolean(long __this__nativeId, int option, boolean on);

    protected final void setupViewport(com.trolltech.qt.gui.QWidget viewport) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setupViewport_QWidget(nativeId(), viewport == null ? 0 : viewport.nativeId());
    }
    private native static void __qt_setupViewport_QWidget(long __this__nativeId, long viewport);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QMdiSubWindow> subWindowList() {
        return subWindowList(com.trolltech.qt.gui.QMdiArea.WindowOrder.CreationOrder);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QMdiSubWindow> subWindowList(com.trolltech.qt.gui.QMdiArea.WindowOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_subWindowList_WindowOrder(nativeId(), order.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QMdiSubWindow> __qt_subWindowList_WindowOrder(long __this__nativeId, int order);

    @QtBlockedSlot public final boolean testOption(com.trolltech.qt.gui.QMdiArea.AreaOption opton) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testOption_AreaOption(nativeId(), opton.value());
    }
    private native static boolean __qt_testOption_AreaOption(long __this__nativeId, int opton);

    public final void tileSubWindows() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tileSubWindows(nativeId());
    }
    private native static void __qt_tileSubWindows(long __this__nativeId);

    @QtBlockedSlot protected void childEvent(com.trolltech.qt.core.QChildEvent childEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_childEvent_QChildEvent(nativeId(), childEvent == null ? 0 : childEvent.nativeId());
    }
    private native static void __qt_childEvent_QChildEvent(long __this__nativeId, long childEvent);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean eventFilter(com.trolltech.qt.core.QObject object, com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_eventFilter_QObject_QEvent(nativeId(), object == null ? 0 : object.nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_eventFilter_QObject_QEvent(long __this__nativeId, long object, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent paintEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), paintEvent == null ? 0 : paintEvent.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long paintEvent);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent resizeEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), resizeEvent == null ? 0 : resizeEvent.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long resizeEvent);

    @QtBlockedSlot protected void scrollContentsBy(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollContentsBy_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scrollContentsBy_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent showEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), showEvent == null ? 0 : showEvent.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long showEvent);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent timerEvent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), timerEvent == null ? 0 : timerEvent.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long timerEvent);

    @QtBlockedSlot protected boolean viewportEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewportEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_viewportEvent_QEvent(long __this__nativeId, long event);


    public static native QMdiArea fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QMdiArea(QPrivateConstructor p) { super(p); } 

}
