package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMovie extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private Object __rcDevice = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum CacheMode implements com.trolltech.qt.QtEnumerator {
        CacheNone(0),
        CacheAll(1);

        CacheMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CacheMode resolve(int value) {
            return (CacheMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CacheNone;
            case 1: return CacheAll;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MovieState implements com.trolltech.qt.QtEnumerator {
        NotRunning(0),
        Paused(1),
        Running(2);

        MovieState(int value) { this.value = value; }
        public int value() { return value; }

        public static MovieState resolve(int value) {
            return (MovieState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotRunning;
            case 1: return Paused;
            case 2: return Running;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QImageReader.ImageReaderError> error = new Signal1<com.trolltech.qt.gui.QImageReader.ImageReaderError>();

    @SuppressWarnings("unused")
    private final void error(com.trolltech.qt.gui.QImageReader.ImageReaderError error) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_error_ImageReaderError(nativeId(), error.value());
    }
    private native static void __qt_error_ImageReaderError(long __this__nativeId, int error);

    public final Signal0 finished = new Signal0();

    @SuppressWarnings("unused")
    private final void finished() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_finished(nativeId());
    }
    private native static void __qt_finished(long __this__nativeId);

    public final Signal1<java.lang.Integer> frameChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void frameChanged(int frameNumber) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_frameChanged_int(nativeId(), frameNumber);
    }
    private native static void __qt_frameChanged_int(long __this__nativeId, int frameNumber);

    public final Signal1<com.trolltech.qt.core.QSize> resized = new Signal1<com.trolltech.qt.core.QSize>();

    @SuppressWarnings("unused")
    private final void resized(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resized_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_resized_QSize(long __this__nativeId, long size);

    public final Signal0 started = new Signal0();

    @SuppressWarnings("unused")
    private final void started() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_started(nativeId());
    }
    private native static void __qt_started(long __this__nativeId);

    public final Signal1<com.trolltech.qt.gui.QMovie.MovieState> stateChanged = new Signal1<com.trolltech.qt.gui.QMovie.MovieState>();

    @SuppressWarnings("unused")
    private final void stateChanged(com.trolltech.qt.gui.QMovie.MovieState state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_MovieState(nativeId(), state.value());
    }
    private native static void __qt_stateChanged_MovieState(long __this__nativeId, int state);

    public final Signal1<com.trolltech.qt.core.QRect> updated = new Signal1<com.trolltech.qt.core.QRect>();

    @SuppressWarnings("unused")
    private final void updated(com.trolltech.qt.core.QRect rect) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updated_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_updated_QRect(long __this__nativeId, long rect);


    public QMovie(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.core.QByteArray format) {
        this(device, format, (com.trolltech.qt.core.QObject)null);
    }

    public QMovie(com.trolltech.qt.core.QIODevice device) {
        this(device, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray(), (com.trolltech.qt.core.QObject)null);
    }
    public QMovie(com.trolltech.qt.core.QIODevice device, com.trolltech.qt.core.QByteArray format, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QMovie_QIODevice_QByteArray_QObject(device == null ? 0 : device.nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QMovie_QIODevice_QByteArray_QObject(long device, long format, long parent);



    public QMovie(java.lang.String fileName, com.trolltech.qt.core.QByteArray format) {
        this(fileName, format, (com.trolltech.qt.core.QObject)null);
    }

    public QMovie(java.lang.String fileName) {
        this(fileName, (com.trolltech.qt.core.QByteArray)new com.trolltech.qt.core.QByteArray(), (com.trolltech.qt.core.QObject)null);
    }
    public QMovie(java.lang.String fileName, com.trolltech.qt.core.QByteArray format, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QMovie_String_QByteArray_QObject(fileName, format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QMovie_String_QByteArray_QObject(java.lang.String fileName, long format, long parent);



    public QMovie() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QMovie(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QMovie_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QMovie_QObject(long parent);


    @QtBlockedSlot public final com.trolltech.qt.gui.QColor backgroundColor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_backgroundColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_backgroundColor(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="cacheMode")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QMovie.CacheMode cacheMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QMovie.CacheMode.resolve(__qt_cacheMode(nativeId()));
    }
    private native static int __qt_cacheMode(long __this__nativeId);

    @QtBlockedSlot public final int currentFrameNumber() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentFrameNumber(nativeId());
    }
    private native static int __qt_currentFrameNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QImage currentImage() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentImage(nativeId());
    }
    private native static com.trolltech.qt.gui.QImage __qt_currentImage(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap currentPixmap() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentPixmap(nativeId());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_currentPixmap(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice device() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_device(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray format() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_format(long __this__nativeId);

    @QtBlockedSlot public final int frameCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameCount(nativeId());
    }
    private native static int __qt_frameCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect frameRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_frameRect(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final boolean jumpToFrame(int frameNumber) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToFrame_int(nativeId(), frameNumber);
    }
    private native static boolean __qt_jumpToFrame_int(long __this__nativeId, int frameNumber);

    public final boolean jumpToNextFrame() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_jumpToNextFrame(nativeId());
    }
    private native static boolean __qt_jumpToNextFrame(long __this__nativeId);

    @QtBlockedSlot public final int loopCount() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loopCount(nativeId());
    }
    private native static int __qt_loopCount(long __this__nativeId);

    @QtBlockedSlot public final int nextFrameDelay() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextFrameDelay(nativeId());
    }
    private native static int __qt_nextFrameDelay(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize scaledSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scaledSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_scaledSize(long __this__nativeId);

    @QtBlockedSlot public final void setBackgroundColor(com.trolltech.qt.gui.QColor color) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundColor_QColor(nativeId(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setBackgroundColor_QColor(long __this__nativeId, long color);

    @com.trolltech.qt.QtPropertyWriter(name="cacheMode")
    @QtBlockedSlot public final void setCacheMode(com.trolltech.qt.gui.QMovie.CacheMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCacheMode_CacheMode(nativeId(), mode.value());
    }
    private native static void __qt_setCacheMode_CacheMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setDevice(com.trolltech.qt.core.QIODevice device) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDevice = device;
        }
        __qt_setDevice_QIODevice(nativeId(), device == null ? 0 : device.nativeId());
    }
    private native static void __qt_setDevice_QIODevice(long __this__nativeId, long device);

    @QtBlockedSlot public final void setFileName(java.lang.String fileName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileName_String(nativeId(), fileName);
    }
    private native static void __qt_setFileName_String(long __this__nativeId, java.lang.String fileName);

    @QtBlockedSlot public final void setFormat(com.trolltech.qt.core.QByteArray format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_QByteArray(nativeId(), format == null ? (format = new com.trolltech.qt.core.QByteArray()).nativeId() : format.nativeId());
    }
    private native static void __qt_setFormat_QByteArray(long __this__nativeId, long format);

    public final void setPaused(boolean paused) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPaused_boolean(nativeId(), paused);
    }
    private native static void __qt_setPaused_boolean(long __this__nativeId, boolean paused);

    @QtBlockedSlot public final void setScaledSize(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScaledSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setScaledSize_QSize(long __this__nativeId, long size);

    @com.trolltech.qt.QtPropertyWriter(name="speed")
    public final void setSpeed(int percentSpeed) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSpeed_int(nativeId(), percentSpeed);
    }
    private native static void __qt_setSpeed_int(long __this__nativeId, int percentSpeed);

    @com.trolltech.qt.QtPropertyReader(name="speed")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final int speed() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_speed(nativeId());
    }
    private native static int __qt_speed(long __this__nativeId);

    public final void start() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_start(nativeId());
    }
    private native static void __qt_start(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMovie.MovieState state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QMovie.MovieState.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);

    public final void stop() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stop(nativeId());
    }
    private native static void __qt_stop(long __this__nativeId);

    public native static java.util.List<com.trolltech.qt.core.QByteArray> supportedFormats();


    public static native QMovie fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QMovie(QPrivateConstructor p) { super(p); } 

}
