package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QPaintEngine extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.gui.QPaintEngine {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot public boolean begin(com.trolltech.qt.gui.QPaintDeviceInterface pdev) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_begin_QPaintDevice(nativeId(), pdev == null ? 0 : pdev.nativeId());
        }
        @QtBlockedSlot public void drawPixmap(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QPixmap pm, com.trolltech.qt.core.QRectF sr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QRectF_QPixmap_QRectF(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRectF()).nativeId() : sr.nativeId());
        }
        @QtBlockedSlot public boolean end() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_end(nativeId());
        }
        @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine.Type type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPaintEngine.Type.resolve(__qt_type(nativeId()));
        }
        @QtBlockedSlot public void updateState(com.trolltech.qt.gui.QPaintEngineState state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateState_QPaintEngineState(nativeId(), state == null ? 0 : state.nativeId());
        }
    }

    public enum PolygonDrawMode implements com.trolltech.qt.QtEnumerator {
        OddEvenMode(0),
        WindingMode(1),
        ConvexMode(2),
        PolylineMode(3);

        PolygonDrawMode(int value) { this.value = value; }
        public int value() { return value; }

        public static PolygonDrawMode resolve(int value) {
            return (PolygonDrawMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OddEvenMode;
            case 1: return WindingMode;
            case 2: return ConvexMode;
            case 3: return PolylineMode;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Type implements com.trolltech.qt.QtEnumerator {
        X11(0),
        Windows(1),
        QuickDraw(2),
        CoreGraphics(3),
        MacPrinter(4),
        QWindowSystem(5),
        PostScript(6),
        OpenGL(7),
        Picture(8),
        SVG(9),
        Raster(10),
        Direct3D(11),
        User(50),
        MaxUser(100);

        Type(int value) { this.value = value; }
        public int value() { return value; }

        public static Type resolve(int value) {
            return (Type) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return X11;
            case 1: return Windows;
            case 2: return QuickDraw;
            case 3: return CoreGraphics;
            case 4: return MacPrinter;
            case 5: return QWindowSystem;
            case 6: return PostScript;
            case 7: return OpenGL;
            case 8: return Picture;
            case 9: return SVG;
            case 10: return Raster;
            case 11: return Direct3D;
            case 50: return User;
            case 100: return MaxUser;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PaintEngineFeature implements com.trolltech.qt.QtEnumerator {
        PrimitiveTransform(1),
        PatternTransform(2),
        PixmapTransform(4),
        PatternBrush(8),
        LinearGradientFill(16),
        RadialGradientFill(32),
        ConicalGradientFill(64),
        AlphaBlend(128),
        PorterDuff(256),
        PainterPaths(512),
        Antialiasing(1024),
        BrushStroke(2048),
        ConstantOpacity(4096),
        MaskedBrush(8192),
        PerspectiveTransform(16384),
        BlendModes(32768),
        PaintOutsidePaintEvent(536870912),
        AllFeatures(-1);

        PaintEngineFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static PaintEngineFeatures createQFlags(PaintEngineFeature ... values) {
            return new PaintEngineFeatures(values);
        }
        public static PaintEngineFeature resolve(int value) {
            return (PaintEngineFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return PrimitiveTransform;
            case 2: return PatternTransform;
            case 4: return PixmapTransform;
            case 8: return PatternBrush;
            case 16: return LinearGradientFill;
            case 32: return RadialGradientFill;
            case 64: return ConicalGradientFill;
            case 128: return AlphaBlend;
            case 256: return PorterDuff;
            case 512: return PainterPaths;
            case 1024: return Antialiasing;
            case 2048: return BrushStroke;
            case 4096: return ConstantOpacity;
            case 8192: return MaskedBrush;
            case 16384: return PerspectiveTransform;
            case 32768: return BlendModes;
            case 536870912: return PaintOutsidePaintEvent;
            case -1: return AllFeatures;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class PaintEngineFeatures extends com.trolltech.qt.QFlags<PaintEngineFeature> {
        private static final long serialVersionUID = 1L;
        public PaintEngineFeatures(PaintEngineFeature ... args) { super(args); }
        public PaintEngineFeatures(int value) { setValue(value); }
    }

    public enum DirtyFlag implements com.trolltech.qt.QtEnumerator {
        DirtyPen(1),
        DirtyBrush(2),
        DirtyBrushOrigin(4),
        DirtyFont(8),
        DirtyBackground(16),
        DirtyBackgroundMode(32),
        DirtyTransform(64),
        DirtyClipRegion(128),
        DirtyClipPath(256),
        DirtyHints(512),
        DirtyCompositionMode(1024),
        DirtyClipEnabled(2048),
        DirtyOpacity(4096),
        AllDirty(65535);

        DirtyFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static DirtyFlags createQFlags(DirtyFlag ... values) {
            return new DirtyFlags(values);
        }
        public static DirtyFlag resolve(int value) {
            return (DirtyFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DirtyPen;
            case 2: return DirtyBrush;
            case 4: return DirtyBrushOrigin;
            case 8: return DirtyFont;
            case 16: return DirtyBackground;
            case 32: return DirtyBackgroundMode;
            case 64: return DirtyTransform;
            case 128: return DirtyClipRegion;
            case 256: return DirtyClipPath;
            case 512: return DirtyHints;
            case 1024: return DirtyCompositionMode;
            case 2048: return DirtyClipEnabled;
            case 4096: return DirtyOpacity;
            case 65535: return AllDirty;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class DirtyFlags extends com.trolltech.qt.QFlags<DirtyFlag> {
        private static final long serialVersionUID = 1L;
        public DirtyFlags(DirtyFlag ... args) { super(args); }
        public DirtyFlags(int value) { setValue(value); }
    }



    public QPaintEngine() {
        this(new com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures(0));
    }
    public QPaintEngine(com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures features) {
        super((QPrivateConstructor)null);
        __qt_QPaintEngine_PaintEngineFeatures(features.value());
    }
    private native void __qt_QPaintEngine_PaintEngineFeatures(int features);



    @QtBlockedSlot public final void clearDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlag ... df) {
        this.clearDirty(new com.trolltech.qt.gui.QPaintEngine.DirtyFlags(df));
    }
    @QtBlockedSlot public final void clearDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlags df) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearDirty_DirtyFlags(nativeId(), df.value());
    }
    private native static void __qt_clearDirty_DirtyFlags(long __this__nativeId, int df);


    @QtBlockedSlot public final boolean hasFeature(com.trolltech.qt.gui.QPaintEngine.PaintEngineFeature ... feature) {
        return this.hasFeature(new com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures(feature));
    }
    @QtBlockedSlot public final boolean hasFeature(com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures feature) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFeature_PaintEngineFeatures(nativeId(), feature.value());
    }
    private native static boolean __qt_hasFeature_PaintEngineFeatures(long __this__nativeId, int feature);

    @QtBlockedSlot public final boolean isActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isActive(nativeId());
    }
    private native static boolean __qt_isActive(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPaintDeviceInterface paintDevice() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintDevice(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintDeviceInterface __qt_paintDevice(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainter painter() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_painter(nativeId());
    }
    private native static com.trolltech.qt.gui.QPainter __qt_painter(long __this__nativeId);

    @QtBlockedSlot public final void setActive(boolean newState) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setActive_boolean(nativeId(), newState);
    }
    private native static void __qt_setActive_boolean(long __this__nativeId, boolean newState);


    @QtBlockedSlot public final void setDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlag ... df) {
        this.setDirty(new com.trolltech.qt.gui.QPaintEngine.DirtyFlags(df));
    }
    @QtBlockedSlot public final void setDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlags df) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirty_DirtyFlags(nativeId(), df.value());
    }
    private native static void __qt_setDirty_DirtyFlags(long __this__nativeId, int df);

    @QtBlockedSlot public final void setSystemClip(com.trolltech.qt.gui.QRegion baseClip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSystemClip_QRegion(nativeId(), baseClip == null ? (baseClip = new com.trolltech.qt.gui.QRegion()).nativeId() : baseClip.nativeId());
    }
    private native static void __qt_setSystemClip_QRegion(long __this__nativeId, long baseClip);

    @QtBlockedSlot public final void setSystemRect(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSystemRect_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setSystemRect_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final void syncState() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_syncState(nativeId());
    }
    private native static void __qt_syncState(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion systemClip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_systemClip(nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_systemClip(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect systemRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_systemRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_systemRect(long __this__nativeId);


    @QtBlockedSlot public final boolean testDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlag ... df) {
        return this.testDirty(new com.trolltech.qt.gui.QPaintEngine.DirtyFlags(df));
    }
    @QtBlockedSlot public final boolean testDirty(com.trolltech.qt.gui.QPaintEngine.DirtyFlags df) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testDirty_DirtyFlags(nativeId(), df.value());
    }
    private native static boolean __qt_testDirty_DirtyFlags(long __this__nativeId, int df);

    @QtBlockedSlot public abstract boolean begin(com.trolltech.qt.gui.QPaintDeviceInterface pdev);
    private native static boolean __qt_begin_QPaintDevice(long __this__nativeId, long pdev);

    @QtBlockedSlot public com.trolltech.qt.core.QPoint coordinateOffset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_coordinateOffset(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_coordinateOffset(long __this__nativeId);

    @QtBlockedSlot public void drawEllipse(com.trolltech.qt.core.QRect r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawEllipse_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static void __qt_drawEllipse_QRect(long __this__nativeId, long r);

    @QtBlockedSlot public void drawEllipse(com.trolltech.qt.core.QRectF r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawEllipse_QRectF(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId());
    }
    private native static void __qt_drawEllipse_QRectF(long __this__nativeId, long r);


    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QImage pm, com.trolltech.qt.core.QRectF sr, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(r, pm, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QImage pm, com.trolltech.qt.core.QRectF sr) {
        drawImage(r, pm, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public void drawImage(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QImage pm, com.trolltech.qt.core.QRectF sr, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QRectF_QImage_QRectF_ImageConversionFlags(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QImage()).nativeId() : pm.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRectF()).nativeId() : sr.nativeId(), flags.value());
    }
    private native static void __qt_drawImage_QRectF_QImage_QRectF_ImageConversionFlags(long __this__nativeId, long r, long pm, long sr, int flags);

    @QtBlockedSlot public void drawLines(com.trolltech.qt.gui.QLineF[] lines) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLines_nativepointer_int(nativeId(), lines);
    }
    private native static void __qt_drawLines_nativepointer_int(long __this__nativeId, com.trolltech.qt.gui.QLineF[] lines);

    @QtBlockedSlot public void drawLines(com.trolltech.qt.gui.QLine[] lines) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLines_nativepointer_int(nativeId(), lines);
    }
    private native static void __qt_drawLines_nativepointer_int(long __this__nativeId, com.trolltech.qt.gui.QLine[] lines);

    @QtBlockedSlot public void drawPath(com.trolltech.qt.gui.QPainterPath path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPath_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static void __qt_drawPath_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public abstract void drawPixmap(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QPixmap pm, com.trolltech.qt.core.QRectF sr);
    private native static void __qt_drawPixmap_QRectF_QPixmap_QRectF(long __this__nativeId, long r, long pm, long sr);

    @QtBlockedSlot public void drawPoints(com.trolltech.qt.core.QPointF[] points) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoints_nativepointer_int(nativeId(), points);
    }
    private native static void __qt_drawPoints_nativepointer_int(long __this__nativeId, com.trolltech.qt.core.QPointF[] points);

    @QtBlockedSlot public void drawPoints(com.trolltech.qt.core.QPoint[] points) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoints_nativepointer_int(nativeId(), points);
    }
    private native static void __qt_drawPoints_nativepointer_int(long __this__nativeId, com.trolltech.qt.core.QPoint[] points);

    @QtBlockedSlot public void drawPolygon(com.trolltech.qt.core.QPointF[] points, com.trolltech.qt.gui.QPaintEngine.PolygonDrawMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolygon_nativepointer_int_PolygonDrawMode(nativeId(), points, mode.value());
    }
    private native static void __qt_drawPolygon_nativepointer_int_PolygonDrawMode(long __this__nativeId, com.trolltech.qt.core.QPointF[] points, int mode);

    @QtBlockedSlot public void drawPolygon(com.trolltech.qt.core.QPoint[] points, com.trolltech.qt.gui.QPaintEngine.PolygonDrawMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolygon_nativepointer_int_PolygonDrawMode(nativeId(), points, mode.value());
    }
    private native static void __qt_drawPolygon_nativepointer_int_PolygonDrawMode(long __this__nativeId, com.trolltech.qt.core.QPoint[] points, int mode);

    @QtBlockedSlot public void drawRects(com.trolltech.qt.core.QRect[] rects) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRects_nativepointer_int(nativeId(), rects);
    }
    private native static void __qt_drawRects_nativepointer_int(long __this__nativeId, com.trolltech.qt.core.QRect[] rects);

    @QtBlockedSlot public void drawRects(com.trolltech.qt.core.QRectF[] rects) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRects_nativepointer_int(nativeId(), rects);
    }
    private native static void __qt_drawRects_nativepointer_int(long __this__nativeId, com.trolltech.qt.core.QRectF[] rects);

    @QtBlockedSlot public void drawTextItem(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QTextItem textItem) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTextItem_QPointF_QTextItem(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), textItem == null ? 0 : textItem.nativeId());
    }
    private native static void __qt_drawTextItem_QPointF_QTextItem(long __this__nativeId, long p, long textItem);

    @QtBlockedSlot public void drawTiledPixmap(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QPixmap pixmap, com.trolltech.qt.core.QPointF s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTiledPixmap_QRectF_QPixmap_QPointF(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), s == null ? (s = new com.trolltech.qt.core.QPointF()).nativeId() : s.nativeId());
    }
    private native static void __qt_drawTiledPixmap_QRectF_QPixmap_QPointF(long __this__nativeId, long r, long pixmap, long s);

    @QtBlockedSlot public abstract boolean end();
    private native static boolean __qt_end(long __this__nativeId);

    @QtBlockedSlot public abstract com.trolltech.qt.gui.QPaintEngine.Type type();
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public abstract void updateState(com.trolltech.qt.gui.QPaintEngineState state);
    private native static void __qt_updateState_QPaintEngineState(long __this__nativeId, long state);

    @QtBlockedSlot protected final void setSelfDestruct(int selfDestruct) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelfDestruct_int(nativeId(), selfDestruct);
    }
    private native static void __qt_setSelfDestruct_int(long __this__nativeId, int selfDestruct);

    @QtBlockedSlot protected final int selfDestruct() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selfDestruct(nativeId());
    }
    private native static int __qt_selfDestruct(long __this__nativeId);

    @QtBlockedSlot protected final void setActive(int active) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setActive_int(nativeId(), active);
    }
    private native static void __qt_setActive_int(long __this__nativeId, int active);

    @QtBlockedSlot protected final int active() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_active(nativeId());
    }
    private native static int __qt_active(long __this__nativeId);


    @QtBlockedSlot protected final void setGccaps(com.trolltech.qt.gui.QPaintEngine.PaintEngineFeature ... gccaps) {
        this.setGccaps(new com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures(gccaps));
    }
    @QtBlockedSlot protected final void setGccaps(com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures gccaps) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGccaps_PaintEngineFeatures(nativeId(), gccaps.value());
    }
    private native static void __qt_setGccaps_PaintEngineFeatures(long __this__nativeId, int gccaps);

    @QtBlockedSlot protected final com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures gccaps() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QPaintEngine.PaintEngineFeatures(__qt_gccaps(nativeId()));
    }
    private native static int __qt_gccaps(long __this__nativeId);


    public static native QPaintEngine fromNativePointer(QNativePointer nativePointer);

    protected QPaintEngine(QPrivateConstructor p) { super(p); } 

}
