package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QPainter extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum CompositionMode implements com.trolltech.qt.QtEnumerator {
        CompositionMode_SourceOver(0),
        CompositionMode_DestinationOver(1),
        CompositionMode_Clear(2),
        CompositionMode_Source(3),
        CompositionMode_Destination(4),
        CompositionMode_SourceIn(5),
        CompositionMode_DestinationIn(6),
        CompositionMode_SourceOut(7),
        CompositionMode_DestinationOut(8),
        CompositionMode_SourceAtop(9),
        CompositionMode_DestinationAtop(10),
        CompositionMode_Xor(11),
        CompositionMode_Plus(12),
        CompositionMode_Multiply(13),
        CompositionMode_Screen(14),
        CompositionMode_Overlay(15),
        CompositionMode_Darken(16),
        CompositionMode_Lighten(17),
        CompositionMode_ColorDodge(18),
        CompositionMode_ColorBurn(19),
        CompositionMode_HardLight(20),
        CompositionMode_SoftLight(21),
        CompositionMode_Difference(22),
        CompositionMode_Exclusion(23);

        CompositionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CompositionMode resolve(int value) {
            return (CompositionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CompositionMode_SourceOver;
            case 1: return CompositionMode_DestinationOver;
            case 2: return CompositionMode_Clear;
            case 3: return CompositionMode_Source;
            case 4: return CompositionMode_Destination;
            case 5: return CompositionMode_SourceIn;
            case 6: return CompositionMode_DestinationIn;
            case 7: return CompositionMode_SourceOut;
            case 8: return CompositionMode_DestinationOut;
            case 9: return CompositionMode_SourceAtop;
            case 10: return CompositionMode_DestinationAtop;
            case 11: return CompositionMode_Xor;
            case 12: return CompositionMode_Plus;
            case 13: return CompositionMode_Multiply;
            case 14: return CompositionMode_Screen;
            case 15: return CompositionMode_Overlay;
            case 16: return CompositionMode_Darken;
            case 17: return CompositionMode_Lighten;
            case 18: return CompositionMode_ColorDodge;
            case 19: return CompositionMode_ColorBurn;
            case 20: return CompositionMode_HardLight;
            case 21: return CompositionMode_SoftLight;
            case 22: return CompositionMode_Difference;
            case 23: return CompositionMode_Exclusion;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum RenderHint implements com.trolltech.qt.QtEnumerator {
        Antialiasing(1),
        TextAntialiasing(2),
        SmoothPixmapTransform(4),
        HighQualityAntialiasing(8);

        RenderHint(int value) { this.value = value; }
        public int value() { return value; }

        public static RenderHints createQFlags(RenderHint ... values) {
            return new RenderHints(values);
        }
        public static RenderHint resolve(int value) {
            return (RenderHint) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Antialiasing;
            case 2: return TextAntialiasing;
            case 4: return SmoothPixmapTransform;
            case 8: return HighQualityAntialiasing;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class RenderHints extends com.trolltech.qt.QFlags<RenderHint> {
        private static final long serialVersionUID = 1L;
        public RenderHints(RenderHint ... args) { super(args); }
        public RenderHints(int value) { setValue(value); }
    }


    public QPainter() {
        super((QPrivateConstructor)null);
        __qt_QPainter();
    }
    private native void __qt_QPainter();


    public QPainter(com.trolltech.qt.gui.QPaintDeviceInterface arg__1) {
        super((QPrivateConstructor)null);
        if (arg__1 == null)
            throw new NullPointerException("Argument 'arg__1': null not expected.");
        __qt_QPainter_QPaintDevice(arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native void __qt_QPainter_QPaintDevice(long arg__1);


    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.BGMode backgroundMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.BGMode.resolve(__qt_backgroundMode(nativeId()));
    }
    private native static int __qt_backgroundMode(long __this__nativeId);

    @QtBlockedSlot public final boolean begin(com.trolltech.qt.gui.QPaintDeviceInterface arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (arg__1 == null)
            throw new NullPointerException("Argument 'arg__1': null not expected.");
        return __qt_begin_QPaintDevice(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_begin_QPaintDevice(long __this__nativeId, long arg__1);


    @QtBlockedSlot public final com.trolltech.qt.core.QRectF boundingRect(com.trolltech.qt.core.QRectF rect, java.lang.String text) {
        return boundingRect(rect, text, (com.trolltech.qt.gui.QTextOption)new com.trolltech.qt.gui.QTextOption());
    }
    @QtBlockedSlot public final com.trolltech.qt.core.QRectF boundingRect(com.trolltech.qt.core.QRectF rect, java.lang.String text, com.trolltech.qt.gui.QTextOption o) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect_QRectF_String_QTextOption(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), text, o == null ? (o = new com.trolltech.qt.gui.QTextOption()).nativeId() : o.nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_boundingRect_QRectF_String_QTextOption(long __this__nativeId, long rect, java.lang.String text, long o);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect boundingRect(com.trolltech.qt.core.QRect rect, int flags, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect_QRect_int_String(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId(), flags, text);
    }
    private native static com.trolltech.qt.core.QRect __qt_boundingRect_QRect_int_String(long __this__nativeId, long rect, int flags, java.lang.String text);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF boundingRect(com.trolltech.qt.core.QRectF rect, int flags, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect_QRectF_int_String(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), flags, text);
    }
    private native static com.trolltech.qt.core.QRectF __qt_boundingRect_QRectF_int_String(long __this__nativeId, long rect, int flags, java.lang.String text);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect boundingRect(int x, int y, int w, int h, int flags, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect_int_int_int_int_int_String(nativeId(), x, y, w, h, flags, text);
    }
    private native static com.trolltech.qt.core.QRect __qt_boundingRect_int_int_int_int_int_String(long __this__nativeId, int x, int y, int w, int h, int flags, java.lang.String text);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush brush() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_brush(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint brushOrigin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_brushOrigin(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_brushOrigin(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath clipPath() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clipPath(nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_clipPath(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion clipRegion() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clipRegion(nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_clipRegion(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMatrix combinedMatrix() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_combinedMatrix(nativeId());
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_combinedMatrix(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform combinedTransform() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_combinedTransform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_combinedTransform(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainter.CompositionMode compositionMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPainter.CompositionMode.resolve(__qt_compositionMode(nativeId()));
    }
    private native static int __qt_compositionMode(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPaintDeviceInterface device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_device(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintDeviceInterface __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMatrix deviceMatrix() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_deviceMatrix(nativeId());
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_deviceMatrix(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform deviceTransform() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_deviceTransform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_deviceTransform(long __this__nativeId);

    @QtBlockedSlot public final void drawArc(com.trolltech.qt.core.QRectF rect, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawArc_QRectF_int_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), a, alen);
    }
    private native static void __qt_drawArc_QRectF_int_int(long __this__nativeId, long rect, int a, int alen);

    @QtBlockedSlot public final void drawArc(int x, int y, int w, int h, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawArc_int_int_int_int_int_int(nativeId(), x, y, w, h, a, alen);
    }
    private native static void __qt_drawArc_int_int_int_int_int_int(long __this__nativeId, int x, int y, int w, int h, int a, int alen);

    @QtBlockedSlot public final void drawArc(com.trolltech.qt.core.QRect arg__1, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawArc_QRect_int_int(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), a, alen);
    }
    private native static void __qt_drawArc_QRect_int_int(long __this__nativeId, long arg__1, int a, int alen);

    @QtBlockedSlot public final void drawChord(int x, int y, int w, int h, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawChord_int_int_int_int_int_int(nativeId(), x, y, w, h, a, alen);
    }
    private native static void __qt_drawChord_int_int_int_int_int_int(long __this__nativeId, int x, int y, int w, int h, int a, int alen);

    @QtBlockedSlot public final void drawChord(com.trolltech.qt.core.QRect arg__1, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawChord_QRect_int_int(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), a, alen);
    }
    private native static void __qt_drawChord_QRect_int_int(long __this__nativeId, long arg__1, int a, int alen);

    @QtBlockedSlot public final void drawChord(com.trolltech.qt.core.QRectF rect, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawChord_QRectF_int_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), a, alen);
    }
    private native static void __qt_drawChord_QRectF_int_int(long __this__nativeId, long rect, int a, int alen);

    @QtBlockedSlot public final void drawConvexPolygon(com.trolltech.qt.gui.QPolygonF polygon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawConvexPolygon_QPolygonF(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId());
    }
    private native static void __qt_drawConvexPolygon_QPolygonF(long __this__nativeId, long polygon);

    @QtBlockedSlot public final void drawConvexPolygon(com.trolltech.qt.gui.QPolygon polygon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawConvexPolygon_QPolygon(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygon()).nativeId() : polygon.nativeId());
    }
    private native static void __qt_drawConvexPolygon_QPolygon(long __this__nativeId, long polygon);

    @QtBlockedSlot public final void drawEllipse(com.trolltech.qt.core.QRectF r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawEllipse_QRectF(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId());
    }
    private native static void __qt_drawEllipse_QRectF(long __this__nativeId, long r);

    @QtBlockedSlot public final void drawEllipse(com.trolltech.qt.core.QRect r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawEllipse_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static void __qt_drawEllipse_QRect(long __this__nativeId, long r);

    @QtBlockedSlot public final void drawEllipse(int x, int y, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawEllipse_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_drawEllipse_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);


    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sr, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(p, image, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sr) {
        drawImage(p, image, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sr, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QPoint_QImage_QRect_ImageConversionFlags(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRect()).nativeId() : sr.nativeId(), flags.value());
    }
    private native static void __qt_drawImage_QPoint_QImage_QRect_ImageConversionFlags(long __this__nativeId, long p, long image, long sr, int flags);


    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sr, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(p, image, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sr) {
        drawImage(p, image, sr, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sr, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QPointF_QImage_QRectF_ImageConversionFlags(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRectF()).nativeId() : sr.nativeId(), flags.value());
    }
    private native static void __qt_drawImage_QPointF_QImage_QRectF_ImageConversionFlags(long __this__nativeId, long p, long image, long sr, int flags);

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRect r, com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QRect_QImage(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static void __qt_drawImage_QRect_QImage(long __this__nativeId, long r, long image);


    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sourceRect, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(targetRect, image, sourceRect, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sourceRect) {
        drawImage(targetRect, image, sourceRect, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRectF sourceRect, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QRectF_QImage_QRectF_ImageConversionFlags(nativeId(), targetRect == null ? (targetRect = new com.trolltech.qt.core.QRectF()).nativeId() : targetRect.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), sourceRect == null ? (sourceRect = new com.trolltech.qt.core.QRectF()).nativeId() : sourceRect.nativeId(), flags.value());
    }
    private native static void __qt_drawImage_QRectF_QImage_QRectF_ImageConversionFlags(long __this__nativeId, long targetRect, long image, long sourceRect, int flags);


    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx, int sy, int sw, int sh, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(x, y, image, sx, sy, sw, sh, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx, int sy, int sw, int sh) {
        drawImage(x, y, image, sx, sy, sw, sh, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }

    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx, int sy, int sw) {
        drawImage(x, y, image, sx, sy, sw, (int)-1, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }

    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx, int sy) {
        drawImage(x, y, image, sx, sy, (int)-1, (int)-1, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }

    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx) {
        drawImage(x, y, image, sx, (int)0, (int)-1, (int)-1, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }

    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image) {
        drawImage(x, y, image, (int)0, (int)0, (int)-1, (int)-1, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final void drawImage(int x, int y, com.trolltech.qt.gui.QImage image, int sx, int sy, int sw, int sh, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_int_int_QImage_int_int_int_int_ImageConversionFlags(nativeId(), x, y, image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), sx, sy, sw, sh, flags.value());
    }
    private native static void __qt_drawImage_int_int_QImage_int_int_int_int_ImageConversionFlags(long __this__nativeId, int x, int y, long image, int sx, int sy, int sw, int sh, int flags);

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QPointF_QImage(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static void __qt_drawImage_QPointF_QImage(long __this__nativeId, long p, long image);

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QPoint_QImage(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static void __qt_drawImage_QPoint_QImage(long __this__nativeId, long p, long image);


    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRect targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sourceRect, com.trolltech.qt.core.Qt.ImageConversionFlag ... flags) {
        this.drawImage(targetRect, image, sourceRect, new com.trolltech.qt.core.Qt.ImageConversionFlags(flags));
    }

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRect targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sourceRect) {
        drawImage(targetRect, image, sourceRect, new com.trolltech.qt.core.Qt.ImageConversionFlags(0));
    }
    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRect targetRect, com.trolltech.qt.gui.QImage image, com.trolltech.qt.core.QRect sourceRect, com.trolltech.qt.core.Qt.ImageConversionFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QRect_QImage_QRect_ImageConversionFlags(nativeId(), targetRect == null ? (targetRect = new com.trolltech.qt.core.QRect()).nativeId() : targetRect.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId(), sourceRect == null ? (sourceRect = new com.trolltech.qt.core.QRect()).nativeId() : sourceRect.nativeId(), flags.value());
    }
    private native static void __qt_drawImage_QRect_QImage_QRect_ImageConversionFlags(long __this__nativeId, long targetRect, long image, long sourceRect, int flags);

    @QtBlockedSlot public final void drawImage(com.trolltech.qt.core.QRectF r, com.trolltech.qt.gui.QImage image) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawImage_QRectF_QImage(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), image == null ? (image = new com.trolltech.qt.gui.QImage()).nativeId() : image.nativeId());
    }
    private native static void __qt_drawImage_QRectF_QImage(long __this__nativeId, long r, long image);

    @QtBlockedSlot public final void drawLine(com.trolltech.qt.gui.QLine line) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLine_QLine(nativeId(), line == null ? (line = new com.trolltech.qt.gui.QLine()).nativeId() : line.nativeId());
    }
    private native static void __qt_drawLine_QLine(long __this__nativeId, long line);

    @QtBlockedSlot public final void drawLine(com.trolltech.qt.core.QPoint p1, com.trolltech.qt.core.QPoint p2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLine_QPoint_QPoint(nativeId(), p1 == null ? (p1 = new com.trolltech.qt.core.QPoint()).nativeId() : p1.nativeId(), p2 == null ? (p2 = new com.trolltech.qt.core.QPoint()).nativeId() : p2.nativeId());
    }
    private native static void __qt_drawLine_QPoint_QPoint(long __this__nativeId, long p1, long p2);

    @QtBlockedSlot public final void drawLine(com.trolltech.qt.core.QPointF p1, com.trolltech.qt.core.QPointF p2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLine_QPointF_QPointF(nativeId(), p1 == null ? (p1 = new com.trolltech.qt.core.QPointF()).nativeId() : p1.nativeId(), p2 == null ? (p2 = new com.trolltech.qt.core.QPointF()).nativeId() : p2.nativeId());
    }
    private native static void __qt_drawLine_QPointF_QPointF(long __this__nativeId, long p1, long p2);

    @QtBlockedSlot public final void drawLine(int x1, int y1, int x2, int y2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLine_int_int_int_int(nativeId(), x1, y1, x2, y2);
    }
    private native static void __qt_drawLine_int_int_int_int(long __this__nativeId, int x1, int y1, int x2, int y2);

    @QtBlockedSlot public final void drawLine(com.trolltech.qt.gui.QLineF line) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLine_QLineF(nativeId(), line == null ? (line = new com.trolltech.qt.gui.QLineF()).nativeId() : line.nativeId());
    }
    private native static void __qt_drawLine_QLineF(long __this__nativeId, long line);

    @QtBlockedSlot public final void drawLinesFromPointsF(java.util.List<com.trolltech.qt.core.QPointF> pointPairs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLinesFromPointsF_List(nativeId(), pointPairs);
    }
    private native static void __qt_drawLinesFromPointsF_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QPointF> pointPairs);

    @QtBlockedSlot public final void drawLinesF(java.util.List<com.trolltech.qt.gui.QLineF> lines) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLinesF_List(nativeId(), lines);
    }
    private native static void __qt_drawLinesF_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QLineF> lines);

    @QtBlockedSlot public final void drawLines(java.util.List<com.trolltech.qt.gui.QLine> lines) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLines_List(nativeId(), lines);
    }
    private native static void __qt_drawLines_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QLine> lines);

    @QtBlockedSlot public final void drawLinesFromPoints(java.util.List<com.trolltech.qt.core.QPoint> pointPairs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawLinesFromPoints_List(nativeId(), pointPairs);
    }
    private native static void __qt_drawLinesFromPoints_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QPoint> pointPairs);

    @QtBlockedSlot public final void drawPath(com.trolltech.qt.gui.QPainterPath path) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPath_QPainterPath(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId());
    }
    private native static void __qt_drawPath_QPainterPath(long __this__nativeId, long path);

    @QtBlockedSlot public final void drawPicture(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QPicture picture) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPicture_QPoint_QPicture(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), picture == null ? 0 : picture.nativeId());
    }
    private native static void __qt_drawPicture_QPoint_QPicture(long __this__nativeId, long p, long picture);

    @QtBlockedSlot public final void drawPicture(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QPicture picture) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPicture_QPointF_QPicture(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), picture == null ? 0 : picture.nativeId());
    }
    private native static void __qt_drawPicture_QPointF_QPicture(long __this__nativeId, long p, long picture);

    @QtBlockedSlot public final void drawPicture(int x, int y, com.trolltech.qt.gui.QPicture picture) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPicture_int_int_QPicture(nativeId(), x, y, picture == null ? 0 : picture.nativeId());
    }
    private native static void __qt_drawPicture_int_int_QPicture(long __this__nativeId, int x, int y, long picture);

    @QtBlockedSlot public final void drawPie(int x, int y, int w, int h, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPie_int_int_int_int_int_int(nativeId(), x, y, w, h, a, alen);
    }
    private native static void __qt_drawPie_int_int_int_int_int_int(long __this__nativeId, int x, int y, int w, int h, int a, int alen);

    @QtBlockedSlot public final void drawPie(com.trolltech.qt.core.QRect arg__1, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPie_QRect_int_int(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), a, alen);
    }
    private native static void __qt_drawPie_QRect_int_int(long __this__nativeId, long arg__1, int a, int alen);

    @QtBlockedSlot public final void drawPie(com.trolltech.qt.core.QRectF rect, int a, int alen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPie_QRectF_int_int(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), a, alen);
    }
    private native static void __qt_drawPie_QRectF_int_int(long __this__nativeId, long rect, int a, int alen);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QRect r, com.trolltech.qt.gui.QPixmap pm) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QRect_QPixmap(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId());
    }
    private native static void __qt_drawPixmap_QRect_QPixmap(long __this__nativeId, long r, long pm);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QPixmap pm, com.trolltech.qt.core.QRect sr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QPoint_QPixmap_QRect(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRect()).nativeId() : sr.nativeId());
    }
    private native static void __qt_drawPixmap_QPoint_QPixmap_QRect(long __this__nativeId, long p, long pm, long sr);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QRectF targetRect, com.trolltech.qt.gui.QPixmap pixmap, com.trolltech.qt.core.QRectF sourceRect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QRectF_QPixmap_QRectF(nativeId(), targetRect == null ? (targetRect = new com.trolltech.qt.core.QRectF()).nativeId() : targetRect.nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), sourceRect == null ? (sourceRect = new com.trolltech.qt.core.QRectF()).nativeId() : sourceRect.nativeId());
    }
    private native static void __qt_drawPixmap_QRectF_QPixmap_QRectF(long __this__nativeId, long targetRect, long pixmap, long sourceRect);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QPixmap pm) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QPointF_QPixmap(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId());
    }
    private native static void __qt_drawPixmap_QPointF_QPixmap(long __this__nativeId, long p, long pm);

    @QtBlockedSlot public final void drawPixmap(int x, int y, int w, int h, com.trolltech.qt.gui.QPixmap pm, int sx, int sy, int sw, int sh) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_int_int_int_int_QPixmap_int_int_int_int(nativeId(), x, y, w, h, pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), sx, sy, sw, sh);
    }
    private native static void __qt_drawPixmap_int_int_int_int_QPixmap_int_int_int_int(long __this__nativeId, int x, int y, int w, int h, long pm, int sx, int sy, int sw, int sh);

    @QtBlockedSlot public final void drawPixmap(int x, int y, com.trolltech.qt.gui.QPixmap pm) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_int_int_QPixmap(nativeId(), x, y, pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId());
    }
    private native static void __qt_drawPixmap_int_int_QPixmap(long __this__nativeId, int x, int y, long pm);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QPixmap pm) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QPoint_QPixmap(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId());
    }
    private native static void __qt_drawPixmap_QPoint_QPixmap(long __this__nativeId, long p, long pm);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QPixmap pm, com.trolltech.qt.core.QRectF sr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QPointF_QPixmap_QRectF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), sr == null ? (sr = new com.trolltech.qt.core.QRectF()).nativeId() : sr.nativeId());
    }
    private native static void __qt_drawPixmap_QPointF_QPixmap_QRectF(long __this__nativeId, long p, long pm, long sr);

    @QtBlockedSlot public final void drawPixmap(int x, int y, int w, int h, com.trolltech.qt.gui.QPixmap pm) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_int_int_int_int_QPixmap(nativeId(), x, y, w, h, pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId());
    }
    private native static void __qt_drawPixmap_int_int_int_int_QPixmap(long __this__nativeId, int x, int y, int w, int h, long pm);

    @QtBlockedSlot public final void drawPixmap(int x, int y, com.trolltech.qt.gui.QPixmap pm, int sx, int sy, int sw, int sh) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_int_int_QPixmap_int_int_int_int(nativeId(), x, y, pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), sx, sy, sw, sh);
    }
    private native static void __qt_drawPixmap_int_int_QPixmap_int_int_int_int(long __this__nativeId, int x, int y, long pm, int sx, int sy, int sw, int sh);

    @QtBlockedSlot public final void drawPixmap(com.trolltech.qt.core.QRect targetRect, com.trolltech.qt.gui.QPixmap pixmap, com.trolltech.qt.core.QRect sourceRect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPixmap_QRect_QPixmap_QRect(nativeId(), targetRect == null ? (targetRect = new com.trolltech.qt.core.QRect()).nativeId() : targetRect.nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId(), sourceRect == null ? (sourceRect = new com.trolltech.qt.core.QRect()).nativeId() : sourceRect.nativeId());
    }
    private native static void __qt_drawPixmap_QRect_QPixmap_QRect(long __this__nativeId, long targetRect, long pixmap, long sourceRect);

    @QtBlockedSlot public final void drawPoint(com.trolltech.qt.core.QPointF pt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoint_QPointF(nativeId(), pt == null ? (pt = new com.trolltech.qt.core.QPointF()).nativeId() : pt.nativeId());
    }
    private native static void __qt_drawPoint_QPointF(long __this__nativeId, long pt);

    @QtBlockedSlot public final void drawPoint(int x, int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoint_int_int(nativeId(), x, y);
    }
    private native static void __qt_drawPoint_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final void drawPoint(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoint_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static void __qt_drawPoint_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final void drawPoints(com.trolltech.qt.gui.QPolygon points) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoints_QPolygon(nativeId(), points == null ? (points = new com.trolltech.qt.gui.QPolygon()).nativeId() : points.nativeId());
    }
    private native static void __qt_drawPoints_QPolygon(long __this__nativeId, long points);

    @QtBlockedSlot public final void drawPoints(com.trolltech.qt.gui.QPolygonF points) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPoints_QPolygonF(nativeId(), points == null ? (points = new com.trolltech.qt.gui.QPolygonF()).nativeId() : points.nativeId());
    }
    private native static void __qt_drawPoints_QPolygonF(long __this__nativeId, long points);


    @QtBlockedSlot public final void drawPolygon(com.trolltech.qt.gui.QPolygonF polygon) {
        drawPolygon(polygon, com.trolltech.qt.core.Qt.FillRule.OddEvenFill);
    }
    @QtBlockedSlot public final void drawPolygon(com.trolltech.qt.gui.QPolygonF polygon, com.trolltech.qt.core.Qt.FillRule fillRule) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolygon_QPolygonF_FillRule(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polygon.nativeId(), fillRule.value());
    }
    private native static void __qt_drawPolygon_QPolygonF_FillRule(long __this__nativeId, long polygon, int fillRule);


    @QtBlockedSlot public final void drawPolygon(com.trolltech.qt.gui.QPolygon polygon) {
        drawPolygon(polygon, com.trolltech.qt.core.Qt.FillRule.OddEvenFill);
    }
    @QtBlockedSlot public final void drawPolygon(com.trolltech.qt.gui.QPolygon polygon, com.trolltech.qt.core.Qt.FillRule fillRule) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolygon_QPolygon_FillRule(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygon()).nativeId() : polygon.nativeId(), fillRule.value());
    }
    private native static void __qt_drawPolygon_QPolygon_FillRule(long __this__nativeId, long polygon, int fillRule);

    @QtBlockedSlot public final void drawPolyline(com.trolltech.qt.gui.QPolygon polygon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolyline_QPolygon(nativeId(), polygon == null ? (polygon = new com.trolltech.qt.gui.QPolygon()).nativeId() : polygon.nativeId());
    }
    private native static void __qt_drawPolyline_QPolygon(long __this__nativeId, long polygon);

    @QtBlockedSlot public final void drawPolyline(com.trolltech.qt.gui.QPolygonF polyline) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawPolyline_QPolygonF(nativeId(), polyline == null ? (polyline = new com.trolltech.qt.gui.QPolygonF()).nativeId() : polyline.nativeId());
    }
    private native static void __qt_drawPolyline_QPolygonF(long __this__nativeId, long polyline);

    @QtBlockedSlot public final void drawRect(int x1, int y1, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRect_int_int_int_int(nativeId(), x1, y1, w, h);
    }
    private native static void __qt_drawRect_int_int_int_int(long __this__nativeId, int x1, int y1, int w, int h);

    @QtBlockedSlot public final void drawRect(com.trolltech.qt.core.QRectF rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRect_QRectF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawRect_QRectF(long __this__nativeId, long rect);

    @QtBlockedSlot public final void drawRect(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRect_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_drawRect_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final void drawRects(java.util.List<com.trolltech.qt.core.QRect> rectangles) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRects_List(nativeId(), rectangles);
    }
    private native static void __qt_drawRects_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QRect> rectangles);

    @QtBlockedSlot public final void drawRectsF(java.util.List<com.trolltech.qt.core.QRectF> rectangles) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRectsF_List(nativeId(), rectangles);
    }
    private native static void __qt_drawRectsF_List(long __this__nativeId, java.util.List<com.trolltech.qt.core.QRectF> rectangles);


    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRect r, int xround) {
        drawRoundRect(r, xround, (int)25);
    }

    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRect r) {
        drawRoundRect(r, (int)25, (int)25);
    }
    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRect r, int xround, int yround) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRoundRect_QRect_int_int(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId(), xround, yround);
    }
    private native static void __qt_drawRoundRect_QRect_int_int(long __this__nativeId, long r, int xround, int yround);


    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRectF r, int xround) {
        drawRoundRect(r, xround, (int)25);
    }

    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRectF r) {
        drawRoundRect(r, (int)25, (int)25);
    }
    @QtBlockedSlot public final void drawRoundRect(com.trolltech.qt.core.QRectF r, int xround, int yround) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRoundRect_QRectF_int_int(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), xround, yround);
    }
    private native static void __qt_drawRoundRect_QRectF_int_int(long __this__nativeId, long r, int xround, int yround);


    @QtBlockedSlot public final void drawRoundRect(int x, int y, int w, int h, int arg__5) {
        drawRoundRect(x, y, w, h, arg__5, (int)25);
    }

    @QtBlockedSlot public final void drawRoundRect(int x, int y, int w, int h) {
        drawRoundRect(x, y, w, h, (int)25, (int)25);
    }
    @QtBlockedSlot public final void drawRoundRect(int x, int y, int w, int h, int arg__5, int arg__6) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawRoundRect_int_int_int_int_int_int(nativeId(), x, y, w, h, arg__5, arg__6);
    }
    private native static void __qt_drawRoundRect_int_int_int_int_int_int(long __this__nativeId, int x, int y, int w, int h, int arg__5, int arg__6);


    @QtBlockedSlot public final void drawText(com.trolltech.qt.core.QRectF r, java.lang.String text) {
        drawText(r, text, (com.trolltech.qt.gui.QTextOption)new com.trolltech.qt.gui.QTextOption());
    }
    @QtBlockedSlot public final void drawText(com.trolltech.qt.core.QRectF r, java.lang.String text, com.trolltech.qt.gui.QTextOption o) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_QRectF_String_QTextOption(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), text, o == null ? (o = new com.trolltech.qt.gui.QTextOption()).nativeId() : o.nativeId());
    }
    private native static void __qt_drawText_QRectF_String_QTextOption(long __this__nativeId, long r, java.lang.String text, long o);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void drawText(com.trolltech.qt.core.QRect r, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_QRect_int_String_nativepointer(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId(), flags, text, br);
    }
    private native static void __qt_drawText_QRect_int_String_nativepointer(long __this__nativeId, long r, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void drawText(int x, int y, int w, int h, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_int_int_int_int_int_String_nativepointer(nativeId(), x, y, w, h, flags, text, br);
    }
    private native static void __qt_drawText_int_int_int_int_int_String_nativepointer(long __this__nativeId, int x, int y, int w, int h, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br);

    @QtBlockedSlot public final void drawText(int x, int y, java.lang.String s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_int_int_String(nativeId(), x, y, s);
    }
    private native static void __qt_drawText_int_int_String(long __this__nativeId, int x, int y, java.lang.String s);

    @QtBlockedSlot public final void drawText(com.trolltech.qt.core.QPointF p, java.lang.String s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_QPointF_String(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), s);
    }
    private native static void __qt_drawText_QPointF_String(long __this__nativeId, long p, java.lang.String s);

    @QtBlockedSlot public final void drawText(com.trolltech.qt.core.QPoint p, java.lang.String s) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_QPoint_String(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), s);
    }
    private native static void __qt_drawText_QPoint_String(long __this__nativeId, long p, java.lang.String s);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void drawText(com.trolltech.qt.core.QRectF r, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawText_QRectF_int_String_nativepointer(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRectF()).nativeId() : r.nativeId(), flags, text, br);
    }
    private native static void __qt_drawText_QRectF_int_String_nativepointer(long __this__nativeId, long r, int flags, java.lang.String text, com.trolltech.qt.QNativePointer br);

    @QtBlockedSlot public final void drawTextItem(int x, int y, com.trolltech.qt.gui.QTextItem ti) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTextItem_int_int_QTextItem(nativeId(), x, y, ti == null ? 0 : ti.nativeId());
    }
    private native static void __qt_drawTextItem_int_int_QTextItem(long __this__nativeId, int x, int y, long ti);

    @QtBlockedSlot public final void drawTextItem(com.trolltech.qt.core.QPoint p, com.trolltech.qt.gui.QTextItem ti) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTextItem_QPoint_QTextItem(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId(), ti == null ? 0 : ti.nativeId());
    }
    private native static void __qt_drawTextItem_QPoint_QTextItem(long __this__nativeId, long p, long ti);

    @QtBlockedSlot public final void drawTextItem(com.trolltech.qt.core.QPointF p, com.trolltech.qt.gui.QTextItem ti) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTextItem_QPointF_QTextItem(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId(), ti == null ? 0 : ti.nativeId());
    }
    private native static void __qt_drawTextItem_QPointF_QTextItem(long __this__nativeId, long p, long ti);


    @QtBlockedSlot public final void drawTiledPixmap(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPixmap pm) {
        drawTiledPixmap(rect, pm, (com.trolltech.qt.core.QPointF)new com.trolltech.qt.core.QPointF());
    }
    @QtBlockedSlot public final void drawTiledPixmap(com.trolltech.qt.core.QRectF rect, com.trolltech.qt.gui.QPixmap pm, com.trolltech.qt.core.QPointF offset) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTiledPixmap_QRectF_QPixmap_QPointF(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRectF()).nativeId() : rect.nativeId(), pm == null ? (pm = new com.trolltech.qt.gui.QPixmap()).nativeId() : pm.nativeId(), offset == null ? (offset = new com.trolltech.qt.core.QPointF()).nativeId() : offset.nativeId());
    }
    private native static void __qt_drawTiledPixmap_QRectF_QPixmap_QPointF(long __this__nativeId, long rect, long pm, long offset);


    @QtBlockedSlot public final void drawTiledPixmap(int x, int y, int w, int h, com.trolltech.qt.gui.QPixmap arg__5, int sx) {
        drawTiledPixmap(x, y, w, h, arg__5, sx, (int)0);
    }

    @QtBlockedSlot public final void drawTiledPixmap(int x, int y, int w, int h, com.trolltech.qt.gui.QPixmap arg__5) {
        drawTiledPixmap(x, y, w, h, arg__5, (int)0, (int)0);
    }
    @QtBlockedSlot public final void drawTiledPixmap(int x, int y, int w, int h, com.trolltech.qt.gui.QPixmap arg__5, int sx, int sy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTiledPixmap_int_int_int_int_QPixmap_int_int(nativeId(), x, y, w, h, arg__5 == null ? (arg__5 = new com.trolltech.qt.gui.QPixmap()).nativeId() : arg__5.nativeId(), sx, sy);
    }
    private native static void __qt_drawTiledPixmap_int_int_int_int_QPixmap_int_int(long __this__nativeId, int x, int y, int w, int h, long arg__5, int sx, int sy);


    @QtBlockedSlot public final void drawTiledPixmap(com.trolltech.qt.core.QRect arg__1, com.trolltech.qt.gui.QPixmap arg__2) {
        drawTiledPixmap(arg__1, arg__2, (com.trolltech.qt.core.QPoint)new com.trolltech.qt.core.QPoint());
    }
    @QtBlockedSlot public final void drawTiledPixmap(com.trolltech.qt.core.QRect arg__1, com.trolltech.qt.gui.QPixmap arg__2, com.trolltech.qt.core.QPoint arg__3) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawTiledPixmap_QRect_QPixmap_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.gui.QPixmap()).nativeId() : arg__2.nativeId(), arg__3 == null ? (arg__3 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__3.nativeId());
    }
    private native static void __qt_drawTiledPixmap_QRect_QPixmap_QPoint(long __this__nativeId, long arg__1, long arg__2, long arg__3);

    @QtBlockedSlot public final boolean end() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_end(nativeId());
    }
    private native static boolean __qt_end(long __this__nativeId);

    @QtBlockedSlot public final void eraseRect(int x, int y, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_eraseRect_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_eraseRect_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    @QtBlockedSlot public final void eraseRect(com.trolltech.qt.core.QRectF arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_eraseRect_QRectF(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRectF()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_eraseRect_QRectF(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void eraseRect(com.trolltech.qt.core.QRect arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_eraseRect_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_eraseRect_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void fillPath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fillPath_QPainterPath_QBrush(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_fillPath_QPainterPath_QBrush(long __this__nativeId, long path, long brush);

    @QtBlockedSlot public final void fillRect(com.trolltech.qt.core.QRect arg__1, com.trolltech.qt.gui.QBrush arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fillRect_QRect_QBrush(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.gui.QBrush()).nativeId() : arg__2.nativeId());
    }
    private native static void __qt_fillRect_QRect_QBrush(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot public final void fillRect(int x, int y, int w, int h, com.trolltech.qt.gui.QBrush arg__5) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fillRect_int_int_int_int_QBrush(nativeId(), x, y, w, h, arg__5 == null ? (arg__5 = new com.trolltech.qt.gui.QBrush()).nativeId() : arg__5.nativeId());
    }
    private native static void __qt_fillRect_int_int_int_int_QBrush(long __this__nativeId, int x, int y, int w, int h, long arg__5);

    @QtBlockedSlot public final void fillRect(com.trolltech.qt.core.QRectF arg__1, com.trolltech.qt.gui.QBrush arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_fillRect_QRectF_QBrush(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRectF()).nativeId() : arg__1.nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.gui.QBrush()).nativeId() : arg__2.nativeId());
    }
    private native static void __qt_fillRect_QRectF_QBrush(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFontInfo fontInfo() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontInfo(nativeId());
    }
    private native static com.trolltech.qt.gui.QFontInfo __qt_fontInfo(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFontMetrics fontMetrics() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontMetrics(nativeId());
    }
    private native static com.trolltech.qt.gui.QFontMetrics __qt_fontMetrics(long __this__nativeId);

    @QtBlockedSlot public final boolean hasClipping() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasClipping(nativeId());
    }
    private native static boolean __qt_hasClipping(long __this__nativeId);

    @QtBlockedSlot public final void initFrom(com.trolltech.qt.gui.QWidget widget) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (widget == null)
            throw new NullPointerException("Argument 'widget': null not expected.");
        __qt_initFrom_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_initFrom_QWidget(long __this__nativeId, long widget);

    @QtBlockedSlot public final boolean isActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isActive(nativeId());
    }
    private native static boolean __qt_isActive(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.LayoutDirection layoutDirection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_layoutDirection(nativeId()));
    }
    private native static int __qt_layoutDirection(long __this__nativeId);

    @QtBlockedSlot public final double opacity() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_opacity(nativeId());
    }
    private native static double __qt_opacity(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPen pen() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pen(nativeId());
    }
    private native static com.trolltech.qt.gui.QPen __qt_pen(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainter.RenderHints renderHints() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QPainter.RenderHints(__qt_renderHints(nativeId()));
    }
    private native static int __qt_renderHints(long __this__nativeId);

    @QtBlockedSlot public final void resetMatrix() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetMatrix(nativeId());
    }
    private native static void __qt_resetMatrix(long __this__nativeId);

    @QtBlockedSlot public final void resetTransform() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetTransform(nativeId());
    }
    private native static void __qt_resetTransform(long __this__nativeId);

    @QtBlockedSlot public final void restore() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_restore(nativeId());
    }
    private native static void __qt_restore(long __this__nativeId);

    @QtBlockedSlot public final void rotate(double a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_rotate_double(nativeId(), a);
    }
    private native static void __qt_rotate_double(long __this__nativeId, double a);

    @QtBlockedSlot public final void save() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_save(nativeId());
    }
    private native static void __qt_save(long __this__nativeId);

    @QtBlockedSlot public final void scale(double sx, double sy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scale_double_double(nativeId(), sx, sy);
    }
    private native static void __qt_scale_double_double(long __this__nativeId, double sx, double sy);

    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush bg) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), bg == null ? (bg = new com.trolltech.qt.gui.QBrush()).nativeId() : bg.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long bg);

    @QtBlockedSlot public final void setBackgroundMode(com.trolltech.qt.core.Qt.BGMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundMode_BGMode(nativeId(), mode.value());
    }
    private native static void __qt_setBackgroundMode_BGMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setBrush(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBrush_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setBrush(com.trolltech.qt.core.Qt.BrushStyle style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrush_BrushStyle(nativeId(), style.value());
    }
    private native static void __qt_setBrush_BrushStyle(long __this__nativeId, int style);

    @QtBlockedSlot public final void setBrushOrigin(com.trolltech.qt.core.QPoint arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrushOrigin_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setBrushOrigin_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setBrushOrigin(int x, int y) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrushOrigin_int_int(nativeId(), x, y);
    }
    private native static void __qt_setBrushOrigin_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final void setBrushOrigin(com.trolltech.qt.core.QPointF arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBrushOrigin_QPointF(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPointF()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setBrushOrigin_QPointF(long __this__nativeId, long arg__1);


    @QtBlockedSlot public final void setClipPath(com.trolltech.qt.gui.QPainterPath path) {
        setClipPath(path, com.trolltech.qt.core.Qt.ClipOperation.ReplaceClip);
    }
    @QtBlockedSlot public final void setClipPath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.core.Qt.ClipOperation op) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipPath_QPainterPath_ClipOperation(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), op.value());
    }
    private native static void __qt_setClipPath_QPainterPath_ClipOperation(long __this__nativeId, long path, int op);


    @QtBlockedSlot public final void setClipRect(com.trolltech.qt.core.QRectF arg__1) {
        setClipRect(arg__1, com.trolltech.qt.core.Qt.ClipOperation.ReplaceClip);
    }
    @QtBlockedSlot public final void setClipRect(com.trolltech.qt.core.QRectF arg__1, com.trolltech.qt.core.Qt.ClipOperation op) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipRect_QRectF_ClipOperation(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRectF()).nativeId() : arg__1.nativeId(), op.value());
    }
    private native static void __qt_setClipRect_QRectF_ClipOperation(long __this__nativeId, long arg__1, int op);


    @QtBlockedSlot public final void setClipRect(int x, int y, int w, int h) {
        setClipRect(x, y, w, h, com.trolltech.qt.core.Qt.ClipOperation.ReplaceClip);
    }
    @QtBlockedSlot public final void setClipRect(int x, int y, int w, int h, com.trolltech.qt.core.Qt.ClipOperation op) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipRect_int_int_int_int_ClipOperation(nativeId(), x, y, w, h, op.value());
    }
    private native static void __qt_setClipRect_int_int_int_int_ClipOperation(long __this__nativeId, int x, int y, int w, int h, int op);


    @QtBlockedSlot public final void setClipRect(com.trolltech.qt.core.QRect arg__1) {
        setClipRect(arg__1, com.trolltech.qt.core.Qt.ClipOperation.ReplaceClip);
    }
    @QtBlockedSlot public final void setClipRect(com.trolltech.qt.core.QRect arg__1, com.trolltech.qt.core.Qt.ClipOperation op) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipRect_QRect_ClipOperation(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId(), op.value());
    }
    private native static void __qt_setClipRect_QRect_ClipOperation(long __this__nativeId, long arg__1, int op);


    @QtBlockedSlot public final void setClipRegion(com.trolltech.qt.gui.QRegion arg__1) {
        setClipRegion(arg__1, com.trolltech.qt.core.Qt.ClipOperation.ReplaceClip);
    }
    @QtBlockedSlot public final void setClipRegion(com.trolltech.qt.gui.QRegion arg__1, com.trolltech.qt.core.Qt.ClipOperation op) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipRegion_QRegion_ClipOperation(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QRegion()).nativeId() : arg__1.nativeId(), op.value());
    }
    private native static void __qt_setClipRegion_QRegion_ClipOperation(long __this__nativeId, long arg__1, int op);

    @QtBlockedSlot public final void setClipping(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setClipping_boolean(nativeId(), enable);
    }
    private native static void __qt_setClipping_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setCompositionMode(com.trolltech.qt.gui.QPainter.CompositionMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCompositionMode_CompositionMode(nativeId(), mode.value());
    }
    private native static void __qt_setCompositionMode_CompositionMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long f);

    @QtBlockedSlot public final void setLayoutDirection(com.trolltech.qt.core.Qt.LayoutDirection direction) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLayoutDirection_LayoutDirection(nativeId(), direction.value());
    }
    private native static void __qt_setLayoutDirection_LayoutDirection(long __this__nativeId, int direction);

    @QtBlockedSlot public final void setOpacity(double opacity) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOpacity_double(nativeId(), opacity);
    }
    private native static void __qt_setOpacity_double(long __this__nativeId, double opacity);

    @QtBlockedSlot public final void setPen(com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPen_QColor(nativeId(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setPen_QColor(long __this__nativeId, long color);

    @QtBlockedSlot public final void setPen(com.trolltech.qt.gui.QPen pen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPen_QPen(nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId());
    }
    private native static void __qt_setPen_QPen(long __this__nativeId, long pen);

    @QtBlockedSlot public final void setPen(com.trolltech.qt.core.Qt.PenStyle style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPen_PenStyle(nativeId(), style.value());
    }
    private native static void __qt_setPen_PenStyle(long __this__nativeId, int style);


    @QtBlockedSlot public final void setRenderHint(com.trolltech.qt.gui.QPainter.RenderHint hint) {
        setRenderHint(hint, (boolean)true);
    }
    @QtBlockedSlot public final void setRenderHint(com.trolltech.qt.gui.QPainter.RenderHint hint, boolean on) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRenderHint_RenderHint_boolean(nativeId(), hint.value(), on);
    }
    private native static void __qt_setRenderHint_RenderHint_boolean(long __this__nativeId, int hint, boolean on);


    @QtBlockedSlot public final void setRenderHints(com.trolltech.qt.gui.QPainter.RenderHints hints) {
        setRenderHints(hints, (boolean)true);
    }
    @QtBlockedSlot public final void setRenderHints(com.trolltech.qt.gui.QPainter.RenderHints hints, boolean on) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRenderHints_RenderHints_boolean(nativeId(), hints.value(), on);
    }
    private native static void __qt_setRenderHints_RenderHints_boolean(long __this__nativeId, int hints, boolean on);


    @QtBlockedSlot public final void setTransform(com.trolltech.qt.gui.QTransform transform) {
        setTransform(transform, (boolean)false);
    }
    @QtBlockedSlot public final void setTransform(com.trolltech.qt.gui.QTransform transform, boolean combine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTransform_QTransform_boolean(nativeId(), transform == null ? (transform = new com.trolltech.qt.gui.QTransform()).nativeId() : transform.nativeId(), combine);
    }
    private native static void __qt_setTransform_QTransform_boolean(long __this__nativeId, long transform, boolean combine);

    @QtBlockedSlot public final void setViewTransformEnabled(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewTransformEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setViewTransformEnabled_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setViewport(int x, int y, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewport_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_setViewport_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    @QtBlockedSlot public final void setViewport(com.trolltech.qt.core.QRect viewport) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setViewport_QRect(nativeId(), viewport == null ? (viewport = new com.trolltech.qt.core.QRect()).nativeId() : viewport.nativeId());
    }
    private native static void __qt_setViewport_QRect(long __this__nativeId, long viewport);

    @QtBlockedSlot public final void setWindow(int x, int y, int w, int h) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindow_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_setWindow_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    @QtBlockedSlot public final void setWindow(com.trolltech.qt.core.QRect window) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindow_QRect(nativeId(), window == null ? (window = new com.trolltech.qt.core.QRect()).nativeId() : window.nativeId());
    }
    private native static void __qt_setWindow_QRect(long __this__nativeId, long window);


    @QtBlockedSlot public final void setWorldMatrix(com.trolltech.qt.gui.QMatrix matrix) {
        setWorldMatrix(matrix, (boolean)false);
    }
    @QtBlockedSlot public final void setWorldMatrix(com.trolltech.qt.gui.QMatrix matrix, boolean combine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWorldMatrix_QMatrix_boolean(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QMatrix()).nativeId() : matrix.nativeId(), combine);
    }
    private native static void __qt_setWorldMatrix_QMatrix_boolean(long __this__nativeId, long matrix, boolean combine);

    @QtBlockedSlot public final void setWorldMatrixEnabled(boolean enabled) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWorldMatrixEnabled_boolean(nativeId(), enabled);
    }
    private native static void __qt_setWorldMatrixEnabled_boolean(long __this__nativeId, boolean enabled);


    @QtBlockedSlot public final void setWorldTransform(com.trolltech.qt.gui.QTransform matrix) {
        setWorldTransform(matrix, (boolean)false);
    }
    @QtBlockedSlot public final void setWorldTransform(com.trolltech.qt.gui.QTransform matrix, boolean combine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWorldTransform_QTransform_boolean(nativeId(), matrix == null ? (matrix = new com.trolltech.qt.gui.QTransform()).nativeId() : matrix.nativeId(), combine);
    }
    private native static void __qt_setWorldTransform_QTransform_boolean(long __this__nativeId, long matrix, boolean combine);

    @QtBlockedSlot public final void shear(double sh, double sv) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_shear_double_double(nativeId(), sh, sv);
    }
    private native static void __qt_shear_double_double(long __this__nativeId, double sh, double sv);

    @QtBlockedSlot public final void strokePath(com.trolltech.qt.gui.QPainterPath path, com.trolltech.qt.gui.QPen pen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_strokePath_QPainterPath_QPen(nativeId(), path == null ? (path = new com.trolltech.qt.gui.QPainterPath()).nativeId() : path.nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId());
    }
    private native static void __qt_strokePath_QPainterPath_QPen(long __this__nativeId, long path, long pen);

    @QtBlockedSlot public final boolean testRenderHint(com.trolltech.qt.gui.QPainter.RenderHint hint) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testRenderHint_RenderHint(nativeId(), hint.value());
    }
    private native static boolean __qt_testRenderHint_RenderHint(long __this__nativeId, int hint);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform transform() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_transform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_transform(long __this__nativeId);

    @QtBlockedSlot public final void translate(double dx, double dy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_double_double(nativeId(), dx, dy);
    }
    private native static void __qt_translate_double_double(long __this__nativeId, double dx, double dy);

    @QtBlockedSlot public final void translate(com.trolltech.qt.core.QPointF offset) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_QPointF(nativeId(), offset == null ? (offset = new com.trolltech.qt.core.QPointF()).nativeId() : offset.nativeId());
    }
    private native static void __qt_translate_QPointF(long __this__nativeId, long offset);

    @QtBlockedSlot public final void translate(com.trolltech.qt.core.QPoint offset) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_QPoint(nativeId(), offset == null ? (offset = new com.trolltech.qt.core.QPoint()).nativeId() : offset.nativeId());
    }
    private native static void __qt_translate_QPoint(long __this__nativeId, long offset);

    @QtBlockedSlot public final boolean viewTransformEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewTransformEnabled(nativeId());
    }
    private native static boolean __qt_viewTransformEnabled(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect viewport() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_viewport(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_viewport(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect window() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_window(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_window(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMatrix worldMatrix() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_worldMatrix(nativeId());
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_worldMatrix(long __this__nativeId);

    @QtBlockedSlot public final boolean worldMatrixEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_worldMatrixEnabled(nativeId());
    }
    private native static boolean __qt_worldMatrixEnabled(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform worldTransform() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_worldTransform(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_worldTransform(long __this__nativeId);

    @SuppressWarnings("unused")
    private static com.trolltech.qt.gui.QPaintDeviceInterface redirected(com.trolltech.qt.gui.QPaintDeviceInterface device, com.trolltech.qt.QNativePointer offset) {
        return __qt_redirected_QPaintDevice_nativepointer(device == null ? 0 : device.nativeId(), offset);
    }
    private native static com.trolltech.qt.gui.QPaintDeviceInterface __qt_redirected_QPaintDevice_nativepointer(long device, com.trolltech.qt.QNativePointer offset);

    public static void restoreRedirected(com.trolltech.qt.gui.QPaintDeviceInterface device) {
        if (device == null)
            throw new NullPointerException("Argument 'device': null not expected.");
        __qt_restoreRedirected_QPaintDevice(device == null ? 0 : device.nativeId());
    if (!__rcRedirections.empty()) __rcRedirections.pop();
    if (!__rcRedirections.empty()) __rcRedirections.pop();

    }
    private native static void __qt_restoreRedirected_QPaintDevice(long device);


    public static void setRedirected(com.trolltech.qt.gui.QPaintDeviceInterface device, com.trolltech.qt.gui.QPaintDeviceInterface replacement) {
        setRedirected(device, replacement, (com.trolltech.qt.core.QPoint)new com.trolltech.qt.core.QPoint());
    }
    public static void setRedirected(com.trolltech.qt.gui.QPaintDeviceInterface device, com.trolltech.qt.gui.QPaintDeviceInterface replacement, com.trolltech.qt.core.QPoint offset) {
        if (device == null)
            throw new NullPointerException("Argument 'device': null not expected.");
        __qt_setRedirected_QPaintDevice_QPaintDevice_QPoint(device == null ? 0 : device.nativeId(), replacement == null ? 0 : replacement.nativeId(), offset == null ? (offset = new com.trolltech.qt.core.QPoint()).nativeId() : offset.nativeId());
    __rcRedirections.push(device);
    __rcRedirections.push(replacement);

    }
    private native static void __qt_setRedirected_QPaintDevice_QPaintDevice_QPoint(long device, long replacement, long offset);


    public static native QPainter fromNativePointer(QNativePointer nativePointer);

    protected QPainter(QPrivateConstructor p) { super(p); } 


    public void setBrush(QColor color) { setBrush(new QBrush(color)); }
    public void setBrush(QGradient gradient) { setBrush(new QBrush(gradient)); }
    public void setBrush(QPixmap pm) { setBrush(new QBrush(pm)); }
    

        // TEMPLATE - gui.painter_draw_text_qrect - START
        // TEMPLATE - gui.painter_draw_text_general - START
        public final void drawText(com.trolltech.qt.core.QRect rectangle, int flags, String text, com.trolltech.qt.core.QRect boundingRect) {
            drawText(rectangle, flags, text, boundingRect == null ? null : boundingRect.nativePointer());
        }
        
        public final void drawText(com.trolltech.qt.core.QRect rectangle, int flags, String text) {
            drawText(rectangle, flags, text, (com.trolltech.qt.core.QRect) null);
        }    
    // TEMPLATE - gui.painter_draw_text_general - END
    // TEMPLATE - gui.painter_draw_text_qrect - END
    

        // TEMPLATE - gui.painter_draw_text_qrect - START
        // TEMPLATE - gui.painter_draw_text_general - START
        public final void drawText(com.trolltech.qt.core.QRectF rectangle, int flags, String text, com.trolltech.qt.core.QRectF boundingRect) {
            drawText(rectangle, flags, text, boundingRect == null ? null : boundingRect.nativePointer());
        }
        
        public final void drawText(com.trolltech.qt.core.QRectF rectangle, int flags, String text) {
            drawText(rectangle, flags, text, (com.trolltech.qt.core.QRectF) null);
        }    
    // TEMPLATE - gui.painter_draw_text_general - END
    // TEMPLATE - gui.painter_draw_text_qrect - END
    

        // TEMPLATE - gui.painter_draw_text_general - START
        public final void drawText(int x, int y, int width, int height, int flags, String text, com.trolltech.qt.core.QRect boundingRect) {
            drawText(x, y, width, height, flags, text, boundingRect == null ? null : boundingRect.nativePointer());
        }
        
        public final void drawText(int x, int y, int width, int height, int flags, String text) {
            drawText(x, y, width, height, flags, text, (com.trolltech.qt.core.QRect) null);
        }    
    // TEMPLATE - gui.painter_draw_text_general - END
    

        public static QPaintDeviceInterface redirected(QPaintDeviceInterface device, com.trolltech.qt.core.QPoint offset) {
            return redirected(device, offset == null ? null : offset.nativePointer());
        }
    

    public QPainter(QWidget widget) {
        this();
        begin(widget);  
    }

    public boolean begin(QWidget widget) {
        return com.trolltech.qt.QtJambiGuiInternal.beginPaint(widget, this);
    }
    

        private static java.util.Stack<QPaintDeviceInterface> __rcRedirections = new java.util.Stack<QPaintDeviceInterface>();
    
}
