package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QPrinter extends com.trolltech.qt.QtJambiObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    @SuppressWarnings("unused") private Object __rcPaintEngine = null;
    @SuppressWarnings("unused") private Object __rcPrintEngine = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum OutputFormat implements com.trolltech.qt.QtEnumerator {
        NativeFormat(0),
        PdfFormat(1),
        PostScriptFormat(2);

        OutputFormat(int value) { this.value = value; }
        public int value() { return value; }

        public static OutputFormat resolve(int value) {
            return (OutputFormat) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NativeFormat;
            case 1: return PdfFormat;
            case 2: return PostScriptFormat;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PrintRange implements com.trolltech.qt.QtEnumerator {
        AllPages(0),
        Selection(1),
        PageRange(2);

        PrintRange(int value) { this.value = value; }
        public int value() { return value; }

        public static PrintRange resolve(int value) {
            return (PrintRange) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AllPages;
            case 1: return Selection;
            case 2: return PageRange;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PrinterMode implements com.trolltech.qt.QtEnumerator {
        ScreenResolution(0),
        PrinterResolution(1),
        HighResolution(2);

        PrinterMode(int value) { this.value = value; }
        public int value() { return value; }

        public static PrinterMode resolve(int value) {
            return (PrinterMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ScreenResolution;
            case 1: return PrinterResolution;
            case 2: return HighResolution;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Orientation implements com.trolltech.qt.QtEnumerator {
        Portrait(0),
        Landscape(1);

        Orientation(int value) { this.value = value; }
        public int value() { return value; }

        public static Orientation resolve(int value) {
            return (Orientation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Portrait;
            case 1: return Landscape;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PrinterState implements com.trolltech.qt.QtEnumerator {
        Idle(0),
        Active(1),
        Aborted(2),
        Error(3);

        PrinterState(int value) { this.value = value; }
        public int value() { return value; }

        public static PrinterState resolve(int value) {
            return (PrinterState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Idle;
            case 1: return Active;
            case 2: return Aborted;
            case 3: return Error;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ColorMode implements com.trolltech.qt.QtEnumerator {
        GrayScale(0),
        Color(1);

        ColorMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ColorMode resolve(int value) {
            return (ColorMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return GrayScale;
            case 1: return Color;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PaperSource implements com.trolltech.qt.QtEnumerator {
        OnlyOne(0),
        Lower(1),
        Middle(2),
        Manual(3),
        Envelope(4),
        EnvelopeManual(5),
        Auto(6),
        Tractor(7),
        SmallFormat(8),
        LargeFormat(9),
        LargeCapacity(10),
        Cassette(11),
        FormSource(12),
        MaxPageSource(13);

        PaperSource(int value) { this.value = value; }
        public int value() { return value; }

        public static PaperSource resolve(int value) {
            return (PaperSource) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OnlyOne;
            case 1: return Lower;
            case 2: return Middle;
            case 3: return Manual;
            case 4: return Envelope;
            case 5: return EnvelopeManual;
            case 6: return Auto;
            case 7: return Tractor;
            case 8: return SmallFormat;
            case 9: return LargeFormat;
            case 10: return LargeCapacity;
            case 11: return Cassette;
            case 12: return FormSource;
            case 13: return MaxPageSource;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PageOrder implements com.trolltech.qt.QtEnumerator {
        FirstPageFirst(0),
        LastPageFirst(1);

        PageOrder(int value) { this.value = value; }
        public int value() { return value; }

        public static PageOrder resolve(int value) {
            return (PageOrder) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FirstPageFirst;
            case 1: return LastPageFirst;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PageSize implements com.trolltech.qt.QtEnumerator {
        A4(0),
        B5(1),
        Letter(2),
        Legal(3),
        Executive(4),
        A0(5),
        A1(6),
        A2(7),
        A3(8),
        A5(9),
        A6(10),
        A7(11),
        A8(12),
        A9(13),
        B0(14),
        B1(15),
        B10(16),
        B2(17),
        B3(18),
        B4(19),
        B6(20),
        B7(21),
        B8(22),
        B9(23),
        C5E(24),
        Comm10E(25),
        DLE(26),
        Folio(27),
        Ledger(28),
        Tabloid(29),
        Custom(30),
;

        PageSize(int value) { this.value = value; }
        public int value() { return value; }

        public static PageSize resolve(int value) {
            return (PageSize) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return A4;
            case 1: return B5;
            case 2: return Letter;
            case 3: return Legal;
            case 4: return Executive;
            case 5: return A0;
            case 6: return A1;
            case 7: return A2;
            case 8: return A3;
            case 9: return A5;
            case 10: return A6;
            case 11: return A7;
            case 12: return A8;
            case 13: return A9;
            case 14: return B0;
            case 15: return B1;
            case 16: return B10;
            case 17: return B2;
            case 18: return B3;
            case 19: return B4;
            case 20: return B6;
            case 21: return B7;
            case 22: return B8;
            case 23: return B9;
            case 24: return C5E;
            case 25: return Comm10E;
            case 26: return DLE;
            case 27: return Folio;
            case 28: return Ledger;
            case 29: return Tabloid;
            case 30: return Custom;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QPrinter() {
        this(com.trolltech.qt.gui.QPrinter.PrinterMode.ScreenResolution);
    }
    public QPrinter(com.trolltech.qt.gui.QPrinter.PrinterMode mode) {
        super((QPrivateConstructor)null);
        __qt_QPrinter_PrinterMode(mode.value());
    }
    private native void __qt_QPrinter_PrinterMode(int mode);


    @QtBlockedSlot public final boolean abort() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_abort(nativeId());
    }
    private native static boolean __qt_abort(long __this__nativeId);

    @QtBlockedSlot public final boolean collateCopies() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_collateCopies(nativeId());
    }
    private native static boolean __qt_collateCopies(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.ColorMode colorMode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.ColorMode.resolve(__qt_colorMode(nativeId()));
    }
    private native static int __qt_colorMode(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String creator() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_creator(nativeId());
    }
    private native static java.lang.String __qt_creator(long __this__nativeId);

    @QtBlockedSlot public final int depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String docName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_docName(nativeId());
    }
    private native static java.lang.String __qt_docName(long __this__nativeId);

    @QtBlockedSlot public final boolean doubleSidedPrinting() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_doubleSidedPrinting(nativeId());
    }
    private native static boolean __qt_doubleSidedPrinting(long __this__nativeId);

    @QtBlockedSlot public final boolean fontEmbeddingEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontEmbeddingEnabled(nativeId());
    }
    private native static boolean __qt_fontEmbeddingEnabled(long __this__nativeId);

    @QtBlockedSlot public final int fromPage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fromPage(nativeId());
    }
    private native static int __qt_fromPage(long __this__nativeId);

    @QtBlockedSlot public final boolean fullPage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fullPage(nativeId());
    }
    private native static boolean __qt_fullPage(long __this__nativeId);

    @QtBlockedSlot public final int height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final boolean newPage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_newPage(nativeId());
    }
    private native static boolean __qt_newPage(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);

    @QtBlockedSlot public final int numCopies() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numCopies(nativeId());
    }
    private native static int __qt_numCopies(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.Orientation orientation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String outputFileName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_outputFileName(nativeId());
    }
    private native static java.lang.String __qt_outputFileName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.OutputFormat outputFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.OutputFormat.resolve(__qt_outputFormat(nativeId()));
    }
    private native static int __qt_outputFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.PageOrder pageOrder() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.PageOrder.resolve(__qt_pageOrder(nativeId()));
    }
    private native static int __qt_pageOrder(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect pageRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pageRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_pageRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.PageSize pageSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.PageSize.resolve(__qt_pageSize(nativeId()));
    }
    private native static int __qt_pageSize(long __this__nativeId);

    @QtBlockedSlot public final boolean paintingActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect paperRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paperRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_paperRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.PaperSource paperSource() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.PaperSource.resolve(__qt_paperSource(nativeId()));
    }
    private native static int __qt_paperSource(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrintEngine printEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_printEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPrintEngine __qt_printEngine(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String printProgram() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_printProgram(nativeId());
    }
    private native static java.lang.String __qt_printProgram(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.PrintRange printRange() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.PrintRange.resolve(__qt_printRange(nativeId()));
    }
    private native static int __qt_printRange(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String printerName() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_printerName(nativeId());
    }
    private native static java.lang.String __qt_printerName(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPrinter.PrinterState printerState() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPrinter.PrinterState.resolve(__qt_printerState(nativeId()));
    }
    private native static int __qt_printerState(long __this__nativeId);

    @QtBlockedSlot public final int resolution() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resolution(nativeId());
    }
    private native static int __qt_resolution(long __this__nativeId);

    @QtBlockedSlot public final void setCollateCopies(boolean collate) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCollateCopies_boolean(nativeId(), collate);
    }
    private native static void __qt_setCollateCopies_boolean(long __this__nativeId, boolean collate);

    @QtBlockedSlot public final void setColorMode(com.trolltech.qt.gui.QPrinter.ColorMode arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setColorMode_ColorMode(nativeId(), arg__1.value());
    }
    private native static void __qt_setColorMode_ColorMode(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setCreator(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCreator_String(nativeId(), arg__1);
    }
    private native static void __qt_setCreator_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setDocName(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDocName_String(nativeId(), arg__1);
    }
    private native static void __qt_setDocName_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setDoubleSidedPrinting(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDoubleSidedPrinting_boolean(nativeId(), enable);
    }
    private native static void __qt_setDoubleSidedPrinting_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot protected final void setEngines(com.trolltech.qt.gui.QPrintEngine printEngine, com.trolltech.qt.gui.QPaintEngine paintEngine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcPrintEngine = printEngine;
        }
        {
            __rcPaintEngine = paintEngine;
        }
        __qt_setEngines_QPrintEngine_QPaintEngine(nativeId(), printEngine == null ? 0 : printEngine.nativeId(), paintEngine == null ? 0 : paintEngine.nativeId());
    }
    private native static void __qt_setEngines_QPrintEngine_QPaintEngine(long __this__nativeId, long printEngine, long paintEngine);

    @QtBlockedSlot public final void setFontEmbeddingEnabled(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontEmbeddingEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setFontEmbeddingEnabled_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setFromTo(int fromPage, int toPage) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFromTo_int_int(nativeId(), fromPage, toPage);
    }
    private native static void __qt_setFromTo_int_int(long __this__nativeId, int fromPage, int toPage);

    @QtBlockedSlot public final void setFullPage(boolean arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFullPage_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setFullPage_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setNumCopies(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumCopies_int(nativeId(), arg__1);
    }
    private native static void __qt_setNumCopies_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setOrientation(com.trolltech.qt.gui.QPrinter.Orientation arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOrientation_Orientation(nativeId(), arg__1.value());
    }
    private native static void __qt_setOrientation_Orientation(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setOutputFileName(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOutputFileName_String(nativeId(), arg__1);
    }
    private native static void __qt_setOutputFileName_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setOutputFormat(com.trolltech.qt.gui.QPrinter.OutputFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOutputFormat_OutputFormat(nativeId(), format.value());
    }
    private native static void __qt_setOutputFormat_OutputFormat(long __this__nativeId, int format);

    @QtBlockedSlot public final void setPageOrder(com.trolltech.qt.gui.QPrinter.PageOrder arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPageOrder_PageOrder(nativeId(), arg__1.value());
    }
    private native static void __qt_setPageOrder_PageOrder(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setPageSize(com.trolltech.qt.gui.QPrinter.PageSize arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPageSize_PageSize(nativeId(), arg__1.value());
    }
    private native static void __qt_setPageSize_PageSize(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setPaperSource(com.trolltech.qt.gui.QPrinter.PaperSource arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPaperSource_PaperSource(nativeId(), arg__1.value());
    }
    private native static void __qt_setPaperSource_PaperSource(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setPrintProgram(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrintProgram_String(nativeId(), arg__1);
    }
    private native static void __qt_setPrintProgram_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setPrintRange(com.trolltech.qt.gui.QPrinter.PrintRange range) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrintRange_PrintRange(nativeId(), range.value());
    }
    private native static void __qt_setPrintRange_PrintRange(long __this__nativeId, int range);

    @QtBlockedSlot public final void setPrinterName(java.lang.String arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrinterName_String(nativeId(), arg__1);
    }
    private native static void __qt_setPrinterName_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setResolution(int arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setResolution_int(nativeId(), arg__1);
    }
    private native static void __qt_setResolution_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final java.util.List<java.lang.Integer> supportedResolutions() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_supportedResolutions(nativeId());
    }
    private native static java.util.List<java.lang.Integer> __qt_supportedResolutions(long __this__nativeId);

    @QtBlockedSlot public final int toPage() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toPage(nativeId());
    }
    private native static int __qt_toPage(long __this__nativeId);

    @QtBlockedSlot public final int width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public int devType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), arg__1.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int arg__1);

    @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);


    public static native QPrinter fromNativePointer(QNativePointer nativePointer);

    protected QPrinter(QPrivateConstructor p) { super(p); } 


    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);
}
