package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QProgressBar extends com.trolltech.qt.gui.QWidget
{
    public enum Direction implements com.trolltech.qt.QtEnumerator {
        TopToBottom(0),
        BottomToTop(1);

        Direction(int value) { this.value = value; }
        public int value() { return value; }

        public static Direction resolve(int value) {
            return (Direction) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TopToBottom;
            case 1: return BottomToTop;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> valueChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void valueChanged(int value) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_valueChanged_int(nativeId(), value);
    }
    private native static void __qt_valueChanged_int(long __this__nativeId, int value);


    public QProgressBar() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QProgressBar(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QProgressBar_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QProgressBar_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="alignment")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment alignment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_alignment(nativeId()));
    }
    private native static int __qt_alignment(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="format")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final java.lang.String format() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_format(nativeId());
    }
    private native static java.lang.String __qt_format(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @com.trolltech.qt.QtPropertyReader(name="invertedAppearance")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final boolean invertedAppearance() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_invertedAppearance(nativeId());
    }
    private native static boolean __qt_invertedAppearance(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="textVisible")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final boolean isTextVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTextVisible(nativeId());
    }
    private native static boolean __qt_isTextVisible(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximum")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int maximum() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximum(nativeId());
    }
    private native static int __qt_maximum(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimum")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final int minimum() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimum(nativeId());
    }
    private native static int __qt_minimum(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="orientation")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Orientation orientation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.Orientation.resolve(__qt_orientation(nativeId()));
    }
    private native static int __qt_orientation(long __this__nativeId);

    public final void reset() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);


    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... alignment) {
        this.setAlignment(new com.trolltech.qt.core.Qt.Alignment(alignment));
    }
    @com.trolltech.qt.QtPropertyWriter(name="alignment")
    @QtBlockedSlot public final void setAlignment(com.trolltech.qt.core.Qt.Alignment alignment) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlignment_Alignment(nativeId(), alignment.value());
    }
    private native static void __qt_setAlignment_Alignment(long __this__nativeId, int alignment);

    @com.trolltech.qt.QtPropertyWriter(name="format")
    @QtBlockedSlot public final void setFormat(java.lang.String format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFormat_String(nativeId(), format);
    }
    private native static void __qt_setFormat_String(long __this__nativeId, java.lang.String format);

    @com.trolltech.qt.QtPropertyWriter(name="invertedAppearance")
    @QtBlockedSlot public final void setInvertedAppearance(boolean invert) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInvertedAppearance_boolean(nativeId(), invert);
    }
    private native static void __qt_setInvertedAppearance_boolean(long __this__nativeId, boolean invert);

    @com.trolltech.qt.QtPropertyWriter(name="maximum")
    public final void setMaximum(int maximum) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximum_int(nativeId(), maximum);
    }
    private native static void __qt_setMaximum_int(long __this__nativeId, int maximum);

    @com.trolltech.qt.QtPropertyWriter(name="minimum")
    public final void setMinimum(int minimum) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimum_int(nativeId(), minimum);
    }
    private native static void __qt_setMinimum_int(long __this__nativeId, int minimum);

    @com.trolltech.qt.QtPropertyWriter(name="orientation")
    public final void setOrientation(com.trolltech.qt.core.Qt.Orientation arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOrientation_Orientation(nativeId(), arg__1.value());
    }
    private native static void __qt_setOrientation_Orientation(long __this__nativeId, int arg__1);

    public final void setRange(int minimum, int maximum) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRange_int_int(nativeId(), minimum, maximum);
    }
    private native static void __qt_setRange_int_int(long __this__nativeId, int minimum, int maximum);

    @com.trolltech.qt.QtPropertyWriter(name="textDirection")
    @QtBlockedSlot public final void setTextDirection(com.trolltech.qt.gui.QProgressBar.Direction textDirection) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextDirection_Direction(nativeId(), textDirection.value());
    }
    private native static void __qt_setTextDirection_Direction(long __this__nativeId, int textDirection);

    @com.trolltech.qt.QtPropertyWriter(name="textVisible")
    @QtBlockedSlot public final void setTextVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setTextVisible_boolean(long __this__nativeId, boolean visible);

    @com.trolltech.qt.QtPropertyWriter(name="value")
    public final void setValue(int value) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setValue_int(nativeId(), value);
    }
    private native static void __qt_setValue_int(long __this__nativeId, int value);

    @com.trolltech.qt.QtPropertyReader(name="textDirection")
    @com.trolltech.qt.QtPropertyOrder(8)
    @QtBlockedSlot public final com.trolltech.qt.gui.QProgressBar.Direction textDirection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QProgressBar.Direction.resolve(__qt_textDirection(nativeId()));
    }
    private native static int __qt_textDirection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="value")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int value() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value(nativeId());
    }
    private native static int __qt_value(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="text")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public java.lang.String text() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);


    public static native QProgressBar fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QProgressBar(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionProgressBar option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
