package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QRegion extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum RegionType implements com.trolltech.qt.QtEnumerator {
        Rectangle(0),
        Ellipse(1);

        RegionType(int value) { this.value = value; }
        public int value() { return value; }

        public static RegionType resolve(int value) {
            return (RegionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Rectangle;
            case 1: return Ellipse;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QRegion(com.trolltech.qt.gui.QBitmap bitmap) {
        super((QPrivateConstructor)null);
        __qt_QRegion_QBitmap(bitmap == null ? (bitmap = new com.trolltech.qt.gui.QBitmap()).nativeId() : bitmap.nativeId());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion_QBitmap(long bitmap);



    public QRegion(com.trolltech.qt.gui.QPolygon pa) {
        this(pa, com.trolltech.qt.core.Qt.FillRule.OddEvenFill);
    }
    public QRegion(com.trolltech.qt.gui.QPolygon pa, com.trolltech.qt.core.Qt.FillRule fillRule) {
        super((QPrivateConstructor)null);
        __qt_QRegion_QPolygon_FillRule(pa == null ? (pa = new com.trolltech.qt.gui.QPolygon()).nativeId() : pa.nativeId(), fillRule.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion_QPolygon_FillRule(long pa, int fillRule);



    public QRegion(int x, int y, int w, int h) {
        this(x, y, w, h, com.trolltech.qt.gui.QRegion.RegionType.Rectangle);
    }
    public QRegion(int x, int y, int w, int h, com.trolltech.qt.gui.QRegion.RegionType t) {
        super((QPrivateConstructor)null);
        __qt_QRegion_int_int_int_int_RegionType(x, y, w, h, t.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion_int_int_int_int_RegionType(int x, int y, int w, int h, int t);


    public QRegion() {
        super((QPrivateConstructor)null);
        __qt_QRegion();

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion();


    public QRegion(com.trolltech.qt.gui.QRegion region) {
        super((QPrivateConstructor)null);
        __qt_QRegion_QRegion(region == null ? (region = new com.trolltech.qt.gui.QRegion()).nativeId() : region.nativeId());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion_QRegion(long region);



    public QRegion(com.trolltech.qt.core.QRect r) {
        this(r, com.trolltech.qt.gui.QRegion.RegionType.Rectangle);
    }
    public QRegion(com.trolltech.qt.core.QRect r, com.trolltech.qt.gui.QRegion.RegionType t) {
        super((QPrivateConstructor)null);
        __qt_QRegion_QRect_RegionType(r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId(), t.value());

        QtJambiInternal.countExpense(com.trolltech.qt.gui.QRegion.class, 1, 4096);
    }
    private native void __qt_QRegion_QRect_RegionType(long r, int t);


    @QtBlockedSlot public final com.trolltech.qt.core.QRect boundingRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_boundingRect(long __this__nativeId);

    @QtBlockedSlot public final boolean contains(com.trolltech.qt.core.QRect r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static boolean __qt_contains_QRect(long __this__nativeId, long r);

    @QtBlockedSlot public final boolean contains(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contains_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static boolean __qt_contains_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion intersected(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersected_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_intersected_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final boolean intersects(com.trolltech.qt.core.QRect r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersects_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static boolean __qt_intersects_QRect(long __this__nativeId, long r);

    @QtBlockedSlot public final boolean intersects(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_intersects_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static boolean __qt_intersects_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final boolean isEmpty() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEmpty(nativeId());
    }
    private native static boolean __qt_isEmpty(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static boolean __qt_operator_equal_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.core.QRect> rects() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rects(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.core.QRect> __qt_rects(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void setRects(com.trolltech.qt.QNativePointer rect, int num) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRects_nativepointer_int(nativeId(), rect, num);
    }
    private native static void __qt_setRects_nativepointer_int(long __this__nativeId, com.trolltech.qt.QNativePointer rect, int num);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion subtracted(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_subtracted_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_subtracted_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final void translate(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static void __qt_translate_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final void translate(int dx, int dy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_translate_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_translate_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion translated(int dx, int dy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_translated_int_int(nativeId(), dx, dy);
    }
    private native static com.trolltech.qt.gui.QRegion __qt_translated_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion translated(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_translated_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_translated_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion united(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_united_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_united_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion xored(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_xored_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_xored_QRegion(long __this__nativeId, long r);


    public static native QRegion fromNativePointer(QNativePointer nativePointer);

    protected QRegion(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QRegion array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QRegion)
            return operator_equal((com.trolltech.qt.gui.QRegion) other);
        return false;
    }


        public void setRects(com.trolltech.qt.core.QRect[] rects) {
            setRects(com.trolltech.qt.core.QRect.nativePointerArray(rects), rects.length);
        }
    
}
