package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QRubberBand extends com.trolltech.qt.gui.QWidget
{
    public enum Shape implements com.trolltech.qt.QtEnumerator {
        Line(0),
        Rectangle(1);

        Shape(int value) { this.value = value; }
        public int value() { return value; }

        public static Shape resolve(int value) {
            return (Shape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Line;
            case 1: return Rectangle;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QRubberBand(com.trolltech.qt.gui.QRubberBand.Shape arg__1) {
        this(arg__1, (com.trolltech.qt.gui.QWidget)null);
    }
    public QRubberBand(com.trolltech.qt.gui.QRubberBand.Shape arg__1, com.trolltech.qt.gui.QWidget arg__2) {
        super((QPrivateConstructor)null);
        __qt_QRubberBand_Shape_QWidget(arg__1.value(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native void __qt_QRubberBand_Shape_QWidget(int arg__1, long arg__2);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot public final void moveRubberBand(com.trolltech.qt.core.QPoint p) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveRubberBand_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static void __qt_moveRubberBand_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final void moveRubberBand(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveRubberBand_int_int(nativeId(), x, y);
    }
    private native static void __qt_moveRubberBand_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final void resizeRubberBand(int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeRubberBand_int_int(nativeId(), w, h);
    }
    private native static void __qt_resizeRubberBand_int_int(long __this__nativeId, int w, int h);

    @QtBlockedSlot public final void resizeRubberBand(com.trolltech.qt.core.QSize s) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeRubberBand_QSize(nativeId(), s == null ? (s = new com.trolltech.qt.core.QSize()).nativeId() : s.nativeId());
    }
    private native static void __qt_resizeRubberBand_QSize(long __this__nativeId, long s);

    @QtBlockedSlot public final void setRubberBandGeometry(int x, int y, int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRubberBandGeometry_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_setRubberBandGeometry_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    @QtBlockedSlot public final void setRubberBandGeometry(com.trolltech.qt.core.QRect r) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRubberBandGeometry_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static void __qt_setRubberBandGeometry_QRect(long __this__nativeId, long r);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRubberBand.Shape shape() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QRubberBand.Shape.resolve(__qt_shape(nativeId()));
    }
    private native static int __qt_shape(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void moveEvent(com.trolltech.qt.gui.QMoveEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveEvent_QMoveEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_moveEvent_QMoveEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);


    public static native QRubberBand fromNativePointer(QNativePointer nativePointer);

    protected QRubberBand(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionRubberBand option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
