package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSlider extends com.trolltech.qt.gui.QAbstractSlider
{
    public enum TickPosition implements com.trolltech.qt.QtEnumerator {
        NoTicks(0),
        TicksAbove(1),
        TicksBelow(2),
        TicksBothSides(3);

        TickPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static TickPosition resolve(int value) {
            return (TickPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoTicks;
            case 1: return TicksAbove;
            case 2: return TicksBelow;
            case 3: return TicksBothSides;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSlider() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QSlider(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QSlider_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSlider_QWidget(long parent);



    public QSlider(com.trolltech.qt.core.Qt.Orientation orientation) {
        this(orientation, (com.trolltech.qt.gui.QWidget)null);
    }
    public QSlider(com.trolltech.qt.core.Qt.Orientation orientation, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QSlider_Orientation_QWidget(orientation.value(), parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSlider_Orientation_QWidget(int orientation, long parent);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @com.trolltech.qt.QtPropertyWriter(name="tickInterval")
    @QtBlockedSlot public final void setTickInterval(int ti) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTickInterval_int(nativeId(), ti);
    }
    private native static void __qt_setTickInterval_int(long __this__nativeId, int ti);

    @com.trolltech.qt.QtPropertyWriter(name="tickPosition")
    @QtBlockedSlot public final void setTickPosition(com.trolltech.qt.gui.QSlider.TickPosition position) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTickPosition_TickPosition(nativeId(), position.value());
    }
    private native static void __qt_setTickPosition_TickPosition(long __this__nativeId, int position);

    @com.trolltech.qt.QtPropertyReader(name="tickInterval")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final int tickInterval() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tickInterval(nativeId());
    }
    private native static int __qt_tickInterval(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="tickPosition")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QSlider.TickPosition tickPosition() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QSlider.TickPosition.resolve(__qt_tickPosition(nativeId()));
    }
    private native static int __qt_tickPosition(long __this__nativeId);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent ev) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), ev == null ? 0 : ev.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long ev);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent ev) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), ev == null ? 0 : ev.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long ev);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent ev) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), ev == null ? 0 : ev.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long ev);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent ev) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), ev == null ? 0 : ev.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long ev);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);


    public static native QSlider fromNativePointer(QNativePointer nativePointer);

    protected QSlider(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionSlider option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
