package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOption extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(0);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum OptionType implements com.trolltech.qt.QtEnumerator {
        SO_Default(0),
        SO_FocusRect(1),
        SO_Button(2),
        SO_Tab(3),
        SO_MenuItem(4),
        SO_Frame(5),
        SO_ProgressBar(6),
        SO_ToolBox(7),
        SO_Header(8),
        SO_Q3DockWindow(9),
        SO_DockWidget(10),
        SO_Q3ListViewItem(11),
        SO_ViewItem(12),
        SO_TabWidgetFrame(13),
        SO_TabBarBase(14),
        SO_RubberBand(15),
        SO_ToolBar(16),
        SO_GraphicsItem(17),
        SO_Complex(983040),
        SO_Slider(983041),
        SO_SpinBox(983042),
        SO_ToolButton(983043),
        SO_ComboBox(983044),
        SO_Q3ListView(983045),
        SO_TitleBar(983046),
        SO_GroupBox(983047),
        SO_SizeGrip(983048),
        SO_CustomBase(3840),
        SO_ComplexCustomBase(251658240),
        CustomEnum(0);

        OptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static OptionType resolve(int value) {
            return (OptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SO_Default;
            case 1: return SO_FocusRect;
            case 2: return SO_Button;
            case 3: return SO_Tab;
            case 4: return SO_MenuItem;
            case 5: return SO_Frame;
            case 6: return SO_ProgressBar;
            case 7: return SO_ToolBox;
            case 8: return SO_Header;
            case 9: return SO_Q3DockWindow;
            case 10: return SO_DockWidget;
            case 11: return SO_Q3ListViewItem;
            case 12: return SO_ViewItem;
            case 13: return SO_TabWidgetFrame;
            case 14: return SO_TabBarBase;
            case 15: return SO_RubberBand;
            case 16: return SO_ToolBar;
            case 17: return SO_GraphicsItem;
            case 983040: return SO_Complex;
            case 983041: return SO_Slider;
            case 983042: return SO_SpinBox;
            case 983043: return SO_ToolButton;
            case 983044: return SO_ComboBox;
            case 983045: return SO_Q3ListView;
            case 983046: return SO_TitleBar;
            case 983047: return SO_GroupBox;
            case 983048: return SO_SizeGrip;
            case 3840: return SO_CustomBase;
            case 251658240: return SO_ComplexCustomBase;
            }
            if (enumCache == null)
                enumCache = new java.util.HashMap<Integer, OptionType>();
            OptionType e = enumCache.get(value);
            if (e == null) {
                e = (OptionType) com.trolltech.qt.QtJambiInternal.createExtendedEnum(value, CustomEnum.ordinal(), OptionType.class, CustomEnum.name());
                enumCache.put(value, e);
            }
            return e;
        }
        private final int value;

        private static java.util.HashMap<Integer, OptionType> enumCache;    }

    public QStyleOption(com.trolltech.qt.gui.QStyleOption other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOption_QStyleOption(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QStyleOption_QStyleOption(long other);



    public QStyleOption(int version) {
        this(version, (int)0);
    }

    public QStyleOption() {
        this((int)1, (int)0);
    }
    public QStyleOption(int version, int type) {
        super((QPrivateConstructor)null);
        __qt_QStyleOption_int_int(version, type);
    }
    private native void __qt_QStyleOption_int_int(int version, int type);


    @QtBlockedSlot public final void initFrom(com.trolltech.qt.gui.QWidget w) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initFrom_QWidget(nativeId(), w == null ? 0 : w.nativeId());
    }
    private native static void __qt_initFrom_QWidget(long __this__nativeId, long w);

    @QtBlockedSlot public final void setPalette(com.trolltech.qt.gui.QPalette palette) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPalette_QPalette(nativeId(), palette == null ? (palette = new com.trolltech.qt.gui.QPalette()).nativeId() : palette.nativeId());
    }
    private native static void __qt_setPalette_QPalette(long __this__nativeId, long palette);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette palette() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_palette(nativeId());
    }
    private native static com.trolltech.qt.gui.QPalette __qt_palette(long __this__nativeId);

    @QtBlockedSlot public final void setVersion(int version) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVersion_int(nativeId(), version);
    }
    private native static void __qt_setVersion_int(long __this__nativeId, int version);

    @QtBlockedSlot public final int version() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_version(nativeId());
    }
    private native static int __qt_version(long __this__nativeId);

    @QtBlockedSlot public final void setDirection(com.trolltech.qt.core.Qt.LayoutDirection direction) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirection_LayoutDirection(nativeId(), direction.value());
    }
    private native static void __qt_setDirection_LayoutDirection(long __this__nativeId, int direction);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.LayoutDirection direction() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_direction(nativeId()));
    }
    private native static int __qt_direction(long __this__nativeId);

    @QtBlockedSlot public final void setRect(com.trolltech.qt.core.QRect rect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRect_QRect(nativeId(), rect == null ? (rect = new com.trolltech.qt.core.QRect()).nativeId() : rect.nativeId());
    }
    private native static void __qt_setRect_QRect(long __this__nativeId, long rect);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect rect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_rect(long __this__nativeId);

    @QtBlockedSlot public final void setType(int type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setType_int(nativeId(), type);
    }
    private native static void __qt_setType_int(long __this__nativeId, int type);

    @QtBlockedSlot public final int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);


    @QtBlockedSlot public final void setState(com.trolltech.qt.gui.QStyle.StateFlag ... state) {
        this.setState(new com.trolltech.qt.gui.QStyle.State(state));
    }
    @QtBlockedSlot public final void setState(com.trolltech.qt.gui.QStyle.State state) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setState_State(nativeId(), state.value());
    }
    private native static void __qt_setState_State(long __this__nativeId, int state);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyle.State state() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyle.State(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);

    @QtBlockedSlot public final void setFontMetrics(com.trolltech.qt.gui.QFontMetrics fontMetrics) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontMetrics_QFontMetrics(nativeId(), fontMetrics == null ? 0 : fontMetrics.nativeId());
    }
    private native static void __qt_setFontMetrics_QFontMetrics(long __this__nativeId, long fontMetrics);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFontMetrics fontMetrics() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontMetrics(nativeId());
    }
    private native static com.trolltech.qt.gui.QFontMetrics __qt_fontMetrics(long __this__nativeId);


    public static native QStyleOption fromNativePointer(QNativePointer nativePointer);

    protected QStyleOption(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOption array[]);
}
