package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionButton extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ButtonFeature implements com.trolltech.qt.QtEnumerator {
        None(0),
        Flat(1),
        HasMenu(2),
        DefaultButton(4),
        AutoDefaultButton(8),
        CommandLinkButton(16);

        ButtonFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static ButtonFeatures createQFlags(ButtonFeature ... values) {
            return new ButtonFeatures(values);
        }
        public static ButtonFeature resolve(int value) {
            return (ButtonFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return Flat;
            case 2: return HasMenu;
            case 4: return DefaultButton;
            case 8: return AutoDefaultButton;
            case 16: return CommandLinkButton;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ButtonFeatures extends com.trolltech.qt.QFlags<ButtonFeature> {
        private static final long serialVersionUID = 1L;
        public ButtonFeatures(ButtonFeature ... args) { super(args); }
        public ButtonFeatures(int value) { setValue(value); }
    }

    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(2);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 2: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionButton(com.trolltech.qt.gui.QStyleOptionButton other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionButton_QStyleOptionButton(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionButton()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionButton_QStyleOptionButton(long other);


    public QStyleOptionButton() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionButton();
    }
    private native void __qt_QStyleOptionButton();


    protected QStyleOptionButton(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionButton_int(version);
    }
    private native void __qt_QStyleOptionButton_int(int version);

    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize iconSize) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), iconSize == null ? (iconSize = new com.trolltech.qt.core.QSize()).nativeId() : iconSize.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long iconSize);

    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionButton.ButtonFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionButton.ButtonFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionButton.ButtonFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_ButtonFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_ButtonFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionButton.ButtonFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionButton.ButtonFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);


    public static native QStyleOptionButton fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionButton(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionButton array[]);
}
