package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionFrameV2 extends com.trolltech.qt.gui.QStyleOptionFrame
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(2);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 2: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum FrameFeature implements com.trolltech.qt.QtEnumerator {
        None(0),
        Flat(1);

        FrameFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static FrameFeatures createQFlags(FrameFeature ... values) {
            return new FrameFeatures(values);
        }
        public static FrameFeature resolve(int value) {
            return (FrameFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return Flat;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class FrameFeatures extends com.trolltech.qt.QFlags<FrameFeature> {
        private static final long serialVersionUID = 1L;
        public FrameFeatures(FrameFeature ... args) { super(args); }
        public FrameFeatures(int value) { setValue(value); }
    }


    public QStyleOptionFrameV2(com.trolltech.qt.gui.QStyleOptionFrameV2 other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionFrameV2_QStyleOptionFrameV2(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionFrameV2()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionFrameV2_QStyleOptionFrameV2(long other);


    public QStyleOptionFrameV2() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionFrameV2();
    }
    private native void __qt_QStyleOptionFrameV2();


    protected QStyleOptionFrameV2(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionFrameV2_int(version);
    }
    private native void __qt_QStyleOptionFrameV2_int(int version);


    public QStyleOptionFrameV2(com.trolltech.qt.gui.QStyleOptionFrame other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionFrameV2_QStyleOptionFrame(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionFrame()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionFrameV2_QStyleOptionFrame(long other);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_FrameFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_FrameFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionFrameV2.FrameFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);


    public static native QStyleOptionFrameV2 fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionFrameV2(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionFrameV2 array[]);
}
