package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionMenuItem extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(4);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 4: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CheckType implements com.trolltech.qt.QtEnumerator {
        NotCheckable(0),
        Exclusive(1),
        NonExclusive(2);

        CheckType(int value) { this.value = value; }
        public int value() { return value; }

        public static CheckType resolve(int value) {
            return (CheckType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotCheckable;
            case 1: return Exclusive;
            case 2: return NonExclusive;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MenuItemType implements com.trolltech.qt.QtEnumerator {
        Normal(0),
        DefaultItem(1),
        Separator(2),
        SubMenu(3),
        Scroller(4),
        TearOff(5),
        Margin(6),
        EmptyArea(7);

        MenuItemType(int value) { this.value = value; }
        public int value() { return value; }

        public static MenuItemType resolve(int value) {
            return (MenuItemType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Normal;
            case 1: return DefaultItem;
            case 2: return Separator;
            case 3: return SubMenu;
            case 4: return Scroller;
            case 5: return TearOff;
            case 6: return Margin;
            case 7: return EmptyArea;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionMenuItem(com.trolltech.qt.gui.QStyleOptionMenuItem other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionMenuItem_QStyleOptionMenuItem(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionMenuItem()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionMenuItem_QStyleOptionMenuItem(long other);


    public QStyleOptionMenuItem() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionMenuItem();
    }
    private native void __qt_QStyleOptionMenuItem();


    protected QStyleOptionMenuItem(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionMenuItem_int(version);
    }
    private native void __qt_QStyleOptionMenuItem_int(int version);

    @QtBlockedSlot public final void setMenuHasCheckableItems(boolean menuHasCheckableItems) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMenuHasCheckableItems_boolean(nativeId(), menuHasCheckableItems);
    }
    private native static void __qt_setMenuHasCheckableItems_boolean(long __this__nativeId, boolean menuHasCheckableItems);

    @QtBlockedSlot public final boolean menuHasCheckableItems() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_menuHasCheckableItems(nativeId());
    }
    private native static boolean __qt_menuHasCheckableItems(long __this__nativeId);

    @QtBlockedSlot public final void setMenuRect(com.trolltech.qt.core.QRect menuRect) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMenuRect_QRect(nativeId(), menuRect == null ? (menuRect = new com.trolltech.qt.core.QRect()).nativeId() : menuRect.nativeId());
    }
    private native static void __qt_setMenuRect_QRect(long __this__nativeId, long menuRect);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect menuRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_menuRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_menuRect(long __this__nativeId);

    @QtBlockedSlot public final void setCheckType(com.trolltech.qt.gui.QStyleOptionMenuItem.CheckType checkType) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCheckType_CheckType(nativeId(), checkType.value());
    }
    private native static void __qt_setCheckType_CheckType(long __this__nativeId, int checkType);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionMenuItem.CheckType checkType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionMenuItem.CheckType.resolve(__qt_checkType(nativeId()));
    }
    private native static int __qt_checkType(long __this__nativeId);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final void setChecked(boolean checked) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setChecked_boolean(nativeId(), checked);
    }
    private native static void __qt_setChecked_boolean(long __this__nativeId, boolean checked);

    @QtBlockedSlot public final boolean checked() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_checked(nativeId());
    }
    private native static boolean __qt_checked(long __this__nativeId);

    @QtBlockedSlot public final void setMaxIconWidth(int maxIconWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaxIconWidth_int(nativeId(), maxIconWidth);
    }
    private native static void __qt_setMaxIconWidth_int(long __this__nativeId, int maxIconWidth);

    @QtBlockedSlot public final int maxIconWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maxIconWidth(nativeId());
    }
    private native static int __qt_maxIconWidth(long __this__nativeId);

    @QtBlockedSlot public final void setTabWidth(int tabWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabWidth_int(nativeId(), tabWidth);
    }
    private native static void __qt_setTabWidth_int(long __this__nativeId, int tabWidth);

    @QtBlockedSlot public final int tabWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabWidth(nativeId());
    }
    private native static int __qt_tabWidth(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final void setMenuItemType(com.trolltech.qt.gui.QStyleOptionMenuItem.MenuItemType menuItemType) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMenuItemType_MenuItemType(nativeId(), menuItemType.value());
    }
    private native static void __qt_setMenuItemType_MenuItemType(long __this__nativeId, int menuItemType);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionMenuItem.MenuItemType menuItemType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionMenuItem.MenuItemType.resolve(__qt_menuItemType(nativeId()));
    }
    private native static int __qt_menuItemType(long __this__nativeId);


    public static native QStyleOptionMenuItem fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionMenuItem(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionMenuItem array[]);
}
