package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionProgressBar extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(6);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 6: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionProgressBar(com.trolltech.qt.gui.QStyleOptionProgressBar other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionProgressBar_QStyleOptionProgressBar(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionProgressBar()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionProgressBar_QStyleOptionProgressBar(long other);


    public QStyleOptionProgressBar() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionProgressBar();
    }
    private native void __qt_QStyleOptionProgressBar();


    protected QStyleOptionProgressBar(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionProgressBar_int(version);
    }
    private native void __qt_QStyleOptionProgressBar_int(int version);

    @QtBlockedSlot public final void setMinimum(int minimum) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimum_int(nativeId(), minimum);
    }
    private native static void __qt_setMinimum_int(long __this__nativeId, int minimum);

    @QtBlockedSlot public final int minimum() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimum(nativeId());
    }
    private native static int __qt_minimum(long __this__nativeId);

    @QtBlockedSlot public final void setMaximum(int maximum) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximum_int(nativeId(), maximum);
    }
    private native static void __qt_setMaximum_int(long __this__nativeId, int maximum);

    @QtBlockedSlot public final int maximum() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximum(nativeId());
    }
    private native static int __qt_maximum(long __this__nativeId);

    @QtBlockedSlot public final void setProgress(int progress) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProgress_int(nativeId(), progress);
    }
    private native static void __qt_setProgress_int(long __this__nativeId, int progress);

    @QtBlockedSlot public final int progress() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_progress(nativeId());
    }
    private native static int __qt_progress(long __this__nativeId);


    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... textAlignment) {
        this.setTextAlignment(new com.trolltech.qt.core.Qt.Alignment(textAlignment));
    }
    @QtBlockedSlot public final void setTextAlignment(com.trolltech.qt.core.Qt.Alignment textAlignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextAlignment_Alignment(nativeId(), textAlignment.value());
    }
    private native static void __qt_setTextAlignment_Alignment(long __this__nativeId, int textAlignment);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment textAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_textAlignment(nativeId()));
    }
    private native static int __qt_textAlignment(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setTextVisible(boolean textVisible) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextVisible_boolean(nativeId(), textVisible);
    }
    private native static void __qt_setTextVisible_boolean(long __this__nativeId, boolean textVisible);

    @QtBlockedSlot public final boolean textVisible() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textVisible(nativeId());
    }
    private native static boolean __qt_textVisible(long __this__nativeId);


    public static native QStyleOptionProgressBar fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionProgressBar(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionProgressBar array[]);
}
