package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionTab extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CornerWidget implements com.trolltech.qt.QtEnumerator {
        NoCornerWidgets(0),
        LeftCornerWidget(1),
        RightCornerWidget(2);

        CornerWidget(int value) { this.value = value; }
        public int value() { return value; }

        public static CornerWidgets createQFlags(CornerWidget ... values) {
            return new CornerWidgets(values);
        }
        public static CornerWidget resolve(int value) {
            return (CornerWidget) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoCornerWidgets;
            case 1: return LeftCornerWidget;
            case 2: return RightCornerWidget;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class CornerWidgets extends com.trolltech.qt.QFlags<CornerWidget> {
        private static final long serialVersionUID = 1L;
        public CornerWidgets(CornerWidget ... args) { super(args); }
        public CornerWidgets(int value) { setValue(value); }
    }

    public enum TabPosition implements com.trolltech.qt.QtEnumerator {
        Beginning(0),
        Middle(1),
        End(2),
        OnlyOneTab(3);

        TabPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static TabPosition resolve(int value) {
            return (TabPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Beginning;
            case 1: return Middle;
            case 2: return End;
            case 3: return OnlyOneTab;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SelectedPosition implements com.trolltech.qt.QtEnumerator {
        NotAdjacent(0),
        NextIsSelected(1),
        PreviousIsSelected(2);

        SelectedPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectedPosition resolve(int value) {
            return (SelectedPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotAdjacent;
            case 1: return NextIsSelected;
            case 2: return PreviousIsSelected;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(3);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 3: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionTab(com.trolltech.qt.gui.QStyleOptionTab other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionTab_QStyleOptionTab(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionTab()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionTab_QStyleOptionTab(long other);


    public QStyleOptionTab() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionTab();
    }
    private native void __qt_QStyleOptionTab();


    protected QStyleOptionTab(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionTab_int(version);
    }
    private native void __qt_QStyleOptionTab_int(int version);

    @QtBlockedSlot public final void setRow(int row) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRow_int(nativeId(), row);
    }
    private native static void __qt_setRow_int(long __this__nativeId, int row);

    @QtBlockedSlot public final int row() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_row(nativeId());
    }
    private native static int __qt_row(long __this__nativeId);


    @QtBlockedSlot public final void setCornerWidgets(com.trolltech.qt.gui.QStyleOptionTab.CornerWidget ... cornerWidgets) {
        this.setCornerWidgets(new com.trolltech.qt.gui.QStyleOptionTab.CornerWidgets(cornerWidgets));
    }
    @QtBlockedSlot public final void setCornerWidgets(com.trolltech.qt.gui.QStyleOptionTab.CornerWidgets cornerWidgets) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCornerWidgets_CornerWidgets(nativeId(), cornerWidgets.value());
    }
    private native static void __qt_setCornerWidgets_CornerWidgets(long __this__nativeId, int cornerWidgets);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionTab.CornerWidgets cornerWidgets() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionTab.CornerWidgets(__qt_cornerWidgets(nativeId()));
    }
    private native static int __qt_cornerWidgets(long __this__nativeId);

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.gui.QStyleOptionTab.TabPosition position) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_TabPosition(nativeId(), position.value());
    }
    private native static void __qt_setPosition_TabPosition(long __this__nativeId, int position);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionTab.TabPosition position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionTab.TabPosition.resolve(__qt_position(nativeId()));
    }
    private native static int __qt_position(long __this__nativeId);

    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QIcon icon) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setIcon_QIcon(long __this__nativeId, long icon);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon icon() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_icon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_icon(long __this__nativeId);

    @QtBlockedSlot public final void setShape(com.trolltech.qt.gui.QTabBar.Shape shape) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setShape_Shape(nativeId(), shape.value());
    }
    private native static void __qt_setShape_Shape(long __this__nativeId, int shape);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTabBar.Shape shape() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabBar.Shape.resolve(__qt_shape(nativeId()));
    }
    private native static int __qt_shape(long __this__nativeId);

    @QtBlockedSlot public final void setText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final void setSelectedPosition(com.trolltech.qt.gui.QStyleOptionTab.SelectedPosition selectedPosition) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectedPosition_SelectedPosition(nativeId(), selectedPosition.value());
    }
    private native static void __qt_setSelectedPosition_SelectedPosition(long __this__nativeId, int selectedPosition);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionTab.SelectedPosition selectedPosition() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionTab.SelectedPosition.resolve(__qt_selectedPosition(nativeId()));
    }
    private native static int __qt_selectedPosition(long __this__nativeId);


    public static native QStyleOptionTab fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionTab(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionTab array[]);
}
