package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionToolBar extends com.trolltech.qt.gui.QStyleOption
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(1);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StyleOptionType implements com.trolltech.qt.QtEnumerator {
        Type(16);

        StyleOptionType(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionType resolve(int value) {
            return (StyleOptionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 16: return Type;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolBarPosition implements com.trolltech.qt.QtEnumerator {
        Beginning(0),
        Middle(1),
        End(2),
        OnlyOne(3);

        ToolBarPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolBarPosition resolve(int value) {
            return (ToolBarPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Beginning;
            case 1: return Middle;
            case 2: return End;
            case 3: return OnlyOne;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ToolBarFeature implements com.trolltech.qt.QtEnumerator {
        None(0),
        Movable(1);

        ToolBarFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolBarFeatures createQFlags(ToolBarFeature ... values) {
            return new ToolBarFeatures(values);
        }
        public static ToolBarFeature resolve(int value) {
            return (ToolBarFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return Movable;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ToolBarFeatures extends com.trolltech.qt.QFlags<ToolBarFeature> {
        private static final long serialVersionUID = 1L;
        public ToolBarFeatures(ToolBarFeature ... args) { super(args); }
        public ToolBarFeatures(int value) { setValue(value); }
    }


    public QStyleOptionToolBar(com.trolltech.qt.gui.QStyleOptionToolBar other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBar_QStyleOptionToolBar(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionToolBar()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionToolBar_QStyleOptionToolBar(long other);


    public QStyleOptionToolBar() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBar();
    }
    private native void __qt_QStyleOptionToolBar();


    protected QStyleOptionToolBar(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBar_int(version);
    }
    private native void __qt_QStyleOptionToolBar_int(int version);

    @QtBlockedSlot public final void setLineWidth(int lineWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWidth_int(nativeId(), lineWidth);
    }
    private native static void __qt_setLineWidth_int(long __this__nativeId, int lineWidth);

    @QtBlockedSlot public final int lineWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineWidth(nativeId());
    }
    private native static int __qt_lineWidth(long __this__nativeId);

    @QtBlockedSlot public final void setPositionWithinLine(com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition positionWithinLine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPositionWithinLine_ToolBarPosition(nativeId(), positionWithinLine.value());
    }
    private native static void __qt_setPositionWithinLine_ToolBarPosition(long __this__nativeId, int positionWithinLine);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition positionWithinLine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition.resolve(__qt_positionWithinLine(nativeId()));
    }
    private native static int __qt_positionWithinLine(long __this__nativeId);

    @QtBlockedSlot public final void setPositionOfLine(com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition positionOfLine) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPositionOfLine_ToolBarPosition(nativeId(), positionOfLine.value());
    }
    private native static void __qt_setPositionOfLine_ToolBarPosition(long __this__nativeId, int positionOfLine);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition positionOfLine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarPosition.resolve(__qt_positionOfLine(nativeId()));
    }
    private native static int __qt_positionOfLine(long __this__nativeId);


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_ToolBarFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_ToolBarFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionToolBar.ToolBarFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);

    @QtBlockedSlot public final void setToolBarArea(com.trolltech.qt.core.Qt.ToolBarArea toolBarArea) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolBarArea_ToolBarArea(nativeId(), toolBarArea.value());
    }
    private native static void __qt_setToolBarArea_ToolBarArea(long __this__nativeId, int toolBarArea);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ToolBarArea toolBarArea() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ToolBarArea.resolve(__qt_toolBarArea(nativeId()));
    }
    private native static int __qt_toolBarArea(long __this__nativeId);

    @QtBlockedSlot public final void setMidLineWidth(int midLineWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMidLineWidth_int(nativeId(), midLineWidth);
    }
    private native static void __qt_setMidLineWidth_int(long __this__nativeId, int midLineWidth);

    @QtBlockedSlot public final int midLineWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_midLineWidth(nativeId());
    }
    private native static int __qt_midLineWidth(long __this__nativeId);


    public static native QStyleOptionToolBar fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionToolBar(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionToolBar array[]);
}
