package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionToolBoxV2 extends com.trolltech.qt.gui.QStyleOptionToolBox
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(2);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 2: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TabPosition implements com.trolltech.qt.QtEnumerator {
        Beginning(0),
        Middle(1),
        End(2),
        OnlyOneTab(3);

        TabPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static TabPosition resolve(int value) {
            return (TabPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Beginning;
            case 1: return Middle;
            case 2: return End;
            case 3: return OnlyOneTab;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SelectedPosition implements com.trolltech.qt.QtEnumerator {
        NotAdjacent(0),
        NextIsSelected(1),
        PreviousIsSelected(2);

        SelectedPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectedPosition resolve(int value) {
            return (SelectedPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NotAdjacent;
            case 1: return NextIsSelected;
            case 2: return PreviousIsSelected;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QStyleOptionToolBoxV2(com.trolltech.qt.gui.QStyleOptionToolBox other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBoxV2_QStyleOptionToolBox(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionToolBox()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionToolBoxV2_QStyleOptionToolBox(long other);


    public QStyleOptionToolBoxV2(com.trolltech.qt.gui.QStyleOptionToolBoxV2 other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBoxV2_QStyleOptionToolBoxV2(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionToolBoxV2()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionToolBoxV2_QStyleOptionToolBoxV2(long other);


    protected QStyleOptionToolBoxV2(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBoxV2_int(version);
    }
    private native void __qt_QStyleOptionToolBoxV2_int(int version);


    public QStyleOptionToolBoxV2() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionToolBoxV2();
    }
    private native void __qt_QStyleOptionToolBoxV2();

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.gui.QStyleOptionToolBoxV2.TabPosition position) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_TabPosition(nativeId(), position.value());
    }
    private native static void __qt_setPosition_TabPosition(long __this__nativeId, int position);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolBoxV2.TabPosition position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionToolBoxV2.TabPosition.resolve(__qt_position(nativeId()));
    }
    private native static int __qt_position(long __this__nativeId);

    @QtBlockedSlot public final void setSelectedPosition(com.trolltech.qt.gui.QStyleOptionToolBoxV2.SelectedPosition selectedPosition) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSelectedPosition_SelectedPosition(nativeId(), selectedPosition.value());
    }
    private native static void __qt_setSelectedPosition_SelectedPosition(long __this__nativeId, int selectedPosition);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionToolBoxV2.SelectedPosition selectedPosition() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QStyleOptionToolBoxV2.SelectedPosition.resolve(__qt_selectedPosition(nativeId()));
    }
    private native static int __qt_selectedPosition(long __this__nativeId);


    public static native QStyleOptionToolBoxV2 fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionToolBoxV2(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionToolBoxV2 array[]);
}
