package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QStyleOptionViewItemV2 extends com.trolltech.qt.gui.QStyleOptionViewItem
{
    public enum StyleOptionVersion implements com.trolltech.qt.QtEnumerator {
        Version(2);

        StyleOptionVersion(int value) { this.value = value; }
        public int value() { return value; }

        public static StyleOptionVersion resolve(int value) {
            return (StyleOptionVersion) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 2: return Version;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ViewItemFeature implements com.trolltech.qt.QtEnumerator {
        None(0),
        WrapText(1),
        Alternate(2);

        ViewItemFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static ViewItemFeatures createQFlags(ViewItemFeature ... values) {
            return new ViewItemFeatures(values);
        }
        public static ViewItemFeature resolve(int value) {
            return (ViewItemFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return None;
            case 1: return WrapText;
            case 2: return Alternate;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class ViewItemFeatures extends com.trolltech.qt.QFlags<ViewItemFeature> {
        private static final long serialVersionUID = 1L;
        public ViewItemFeatures(ViewItemFeature ... args) { super(args); }
        public ViewItemFeatures(int value) { setValue(value); }
    }


    public QStyleOptionViewItemV2(com.trolltech.qt.gui.QStyleOptionViewItem other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionViewItemV2_QStyleOptionViewItem(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionViewItem()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionViewItemV2_QStyleOptionViewItem(long other);


    public QStyleOptionViewItemV2(com.trolltech.qt.gui.QStyleOptionViewItemV2 other) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionViewItemV2_QStyleOptionViewItemV2(other == null ? (other = new com.trolltech.qt.gui.QStyleOptionViewItemV2()).nativeId() : other.nativeId());
    }
    private native void __qt_QStyleOptionViewItemV2_QStyleOptionViewItemV2(long other);


    protected QStyleOptionViewItemV2(int version) {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionViewItemV2_int(version);
    }
    private native void __qt_QStyleOptionViewItemV2_int(int version);


    public QStyleOptionViewItemV2() {
        super((QPrivateConstructor)null);
        __qt_QStyleOptionViewItemV2();
    }
    private native void __qt_QStyleOptionViewItemV2();


    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionViewItemV2.ViewItemFeature ... features) {
        this.setFeatures(new com.trolltech.qt.gui.QStyleOptionViewItemV2.ViewItemFeatures(features));
    }
    @QtBlockedSlot public final void setFeatures(com.trolltech.qt.gui.QStyleOptionViewItemV2.ViewItemFeatures features) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFeatures_ViewItemFeatures(nativeId(), features.value());
    }
    private native static void __qt_setFeatures_ViewItemFeatures(long __this__nativeId, int features);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyleOptionViewItemV2.ViewItemFeatures features() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QStyleOptionViewItemV2.ViewItemFeatures(__qt_features(nativeId()));
    }
    private native static int __qt_features(long __this__nativeId);


    public static native QStyleOptionViewItemV2 fromNativePointer(QNativePointer nativePointer);

    protected QStyleOptionViewItemV2(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QStyleOptionViewItemV2 array[]);
}
