package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTabWidget extends com.trolltech.qt.gui.QWidget
{
    public enum TabShape implements com.trolltech.qt.QtEnumerator {
        Rounded(0),
        Triangular(1);

        TabShape(int value) { this.value = value; }
        public int value() { return value; }

        public static TabShape resolve(int value) {
            return (TabShape) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Rounded;
            case 1: return Triangular;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum TabPosition implements com.trolltech.qt.QtEnumerator {
        North(0),
        South(1),
        West(2),
        East(3);

        TabPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static TabPosition resolve(int value) {
            return (TabPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return North;
            case 1: return South;
            case 2: return West;
            case 3: return East;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> currentChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void currentChanged(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentChanged_int(nativeId(), index);
    }
    private native static void __qt_currentChanged_int(long __this__nativeId, int index);


    public QTabWidget() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QTabWidget(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QTabWidget_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTabWidget_QWidget(long parent);


    @QtBlockedSlot public final int addTab(com.trolltech.qt.gui.QWidget widget, java.lang.String arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addTab_QWidget_String(nativeId(), widget == null ? 0 : widget.nativeId(), arg__2);
    }
    private native static int __qt_addTab_QWidget_String(long __this__nativeId, long widget, java.lang.String arg__2);

    @QtBlockedSlot public final int addTab(com.trolltech.qt.gui.QWidget widget, com.trolltech.qt.gui.QIcon icon, java.lang.String label) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addTab_QWidget_QIcon_String(nativeId(), widget == null ? 0 : widget.nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), label);
    }
    private native static int __qt_addTab_QWidget_QIcon_String(long __this__nativeId, long widget, long icon, java.lang.String label);

    @QtBlockedSlot public final void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget cornerWidget() {
        return cornerWidget(com.trolltech.qt.core.Qt.Corner.TopRightCorner);
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget cornerWidget(com.trolltech.qt.core.Qt.Corner corner) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cornerWidget_Corner(nativeId(), corner.value());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_cornerWidget_Corner(long __this__nativeId, int corner);

    @com.trolltech.qt.QtPropertyReader(name="count")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final int count() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_count(nativeId());
    }
    private native static int __qt_count(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="currentIndex")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final int currentIndex() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentIndex(nativeId());
    }
    private native static int __qt_currentIndex(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget currentWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_currentWidget(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="elideMode")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextElideMode elideMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.TextElideMode.resolve(__qt_elideMode(nativeId()));
    }
    private native static int __qt_elideMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="iconSize")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize iconSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_iconSize(long __this__nativeId);

    @QtBlockedSlot public final int indexOf(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexOf_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static int __qt_indexOf_QWidget(long __this__nativeId, long widget);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot public final int insertTab(int index, com.trolltech.qt.gui.QWidget widget, java.lang.String arg__3) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTab_int_QWidget_String(nativeId(), index, widget == null ? 0 : widget.nativeId(), arg__3);
    }
    private native static int __qt_insertTab_int_QWidget_String(long __this__nativeId, int index, long widget, java.lang.String arg__3);

    @QtBlockedSlot public final int insertTab(int index, com.trolltech.qt.gui.QWidget widget, com.trolltech.qt.gui.QIcon icon, java.lang.String label) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTab_int_QWidget_QIcon_String(nativeId(), index, widget == null ? 0 : widget.nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId(), label);
    }
    private native static int __qt_insertTab_int_QWidget_QIcon_String(long __this__nativeId, int index, long widget, long icon, java.lang.String label);

    @QtBlockedSlot public final boolean isTabEnabled(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTabEnabled_int(nativeId(), index);
    }
    private native static boolean __qt_isTabEnabled_int(long __this__nativeId, int index);

    @QtBlockedSlot public final void removeTab(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeTab_int(nativeId(), index);
    }
    private native static void __qt_removeTab_int(long __this__nativeId, int index);


    @QtBlockedSlot public final void setCornerWidget(com.trolltech.qt.gui.QWidget w) {
        setCornerWidget(w, com.trolltech.qt.core.Qt.Corner.TopRightCorner);
    }
    @QtBlockedSlot public final void setCornerWidget(com.trolltech.qt.gui.QWidget w, com.trolltech.qt.core.Qt.Corner corner) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCornerWidget_QWidget_Corner(nativeId(), w == null ? 0 : w.nativeId(), corner.value());
    }
    private native static void __qt_setCornerWidget_QWidget_Corner(long __this__nativeId, long w, int corner);

    @com.trolltech.qt.QtPropertyWriter(name="currentIndex")
    public final void setCurrentIndex(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentIndex_int(nativeId(), index);
    }
    private native static void __qt_setCurrentIndex_int(long __this__nativeId, int index);

    public final void setCurrentWidget(com.trolltech.qt.gui.QWidget widget) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentWidget_QWidget(nativeId(), widget == null ? 0 : widget.nativeId());
    }
    private native static void __qt_setCurrentWidget_QWidget(long __this__nativeId, long widget);

    @com.trolltech.qt.QtPropertyWriter(name="elideMode")
    @QtBlockedSlot public final void setElideMode(com.trolltech.qt.core.Qt.TextElideMode arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setElideMode_TextElideMode(nativeId(), arg__1.value());
    }
    private native static void __qt_setElideMode_TextElideMode(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="iconSize")
    @QtBlockedSlot public final void setIconSize(com.trolltech.qt.core.QSize size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconSize_QSize(nativeId(), size == null ? (size = new com.trolltech.qt.core.QSize()).nativeId() : size.nativeId());
    }
    private native static void __qt_setIconSize_QSize(long __this__nativeId, long size);

    @QtBlockedSlot protected final void setTabBar(com.trolltech.qt.gui.QTabBar arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabBar_QTabBar(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setTabBar_QTabBar(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setTabEnabled(int index, boolean arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabEnabled_int_boolean(nativeId(), index, arg__2);
    }
    private native static void __qt_setTabEnabled_int_boolean(long __this__nativeId, int index, boolean arg__2);

    @QtBlockedSlot public final void setTabIcon(int index, com.trolltech.qt.gui.QIcon icon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabIcon_int_QIcon(nativeId(), index, icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setTabIcon_int_QIcon(long __this__nativeId, int index, long icon);

    @com.trolltech.qt.QtPropertyWriter(name="tabPosition")
    @QtBlockedSlot public final void setTabPosition(com.trolltech.qt.gui.QTabWidget.TabPosition arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabPosition_TabPosition(nativeId(), arg__1.value());
    }
    private native static void __qt_setTabPosition_TabPosition(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="tabShape")
    @QtBlockedSlot public final void setTabShape(com.trolltech.qt.gui.QTabWidget.TabShape s) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabShape_TabShape(nativeId(), s.value());
    }
    private native static void __qt_setTabShape_TabShape(long __this__nativeId, int s);

    @QtBlockedSlot public final void setTabText(int index, java.lang.String arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabText_int_String(nativeId(), index, arg__2);
    }
    private native static void __qt_setTabText_int_String(long __this__nativeId, int index, java.lang.String arg__2);

    @QtBlockedSlot public final void setTabToolTip(int index, java.lang.String tip) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabToolTip_int_String(nativeId(), index, tip);
    }
    private native static void __qt_setTabToolTip_int_String(long __this__nativeId, int index, java.lang.String tip);

    @QtBlockedSlot public final void setTabWhatsThis(int index, java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabWhatsThis_int_String(nativeId(), index, text);
    }
    private native static void __qt_setTabWhatsThis_int_String(long __this__nativeId, int index, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="usesScrollButtons")
    @QtBlockedSlot public final void setUsesScrollButtons(boolean useButtons) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUsesScrollButtons_boolean(nativeId(), useButtons);
    }
    private native static void __qt_setUsesScrollButtons_boolean(long __this__nativeId, boolean useButtons);

    @QtBlockedSlot protected final com.trolltech.qt.gui.QTabBar tabBar() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabBar(nativeId());
    }
    private native static com.trolltech.qt.gui.QTabBar __qt_tabBar(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon tabIcon(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabIcon_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QIcon __qt_tabIcon_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyReader(name="tabPosition")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QTabWidget.TabPosition tabPosition() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabWidget.TabPosition.resolve(__qt_tabPosition(nativeId()));
    }
    private native static int __qt_tabPosition(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="tabShape")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QTabWidget.TabShape tabShape() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabWidget.TabShape.resolve(__qt_tabShape(nativeId()));
    }
    private native static int __qt_tabShape(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String tabText(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabText_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabText_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String tabToolTip(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabToolTip_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabToolTip_int(long __this__nativeId, int index);

    @QtBlockedSlot public final java.lang.String tabWhatsThis(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabWhatsThis_int(nativeId(), index);
    }
    private native static java.lang.String __qt_tabWhatsThis_int(long __this__nativeId, int index);

    @com.trolltech.qt.QtPropertyReader(name="usesScrollButtons")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final boolean usesScrollButtons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_usesScrollButtons(nativeId());
    }
    private native static boolean __qt_usesScrollButtons(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget widget(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widget_int(nativeId(), index);
    }
    private native static com.trolltech.qt.gui.QWidget __qt_widget_int(long __this__nativeId, int index);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void tabInserted(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabInserted_int(nativeId(), index);
    }
    private native static void __qt_tabInserted_int(long __this__nativeId, int index);

    @QtBlockedSlot protected void tabRemoved(int index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabRemoved_int(nativeId(), index);
    }
    private native static void __qt_tabRemoved_int(long __this__nativeId, int index);


    public static native QTabWidget fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTabWidget(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionTabWidgetFrame option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
