package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTabletEvent extends com.trolltech.qt.gui.QInputEvent
{
    public enum TabletDevice implements com.trolltech.qt.QtEnumerator {
        NoDevice(0),
        Puck(1),
        Stylus(2),
        Airbrush(3),
        FourDMouse(4),
        XFreeEraser(5),
        RotationStylus(6);

        TabletDevice(int value) { this.value = value; }
        public int value() { return value; }

        public static TabletDevice resolve(int value) {
            return (TabletDevice) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoDevice;
            case 1: return Puck;
            case 2: return Stylus;
            case 3: return Airbrush;
            case 4: return FourDMouse;
            case 5: return XFreeEraser;
            case 6: return RotationStylus;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum PointerType implements com.trolltech.qt.QtEnumerator {
        UnknownPointer(0),
        Pen(1),
        Cursor(2),
        Eraser(3);

        PointerType(int value) { this.value = value; }
        public int value() { return value; }

        public static PointerType resolve(int value) {
            return (PointerType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnknownPointer;
            case 1: return Pen;
            case 2: return Cursor;
            case 3: return Eraser;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTabletEvent(com.trolltech.qt.core.QEvent.Type t, com.trolltech.qt.core.QPoint pos, com.trolltech.qt.core.QPoint globalPos, com.trolltech.qt.core.QPointF hiResGlobalPos, int device, int pointerType, double pressure, int xTilt, int yTilt, double tangentialPressure, double rotation, int z, com.trolltech.qt.core.Qt.KeyboardModifiers keyState, long uniqueID) {
        super((QPrivateConstructor)null);
        __qt_QTabletEvent_Type_QPoint_QPoint_QPointF_int_int_double_int_int_double_double_int_KeyboardModifiers_long(t.value(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId(), globalPos == null ? (globalPos = new com.trolltech.qt.core.QPoint()).nativeId() : globalPos.nativeId(), hiResGlobalPos == null ? (hiResGlobalPos = new com.trolltech.qt.core.QPointF()).nativeId() : hiResGlobalPos.nativeId(), device, pointerType, pressure, xTilt, yTilt, tangentialPressure, rotation, z, keyState.value(), uniqueID);
    }
    private native void __qt_QTabletEvent_Type_QPoint_QPoint_QPointF_int_int_double_int_int_double_double_int_KeyboardModifiers_long(int t, long pos, long globalPos, long hiResGlobalPos, int device, int pointerType, double pressure, int xTilt, int yTilt, double tangentialPressure, double rotation, int z, int keyState, long uniqueID);


    @QtBlockedSlot public final com.trolltech.qt.gui.QTabletEvent.TabletDevice device() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabletEvent.TabletDevice.resolve(__qt_device(nativeId()));
    }
    private native static int __qt_device(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint globalPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_globalPos(long __this__nativeId);

    @QtBlockedSlot public final int globalX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalX(nativeId());
    }
    private native static int __qt_globalX(long __this__nativeId);

    @QtBlockedSlot public final int globalY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_globalY(nativeId());
    }
    private native static int __qt_globalY(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF hiResGlobalPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hiResGlobalPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_hiResGlobalPos(long __this__nativeId);

    @QtBlockedSlot public final double hiResGlobalX() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hiResGlobalX(nativeId());
    }
    private native static double __qt_hiResGlobalX(long __this__nativeId);

    @QtBlockedSlot public final double hiResGlobalY() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hiResGlobalY(nativeId());
    }
    private native static double __qt_hiResGlobalY(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTabletEvent.PointerType pointerType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTabletEvent.PointerType.resolve(__qt_pointerType(nativeId()));
    }
    private native static int __qt_pointerType(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint pos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_pos(long __this__nativeId);

    @QtBlockedSlot public final double pressure() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pressure(nativeId());
    }
    private native static double __qt_pressure(long __this__nativeId);

    @QtBlockedSlot public final double rotation() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rotation(nativeId());
    }
    private native static double __qt_rotation(long __this__nativeId);

    @QtBlockedSlot public final double tangentialPressure() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tangentialPressure(nativeId());
    }
    private native static double __qt_tangentialPressure(long __this__nativeId);

    @QtBlockedSlot public final long uniqueId() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_uniqueId(nativeId());
    }
    private native static long __qt_uniqueId(long __this__nativeId);

    @QtBlockedSlot public final int x() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x(nativeId());
    }
    private native static int __qt_x(long __this__nativeId);

    @QtBlockedSlot public final int xTilt() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_xTilt(nativeId());
    }
    private native static int __qt_xTilt(long __this__nativeId);

    @QtBlockedSlot public final int y() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y(nativeId());
    }
    private native static int __qt_y(long __this__nativeId);

    @QtBlockedSlot public final int yTilt() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_yTilt(nativeId());
    }
    private native static int __qt_yTilt(long __this__nativeId);

    @QtBlockedSlot public final int z() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_z(nativeId());
    }
    private native static int __qt_z(long __this__nativeId);

    @QtBlockedSlot protected final void setMYT(int mYT) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMYT_int(nativeId(), mYT);
    }
    private native static void __qt_setMYT_int(long __this__nativeId, int mYT);

    @QtBlockedSlot protected final int mYT() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mYT(nativeId());
    }
    private native static int __qt_mYT(long __this__nativeId);

    @QtBlockedSlot protected final void setMGPos(com.trolltech.qt.core.QPoint mGPos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMGPos_QPoint(nativeId(), mGPos == null ? (mGPos = new com.trolltech.qt.core.QPoint()).nativeId() : mGPos.nativeId());
    }
    private native static void __qt_setMGPos_QPoint(long __this__nativeId, long mGPos);

    @QtBlockedSlot protected final com.trolltech.qt.core.QPoint mGPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mGPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mGPos(long __this__nativeId);

    @QtBlockedSlot protected final void setMXT(int mXT) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMXT_int(nativeId(), mXT);
    }
    private native static void __qt_setMXT_int(long __this__nativeId, int mXT);

    @QtBlockedSlot protected final int mXT() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mXT(nativeId());
    }
    private native static int __qt_mXT(long __this__nativeId);

    @QtBlockedSlot protected final void setMUnique(long mUnique) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMUnique_long(nativeId(), mUnique);
    }
    private native static void __qt_setMUnique_long(long __this__nativeId, long mUnique);

    @QtBlockedSlot protected final long mUnique() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mUnique(nativeId());
    }
    private native static long __qt_mUnique(long __this__nativeId);

    @QtBlockedSlot protected final void setMTangential(double mTangential) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMTangential_double(nativeId(), mTangential);
    }
    private native static void __qt_setMTangential_double(long __this__nativeId, double mTangential);

    @QtBlockedSlot protected final double mTangential() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mTangential(nativeId());
    }
    private native static double __qt_mTangential(long __this__nativeId);

    @QtBlockedSlot protected final void setMPointerType(int mPointerType) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMPointerType_int(nativeId(), mPointerType);
    }
    private native static void __qt_setMPointerType_int(long __this__nativeId, int mPointerType);

    @QtBlockedSlot protected final int mPointerType() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mPointerType(nativeId());
    }
    private native static int __qt_mPointerType(long __this__nativeId);

    @QtBlockedSlot protected final void setMHiResGlobalPos(com.trolltech.qt.core.QPointF mHiResGlobalPos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMHiResGlobalPos_QPointF(nativeId(), mHiResGlobalPos == null ? (mHiResGlobalPos = new com.trolltech.qt.core.QPointF()).nativeId() : mHiResGlobalPos.nativeId());
    }
    private native static void __qt_setMHiResGlobalPos_QPointF(long __this__nativeId, long mHiResGlobalPos);

    @QtBlockedSlot protected final com.trolltech.qt.core.QPointF mHiResGlobalPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mHiResGlobalPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_mHiResGlobalPos(long __this__nativeId);

    @QtBlockedSlot protected final void setMPos(com.trolltech.qt.core.QPoint mPos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMPos_QPoint(nativeId(), mPos == null ? (mPos = new com.trolltech.qt.core.QPoint()).nativeId() : mPos.nativeId());
    }
    private native static void __qt_setMPos_QPoint(long __this__nativeId, long mPos);

    @QtBlockedSlot protected final com.trolltech.qt.core.QPoint mPos() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mPos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mPos(long __this__nativeId);

    @QtBlockedSlot protected final void setMPress(double mPress) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMPress_double(nativeId(), mPress);
    }
    private native static void __qt_setMPress_double(long __this__nativeId, double mPress);

    @QtBlockedSlot protected final double mPress() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mPress(nativeId());
    }
    private native static double __qt_mPress(long __this__nativeId);

    @QtBlockedSlot protected final void setMDev(int mDev) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMDev_int(nativeId(), mDev);
    }
    private native static void __qt_setMDev_int(long __this__nativeId, int mDev);

    @QtBlockedSlot protected final int mDev() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mDev(nativeId());
    }
    private native static int __qt_mDev(long __this__nativeId);

    @QtBlockedSlot protected final void setMRot(double mRot) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMRot_double(nativeId(), mRot);
    }
    private native static void __qt_setMRot_double(long __this__nativeId, double mRot);

    @QtBlockedSlot protected final double mRot() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mRot(nativeId());
    }
    private native static double __qt_mRot(long __this__nativeId);

    @QtBlockedSlot protected final void setMZ(int mZ) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMZ_int(nativeId(), mZ);
    }
    private native static void __qt_setMZ_int(long __this__nativeId, int mZ);

    @QtBlockedSlot protected final int mZ() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mZ(nativeId());
    }
    private native static int __qt_mZ(long __this__nativeId);


    public static native QTabletEvent fromNativePointer(QNativePointer nativePointer);

    protected QTabletEvent(QPrivateConstructor p) { super(p); } 

}
