package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextCharFormat extends com.trolltech.qt.gui.QTextFormat
{
    public enum VerticalAlignment implements com.trolltech.qt.QtEnumerator {
        AlignNormal(0),
        AlignSuperScript(1),
        AlignSubScript(2),
        AlignMiddle(3),
        AlignTop(4),
        AlignBottom(5);

        VerticalAlignment(int value) { this.value = value; }
        public int value() { return value; }

        public static VerticalAlignment resolve(int value) {
            return (VerticalAlignment) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AlignNormal;
            case 1: return AlignSuperScript;
            case 2: return AlignSubScript;
            case 3: return AlignMiddle;
            case 4: return AlignTop;
            case 5: return AlignBottom;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum UnderlineStyle implements com.trolltech.qt.QtEnumerator {
        NoUnderline(0),
        SingleUnderline(1),
        DashUnderline(2),
        DotLine(3),
        DashDotLine(4),
        DashDotDotLine(5),
        WaveUnderline(6),
        SpellCheckUnderline(7);

        UnderlineStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static UnderlineStyle resolve(int value) {
            return (UnderlineStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoUnderline;
            case 1: return SingleUnderline;
            case 2: return DashUnderline;
            case 3: return DotLine;
            case 4: return DashDotLine;
            case 5: return DashDotDotLine;
            case 6: return WaveUnderline;
            case 7: return SpellCheckUnderline;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextCharFormat() {
        super((QPrivateConstructor)null);
        __qt_QTextCharFormat();
    }
    private native void __qt_QTextCharFormat();


    @QtBlockedSlot public final java.lang.String anchorHref() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_anchorHref(nativeId());
    }
    private native static java.lang.String __qt_anchorHref(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<java.lang.String> anchorNames() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_anchorNames(nativeId());
    }
    private native static java.util.List<java.lang.String> __qt_anchorNames(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fontFamily() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontFamily(nativeId());
    }
    private native static java.lang.String __qt_fontFamily(long __this__nativeId);

    @QtBlockedSlot public final boolean fontFixedPitch() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontFixedPitch(nativeId());
    }
    private native static boolean __qt_fontFixedPitch(long __this__nativeId);

    @QtBlockedSlot public final boolean fontItalic() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontItalic(nativeId());
    }
    private native static boolean __qt_fontItalic(long __this__nativeId);

    @QtBlockedSlot public final boolean fontOverline() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontOverline(nativeId());
    }
    private native static boolean __qt_fontOverline(long __this__nativeId);

    @QtBlockedSlot public final double fontPointSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontPointSize(nativeId());
    }
    private native static double __qt_fontPointSize(long __this__nativeId);

    @QtBlockedSlot public final boolean fontStrikeOut() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontStrikeOut(nativeId());
    }
    private native static boolean __qt_fontStrikeOut(long __this__nativeId);

    @QtBlockedSlot public final boolean fontUnderline() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontUnderline(nativeId());
    }
    private native static boolean __qt_fontUnderline(long __this__nativeId);

    @QtBlockedSlot public final int fontWeight() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontWeight(nativeId());
    }
    private native static int __qt_fontWeight(long __this__nativeId);

    @QtBlockedSlot public final boolean isAnchor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAnchor(nativeId());
    }
    private native static boolean __qt_isAnchor(long __this__nativeId);

    @QtBlockedSlot public boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final void setAnchor(boolean anchor) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAnchor_boolean(nativeId(), anchor);
    }
    private native static void __qt_setAnchor_boolean(long __this__nativeId, boolean anchor);

    @QtBlockedSlot public final void setAnchorHref(java.lang.String value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAnchorHref_String(nativeId(), value);
    }
    private native static void __qt_setAnchorHref_String(long __this__nativeId, java.lang.String value);

    @QtBlockedSlot public final void setAnchorNames(java.util.List<java.lang.String> names) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAnchorNames_List(nativeId(), names);
    }
    private native static void __qt_setAnchorNames_List(long __this__nativeId, java.util.List<java.lang.String> names);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont font) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long font);

    @QtBlockedSlot public final void setFontFamily(java.lang.String family) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontFamily_String(nativeId(), family);
    }
    private native static void __qt_setFontFamily_String(long __this__nativeId, java.lang.String family);

    @QtBlockedSlot public final void setFontFixedPitch(boolean fixedPitch) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontFixedPitch_boolean(nativeId(), fixedPitch);
    }
    private native static void __qt_setFontFixedPitch_boolean(long __this__nativeId, boolean fixedPitch);

    @QtBlockedSlot public final void setFontItalic(boolean italic) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontItalic_boolean(nativeId(), italic);
    }
    private native static void __qt_setFontItalic_boolean(long __this__nativeId, boolean italic);

    @QtBlockedSlot public final void setFontOverline(boolean overline) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontOverline_boolean(nativeId(), overline);
    }
    private native static void __qt_setFontOverline_boolean(long __this__nativeId, boolean overline);

    @QtBlockedSlot public final void setFontPointSize(double size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontPointSize_double(nativeId(), size);
    }
    private native static void __qt_setFontPointSize_double(long __this__nativeId, double size);

    @QtBlockedSlot public final void setFontStrikeOut(boolean strikeOut) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontStrikeOut_boolean(nativeId(), strikeOut);
    }
    private native static void __qt_setFontStrikeOut_boolean(long __this__nativeId, boolean strikeOut);

    @QtBlockedSlot public final void setFontUnderline(boolean underline) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontUnderline_boolean(nativeId(), underline);
    }
    private native static void __qt_setFontUnderline_boolean(long __this__nativeId, boolean underline);

    @QtBlockedSlot public final void setFontWeight(int weight) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontWeight_int(nativeId(), weight);
    }
    private native static void __qt_setFontWeight_int(long __this__nativeId, int weight);

    @QtBlockedSlot public final void setTableCellColumnSpan(int tableCellColumnSpan) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTableCellColumnSpan_int(nativeId(), tableCellColumnSpan);
    }
    private native static void __qt_setTableCellColumnSpan_int(long __this__nativeId, int tableCellColumnSpan);

    @QtBlockedSlot public final void setTableCellRowSpan(int tableCellRowSpan) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTableCellRowSpan_int(nativeId(), tableCellRowSpan);
    }
    private native static void __qt_setTableCellRowSpan_int(long __this__nativeId, int tableCellRowSpan);

    @QtBlockedSlot public final void setTextOutline(com.trolltech.qt.gui.QPen pen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextOutline_QPen(nativeId(), pen == null ? (pen = new com.trolltech.qt.gui.QPen()).nativeId() : pen.nativeId());
    }
    private native static void __qt_setTextOutline_QPen(long __this__nativeId, long pen);

    @QtBlockedSlot public final void setToolTip(java.lang.String tip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_String(nativeId(), tip);
    }
    private native static void __qt_setToolTip_String(long __this__nativeId, java.lang.String tip);

    @QtBlockedSlot public final void setUnderlineColor(com.trolltech.qt.gui.QColor color) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUnderlineColor_QColor(nativeId(), color == null ? (color = new com.trolltech.qt.gui.QColor()).nativeId() : color.nativeId());
    }
    private native static void __qt_setUnderlineColor_QColor(long __this__nativeId, long color);

    @QtBlockedSlot public final void setUnderlineStyle(com.trolltech.qt.gui.QTextCharFormat.UnderlineStyle style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUnderlineStyle_UnderlineStyle(nativeId(), style.value());
    }
    private native static void __qt_setUnderlineStyle_UnderlineStyle(long __this__nativeId, int style);

    @QtBlockedSlot public final void setVerticalAlignment(com.trolltech.qt.gui.QTextCharFormat.VerticalAlignment alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVerticalAlignment_VerticalAlignment(nativeId(), alignment.value());
    }
    private native static void __qt_setVerticalAlignment_VerticalAlignment(long __this__nativeId, int alignment);

    @QtBlockedSlot public final int tableCellColumnSpan() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tableCellColumnSpan(nativeId());
    }
    private native static int __qt_tableCellColumnSpan(long __this__nativeId);

    @QtBlockedSlot public final int tableCellRowSpan() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tableCellRowSpan(nativeId());
    }
    private native static int __qt_tableCellRowSpan(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPen textOutline() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textOutline(nativeId());
    }
    private native static com.trolltech.qt.gui.QPen __qt_textOutline(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String toolTip() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip(nativeId());
    }
    private native static java.lang.String __qt_toolTip(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor underlineColor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_underlineColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_underlineColor(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat.UnderlineStyle underlineStyle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextCharFormat.UnderlineStyle.resolve(__qt_underlineStyle(nativeId()));
    }
    private native static int __qt_underlineStyle(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat.VerticalAlignment verticalAlignment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextCharFormat.VerticalAlignment.resolve(__qt_verticalAlignment(nativeId()));
    }
    private native static int __qt_verticalAlignment(long __this__nativeId);


    public static native QTextCharFormat fromNativePointer(QNativePointer nativePointer);

    protected QTextCharFormat(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextCharFormat array[]);
}
