package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextCursor extends com.trolltech.qt.QtJambiObject
    implements java.lang.Comparable
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum MoveMode implements com.trolltech.qt.QtEnumerator {
        MoveAnchor(0),
        KeepAnchor(1);

        MoveMode(int value) { this.value = value; }
        public int value() { return value; }

        public static MoveMode resolve(int value) {
            return (MoveMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return MoveAnchor;
            case 1: return KeepAnchor;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum MoveOperation implements com.trolltech.qt.QtEnumerator {
        NoMove(0),
        Start(1),
        Up(2),
        StartOfLine(3),
        StartOfBlock(4),
        StartOfWord(5),
        PreviousBlock(6),
        PreviousCharacter(7),
        PreviousWord(8),
        Left(9),
        WordLeft(10),
        End(11),
        Down(12),
        EndOfLine(13),
        EndOfWord(14),
        EndOfBlock(15),
        NextBlock(16),
        NextCharacter(17),
        NextWord(18),
        Right(19),
        WordRight(20);

        MoveOperation(int value) { this.value = value; }
        public int value() { return value; }

        public static MoveOperation resolve(int value) {
            return (MoveOperation) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoMove;
            case 1: return Start;
            case 2: return Up;
            case 3: return StartOfLine;
            case 4: return StartOfBlock;
            case 5: return StartOfWord;
            case 6: return PreviousBlock;
            case 7: return PreviousCharacter;
            case 8: return PreviousWord;
            case 9: return Left;
            case 10: return WordLeft;
            case 11: return End;
            case 12: return Down;
            case 13: return EndOfLine;
            case 14: return EndOfWord;
            case 15: return EndOfBlock;
            case 16: return NextBlock;
            case 17: return NextCharacter;
            case 18: return NextWord;
            case 19: return Right;
            case 20: return WordRight;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SelectionType implements com.trolltech.qt.QtEnumerator {
        WordUnderCursor(0),
        LineUnderCursor(1),
        BlockUnderCursor(2),
        Document(3);

        SelectionType(int value) { this.value = value; }
        public int value() { return value; }

        public static SelectionType resolve(int value) {
            return (SelectionType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WordUnderCursor;
            case 1: return LineUnderCursor;
            case 2: return BlockUnderCursor;
            case 3: return Document;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextCursor(com.trolltech.qt.gui.QTextFrame frame) {
        super((QPrivateConstructor)null);
        __qt_QTextCursor_QTextFrame(frame == null ? 0 : frame.nativeId());
    }
    private native void __qt_QTextCursor_QTextFrame(long frame);


    public QTextCursor(com.trolltech.qt.gui.QTextCursor cursor) {
        super((QPrivateConstructor)null);
        __qt_QTextCursor_QTextCursor(cursor == null ? (cursor = new com.trolltech.qt.gui.QTextCursor()).nativeId() : cursor.nativeId());
    }
    private native void __qt_QTextCursor_QTextCursor(long cursor);


    public QTextCursor() {
        super((QPrivateConstructor)null);
        __qt_QTextCursor();
    }
    private native void __qt_QTextCursor();


    public QTextCursor(com.trolltech.qt.gui.QTextBlock block) {
        super((QPrivateConstructor)null);
        __qt_QTextCursor_QTextBlock(block == null ? (block = new com.trolltech.qt.gui.QTextBlock()).nativeId() : block.nativeId());
    }
    private native void __qt_QTextCursor_QTextBlock(long block);


    public QTextCursor(com.trolltech.qt.gui.QTextDocument document) {
        super((QPrivateConstructor)null);
        __qt_QTextCursor_QTextDocument(document == null ? 0 : document.nativeId());
    }
    private native void __qt_QTextCursor_QTextDocument(long document);


    @QtBlockedSlot public final int anchor() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_anchor(nativeId());
    }
    private native static int __qt_anchor(long __this__nativeId);

    @QtBlockedSlot public final boolean atBlockEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atBlockEnd(nativeId());
    }
    private native static boolean __qt_atBlockEnd(long __this__nativeId);

    @QtBlockedSlot public final boolean atBlockStart() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atBlockStart(nativeId());
    }
    private native static boolean __qt_atBlockStart(long __this__nativeId);

    @QtBlockedSlot public final boolean atEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public final boolean atStart() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atStart(nativeId());
    }
    private native static boolean __qt_atStart(long __this__nativeId);

    @QtBlockedSlot public final void beginEditBlock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beginEditBlock(nativeId());
    }
    private native static void __qt_beginEditBlock(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlock block() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_block(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextBlock __qt_block(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat blockCharFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blockCharFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_blockCharFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextBlockFormat blockFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blockFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextBlockFormat __qt_blockFormat(long __this__nativeId);

    @QtBlockedSlot public final int blockNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blockNumber(nativeId());
    }
    private native static int __qt_blockNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat charFormat() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_charFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_charFormat(long __this__nativeId);

    @QtBlockedSlot public final void clearSelection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearSelection(nativeId());
    }
    private native static void __qt_clearSelection(long __this__nativeId);

    @QtBlockedSlot public final int columnNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_columnNumber(nativeId());
    }
    private native static int __qt_columnNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextList createList(com.trolltech.qt.gui.QTextListFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createList_QTextListFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextListFormat()).nativeId() : format.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextList __qt_createList_QTextListFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextList createList(com.trolltech.qt.gui.QTextListFormat.Style style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createList_Style(nativeId(), style.value());
    }
    private native static com.trolltech.qt.gui.QTextList __qt_createList_Style(long __this__nativeId, int style);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrame currentFrame() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentFrame(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextFrame __qt_currentFrame(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextList currentList() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentList(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextList __qt_currentList(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextTable currentTable() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentTable(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextTable __qt_currentTable(long __this__nativeId);

    @QtBlockedSlot public final void deleteChar() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_deleteChar(nativeId());
    }
    private native static void __qt_deleteChar(long __this__nativeId);

    @QtBlockedSlot public final void deletePreviousChar() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_deletePreviousChar(nativeId());
    }
    private native static void __qt_deletePreviousChar(long __this__nativeId);

    @QtBlockedSlot public final void endEditBlock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_endEditBlock(nativeId());
    }
    private native static void __qt_endEditBlock(long __this__nativeId);

    @QtBlockedSlot public final boolean hasComplexSelection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasComplexSelection(nativeId());
    }
    private native static boolean __qt_hasComplexSelection(long __this__nativeId);

    @QtBlockedSlot public final boolean hasSelection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasSelection(nativeId());
    }
    private native static boolean __qt_hasSelection(long __this__nativeId);

    @QtBlockedSlot public final void insertBlock(com.trolltech.qt.gui.QTextBlockFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertBlock_QTextBlockFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextBlockFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_insertBlock_QTextBlockFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final void insertBlock(com.trolltech.qt.gui.QTextBlockFormat format, com.trolltech.qt.gui.QTextCharFormat charFormat) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertBlock_QTextBlockFormat_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextBlockFormat()).nativeId() : format.nativeId(), charFormat == null ? (charFormat = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : charFormat.nativeId());
    }
    private native static void __qt_insertBlock_QTextBlockFormat_QTextCharFormat(long __this__nativeId, long format, long charFormat);

    @QtBlockedSlot public final void insertBlock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertBlock(nativeId());
    }
    private native static void __qt_insertBlock(long __this__nativeId);

    @QtBlockedSlot public final void insertFragment(com.trolltech.qt.gui.QTextDocumentFragment fragment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertFragment_QTextDocumentFragment(nativeId(), fragment == null ? (fragment = new com.trolltech.qt.gui.QTextDocumentFragment()).nativeId() : fragment.nativeId());
    }
    private native static void __qt_insertFragment_QTextDocumentFragment(long __this__nativeId, long fragment);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrame insertFrame(com.trolltech.qt.gui.QTextFrameFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertFrame_QTextFrameFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextFrameFormat()).nativeId() : format.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextFrame __qt_insertFrame_QTextFrameFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final void insertHtml(java.lang.String html) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertHtml_String(nativeId(), html);
    }
    private native static void __qt_insertHtml_String(long __this__nativeId, java.lang.String html);

    @QtBlockedSlot public final void insertImage(com.trolltech.qt.gui.QTextImageFormat format, com.trolltech.qt.gui.QTextFrameFormat.Position alignment) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertImage_QTextImageFormat_Position(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextImageFormat()).nativeId() : format.nativeId(), alignment.value());
    }
    private native static void __qt_insertImage_QTextImageFormat_Position(long __this__nativeId, long format, int alignment);

    @QtBlockedSlot public final void insertImage(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertImage_String(nativeId(), name);
    }
    private native static void __qt_insertImage_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final void insertImage(com.trolltech.qt.gui.QTextImageFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertImage_QTextImageFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextImageFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_insertImage_QTextImageFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextList insertList(com.trolltech.qt.gui.QTextListFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertList_QTextListFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextListFormat()).nativeId() : format.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextList __qt_insertList_QTextListFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextList insertList(com.trolltech.qt.gui.QTextListFormat.Style style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertList_Style(nativeId(), style.value());
    }
    private native static com.trolltech.qt.gui.QTextList __qt_insertList_Style(long __this__nativeId, int style);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextTable insertTable(int rows, int cols, com.trolltech.qt.gui.QTextTableFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTable_int_int_QTextTableFormat(nativeId(), rows, cols, format == null ? (format = new com.trolltech.qt.gui.QTextTableFormat()).nativeId() : format.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextTable __qt_insertTable_int_int_QTextTableFormat(long __this__nativeId, int rows, int cols, long format);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextTable insertTable(int rows, int cols) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertTable_int_int(nativeId(), rows, cols);
    }
    private native static com.trolltech.qt.gui.QTextTable __qt_insertTable_int_int(long __this__nativeId, int rows, int cols);

    @QtBlockedSlot public final void insertText(java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertText_String(nativeId(), text);
    }
    private native static void __qt_insertText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final void insertText(java.lang.String text, com.trolltech.qt.gui.QTextCharFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertText_String_QTextCharFormat(nativeId(), text, format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_insertText_String_QTextCharFormat(long __this__nativeId, java.lang.String text, long format);

    @QtBlockedSlot public final boolean isCopyOf(com.trolltech.qt.gui.QTextCursor other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isCopyOf_QTextCursor(nativeId(), other == null ? (other = new com.trolltech.qt.gui.QTextCursor()).nativeId() : other.nativeId());
    }
    private native static boolean __qt_isCopyOf_QTextCursor(long __this__nativeId, long other);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final void joinPreviousEditBlock() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_joinPreviousEditBlock(nativeId());
    }
    private native static void __qt_joinPreviousEditBlock(long __this__nativeId);

    @QtBlockedSlot public final void mergeBlockCharFormat(com.trolltech.qt.gui.QTextCharFormat modifier) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mergeBlockCharFormat_QTextCharFormat(nativeId(), modifier == null ? (modifier = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : modifier.nativeId());
    }
    private native static void __qt_mergeBlockCharFormat_QTextCharFormat(long __this__nativeId, long modifier);

    @QtBlockedSlot public final void mergeBlockFormat(com.trolltech.qt.gui.QTextBlockFormat modifier) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mergeBlockFormat_QTextBlockFormat(nativeId(), modifier == null ? (modifier = new com.trolltech.qt.gui.QTextBlockFormat()).nativeId() : modifier.nativeId());
    }
    private native static void __qt_mergeBlockFormat_QTextBlockFormat(long __this__nativeId, long modifier);

    @QtBlockedSlot public final void mergeCharFormat(com.trolltech.qt.gui.QTextCharFormat modifier) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mergeCharFormat_QTextCharFormat(nativeId(), modifier == null ? (modifier = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : modifier.nativeId());
    }
    private native static void __qt_mergeCharFormat_QTextCharFormat(long __this__nativeId, long modifier);


    @QtBlockedSlot public final boolean movePosition(com.trolltech.qt.gui.QTextCursor.MoveOperation op, com.trolltech.qt.gui.QTextCursor.MoveMode arg__2) {
        return movePosition(op, arg__2, (int)1);
    }

    @QtBlockedSlot public final boolean movePosition(com.trolltech.qt.gui.QTextCursor.MoveOperation op) {
        return movePosition(op, com.trolltech.qt.gui.QTextCursor.MoveMode.MoveAnchor, (int)1);
    }
    @QtBlockedSlot public final boolean movePosition(com.trolltech.qt.gui.QTextCursor.MoveOperation op, com.trolltech.qt.gui.QTextCursor.MoveMode arg__2, int n) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_movePosition_MoveOperation_MoveMode_int(nativeId(), op.value(), arg__2.value(), n);
    }
    private native static boolean __qt_movePosition_MoveOperation_MoveMode_int(long __this__nativeId, int op, int arg__2, int n);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_less(com.trolltech.qt.gui.QTextCursor rhs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_less_QTextCursor(nativeId(), rhs == null ? (rhs = new com.trolltech.qt.gui.QTextCursor()).nativeId() : rhs.nativeId());
    }
    private native static boolean __qt_operator_less_QTextCursor(long __this__nativeId, long rhs);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QTextCursor rhs) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QTextCursor(nativeId(), rhs == null ? (rhs = new com.trolltech.qt.gui.QTextCursor()).nativeId() : rhs.nativeId());
    }
    private native static boolean __qt_operator_equal_QTextCursor(long __this__nativeId, long rhs);

    @QtBlockedSlot public final int position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_position(nativeId());
    }
    private native static int __qt_position(long __this__nativeId);

    @QtBlockedSlot public final void removeSelectedText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeSelectedText(nativeId());
    }
    private native static void __qt_removeSelectedText(long __this__nativeId);

    @QtBlockedSlot public final void select(com.trolltech.qt.gui.QTextCursor.SelectionType selection) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_select_SelectionType(nativeId(), selection.value());
    }
    private native static void __qt_select_SelectionType(long __this__nativeId, int selection);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void selectedTableCells(com.trolltech.qt.QNativePointer firstRow, com.trolltech.qt.QNativePointer numRows, com.trolltech.qt.QNativePointer firstColumn, com.trolltech.qt.QNativePointer numColumns) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectedTableCells_nativepointer_nativepointer_nativepointer_nativepointer(nativeId(), firstRow, numRows, firstColumn, numColumns);
    }
    private native static void __qt_selectedTableCells_nativepointer_nativepointer_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer firstRow, com.trolltech.qt.QNativePointer numRows, com.trolltech.qt.QNativePointer firstColumn, com.trolltech.qt.QNativePointer numColumns);

    @QtBlockedSlot public final java.lang.String selectedText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectedText(nativeId());
    }
    private native static java.lang.String __qt_selectedText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextDocumentFragment selection() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selection(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextDocumentFragment __qt_selection(long __this__nativeId);

    @QtBlockedSlot public final int selectionEnd() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectionEnd(nativeId());
    }
    private native static int __qt_selectionEnd(long __this__nativeId);

    @QtBlockedSlot public final int selectionStart() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectionStart(nativeId());
    }
    private native static int __qt_selectionStart(long __this__nativeId);

    @QtBlockedSlot public final void setBlockCharFormat(com.trolltech.qt.gui.QTextCharFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBlockCharFormat_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setBlockCharFormat_QTextCharFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final void setBlockFormat(com.trolltech.qt.gui.QTextBlockFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBlockFormat_QTextBlockFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextBlockFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setBlockFormat_QTextBlockFormat(long __this__nativeId, long format);

    @QtBlockedSlot public final void setCharFormat(com.trolltech.qt.gui.QTextCharFormat format) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCharFormat_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setCharFormat_QTextCharFormat(long __this__nativeId, long format);


    @QtBlockedSlot public final void setPosition(int pos) {
        setPosition(pos, com.trolltech.qt.gui.QTextCursor.MoveMode.MoveAnchor);
    }
    @QtBlockedSlot public final void setPosition(int pos, com.trolltech.qt.gui.QTextCursor.MoveMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_int_MoveMode(nativeId(), pos, mode.value());
    }
    private native static void __qt_setPosition_int_MoveMode(long __this__nativeId, int pos, int mode);


    public static native QTextCursor fromNativePointer(QNativePointer nativePointer);

    protected QTextCursor(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextCursor array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QTextCursor)
            return operator_equal((com.trolltech.qt.gui.QTextCursor) other);
        return false;
    }

    public int compareTo(Object other) {
        if (equals(other)) return 0;
        else if (other instanceof com.trolltech.qt.gui.QTextCursor && operator_less((com.trolltech.qt.gui.QTextCursor) other)) return -1;
        else return 1;
    }

        public final QTableArea selectedTableCells() {
            QNativePointer firstRow = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer numRows = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer firstColumn = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer numColumns = new QNativePointer(QNativePointer.Type.Int);
            
            selectedTableCells(firstRow, numRows, firstColumn, numColumns);
            
            return new QTableArea(firstRow.intValue(), firstColumn.intValue(), numRows.intValue(), numColumns.intValue());
        }
    
}
