package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextEdit extends com.trolltech.qt.gui.QAbstractScrollArea
{
    @SuppressWarnings("unused") private Object __rcDocument = null;
    public enum AutoFormattingFlag implements com.trolltech.qt.QtEnumerator {
        AutoNone(0),
        AutoBulletList(1),
        AutoAll(-1);

        AutoFormattingFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static AutoFormatting createQFlags(AutoFormattingFlag ... values) {
            return new AutoFormatting(values);
        }
        public static AutoFormattingFlag resolve(int value) {
            return (AutoFormattingFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return AutoNone;
            case 1: return AutoBulletList;
            case -1: return AutoAll;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class AutoFormatting extends com.trolltech.qt.QFlags<AutoFormattingFlag> {
        private static final long serialVersionUID = 1L;
        public AutoFormatting(AutoFormattingFlag ... args) { super(args); }
        public AutoFormatting(int value) { setValue(value); }
    }

    public enum LineWrapMode implements com.trolltech.qt.QtEnumerator {
        NoWrap(0),
        WidgetWidth(1),
        FixedPixelWidth(2),
        FixedColumnWidth(3);

        LineWrapMode(int value) { this.value = value; }
        public int value() { return value; }

        public static LineWrapMode resolve(int value) {
            return (LineWrapMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoWrap;
            case 1: return WidgetWidth;
            case 2: return FixedPixelWidth;
            case 3: return FixedColumnWidth;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Boolean> copyAvailable = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void copyAvailable(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_copyAvailable_boolean(nativeId(), b);
    }
    private native static void __qt_copyAvailable_boolean(long __this__nativeId, boolean b);

    public final Signal1<com.trolltech.qt.gui.QTextCharFormat> currentCharFormatChanged = new Signal1<com.trolltech.qt.gui.QTextCharFormat>();

    @SuppressWarnings("unused")
    private final void currentCharFormatChanged(com.trolltech.qt.gui.QTextCharFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_currentCharFormatChanged_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_currentCharFormatChanged_QTextCharFormat(long __this__nativeId, long format);

    public final Signal0 cursorPositionChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void cursorPositionChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cursorPositionChanged(nativeId());
    }
    private native static void __qt_cursorPositionChanged(long __this__nativeId);

    public final Signal1<java.lang.Boolean> redoAvailable = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void redoAvailable(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_redoAvailable_boolean(nativeId(), b);
    }
    private native static void __qt_redoAvailable_boolean(long __this__nativeId, boolean b);

    public final Signal0 selectionChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void selectionChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectionChanged(nativeId());
    }
    private native static void __qt_selectionChanged(long __this__nativeId);

    public final Signal0 textChanged = new Signal0();

    @SuppressWarnings("unused")
    private final void textChanged() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_textChanged(nativeId());
    }
    private native static void __qt_textChanged(long __this__nativeId);

    public final Signal1<java.lang.Boolean> undoAvailable = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void undoAvailable(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_undoAvailable_boolean(nativeId(), b);
    }
    private native static void __qt_undoAvailable_boolean(long __this__nativeId, boolean b);


    public QTextEdit() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QTextEdit(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QTextEdit_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTextEdit_QWidget(long parent);



    public QTextEdit(java.lang.String text) {
        this(text, (com.trolltech.qt.gui.QWidget)null);
    }
    public QTextEdit(java.lang.String text, com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QTextEdit_String_QWidget(text, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QTextEdit_String_QWidget(java.lang.String text, long parent);


    @com.trolltech.qt.QtPropertyReader(name="acceptRichText")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final boolean acceptRichText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_acceptRichText(nativeId());
    }
    private native static boolean __qt_acceptRichText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.Alignment alignment() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.Alignment(__qt_alignment(nativeId()));
    }
    private native static int __qt_alignment(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String anchorAt(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_anchorAt_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static java.lang.String __qt_anchorAt_QPoint(long __this__nativeId, long pos);

    public final void append(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_append_String(nativeId(), text);
    }
    private native static void __qt_append_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyReader(name="autoFormatting")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextEdit.AutoFormatting autoFormatting() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QTextEdit.AutoFormatting(__qt_autoFormatting(nativeId()));
    }
    private native static int __qt_autoFormatting(long __this__nativeId);

    @QtBlockedSlot public final boolean canPaste() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canPaste(nativeId());
    }
    private native static boolean __qt_canPaste(long __this__nativeId);

    public final void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    public final void copy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_copy(nativeId());
    }
    private native static void __qt_copy(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMenu createStandardContextMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createStandardContextMenu(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenu __qt_createStandardContextMenu(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCharFormat currentCharFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentCharFormat(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCharFormat __qt_currentCharFormat(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont currentFont() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentFont(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_currentFont(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor cursorForPosition(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursorForPosition_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_cursorForPosition_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect cursorRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursorRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_cursorRect(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect cursorRect(com.trolltech.qt.gui.QTextCursor cursor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursorRect_QTextCursor(nativeId(), cursor == null ? (cursor = new com.trolltech.qt.gui.QTextCursor()).nativeId() : cursor.nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_cursorRect_QTextCursor(long __this__nativeId, long cursor);

    @com.trolltech.qt.QtPropertyReader(name="cursorWidth")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final int cursorWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursorWidth(nativeId());
    }
    private native static int __qt_cursorWidth(long __this__nativeId);

    public final void cut() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cut(nativeId());
    }
    private native static void __qt_cut(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextDocument document() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_document(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextDocument __qt_document(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="documentTitle")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final java.lang.String documentTitle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_documentTitle(nativeId());
    }
    private native static java.lang.String __qt_documentTitle(long __this__nativeId);

    @QtBlockedSlot public final void ensureCursorVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ensureCursorVisible(nativeId());
    }
    private native static void __qt_ensureCursorVisible(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QTextEdit_ExtraSelection> extraSelections() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_extraSelections(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QTextEdit_ExtraSelection> __qt_extraSelections(long __this__nativeId);


    @QtBlockedSlot public final boolean find(java.lang.String exp, com.trolltech.qt.gui.QTextDocument.FindFlag ... options) {
        return this.find(exp, new com.trolltech.qt.gui.QTextDocument.FindFlags(options));
    }

    @QtBlockedSlot public final boolean find(java.lang.String exp) {
        return find(exp, new com.trolltech.qt.gui.QTextDocument.FindFlags(0));
    }
    @QtBlockedSlot public final boolean find(java.lang.String exp, com.trolltech.qt.gui.QTextDocument.FindFlags options) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_find_String_FindFlags(nativeId(), exp, options.value());
    }
    private native static boolean __qt_find_String_FindFlags(long __this__nativeId, java.lang.String exp, int options);

    @QtBlockedSlot public final java.lang.String fontFamily() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontFamily(nativeId());
    }
    private native static java.lang.String __qt_fontFamily(long __this__nativeId);

    @QtBlockedSlot public final boolean fontItalic() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontItalic(nativeId());
    }
    private native static boolean __qt_fontItalic(long __this__nativeId);

    @QtBlockedSlot public final double fontPointSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontPointSize(nativeId());
    }
    private native static double __qt_fontPointSize(long __this__nativeId);

    @QtBlockedSlot public final boolean fontUnderline() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontUnderline(nativeId());
    }
    private native static boolean __qt_fontUnderline(long __this__nativeId);

    @QtBlockedSlot public final int fontWeight() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontWeight(nativeId());
    }
    private native static int __qt_fontWeight(long __this__nativeId);

    public final void insertHtml(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertHtml_String(nativeId(), text);
    }
    private native static void __qt_insertHtml_String(long __this__nativeId, java.lang.String text);

    public final void insertPlainText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertPlainText_String(nativeId(), text);
    }
    private native static void __qt_insertPlainText_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyReader(name="readOnly")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final boolean isReadOnly() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadOnly(nativeId());
    }
    private native static boolean __qt_isReadOnly(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="undoRedoEnabled")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final boolean isUndoRedoEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isUndoRedoEnabled(nativeId());
    }
    private native static boolean __qt_isUndoRedoEnabled(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="lineWrapColumnOrWidth")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final int lineWrapColumnOrWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineWrapColumnOrWidth(nativeId());
    }
    private native static int __qt_lineWrapColumnOrWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="lineWrapMode")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.gui.QTextEdit.LineWrapMode lineWrapMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextEdit.LineWrapMode.resolve(__qt_lineWrapMode(nativeId()));
    }
    private native static int __qt_lineWrapMode(long __this__nativeId);

    @QtBlockedSlot public final void mergeCurrentCharFormat(com.trolltech.qt.gui.QTextCharFormat modifier) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mergeCurrentCharFormat_QTextCharFormat(nativeId(), modifier == null ? (modifier = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : modifier.nativeId());
    }
    private native static void __qt_mergeCurrentCharFormat_QTextCharFormat(long __this__nativeId, long modifier);


    @QtBlockedSlot public final void moveCursor(com.trolltech.qt.gui.QTextCursor.MoveOperation operation) {
        moveCursor(operation, com.trolltech.qt.gui.QTextCursor.MoveMode.MoveAnchor);
    }
    @QtBlockedSlot public final void moveCursor(com.trolltech.qt.gui.QTextCursor.MoveOperation operation, com.trolltech.qt.gui.QTextCursor.MoveMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveCursor_MoveOperation_MoveMode(nativeId(), operation.value(), mode.value());
    }
    private native static void __qt_moveCursor_MoveOperation_MoveMode(long __this__nativeId, int operation, int mode);

    @com.trolltech.qt.QtPropertyReader(name="overwriteMode")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final boolean overwriteMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_overwriteMode(nativeId());
    }
    private native static boolean __qt_overwriteMode(long __this__nativeId);

    public final void paste() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paste(nativeId());
    }
    private native static void __qt_paste(long __this__nativeId);

    @QtBlockedSlot public final void print(com.trolltech.qt.gui.QPrinter printer) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_print_QPrinter(nativeId(), printer == null ? 0 : printer.nativeId());
    }
    private native static void __qt_print_QPrinter(long __this__nativeId, long printer);

    public final void redo() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_redo(nativeId());
    }
    private native static void __qt_redo(long __this__nativeId);

    public final void scrollToAnchor(java.lang.String name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollToAnchor_String(nativeId(), name);
    }
    private native static void __qt_scrollToAnchor_String(long __this__nativeId, java.lang.String name);

    public final void selectAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_selectAll(nativeId());
    }
    private native static void __qt_selectAll(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="acceptRichText")
    @QtBlockedSlot public final void setAcceptRichText(boolean accept) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAcceptRichText_boolean(nativeId(), accept);
    }
    private native static void __qt_setAcceptRichText_boolean(long __this__nativeId, boolean accept);


    public final void setAlignment(com.trolltech.qt.core.Qt.AlignmentFlag ... a) {
        this.setAlignment(new com.trolltech.qt.core.Qt.Alignment(a));
    }
    public final void setAlignment(com.trolltech.qt.core.Qt.Alignment a) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlignment_Alignment(nativeId(), a.value());
    }
    private native static void __qt_setAlignment_Alignment(long __this__nativeId, int a);


    @QtBlockedSlot public final void setAutoFormatting(com.trolltech.qt.gui.QTextEdit.AutoFormattingFlag ... features) {
        this.setAutoFormatting(new com.trolltech.qt.gui.QTextEdit.AutoFormatting(features));
    }
    @com.trolltech.qt.QtPropertyWriter(name="autoFormatting")
    @QtBlockedSlot public final void setAutoFormatting(com.trolltech.qt.gui.QTextEdit.AutoFormatting features) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutoFormatting_AutoFormatting(nativeId(), features.value());
    }
    private native static void __qt_setAutoFormatting_AutoFormatting(long __this__nativeId, int features);

    @QtBlockedSlot public final void setCurrentCharFormat(com.trolltech.qt.gui.QTextCharFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentCharFormat_QTextCharFormat(nativeId(), format == null ? (format = new com.trolltech.qt.gui.QTextCharFormat()).nativeId() : format.nativeId());
    }
    private native static void __qt_setCurrentCharFormat_QTextCharFormat(long __this__nativeId, long format);

    public final void setCurrentFont(com.trolltech.qt.gui.QFont f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCurrentFont_QFont(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId());
    }
    private native static void __qt_setCurrentFont_QFont(long __this__nativeId, long f);

    @com.trolltech.qt.QtPropertyWriter(name="cursorWidth")
    @QtBlockedSlot public final void setCursorWidth(int width) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCursorWidth_int(nativeId(), width);
    }
    private native static void __qt_setCursorWidth_int(long __this__nativeId, int width);

    @QtBlockedSlot public final void setDocument(com.trolltech.qt.gui.QTextDocument document) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDocument = document;
        }
        __qt_setDocument_QTextDocument(nativeId(), document == null ? 0 : document.nativeId());
    }
    private native static void __qt_setDocument_QTextDocument(long __this__nativeId, long document);

    @com.trolltech.qt.QtPropertyWriter(name="documentTitle")
    @QtBlockedSlot public final void setDocumentTitle(java.lang.String title) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDocumentTitle_String(nativeId(), title);
    }
    private native static void __qt_setDocumentTitle_String(long __this__nativeId, java.lang.String title);

    @QtBlockedSlot public final void setExtraSelections(java.util.List<com.trolltech.qt.gui.QTextEdit_ExtraSelection> selections) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setExtraSelections_List(nativeId(), selections);
    }
    private native static void __qt_setExtraSelections_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QTextEdit_ExtraSelection> selections);

    public final void setFontFamily(java.lang.String fontFamily) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontFamily_String(nativeId(), fontFamily);
    }
    private native static void __qt_setFontFamily_String(long __this__nativeId, java.lang.String fontFamily);

    public final void setFontItalic(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontItalic_boolean(nativeId(), b);
    }
    private native static void __qt_setFontItalic_boolean(long __this__nativeId, boolean b);

    public final void setFontPointSize(double s) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontPointSize_double(nativeId(), s);
    }
    private native static void __qt_setFontPointSize_double(long __this__nativeId, double s);

    public final void setFontUnderline(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontUnderline_boolean(nativeId(), b);
    }
    private native static void __qt_setFontUnderline_boolean(long __this__nativeId, boolean b);

    public final void setFontWeight(int w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFontWeight_int(nativeId(), w);
    }
    private native static void __qt_setFontWeight_int(long __this__nativeId, int w);

    @com.trolltech.qt.QtPropertyWriter(name="html")
    public final void setHtml(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHtml_String(nativeId(), text);
    }
    private native static void __qt_setHtml_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="lineWrapColumnOrWidth")
    @QtBlockedSlot public final void setLineWrapColumnOrWidth(int w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWrapColumnOrWidth_int(nativeId(), w);
    }
    private native static void __qt_setLineWrapColumnOrWidth_int(long __this__nativeId, int w);

    @com.trolltech.qt.QtPropertyWriter(name="lineWrapMode")
    @QtBlockedSlot public final void setLineWrapMode(com.trolltech.qt.gui.QTextEdit.LineWrapMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWrapMode_LineWrapMode(nativeId(), mode.value());
    }
    private native static void __qt_setLineWrapMode_LineWrapMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="overwriteMode")
    @QtBlockedSlot public final void setOverwriteMode(boolean overwrite) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOverwriteMode_boolean(nativeId(), overwrite);
    }
    private native static void __qt_setOverwriteMode_boolean(long __this__nativeId, boolean overwrite);

    @com.trolltech.qt.QtPropertyWriter(name="plainText")
    public final void setPlainText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPlainText_String(nativeId(), text);
    }
    private native static void __qt_setPlainText_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="readOnly")
    @QtBlockedSlot public final void setReadOnly(boolean ro) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadOnly_boolean(nativeId(), ro);
    }
    private native static void __qt_setReadOnly_boolean(long __this__nativeId, boolean ro);

    @com.trolltech.qt.QtPropertyWriter(name="tabChangesFocus")
    @QtBlockedSlot public final void setTabChangesFocus(boolean b) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabChangesFocus_boolean(nativeId(), b);
    }
    private native static void __qt_setTabChangesFocus_boolean(long __this__nativeId, boolean b);

    @com.trolltech.qt.QtPropertyWriter(name="tabStopWidth")
    @QtBlockedSlot public final void setTabStopWidth(int width) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTabStopWidth_int(nativeId(), width);
    }
    private native static void __qt_setTabStopWidth_int(long __this__nativeId, int width);

    public final void setText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    public final void setTextColor(com.trolltech.qt.gui.QColor c) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextColor_QColor(nativeId(), c == null ? (c = new com.trolltech.qt.gui.QColor()).nativeId() : c.nativeId());
    }
    private native static void __qt_setTextColor_QColor(long __this__nativeId, long c);

    @QtBlockedSlot public final void setTextCursor(com.trolltech.qt.gui.QTextCursor cursor) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextCursor_QTextCursor(nativeId(), cursor == null ? (cursor = new com.trolltech.qt.gui.QTextCursor()).nativeId() : cursor.nativeId());
    }
    private native static void __qt_setTextCursor_QTextCursor(long __this__nativeId, long cursor);


    @QtBlockedSlot public final void setTextInteractionFlags(com.trolltech.qt.core.Qt.TextInteractionFlag ... flags) {
        this.setTextInteractionFlags(new com.trolltech.qt.core.Qt.TextInteractionFlags(flags));
    }
    @com.trolltech.qt.QtPropertyWriter(name="textInteractionFlags")
    @QtBlockedSlot public final void setTextInteractionFlags(com.trolltech.qt.core.Qt.TextInteractionFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextInteractionFlags_TextInteractionFlags(nativeId(), flags.value());
    }
    private native static void __qt_setTextInteractionFlags_TextInteractionFlags(long __this__nativeId, int flags);

    @com.trolltech.qt.QtPropertyWriter(name="undoRedoEnabled")
    @QtBlockedSlot public final void setUndoRedoEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUndoRedoEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setUndoRedoEnabled_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setWordWrapMode(com.trolltech.qt.gui.QTextOption.WrapMode policy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWordWrapMode_WrapMode(nativeId(), policy.value());
    }
    private native static void __qt_setWordWrapMode_WrapMode(long __this__nativeId, int policy);

    @com.trolltech.qt.QtPropertyReader(name="tabChangesFocus")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final boolean tabChangesFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabChangesFocus(nativeId());
    }
    private native static boolean __qt_tabChangesFocus(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="tabStopWidth")
    @com.trolltech.qt.QtPropertyOrder(10)
    @QtBlockedSlot public final int tabStopWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tabStopWidth(nativeId());
    }
    private native static int __qt_tabStopWidth(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QColor textColor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textColor(nativeId());
    }
    private native static com.trolltech.qt.gui.QColor __qt_textColor(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextCursor textCursor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textCursor(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextCursor __qt_textCursor(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="textInteractionFlags")
    @com.trolltech.qt.QtPropertyOrder(13)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextInteractionFlags textInteractionFlags() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.TextInteractionFlags(__qt_textInteractionFlags(nativeId()));
    }
    private native static int __qt_textInteractionFlags(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="html")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final java.lang.String toHtml() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toHtml(nativeId());
    }
    private native static java.lang.String __qt_toHtml(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="plainText")
    @com.trolltech.qt.QtPropertyOrder(8)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final java.lang.String toPlainText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toPlainText(nativeId());
    }
    private native static java.lang.String __qt_toPlainText(long __this__nativeId);

    public final void undo() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_undo(nativeId());
    }
    private native static void __qt_undo(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextOption.WrapMode wordWrapMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextOption.WrapMode.resolve(__qt_wordWrapMode(nativeId()));
    }
    private native static int __qt_wordWrapMode(long __this__nativeId);


    public final void zoomIn() {
        zoomIn((int)1);
    }
    public final void zoomIn(int range) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_zoomIn_int(nativeId(), range);
    }
    private native static void __qt_zoomIn_int(long __this__nativeId, int range);


    public final void zoomOut() {
        zoomOut((int)1);
    }
    public final void zoomOut(int range) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_zoomOut_int(nativeId(), range);
    }
    private native static void __qt_zoomOut_int(long __this__nativeId, int range);

    @QtBlockedSlot protected boolean canInsertFromMimeData(com.trolltech.qt.gui.QMimeData source) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canInsertFromMimeData_QMimeData(nativeId(), source == null ? 0 : source.nativeId());
    }
    private native static boolean __qt_canInsertFromMimeData_QMimeData(long __this__nativeId, long source);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected com.trolltech.qt.gui.QMimeData createMimeDataFromSelection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createMimeDataFromSelection(nativeId());
    }
    private native static com.trolltech.qt.gui.QMimeData __qt_createMimeDataFromSelection(long __this__nativeId);

    @QtBlockedSlot protected void dragEnterEvent(com.trolltech.qt.gui.QDragEnterEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragEnterEvent_QDragEnterEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dragEnterEvent_QDragEnterEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void dragLeaveEvent(com.trolltech.qt.gui.QDragLeaveEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragLeaveEvent_QDragLeaveEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dragLeaveEvent_QDragLeaveEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void dragMoveEvent(com.trolltech.qt.gui.QDragMoveEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragMoveEvent_QDragMoveEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dragMoveEvent_QDragMoveEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void dropEvent(com.trolltech.qt.gui.QDropEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dropEvent_QDropEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_dropEvent_QDropEvent(long __this__nativeId, long e);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected boolean focusNextPrevChild(boolean next) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusNextPrevChild_boolean(nativeId(), next);
    }
    private native static boolean __qt_focusNextPrevChild_boolean(long __this__nativeId, boolean next);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_inputMethodEvent_QInputMethodEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_inputMethodEvent_QInputMethodEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery property) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputMethodQuery_InputMethodQuery(nativeId(), property.value());
    }
    private native static java.lang.Object __qt_inputMethodQuery_InputMethodQuery(long __this__nativeId, int property);

    @QtBlockedSlot protected void insertFromMimeData(com.trolltech.qt.gui.QMimeData source) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_insertFromMimeData_QMimeData(nativeId(), source == null ? 0 : source.nativeId());
    }
    private native static void __qt_insertFromMimeData_QMimeData(long __this__nativeId, long source);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long e);

    @QtBlockedSlot public java.lang.Object loadResource(int type, com.trolltech.qt.core.QUrl name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_loadResource_int_QUrl(nativeId(), type, name == null ? (name = new com.trolltech.qt.core.QUrl()).nativeId() : name.nativeId());
    }
    private native static java.lang.Object __qt_loadResource_int_QUrl(long __this__nativeId, int type, long name);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void scrollContentsBy(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scrollContentsBy_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scrollContentsBy_int_int(long __this__nativeId, int dx, int dy);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long e);


    public static native QTextEdit fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QTextEdit(QPrivateConstructor p) { super(p); } 

}
