package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextFrameFormat extends com.trolltech.qt.gui.QTextFormat
{
    public enum Position implements com.trolltech.qt.QtEnumerator {
        InFlow(0),
        FloatLeft(1),
        FloatRight(2);

        Position(int value) { this.value = value; }
        public int value() { return value; }

        public static Position resolve(int value) {
            return (Position) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return InFlow;
            case 1: return FloatLeft;
            case 2: return FloatRight;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum BorderStyle implements com.trolltech.qt.QtEnumerator {
        BorderStyle_None(0),
        BorderStyle_Dotted(1),
        BorderStyle_Dashed(2),
        BorderStyle_Solid(3),
        BorderStyle_Double(4),
        BorderStyle_DotDash(5),
        BorderStyle_DotDotDash(6),
        BorderStyle_Groove(7),
        BorderStyle_Ridge(8),
        BorderStyle_Inset(9),
        BorderStyle_Outset(10);

        BorderStyle(int value) { this.value = value; }
        public int value() { return value; }

        public static BorderStyle resolve(int value) {
            return (BorderStyle) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return BorderStyle_None;
            case 1: return BorderStyle_Dotted;
            case 2: return BorderStyle_Dashed;
            case 3: return BorderStyle_Solid;
            case 4: return BorderStyle_Double;
            case 5: return BorderStyle_DotDash;
            case 6: return BorderStyle_DotDotDash;
            case 7: return BorderStyle_Groove;
            case 8: return BorderStyle_Ridge;
            case 9: return BorderStyle_Inset;
            case 10: return BorderStyle_Outset;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextFrameFormat() {
        super((QPrivateConstructor)null);
        __qt_QTextFrameFormat();
    }
    private native void __qt_QTextFrameFormat();


    @QtBlockedSlot public final double border() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_border(nativeId());
    }
    private native static double __qt_border(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush borderBrush() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_borderBrush(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_borderBrush(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrameFormat.BorderStyle borderStyle() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextFrameFormat.BorderStyle.resolve(__qt_borderStyle(nativeId()));
    }
    private native static int __qt_borderStyle(long __this__nativeId);

    @QtBlockedSlot public final double bottomMargin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bottomMargin(nativeId());
    }
    private native static double __qt_bottomMargin(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLength height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextLength __qt_height(long __this__nativeId);

    @QtBlockedSlot public boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final double leftMargin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_leftMargin(nativeId());
    }
    private native static double __qt_leftMargin(long __this__nativeId);

    @QtBlockedSlot public final double margin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_margin(nativeId());
    }
    private native static double __qt_margin(long __this__nativeId);

    @QtBlockedSlot public final double padding() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_padding(nativeId());
    }
    private native static double __qt_padding(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFormat.PageBreakFlags pageBreakPolicy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QTextFormat.PageBreakFlags(__qt_pageBreakPolicy(nativeId()));
    }
    private native static int __qt_pageBreakPolicy(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextFrameFormat.Position position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTextFrameFormat.Position.resolve(__qt_position(nativeId()));
    }
    private native static int __qt_position(long __this__nativeId);

    @QtBlockedSlot public final double rightMargin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rightMargin(nativeId());
    }
    private native static double __qt_rightMargin(long __this__nativeId);

    @QtBlockedSlot public final void setBorder(double border) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBorder_double(nativeId(), border);
    }
    private native static void __qt_setBorder_double(long __this__nativeId, double border);

    @QtBlockedSlot public final void setBorderBrush(com.trolltech.qt.gui.QBrush brush) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBorderBrush_QBrush(nativeId(), brush == null ? (brush = new com.trolltech.qt.gui.QBrush()).nativeId() : brush.nativeId());
    }
    private native static void __qt_setBorderBrush_QBrush(long __this__nativeId, long brush);

    @QtBlockedSlot public final void setBorderStyle(com.trolltech.qt.gui.QTextFrameFormat.BorderStyle style) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBorderStyle_BorderStyle(nativeId(), style.value());
    }
    private native static void __qt_setBorderStyle_BorderStyle(long __this__nativeId, int style);

    @QtBlockedSlot public final void setBottomMargin(double margin) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBottomMargin_double(nativeId(), margin);
    }
    private native static void __qt_setBottomMargin_double(long __this__nativeId, double margin);

    @QtBlockedSlot public final void setHeight(double height) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHeight_double(nativeId(), height);
    }
    private native static void __qt_setHeight_double(long __this__nativeId, double height);

    @QtBlockedSlot public final void setHeight(com.trolltech.qt.gui.QTextLength height) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHeight_QTextLength(nativeId(), height == null ? (height = new com.trolltech.qt.gui.QTextLength()).nativeId() : height.nativeId());
    }
    private native static void __qt_setHeight_QTextLength(long __this__nativeId, long height);

    @QtBlockedSlot public final void setLeftMargin(double margin) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLeftMargin_double(nativeId(), margin);
    }
    private native static void __qt_setLeftMargin_double(long __this__nativeId, double margin);

    @QtBlockedSlot public final void setMargin(double margin) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMargin_double(nativeId(), margin);
    }
    private native static void __qt_setMargin_double(long __this__nativeId, double margin);

    @QtBlockedSlot public final void setPadding(double padding) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPadding_double(nativeId(), padding);
    }
    private native static void __qt_setPadding_double(long __this__nativeId, double padding);


    @QtBlockedSlot public final void setPageBreakPolicy(com.trolltech.qt.gui.QTextFormat.PageBreakFlag ... flags) {
        this.setPageBreakPolicy(new com.trolltech.qt.gui.QTextFormat.PageBreakFlags(flags));
    }
    @QtBlockedSlot public final void setPageBreakPolicy(com.trolltech.qt.gui.QTextFormat.PageBreakFlags flags) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPageBreakPolicy_PageBreakFlags(nativeId(), flags.value());
    }
    private native static void __qt_setPageBreakPolicy_PageBreakFlags(long __this__nativeId, int flags);

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.gui.QTextFrameFormat.Position f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_Position(nativeId(), f.value());
    }
    private native static void __qt_setPosition_Position(long __this__nativeId, int f);

    @QtBlockedSlot public final void setRightMargin(double margin) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRightMargin_double(nativeId(), margin);
    }
    private native static void __qt_setRightMargin_double(long __this__nativeId, double margin);

    @QtBlockedSlot public final void setTopMargin(double margin) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTopMargin_double(nativeId(), margin);
    }
    private native static void __qt_setTopMargin_double(long __this__nativeId, double margin);

    @QtBlockedSlot public final void setWidth(com.trolltech.qt.gui.QTextLength length) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWidth_QTextLength(nativeId(), length == null ? (length = new com.trolltech.qt.gui.QTextLength()).nativeId() : length.nativeId());
    }
    private native static void __qt_setWidth_QTextLength(long __this__nativeId, long length);

    @QtBlockedSlot public final void setWidth(double width) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWidth_double(nativeId(), width);
    }
    private native static void __qt_setWidth_double(long __this__nativeId, double width);

    @QtBlockedSlot public final double topMargin() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_topMargin(nativeId());
    }
    private native static double __qt_topMargin(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLength width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextLength __qt_width(long __this__nativeId);


    public static native QTextFrameFormat fromNativePointer(QNativePointer nativePointer);

    protected QTextFrameFormat(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextFrameFormat array[]);
}
