package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextLayout extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum CursorMode implements com.trolltech.qt.QtEnumerator {
        SkipCharacters(0),
        SkipWords(1);

        CursorMode(int value) { this.value = value; }
        public int value() { return value; }

        public static CursorMode resolve(int value) {
            return (CursorMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return SkipCharacters;
            case 1: return SkipWords;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextLayout() {
        super((QPrivateConstructor)null);
        __qt_QTextLayout();
    }
    private native void __qt_QTextLayout();



    public QTextLayout(java.lang.String text, com.trolltech.qt.gui.QFont font) {
        this(text, font, (com.trolltech.qt.gui.QPaintDeviceInterface)null);
    }
    public QTextLayout(java.lang.String text, com.trolltech.qt.gui.QFont font, com.trolltech.qt.gui.QPaintDeviceInterface paintdevice) {
        super((QPrivateConstructor)null);
        __qt_QTextLayout_String_QFont_QPaintDevice(text, font == null ? (font = new com.trolltech.qt.gui.QFont()).nativeId() : font.nativeId(), paintdevice == null ? 0 : paintdevice.nativeId());
    }
    private native void __qt_QTextLayout_String_QFont_QPaintDevice(java.lang.String text, long font, long paintdevice);


    public QTextLayout(java.lang.String text) {
        super((QPrivateConstructor)null);
        __qt_QTextLayout_String(text);
    }
    private native void __qt_QTextLayout_String(java.lang.String text);


    public QTextLayout(com.trolltech.qt.gui.QTextBlock b) {
        super((QPrivateConstructor)null);
        __qt_QTextLayout_QTextBlock(b == null ? (b = new com.trolltech.qt.gui.QTextBlock()).nativeId() : b.nativeId());
    }
    private native void __qt_QTextLayout_QTextBlock(long b);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> additionalFormats() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_additionalFormats(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> __qt_additionalFormats(long __this__nativeId);

    @QtBlockedSlot public final void beginLayout() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beginLayout(nativeId());
    }
    private native static void __qt_beginLayout(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF boundingRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundingRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_boundingRect(long __this__nativeId);

    @QtBlockedSlot public final boolean cacheEnabled() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cacheEnabled(nativeId());
    }
    private native static boolean __qt_cacheEnabled(long __this__nativeId);

    @QtBlockedSlot public final void clearAdditionalFormats() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearAdditionalFormats(nativeId());
    }
    private native static void __qt_clearAdditionalFormats(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLine createLine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createLine(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextLine __qt_createLine(long __this__nativeId);


    @QtBlockedSlot public final void draw(com.trolltech.qt.gui.QPainter p, com.trolltech.qt.core.QPointF pos, java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> selections) {
        draw(p, pos, selections, (com.trolltech.qt.core.QRectF)new com.trolltech.qt.core.QRectF());
    }
    @QtBlockedSlot public final void draw(com.trolltech.qt.gui.QPainter p, com.trolltech.qt.core.QPointF pos, java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> selections, com.trolltech.qt.core.QRectF clip) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_draw_QPainter_QPointF_List_QRectF(nativeId(), p == null ? 0 : p.nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId(), selections, clip == null ? (clip = new com.trolltech.qt.core.QRectF()).nativeId() : clip.nativeId());
    }
    private native static void __qt_draw_QPainter_QPointF_List_QRectF(long __this__nativeId, long p, long pos, java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> selections, long clip);

    @QtBlockedSlot public final void drawCursor(com.trolltech.qt.gui.QPainter p, com.trolltech.qt.core.QPointF pos, int cursorPosition, int width) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawCursor_QPainter_QPointF_int_int(nativeId(), p == null ? 0 : p.nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId(), cursorPosition, width);
    }
    private native static void __qt_drawCursor_QPainter_QPointF_int_int(long __this__nativeId, long p, long pos, int cursorPosition, int width);

    @QtBlockedSlot public final void drawCursor(com.trolltech.qt.gui.QPainter p, com.trolltech.qt.core.QPointF pos, int cursorPosition) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_drawCursor_QPainter_QPointF_int(nativeId(), p == null ? 0 : p.nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId(), cursorPosition);
    }
    private native static void __qt_drawCursor_QPainter_QPointF_int(long __this__nativeId, long p, long pos, int cursorPosition);

    @QtBlockedSlot public final void endLayout() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_endLayout(nativeId());
    }
    private native static void __qt_endLayout(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final boolean isValidCursorPosition(int pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValidCursorPosition_int(nativeId(), pos);
    }
    private native static boolean __qt_isValidCursorPosition_int(long __this__nativeId, int pos);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLine lineAt(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineAt_int(nativeId(), i);
    }
    private native static com.trolltech.qt.gui.QTextLine __qt_lineAt_int(long __this__nativeId, int i);

    @QtBlockedSlot public final int lineCount() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineCount(nativeId());
    }
    private native static int __qt_lineCount(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextLine lineForTextPosition(int pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineForTextPosition_int(nativeId(), pos);
    }
    private native static com.trolltech.qt.gui.QTextLine __qt_lineForTextPosition_int(long __this__nativeId, int pos);

    @QtBlockedSlot public final double maximumWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumWidth(nativeId());
    }
    private native static double __qt_maximumWidth(long __this__nativeId);

    @QtBlockedSlot public final double minimumWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumWidth(nativeId());
    }
    private native static double __qt_minimumWidth(long __this__nativeId);


    @QtBlockedSlot public final int nextCursorPosition(int oldPos) {
        return nextCursorPosition(oldPos, com.trolltech.qt.gui.QTextLayout.CursorMode.SkipCharacters);
    }
    @QtBlockedSlot public final int nextCursorPosition(int oldPos, com.trolltech.qt.gui.QTextLayout.CursorMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextCursorPosition_int_CursorMode(nativeId(), oldPos, mode.value());
    }
    private native static int __qt_nextCursorPosition_int_CursorMode(long __this__nativeId, int oldPos, int mode);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_position(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_position(long __this__nativeId);

    @QtBlockedSlot public final int preeditAreaPosition() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_preeditAreaPosition(nativeId());
    }
    private native static int __qt_preeditAreaPosition(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String preeditAreaText() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_preeditAreaText(nativeId());
    }
    private native static java.lang.String __qt_preeditAreaText(long __this__nativeId);


    @QtBlockedSlot public final int previousCursorPosition(int oldPos) {
        return previousCursorPosition(oldPos, com.trolltech.qt.gui.QTextLayout.CursorMode.SkipCharacters);
    }
    @QtBlockedSlot public final int previousCursorPosition(int oldPos, com.trolltech.qt.gui.QTextLayout.CursorMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_previousCursorPosition_int_CursorMode(nativeId(), oldPos, mode.value());
    }
    private native static int __qt_previousCursorPosition_int_CursorMode(long __this__nativeId, int oldPos, int mode);

    @QtBlockedSlot public final void setAdditionalFormats(java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> overrides) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAdditionalFormats_List(nativeId(), overrides);
    }
    private native static void __qt_setAdditionalFormats_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QTextLayout_FormatRange> overrides);

    @QtBlockedSlot public final void setCacheEnabled(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCacheEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setCacheEnabled_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont f) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), f == null ? (f = new com.trolltech.qt.gui.QFont()).nativeId() : f.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long f);

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.core.QPointF p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_QPointF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId());
    }
    private native static void __qt_setPosition_QPointF(long __this__nativeId, long p);

    @QtBlockedSlot public final void setPreeditArea(int position, java.lang.String text) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPreeditArea_int_String(nativeId(), position, text);
    }
    private native static void __qt_setPreeditArea_int_String(long __this__nativeId, int position, java.lang.String text);

    @QtBlockedSlot public final void setText(java.lang.String string) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), string);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String string);

    @QtBlockedSlot public final void setTextOption(com.trolltech.qt.gui.QTextOption option) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextOption_QTextOption(nativeId(), option == null ? (option = new com.trolltech.qt.gui.QTextOption()).nativeId() : option.nativeId());
    }
    private native static void __qt_setTextOption_QTextOption(long __this__nativeId, long option);

    @QtBlockedSlot public final java.lang.String text() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTextOption textOption() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textOption(nativeId());
    }
    private native static com.trolltech.qt.gui.QTextOption __qt_textOption(long __this__nativeId);


    public static native QTextLayout fromNativePointer(QNativePointer nativePointer);

    protected QTextLayout(QPrivateConstructor p) { super(p); } 

}
