package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTextLine extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum Edge implements com.trolltech.qt.QtEnumerator {
        Leading(0),
        Trailing(1);

        Edge(int value) { this.value = value; }
        public int value() { return value; }

        public static Edge resolve(int value) {
            return (Edge) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Leading;
            case 1: return Trailing;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum CursorPosition implements com.trolltech.qt.QtEnumerator {
        CursorBetweenCharacters(0),
        CursorOnCharacter(1);

        CursorPosition(int value) { this.value = value; }
        public int value() { return value; }

        public static CursorPosition resolve(int value) {
            return (CursorPosition) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CursorBetweenCharacters;
            case 1: return CursorOnCharacter;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTextLine() {
        super((QPrivateConstructor)null);
        __qt_QTextLine();
    }
    private native void __qt_QTextLine();


    @QtBlockedSlot public final double ascent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_ascent(nativeId());
    }
    private native static double __qt_ascent(long __this__nativeId);


    @QtBlockedSlot public final double cursorToX(int cursorPos) {
        return cursorToX(cursorPos, com.trolltech.qt.gui.QTextLine.Edge.Leading);
    }
    @QtBlockedSlot public final double cursorToX(int cursorPos, com.trolltech.qt.gui.QTextLine.Edge edge) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursorToX_int_Edge(nativeId(), cursorPos, edge.value());
    }
    private native static double __qt_cursorToX_int_Edge(long __this__nativeId, int cursorPos, int edge);

    @QtBlockedSlot public final double descent() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_descent(nativeId());
    }
    private native static double __qt_descent(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void draw(com.trolltech.qt.gui.QPainter p, com.trolltech.qt.core.QPointF point, com.trolltech.qt.QNativePointer selection) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_draw_QPainter_QPointF_nativepointer(nativeId(), p == null ? 0 : p.nativeId(), point == null ? (point = new com.trolltech.qt.core.QPointF()).nativeId() : point.nativeId(), selection);
    }
    private native static void __qt_draw_QPainter_QPointF_nativepointer(long __this__nativeId, long p, long point, com.trolltech.qt.QNativePointer selection);

    @QtBlockedSlot public final double height() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static double __qt_height(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final int lineNumber() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lineNumber(nativeId());
    }
    private native static int __qt_lineNumber(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF naturalTextRect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_naturalTextRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_naturalTextRect(long __this__nativeId);

    @QtBlockedSlot public final double naturalTextWidth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_naturalTextWidth(nativeId());
    }
    private native static double __qt_naturalTextWidth(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF position() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_position(nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_position(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF rect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rect(nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_rect(long __this__nativeId);

    @QtBlockedSlot public final void setLineWidth(double width) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLineWidth_double(nativeId(), width);
    }
    private native static void __qt_setLineWidth_double(long __this__nativeId, double width);

    @QtBlockedSlot public final void setNumColumns(int columns) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumColumns_int(nativeId(), columns);
    }
    private native static void __qt_setNumColumns_int(long __this__nativeId, int columns);

    @QtBlockedSlot public final void setNumColumns(int columns, double alignmentWidth) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumColumns_int_double(nativeId(), columns, alignmentWidth);
    }
    private native static void __qt_setNumColumns_int_double(long __this__nativeId, int columns, double alignmentWidth);

    @QtBlockedSlot public final void setPosition(com.trolltech.qt.core.QPointF pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPosition_QPointF(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPointF()).nativeId() : pos.nativeId());
    }
    private native static void __qt_setPosition_QPointF(long __this__nativeId, long pos);

    @QtBlockedSlot public final int textLength() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textLength(nativeId());
    }
    private native static int __qt_textLength(long __this__nativeId);

    @QtBlockedSlot public final int textStart() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_textStart(nativeId());
    }
    private native static int __qt_textStart(long __this__nativeId);

    @QtBlockedSlot public final double width() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static double __qt_width(long __this__nativeId);

    @QtBlockedSlot public final double x() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x(nativeId());
    }
    private native static double __qt_x(long __this__nativeId);


    @QtBlockedSlot public final int xToCursor(double x) {
        return xToCursor(x, com.trolltech.qt.gui.QTextLine.CursorPosition.CursorBetweenCharacters);
    }
    @QtBlockedSlot public final int xToCursor(double x, com.trolltech.qt.gui.QTextLine.CursorPosition arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_xToCursor_double_CursorPosition(nativeId(), x, arg__2.value());
    }
    private native static int __qt_xToCursor_double_CursorPosition(long __this__nativeId, double x, int arg__2);

    @QtBlockedSlot public final double y() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y(nativeId());
    }
    private native static double __qt_y(long __this__nativeId);


    public static native QTextLine fromNativePointer(QNativePointer nativePointer);

    protected QTextLine(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTextLine array[]);

        public final void draw(QPainter painter, com.trolltech.qt.core.QPointF position) {
            draw(painter, position, null);
        }
    
}
