package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QToolButton extends com.trolltech.qt.gui.QAbstractButton
{
    @SuppressWarnings("unused") private Object __rcDefaultAction = null;
    @SuppressWarnings("unused") private Object __rcMenu = null;
    public enum ToolButtonPopupMode implements com.trolltech.qt.QtEnumerator {
        DelayedPopup(0),
        MenuButtonPopup(1),
        InstantPopup(2);

        ToolButtonPopupMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ToolButtonPopupMode resolve(int value) {
            return (ToolButtonPopupMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return DelayedPopup;
            case 1: return MenuButtonPopup;
            case 2: return InstantPopup;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QAction> triggered = new Signal1<com.trolltech.qt.gui.QAction>();

    @SuppressWarnings("unused")
    private final void triggered(com.trolltech.qt.gui.QAction arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_triggered_QAction(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_triggered_QAction(long __this__nativeId, long arg__1);


    public QToolButton() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QToolButton(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QToolButton_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QToolButton_QWidget(long parent);


    @com.trolltech.qt.QtPropertyReader(name="arrowType")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ArrowType arrowType() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ArrowType.resolve(__qt_arrowType(nativeId()));
    }
    private native static int __qt_arrowType(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="autoRaise")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean autoRaise() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_autoRaise(nativeId());
    }
    private native static boolean __qt_autoRaise(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAction defaultAction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultAction(nativeId());
    }
    private native static com.trolltech.qt.gui.QAction __qt_defaultAction(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void initStyleOption(com.trolltech.qt.QNativePointer option) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_initStyleOption_nativepointer(nativeId(), option);
    }
    private native static void __qt_initStyleOption_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer option);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMenu menu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_menu(nativeId());
    }
    private native static com.trolltech.qt.gui.QMenu __qt_menu(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="popupMode")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final com.trolltech.qt.gui.QToolButton.ToolButtonPopupMode popupMode() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QToolButton.ToolButtonPopupMode.resolve(__qt_popupMode(nativeId()));
    }
    private native static int __qt_popupMode(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="arrowType")
    @QtBlockedSlot public final void setArrowType(com.trolltech.qt.core.Qt.ArrowType type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setArrowType_ArrowType(nativeId(), type.value());
    }
    private native static void __qt_setArrowType_ArrowType(long __this__nativeId, int type);

    @com.trolltech.qt.QtPropertyWriter(name="autoRaise")
    @QtBlockedSlot public final void setAutoRaise(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutoRaise_boolean(nativeId(), enable);
    }
    private native static void __qt_setAutoRaise_boolean(long __this__nativeId, boolean enable);

    public final void setDefaultAction(com.trolltech.qt.gui.QAction arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcDefaultAction = arg__1;
        }
        __qt_setDefaultAction_QAction(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setDefaultAction_QAction(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setMenu(com.trolltech.qt.gui.QMenu menu) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcMenu = menu;
        }
        __qt_setMenu_QMenu(nativeId(), menu == null ? 0 : menu.nativeId());
    }
    private native static void __qt_setMenu_QMenu(long __this__nativeId, long menu);

    @com.trolltech.qt.QtPropertyWriter(name="popupMode")
    @QtBlockedSlot public final void setPopupMode(com.trolltech.qt.gui.QToolButton.ToolButtonPopupMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPopupMode_ToolButtonPopupMode(nativeId(), mode.value());
    }
    private native static void __qt_setPopupMode_ToolButtonPopupMode(long __this__nativeId, int mode);

    @com.trolltech.qt.QtPropertyWriter(name="toolButtonStyle")
    public final void setToolButtonStyle(com.trolltech.qt.core.Qt.ToolButtonStyle style) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolButtonStyle_ToolButtonStyle(nativeId(), style.value());
    }
    private native static void __qt_setToolButtonStyle_ToolButtonStyle(long __this__nativeId, int style);

    public final void showMenu() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showMenu(nativeId());
    }
    private native static void __qt_showMenu(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="toolButtonStyle")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ToolButtonStyle toolButtonStyle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ToolButtonStyle.resolve(__qt_toolButtonStyle(nativeId()));
    }
    private native static int __qt_toolButtonStyle(long __this__nativeId);

    @QtBlockedSlot protected void actionEvent(com.trolltech.qt.gui.QActionEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_actionEvent_QActionEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_actionEvent_QActionEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void enterEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_enterEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_enterEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected boolean hitButton(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hitButton_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static boolean __qt_hitButton_QPoint(long __this__nativeId, long pos);

    @QtBlockedSlot protected void leaveEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_leaveEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_leaveEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void nextCheckState() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_nextCheckState(nativeId());
    }
    private native static void __qt_nextCheckState(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void timerEvent(com.trolltech.qt.core.QTimerEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_timerEvent_QTimerEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_timerEvent_QTimerEvent(long __this__nativeId, long arg__1);


    public static native QToolButton fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QToolButton(QPrivateConstructor p) { super(p); } 


        // TEMPLATE - gui.init_style_option - START
        protected final void initStyleOption(QStyleOptionToolButton option) {
            initStyleOption(option.nativePointer());
        }
    // TEMPLATE - gui.init_style_option - END
    
}
