package com.trolltech.qt.gui;

import com.trolltech.qt.*;

import com.trolltech.qt.core.Qt.Axis;

@QtJambiGeneratedClass
public class QTransform extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum TransformationType implements com.trolltech.qt.QtEnumerator {
        TxNone(0),
        TxTranslate(1),
        TxScale(2),
        TxRotate(4),
        TxShear(8),
        TxProject(16);

        TransformationType(int value) { this.value = value; }
        public int value() { return value; }

        public static TransformationType resolve(int value) {
            return (TransformationType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TxNone;
            case 1: return TxTranslate;
            case 2: return TxScale;
            case 4: return TxRotate;
            case 8: return TxShear;
            case 16: return TxProject;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QTransform(com.trolltech.qt.gui.QMatrix mtx) {
        super((QPrivateConstructor)null);
        __qt_QTransform_QMatrix(mtx == null ? (mtx = new com.trolltech.qt.gui.QMatrix()).nativeId() : mtx.nativeId());
    }
    private native void __qt_QTransform_QMatrix(long mtx);



    public QTransform(double h11, double h12, double h13, double h21, double h22, double h23, double h31, double h32) {
        this(h11, h12, h13, h21, h22, h23, h31, h32, (double)1.0);
    }
    public QTransform(double h11, double h12, double h13, double h21, double h22, double h23, double h31, double h32, double h33) {
        super((QPrivateConstructor)null);
        __qt_QTransform_double_double_double_double_double_double_double_double_double(h11, h12, h13, h21, h22, h23, h31, h32, h33);
    }
    private native void __qt_QTransform_double_double_double_double_double_double_double_double_double(double h11, double h12, double h13, double h21, double h22, double h23, double h31, double h32, double h33);


    public QTransform(double h11, double h12, double h13, double h21, double h22, double h23) {
        super((QPrivateConstructor)null);
        __qt_QTransform_double_double_double_double_double_double(h11, h12, h13, h21, h22, h23);
    }
    private native void __qt_QTransform_double_double_double_double_double_double(double h11, double h12, double h13, double h21, double h22, double h23);


    public QTransform() {
        super((QPrivateConstructor)null);
        __qt_QTransform();
    }
    private native void __qt_QTransform();


    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform adjoint() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_adjoint(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_adjoint(long __this__nativeId);

    @QtBlockedSlot public final double det() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_det(nativeId());
    }
    private native static double __qt_det(long __this__nativeId);

    @QtBlockedSlot public final double determinant() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_determinant(nativeId());
    }
    private native static double __qt_determinant(long __this__nativeId);

    @QtBlockedSlot public final double dx() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dx(nativeId());
    }
    private native static double __qt_dx(long __this__nativeId);

    @QtBlockedSlot public final double dy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_dy(nativeId());
    }
    private native static double __qt_dy(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.gui.QTransform inverted(com.trolltech.qt.QNativePointer invertible) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inverted_nativepointer(nativeId(), invertible);
    }
    private native static com.trolltech.qt.gui.QTransform __qt_inverted_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer invertible);

    @QtBlockedSlot public final boolean isAffine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAffine(nativeId());
    }
    private native static boolean __qt_isAffine(long __this__nativeId);

    @QtBlockedSlot public final boolean isIdentity() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isIdentity(nativeId());
    }
    private native static boolean __qt_isIdentity(long __this__nativeId);

    @QtBlockedSlot public final boolean isInvertible() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isInvertible(nativeId());
    }
    private native static boolean __qt_isInvertible(long __this__nativeId);

    @QtBlockedSlot public final boolean isRotating() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRotating(nativeId());
    }
    private native static boolean __qt_isRotating(long __this__nativeId);

    @QtBlockedSlot public final boolean isScaling() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isScaling(nativeId());
    }
    private native static boolean __qt_isScaling(long __this__nativeId);

    @QtBlockedSlot public final boolean isTranslating() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isTranslating(nativeId());
    }
    private native static boolean __qt_isTranslating(long __this__nativeId);

    @QtBlockedSlot public final double m11() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m11(nativeId());
    }
    private native static double __qt_m11(long __this__nativeId);

    @QtBlockedSlot public final double m12() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m12(nativeId());
    }
    private native static double __qt_m12(long __this__nativeId);

    @QtBlockedSlot public final double m13() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m13(nativeId());
    }
    private native static double __qt_m13(long __this__nativeId);

    @QtBlockedSlot public final double m21() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m21(nativeId());
    }
    private native static double __qt_m21(long __this__nativeId);

    @QtBlockedSlot public final double m22() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m22(nativeId());
    }
    private native static double __qt_m22(long __this__nativeId);

    @QtBlockedSlot public final double m23() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m23(nativeId());
    }
    private native static double __qt_m23(long __this__nativeId);

    @QtBlockedSlot public final double m31() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m31(nativeId());
    }
    private native static double __qt_m31(long __this__nativeId);

    @QtBlockedSlot public final double m32() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m32(nativeId());
    }
    private native static double __qt_m32(long __this__nativeId);

    @QtBlockedSlot public final double m33() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_m33(nativeId());
    }
    private native static double __qt_m33(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygon map(com.trolltech.qt.gui.QPolygon a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QPolygon(nativeId(), a == null ? (a = new com.trolltech.qt.gui.QPolygon()).nativeId() : a.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygon __qt_map_QPolygon(long __this__nativeId, long a);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint map(com.trolltech.qt.core.QPoint p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_map_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.core.QPointF map(com.trolltech.qt.core.QPointF p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QPointF(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPointF()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.core.QPointF __qt_map_QPointF(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPainterPath map(com.trolltech.qt.gui.QPainterPath p) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QPainterPath(nativeId(), p == null ? (p = new com.trolltech.qt.gui.QPainterPath()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.gui.QPainterPath __qt_map_QPainterPath(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLineF map(com.trolltech.qt.gui.QLineF l) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QLineF(nativeId(), l == null ? (l = new com.trolltech.qt.gui.QLineF()).nativeId() : l.nativeId());
    }
    private native static com.trolltech.qt.gui.QLineF __qt_map_QLineF(long __this__nativeId, long l);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygonF map(com.trolltech.qt.gui.QPolygonF a) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QPolygonF(nativeId(), a == null ? (a = new com.trolltech.qt.gui.QPolygonF()).nativeId() : a.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygonF __qt_map_QPolygonF(long __this__nativeId, long a);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLine map(com.trolltech.qt.gui.QLine l) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QLine(nativeId(), l == null ? (l = new com.trolltech.qt.gui.QLine()).nativeId() : l.nativeId());
    }
    private native static com.trolltech.qt.gui.QLine __qt_map_QLine(long __this__nativeId, long l);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion map(com.trolltech.qt.gui.QRegion r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_map_QRegion(nativeId(), r == null ? (r = new com.trolltech.qt.gui.QRegion()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_map_QRegion(long __this__nativeId, long r);

    @QtBlockedSlot public final com.trolltech.qt.core.QRectF mapRect(com.trolltech.qt.core.QRectF arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapRect_QRectF(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRectF()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QRectF __qt_mapRect_QRectF(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect mapRect(com.trolltech.qt.core.QRect arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapRect_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_mapRect_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPolygon mapToPolygon(com.trolltech.qt.core.QRect r) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToPolygon_QRect(nativeId(), r == null ? (r = new com.trolltech.qt.core.QRect()).nativeId() : r.nativeId());
    }
    private native static com.trolltech.qt.gui.QPolygon __qt_mapToPolygon_QRect(long __this__nativeId, long r);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.gui.QTransform operator_multiply(com.trolltech.qt.gui.QTransform o) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_multiply_QTransform(nativeId(), o == null ? (o = new com.trolltech.qt.gui.QTransform()).nativeId() : o.nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_operator_multiply_QTransform(long __this__nativeId, long o);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_multiply_assign(double div) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_multiply_assign_double(nativeId(), div);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_multiply_assign_double(long __this__nativeId, double div);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_multiply_assign(com.trolltech.qt.gui.QTransform arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_multiply_assign_QTransform(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QTransform()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_multiply_assign_QTransform(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_add_assign(double div) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_add_assign_double(nativeId(), div);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_add_assign_double(long __this__nativeId, double div);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_subtract_assign(double div) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_subtract_assign_double(nativeId(), div);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_subtract_assign_double(long __this__nativeId, double div);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_divide_assign(double div) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_divide_assign_double(nativeId(), div);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_divide_assign_double(long __this__nativeId, double div);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.gui.QTransform arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QTransform(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QTransform()).nativeId() : arg__1.nativeId());
    }
    private native static boolean __qt_operator_equal_QTransform(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void reset() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_reset(nativeId());
    }
    private native static void __qt_reset(long __this__nativeId);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer rotate_private(double a) {
        return rotate_private(a, com.trolltech.qt.core.Qt.Axis.ZAxis);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer rotate_private(double a, com.trolltech.qt.core.Qt.Axis axis) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rotate_private_double_Axis(nativeId(), a, axis.value());
    }
    private native static com.trolltech.qt.QNativePointer __qt_rotate_private_double_Axis(long __this__nativeId, double a, int axis);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer rotateRadians_private(double a) {
        return rotateRadians_private(a, com.trolltech.qt.core.Qt.Axis.ZAxis);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer rotateRadians_private(double a, com.trolltech.qt.core.Qt.Axis axis) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rotateRadians_private_double_Axis(nativeId(), a, axis.value());
    }
    private native static com.trolltech.qt.QNativePointer __qt_rotateRadians_private_double_Axis(long __this__nativeId, double a, int axis);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer scale_private(double sx, double sy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scale_private_double_double(nativeId(), sx, sy);
    }
    private native static com.trolltech.qt.QNativePointer __qt_scale_private_double_double(long __this__nativeId, double sx, double sy);

    @QtBlockedSlot public final void setMatrix(double m11, double m12, double m13, double m21, double m22, double m23, double m31, double m32, double m33) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMatrix_double_double_double_double_double_double_double_double_double(nativeId(), m11, m12, m13, m21, m22, m23, m31, m32, m33);
    }
    private native static void __qt_setMatrix_double_double_double_double_double_double_double_double_double(long __this__nativeId, double m11, double m12, double m13, double m21, double m22, double m23, double m31, double m32, double m33);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer shear_private(double sh, double sv) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_shear_private_double_double(nativeId(), sh, sv);
    }
    private native static com.trolltech.qt.QNativePointer __qt_shear_private_double_double(long __this__nativeId, double sh, double sv);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMatrix toAffine() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toAffine(nativeId());
    }
    private native static com.trolltech.qt.gui.QMatrix __qt_toAffine(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer translate_private(double dx, double dy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_translate_private_double_double(nativeId(), dx, dy);
    }
    private native static com.trolltech.qt.QNativePointer __qt_translate_private_double_double(long __this__nativeId, double dx, double dy);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform transposed() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_transposed(nativeId());
    }
    private native static com.trolltech.qt.gui.QTransform __qt_transposed(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QTransform.TransformationType type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QTransform.TransformationType.resolve(__qt_type(nativeId()));
    }
    private native static int __qt_type(long __this__nativeId);

    @SuppressWarnings("unused")
    private static boolean quadToQuadPrivate(com.trolltech.qt.gui.QPolygonF one, com.trolltech.qt.gui.QPolygonF two, com.trolltech.qt.QNativePointer result) {
        return __qt_quadToQuadPrivate_QPolygonF_QPolygonF_nativepointer(one == null ? (one = new com.trolltech.qt.gui.QPolygonF()).nativeId() : one.nativeId(), two == null ? (two = new com.trolltech.qt.gui.QPolygonF()).nativeId() : two.nativeId(), result);
    }
    private native static boolean __qt_quadToQuadPrivate_QPolygonF_QPolygonF_nativepointer(long one, long two, com.trolltech.qt.QNativePointer result);

    @SuppressWarnings("unused")
    private static boolean quadToSquarePrivate(com.trolltech.qt.gui.QPolygonF quad, com.trolltech.qt.QNativePointer result) {
        return __qt_quadToSquarePrivate_QPolygonF_nativepointer(quad == null ? (quad = new com.trolltech.qt.gui.QPolygonF()).nativeId() : quad.nativeId(), result);
    }
    private native static boolean __qt_quadToSquarePrivate_QPolygonF_nativepointer(long quad, com.trolltech.qt.QNativePointer result);

    @SuppressWarnings("unused")
    private static boolean squareToQuadPrivate(com.trolltech.qt.gui.QPolygonF square, com.trolltech.qt.QNativePointer result) {
        return __qt_squareToQuadPrivate_QPolygonF_nativepointer(square == null ? (square = new com.trolltech.qt.gui.QPolygonF()).nativeId() : square.nativeId(), result);
    }
    private native static boolean __qt_squareToQuadPrivate_QPolygonF_nativepointer(long square, com.trolltech.qt.QNativePointer result);


    public static native QTransform fromNativePointer(QNativePointer nativePointer);

    protected QTransform(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTransform array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.gui.QTransform)
            return operator_equal((com.trolltech.qt.gui.QTransform) other);
        return false;
    }


        public final QTransform multiply(double d) { operator_multiply_assign(d); return this; }
        public final QTransform add(double d) { operator_add_assign(d); return this; }
        public final QTransform divide(double d) { operator_divide_assign(d); return this; }
        public final QTransform subtract(double d) { operator_subtract_assign(d); return this; }
    
 
    /**
     * Returns an inverted copy of this transformation.
     *
     * @return The inverse of the transformation.
     * @throws IllegalArgumentException If this transformation is not invertible.
     */
    public final QTransform inverted() {
        QNativePointer ok = new QNativePointer(QNativePointer.Type.Boolean);
        QTransform returned = inverted(ok);
        if (!ok.booleanValue())
            throw new IllegalArgumentException("Transformation is not invertible");
        return returned;
    }
    

    /**
     * Rotates the transformation around the given axis.
     *
     * @return The rotated transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform rotate(double angle, Axis axis) {
        rotate_private(angle, axis);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END

    /**
     * Rotates the transformation around the z-axis.
     *
     * @return The rotated transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform rotate(double angle) {
        rotate_private(angle);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END
    

    /**
     * Rotates the transformation around the given axis.
     *
     * @return The rotated transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform rotateRadians(double angle, Axis axis) {
        rotateRadians_private(angle, axis);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END

    /**
     * Rotates the transformation around the z-axis.
     *
     * @return The rotated transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform rotateRadians(double angle) {
        rotateRadians_private(angle);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END
    

    /**
     * Scales the transformation using x and y.
     *
     * @return The scaled transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform scale(double x, double y) {
        scale_private(x, y);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END
    

    /**
      * Shears the transformation using x and y.
      *
      * @return The sheared transformation.
      */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform shear(double x, double y) {
        shear_private(x, y);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END
    

    /**
     * Translates the transformation using x and y.
     *
     * @return The translated transformation.
     */
        // TEMPLATE - core.private_function_return_self - START
      public final QTransform translate(double x, double y) {
        translate_private(x, y);
        return this;
      }
  // TEMPLATE - core.private_function_return_self - END
    

    /**
     * Creates a transformation mapping one arbitrary quad into another.
     *
     * @return The transformation.
     * @throws IllegalArgumentException If this transformation is not possible.
     */
    public static final QTransform quadToQuad(QPolygonF from, QPolygonF to) {
        QTransform res = new QTransform();
        QNativePointer resPointer = res.nativePointer();
        if (quadToQuadPrivate(from, to, resPointer)) {
            return res;
        } else
            throw new IllegalArgumentException("Transformation is not possible");
    }
    

    /**
     * Creates a transformation that maps a quad to a unit square.
     *
     * @return The transformation.
     * @throws IllegalArgumentException If this transformation is not possible.
     */
    public static final QTransform quadToSquare(QPolygonF quad) {
        QTransform res = new QTransform();
        QNativePointer resPointer = res.nativePointer();
        if (quadToSquarePrivate(quad, resPointer)) {
            return res;
        } else
            throw new IllegalArgumentException("Transformation is not possible");
    }
    

    /**
     * Creates a transformation that maps a unit square to a the given quad.
     *
     * @return The transformation.
     * @throws IllegalArgumentException If this transformation is not possible.
     */
    public static final QTransform squareToQuad(QPolygonF quad) {
        QTransform res = new QTransform();
        QNativePointer resPointer = res.nativePointer();
        if (squareToQuadPrivate(quad, resPointer)) {
            return res;
        } else
            throw new IllegalArgumentException("Transformation is not possible");
    }
    
}
