package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QTreeWidgetItemIterator extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum IteratorFlag implements com.trolltech.qt.QtEnumerator {
        All(0),
        Hidden(1),
        NotHidden(2),
        Selected(4),
        Unselected(8),
        Selectable(16),
        NotSelectable(32),
        DragEnabled(64),
        DragDisabled(128),
        DropEnabled(256),
        DropDisabled(512),
        HasChildren(1024),
        NoChildren(2048),
        Checked(4096),
        NotChecked(8192),
        Enabled(16384),
        Disabled(32768),
        Editable(65536),
        NotEditable(131072),
        UserFlag(16777216);

        IteratorFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static IteratorFlags createQFlags(IteratorFlag ... values) {
            return new IteratorFlags(values);
        }
        public static IteratorFlag resolve(int value) {
            return (IteratorFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return All;
            case 1: return Hidden;
            case 2: return NotHidden;
            case 4: return Selected;
            case 8: return Unselected;
            case 16: return Selectable;
            case 32: return NotSelectable;
            case 64: return DragEnabled;
            case 128: return DragDisabled;
            case 256: return DropEnabled;
            case 512: return DropDisabled;
            case 1024: return HasChildren;
            case 2048: return NoChildren;
            case 4096: return Checked;
            case 8192: return NotChecked;
            case 16384: return Enabled;
            case 32768: return Disabled;
            case 65536: return Editable;
            case 131072: return NotEditable;
            case 16777216: return UserFlag;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class IteratorFlags extends com.trolltech.qt.QFlags<IteratorFlag> {
        private static final long serialVersionUID = 1L;
        public IteratorFlags(IteratorFlag ... args) { super(args); }
        public IteratorFlags(int value) { setValue(value); }
    }


    public QTreeWidgetItemIterator(com.trolltech.qt.gui.QTreeWidgetItemIterator it) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItemIterator_QTreeWidgetItemIterator(it == null ? 0 : it.nativeId());
    }
    private native void __qt_QTreeWidgetItemIterator_QTreeWidgetItemIterator(long it);



    public QTreeWidgetItemIterator(com.trolltech.qt.gui.QTreeWidget widget) {
        this(widget, new com.trolltech.qt.gui.QTreeWidgetItemIterator.IteratorFlags(0));
    }
    public QTreeWidgetItemIterator(com.trolltech.qt.gui.QTreeWidget widget, com.trolltech.qt.gui.QTreeWidgetItemIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItemIterator_QTreeWidget_IteratorFlags(widget == null ? 0 : widget.nativeId(), flags.value());
    }
    private native void __qt_QTreeWidgetItemIterator_QTreeWidget_IteratorFlags(long widget, int flags);



    public QTreeWidgetItemIterator(com.trolltech.qt.gui.QTreeWidgetItem item) {
        this(item, new com.trolltech.qt.gui.QTreeWidgetItemIterator.IteratorFlags(0));
    }
    public QTreeWidgetItemIterator(com.trolltech.qt.gui.QTreeWidgetItem item, com.trolltech.qt.gui.QTreeWidgetItemIterator.IteratorFlags flags) {
        super((QPrivateConstructor)null);
        __qt_QTreeWidgetItemIterator_QTreeWidgetItem_IteratorFlags(item == null ? 0 : item.nativeId(), flags.value());
    }
    private native void __qt_QTreeWidgetItemIterator_QTreeWidgetItem_IteratorFlags(long item, int flags);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.gui.QTreeWidgetItem operator_multiply() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_multiply(nativeId());
    }
    private native static com.trolltech.qt.gui.QTreeWidgetItem __qt_operator_multiply(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_increment() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_increment(nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_increment(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_add_assign(int n) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_add_assign_int(nativeId(), n);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_add_assign_int(long __this__nativeId, int n);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_decrement() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_decrement(nativeId());
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_decrement(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final com.trolltech.qt.QNativePointer operator_subtract_assign(int n) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_subtract_assign_int(nativeId(), n);
    }
    private native static com.trolltech.qt.QNativePointer __qt_operator_subtract_assign_int(long __this__nativeId, int n);


    public static native QTreeWidgetItemIterator fromNativePointer(QNativePointer nativePointer);

    protected QTreeWidgetItemIterator(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QTreeWidgetItemIterator array[]);

        @QtBlockedSlot public final void next(int i) { operator_add_assign(i); }
        @QtBlockedSlot public final void previous(int i) { operator_subtract_assign(i); }
        @QtBlockedSlot public final void next() { operator_increment(); }
        @QtBlockedSlot public final void previous() { operator_decrement(); }
        @QtBlockedSlot public final QTreeWidgetItem current() { return operator_multiply(); }
    
}
