package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QWidget extends com.trolltech.qt.core.QObject
    implements com.trolltech.qt.gui.QPaintDeviceInterface
{
    @SuppressWarnings("unused") private Object __rcStyle = null;
    @SuppressWarnings("unused") private java.util.Collection<Object> __rcActions = new java.util.ArrayList<Object>();
    @SuppressWarnings("unused") private Object __rcFocusProxy = null;
    static {
        com.trolltech.qt.gui.QtJambi_LibraryInitializer.init();
    }
    public enum RenderFlag implements com.trolltech.qt.QtEnumerator {
        DrawWindowBackground(1),
        DrawChildren(2),
        IgnoreMask(4);

        RenderFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static RenderFlags createQFlags(RenderFlag ... values) {
            return new RenderFlags(values);
        }
        public static RenderFlag resolve(int value) {
            return (RenderFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 1: return DrawWindowBackground;
            case 2: return DrawChildren;
            case 4: return IgnoreMask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class RenderFlags extends com.trolltech.qt.QFlags<RenderFlag> {
        private static final long serialVersionUID = 1L;
        public RenderFlags(RenderFlag ... args) { super(args); }
        public RenderFlags(int value) { setValue(value); }
    }


    public final Signal1<com.trolltech.qt.core.QPoint> customContextMenuRequested = new Signal1<com.trolltech.qt.core.QPoint>();

    @SuppressWarnings("unused")
    private final void customContextMenuRequested(com.trolltech.qt.core.QPoint pos) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_customContextMenuRequested_QPoint(nativeId(), pos == null ? (pos = new com.trolltech.qt.core.QPoint()).nativeId() : pos.nativeId());
    }
    private native static void __qt_customContextMenuRequested_QPoint(long __this__nativeId, long pos);


    public QWidget(com.trolltech.qt.gui.QWidget parent) {
        this(parent, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }

    public QWidget() {
        this((com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    public QWidget(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        super((QPrivateConstructor)null);
        __qt_QWidget_QWidget_WindowFlags(parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native void __qt_QWidget_QWidget_WindowFlags(long parent, int f);


    @com.trolltech.qt.QtPropertyReader(name="acceptDrops")
    @com.trolltech.qt.QtPropertyOrder(40)
    @QtBlockedSlot public final boolean acceptDrops() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_acceptDrops(nativeId());
    }
    private native static boolean __qt_acceptDrops(long __this__nativeId);

    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QAction> actions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_actions(nativeId());
    }
    private native static java.util.List<com.trolltech.qt.gui.QAction> __qt_actions(long __this__nativeId);

    @QtBlockedSlot public final void activateWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activateWindow(nativeId());
    }
    private native static void __qt_activateWindow(long __this__nativeId);

    @QtBlockedSlot public final void addAction(com.trolltech.qt.gui.QAction action) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (action != null) {
            __rcActions.add(action);
        }
        __qt_addAction_QAction(nativeId(), action == null ? 0 : action.nativeId());
    }
    private native static void __qt_addAction_QAction(long __this__nativeId, long action);

    @QtBlockedSlot public final void addActions(java.util.List<com.trolltech.qt.gui.QAction> actions) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (actions != null) {
            __rcActions.addAll(actions);
        }
        __qt_addActions_List(nativeId(), actions);
    }
    private native static void __qt_addActions_List(long __this__nativeId, java.util.List<com.trolltech.qt.gui.QAction> actions);

    @QtBlockedSlot public final void adjustSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_adjustSize(nativeId());
    }
    private native static void __qt_adjustSize(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="autoFillBackground")
    @com.trolltech.qt.QtPropertyOrder(50)
    @QtBlockedSlot public final boolean autoFillBackground() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_autoFillBackground(nativeId());
    }
    private native static boolean __qt_autoFillBackground(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette.ColorRole backgroundRole() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPalette.ColorRole.resolve(__qt_backgroundRole(nativeId()));
    }
    private native static int __qt_backgroundRole(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="baseSize")
    @com.trolltech.qt.QtPropertyOrder(24)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize baseSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_baseSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_baseSize(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget childAt(com.trolltech.qt.core.QPoint p) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childAt_QPoint(nativeId(), p == null ? (p = new com.trolltech.qt.core.QPoint()).nativeId() : p.nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_childAt_QPoint(long __this__nativeId, long p);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget childAt(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childAt_int_int(nativeId(), x, y);
    }
    private native static com.trolltech.qt.gui.QWidget __qt_childAt_int_int(long __this__nativeId, int x, int y);

    @com.trolltech.qt.QtPropertyReader(name="childrenRect")
    @com.trolltech.qt.QtPropertyOrder(14)
    @QtBlockedSlot public final com.trolltech.qt.core.QRect childrenRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childrenRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_childrenRect(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="childrenRegion")
    @com.trolltech.qt.QtPropertyOrder(15)
    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion childrenRegion() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_childrenRegion(nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_childrenRegion(long __this__nativeId);

    @QtBlockedSlot public final void clearFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearFocus(nativeId());
    }
    private native static void __qt_clearFocus(long __this__nativeId);

    @QtBlockedSlot public final void clearMask() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearMask(nativeId());
    }
    private native static void __qt_clearMask(long __this__nativeId);

    public final boolean close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_close(nativeId());
    }
    private native static boolean __qt_close(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QRect contentsRect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_contentsRect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_contentsRect(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="contextMenuPolicy")
    @com.trolltech.qt.QtPropertyOrder(32)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.ContextMenuPolicy contextMenuPolicy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.ContextMenuPolicy.resolve(__qt_contextMenuPolicy(nativeId()));
    }
    private native static int __qt_contextMenuPolicy(long __this__nativeId);

    @QtBlockedSlot public final void createWinId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_createWinId(nativeId());
    }
    private native static void __qt_createWinId(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="cursor")
    @com.trolltech.qt.QtPropertyOrder(27)
    @QtBlockedSlot public final com.trolltech.qt.gui.QCursor cursor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_cursor(nativeId());
    }
    private native static com.trolltech.qt.gui.QCursor __qt_cursor(long __this__nativeId);

    @QtBlockedSlot public final int depth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static int __qt_depth(long __this__nativeId);


    @QtBlockedSlot protected final void destroy(boolean destroyWindow) {
        destroy(destroyWindow, (boolean)true);
    }

    @QtBlockedSlot protected final void destroy() {
        destroy((boolean)true, (boolean)true);
    }
    @QtBlockedSlot protected final void destroy(boolean destroyWindow, boolean destroySubWindows) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_destroy_boolean_boolean(nativeId(), destroyWindow, destroySubWindows);
    }
    private native static void __qt_destroy_boolean_boolean(long __this__nativeId, boolean destroyWindow, boolean destroySubWindows);

    @QtBlockedSlot public final void ensurePolished() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ensurePolished(nativeId());
    }
    private native static void __qt_ensurePolished(long __this__nativeId);

    @QtBlockedSlot protected final boolean focusNextChild() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusNextChild(nativeId());
    }
    private native static boolean __qt_focusNextChild(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="focusPolicy")
    @com.trolltech.qt.QtPropertyOrder(30)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.FocusPolicy focusPolicy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.FocusPolicy.resolve(__qt_focusPolicy(nativeId()));
    }
    private native static int __qt_focusPolicy(long __this__nativeId);

    @QtBlockedSlot protected final boolean focusPreviousChild() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusPreviousChild(nativeId());
    }
    private native static boolean __qt_focusPreviousChild(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget focusProxy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusProxy(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_focusProxy(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget focusWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_focusWidget(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="font")
    @com.trolltech.qt.QtPropertyOrder(26)
    @QtBlockedSlot public final com.trolltech.qt.gui.QFont font() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_font(nativeId());
    }
    private native static com.trolltech.qt.gui.QFont __qt_font(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFontInfo fontInfo() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontInfo(nativeId());
    }
    private native static com.trolltech.qt.gui.QFontInfo __qt_fontInfo(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QFontMetrics fontMetrics() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fontMetrics(nativeId());
    }
    private native static com.trolltech.qt.gui.QFontMetrics __qt_fontMetrics(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette.ColorRole foregroundRole() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QPalette.ColorRole.resolve(__qt_foregroundRole(nativeId()));
    }
    private native static int __qt_foregroundRole(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frameGeometry")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.core.QRect frameGeometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameGeometry(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_frameGeometry(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="frameSize")
    @com.trolltech.qt.QtPropertyOrder(9)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize frameSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_frameSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_frameSize(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="geometry")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.QRect geometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_geometry(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_geometry(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void getContentsMargins(com.trolltech.qt.QNativePointer left, com.trolltech.qt.QNativePointer top, com.trolltech.qt.QNativePointer right, com.trolltech.qt.QNativePointer bottom) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_getContentsMargins_nativepointer_nativepointer_nativepointer_nativepointer(nativeId(), left, top, right, bottom);
    }
    private native static void __qt_getContentsMargins_nativepointer_nativepointer_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer left, com.trolltech.qt.QNativePointer top, com.trolltech.qt.QNativePointer right, com.trolltech.qt.QNativePointer bottom);

    @QtBlockedSlot public final void grabKeyboard() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_grabKeyboard(nativeId());
    }
    private native static void __qt_grabKeyboard(long __this__nativeId);

    @QtBlockedSlot public final void grabMouse() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_grabMouse(nativeId());
    }
    private native static void __qt_grabMouse(long __this__nativeId);

    @QtBlockedSlot public final void grabMouse(com.trolltech.qt.gui.QCursor arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_grabMouse_QCursor(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QCursor()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_grabMouse_QCursor(long __this__nativeId, long arg__1);


    @QtBlockedSlot public final int grabShortcut(com.trolltech.qt.gui.QKeySequence key) {
        return grabShortcut(key, com.trolltech.qt.core.Qt.ShortcutContext.WindowShortcut);
    }
    @QtBlockedSlot public final int grabShortcut(com.trolltech.qt.gui.QKeySequence key, com.trolltech.qt.core.Qt.ShortcutContext context) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_grabShortcut_QKeySequence_ShortcutContext(nativeId(), key == null ? (key = new com.trolltech.qt.gui.QKeySequence()).nativeId() : key.nativeId(), context.value());
    }
    private native static int __qt_grabShortcut_QKeySequence_ShortcutContext(long __this__nativeId, long key, int context);

    @com.trolltech.qt.QtPropertyReader(name="focus")
    @com.trolltech.qt.QtPropertyOrder(31)
    @QtBlockedSlot public final boolean hasFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFocus(nativeId());
    }
    private native static boolean __qt_hasFocus(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="mouseTracking")
    @com.trolltech.qt.QtPropertyOrder(28)
    @QtBlockedSlot public final boolean hasMouseTracking() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasMouseTracking(nativeId());
    }
    private native static boolean __qt_hasMouseTracking(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="height")
    @com.trolltech.qt.QtPropertyOrder(12)
    @QtBlockedSlot public final int height() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_height(nativeId());
    }
    private native static int __qt_height(long __this__nativeId);

    @QtBlockedSlot public final int heightMM() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightMM(nativeId());
    }
    private native static int __qt_heightMM(long __this__nativeId);

    public final void hide() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hide(nativeId());
    }
    private native static void __qt_hide(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QInputContext inputContext() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputContext(nativeId());
    }
    private native static com.trolltech.qt.gui.QInputContext __qt_inputContext(long __this__nativeId);

    @QtBlockedSlot public final void insertAction(com.trolltech.qt.gui.QAction before, com.trolltech.qt.gui.QAction action) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (action != null) {
            __rcActions.add(action);
        }
        __qt_insertAction_QAction_QAction(nativeId(), before == null ? 0 : before.nativeId(), action == null ? 0 : action.nativeId());
    }
    private native static void __qt_insertAction_QAction_QAction(long __this__nativeId, long before, long action);

    @QtBlockedSlot public final void insertActions(com.trolltech.qt.gui.QAction before, java.util.List<com.trolltech.qt.gui.QAction> actions) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (actions != null) {
            __rcActions.addAll(actions);
        }
        __qt_insertActions_QAction_List(nativeId(), before == null ? 0 : before.nativeId(), actions);
    }
    private native static void __qt_insertActions_QAction_List(long __this__nativeId, long before, java.util.List<com.trolltech.qt.gui.QAction> actions);

    @com.trolltech.qt.QtPropertyReader(name="isActiveWindow")
    @com.trolltech.qt.QtPropertyOrder(29)
    @QtBlockedSlot public final boolean isActiveWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isActiveWindow(nativeId());
    }
    private native static boolean __qt_isActiveWindow(long __this__nativeId);

    @QtBlockedSlot public final boolean isAncestorOf(com.trolltech.qt.gui.QWidget child) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAncestorOf_QWidget(nativeId(), child == null ? 0 : child.nativeId());
    }
    private native static boolean __qt_isAncestorOf_QWidget(long __this__nativeId, long child);

    @com.trolltech.qt.QtPropertyReader(name="enabled")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final boolean isEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEnabled(nativeId());
    }
    private native static boolean __qt_isEnabled(long __this__nativeId);

    @QtBlockedSlot public final boolean isEnabledTo(com.trolltech.qt.gui.QWidget arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isEnabledTo_QWidget(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_isEnabledTo_QWidget(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyReader(name="fullScreen")
    @com.trolltech.qt.QtPropertyOrder(37)
    @QtBlockedSlot public final boolean isFullScreen() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isFullScreen(nativeId());
    }
    private native static boolean __qt_isFullScreen(long __this__nativeId);

    @QtBlockedSlot public final boolean isHidden() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isHidden(nativeId());
    }
    private native static boolean __qt_isHidden(long __this__nativeId);

    @QtBlockedSlot public final boolean isLeftToRight() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isLeftToRight(nativeId());
    }
    private native static boolean __qt_isLeftToRight(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximized")
    @com.trolltech.qt.QtPropertyOrder(36)
    @QtBlockedSlot public final boolean isMaximized() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isMaximized(nativeId());
    }
    private native static boolean __qt_isMaximized(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimized")
    @com.trolltech.qt.QtPropertyOrder(35)
    @QtBlockedSlot public final boolean isMinimized() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isMinimized(nativeId());
    }
    private native static boolean __qt_isMinimized(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="modal")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean isModal() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isModal(nativeId());
    }
    private native static boolean __qt_isModal(long __this__nativeId);

    @QtBlockedSlot public final boolean isRightToLeft() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isRightToLeft(nativeId());
    }
    private native static boolean __qt_isRightToLeft(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="visible")
    @com.trolltech.qt.QtPropertyOrder(34)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final boolean isVisible() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isVisible(nativeId());
    }
    private native static boolean __qt_isVisible(long __this__nativeId);

    @QtBlockedSlot public final boolean isVisibleTo(com.trolltech.qt.gui.QWidget arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isVisibleTo_QWidget(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_isVisibleTo_QWidget(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final boolean isWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWindow(nativeId());
    }
    private native static boolean __qt_isWindow(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowModified")
    @com.trolltech.qt.QtPropertyOrder(45)
    @com.trolltech.qt.QtPropertyDesignable("isWindow")
    @QtBlockedSlot public final boolean isWindowModified() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isWindowModified(nativeId());
    }
    private native static boolean __qt_isWindowModified(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QLayout layout() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_layout(nativeId());
    }
    private native static com.trolltech.qt.gui.QLayout __qt_layout(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="layoutDirection")
    @com.trolltech.qt.QtPropertyOrder(49)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.LayoutDirection layoutDirection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.LayoutDirection.resolve(__qt_layoutDirection(nativeId()));
    }
    private native static int __qt_layoutDirection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="locale")
    @com.trolltech.qt.QtPropertyOrder(52)
    @QtBlockedSlot public final com.trolltech.qt.core.QLocale locale() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_locale(nativeId());
    }
    private native static com.trolltech.qt.core.QLocale __qt_locale(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiX() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiX(nativeId());
    }
    private native static int __qt_logicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int logicalDpiY() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_logicalDpiY(nativeId());
    }
    private native static int __qt_logicalDpiY(long __this__nativeId);

    public final void lower() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_lower(nativeId());
    }
    private native static void __qt_lower(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapFrom(com.trolltech.qt.gui.QWidget arg__1, com.trolltech.qt.core.QPoint arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFrom_QWidget_QPoint(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__2.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapFrom_QWidget_QPoint(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapFromGlobal(com.trolltech.qt.core.QPoint arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromGlobal_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapFromGlobal_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapFromParent(com.trolltech.qt.core.QPoint arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapFromParent_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapFromParent_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapTo(com.trolltech.qt.gui.QWidget arg__1, com.trolltech.qt.core.QPoint arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapTo_QWidget_QPoint(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__2.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapTo_QWidget_QPoint(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapToGlobal(com.trolltech.qt.core.QPoint arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToGlobal_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapToGlobal_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.core.QPoint mapToParent(com.trolltech.qt.core.QPoint arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mapToParent_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_mapToParent_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion mask() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_mask(nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_mask(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximumHeight")
    @com.trolltech.qt.QtPropertyOrder(22)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final int maximumHeight() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumHeight(nativeId());
    }
    private native static int __qt_maximumHeight(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximumSize")
    @com.trolltech.qt.QtPropertyOrder(18)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize maximumSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_maximumSize(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="maximumWidth")
    @com.trolltech.qt.QtPropertyOrder(21)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final int maximumWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_maximumWidth(nativeId());
    }
    private native static int __qt_maximumWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumHeight")
    @com.trolltech.qt.QtPropertyOrder(20)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final int minimumHeight() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumHeight(nativeId());
    }
    private native static int __qt_minimumHeight(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumSize")
    @com.trolltech.qt.QtPropertyOrder(17)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize minimumSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSize(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSize(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="minimumWidth")
    @com.trolltech.qt.QtPropertyOrder(19)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final int minimumWidth() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumWidth(nativeId());
    }
    private native static int __qt_minimumWidth(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="pos")
    @QtBlockedSlot public final void move(com.trolltech.qt.core.QPoint arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_move_QPoint(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QPoint()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_move_QPoint(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void move(int x, int y) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_move_int_int(nativeId(), x, y);
    }
    private native static void __qt_move_int_int(long __this__nativeId, int x, int y);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget nextInFocusChain() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_nextInFocusChain(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_nextInFocusChain(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="normalGeometry")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final com.trolltech.qt.core.QRect normalGeometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_normalGeometry(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_normalGeometry(long __this__nativeId);

    @QtBlockedSlot public final int numColors() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numColors(nativeId());
    }
    private native static int __qt_numColors(long __this__nativeId);


    @QtBlockedSlot public final void overrideWindowFlags(com.trolltech.qt.core.Qt.WindowType ... type) {
        this.overrideWindowFlags(new com.trolltech.qt.core.Qt.WindowFlags(type));
    }
    @QtBlockedSlot public final void overrideWindowFlags(com.trolltech.qt.core.Qt.WindowFlags type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_overrideWindowFlags_WindowFlags(nativeId(), type.value());
    }
    private native static void __qt_overrideWindowFlags_WindowFlags(long __this__nativeId, int type);


    @QtBlockedSlot public final void overrideWindowState(com.trolltech.qt.core.Qt.WindowState ... state) {
        this.overrideWindowState(new com.trolltech.qt.core.Qt.WindowStates(state));
    }
    @QtBlockedSlot public final void overrideWindowState(com.trolltech.qt.core.Qt.WindowStates state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_overrideWindowState_WindowStates(nativeId(), state.value());
    }
    private native static void __qt_overrideWindowState_WindowStates(long __this__nativeId, int state);

    @QtBlockedSlot public final boolean paintingActive() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintingActive(nativeId());
    }
    private native static boolean __qt_paintingActive(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="palette")
    @com.trolltech.qt.QtPropertyOrder(25)
    @QtBlockedSlot public final com.trolltech.qt.gui.QPalette palette() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_palette(nativeId());
    }
    private native static com.trolltech.qt.gui.QPalette __qt_palette(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget parentWidget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parentWidget(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_parentWidget(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiX() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiX(nativeId());
    }
    private native static int __qt_physicalDpiX(long __this__nativeId);

    @QtBlockedSlot public final int physicalDpiY() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_physicalDpiY(nativeId());
    }
    private native static int __qt_physicalDpiY(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="pos")
    @com.trolltech.qt.QtPropertyOrder(8)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final com.trolltech.qt.core.QPoint pos() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static com.trolltech.qt.core.QPoint __qt_pos(long __this__nativeId);

    public final void raise() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_raise(nativeId());
    }
    private native static void __qt_raise(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="rect")
    @com.trolltech.qt.QtPropertyOrder(13)
    @QtBlockedSlot public final com.trolltech.qt.core.QRect rect() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rect(nativeId());
    }
    private native static com.trolltech.qt.core.QRect __qt_rect(long __this__nativeId);

    @QtBlockedSlot public final void releaseKeyboard() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_releaseKeyboard(nativeId());
    }
    private native static void __qt_releaseKeyboard(long __this__nativeId);

    @QtBlockedSlot public final void releaseMouse() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_releaseMouse(nativeId());
    }
    private native static void __qt_releaseMouse(long __this__nativeId);

    @QtBlockedSlot public final void releaseShortcut(int id) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_releaseShortcut_int(nativeId(), id);
    }
    private native static void __qt_releaseShortcut_int(long __this__nativeId, int id);

    @QtBlockedSlot public final void removeAction(com.trolltech.qt.gui.QAction action) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (action != null) {
            while (__rcActions.remove(action)) ;
        }
        __qt_removeAction_QAction(nativeId(), action == null ? 0 : action.nativeId());
    }
    private native static void __qt_removeAction_QAction(long __this__nativeId, long action);


    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPaintDeviceInterface target, com.trolltech.qt.core.QPoint targetOffset, com.trolltech.qt.gui.QRegion sourceRegion, com.trolltech.qt.gui.QWidget.RenderFlag ... renderFlags) {
        this.render(target, targetOffset, sourceRegion, new com.trolltech.qt.gui.QWidget.RenderFlags(renderFlags));
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPaintDeviceInterface target, com.trolltech.qt.core.QPoint targetOffset, com.trolltech.qt.gui.QRegion sourceRegion) {
        render(target, targetOffset, sourceRegion, new com.trolltech.qt.gui.QWidget.RenderFlags(RenderFlag.DrawWindowBackground, RenderFlag.DrawChildren));
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPaintDeviceInterface target, com.trolltech.qt.core.QPoint targetOffset) {
        render(target, targetOffset, (com.trolltech.qt.gui.QRegion)new com.trolltech.qt.gui.QRegion(), new com.trolltech.qt.gui.QWidget.RenderFlags(RenderFlag.DrawWindowBackground, RenderFlag.DrawChildren));
    }

    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPaintDeviceInterface target) {
        render(target, (com.trolltech.qt.core.QPoint)new com.trolltech.qt.core.QPoint(), (com.trolltech.qt.gui.QRegion)new com.trolltech.qt.gui.QRegion(), new com.trolltech.qt.gui.QWidget.RenderFlags(RenderFlag.DrawWindowBackground, RenderFlag.DrawChildren));
    }
    @QtBlockedSlot public final void render(com.trolltech.qt.gui.QPaintDeviceInterface target, com.trolltech.qt.core.QPoint targetOffset, com.trolltech.qt.gui.QRegion sourceRegion, com.trolltech.qt.gui.QWidget.RenderFlags renderFlags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_render_QPaintDevice_QPoint_QRegion_RenderFlags(nativeId(), target == null ? 0 : target.nativeId(), targetOffset == null ? (targetOffset = new com.trolltech.qt.core.QPoint()).nativeId() : targetOffset.nativeId(), sourceRegion == null ? (sourceRegion = new com.trolltech.qt.gui.QRegion()).nativeId() : sourceRegion.nativeId(), renderFlags.value());
    }
    private native static void __qt_render_QPaintDevice_QPoint_QRegion_RenderFlags(long __this__nativeId, long target, long targetOffset, long sourceRegion, int renderFlags);

    @QtBlockedSlot public final void repaint(int x, int y, int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_repaint_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_repaint_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    public final void repaint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_repaint(nativeId());
    }
    private native static void __qt_repaint(long __this__nativeId);

    @QtBlockedSlot public final void repaint(com.trolltech.qt.gui.QRegion arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_repaint_QRegion(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QRegion()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_repaint_QRegion(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void repaint(com.trolltech.qt.core.QRect arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_repaint_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_repaint_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected final void resetInputContext() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resetInputContext(nativeId());
    }
    private native static void __qt_resetInputContext(long __this__nativeId);

    @com.trolltech.qt.QtPropertyWriter(name="size")
    @QtBlockedSlot public final void resize(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resize_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_resize_QSize(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void resize(int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resize_int_int(nativeId(), w, h);
    }
    private native static void __qt_resize_int_int(long __this__nativeId, int w, int h);

    @QtBlockedSlot public final boolean restoreGeometry(com.trolltech.qt.core.QByteArray geometry) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_restoreGeometry_QByteArray(nativeId(), geometry == null ? (geometry = new com.trolltech.qt.core.QByteArray()).nativeId() : geometry.nativeId());
    }
    private native static boolean __qt_restoreGeometry_QByteArray(long __this__nativeId, long geometry);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray saveGeometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_saveGeometry(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_saveGeometry(long __this__nativeId);

    @QtBlockedSlot public final void scroll(int dx, int dy, com.trolltech.qt.core.QRect arg__3) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scroll_int_int_QRect(nativeId(), dx, dy, arg__3 == null ? (arg__3 = new com.trolltech.qt.core.QRect()).nativeId() : arg__3.nativeId());
    }
    private native static void __qt_scroll_int_int_QRect(long __this__nativeId, int dx, int dy, long arg__3);

    @QtBlockedSlot public final void scroll(int dx, int dy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_scroll_int_int(nativeId(), dx, dy);
    }
    private native static void __qt_scroll_int_int(long __this__nativeId, int dx, int dy);

    @com.trolltech.qt.QtPropertyWriter(name="acceptDrops")
    @QtBlockedSlot public final void setAcceptDrops(boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAcceptDrops_boolean(nativeId(), on);
    }
    private native static void __qt_setAcceptDrops_boolean(long __this__nativeId, boolean on);


    @QtBlockedSlot public final void setAttribute(com.trolltech.qt.core.Qt.WidgetAttribute arg__1) {
        setAttribute(arg__1, (boolean)true);
    }
    @QtBlockedSlot public final void setAttribute(com.trolltech.qt.core.Qt.WidgetAttribute arg__1, boolean on) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAttribute_WidgetAttribute_boolean(nativeId(), arg__1.value(), on);
    }
    private native static void __qt_setAttribute_WidgetAttribute_boolean(long __this__nativeId, int arg__1, boolean on);

    @com.trolltech.qt.QtPropertyWriter(name="autoFillBackground")
    @QtBlockedSlot public final void setAutoFillBackground(boolean enabled) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutoFillBackground_boolean(nativeId(), enabled);
    }
    private native static void __qt_setAutoFillBackground_boolean(long __this__nativeId, boolean enabled);

    @QtBlockedSlot public final void setBackgroundRole(com.trolltech.qt.gui.QPalette.ColorRole arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackgroundRole_ColorRole(nativeId(), arg__1.value());
    }
    private native static void __qt_setBackgroundRole_ColorRole(long __this__nativeId, int arg__1);

    @QtBlockedSlot public final void setBaseSize(int basew, int baseh) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBaseSize_int_int(nativeId(), basew, baseh);
    }
    private native static void __qt_setBaseSize_int_int(long __this__nativeId, int basew, int baseh);

    @com.trolltech.qt.QtPropertyWriter(name="baseSize")
    @QtBlockedSlot public final void setBaseSize(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBaseSize_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setBaseSize_QSize(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setContentsMargins(int left, int top, int right, int bottom) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setContentsMargins_int_int_int_int(nativeId(), left, top, right, bottom);
    }
    private native static void __qt_setContentsMargins_int_int_int_int(long __this__nativeId, int left, int top, int right, int bottom);

    @com.trolltech.qt.QtPropertyWriter(name="contextMenuPolicy")
    @QtBlockedSlot public final void setContextMenuPolicy(com.trolltech.qt.core.Qt.ContextMenuPolicy policy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setContextMenuPolicy_ContextMenuPolicy(nativeId(), policy.value());
    }
    private native static void __qt_setContextMenuPolicy_ContextMenuPolicy(long __this__nativeId, int policy);

    @com.trolltech.qt.QtPropertyWriter(name="cursor")
    @QtBlockedSlot public final void setCursor(com.trolltech.qt.gui.QCursor arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setCursor_QCursor(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QCursor()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setCursor_QCursor(long __this__nativeId, long arg__1);

    public final void setDisabled(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDisabled_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setDisabled_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="enabled")
    public final void setEnabled(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEnabled_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setEnabled_boolean(long __this__nativeId, boolean arg__1);

    @QtBlockedSlot public final void setFixedHeight(int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFixedHeight_int(nativeId(), h);
    }
    private native static void __qt_setFixedHeight_int(long __this__nativeId, int h);

    @QtBlockedSlot public final void setFixedSize(int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFixedSize_int_int(nativeId(), w, h);
    }
    private native static void __qt_setFixedSize_int_int(long __this__nativeId, int w, int h);

    @QtBlockedSlot public final void setFixedSize(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFixedSize_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setFixedSize_QSize(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setFixedWidth(int w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFixedWidth_int(nativeId(), w);
    }
    private native static void __qt_setFixedWidth_int(long __this__nativeId, int w);

    public final void setFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFocus(nativeId());
    }
    private native static void __qt_setFocus(long __this__nativeId);

    @QtBlockedSlot public final void setFocus(com.trolltech.qt.core.Qt.FocusReason reason) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFocus_FocusReason(nativeId(), reason.value());
    }
    private native static void __qt_setFocus_FocusReason(long __this__nativeId, int reason);

    @com.trolltech.qt.QtPropertyWriter(name="focusPolicy")
    @QtBlockedSlot public final void setFocusPolicy(com.trolltech.qt.core.Qt.FocusPolicy policy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFocusPolicy_FocusPolicy(nativeId(), policy.value());
    }
    private native static void __qt_setFocusPolicy_FocusPolicy(long __this__nativeId, int policy);

    @QtBlockedSlot public final void setFocusProxy(com.trolltech.qt.gui.QWidget arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcFocusProxy = arg__1;
        }
        __qt_setFocusProxy_QWidget(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setFocusProxy_QWidget(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="font")
    @QtBlockedSlot public final void setFont(com.trolltech.qt.gui.QFont arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFont_QFont(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QFont()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setFont_QFont(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setForegroundRole(com.trolltech.qt.gui.QPalette.ColorRole arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForegroundRole_ColorRole(nativeId(), arg__1.value());
    }
    private native static void __qt_setForegroundRole_ColorRole(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="geometry")
    @QtBlockedSlot public final void setGeometry(com.trolltech.qt.core.QRect arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGeometry_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setGeometry_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setGeometry(int x, int y, int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGeometry_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_setGeometry_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    public final void setHidden(boolean hidden) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setHidden_boolean(nativeId(), hidden);
    }
    private native static void __qt_setHidden_boolean(long __this__nativeId, boolean hidden);

    @QtBlockedSlot public final void setInputContext(com.trolltech.qt.gui.QInputContext arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (arg__1 != null) {
            arg__1.disableGarbageCollection();
        }
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInputContext_QInputContext(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setInputContext_QInputContext(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setLayout(com.trolltech.qt.gui.QLayout arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        if (arg__1 == null)
            throw new NullPointerException("Argument 'arg__1': null not expected.");
        __qt_setLayout_QLayout(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setLayout_QLayout(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="layoutDirection")
    @QtBlockedSlot public final void setLayoutDirection(com.trolltech.qt.core.Qt.LayoutDirection direction) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLayoutDirection_LayoutDirection(nativeId(), direction.value());
    }
    private native static void __qt_setLayoutDirection_LayoutDirection(long __this__nativeId, int direction);

    @com.trolltech.qt.QtPropertyWriter(name="locale")
    @QtBlockedSlot public final void setLocale(com.trolltech.qt.core.QLocale locale) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLocale_QLocale(nativeId(), locale == null ? (locale = new com.trolltech.qt.core.QLocale()).nativeId() : locale.nativeId());
    }
    private native static void __qt_setLocale_QLocale(long __this__nativeId, long locale);

    @QtBlockedSlot public final void setMask(com.trolltech.qt.gui.QRegion arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMask_QRegion(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QRegion()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setMask_QRegion(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setMask(com.trolltech.qt.gui.QBitmap arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMask_QBitmap(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QBitmap()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setMask_QBitmap(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="maximumHeight")
    @QtBlockedSlot public final void setMaximumHeight(int maxh) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumHeight_int(nativeId(), maxh);
    }
    private native static void __qt_setMaximumHeight_int(long __this__nativeId, int maxh);

    @QtBlockedSlot public final void setMaximumSize(int maxw, int maxh) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumSize_int_int(nativeId(), maxw, maxh);
    }
    private native static void __qt_setMaximumSize_int_int(long __this__nativeId, int maxw, int maxh);

    @com.trolltech.qt.QtPropertyWriter(name="maximumSize")
    @QtBlockedSlot public final void setMaximumSize(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumSize_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setMaximumSize_QSize(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="maximumWidth")
    @QtBlockedSlot public final void setMaximumWidth(int maxw) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMaximumWidth_int(nativeId(), maxw);
    }
    private native static void __qt_setMaximumWidth_int(long __this__nativeId, int maxw);

    @com.trolltech.qt.QtPropertyWriter(name="minimumHeight")
    @QtBlockedSlot public final void setMinimumHeight(int minh) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumHeight_int(nativeId(), minh);
    }
    private native static void __qt_setMinimumHeight_int(long __this__nativeId, int minh);

    @QtBlockedSlot public final void setMinimumSize(int minw, int minh) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumSize_int_int(nativeId(), minw, minh);
    }
    private native static void __qt_setMinimumSize_int_int(long __this__nativeId, int minw, int minh);

    @com.trolltech.qt.QtPropertyWriter(name="minimumSize")
    @QtBlockedSlot public final void setMinimumSize(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumSize_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setMinimumSize_QSize(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="minimumWidth")
    @QtBlockedSlot public final void setMinimumWidth(int minw) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMinimumWidth_int(nativeId(), minw);
    }
    private native static void __qt_setMinimumWidth_int(long __this__nativeId, int minw);

    @com.trolltech.qt.QtPropertyWriter(name="mouseTracking")
    @QtBlockedSlot public final void setMouseTracking(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setMouseTracking_boolean(nativeId(), enable);
    }
    private native static void __qt_setMouseTracking_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="palette")
    @QtBlockedSlot public final void setPalette(com.trolltech.qt.gui.QPalette arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPalette_QPalette(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QPalette()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setPalette_QPalette(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setParent(com.trolltech.qt.gui.QWidget parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setParent_QWidget(nativeId(), parent == null ? 0 : parent.nativeId());
    }
    private native static void __qt_setParent_QWidget(long __this__nativeId, long parent);


    @QtBlockedSlot public final void setParent(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowType ... f) {
        this.setParent(parent, new com.trolltech.qt.core.Qt.WindowFlags(f));
    }
    @QtBlockedSlot public final void setParent(com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setParent_QWidget_WindowFlags(nativeId(), parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native static void __qt_setParent_QWidget_WindowFlags(long __this__nativeId, long parent, int f);


    @QtBlockedSlot public final void setShortcutAutoRepeat(int id) {
        setShortcutAutoRepeat(id, (boolean)true);
    }
    @QtBlockedSlot public final void setShortcutAutoRepeat(int id, boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setShortcutAutoRepeat_int_boolean(nativeId(), id, enable);
    }
    private native static void __qt_setShortcutAutoRepeat_int_boolean(long __this__nativeId, int id, boolean enable);


    @QtBlockedSlot public final void setShortcutEnabled(int id) {
        setShortcutEnabled(id, (boolean)true);
    }
    @QtBlockedSlot public final void setShortcutEnabled(int id, boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setShortcutEnabled_int_boolean(nativeId(), id, enable);
    }
    private native static void __qt_setShortcutEnabled_int_boolean(long __this__nativeId, int id, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="sizeIncrement")
    @QtBlockedSlot public final void setSizeIncrement(com.trolltech.qt.core.QSize arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeIncrement_QSize(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QSize()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setSizeIncrement_QSize(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void setSizeIncrement(int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizeIncrement_int_int(nativeId(), w, h);
    }
    private native static void __qt_setSizeIncrement_int_int(long __this__nativeId, int w, int h);

    @QtBlockedSlot public final void setSizePolicy(com.trolltech.qt.gui.QSizePolicy.Policy horizontal, com.trolltech.qt.gui.QSizePolicy.Policy vertical) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizePolicy_Policy_Policy(nativeId(), horizontal.value(), vertical.value());
    }
    private native static void __qt_setSizePolicy_Policy_Policy(long __this__nativeId, int horizontal, int vertical);

    @com.trolltech.qt.QtPropertyWriter(name="sizePolicy")
    @QtBlockedSlot public final void setSizePolicy(com.trolltech.qt.gui.QSizePolicy arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSizePolicy_QSizePolicy(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QSizePolicy()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_setSizePolicy_QSizePolicy(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="statusTip")
    @QtBlockedSlot public final void setStatusTip(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusTip_String(nativeId(), arg__1);
    }
    private native static void __qt_setStatusTip_String(long __this__nativeId, java.lang.String arg__1);

    @QtBlockedSlot public final void setStyle(com.trolltech.qt.gui.QStyle arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcStyle = arg__1;
        }
        __qt_setStyle_QStyle(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_setStyle_QStyle(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="styleSheet")
    public final void setStyleSheet(java.lang.String styleSheet) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStyleSheet_String(nativeId(), styleSheet);
    }
    private native static void __qt_setStyleSheet_String(long __this__nativeId, java.lang.String styleSheet);

    @com.trolltech.qt.QtPropertyWriter(name="toolTip")
    @QtBlockedSlot public final void setToolTip(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setToolTip_String(nativeId(), arg__1);
    }
    private native static void __qt_setToolTip_String(long __this__nativeId, java.lang.String arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="updatesEnabled")
    @QtBlockedSlot public final void setUpdatesEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setUpdatesEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setUpdatesEnabled_boolean(long __this__nativeId, boolean enable);

    @com.trolltech.qt.QtPropertyWriter(name="whatsThis")
    @QtBlockedSlot public final void setWhatsThis(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWhatsThis_String(nativeId(), arg__1);
    }
    private native static void __qt_setWhatsThis_String(long __this__nativeId, java.lang.String arg__1);


    @QtBlockedSlot public final void setWindowFlags(com.trolltech.qt.core.Qt.WindowType ... type) {
        this.setWindowFlags(new com.trolltech.qt.core.Qt.WindowFlags(type));
    }
    @QtBlockedSlot public final void setWindowFlags(com.trolltech.qt.core.Qt.WindowFlags type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowFlags_WindowFlags(nativeId(), type.value());
    }
    private native static void __qt_setWindowFlags_WindowFlags(long __this__nativeId, int type);

    @com.trolltech.qt.QtPropertyWriter(name="windowIcon")
    @QtBlockedSlot public final void setWindowIcon(com.trolltech.qt.gui.QIcon icon) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowIcon_QIcon(nativeId(), icon == null ? (icon = new com.trolltech.qt.gui.QIcon()).nativeId() : icon.nativeId());
    }
    private native static void __qt_setWindowIcon_QIcon(long __this__nativeId, long icon);

    @com.trolltech.qt.QtPropertyWriter(name="windowIconText")
    @QtBlockedSlot public final void setWindowIconText(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowIconText_String(nativeId(), arg__1);
    }
    private native static void __qt_setWindowIconText_String(long __this__nativeId, java.lang.String arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="windowModality")
    @QtBlockedSlot public final void setWindowModality(com.trolltech.qt.core.Qt.WindowModality windowModality) {
    if (this instanceof QMessageBox) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_QMessageBox_setWindowModality(nativeId(), windowModality.value());
        return ;
    }

        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowModality_WindowModality(nativeId(), windowModality.value());
    }
    private native static void __qt_setWindowModality_WindowModality(long __this__nativeId, int windowModality);

    @com.trolltech.qt.QtPropertyWriter(name="windowModified")
    public final void setWindowModified(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowModified_boolean(nativeId(), arg__1);
    }
    private native static void __qt_setWindowModified_boolean(long __this__nativeId, boolean arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="windowOpacity")
    @QtBlockedSlot public final void setWindowOpacity(double level) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowOpacity_double(nativeId(), level);
    }
    private native static void __qt_setWindowOpacity_double(long __this__nativeId, double level);

    @QtBlockedSlot public final void setWindowRole(java.lang.String arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowRole_String(nativeId(), arg__1);
    }
    private native static void __qt_setWindowRole_String(long __this__nativeId, java.lang.String arg__1);


    @QtBlockedSlot public final void setWindowState(com.trolltech.qt.core.Qt.WindowState ... state) {
        this.setWindowState(new com.trolltech.qt.core.Qt.WindowStates(state));
    }
    @QtBlockedSlot public final void setWindowState(com.trolltech.qt.core.Qt.WindowStates state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowState_WindowStates(nativeId(), state.value());
    }
    private native static void __qt_setWindowState_WindowStates(long __this__nativeId, int state);

    @com.trolltech.qt.QtPropertyWriter(name="windowTitle")
    public final void setWindowTitle(java.lang.String arg__1) {
    if (this instanceof QMessageBox) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_QMessageBox_setWindowTitle(nativeId(), arg__1);
        return ;
    }

        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setWindowTitle_String(nativeId(), arg__1);
    }
    private native static void __qt_setWindowTitle_String(long __this__nativeId, java.lang.String arg__1);

    public final void show() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_show(nativeId());
    }
    private native static void __qt_show(long __this__nativeId);

    public final void showFullScreen() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showFullScreen(nativeId());
    }
    private native static void __qt_showFullScreen(long __this__nativeId);

    public final void showMaximized() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showMaximized(nativeId());
    }
    private native static void __qt_showMaximized(long __this__nativeId);

    public final void showMinimized() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showMinimized(nativeId());
    }
    private native static void __qt_showMinimized(long __this__nativeId);

    public final void showNormal() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showNormal(nativeId());
    }
    private native static void __qt_showNormal(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="size")
    @com.trolltech.qt.QtPropertyOrder(10)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final com.trolltech.qt.core.QSize size() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_size(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sizeIncrement")
    @com.trolltech.qt.QtPropertyOrder(23)
    @QtBlockedSlot public final com.trolltech.qt.core.QSize sizeIncrement() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeIncrement(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeIncrement(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="sizePolicy")
    @com.trolltech.qt.QtPropertyOrder(16)
    @QtBlockedSlot public final com.trolltech.qt.gui.QSizePolicy sizePolicy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizePolicy(nativeId());
    }
    private native static com.trolltech.qt.gui.QSizePolicy __qt_sizePolicy(long __this__nativeId);

    @QtBlockedSlot public final void stackUnder(com.trolltech.qt.gui.QWidget arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stackUnder_QWidget(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_stackUnder_QWidget(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyReader(name="statusTip")
    @com.trolltech.qt.QtPropertyOrder(47)
    @QtBlockedSlot public final java.lang.String statusTip() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusTip(nativeId());
    }
    private native static java.lang.String __qt_statusTip(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QStyle style() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_style(nativeId());
    }
    private native static com.trolltech.qt.gui.QStyle __qt_style(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="styleSheet")
    @com.trolltech.qt.QtPropertyOrder(51)
    @QtBlockedSlot public final java.lang.String styleSheet() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_styleSheet(nativeId());
    }
    private native static java.lang.String __qt_styleSheet(long __this__nativeId);

    @QtBlockedSlot public final boolean testAttribute(com.trolltech.qt.core.Qt.WidgetAttribute arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testAttribute_WidgetAttribute(nativeId(), arg__1.value());
    }
    private native static boolean __qt_testAttribute_WidgetAttribute(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyReader(name="toolTip")
    @com.trolltech.qt.QtPropertyOrder(46)
    @QtBlockedSlot public final java.lang.String toolTip() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toolTip(nativeId());
    }
    private native static java.lang.String __qt_toolTip(long __this__nativeId);

    @QtBlockedSlot public final boolean underMouse() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_underMouse(nativeId());
    }
    private native static boolean __qt_underMouse(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="cursor")
    @QtBlockedSlot public final void unsetCursor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unsetCursor(nativeId());
    }
    private native static void __qt_unsetCursor(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="layoutDirection")
    @QtBlockedSlot public final void unsetLayoutDirection() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unsetLayoutDirection(nativeId());
    }
    private native static void __qt_unsetLayoutDirection(long __this__nativeId);

    @com.trolltech.qt.QtPropertyResetter(name="locale")
    @QtBlockedSlot public final void unsetLocale() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unsetLocale(nativeId());
    }
    private native static void __qt_unsetLocale(long __this__nativeId);

    @QtBlockedSlot public final void update(com.trolltech.qt.gui.QRegion arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update_QRegion(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.gui.QRegion()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_update_QRegion(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void update(int x, int y, int w, int h) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update_int_int_int_int(nativeId(), x, y, w, h);
    }
    private native static void __qt_update_int_int_int_int(long __this__nativeId, int x, int y, int w, int h);

    public final void update() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update(nativeId());
    }
    private native static void __qt_update(long __this__nativeId);

    @QtBlockedSlot public final void update(com.trolltech.qt.core.QRect arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_update_QRect(nativeId(), arg__1 == null ? (arg__1 = new com.trolltech.qt.core.QRect()).nativeId() : arg__1.nativeId());
    }
    private native static void __qt_update_QRect(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final void updateGeometry() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateGeometry(nativeId());
    }
    private native static void __qt_updateGeometry(long __this__nativeId);

    protected final void updateMicroFocus() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_updateMicroFocus(nativeId());
    }
    private native static void __qt_updateMicroFocus(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="updatesEnabled")
    @com.trolltech.qt.QtPropertyOrder(33)
    @com.trolltech.qt.QtPropertyDesignable("false")
    @QtBlockedSlot public final boolean updatesEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_updatesEnabled(nativeId());
    }
    private native static boolean __qt_updatesEnabled(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QRegion visibleRegion() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_visibleRegion(nativeId());
    }
    private native static com.trolltech.qt.gui.QRegion __qt_visibleRegion(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="whatsThis")
    @com.trolltech.qt.QtPropertyOrder(48)
    @QtBlockedSlot public final java.lang.String whatsThis() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_whatsThis(nativeId());
    }
    private native static java.lang.String __qt_whatsThis(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="width")
    @com.trolltech.qt.QtPropertyOrder(11)
    @QtBlockedSlot public final int width() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_width(nativeId());
    }
    private native static int __qt_width(long __this__nativeId);

    @QtBlockedSlot public final int widthMM() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_widthMM(nativeId());
    }
    private native static int __qt_widthMM(long __this__nativeId);

    @QtBlockedSlot public final long winId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_winId(nativeId());
    }
    private native static long __qt_winId(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget window() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_window(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_window(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.WindowFlags windowFlags() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.WindowFlags(__qt_windowFlags(nativeId()));
    }
    private native static int __qt_windowFlags(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowIcon")
    @com.trolltech.qt.QtPropertyOrder(42)
    @com.trolltech.qt.QtPropertyDesignable("isWindow")
    @QtBlockedSlot public final com.trolltech.qt.gui.QIcon windowIcon() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowIcon(nativeId());
    }
    private native static com.trolltech.qt.gui.QIcon __qt_windowIcon(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowIconText")
    @com.trolltech.qt.QtPropertyOrder(43)
    @com.trolltech.qt.QtPropertyDesignable("isWindow")
    @QtBlockedSlot public final java.lang.String windowIconText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowIconText(nativeId());
    }
    private native static java.lang.String __qt_windowIconText(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowModality")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.WindowModality windowModality() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.WindowModality.resolve(__qt_windowModality(nativeId()));
    }
    private native static int __qt_windowModality(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowOpacity")
    @com.trolltech.qt.QtPropertyOrder(44)
    @com.trolltech.qt.QtPropertyDesignable("isWindow")
    @QtBlockedSlot public final double windowOpacity() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowOpacity(nativeId());
    }
    private native static double __qt_windowOpacity(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String windowRole() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowRole(nativeId());
    }
    private native static java.lang.String __qt_windowRole(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.WindowStates windowState() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.WindowStates(__qt_windowState(nativeId()));
    }
    private native static int __qt_windowState(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="windowTitle")
    @com.trolltech.qt.QtPropertyOrder(41)
    @com.trolltech.qt.QtPropertyDesignable("isWindow")
    @QtBlockedSlot public final java.lang.String windowTitle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowTitle(nativeId());
    }
    private native static java.lang.String __qt_windowTitle(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.Qt.WindowType windowType() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.WindowType.resolve(__qt_windowType(nativeId()));
    }
    private native static int __qt_windowType(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="x")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final int x() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_x(nativeId());
    }
    private native static int __qt_x(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="y")
    @com.trolltech.qt.QtPropertyOrder(7)
    @QtBlockedSlot public final int y() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_y(nativeId());
    }
    private native static int __qt_y(long __this__nativeId);

    @QtBlockedSlot protected void actionEvent(com.trolltech.qt.gui.QActionEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_actionEvent_QActionEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_actionEvent_QActionEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void contextMenuEvent(com.trolltech.qt.gui.QContextMenuEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_contextMenuEvent_QContextMenuEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_contextMenuEvent_QContextMenuEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public int devType() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_devType(nativeId());
    }
    private native static int __qt_devType(long __this__nativeId);

    @QtBlockedSlot protected void dragEnterEvent(com.trolltech.qt.gui.QDragEnterEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragEnterEvent_QDragEnterEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_dragEnterEvent_QDragEnterEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void dragLeaveEvent(com.trolltech.qt.gui.QDragLeaveEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragLeaveEvent_QDragLeaveEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_dragLeaveEvent_QDragLeaveEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void dragMoveEvent(com.trolltech.qt.gui.QDragMoveEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dragMoveEvent_QDragMoveEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_dragMoveEvent_QDragMoveEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void dropEvent(com.trolltech.qt.gui.QDropEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dropEvent_QDropEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_dropEvent_QDropEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void enterEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_enterEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_enterEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void focusInEvent(com.trolltech.qt.gui.QFocusEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusInEvent_QFocusEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_focusInEvent_QFocusEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected boolean focusNextPrevChild(boolean next) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_focusNextPrevChild_boolean(nativeId(), next);
    }
    private native static boolean __qt_focusNextPrevChild_boolean(long __this__nativeId, boolean next);

    @QtBlockedSlot protected void focusOutEvent(com.trolltech.qt.gui.QFocusEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_focusOutEvent_QFocusEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_focusOutEvent_QFocusEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public int heightForWidth(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_heightForWidth_int(nativeId(), arg__1);
    }
    private native static int __qt_heightForWidth_int(long __this__nativeId, int arg__1);

    @QtBlockedSlot protected void hideEvent(com.trolltech.qt.gui.QHideEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideEvent_QHideEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_hideEvent_QHideEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void inputMethodEvent(com.trolltech.qt.gui.QInputMethodEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_inputMethodEvent_QInputMethodEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_inputMethodEvent_QInputMethodEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public java.lang.Object inputMethodQuery(com.trolltech.qt.core.Qt.InputMethodQuery arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_inputMethodQuery_InputMethodQuery(nativeId(), arg__1.value());
    }
    private native static java.lang.Object __qt_inputMethodQuery_InputMethodQuery(long __this__nativeId, int arg__1);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void keyReleaseEvent(com.trolltech.qt.gui.QKeyEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyReleaseEvent_QKeyEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_keyReleaseEvent_QKeyEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void languageChange() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_languageChange(nativeId());
    }
    private native static void __qt_languageChange(long __this__nativeId);

    @QtBlockedSlot protected void leaveEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_leaveEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_leaveEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public int metric(com.trolltech.qt.gui.QPaintDevice.PaintDeviceMetric arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_metric_PaintDeviceMetric(nativeId(), arg__1.value());
    }
    private native static int __qt_metric_PaintDeviceMetric(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyReader(name="minimumSizeHint")
    @com.trolltech.qt.QtPropertyOrder(39)
    @QtBlockedSlot public com.trolltech.qt.core.QSize minimumSizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minimumSizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_minimumSizeHint(long __this__nativeId);

    @QtBlockedSlot protected void mouseDoubleClickEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseDoubleClickEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseDoubleClickEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mouseMoveEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseMoveEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseMoveEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mousePressEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mousePressEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mousePressEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void mouseReleaseEvent(com.trolltech.qt.gui.QMouseEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_mouseReleaseEvent_QMouseEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_mouseReleaseEvent_QMouseEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void moveEvent(com.trolltech.qt.gui.QMoveEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_moveEvent_QMoveEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_moveEvent_QMoveEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public com.trolltech.qt.gui.QPaintEngine paintEngine() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_paintEngine(nativeId());
    }
    private native static com.trolltech.qt.gui.QPaintEngine __qt_paintEngine(long __this__nativeId);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="visible")
    public void setVisible(boolean visible) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setVisible_boolean(nativeId(), visible);
    }
    private native static void __qt_setVisible_boolean(long __this__nativeId, boolean visible);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long arg__1);

    @com.trolltech.qt.QtPropertyReader(name="sizeHint")
    @com.trolltech.qt.QtPropertyOrder(38)
    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void tabletEvent(com.trolltech.qt.gui.QTabletEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tabletEvent_QTabletEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_tabletEvent_QTabletEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long arg__1);

    public native static com.trolltech.qt.gui.QWidget keyboardGrabber();

    public native static com.trolltech.qt.gui.QWidget mouseGrabber();

    public static void setTabOrder(com.trolltech.qt.gui.QWidget arg__1, com.trolltech.qt.gui.QWidget arg__2) {
        __qt_setTabOrder_QWidget_QWidget(arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static void __qt_setTabOrder_QWidget_QWidget(long arg__1, long arg__2);


    public static native QWidget fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QWidget(QPrivateConstructor p) { super(p); } 


    @QtBlockedSlot public native long __qt_cast_to_QPaintDevice(long ptr);

        private native static void __qt_QMessageBox_setWindowTitle(long native_id, String windowTitle);
    

        private native static void __qt_QMessageBox_setWindowModality(long native_id, int modality);
    

        @QtBlockedSlot public final QContentsMargins getContentsMargins() {
            QNativePointer left = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer top = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer right = new QNativePointer(QNativePointer.Type.Int);
            QNativePointer bottom = new QNativePointer(QNativePointer.Type.Int);
            
            getContentsMargins(left, top, right, bottom);
            return new QContentsMargins(left.intValue(), top.intValue(), right.intValue(), bottom.intValue());
        }
        
        @QtBlockedSlot public final void setContentsMargins(QContentsMargins margins) {
            setContentsMargins(margins.left, margins.top, margins.right, margins.bottom);
        }        
    
}
