package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QWorkspace extends com.trolltech.qt.gui.QWidget
{
    public enum WindowOrder implements com.trolltech.qt.QtEnumerator {
        CreationOrder(0),
        StackingOrder(1);

        WindowOrder(int value) { this.value = value; }
        public int value() { return value; }

        public static WindowOrder resolve(int value) {
            return (WindowOrder) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return CreationOrder;
            case 1: return StackingOrder;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<com.trolltech.qt.gui.QWidget> windowActivated = new Signal1<com.trolltech.qt.gui.QWidget>();

    @SuppressWarnings("unused")
    private final void windowActivated(com.trolltech.qt.gui.QWidget w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_windowActivated_QWidget(nativeId(), w == null ? 0 : w.nativeId());
    }
    private native static void __qt_windowActivated_QWidget(long __this__nativeId, long w);


    public QWorkspace() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QWorkspace(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QWorkspace_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QWorkspace_QWidget(long parent);


    public final void activateNextWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activateNextWindow(nativeId());
    }
    private native static void __qt_activateNextWindow(long __this__nativeId);

    public final void activatePreviousWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_activatePreviousWindow(nativeId());
    }
    private native static void __qt_activatePreviousWindow(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget activeWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_activeWindow(nativeId());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_activeWindow(long __this__nativeId);


    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget addWindow(com.trolltech.qt.gui.QWidget w, com.trolltech.qt.core.Qt.WindowType ... flags) {
        return this.addWindow(w, new com.trolltech.qt.core.Qt.WindowFlags(flags));
    }

    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget addWindow(com.trolltech.qt.gui.QWidget w) {
        return addWindow(w, new com.trolltech.qt.core.Qt.WindowFlags(0));
    }
    @QtBlockedSlot public final com.trolltech.qt.gui.QWidget addWindow(com.trolltech.qt.gui.QWidget w, com.trolltech.qt.core.Qt.WindowFlags flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addWindow_QWidget_WindowFlags(nativeId(), w == null ? 0 : w.nativeId(), flags.value());
    }
    private native static com.trolltech.qt.gui.QWidget __qt_addWindow_QWidget_WindowFlags(long __this__nativeId, long w, int flags);

    public final void arrangeIcons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_arrangeIcons(nativeId());
    }
    private native static void __qt_arrangeIcons(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="background")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QBrush background() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_background(nativeId());
    }
    private native static com.trolltech.qt.gui.QBrush __qt_background(long __this__nativeId);

    public final void cascade() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_cascade(nativeId());
    }
    private native static void __qt_cascade(long __this__nativeId);

    public final void closeActiveWindow() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeActiveWindow(nativeId());
    }
    private native static void __qt_closeActiveWindow(long __this__nativeId);

    public final void closeAllWindows() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeAllWindows(nativeId());
    }
    private native static void __qt_closeAllWindows(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="scrollBarsEnabled")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final boolean scrollBarsEnabled() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scrollBarsEnabled(nativeId());
    }
    private native static boolean __qt_scrollBarsEnabled(long __this__nativeId);

    public final void setActiveWindow(com.trolltech.qt.gui.QWidget w) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setActiveWindow_QWidget(nativeId(), w == null ? 0 : w.nativeId());
    }
    private native static void __qt_setActiveWindow_QWidget(long __this__nativeId, long w);

    @com.trolltech.qt.QtPropertyWriter(name="background")
    @QtBlockedSlot public final void setBackground(com.trolltech.qt.gui.QBrush background) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBackground_QBrush(nativeId(), background == null ? (background = new com.trolltech.qt.gui.QBrush()).nativeId() : background.nativeId());
    }
    private native static void __qt_setBackground_QBrush(long __this__nativeId, long background);

    @com.trolltech.qt.QtPropertyWriter(name="scrollBarsEnabled")
    @QtBlockedSlot public final void setScrollBarsEnabled(boolean enable) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScrollBarsEnabled_boolean(nativeId(), enable);
    }
    private native static void __qt_setScrollBarsEnabled_boolean(long __this__nativeId, boolean enable);

    public final void tile() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_tile(nativeId());
    }
    private native static void __qt_tile(long __this__nativeId);


    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QWidget> windowList() {
        return windowList(com.trolltech.qt.gui.QWorkspace.WindowOrder.CreationOrder);
    }
    @QtBlockedSlot public final java.util.List<com.trolltech.qt.gui.QWidget> windowList(com.trolltech.qt.gui.QWorkspace.WindowOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_windowList_WindowOrder(nativeId(), order.value());
    }
    private native static java.util.List<com.trolltech.qt.gui.QWidget> __qt_windowList_WindowOrder(long __this__nativeId, int order);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void childEvent(com.trolltech.qt.core.QChildEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_childEvent_QChildEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_childEvent_QChildEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot public boolean eventFilter(com.trolltech.qt.core.QObject arg__1, com.trolltech.qt.core.QEvent arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_eventFilter_QObject_QEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId(), arg__2 == null ? 0 : arg__2.nativeId());
    }
    private native static boolean __qt_eventFilter_QObject_QEvent(long __this__nativeId, long arg__1, long arg__2);

    @QtBlockedSlot protected void hideEvent(com.trolltech.qt.gui.QHideEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hideEvent_QHideEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_hideEvent_QHideEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void paintEvent(com.trolltech.qt.gui.QPaintEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_paintEvent_QPaintEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_paintEvent_QPaintEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long arg__1);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long e);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    @QtBlockedSlot protected void wheelEvent(com.trolltech.qt.gui.QWheelEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_wheelEvent_QWheelEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_wheelEvent_QWheelEvent(long __this__nativeId, long e);


    public static native QWorkspace fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QWorkspace(QPrivateConstructor p) { super(p); } 

}
