package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QHostAddress extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum SpecialAddress implements com.trolltech.qt.QtEnumerator {
        Null(0),
        Broadcast(1),
        LocalHost(2),
        LocalHostIPv6(3),
        Any(4),
        AnyIPv6(5);

        SpecialAddress(int value) { this.value = value; }
        public int value() { return value; }

        public static SpecialAddress resolve(int value) {
            return (SpecialAddress) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Null;
            case 1: return Broadcast;
            case 2: return LocalHost;
            case 3: return LocalHostIPv6;
            case 4: return Any;
            case 5: return AnyIPv6;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public QHostAddress(java.lang.String address) {
        super((QPrivateConstructor)null);
        __qt_QHostAddress_String(address);
    }
    private native void __qt_QHostAddress_String(java.lang.String address);


    public QHostAddress(com.trolltech.qt.network.QHostAddress copy) {
        super((QPrivateConstructor)null);
        __qt_QHostAddress_QHostAddress(copy == null ? (copy = new com.trolltech.qt.network.QHostAddress()).nativeId() : copy.nativeId());
    }
    private native void __qt_QHostAddress_QHostAddress(long copy);


    public QHostAddress() {
        super((QPrivateConstructor)null);
        __qt_QHostAddress();
    }
    private native void __qt_QHostAddress();


    public QHostAddress(int ip4Addr) {
        super((QPrivateConstructor)null);
        __qt_QHostAddress_int(ip4Addr);
    }
    private native void __qt_QHostAddress_int(int ip4Addr);


    public QHostAddress(com.trolltech.qt.network.QIPv6Address ip6Addr) {
        super((QPrivateConstructor)null);
        __qt_QHostAddress_QIPv6Address(ip6Addr == null ? (ip6Addr = new com.trolltech.qt.network.QIPv6Address()).nativeId() : ip6Addr.nativeId());
    }
    private native void __qt_QHostAddress_QIPv6Address(long ip6Addr);


    public QHostAddress(com.trolltech.qt.network.QHostAddress.SpecialAddress address) {
        super((QPrivateConstructor)null);
        __qt_QHostAddress_SpecialAddress(address.value());
    }
    private native void __qt_QHostAddress_SpecialAddress(int address);


    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final void writeTo(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_writeTo_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_writeTo_QDataStream(long __this__nativeId, long arg__1);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.network.QHostAddress address) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QHostAddress(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId());
    }
    private native static boolean __qt_operator_equal_QHostAddress(long __this__nativeId, long address);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.network.QHostAddress.SpecialAddress address) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_SpecialAddress(nativeId(), address.value());
    }
    private native static boolean __qt_operator_equal_SpecialAddress(long __this__nativeId, int address);

    @QtBlockedSlot public final void readFrom(com.trolltech.qt.core.QDataStream arg__1) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readFrom_QDataStream(nativeId(), arg__1 == null ? 0 : arg__1.nativeId());
    }
    private native static void __qt_readFrom_QDataStream(long __this__nativeId, long arg__1);

    @QtBlockedSlot public final com.trolltech.qt.network.QAbstractSocket.NetworkLayerProtocol protocol() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QAbstractSocket.NetworkLayerProtocol.resolve(__qt_protocol(nativeId()));
    }
    private native static int __qt_protocol(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String scopeId() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_scopeId(nativeId());
    }
    private native static java.lang.String __qt_scopeId(long __this__nativeId);

    @QtBlockedSlot public final void setAddress(int ip4Addr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAddress_int(nativeId(), ip4Addr);
    }
    private native static void __qt_setAddress_int(long __this__nativeId, int ip4Addr);

    @QtBlockedSlot public final boolean setAddress(java.lang.String address) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setAddress_String(nativeId(), address);
    }
    private native static boolean __qt_setAddress_String(long __this__nativeId, java.lang.String address);

    @QtBlockedSlot public final void setAddress(com.trolltech.qt.network.QIPv6Address ip6Addr) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAddress_QIPv6Address(nativeId(), ip6Addr == null ? (ip6Addr = new com.trolltech.qt.network.QIPv6Address()).nativeId() : ip6Addr.nativeId());
    }
    private native static void __qt_setAddress_QIPv6Address(long __this__nativeId, long ip6Addr);

    @QtBlockedSlot public final void setScopeId(java.lang.String id) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setScopeId_String(nativeId(), id);
    }
    private native static void __qt_setScopeId_String(long __this__nativeId, java.lang.String id);

    @QtBlockedSlot public final int toIPv4Address() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toIPv4Address(nativeId());
    }
    private native static int __qt_toIPv4Address(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QIPv6Address toIPv6Address() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toIPv6Address(nativeId());
    }
    private native static com.trolltech.qt.network.QIPv6Address __qt_toIPv6Address(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String toString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString(nativeId());
    }
    private native static java.lang.String __qt_toString(long __this__nativeId);


    public static native QHostAddress fromNativePointer(QNativePointer nativePointer);

    protected QHostAddress(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QHostAddress array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.network.QHostAddress)
            return operator_equal((com.trolltech.qt.network.QHostAddress) other);
        else if (other instanceof com.trolltech.qt.network.QHostAddress.SpecialAddress)
            return operator_equal((com.trolltech.qt.network.QHostAddress.SpecialAddress) other);
        return false;
    }


    public int hashCode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hashCode(nativeId());
    }
    private static native int __qt_hashCode(long __this_nativeId);

}
