package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QHttp extends com.trolltech.qt.core.QObject
{
    @SuppressWarnings("unused") private Object __rcSocket = null;
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum Error implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        UnknownError(1),
        HostNotFound(2),
        ConnectionRefused(3),
        UnexpectedClose(4),
        InvalidResponseHeader(5),
        WrongContentLength(6),
        Aborted(7),
        AuthenticationRequiredError(8),
        ProxyAuthenticationRequiredError(9);

        Error(int value) { this.value = value; }
        public int value() { return value; }

        public static Error resolve(int value) {
            return (Error) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return UnknownError;
            case 2: return HostNotFound;
            case 3: return ConnectionRefused;
            case 4: return UnexpectedClose;
            case 5: return InvalidResponseHeader;
            case 6: return WrongContentLength;
            case 7: return Aborted;
            case 8: return AuthenticationRequiredError;
            case 9: return ProxyAuthenticationRequiredError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum ConnectionMode implements com.trolltech.qt.QtEnumerator {
        ConnectionModeHttp(0),
        ConnectionModeHttps(1);

        ConnectionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static ConnectionMode resolve(int value) {
            return (ConnectionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ConnectionModeHttp;
            case 1: return ConnectionModeHttps;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum State implements com.trolltech.qt.QtEnumerator {
        Unconnected(0),
        HostLookup(1),
        Connecting(2),
        Sending(3),
        Reading(4),
        Connected(5),
        Closing(6);

        State(int value) { this.value = value; }
        public int value() { return value; }

        public static State resolve(int value) {
            return (State) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Unconnected;
            case 1: return HostLookup;
            case 2: return Connecting;
            case 3: return Sending;
            case 4: return Reading;
            case 5: return Connected;
            case 6: return Closing;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    private final Signal3<java.lang.String, java.lang.Character, com.trolltech.qt.QNativePointer> authenticationRequiredPrivate = new Signal3<java.lang.String, java.lang.Character, com.trolltech.qt.QNativePointer>();

    @SuppressWarnings("unused")
    private final void authenticationRequiredPrivate(java.lang.String hostname, char port, com.trolltech.qt.QNativePointer arg__3) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_authenticationRequiredPrivate_String_char_nativepointer(nativeId(), hostname, port, arg__3);
    }
    private native static void __qt_authenticationRequiredPrivate_String_char_nativepointer(long __this__nativeId, java.lang.String hostname, char port, com.trolltech.qt.QNativePointer arg__3);

    public final Signal2<java.lang.Integer, java.lang.Integer> dataReadProgress = new Signal2<java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void dataReadProgress(int arg__1, int arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataReadProgress_int_int(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_dataReadProgress_int_int(long __this__nativeId, int arg__1, int arg__2);

    public final Signal2<java.lang.Integer, java.lang.Integer> dataSendProgress = new Signal2<java.lang.Integer, java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void dataSendProgress(int arg__1, int arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_dataSendProgress_int_int(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_dataSendProgress_int_int(long __this__nativeId, int arg__1, int arg__2);

    public final Signal1<java.lang.Boolean> done = new Signal1<java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void done(boolean arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_done_boolean(nativeId(), arg__1);
    }
    private native static void __qt_done_boolean(long __this__nativeId, boolean arg__1);

    private final Signal2<com.trolltech.qt.network.QNetworkProxy, com.trolltech.qt.QNativePointer> proxyAuthenticationRequiredPrivate = new Signal2<com.trolltech.qt.network.QNetworkProxy, com.trolltech.qt.QNativePointer>();

    @SuppressWarnings("unused")
    private final void proxyAuthenticationRequiredPrivate(com.trolltech.qt.network.QNetworkProxy proxy, com.trolltech.qt.QNativePointer arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_proxyAuthenticationRequiredPrivate_QNetworkProxy_nativepointer(nativeId(), proxy == null ? (proxy = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : proxy.nativeId(), arg__2);
    }
    private native static void __qt_proxyAuthenticationRequiredPrivate_QNetworkProxy_nativepointer(long __this__nativeId, long proxy, com.trolltech.qt.QNativePointer arg__2);

    public final Signal1<com.trolltech.qt.network.QHttpResponseHeader> readyRead = new Signal1<com.trolltech.qt.network.QHttpResponseHeader>();

    @SuppressWarnings("unused")
    private final void readyRead(com.trolltech.qt.network.QHttpResponseHeader resp) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_readyRead_QHttpResponseHeader(nativeId(), resp == null ? (resp = new com.trolltech.qt.network.QHttpResponseHeader()).nativeId() : resp.nativeId());
    }
    private native static void __qt_readyRead_QHttpResponseHeader(long __this__nativeId, long resp);

    public final Signal2<java.lang.Integer, java.lang.Boolean> requestFinished = new Signal2<java.lang.Integer, java.lang.Boolean>();

    @SuppressWarnings("unused")
    private final void requestFinished(int arg__1, boolean arg__2) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_requestFinished_int_boolean(nativeId(), arg__1, arg__2);
    }
    private native static void __qt_requestFinished_int_boolean(long __this__nativeId, int arg__1, boolean arg__2);

    public final Signal1<java.lang.Integer> requestStarted = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void requestStarted(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_requestStarted_int(nativeId(), arg__1);
    }
    private native static void __qt_requestStarted_int(long __this__nativeId, int arg__1);

    public final Signal1<com.trolltech.qt.network.QHttpResponseHeader> responseHeaderReceived = new Signal1<com.trolltech.qt.network.QHttpResponseHeader>();

    @SuppressWarnings("unused")
    private final void responseHeaderReceived(com.trolltech.qt.network.QHttpResponseHeader resp) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_responseHeaderReceived_QHttpResponseHeader(nativeId(), resp == null ? (resp = new com.trolltech.qt.network.QHttpResponseHeader()).nativeId() : resp.nativeId());
    }
    private native static void __qt_responseHeaderReceived_QHttpResponseHeader(long __this__nativeId, long resp);

    public final Signal1<java.lang.Integer> stateChanged = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void stateChanged(int arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_int(nativeId(), arg__1);
    }
    private native static void __qt_stateChanged_int(long __this__nativeId, int arg__1);


    public QHttp() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QHttp(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QHttp_QObject(parent == null ? 0 : parent.nativeId());
    // TEMPLATE - QHttp.constructor.injection - START
        proxyAuthenticationRequired.connect(this, "emitProxyAuthenticationRequiredPrivate(QNetworkProxy, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    proxyAuthenticationRequiredPrivate.connect(this, "emitProxyAuthenticationRequired(QNetworkProxy,QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequired.connect(this, "emitAuthenticationRequiredPrivate(String, int, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequiredPrivate.connect(this, "emitAuthenticationRequired(String, char, QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    // TEMPLATE - QHttp.constructor.injection - END

    }
    private native void __qt_QHttp_QObject(long parent);



    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname, char port) {
        this(hostname, port, (com.trolltech.qt.core.QObject)null);
    }

    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname) {
        this(hostname, (char)80, (com.trolltech.qt.core.QObject)null);
    }
    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname, char port, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QHttp_String_char_QObject(hostname, port, parent == null ? 0 : parent.nativeId());
    // TEMPLATE - QHttp.constructor.injection - START
        proxyAuthenticationRequired.connect(this, "emitProxyAuthenticationRequiredPrivate(QNetworkProxy, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    proxyAuthenticationRequiredPrivate.connect(this, "emitProxyAuthenticationRequired(QNetworkProxy,QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequired.connect(this, "emitAuthenticationRequiredPrivate(String, int, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequiredPrivate.connect(this, "emitAuthenticationRequired(String, char, QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    // TEMPLATE - QHttp.constructor.injection - END

    }
    private native void __qt_QHttp_String_char_QObject(java.lang.String hostname, char port, long parent);



    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname, com.trolltech.qt.network.QHttp.ConnectionMode mode, char port) {
        this(hostname, mode, port, (com.trolltech.qt.core.QObject)null);
    }

    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname, com.trolltech.qt.network.QHttp.ConnectionMode mode) {
        this(hostname, mode, (char)0, (com.trolltech.qt.core.QObject)null);
    }
    @SuppressWarnings("unused")
    private QHttp(java.lang.String hostname, com.trolltech.qt.network.QHttp.ConnectionMode mode, char port, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QHttp_String_ConnectionMode_char_QObject(hostname, mode.value(), port, parent == null ? 0 : parent.nativeId());
    // TEMPLATE - QHttp.constructor.injection - START
        proxyAuthenticationRequired.connect(this, "emitProxyAuthenticationRequiredPrivate(QNetworkProxy, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    proxyAuthenticationRequiredPrivate.connect(this, "emitProxyAuthenticationRequired(QNetworkProxy,QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequired.connect(this, "emitAuthenticationRequiredPrivate(String, int, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    authenticationRequiredPrivate.connect(this, "emitAuthenticationRequired(String, char, QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    // TEMPLATE - QHttp.constructor.injection - END

    }
    private native void __qt_QHttp_String_ConnectionMode_char_QObject(java.lang.String hostname, int mode, char port, long parent);


    public final void abort() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_abort(nativeId());
    }
    private native static void __qt_abort(long __this__nativeId);

    @QtBlockedSlot public final long bytesAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesAvailable(nativeId());
    }
    private native static long __qt_bytesAvailable(long __this__nativeId);

    @QtBlockedSlot public final void clearPendingRequests() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clearPendingRequests(nativeId());
    }
    private native static void __qt_clearPendingRequests(long __this__nativeId);

    @QtBlockedSlot public final int close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_close(nativeId());
    }
    private native static int __qt_close(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice currentDestinationDevice() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentDestinationDevice(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_currentDestinationDevice(long __this__nativeId);

    @QtBlockedSlot public final int currentId() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentId(nativeId());
    }
    private native static int __qt_currentId(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHttpRequestHeader currentRequest() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentRequest(nativeId());
    }
    private native static com.trolltech.qt.network.QHttpRequestHeader __qt_currentRequest(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.core.QIODevice currentSourceDevice() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_currentSourceDevice(nativeId());
    }
    private native static com.trolltech.qt.core.QIODevice __qt_currentSourceDevice(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHttp.Error error() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QHttp.Error.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String errorString() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_errorString(nativeId());
    }
    private native static java.lang.String __qt_errorString(long __this__nativeId);


    @QtBlockedSlot public final int get(java.lang.String path) {
        return get(path, (com.trolltech.qt.core.QIODevice)null);
    }
    @QtBlockedSlot public final int get(java.lang.String path, com.trolltech.qt.core.QIODevice to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_get_String_QIODevice(nativeId(), path, to == null ? 0 : to.nativeId());
    }
    private native static int __qt_get_String_QIODevice(long __this__nativeId, java.lang.String path, long to);

    @QtBlockedSlot public final boolean hasPendingRequests() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasPendingRequests(nativeId());
    }
    private native static boolean __qt_hasPendingRequests(long __this__nativeId);

    @QtBlockedSlot public final int head(java.lang.String path) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_head_String(nativeId(), path);
    }
    private native static int __qt_head_String(long __this__nativeId, java.lang.String path);

    public final void ignoreSslErrors() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_ignoreSslErrors(nativeId());
    }
    private native static void __qt_ignoreSslErrors(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHttpResponseHeader lastResponse() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastResponse(nativeId());
    }
    private native static com.trolltech.qt.network.QHttpResponseHeader __qt_lastResponse(long __this__nativeId);


    @QtBlockedSlot public final int post(java.lang.String path, com.trolltech.qt.core.QByteArray data) {
        return post(path, data, (com.trolltech.qt.core.QIODevice)null);
    }
    @QtBlockedSlot public final int post(java.lang.String path, com.trolltech.qt.core.QByteArray data, com.trolltech.qt.core.QIODevice to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_post_String_QByteArray_QIODevice(nativeId(), path, data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), to == null ? 0 : to.nativeId());
    }
    private native static int __qt_post_String_QByteArray_QIODevice(long __this__nativeId, java.lang.String path, long data, long to);


    @QtBlockedSlot public final int post(java.lang.String path, com.trolltech.qt.core.QIODevice data) {
        return post(path, data, (com.trolltech.qt.core.QIODevice)null);
    }
    @QtBlockedSlot public final int post(java.lang.String path, com.trolltech.qt.core.QIODevice data, com.trolltech.qt.core.QIODevice to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_post_String_QIODevice_QIODevice(nativeId(), path, data == null ? 0 : data.nativeId(), to == null ? 0 : to.nativeId());
    }
    private native static int __qt_post_String_QIODevice_QIODevice(long __this__nativeId, java.lang.String path, long data, long to);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long read(com.trolltech.qt.QNativePointer data, long maxlen) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_read_nativepointer_long(nativeId(), data, maxlen);
    }
    private native static long __qt_read_nativepointer_long(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen);

    @QtBlockedSlot public final com.trolltech.qt.core.QByteArray readAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readAll(nativeId());
    }
    private native static com.trolltech.qt.core.QByteArray __qt_readAll(long __this__nativeId);


    @QtBlockedSlot public final int request(com.trolltech.qt.network.QHttpRequestHeader header, com.trolltech.qt.core.QByteArray data) {
        return request(header, data, (com.trolltech.qt.core.QIODevice)null);
    }
    @QtBlockedSlot public final int request(com.trolltech.qt.network.QHttpRequestHeader header, com.trolltech.qt.core.QByteArray data, com.trolltech.qt.core.QIODevice to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_request_QHttpRequestHeader_QByteArray_QIODevice(nativeId(), header == null ? (header = new com.trolltech.qt.network.QHttpRequestHeader()).nativeId() : header.nativeId(), data == null ? (data = new com.trolltech.qt.core.QByteArray()).nativeId() : data.nativeId(), to == null ? 0 : to.nativeId());
    }
    private native static int __qt_request_QHttpRequestHeader_QByteArray_QIODevice(long __this__nativeId, long header, long data, long to);


    @QtBlockedSlot public final int request(com.trolltech.qt.network.QHttpRequestHeader header, com.trolltech.qt.core.QIODevice device) {
        return request(header, device, (com.trolltech.qt.core.QIODevice)null);
    }

    @QtBlockedSlot public final int request(com.trolltech.qt.network.QHttpRequestHeader header) {
        return request(header, (com.trolltech.qt.core.QIODevice)null, (com.trolltech.qt.core.QIODevice)null);
    }
    @QtBlockedSlot public final int request(com.trolltech.qt.network.QHttpRequestHeader header, com.trolltech.qt.core.QIODevice device, com.trolltech.qt.core.QIODevice to) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_request_QHttpRequestHeader_QIODevice_QIODevice(nativeId(), header == null ? (header = new com.trolltech.qt.network.QHttpRequestHeader()).nativeId() : header.nativeId(), device == null ? 0 : device.nativeId(), to == null ? 0 : to.nativeId());
    }
    private native static int __qt_request_QHttpRequestHeader_QIODevice_QIODevice(long __this__nativeId, long header, long device, long to);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final int setHost(java.lang.String hostname) {
        return setHost(hostname, (char)80);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final int setHost(java.lang.String hostname, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setHost_String_char(nativeId(), hostname, port);
    }
    private native static int __qt_setHost_String_char(long __this__nativeId, java.lang.String hostname, char port);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final int setHost(java.lang.String hostname, com.trolltech.qt.network.QHttp.ConnectionMode mode) {
        return setHost(hostname, mode, (char)0);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final int setHost(java.lang.String hostname, com.trolltech.qt.network.QHttp.ConnectionMode mode, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setHost_String_ConnectionMode_char(nativeId(), hostname, mode.value(), port);
    }
    private native static int __qt_setHost_String_ConnectionMode_char(long __this__nativeId, java.lang.String hostname, int mode, char port);


    @QtBlockedSlot public final int setProxy(java.lang.String host, int port, java.lang.String username) {
        return setProxy(host, port, username, (java.lang.String)"");
    }

    @QtBlockedSlot public final int setProxy(java.lang.String host, int port) {
        return setProxy(host, port, (java.lang.String)"", (java.lang.String)"");
    }
    @QtBlockedSlot public final int setProxy(java.lang.String host, int port, java.lang.String username, java.lang.String password) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setProxy_String_int_String_String(nativeId(), host, port, username, password);
    }
    private native static int __qt_setProxy_String_int_String_String(long __this__nativeId, java.lang.String host, int port, java.lang.String username, java.lang.String password);

    @QtBlockedSlot public final int setProxy(com.trolltech.qt.network.QNetworkProxy proxy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setProxy_QNetworkProxy(nativeId(), proxy == null ? (proxy = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : proxy.nativeId());
    }
    private native static int __qt_setProxy_QNetworkProxy(long __this__nativeId, long proxy);

    @QtBlockedSlot public final int setSocket(com.trolltech.qt.network.QTcpSocket socket) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        {
            __rcSocket = socket;
        }
        return __qt_setSocket_QTcpSocket(nativeId(), socket == null ? 0 : socket.nativeId());
    }
    private native static int __qt_setSocket_QTcpSocket(long __this__nativeId, long socket);


    @QtBlockedSlot public final int setUser(java.lang.String username) {
        return setUser(username, (java.lang.String)"");
    }
    @QtBlockedSlot public final int setUser(java.lang.String username, java.lang.String password) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setUser_String_String(nativeId(), username, password);
    }
    private native static int __qt_setUser_String_String(long __this__nativeId, java.lang.String username, java.lang.String password);

    @QtBlockedSlot public final com.trolltech.qt.network.QHttp.State state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QHttp.State.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);


    public static native QHttp fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QHttp(QPrivateConstructor p) { super(p); } 


        public Signal2<QNetworkProxy, QAuthenticator> proxyAuthenticationRequired = new Signal2<QNetworkProxy, QAuthenticator>();        
        private boolean inEmission = false;
        
        @SuppressWarnings("unused")
        private void emitProxyAuthenticationRequiredPrivate(QNetworkProxy proxy, QAuthenticator authenticator) 
        {
            if (!inEmission) {           
                inEmission = true;
                proxyAuthenticationRequiredPrivate.emit(proxy, authenticator.nativePointer());
                inEmission = false;
            }
        }
        
        @SuppressWarnings("unused")
        private void emitProxyAuthenticationRequired(QNetworkProxy proxy, QNativePointer authenticator) 
        {
            if (!inEmission) {
                inEmission = true;
                proxyAuthenticationRequired.emit(proxy, QAuthenticator.fromNativePointer(authenticator));
                inEmission = false;
            }
        }
    

        public Signal3<String, Integer, QAuthenticator> authenticationRequired = new Signal3<String, Integer, QAuthenticator>();
        private boolean inEmissionAuthenticationRequired = false;
        
        @SuppressWarnings("unused")
        private void emitAuthenticationRequiredPrivate(String hostName, int port, QAuthenticator authenticator) {
            if (!inEmissionAuthenticationRequired) {
                inEmissionAuthenticationRequired = true;
                authenticationRequiredPrivate.emit(hostName, (char) port, authenticator.nativePointer());
                inEmissionAuthenticationRequired = false;
            }                        
        }
        
        @SuppressWarnings("unused")
        private void emitAuthenticationRequired(String hostName, char port, QNativePointer authenticator) {
            if (!inEmissionAuthenticationRequired) {
                inEmissionAuthenticationRequired = true;
                authenticationRequired.emit(hostName, (int) port, QAuthenticator.fromNativePointer(authenticator));
                inEmissionAuthenticationRequired = false;
            }
        }
    

        // TEMPLATE - network.read_char*_long_long - START
        public final int read(byte data[]) {
            if (data.length == 0) return 0;
            
            com.trolltech.qt.QNativePointer np = new com.trolltech.qt.QNativePointer(com.trolltech.qt.QNativePointer.Type.Byte, data.length);
            int len = (int) read(np, data.length);
            for (int i=0; i<len; ++i) data[i] = np.byteAt(i);
            
            return len;
        }      
  // TEMPLATE - network.read_char*_long_long - END
    

    public QHttp(String hostname, int port) { 
        this(hostname, (char) port); 
    }
    public QHttp(String hostname, int port, com.trolltech.qt.core.QObject parent) { 
        this(hostname, (char) port, parent); 
    }
    public QHttp(String hostname, QHttp.ConnectionMode mode, int port) {
        this(hostname, mode, (char) port);
    }
    public QHttp(String hostname, QHttp.ConnectionMode mode, int port, com.trolltech.qt.core.QObject parent) {
	this(hostname, mode, (char) port, parent);
    }
    public final int setHost(String hostname, QHttp.ConnectionMode mode, int port) {
        return setHost(hostname, mode, (char) port);
    }
    public final int setHost(String hostname, int port) {
        return setHost(hostname, (char) port);
    }
    
}
