package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QHttpResponseHeader extends com.trolltech.qt.network.QHttpHeader
{

    public QHttpResponseHeader(int code, java.lang.String text, int majorVer) {
        this(code, text, majorVer, (int)1);
    }

    public QHttpResponseHeader(int code, java.lang.String text) {
        this(code, text, (int)1, (int)1);
    }

    public QHttpResponseHeader(int code) {
        this(code, (java.lang.String)"", (int)1, (int)1);
    }
    public QHttpResponseHeader(int code, java.lang.String text, int majorVer, int minorVer) {
        super((QPrivateConstructor)null);
        __qt_QHttpResponseHeader_int_String_int_int(code, text, majorVer, minorVer);
    }
    private native void __qt_QHttpResponseHeader_int_String_int_int(int code, java.lang.String text, int majorVer, int minorVer);


    public QHttpResponseHeader(java.lang.String str) {
        super((QPrivateConstructor)null);
        __qt_QHttpResponseHeader_String(str);
    }
    private native void __qt_QHttpResponseHeader_String(java.lang.String str);


    public QHttpResponseHeader(com.trolltech.qt.network.QHttpResponseHeader header) {
        super((QPrivateConstructor)null);
        __qt_QHttpResponseHeader_QHttpResponseHeader(header == null ? (header = new com.trolltech.qt.network.QHttpResponseHeader()).nativeId() : header.nativeId());
    }
    private native void __qt_QHttpResponseHeader_QHttpResponseHeader(long header);


    public QHttpResponseHeader() {
        super((QPrivateConstructor)null);
        __qt_QHttpResponseHeader();
    }
    private native void __qt_QHttpResponseHeader();


    @QtBlockedSlot public final java.lang.String reasonPhrase() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_reasonPhrase(nativeId());
    }
    private native static java.lang.String __qt_reasonPhrase(long __this__nativeId);


    @QtBlockedSlot public final void setStatusLine(int code, java.lang.String text, int majorVer) {
        setStatusLine(code, text, majorVer, (int)1);
    }

    @QtBlockedSlot public final void setStatusLine(int code, java.lang.String text) {
        setStatusLine(code, text, (int)1, (int)1);
    }

    @QtBlockedSlot public final void setStatusLine(int code) {
        setStatusLine(code, (java.lang.String)"", (int)1, (int)1);
    }
    @QtBlockedSlot public final void setStatusLine(int code, java.lang.String text, int majorVer, int minorVer) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStatusLine_int_String_int_int(nativeId(), code, text, majorVer, minorVer);
    }
    private native static void __qt_setStatusLine_int_String_int_int(long __this__nativeId, int code, java.lang.String text, int majorVer, int minorVer);

    @QtBlockedSlot public final int statusCode() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_statusCode(nativeId());
    }
    private native static int __qt_statusCode(long __this__nativeId);

    @QtBlockedSlot public int majorVersion() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_majorVersion(nativeId());
    }
    private native static int __qt_majorVersion(long __this__nativeId);

    @QtBlockedSlot public int minorVersion() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_minorVersion(nativeId());
    }
    private native static int __qt_minorVersion(long __this__nativeId);

    @QtBlockedSlot protected boolean parseLine(java.lang.String line, int number) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_parseLine_String_int(nativeId(), line, number);
    }
    private native static boolean __qt_parseLine_String_int(long __this__nativeId, java.lang.String line, int number);

    @QtBlockedSlot public java.lang.String toString() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_toString(nativeId());
    }
    private native static java.lang.String __qt_toString(long __this__nativeId);


    public static native QHttpResponseHeader fromNativePointer(QNativePointer nativePointer);

    protected QHttpResponseHeader(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QHttpResponseHeader array[]);
}
