package com.trolltech.qt.network;

import com.trolltech.qt.*;

import com.trolltech.qt.QNativePointer;

@QtJambiGeneratedClass
public class QUdpSocket extends com.trolltech.qt.network.QAbstractSocket
{
    public enum BindFlag implements com.trolltech.qt.QtEnumerator {
        DefaultForPlatform(0),
        ShareAddress(1),
        DontShareAddress(2),
        ReuseAddressHint(4);

        BindFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static BindMode createQFlags(BindFlag ... values) {
            return new BindMode(values);
        }
        public static BindFlag resolve(int value) {
            return (BindFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return DefaultForPlatform;
            case 1: return ShareAddress;
            case 2: return DontShareAddress;
            case 4: return ReuseAddressHint;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class BindMode extends com.trolltech.qt.QFlags<BindFlag> {
        private static final long serialVersionUID = 1L;
        public BindMode(BindFlag ... args) { super(args); }
        public BindMode(int value) { setValue(value); }
    }



    public QUdpSocket() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QUdpSocket(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QUdpSocket_QObject(parent == null ? 0 : parent.nativeId());
    proxyAuthenticationRequired.connect(this, "emitProxyAuthenticationRequiredPrivate(QNetworkProxy, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    AbstractSignal sig = (AbstractSignal) QtJambiInternal.fetchField(this, QAbstractSocket.class, "proxyAuthenticationRequiredPrivate");
    sig.connect(this, "emitProxyAuthenticationRequired(QNetworkProxy,QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);

    }
    private native void __qt_QUdpSocket_QObject(long parent);



    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private() {
        return bind_private((char)0);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bind_private_char(nativeId(), port);
    }
    private native static boolean __qt_bind_private_char(long __this__nativeId, char port);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(com.trolltech.qt.network.QHostAddress address, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bind_private_QHostAddress_char(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId(), port);
    }
    private native static boolean __qt_bind_private_QHostAddress_char(long __this__nativeId, long address, char port);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(com.trolltech.qt.network.QHostAddress address, char port, com.trolltech.qt.network.QUdpSocket.BindFlag ... mode) {
        return this.bind_private(address, port, new com.trolltech.qt.network.QUdpSocket.BindMode(mode));
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(com.trolltech.qt.network.QHostAddress address, char port, com.trolltech.qt.network.QUdpSocket.BindMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bind_private_QHostAddress_char_BindMode(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId(), port, mode.value());
    }
    private native static boolean __qt_bind_private_QHostAddress_char_BindMode(long __this__nativeId, long address, char port, int mode);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(char port, com.trolltech.qt.network.QUdpSocket.BindFlag ... mode) {
        return this.bind_private(port, new com.trolltech.qt.network.QUdpSocket.BindMode(mode));
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean bind_private(char port, com.trolltech.qt.network.QUdpSocket.BindMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bind_private_char_BindMode(nativeId(), port, mode.value());
    }
    private native static boolean __qt_bind_private_char_BindMode(long __this__nativeId, char port, int mode);

    @QtBlockedSlot public final boolean hasPendingDatagrams() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasPendingDatagrams(nativeId());
    }
    private native static boolean __qt_hasPendingDatagrams(long __this__nativeId);

    @QtBlockedSlot public final long pendingDatagramSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pendingDatagramSize(nativeId());
    }
    private native static long __qt_pendingDatagramSize(long __this__nativeId);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final long readDatagram(com.trolltech.qt.QNativePointer data, long maxlen, com.trolltech.qt.QNativePointer host) {
        return readDatagram(data, maxlen, host, (com.trolltech.qt.QNativePointer)null);
    }

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long readDatagram(com.trolltech.qt.QNativePointer data, long maxlen) {
        return readDatagram(data, maxlen, (com.trolltech.qt.QNativePointer)null, (com.trolltech.qt.QNativePointer)null);
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final long readDatagram(com.trolltech.qt.QNativePointer data, long maxlen, com.trolltech.qt.QNativePointer host, com.trolltech.qt.QNativePointer port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readDatagram_nativepointer_long_nativepointer_nativepointer(nativeId(), data, maxlen, host, port);
    }
    private native static long __qt_readDatagram_nativepointer_long_nativepointer_nativepointer(long __this__nativeId, com.trolltech.qt.QNativePointer data, long maxlen, com.trolltech.qt.QNativePointer host, com.trolltech.qt.QNativePointer port);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long writeDatagram(com.trolltech.qt.core.QByteArray datagram, com.trolltech.qt.network.QHostAddress host, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeDatagram_QByteArray_QHostAddress_char(nativeId(), datagram == null ? (datagram = new com.trolltech.qt.core.QByteArray()).nativeId() : datagram.nativeId(), host == null ? (host = new com.trolltech.qt.network.QHostAddress()).nativeId() : host.nativeId(), port);
    }
    private native static long __qt_writeDatagram_QByteArray_QHostAddress_char(long __this__nativeId, long datagram, long host, char port);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final long writeDatagram(com.trolltech.qt.QNativePointer data, long len, com.trolltech.qt.network.QHostAddress host, char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeDatagram_nativepointer_long_QHostAddress_char(nativeId(), data, len, host == null ? (host = new com.trolltech.qt.network.QHostAddress()).nativeId() : host.nativeId(), port);
    }
    private native static long __qt_writeDatagram_nativepointer_long_QHostAddress_char(long __this__nativeId, com.trolltech.qt.QNativePointer data, long len, long host, char port);


    public static native QUdpSocket fromNativePointer(QNativePointer nativePointer);

    protected QUdpSocket(QPrivateConstructor p) { super(p); } 


      public final boolean bind(QHostAddress address, int port) { 
          return bind_private(address, (char) port); 
      }
      public final boolean bind(int port) { 
          return bind_private((char) port); 
      }
      public final boolean bind(QHostAddress address, int port, BindMode mode) {
          return bind_private(address, (char) port, mode);
      }
      public final boolean bind(int port, BindMode mode) {
          return bind_private((char) port, mode);
      }
    

        public static class HostInfo {
            public HostInfo() {
                address = new QHostAddress();
                port = 0;
            }
            public QHostAddress address;
            public int port;
        }
        public final int readDatagram(byte data[], HostInfo info) {
            QNativePointer np = new QNativePointer(QNativePointer.Type.Byte, data.length);
            QNativePointer address = info != null && info.address != null ? info.address.nativePointer() : null;
            QNativePointer port = new QNativePointer(QNativePointer.Type.Char);
            
            int len = (int) readDatagram(np, data.length, address, port);
            if (info != null) info.port = port.charValue();       
            for (int i=0; i<len; ++i) data[i] = np.byteAt(i);
            
            return len;
        }
    

        public int writeDatagram(byte data[], QHostAddress address, int port) {
            QNativePointer np = com.trolltech.qt.QtJambiInternal.byteArrayToNativePointer(data);
            return (int) writeDatagram(np, data.length, address, (char) port);
        }
    

        public int writeDatagram(com.trolltech.qt.core.QByteArray data, QHostAddress address, int port) {
            return (int) writeDatagram(data, address, (char) port);
        }
    
}
