package com.trolltech.qt.opengl;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QGLFormat extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.opengl.QtJambi_LibraryInitializer.init();
    }
    public enum OpenGLVersionFlag implements com.trolltech.qt.QtEnumerator {
        OpenGL_Version_None(0),
        OpenGL_Version_1_1(1),
        OpenGL_Version_1_2(2),
        OpenGL_Version_1_3(4),
        OpenGL_Version_1_4(8),
        OpenGL_Version_1_5(16),
        OpenGL_Version_2_0(32),
        OpenGL_Version_2_1(64),
        OpenGL_ES_Common_Version_1_0(128),
        OpenGL_ES_CommonLite_Version_1_0(256),
        OpenGL_ES_Common_Version_1_1(512),
        OpenGL_ES_CommonLite_Version_1_1(1024),
        OpenGL_ES_Version_2_0(2048);

        OpenGLVersionFlag(int value) { this.value = value; }
        public int value() { return value; }

        public static OpenGLVersionFlags createQFlags(OpenGLVersionFlag ... values) {
            return new OpenGLVersionFlags(values);
        }
        public static OpenGLVersionFlag resolve(int value) {
            return (OpenGLVersionFlag) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OpenGL_Version_None;
            case 1: return OpenGL_Version_1_1;
            case 2: return OpenGL_Version_1_2;
            case 4: return OpenGL_Version_1_3;
            case 8: return OpenGL_Version_1_4;
            case 16: return OpenGL_Version_1_5;
            case 32: return OpenGL_Version_2_0;
            case 64: return OpenGL_Version_2_1;
            case 128: return OpenGL_ES_Common_Version_1_0;
            case 256: return OpenGL_ES_CommonLite_Version_1_0;
            case 512: return OpenGL_ES_Common_Version_1_1;
            case 1024: return OpenGL_ES_CommonLite_Version_1_1;
            case 2048: return OpenGL_ES_Version_2_0;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class OpenGLVersionFlags extends com.trolltech.qt.QFlags<OpenGLVersionFlag> {
        private static final long serialVersionUID = 1L;
        public OpenGLVersionFlags(OpenGLVersionFlag ... args) { super(args); }
        public OpenGLVersionFlags(int value) { setValue(value); }
    }


    public QGLFormat(com.trolltech.qt.opengl.QGLFormat other) {
        super((QPrivateConstructor)null);
        __qt_QGLFormat_QGLFormat(other == null ? (other = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : other.nativeId());
    }
    private native void __qt_QGLFormat_QGLFormat(long other);


    public QGLFormat() {
        super((QPrivateConstructor)null);
        __qt_QGLFormat();
    }
    private native void __qt_QGLFormat();



    public QGLFormat(com.trolltech.qt.opengl.QGL.FormatOptions options) {
        this(options, (int)0);
    }
    public QGLFormat(com.trolltech.qt.opengl.QGL.FormatOptions options, int plane) {
        super((QPrivateConstructor)null);
        __qt_QGLFormat_FormatOptions_int(options.value(), plane);
    }
    private native void __qt_QGLFormat_FormatOptions_int(int options, int plane);


    @QtBlockedSlot public final boolean accum() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_accum(nativeId());
    }
    private native static boolean __qt_accum(long __this__nativeId);

    @QtBlockedSlot public final int accumBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_accumBufferSize(nativeId());
    }
    private native static int __qt_accumBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean alpha() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alpha(nativeId());
    }
    private native static boolean __qt_alpha(long __this__nativeId);

    @QtBlockedSlot public final int alphaBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_alphaBufferSize(nativeId());
    }
    private native static int __qt_alphaBufferSize(long __this__nativeId);

    @QtBlockedSlot public final int blueBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_blueBufferSize(nativeId());
    }
    private native static int __qt_blueBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean depth() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depth(nativeId());
    }
    private native static boolean __qt_depth(long __this__nativeId);

    @QtBlockedSlot public final int depthBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_depthBufferSize(nativeId());
    }
    private native static int __qt_depthBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean directRendering() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_directRendering(nativeId());
    }
    private native static boolean __qt_directRendering(long __this__nativeId);

    @QtBlockedSlot public final boolean doubleBuffer() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_doubleBuffer(nativeId());
    }
    private native static boolean __qt_doubleBuffer(long __this__nativeId);

    @QtBlockedSlot public final int greenBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_greenBufferSize(nativeId());
    }
    private native static int __qt_greenBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean hasOverlay() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasOverlay(nativeId());
    }
    private native static boolean __qt_hasOverlay(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.opengl.QGLFormat arg__2) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QGLFormat(nativeId(), arg__2 == null ? (arg__2 = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : arg__2.nativeId());
    }
    private native static boolean __qt_operator_equal_QGLFormat(long __this__nativeId, long arg__2);

    @QtBlockedSlot public final int plane() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_plane(nativeId());
    }
    private native static int __qt_plane(long __this__nativeId);

    @QtBlockedSlot public final int redBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_redBufferSize(nativeId());
    }
    private native static int __qt_redBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean rgba() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rgba(nativeId());
    }
    private native static boolean __qt_rgba(long __this__nativeId);

    @QtBlockedSlot public final boolean sampleBuffers() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sampleBuffers(nativeId());
    }
    private native static boolean __qt_sampleBuffers(long __this__nativeId);

    @QtBlockedSlot public final int samples() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_samples(nativeId());
    }
    private native static int __qt_samples(long __this__nativeId);

    @QtBlockedSlot public final void setAccum(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAccum_boolean(nativeId(), enable);
    }
    private native static void __qt_setAccum_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setAccumBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAccumBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setAccumBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setAlpha(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlpha_boolean(nativeId(), enable);
    }
    private native static void __qt_setAlpha_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setAlphaBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAlphaBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setAlphaBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setBlueBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setBlueBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setBlueBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setDepth(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDepth_boolean(nativeId(), enable);
    }
    private native static void __qt_setDepth_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setDepthBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDepthBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setDepthBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setDirectRendering(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDirectRendering_boolean(nativeId(), enable);
    }
    private native static void __qt_setDirectRendering_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setDoubleBuffer(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDoubleBuffer_boolean(nativeId(), enable);
    }
    private native static void __qt_setDoubleBuffer_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setGreenBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGreenBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setGreenBufferSize_int(long __this__nativeId, int size);


    @QtBlockedSlot public final void setOption(com.trolltech.qt.opengl.QGL.FormatOption ... opt) {
        this.setOption(new com.trolltech.qt.opengl.QGL.FormatOptions(opt));
    }
    @QtBlockedSlot public final void setOption(com.trolltech.qt.opengl.QGL.FormatOptions opt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOption_FormatOptions(nativeId(), opt.value());
    }
    private native static void __qt_setOption_FormatOptions(long __this__nativeId, int opt);

    @QtBlockedSlot public final void setOverlay(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOverlay_boolean(nativeId(), enable);
    }
    private native static void __qt_setOverlay_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setPlane(int plane) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPlane_int(nativeId(), plane);
    }
    private native static void __qt_setPlane_int(long __this__nativeId, int plane);

    @QtBlockedSlot public final void setRedBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRedBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setRedBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setRgba(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRgba_boolean(nativeId(), enable);
    }
    private native static void __qt_setRgba_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setSampleBuffers(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSampleBuffers_boolean(nativeId(), enable);
    }
    private native static void __qt_setSampleBuffers_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setSamples(int numSamples) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSamples_int(nativeId(), numSamples);
    }
    private native static void __qt_setSamples_int(long __this__nativeId, int numSamples);

    @QtBlockedSlot public final void setStencil(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStencil_boolean(nativeId(), enable);
    }
    private native static void __qt_setStencil_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setStencilBufferSize(int size) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStencilBufferSize_int(nativeId(), size);
    }
    private native static void __qt_setStencilBufferSize_int(long __this__nativeId, int size);

    @QtBlockedSlot public final void setStereo(boolean enable) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStereo_boolean(nativeId(), enable);
    }
    private native static void __qt_setStereo_boolean(long __this__nativeId, boolean enable);

    @QtBlockedSlot public final void setSwapInterval(int interval) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSwapInterval_int(nativeId(), interval);
    }
    private native static void __qt_setSwapInterval_int(long __this__nativeId, int interval);

    @QtBlockedSlot public final boolean stencil() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stencil(nativeId());
    }
    private native static boolean __qt_stencil(long __this__nativeId);

    @QtBlockedSlot public final int stencilBufferSize() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stencilBufferSize(nativeId());
    }
    private native static int __qt_stencilBufferSize(long __this__nativeId);

    @QtBlockedSlot public final boolean stereo() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_stereo(nativeId());
    }
    private native static boolean __qt_stereo(long __this__nativeId);

    @QtBlockedSlot public final int swapInterval() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_swapInterval(nativeId());
    }
    private native static int __qt_swapInterval(long __this__nativeId);


    @QtBlockedSlot public final boolean testOption(com.trolltech.qt.opengl.QGL.FormatOption ... opt) {
        return this.testOption(new com.trolltech.qt.opengl.QGL.FormatOptions(opt));
    }
    @QtBlockedSlot public final boolean testOption(com.trolltech.qt.opengl.QGL.FormatOptions opt) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_testOption_FormatOptions(nativeId(), opt.value());
    }
    private native static boolean __qt_testOption_FormatOptions(long __this__nativeId, int opt);

    public native static com.trolltech.qt.opengl.QGLFormat defaultFormat();

    public native static com.trolltech.qt.opengl.QGLFormat defaultOverlayFormat();

    public native static boolean hasOpenGL();

    public native static boolean hasOpenGLOverlays();

    public static com.trolltech.qt.opengl.QGLFormat.OpenGLVersionFlags openGLVersionFlags() {
        return new com.trolltech.qt.opengl.QGLFormat.OpenGLVersionFlags(__qt_openGLVersionFlags());
    }
    private native static int __qt_openGLVersionFlags();

    public static void setDefaultFormat(com.trolltech.qt.opengl.QGLFormat f) {
        __qt_setDefaultFormat_QGLFormat(f == null ? (f = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : f.nativeId());
    }
    private native static void __qt_setDefaultFormat_QGLFormat(long f);

    public static void setDefaultOverlayFormat(com.trolltech.qt.opengl.QGLFormat f) {
        __qt_setDefaultOverlayFormat_QGLFormat(f == null ? (f = new com.trolltech.qt.opengl.QGLFormat()).nativeId() : f.nativeId());
    }
    private native static void __qt_setDefaultOverlayFormat_QGLFormat(long f);


    public static native QGLFormat fromNativePointer(QNativePointer nativePointer);

    protected QGLFormat(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QGLFormat array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.opengl.QGLFormat)
            return operator_equal((com.trolltech.qt.opengl.QGLFormat) other);
        return false;
    }

}
