package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public abstract class QSqlDriver extends com.trolltech.qt.core.QObject
{
    static {
        com.trolltech.qt.sql.QtJambi_LibraryInitializer.init();
    }
    @SuppressWarnings("unused")
    private static class ConcreteWrapper extends com.trolltech.qt.sql.QSqlDriver {
        protected ConcreteWrapper(QPrivateConstructor p) { super(p); }
        @QtBlockedSlot public void close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_close(nativeId());
        }
        @QtBlockedSlot public com.trolltech.qt.sql.QSqlResult createResult() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_createResult(nativeId());
        }
        @QtBlockedSlot public boolean hasFeature(com.trolltech.qt.sql.QSqlDriver.DriverFeature f) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_hasFeature_DriverFeature(nativeId(), f.value());
        }
        @QtBlockedSlot public boolean open(java.lang.String db, java.lang.String user, java.lang.String password, java.lang.String host, int port, java.lang.String connOpts) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_open_String_String_String_String_int_String(nativeId(), db, user, password, host, port, connOpts);
        }
    }

    public enum StatementType implements com.trolltech.qt.QtEnumerator {
        WhereStatement(0),
        SelectStatement(1),
        UpdateStatement(2),
        InsertStatement(3),
        DeleteStatement(4);

        StatementType(int value) { this.value = value; }
        public int value() { return value; }

        public static StatementType resolve(int value) {
            return (StatementType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return WhereStatement;
            case 1: return SelectStatement;
            case 2: return UpdateStatement;
            case 3: return InsertStatement;
            case 4: return DeleteStatement;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum IdentifierType implements com.trolltech.qt.QtEnumerator {
        FieldName(0),
        TableName(1);

        IdentifierType(int value) { this.value = value; }
        public int value() { return value; }

        public static IdentifierType resolve(int value) {
            return (IdentifierType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return FieldName;
            case 1: return TableName;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum DriverFeature implements com.trolltech.qt.QtEnumerator {
        Transactions(0),
        QuerySize(1),
        BLOB(2),
        Unicode(3),
        PreparedQueries(4),
        NamedPlaceholders(5),
        PositionalPlaceholders(6),
        LastInsertId(7),
        BatchOperations(8),
        SimpleLocking(9),
        LowPrecisionNumbers(10);

        DriverFeature(int value) { this.value = value; }
        public int value() { return value; }

        public static DriverFeature resolve(int value) {
            return (DriverFeature) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return Transactions;
            case 1: return QuerySize;
            case 2: return BLOB;
            case 3: return Unicode;
            case 4: return PreparedQueries;
            case 5: return NamedPlaceholders;
            case 6: return PositionalPlaceholders;
            case 7: return LastInsertId;
            case 8: return BatchOperations;
            case 9: return SimpleLocking;
            case 10: return LowPrecisionNumbers;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSqlDriver() {
        this((com.trolltech.qt.core.QObject)null);
    }
    public QSqlDriver(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QSqlDriver_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QSqlDriver_QObject(long parent);


    @QtBlockedSlot public final boolean isOpenError() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isOpenError(nativeId());
    }
    private native static boolean __qt_isOpenError(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlError lastError() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastError(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlError __qt_lastError(long __this__nativeId);

    @QtBlockedSlot public boolean beginTransaction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_beginTransaction(nativeId());
    }
    private native static boolean __qt_beginTransaction(long __this__nativeId);

    @QtBlockedSlot public abstract void close();
    private native static void __qt_close(long __this__nativeId);

    @QtBlockedSlot public boolean commitTransaction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_commitTransaction(nativeId());
    }
    private native static boolean __qt_commitTransaction(long __this__nativeId);

    @QtBlockedSlot public abstract com.trolltech.qt.sql.QSqlResult createResult();
    private native static com.trolltech.qt.sql.QSqlResult __qt_createResult(long __this__nativeId);

    @QtBlockedSlot public java.lang.String escapeIdentifier(java.lang.String identifier, com.trolltech.qt.sql.QSqlDriver.IdentifierType type) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_escapeIdentifier_String_IdentifierType(nativeId(), identifier, type.value());
    }
    private native static java.lang.String __qt_escapeIdentifier_String_IdentifierType(long __this__nativeId, java.lang.String identifier, int type);


    @QtBlockedSlot public final java.lang.String formatValue(com.trolltech.qt.sql.QSqlField field) {
        return formatValue(field, (boolean)false);
    }
    @QtBlockedSlot public java.lang.String formatValue(com.trolltech.qt.sql.QSqlField field, boolean trimStrings) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_formatValue_QSqlField_boolean(nativeId(), field == null ? 0 : field.nativeId(), trimStrings);
    }
    private native static java.lang.String __qt_formatValue_QSqlField_boolean(long __this__nativeId, long field, boolean trimStrings);

    @QtBlockedSlot public java.lang.Object handle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static java.lang.Object __qt_handle(long __this__nativeId);

    @QtBlockedSlot public abstract boolean hasFeature(com.trolltech.qt.sql.QSqlDriver.DriverFeature f);
    private native static boolean __qt_hasFeature_DriverFeature(long __this__nativeId, int f);

    @QtBlockedSlot public boolean isOpen() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isOpen(nativeId());
    }
    private native static boolean __qt_isOpen(long __this__nativeId);


    @QtBlockedSlot public final boolean open(java.lang.String db, java.lang.String user, java.lang.String password, java.lang.String host, int port) {
        return open(db, user, password, host, port, (java.lang.String)"");
    }

    @QtBlockedSlot public final boolean open(java.lang.String db, java.lang.String user, java.lang.String password, java.lang.String host) {
        return open(db, user, password, host, (int)-1, (java.lang.String)"");
    }

    @QtBlockedSlot public final boolean open(java.lang.String db, java.lang.String user, java.lang.String password) {
        return open(db, user, password, (java.lang.String)"", (int)-1, (java.lang.String)"");
    }

    @QtBlockedSlot public final boolean open(java.lang.String db, java.lang.String user) {
        return open(db, user, (java.lang.String)"", (java.lang.String)"", (int)-1, (java.lang.String)"");
    }

    @QtBlockedSlot public final boolean open(java.lang.String db) {
        return open(db, (java.lang.String)"", (java.lang.String)"", (java.lang.String)"", (int)-1, (java.lang.String)"");
    }
    @QtBlockedSlot public abstract boolean open(java.lang.String db, java.lang.String user, java.lang.String password, java.lang.String host, int port, java.lang.String connOpts);
    private native static boolean __qt_open_String_String_String_String_int_String(long __this__nativeId, java.lang.String db, java.lang.String user, java.lang.String password, java.lang.String host, int port, java.lang.String connOpts);

    @QtBlockedSlot public com.trolltech.qt.sql.QSqlIndex primaryIndex(java.lang.String tableName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_primaryIndex_String(nativeId(), tableName);
    }
    private native static com.trolltech.qt.sql.QSqlIndex __qt_primaryIndex_String(long __this__nativeId, java.lang.String tableName);

    @QtBlockedSlot public com.trolltech.qt.sql.QSqlRecord record(java.lang.String tableName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_record_String(nativeId(), tableName);
    }
    private native static com.trolltech.qt.sql.QSqlRecord __qt_record_String(long __this__nativeId, java.lang.String tableName);

    @QtBlockedSlot public boolean rollbackTransaction() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rollbackTransaction(nativeId());
    }
    private native static boolean __qt_rollbackTransaction(long __this__nativeId);

    @QtBlockedSlot protected void setLastError(com.trolltech.qt.sql.QSqlError e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLastError_QSqlError(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static void __qt_setLastError_QSqlError(long __this__nativeId, long e);

    @QtBlockedSlot protected void setOpen(boolean o) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOpen_boolean(nativeId(), o);
    }
    private native static void __qt_setOpen_boolean(long __this__nativeId, boolean o);

    @QtBlockedSlot protected void setOpenError(boolean e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setOpenError_boolean(nativeId(), e);
    }
    private native static void __qt_setOpenError_boolean(long __this__nativeId, boolean e);

    @QtBlockedSlot public java.lang.String sqlStatement(com.trolltech.qt.sql.QSqlDriver.StatementType type, java.lang.String tableName, com.trolltech.qt.sql.QSqlRecord rec, boolean preparedStatement) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sqlStatement_StatementType_String_QSqlRecord_boolean(nativeId(), type.value(), tableName, rec == null ? (rec = new com.trolltech.qt.sql.QSqlRecord()).nativeId() : rec.nativeId(), preparedStatement);
    }
    private native static java.lang.String __qt_sqlStatement_StatementType_String_QSqlRecord_boolean(long __this__nativeId, int type, java.lang.String tableName, long rec, boolean preparedStatement);

    @QtBlockedSlot public java.util.List<java.lang.String> tables(com.trolltech.qt.sql.QSql.TableType tableType) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tables_TableType(nativeId(), tableType.value());
    }
    private native static java.util.List<java.lang.String> __qt_tables_TableType(long __this__nativeId, int tableType);


    public static native QSqlDriver fromNativePointer(QNativePointer nativePointer);

    protected QSqlDriver(QPrivateConstructor p) { super(p); } 

}
