package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSqlField extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.sql.QtJambi_LibraryInitializer.init();
    }
    public enum RequiredStatus implements com.trolltech.qt.QtEnumerator {
        Unknown(-1),
        Optional(0),
        Required(1);

        RequiredStatus(int value) { this.value = value; }
        public int value() { return value; }

        public static RequiredStatus resolve(int value) {
            return (RequiredStatus) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return Unknown;
            case 0: return Optional;
            case 1: return Required;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSqlField(java.lang.String fieldName) {
        this(fieldName, (int)0);
    }

    public QSqlField() {
        this((java.lang.String)"", (int)0);
    }
    public QSqlField(java.lang.String fieldName, int type) {
        super((QPrivateConstructor)null);
        __qt_QSqlField_String_int(fieldName, type);
    }
    private native void __qt_QSqlField_String_int(java.lang.String fieldName, int type);


    public QSqlField(com.trolltech.qt.sql.QSqlField other) {
        super((QPrivateConstructor)null);
        __qt_QSqlField_QSqlField(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QSqlField_QSqlField(long other);


    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object defaultValue() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultValue(nativeId());
    }
    private native static java.lang.Object __qt_defaultValue(long __this__nativeId);

    @QtBlockedSlot public final boolean isAutoValue() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isAutoValue(nativeId());
    }
    private native static boolean __qt_isAutoValue(long __this__nativeId);

    @QtBlockedSlot public final boolean isGenerated() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isGenerated(nativeId());
    }
    private native static boolean __qt_isGenerated(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull(nativeId());
    }
    private native static boolean __qt_isNull(long __this__nativeId);

    @QtBlockedSlot public final boolean isReadOnly() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isReadOnly(nativeId());
    }
    private native static boolean __qt_isReadOnly(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final int length() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_length(nativeId());
    }
    private native static int __qt_length(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String name() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_name(nativeId());
    }
    private native static java.lang.String __qt_name(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final boolean operator_equal(com.trolltech.qt.sql.QSqlField other) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_operator_equal_QSqlField(nativeId(), other == null ? 0 : other.nativeId());
    }
    private native static boolean __qt_operator_equal_QSqlField(long __this__nativeId, long other);

    @QtBlockedSlot public final int precision() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_precision(nativeId());
    }
    private native static int __qt_precision(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlField.RequiredStatus requiredStatus() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.sql.QSqlField.RequiredStatus.resolve(__qt_requiredStatus(nativeId()));
    }
    private native static int __qt_requiredStatus(long __this__nativeId);

    @QtBlockedSlot public final void setAutoValue(boolean autoVal) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setAutoValue_boolean(nativeId(), autoVal);
    }
    private native static void __qt_setAutoValue_boolean(long __this__nativeId, boolean autoVal);

    @QtBlockedSlot public final void setDefaultValue(java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultValue_Object(nativeId(), value);
    }
    private native static void __qt_setDefaultValue_Object(long __this__nativeId, java.lang.Object value);

    @QtBlockedSlot public final void setGenerated(boolean gen) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setGenerated_boolean(nativeId(), gen);
    }
    private native static void __qt_setGenerated_boolean(long __this__nativeId, boolean gen);

    @QtBlockedSlot public final void setLength(int fieldLength) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLength_int(nativeId(), fieldLength);
    }
    private native static void __qt_setLength_int(long __this__nativeId, int fieldLength);

    @QtBlockedSlot public final void setName(java.lang.String name) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setName_String(nativeId(), name);
    }
    private native static void __qt_setName_String(long __this__nativeId, java.lang.String name);

    @QtBlockedSlot public final void setPrecision(int precision) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrecision_int(nativeId(), precision);
    }
    private native static void __qt_setPrecision_int(long __this__nativeId, int precision);

    @QtBlockedSlot public final void setReadOnly(boolean readOnly) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadOnly_boolean(nativeId(), readOnly);
    }
    private native static void __qt_setReadOnly_boolean(long __this__nativeId, boolean readOnly);

    @QtBlockedSlot public final void setRequired(boolean required) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRequired_boolean(nativeId(), required);
    }
    private native static void __qt_setRequired_boolean(long __this__nativeId, boolean required);

    @QtBlockedSlot public final void setRequiredStatus(com.trolltech.qt.sql.QSqlField.RequiredStatus status) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setRequiredStatus_RequiredStatus(nativeId(), status.value());
    }
    private native static void __qt_setRequiredStatus_RequiredStatus(long __this__nativeId, int status);

    @QtBlockedSlot public final void setSqlType(int type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSqlType_int(nativeId(), type);
    }
    private native static void __qt_setSqlType_int(long __this__nativeId, int type);

    @QtBlockedSlot public final void setType(int type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setType_int(nativeId(), type);
    }
    private native static void __qt_setType_int(long __this__nativeId, int type);

    @QtBlockedSlot public final void setValue(java.lang.Object value) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setValue_Object(nativeId(), value);
    }
    private native static void __qt_setValue_Object(long __this__nativeId, java.lang.Object value);

    @QtBlockedSlot public final int type() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_type(nativeId());
    }
    private native static int __qt_type(long __this__nativeId);

    @QtBlockedSlot public final int typeID() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_typeID(nativeId());
    }
    private native static int __qt_typeID(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object value() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value(nativeId());
    }
    private native static java.lang.Object __qt_value(long __this__nativeId);


    public static native QSqlField fromNativePointer(QNativePointer nativePointer);

    protected QSqlField(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QSqlField array[]);

    @SuppressWarnings("unchecked")
    public boolean equals(Object other) {
        if (other instanceof com.trolltech.qt.sql.QSqlField)
            return operator_equal((com.trolltech.qt.sql.QSqlField) other);
        return false;
    }

}
