package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSqlQuery extends com.trolltech.qt.QtJambiObject
{
    static {
        com.trolltech.qt.sql.QtJambi_LibraryInitializer.init();
    }
    public enum BatchExecutionMode implements com.trolltech.qt.QtEnumerator {
        ValuesAsRows(0),
        ValuesAsColumns(1);

        BatchExecutionMode(int value) { this.value = value; }
        public int value() { return value; }

        public static BatchExecutionMode resolve(int value) {
            return (BatchExecutionMode) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ValuesAsRows;
            case 1: return ValuesAsColumns;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QSqlQuery(java.lang.String query) {
        this(query, (com.trolltech.qt.sql.QSqlDatabase)new com.trolltech.qt.sql.QSqlDatabase());
    }

    public QSqlQuery() {
        this((java.lang.String)"", (com.trolltech.qt.sql.QSqlDatabase)new com.trolltech.qt.sql.QSqlDatabase());
    }
    public QSqlQuery(java.lang.String query, com.trolltech.qt.sql.QSqlDatabase db) {
        super((QPrivateConstructor)null);
        __qt_QSqlQuery_String_QSqlDatabase(query, db == null ? (db = new com.trolltech.qt.sql.QSqlDatabase()).nativeId() : db.nativeId());
    }
    private native void __qt_QSqlQuery_String_QSqlDatabase(java.lang.String query, long db);


    public QSqlQuery(com.trolltech.qt.sql.QSqlQuery other) {
        super((QPrivateConstructor)null);
        __qt_QSqlQuery_QSqlQuery(other == null ? 0 : other.nativeId());
    }
    private native void __qt_QSqlQuery_QSqlQuery(long other);


    public QSqlQuery(com.trolltech.qt.sql.QSqlResult r) {
        super((QPrivateConstructor)null);
        __qt_QSqlQuery_QSqlResult(r == null ? 0 : r.nativeId());
    }
    private native void __qt_QSqlQuery_QSqlResult(long r);


    public QSqlQuery(com.trolltech.qt.sql.QSqlDatabase db) {
        super((QPrivateConstructor)null);
        __qt_QSqlQuery_QSqlDatabase(db == null ? (db = new com.trolltech.qt.sql.QSqlDatabase()).nativeId() : db.nativeId());
    }
    private native void __qt_QSqlQuery_QSqlDatabase(long db);



    @QtBlockedSlot public final void addBindValue(java.lang.Object val, com.trolltech.qt.sql.QSql.ParamTypeFlag ... type) {
        this.addBindValue(val, new com.trolltech.qt.sql.QSql.ParamType(type));
    }

    @QtBlockedSlot public final void addBindValue(java.lang.Object val) {
        addBindValue(val, new com.trolltech.qt.sql.QSql.ParamType(1));
    }
    @QtBlockedSlot public final void addBindValue(java.lang.Object val, com.trolltech.qt.sql.QSql.ParamType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addBindValue_Object_ParamType(nativeId(), val, type.value());
    }
    private native static void __qt_addBindValue_Object_ParamType(long __this__nativeId, java.lang.Object val, int type);

    @QtBlockedSlot public final int at() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_at(nativeId());
    }
    private native static int __qt_at(long __this__nativeId);


    @QtBlockedSlot public final void bindValue(int pos, java.lang.Object val, com.trolltech.qt.sql.QSql.ParamTypeFlag ... type) {
        this.bindValue(pos, val, new com.trolltech.qt.sql.QSql.ParamType(type));
    }

    @QtBlockedSlot public final void bindValue(int pos, java.lang.Object val) {
        bindValue(pos, val, new com.trolltech.qt.sql.QSql.ParamType(1));
    }
    @QtBlockedSlot public final void bindValue(int pos, java.lang.Object val, com.trolltech.qt.sql.QSql.ParamType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_bindValue_int_Object_ParamType(nativeId(), pos, val, type.value());
    }
    private native static void __qt_bindValue_int_Object_ParamType(long __this__nativeId, int pos, java.lang.Object val, int type);


    @QtBlockedSlot public final void bindValue(java.lang.String placeholder, java.lang.Object val, com.trolltech.qt.sql.QSql.ParamTypeFlag ... type) {
        this.bindValue(placeholder, val, new com.trolltech.qt.sql.QSql.ParamType(type));
    }

    @QtBlockedSlot public final void bindValue(java.lang.String placeholder, java.lang.Object val) {
        bindValue(placeholder, val, new com.trolltech.qt.sql.QSql.ParamType(1));
    }
    @QtBlockedSlot public final void bindValue(java.lang.String placeholder, java.lang.Object val, com.trolltech.qt.sql.QSql.ParamType type) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_bindValue_String_Object_ParamType(nativeId(), placeholder, val, type.value());
    }
    private native static void __qt_bindValue_String_Object_ParamType(long __this__nativeId, java.lang.String placeholder, java.lang.Object val, int type);

    @QtBlockedSlot public final java.lang.Object boundValue(int pos) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundValue_int(nativeId(), pos);
    }
    private native static java.lang.Object __qt_boundValue_int(long __this__nativeId, int pos);

    @QtBlockedSlot public final java.lang.Object boundValue(java.lang.String placeholder) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundValue_String(nativeId(), placeholder);
    }
    private native static java.lang.Object __qt_boundValue_String(long __this__nativeId, java.lang.String placeholder);

    @QtBlockedSlot public final java.util.SortedMap<java.lang.String, java.lang.Object> boundValues() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_boundValues(nativeId());
    }
    private native static java.util.SortedMap<java.lang.String, java.lang.Object> __qt_boundValues(long __this__nativeId);

    @QtBlockedSlot public final void clear() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlDriver driver() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_driver(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlDriver __qt_driver(long __this__nativeId);

    @QtBlockedSlot public final boolean exec(java.lang.String query) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exec_String(nativeId(), query);
    }
    private native static boolean __qt_exec_String(long __this__nativeId, java.lang.String query);

    @QtBlockedSlot public final boolean exec() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exec(nativeId());
    }
    private native static boolean __qt_exec(long __this__nativeId);


    @QtBlockedSlot public final boolean execBatch() {
        return execBatch(com.trolltech.qt.sql.QSqlQuery.BatchExecutionMode.ValuesAsRows);
    }
    @QtBlockedSlot public final boolean execBatch(com.trolltech.qt.sql.QSqlQuery.BatchExecutionMode mode) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_execBatch_BatchExecutionMode(nativeId(), mode.value());
    }
    private native static boolean __qt_execBatch_BatchExecutionMode(long __this__nativeId, int mode);

    @QtBlockedSlot public final java.lang.String executedQuery() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_executedQuery(nativeId());
    }
    private native static java.lang.String __qt_executedQuery(long __this__nativeId);

    @QtBlockedSlot public final boolean first() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_first(nativeId());
    }
    private native static boolean __qt_first(long __this__nativeId);

    @QtBlockedSlot public final boolean isActive() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isActive(nativeId());
    }
    private native static boolean __qt_isActive(long __this__nativeId);

    @QtBlockedSlot public final boolean isForwardOnly() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isForwardOnly(nativeId());
    }
    private native static boolean __qt_isForwardOnly(long __this__nativeId);

    @QtBlockedSlot public final boolean isNull(int field) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isNull_int(nativeId(), field);
    }
    private native static boolean __qt_isNull_int(long __this__nativeId, int field);

    @QtBlockedSlot public final boolean isSelect() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSelect(nativeId());
    }
    private native static boolean __qt_isSelect(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final boolean last() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_last(nativeId());
    }
    private native static boolean __qt_last(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlError lastError() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastError(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlError __qt_lastError(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object lastInsertId() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastInsertId(nativeId());
    }
    private native static java.lang.Object __qt_lastInsertId(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String lastQuery() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_lastQuery(nativeId());
    }
    private native static java.lang.String __qt_lastQuery(long __this__nativeId);

    @QtBlockedSlot public final boolean next() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_next(nativeId());
    }
    private native static boolean __qt_next(long __this__nativeId);

    @QtBlockedSlot public final int numRowsAffected() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_numRowsAffected(nativeId());
    }
    private native static int __qt_numRowsAffected(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSql.NumericalPrecisionPolicy numericalPrecisionPolicy() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.sql.QSql.NumericalPrecisionPolicy.resolve(__qt_numericalPrecisionPolicy(nativeId()));
    }
    private native static int __qt_numericalPrecisionPolicy(long __this__nativeId);

    @QtBlockedSlot public final boolean prepare(java.lang.String query) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_prepare_String(nativeId(), query);
    }
    private native static boolean __qt_prepare_String(long __this__nativeId, java.lang.String query);

    @QtBlockedSlot public final boolean previous() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_previous(nativeId());
    }
    private native static boolean __qt_previous(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlRecord record() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_record(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlRecord __qt_record(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlResult result() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_result(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlResult __qt_result(long __this__nativeId);


    @QtBlockedSlot public final boolean seek(int i) {
        return seek(i, (boolean)false);
    }
    @QtBlockedSlot public final boolean seek(int i, boolean relative) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_seek_int_boolean(nativeId(), i, relative);
    }
    private native static boolean __qt_seek_int_boolean(long __this__nativeId, int i, boolean relative);

    @QtBlockedSlot public final void setForwardOnly(boolean forward) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setForwardOnly_boolean(nativeId(), forward);
    }
    private native static void __qt_setForwardOnly_boolean(long __this__nativeId, boolean forward);

    @QtBlockedSlot public final void setNumericalPrecisionPolicy(com.trolltech.qt.sql.QSql.NumericalPrecisionPolicy precisionPolicy) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setNumericalPrecisionPolicy_NumericalPrecisionPolicy(nativeId(), precisionPolicy.value());
    }
    private native static void __qt_setNumericalPrecisionPolicy_NumericalPrecisionPolicy(long __this__nativeId, int precisionPolicy);

    @QtBlockedSlot public final int size() {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static int __qt_size(long __this__nativeId);

    @QtBlockedSlot public final java.lang.Object value(int i) {
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_value_int(nativeId(), i);
    }
    private native static java.lang.Object __qt_value_int(long __this__nativeId, int i);


    public static native QSqlQuery fromNativePointer(QNativePointer nativePointer);

    protected QSqlQuery(QPrivateConstructor p) { super(p); } 


    public static native QNativePointer nativePointerArray(QSqlQuery array[]);
}
