package com.trolltech.qt.sql;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QSqlTableModel extends com.trolltech.qt.sql.QSqlQueryModel
{
    public enum EditStrategy implements com.trolltech.qt.QtEnumerator {
        OnFieldChange(0),
        OnRowChange(1),
        OnManualSubmit(2);

        EditStrategy(int value) { this.value = value; }
        public int value() { return value; }

        public static EditStrategy resolve(int value) {
            return (EditStrategy) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return OnFieldChange;
            case 1: return OnRowChange;
            case 2: return OnManualSubmit;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal1<java.lang.Integer> beforeDelete = new Signal1<java.lang.Integer>();

    @SuppressWarnings("unused")
    private final void beforeDelete(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beforeDelete_int(nativeId(), row);
    }
    private native static void __qt_beforeDelete_int(long __this__nativeId, int row);

    public final Signal1<com.trolltech.qt.sql.QSqlRecord> beforeInsert = new Signal1<com.trolltech.qt.sql.QSqlRecord>();

    @SuppressWarnings("unused")
    private final void beforeInsert(com.trolltech.qt.sql.QSqlRecord record) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beforeInsert_nativepointer(nativeId(), record);
    }
    private native static void __qt_beforeInsert_nativepointer(long __this__nativeId, com.trolltech.qt.sql.QSqlRecord record);

    public final Signal2<java.lang.Integer, com.trolltech.qt.sql.QSqlRecord> beforeUpdate = new Signal2<java.lang.Integer, com.trolltech.qt.sql.QSqlRecord>();

    @SuppressWarnings("unused")
    private final void beforeUpdate(int row, com.trolltech.qt.sql.QSqlRecord record) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_beforeUpdate_int_nativepointer(nativeId(), row, record);
    }
    private native static void __qt_beforeUpdate_int_nativepointer(long __this__nativeId, int row, com.trolltech.qt.sql.QSqlRecord record);

    public final Signal2<java.lang.Integer, com.trolltech.qt.sql.QSqlRecord> primeInsert = new Signal2<java.lang.Integer, com.trolltech.qt.sql.QSqlRecord>();

    @SuppressWarnings("unused")
    private final void primeInsert(int row, com.trolltech.qt.sql.QSqlRecord record) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_primeInsert_int_nativepointer(nativeId(), row, record);
    }
    private native static void __qt_primeInsert_int_nativepointer(long __this__nativeId, int row, com.trolltech.qt.sql.QSqlRecord record);


    public QSqlTableModel(com.trolltech.qt.core.QObject parent) {
        this(parent, (com.trolltech.qt.sql.QSqlDatabase)new com.trolltech.qt.sql.QSqlDatabase());
    }

    public QSqlTableModel() {
        this((com.trolltech.qt.core.QObject)null, (com.trolltech.qt.sql.QSqlDatabase)new com.trolltech.qt.sql.QSqlDatabase());
    }
    public QSqlTableModel(com.trolltech.qt.core.QObject parent, com.trolltech.qt.sql.QSqlDatabase db) {
        super((QPrivateConstructor)null);
        __qt_QSqlTableModel_QObject_QSqlDatabase(parent == null ? 0 : parent.nativeId(), db == null ? (db = new com.trolltech.qt.sql.QSqlDatabase()).nativeId() : db.nativeId());
    }
    private native void __qt_QSqlTableModel_QObject_QSqlDatabase(long parent, long db);


    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlDatabase database() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_database(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlDatabase __qt_database(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlTableModel.EditStrategy editStrategy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.sql.QSqlTableModel.EditStrategy.resolve(__qt_editStrategy(nativeId()));
    }
    private native static int __qt_editStrategy(long __this__nativeId);

    @QtBlockedSlot public final int fieldIndex(java.lang.String fieldName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fieldIndex_String(nativeId(), fieldName);
    }
    private native static int __qt_fieldIndex_String(long __this__nativeId, java.lang.String fieldName);

    @QtBlockedSlot public final java.lang.String filter() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_filter(nativeId());
    }
    private native static java.lang.String __qt_filter(long __this__nativeId);

    @QtBlockedSlot protected final com.trolltech.qt.core.QModelIndex indexInQuery(com.trolltech.qt.core.QModelIndex item) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_indexInQuery_QModelIndex(nativeId(), item);
    }
    private native static com.trolltech.qt.core.QModelIndex __qt_indexInQuery_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex item);

    @QtBlockedSlot public final boolean insertRecord(int row, com.trolltech.qt.sql.QSqlRecord record) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertRecord_int_QSqlRecord(nativeId(), row, record == null ? (record = new com.trolltech.qt.sql.QSqlRecord()).nativeId() : record.nativeId());
    }
    private native static boolean __qt_insertRecord_int_QSqlRecord(long __this__nativeId, int row, long record);

    @QtBlockedSlot public final boolean isDirty(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isDirty_QModelIndex(nativeId(), index);
    }
    private native static boolean __qt_isDirty_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public final com.trolltech.qt.sql.QSqlIndex primaryKey() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_primaryKey(nativeId());
    }
    private native static com.trolltech.qt.sql.QSqlIndex __qt_primaryKey(long __this__nativeId);

    public final void revertAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_revertAll(nativeId());
    }
    private native static void __qt_revertAll(long __this__nativeId);

    @QtBlockedSlot protected final void setPrimaryKey(com.trolltech.qt.sql.QSqlIndex key) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPrimaryKey_QSqlIndex(nativeId(), key == null ? 0 : key.nativeId());
    }
    private native static void __qt_setPrimaryKey_QSqlIndex(long __this__nativeId, long key);

    @QtBlockedSlot public final void setQuery(com.trolltech.qt.sql.QSqlQuery query) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setQuery_QSqlQuery(nativeId(), query == null ? 0 : query.nativeId());
    }
    private native static void __qt_setQuery_QSqlQuery(long __this__nativeId, long query);

    @QtBlockedSlot public final boolean setRecord(int row, com.trolltech.qt.sql.QSqlRecord record) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setRecord_int_QSqlRecord(nativeId(), row, record == null ? (record = new com.trolltech.qt.sql.QSqlRecord()).nativeId() : record.nativeId());
    }
    private native static boolean __qt_setRecord_int_QSqlRecord(long __this__nativeId, int row, long record);

    public final boolean submitAll() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_submitAll(nativeId());
    }
    private native static boolean __qt_submitAll(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String tableName() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_tableName(nativeId());
    }
    private native static java.lang.String __qt_tableName(long __this__nativeId);

    @QtBlockedSlot public void clear() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_clear(nativeId());
    }
    private native static void __qt_clear(long __this__nativeId);

    @QtBlockedSlot public java.lang.Object data(com.trolltech.qt.core.QModelIndex idx, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_data_QModelIndex_int(nativeId(), idx, role);
    }
    private native static java.lang.Object __qt_data_QModelIndex_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex idx, int role);

    @QtBlockedSlot protected boolean deleteRowFromTable(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_deleteRowFromTable_int(nativeId(), row);
    }
    private native static boolean __qt_deleteRowFromTable_int(long __this__nativeId, int row);

    @QtBlockedSlot public com.trolltech.qt.core.Qt.ItemFlags flags(com.trolltech.qt.core.QModelIndex index) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.Qt.ItemFlags(__qt_flags_QModelIndex(nativeId(), index));
    }
    private native static int __qt_flags_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex index);

    @QtBlockedSlot public java.lang.Object headerData(int section, com.trolltech.qt.core.Qt.Orientation orientation, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_headerData_int_Orientation_int(nativeId(), section, orientation.value(), role);
    }
    private native static java.lang.Object __qt_headerData_int_Orientation_int(long __this__nativeId, int section, int orientation, int role);

    @QtBlockedSlot protected boolean insertRowIntoTable(com.trolltech.qt.sql.QSqlRecord values) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertRowIntoTable_QSqlRecord(nativeId(), values == null ? (values = new com.trolltech.qt.sql.QSqlRecord()).nativeId() : values.nativeId());
    }
    private native static boolean __qt_insertRowIntoTable_QSqlRecord(long __this__nativeId, long values);

    @QtBlockedSlot public boolean insertRows(int row, int count, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_insertRows_int_int_QModelIndex(nativeId(), row, count, parent);
    }
    private native static boolean __qt_insertRows_int_int_QModelIndex(long __this__nativeId, int row, int count, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot protected java.lang.String orderByClause() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_orderByClause(nativeId());
    }
    private native static java.lang.String __qt_orderByClause(long __this__nativeId);

    @QtBlockedSlot public boolean removeColumns(int column, int count, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_removeColumns_int_int_QModelIndex(nativeId(), column, count, parent);
    }
    private native static boolean __qt_removeColumns_int_int_QModelIndex(long __this__nativeId, int column, int count, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public boolean removeRows(int row, int count, com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_removeRows_int_int_QModelIndex(nativeId(), row, count, parent);
    }
    private native static boolean __qt_removeRows_int_int_QModelIndex(long __this__nativeId, int row, int count, com.trolltech.qt.core.QModelIndex parent);

    public void revert() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_revert(nativeId());
    }
    private native static void __qt_revert(long __this__nativeId);

    @QtBlockedSlot public void revertRow(int row) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_revertRow_int(nativeId(), row);
    }
    private native static void __qt_revertRow_int(long __this__nativeId, int row);

    @QtBlockedSlot public int rowCount(com.trolltech.qt.core.QModelIndex parent) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rowCount_QModelIndex(nativeId(), parent);
    }
    private native static int __qt_rowCount_QModelIndex(long __this__nativeId, com.trolltech.qt.core.QModelIndex parent);

    @QtBlockedSlot public boolean select() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_select(nativeId());
    }
    private native static boolean __qt_select(long __this__nativeId);

    @QtBlockedSlot protected java.lang.String selectStatement() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_selectStatement(nativeId());
    }
    private native static java.lang.String __qt_selectStatement(long __this__nativeId);

    @QtBlockedSlot public boolean setData(com.trolltech.qt.core.QModelIndex index, java.lang.Object value, int role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setData_QModelIndex_Object_int(nativeId(), index, value, role);
    }
    private native static boolean __qt_setData_QModelIndex_Object_int(long __this__nativeId, com.trolltech.qt.core.QModelIndex index, java.lang.Object value, int role);

    @QtBlockedSlot public void setEditStrategy(com.trolltech.qt.sql.QSqlTableModel.EditStrategy strategy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEditStrategy_EditStrategy(nativeId(), strategy.value());
    }
    private native static void __qt_setEditStrategy_EditStrategy(long __this__nativeId, int strategy);

    @QtBlockedSlot public void setFilter(java.lang.String filter) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFilter_String(nativeId(), filter);
    }
    private native static void __qt_setFilter_String(long __this__nativeId, java.lang.String filter);

    @QtBlockedSlot public void setSort(int column, com.trolltech.qt.core.Qt.SortOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSort_int_SortOrder(nativeId(), column, order.value());
    }
    private native static void __qt_setSort_int_SortOrder(long __this__nativeId, int column, int order);

    @QtBlockedSlot public void setTable(java.lang.String tableName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTable_String(nativeId(), tableName);
    }
    private native static void __qt_setTable_String(long __this__nativeId, java.lang.String tableName);

    @QtBlockedSlot public void sort(int column, com.trolltech.qt.core.Qt.SortOrder order) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_sort_int_SortOrder(nativeId(), column, order.value());
    }
    private native static void __qt_sort_int_SortOrder(long __this__nativeId, int column, int order);

    public boolean submit() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_submit(nativeId());
    }
    private native static boolean __qt_submit(long __this__nativeId);

    @QtBlockedSlot protected boolean updateRowInTable(int row, com.trolltech.qt.sql.QSqlRecord values) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_updateRowInTable_int_QSqlRecord(nativeId(), row, values == null ? (values = new com.trolltech.qt.sql.QSqlRecord()).nativeId() : values.nativeId());
    }
    private native static boolean __qt_updateRowInTable_int_QSqlRecord(long __this__nativeId, int row, long values);


    public static native QSqlTableModel fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QSqlTableModel(QPrivateConstructor p) { super(p); } 

}
